#!/usr/bin/python3
import sys
if len(sys.argv) > 1 and sys.argv[1] == "--terminal":
	GUI=False
	CCM=False
else:
	GUI=True
	CCM=False
import cgi,cgitb
from global_func import *
cgitb.enable()
import sqlite3
import json
from globalSettings import DBPath

form = cgi.FieldStorage()
if GUI:
	RequestType=form.getvalue('RequestType') 
else:
	print("1. create Pool")
	print("2. update pool")
	print("3. Delete pool")

	choice = int(input("Enter choice =>"))
	if choice == 1:
		RequestType = ""
	elif choice == 2:
		RequestType = "Update"
	elif choice == 3:
		RequestType = "Delete"

def CreatePool():
	conn=sqlite3.connect(DBPath)
	conn.text_factory=str
	c=conn.cursor()
	try:
		if GUI:
			PoolName=form.getvalue('PoolName') 
			PoolSize=form.getvalue('PoolSize') 
			PoolLevel=form.getvalue('PoolLevel')
			
			Compression=form.getvalue('Compression') 
			Accelaration=form.getvalue('Accelaration') 
			Deduplication=form.getvalue('Deduplication')
		else:
			PoolName=input('Enter PoolName => ') 
			SystemName=input('Enter System Name => ') 
			PoolSize=input('Enter PoolSize => ') 
			PoolLevel=input('Enter PoolLevel (0,1,2) => ')
			
			Compression=input('Enter Compression yes or no => ') 
			Accelaration=input('Enter Accelaration % => ') 
			Deduplication=input('Enter Deduplication (yes/no) => ')
		
		if 1==1:
			query_SP=c.execute("insert into multi_device(name,pool_storage,level,state,cr_date,edit_date,compression,acceleration,deduplication,system_name) values(?,?,?,1,datetime(),datetime(),?,?,?,?)",[PoolName,PoolSize,PoolLevel,Compression,Accelaration,Deduplication,SystemName])
			#query_SP=c.execute("update multi_device set name=?,pool_storage=?,level=?,state=1,edit_date=datetime() where name=?",[PoolName,PoolSize,PoolLevel,PoolName])
			conn.commit()		
			print (json.JSONEncoder().encode({'status':'success','description':'Saved successfully'}))
		else:
			print (json.JSONEncoder().encode({"status":"fail","description":"Name already exists"}))
			
		c.close()
		conn.close()
	except Exception as e:
		print(e)
		c.close()
		conn.close()
def DeletePool():
	conn=sqlite3.connect(DBPath)
	conn.text_factory=str
	c=conn.cursor()
	try:
		if GUI:
			PoolType=form.getvalue('PoolType') 
		else:
			c.execute("select id,name from multi_device")
			print(c.fetchall())
			PoolType=input('Enter Pool Name => ') 

		query_FT=c.execute("delete from  multi_device where name=?",[PoolType])
		conn.commit()
		print (json.JSONEncoder().encode({'status':'success','description':'Deleted successfully'}))
		c.close()
		conn.close()
	except Exception as e:
		c.close()
		conn.close()
def UpdatePool():
	conn=sqlite3.connect(DBPath)
	conn.text_factory=str
	c=conn.cursor()
	try:
		if GUI:
			PoolName=form.getvalue('PoolName')
			Compression=form.getvalue('Compression')  
			Deduplication=form.getvalue('Deduplication')
			Accelaration=form.getvalue('Accelaration') 
			PoolLevel=form.getvalue('PoolLevel')
		else:
			# PoolName=input('Enter PoolName => ') 
			c.execute("select id,system_name from multi_device")
			print(c.fetchall())
			SystemName=input('Enter System Name => ') 
			PoolLevel=input('Enter PoolLevel (0,1,2) => ')
			
			Compression=input('Enter Compression yes or no => ') 
			Accelaration=input('Enter Accelaration % => ') 
			Deduplication=input('Enter Deduplication (yes/no) => ')
		
		query_FT=c.execute("update multi_device set compression=?,deduplication=?,acceleration=?,level=? where system_name=?",[Compression,Deduplication,Accelaration,PoolLevel,SystemName])
		print (json.JSONEncoder().encode({'status':'success','description':'Updated successfully'}))
		conn.commit()
		c.close()
		conn.close()
	except Exception as e:
		c.close()
		conn.close()
	
print ("Content-type:text/html\r\n\r\n")
if RequestType=='Delete':
	DeletePool()
elif RequestType== 'Update':
	UpdatePool()
else:
	CreatePool()
