#!/usr/bin/python3
from __future__ import division



import cgi,cgitb
import sqlite3
import datetime
import json
from globalSettings import DBPath
cgitb.enable()

#res_available=[]

form=cgi.FieldStorage()
server_name=form.getvalue('server_name')



def sys_tot_CMS():
	conn=sqlite3.connect(DBPath)
	conn.text_factory=str
	c=conn.cursor()
	try:
		q_sysTot_cms=c.execute("select total_vcpu,total_memoryGB,total_storageGB from system where name='System1'")

		for val in c:
			res_sysTot_cms=val
		c.close()
		conn.close()
		return res_sysTot_cms
	except Exception as e:
		c.close()
		conn.close()
		return ""

def sys_usd_CMS():
	conn=sqlite3.connect(DBPath)
	conn.text_factory=str
	c=conn.cursor()
	try:
		q_sysUsd_cms=c.execute("select used_vcpu,used_memoryGB,used_storageGB from system where name='System1'")

		for val in c:
			res_sysUsd_cms=val
		c.close()
		conn.close()
		return res_sysUsd_cms
	except Exception as e:
		c.close()
		conn.close()
		return ""

def sys_storage():
	conn=sqlite3.connect(DBPath)
	conn.text_factory=str
	c=conn.cursor()
	try:
		q=c.execute("select total_storageGB,used_storageGB from system where name='System1'")
		storage_vals = []
		for val in c:
			storage_vals=val
		available_storage=storage_vals[0]-storage_vals[1]
		c.close()
		conn.close()
		return available_storage
	except Exception as e:
		c.close()
		conn.close()
		return ""
def sys_vcpu():
	conn=sqlite3.connect(DBPath)
	conn.text_factory=str
	c=conn.cursor()
	try:
		q=c.execute("select total_vcpu,used_vcpu from system where name='System1'")

		for val in c:
			vcpu_vals=val
		availbale_vcpu=vcpu_vals[0]-vcpu_vals[1]
		c.close()
		conn.close()
		return availbale_vcpu
	except Exception as e:
		c.close()
		conn.close()
		return ""

def sys_memory():
	conn=sqlite3.connect(DBPath)
	conn.text_factory=str
	c=conn.cursor()
	try:
		q=c.execute("select total_memoryGB,used_memoryGB from system where name='System1'")

		for val in c:
			memory_vals=val
		available_memory=memory_vals[0]-memory_vals[1]
		c.close()
		conn.close()
		return available_memory	
	except Exception as e:
		c.close()
		conn.close()
		return ""


def resources_vm_running():
	conn=sqlite3.connect(DBPath)
	conn.text_factory=str
	c=conn.cursor()
	try:
		sum_vcpu_running=0
		sum_memory_running=0
		sum_storage_utilised=0

		q_vm_cpu=c.execute("select num_cores from virtualmachine where state=6")
		all_rows_vcpu=c.fetchall()	
		for val in all_rows_vcpu:
			sum_vcpu_running=sum_vcpu_running+val[0]
		#print sum_vcpu_running

		q_vm_memory=c.execute("select memory_GB from virtualmachine where state=6")
		all_rows_memory=c.fetchall()
		for val in all_rows_memory:
			sum_memory_running=sum_memory_running+val[0]
			
		#print sum_memory_running

		q_vm_memory=c.execute("select vm_disk_size from virtualmachine where state=4 or state=6")
		all_rows_storage=c.fetchall()
		for val in all_rows_storage:
			sum_storage_utilised=sum_storage_utilised+val[0]
		#print sum_storage_utilised

		q_update_sysUsd_CMS=c.execute("update system set used_vcpu={0},used_memoryGB={1},used_storageGB={2} where name='System1'".format(sum_vcpu_running,sum_memory_running,sum_storage_utilised))
		conn.commit()
		c.close()
		conn.close()
	except Exception as e:
		c.close()
		conn.close()

