#!/usr/bin/python3
# -*- coding: utf-8 -*-
import sys
if len(sys.argv) > 1 and sys.argv[1] == "--terminal":
	GUI=False
	CCM=False
else:
	GUI=True
	CCM=True

if GUI==True:
    import cgi,cgitb
    cgitb.enable()
import uuid
import string
import random
import os
import subprocess
from subprocess import call
import time
import json

#from global_func import *
import sqlite3
import json
import base64
#from db import *
from clearTextPwd import *

if GUI==True:
    form = cgi.FieldStorage()
    request_Type = form.getvalue('RequestType')
else:
    print( '1. Restart')
    print ('2. Reboot & Burn ISO')
    print ('3  exit')
    choice=int(input("select cgi function==>"))
    if (choice==1):
        request_Type='restart'
    if (choice==2):
        request_Type='reboot'
    if (choice==3):
        exit (0)
        
        
def get_ccm_command_id():
    command_id=id_generator()
    return (command_id)

def ccm_msg_length(message):
    length="0000"
    tail="</msg>"
    length_message=len(message)
    length_message=length_message+len(tail) # add in the tail length </msg>
    if length_message<=9:
        k=length.rfind("0")
    elif length_message<=99:
        k=length.rfind("00")
    elif length_message<=999:
        k=length.rfind("000")
    msg_length=length[:k]+str(length_message)
    return msg_length

#</msg>0099set,element=multi_device,element_name=mrp1,args=3,action=PoolDelete,SystemName=mrp1,uuid=6RM6</msg>

def send_wd_msg(message):
    msg_length = ccm_msg_length(message)
    socket_cmd = "</msg>{0}{1}</msg>".format(msg_length, message)
    try:
        socket_msg = bytes(socket_cmd,'utf-8')
        WDpath="/var/www/cgiWD.sh"
        process1 = subprocess.call(["sudo",WDpath,socket_cmd])
    except Exception as err:
        print ("send_ccm_msg except ",err)

def get_wd_response(uuid):
    filename="ccm_response.txt"
    wd_path="/var/www/"
    ccm_response_file= wd_path+'b'+"'"+str(uuid)+"'"+filename
    file=0
    while (file < 100):
        if os.path.isfile(ccm_response_file):
            file=101
        else:
            file=file+1
            time.sleep(.1)
            if file==99:
                return (json.JSONEncoder().encode({'status':'fail','description':'Command Timeout'}))
    fo = open(ccm_response_file, "r")
    CcmResponse=fo.read()
    fo.close()
    os.remove(ccm_response_file)
    return CcmResponse



def id_generator(size=4, chars=string.ascii_uppercase + string.digits):
    return ''.join(random.choice(chars) for _ in range(size))

def get_ccm_command_id():
    command_id=id_generator()
    return (command_id)


def restartServer():
    if GUI==True:
    
        DBPath="/mnt/data/quantumDB.db"
        userId = form.getvalue('userId')
        password = form.getvalue('password')
        decoded_password = (base64.b64decode(password)).decode('utf-8')
        password = decoded_password
        conn=sqlite3.connect(DBPath)
        conn.text_factory=str
        c=conn.cursor()
        
        query_pwd = c.execute("select password from person where id=?",[userId])
        db_Pwd = c.fetchone()[0]
        conn.commit()
        isEnPwd = is_EncodedString_base64(db_Pwd)
        if isEnPwd :
            EncryptGUIpwd = pwd_encoding(password)
            password = EncryptGUIpwd
        
        query=c.execute("SELECT * from person where id=? and password=?",[userId,password])
        isValidCredentials=c.fetchall()
        c.close()
        conn.close()    
        if isValidCredentials:
            cmd_Id = get_ccm_command_id()
            message="set,element=code,args=2,action=reboot,uuid={0}".format(cmd_Id)
            send_wd_msg(message) 
            response = get_wd_response(cmd_Id)
            print (response)
        else:
            print (json.JSONEncoder().encode({"status": "error", "description": "Invalid Credentials"}))
    else:
        cmd_Id = get_ccm_command_id()
        message="set,element=code,args=2,action=reboot,uuid={0}".format(cmd_Id)
        send_wd_msg(message) 
        response = get_wd_response(cmd_Id)
        print (response)  

def rebootServer():
    DBPath="/mnt/data/quantumDB.db"
    if GUI==True:
        userId = form.getvalue('userId')
        password = form.getvalue('password')
        decoded_password = (base64.b64decode(password)).decode('utf-8')
        password = decoded_password
        conn=sqlite3.connect(DBPath)
        conn.text_factory=str
        c=conn.cursor()
        query_pwd = c.execute("select password from person where id=?",[userId])
        db_Pwd = c.fetchone()[0]
        conn.commit()

        isEnPwd = is_EncodedString_base64(db_Pwd)
        if isEnPwd :
            EncryptGUIpwd = pwd_encoding(password)
            password = EncryptGUIpwd
        query=c.execute("SELECT * from person where id=? and password=?",[userId,password])
        isValidCredentials=c.fetchall()
        c.close()
        conn.close()
        path="/mnt/xdata/iso"
    else:
        conn=sqlite3.connect(DBPath)
        conn.text_factory=str
        c=conn.cursor()
        userName="admin"
        password="Naveen@123"
        query_pwd = c.execute("select password from person where userName=?",[userName])
        db_Pwd = c.fetchone()[0]
        conn.commit()

        isEnPwd = is_EncodedString_base64(db_Pwd)
        if isEnPwd :
            EncryptGUIpwd = pwd_encoding(password)
            password = EncryptGUIpwd
            
        query=c.execute("SELECT * from person where userName=? and password=?",[userName,password])
        isValidCredentials=c.fetchall()
        c.close()
        conn.close()
        path="/home/sanuyi/wd"

    if isValidCredentials:
        if GUI==True:
            cmd_Id = get_ccm_command_id()
            message="set,element=iso,args=2,element_name=prowler.iso,action=burn,path={0},uuid={1}".format(path,cmd_Id)
            send_wd_msg(message) 
            response = get_wd_response(cmd_Id)
            print (response)
        else:
            LoopMax=30
            loop=0
            test=True
            while (test==True and loop < LoopMax):
                file_size = os.path.getsize(DBPath)
                print("quantumDB.db file Size is :", file_size, "bytes")
                cmd_Id = get_ccm_command_id()
                message="set,element=iso,args=2,element_name=prowler.iso,action=burn,path={0},uuid={1}".format(path,cmd_Id)
                send_wd_msg(message) 
                response = get_wd_response(cmd_Id)
                print (response)
                y=json.loads(response)
                if (y["status"])=="success":
                    loop=loop+1
                    time.sleep(2)
                    cmd_Id = get_ccm_command_id()
                    message="set,element=isoCheck,args=2,element_name=prowler.iso,action=check,path={0},uuid={1}".format(path,cmd_Id)
                    send_wd_msg(message) 
                    response = get_wd_response(cmd_Id)
                    print (response)
                    y=json.loads(response)
                    if (y["status"])=="success":
                        test=True
                        time.sleep(60)
                    else:
                        test=False
                else:
                    loop=LoopMax
                    test=False
    else:
        print (json.JSONEncoder().encode({"status": "error", "description": "Invalid Credentials"}))


print ("Content-type:text/html\r\n\r\n")
if request_Type == 'restart':
    restartServer()
elif request_Type == 'reboot':
    rebootServer()
