#!/usr/bin/python

from global_func import *
import sqlite3
import json
from db import *
import subprocess
import os

GUI=true
#GUI=false

if GUI==true:
    import cgi,cgitb
    cgitb.enable()

if GUI==true:
    form = cgi.FieldStorage()
    request_Type=form.getvalue('requestType')

else:
    print('1. create_Storage')
    print('2. read_Storage')
    print('3. OnOff_Device')
    print('4. delete_Storage ')
    print('5. ConnectDisconnect SM_Storage ')

    choice=int(input("select cgi function==>"))
    if (choice==1):
        request_Type='create_Storage'
    if (choice==2):
        request_Type='read_Storage'
    if (choice==3):
        request_Type='OnOff_Device'
    if (choice==4):
        request_Type='delete_Storage'
    if (choice==5):
        request_Type='ConnectDisconnectSM_Storage'
    print("Reques_Type="+str(request_Type))


def form_getvalue(val):
    if (val=='name'):
        name=str(input("input StorMan Name==>"))
        return name
    elif (val=='protocolId'):
        protID=str(input("input ProtID (1-5)==>"))
        return protID
    elif (val=='hostId'):
        hostID=str(input("input HostID ==>"))
        return hostID
    elif (val=='Status'):
        statusID=str(input("input Status ==>"))
        return status
    elif (val=='storageId'):
        storageId=str(input("input StorMan storageId ==>"))
        return storageId
    elif (val=='state'):
        state=str(input("input state 0=Off, 1=On ==>"))
        return state
    elif (val=='deviceId'):
        deviceId=str(input("input deviceId ==>"))
        return deviceId
    elif (val=='action'):
        action=str(input("input action C/D ==>"))
        return action
    elif (val=='remoteDir'):
        remoteDir=str(input("input Remote Directory Share ==>"))
        return remoteDir

    else: 
        print("Unknown Value")

def create_Storage():
    if GUI==true:
        name=form.getvalue('name')
        protocolId=form.getvalue('protocolId') 
        hostId=form.getvalue('hostId') 
        Status=form.getvalue('Status')
        remoteDir=form.getvalue('remoteDir')
    else:
        name=form_getvalue('name')
        protocolId=form_getvalue('protocolId') 
        hostId=form_getvalue('hostId') 
        Status=form_getvalue('Status')
        remoteDir=form_getvalue('remoteDir')
        
    query_lan=c.execute("select count(*) from stor_man where name='"+ str(name)+"'")
    nameCount = c.fetchone()[0]
    conn.commit()
    
    if nameCount == 0:
        query_SP=c.execute("insert into  stor_man(name,protocol,host_id,state,cr_date,remote_share) values(?,?,?,?,datetime(),?)",[name,protocolId,hostId,0,remoteDir])
        conn.commit()       
        print(json.JSONEncoder().encode({'status':'success','description':'Saved successfully'}))
    else:               
        print(json.JSONEncoder().encode({'status':'fail','description':'Host Name Already Exists'}))
        
    c.close()
    conn.close()

def read_Storage():
    if GUI==true:
        storageId = form.getvalue('storageId')
    else:
        storageId = form_getvalue('storageId')
        
    if storageId == '0':
        dbquery="SELECT id,name,protocol,host_id,state,remote_share from stor_man"
    else:
        dbquery="SELECT id,name,protocol,host_id,state,remote_share from stor_man where id="+str(storageId)
    query = c.execute(dbquery)
    dbdata = []
    conn.commit()
    for col in c:
        jsonschema = {"id":col[0],"name" : col[1],"protocol":col[2],"host_id":col[3],"state":col[4],"remoteDir":col[5],"dummy":'-'}
        dbdata.append(jsonschema)
    print(json.JSONEncoder().encode(dbdata))


def OnOff_Device():
    if GUI==true:
        state=form.getvalue('state') 
        deviceId = form.getvalue('deviceId')
    else:
        state=form_getvalue('state') 
        deviceId = form_getvalue('deviceId')
        print("state, deviceId",state,deviceId)
        
    query=c.execute("update device set state=? where id=?",[state,deviceId])
    conn.commit()
    
    if  state == str(0):
        print(json.JSONEncoder().encode({'status':'success','description':'Device is OFF'}))
    else:               
        print(json.JSONEncoder().encode({'status':'success','description':'Device is ON'}))

def ConnectDisconnectSM_Storage():
    if GUI==true:
        storageId = form.getvalue('storageId')
        #hostId=form.getvalue('hostId')
        #action=form.getvalue('action')
    else:
        #hostId=form_getvalue('hostId')
        storageId = form_getvalue('storageId')
        #action=form_getvalue('action')

    dbquery="SELECT sm.state,h.user_name,sm.remote_share from stor_man sm join host h on h.id=sm.host_id where sm.id="+str(storageId)
    query = c.execute(dbquery)
    dbdata = []
    conn.commit()
    for col in c:
        state = col[0]
        user_name = col[1]
        remote_share = col[2]

    if state == 0:
        action="C"
    elif state == 1:
        action="D"

    #select user_name from host where hostId=hostId
    if action=="C":   #connection

        #user_name="15.207.222.197:/mnt/backup"
        #remote_share="nfs_backup"   #get the share name from host/share
        local_path="/mnt/"+remote_share
        arg1="-p"
        arg2=local_path

        #sudo mkdir -p /mnt/nfs_backup
        process1 = subprocess.check_output(["mkdir",arg1,arg2])
        #print(process1)
        
        #sudo mount 192.168.30.7:/mnt/nfs_backup  /mnt/nfs_backup
        arg1=user_name      #this is the remote share path , maybe need to fix the db field name
        arg2=local_path
        process1 = subprocess.check_output(["sudo","mount",arg1,arg2])
        print(process1)
        
        arg2=local_path
        process1 = subprocess.check_output(["mountpoint",arg2]) #Check if mountpoint
        #print process1
        
        #insert user_name into volume and set  backup_device to true  ###NAVEEN
        
    elif action=="D":   #dis-connection
        #user_name="192.168.30.7:/mnt/nfs_backup"
        #remote_share="nfs_backup"   #get the share name from host/share
        local_path="/mnt/"+remote_share    
        arg1=local_path
        process1 = subprocess.check_output(["sudo","umount",arg1])
        #print process1
        #needs to poll here until mountpoint is gone
        
        #sudo rmdir -p /mnt/nfs_backup
        arg1="-p"
        arg2=local_path        
        #process1 = subprocess.check_output(["sudo","rmdir",arg1,arg2])
        process1 = subprocess.check_output(["rmdir",arg2])
        
        arg1=local_path
        #process1 = subprocess.check_output(["mountpoint",arg1]) #Check if mountpoint
        #print process1
        
    query=c.execute("update stor_man set state = (case when state=1 then 0 else 1 end) where id=?",[storageId])
    conn.commit()
    
    print(json.JSONEncoder().encode({'status':'success','description':'Updated Successfully'}))
        
def delete_Storage():

    if GUI==true:
        storageId = form.getvalue('storageId') 
    else:
        storageId = form_getvalue('storageId')
    
    query_lan=c.execute("select count(*) from stor_man where state=1 and id='"+ str(storageId)+"'")
    state = c.fetchone()[0]
    conn.commit()
    if state > 0:
        print(json.JSONEncoder().encode({'status':'fail','description':'Cannot Delete Used Storage'}))
        return
    
    query=c.execute("delete from stor_man where id=?",[storageId])
    conn.commit()
    
    print(json.JSONEncoder().encode({'status':'success','description':'Deleted successfully'}))

def read_Devices():
    if GUI==true:
        storageId = form.getvalue('storageId') 
    else:
        storageId = form_getvalue('storageId')
    
    dbquery="SELECT d.id,d.name,d.sys_name,d.state,p.name protocol from device d  join stor_man sm on sm.id=d.stor_man_id  inner join protocol p on p.id=sm.protocol  where stor_man_id="+str(storageId)
    query = c.execute(dbquery)
    dbdata = []
    conn.commit()
    for col in c:
        jsonschema = {"id":col[0],"name" : col[1],"sys_name":col[2],"state":col[3],"protocol":col[4],"dummy":'-'}
        dbdata.append(jsonschema)
    
    print(json.JSONEncoder().encode(dbdata))
    
print("Content-type:text/html\r\n\r\n")

try:
    if request_Type == 'create_Storage':
        create_Storage()
    elif request_Type == 'read_Storage':
        read_Storage()
    elif request_Type == 'OnOff_Device':
        OnOff_Device()
    elif request_Type == 'delete_Storage':
        delete_Storage()
    elif request_Type == 'ConnectDisconnectSM_Storage':
        ConnectDisconnectSM_Storage()
    elif request_Type == 'read_Devices':
        read_Devices()
    
except BaseException as e:
    pass
    #print e.message #Better to implement error logging
finally:
    conn.close()
