#!/usr/bin/python3
import cgi
import cgitb
import json
import uuid
from clientConfiguration import *
#from globalSettings import *
from global_func import *


cgitb.enable()

print("Content-type:text/html\r\n\r\n")

# import required modules for unpacking
import os
import zipfile
import shutil
import subprocess

form = cgi.FieldStorage()
message = ''
status = 'fail'
CCM = True

fileId = 0
FolderUploadPath = '/mnt/data/ssl/'
# intermediary folder to store files
dest_Directory = "/mnt/data/ssl/"
LOG_ZIP_PASSWORD = "pleasehideme"

def createFolderIfnotExists(path):
    if not os.path.exists(path):
        os.makedirs(path, mode=0o777)
        process2 = subprocess.call(['sudo','chmod','-R', '777', path])


def unzipFile_SSL(ZipFilePath):
    zipFileName = ZipFilePath.split("/")[-1]
    uploadCode = {}
    destFileName = zipFileName.split(".zip")[0]
    directory_to_extract_to = str(dest_Directory+destFileName)
    with zipfile.ZipFile(os.path.join(ZipFilePath), 'r') as zip_ref:
        try:
            zip_ref.extractall(directory_to_extract_to,pwd= bytes(LOG_ZIP_PASSWORD, 'utf-8'))
        except Exception as e:
            os.rmdir(directory_to_extract_to)
            os.remove(ZipFilePath)
            return 0,str(e)
    fileList = os.listdir(directory_to_extract_to)
    return fileList, directory_to_extract_to

def removeFiles(fileList):
    for file in fileList:
        if os.path.isdir(file):
            shutil.rmtree(file)
        else:
            os.remove(file)

try:  # Windows needs stdio set for binary mode.
    import msvcrt
    msvcrt.setmode(0, os.O_BINARY)  # stdin  = 0
    msvcrt.setmode(1, os.O_BINARY)  # stdout = 1
except ImportError:
    pass

createFolderIfnotExists(FolderUploadPath)
cmd_Id = get_ccm_command_id()

fileitem = form['folder']
#fileitem = form.getvalue('folder')


# Test if the file was uploaded
if fileitem.filename:
    uploaded_filename = os.path.basename(fileitem.filename)
    fileName = uploaded_filename
    process2 = subprocess.call(['sudo','chmod','-R', '777', FolderUploadPath])
    open(os.path.join(FolderUploadPath, fileName),'wb').write(fileitem.file.read())

    if CCM==True:
        #print"Send CCM"
        mssage = "set,element=packageUpload,element_name=admin,args=2,Action=upload_ssl,tempPath={0},version={1},uuid={2}" \
                    .format(FolderUploadPath,fileName,cmd_Id)
        send_ccm_msg(mssage)
        response = get_ccm_response(cmd_Id)
        response = json.loads(response)
        
        status = response['status']
        message = message + response['description']
        delete_ccm_response(cmd_Id)
    
    else:      

        # make sure that the localhost contains the Sanuyi foldet
        process2 = subprocess.call(['sudo','chmod','-R', '777', FolderUploadPath])
        #open(os.path.join(FolderUploadPath, fileName),
        #    'wb').write(fileitem.file.read())
        #message = fileName
        residualFiles = []
        try:
            fileName = os.path.join(FolderUploadPath, fileName)
            filesList = unzipFile_SSL(fileName)
            if filesList[0]!=0:
                message += " <br> File uploaded successfully"
                status = 'success'
                os.remove(fileName)
            else:
                status = 'fail'
                msg = 'Bad password for file'
                if msg in filesList[1]:
                    message += "<br> No file is uploaded: "+msg
                else:
                    message+="<br> "+str(filesList[1])
        except Exception as e:
            status = 'fail'
            message = "<br> Error: "+str(e)
else:
    message += '<br> No file was uploaded'
    message = message.capitalize()
print((json.JSONEncoder().encode(
    {"status": status, "description": message.replace("<br>", "", 1)})))

