#!/usr/bin/python3   
import sys
if len(sys.argv) > 1 and sys.argv[1] == "--terminal":
	GUI=False
	CCM=False
else:
	GUI=True
	CCM=False
import cgi, cgitb
from global_gui_data import *
from globalSettings import DBPath
import json
# from db import *

cgitb.enable()
import sqlite3
form=cgi.FieldStorage()
if GUI:
	request_Type=form.getvalue('requestType')
else:
	print("1. read_StatusAll")
	choice = int(input("Select choice => "))
	if choice == 1:
		request_Type = "read_StatusAll"
	else:
		request_Type = ""
		print("Invalid choice")


def read_StatusAll():
	conn=sqlite3.connect(DBPath)
	conn.text_factory=str
	c=conn.cursor()
	try:
		query = c.execute("SELECT name,state,speed,low_threshold,hi_threshold from fan")
		fandata = []
		conn.commit()
		for col in c:
			fandata.append(col[1])
		
		query = c.execute("SELECT name,state,temp,low_threshold,hi_threshold from temp_probes")
		cpudata=[]
		conn.commit()
		for col in c:
			jsonschema = {"name" : "cpu","state" :col[1]}
			cpudata.append(col[1])
		query = c.execute("SELECT name,state,speed,ip,netmask,port_id from eth_ports")
		networkdata=[]
		conn.commit()
		for col in c:
			jsonschema = {"name" : "network","state" :col[1]}
			networkdata.append(col[1])
		query = c.execute("SELECT name,state,ac_status,dc_status from psu where name='PSU_1'")
		psudata=[]
		conn.commit()
		for col in c:
			jsonschema = {"name" : "psu","state" :col[1]}
			psudata.append(col[1])
		query = c.execute("SELECT name,state,ac_status,dc_status from psu where name='PSU_2'")
		psudata2=[]
		conn.commit()
		for col in c:
			jsonschema = {"name" : "psu","state" :col[1]}
			psudata2.append(col[1])
		query = c.execute("SELECT name,state,vid,pid,prl,serial,size from disks")
		disksdata=[]
		conn.commit()
		for col in c:
			jsonschema = {"name" : "disks","state" :col[1]}
			disksdata.append(col[1])
		print (json.JSONEncoder().encode({"fans":fandata,"cpu":cpudata,"network":networkdata,"psu1":psudata,"psu2":psudata2,"disks":disksdata}))
		c.close()
		conn.close()
	except Exception as e:
		c.close()
		conn.close()

def fakedata():
	
	print (json.JSONEncoder().encode({"disks": [0, 0, 0, 0], "fans": [0, 1, 2, 0, 0, 0, 0, 0, 0, 1], "psu1": [0, 0, 0, 1, 2, 3],"psu2": [0, 0, 0, 1, 2, 3], "cpu": [0, 1], "network": [0, 0, 1, 0]} ))



print ("Content-type:text/html\r\n\r\n")

if request_Type == 'read_StatusAll':
	read_StatusAll()
else:
	read_StatusAll()


