#!/usr/bin/python3
print ("Content-type:text/html\r\n\r\n")
import traceback
import cgi, cgitb
import json
import uuid
from clientConfiguration import *
from globalSettings import *
from db import *
cgitb.enable()
import sqlite3
import license_unpack
from global_func import *

CCM = False

#import required modules for unpacking
import subprocess
import os

form=cgi.FieldStorage()
message = ''
status = 'fail'

def createFolderIfnotExists(path):
    if not os.path.exists(path):
        os.makedirs(path, mode=0o777)

fileId = 0 
#FolderUploadPath = '/var/www/Sanuyi/UploadedFolder/'
FolderUploadPath = '/var/www/uploaded/'
#FolderUploadPath = '/mnt/data/licence'
createFolderIfnotExists(FolderUploadPath)

#dest_Directory = "/var/www/Sanuyi/UploadedFolder/"  #intermediary folder to store files
cmd_Id = get_ccm_command_id()

try: # Windows needs stdio set for binary mode.
    import msvcrt
    msvcrt.setmode (0, os.O_BINARY) # stdin  = 0
    msvcrt.setmode (1, os.O_BINARY) # stdout = 1
except ImportError:
    pass

def main():
    global message
    global status
    # A nested FieldStorage instance holds the file
    fileitem = form['file']
    #fileitem = form.getvalue('folder')
    # Test if the file was uploaded
    if fileitem.filename:
        # strip leading path from file name
        # to avoid directory traversal attacks
        fn = os.path.basename(fileitem.filename)
        fileName = str("License") + os.path.splitext(fn)[1]
        fileName = os.path.join(FolderUploadPath,fileName)
        #make sure that the localhost contains the Sanuyi folder
        open(fileName, 'wb').write(fileitem.file.read())
        #message = fileName
	
        if CCM == True:
            #print("CCM Is True")
            mssage = "set,element=packageUpload,element_name=admin,args=2,Action=license,file_path={0},uuid={1}" \
                    .format(fileName,cmd_Id)
            #message = "set,element=eth_ports,element_name=Management,args=6,Action=update_MGT,netmask=255.255.0.0,ip_address=192.168.12.11,gateway=10.0.15.2,dhcp=No,dns=103.12.15.11,uuid="+str(cmd_Id)
            send_ccm_msg(mssage)
            response = get_ccm_response(cmd_Id)
            #print response
            response = json.loads(response)
                
            status = response['status']
            message = message + response['description']
            delete_ccm_response(cmd_Id)
        else:
            residualFiles = []
            stat, mssg = license_unpack.unpack(fileName)
            message = message + mssg
            status = stat
            response = {"status":status,"description":message.replace("<br>","",1)}
        
    else:
        message += '<br> No file was uploaded'
        response = {"status":status,"description":message.replace("<br>","",1)}

try:
    main()
except Exception as e:
    message += str(traceback.format_exc()).replace('\n','<br>')
    pass

#message = message.title()  
print (json.JSONEncoder().encode({"status":status,"description":message.replace("<br>","",1)}) )