
	
#second approach

from threading import Timer
from cgi_RunScheduledJobs import *

class RepeatedTimer(object):
     def __init__(self, interval, function, *args, **kwargs):
         self._timer     = None
         self.interval   = interval
         self.function   = function
         self.args       = args
         self.kwargs     = kwargs
         self.is_running = False
         self.start()

     def _run(self):
         self.is_running = False
         self.start()
         self.function(*self.args, **self.kwargs)

     def start(self):
         if not self.is_running:
             self._timer = Timer(self.interval, self._run)
             self._timer.start()
             self.is_running = True

     def stop(self):
         self._timer.cancel()
         self.is_running = False


from time import sleep
from datetime import datetime
def hello(name):
     print datetime.now()#.strftime('%H:%M')

print "starting..."
rt = RepeatedTimer(10, hello, "World") # it auto-starts, no need of rt.start()
try:
     sleep(15) # your long-running job goes here...
	# #print 'try'
finally:
     rt.stop() # better in a try/finally block to make sure the program ends!