#!/usr/bin/python

import cgi, cgitb
from global_func import *

cgitb.enable()
import sqlite3
import json
import subprocess
from db import *
from logRoutine import *
initLogging()

form = cgi.FieldStorage()
request_Type = form.getvalue('RequestType')
cmd_Id = get_ccm_command_id()

CCM = False

def updateSystemName(system_name):
    FileName = "/etc/hosts"
    old_system_name = getSystemName()

    process = subprocess.check_output(['sudo','chmod','777',FileName])

    process = subprocess.check_output(['sudo','hostnamectl','set-hostname',system_name])

    with open(FileName) as f:
        newText=f.read().replace(old_system_name, system_name)

    with open(FileName, "w") as f:
        f.write(newText)

def getSystemName():
    system_name = "n/a"
    process1 = subprocess.check_output(["hostnamectl"])
    output = process1.splitlines()
    for line in output:
        if "Static hostname" in line.split(':')[0].strip():
            system_name = line.split(':')[-1].strip()
    return system_name


def create_MachineSetupServices():
    system_name = form.getvalue('system_name')
    controller_name = form.getvalue('controller_name')

    if system_name != "" and controller_name!='' and system_name and controller_name:
        try:
            updateSystemName(system_name)
        except Exception as e:
            print json.JSONEncoder().encode({"status": "fail", "description": "Error while updating the system name: {}".format(e)})
            return
        query_lan = c.execute("update system set name='" + str(system_name) + "'")
        conn.commit()
        query_lan = c.execute("update controller set name='" + str(controller_name) + "'")
        conn.commit()
        dArgs=loggerArgs("controller-system/" + "MachineSetupService","controller-system",infoLevel,"update")
        ccmLogger(info,"Saved successfully " + controller_name + " and " + system_name,dArgs)
        print json.JSONEncoder().encode({"status": "success", "description": "Saved successfully"})
    else:
        dArgs=loggerArgs("controller-system/" + "MachineSetupService","controller-system",errorLevel,"update")
        ccmLogger(error,"Fill All mandatory fields",dArgs)
        print json.JSONEncoder().encode({"status": "fail", "description": "Fill All mandatory fields"})

    c.close()
    conn.close()


def read_MachineSetupServices():
    dbquery = "SELECT c.name, s.serial_number from system s, controller c"
    query = c.execute(dbquery)
    dbdata = []
    conn.commit()
    for col in c:
        system_name = getSystemName()
        jsonschema = {"system_name": system_name, "controller_name": col[0], "serial_number":col[1]}
        dbdata.append(jsonschema)
    conn.close()
    print json.JSONEncoder().encode(dbdata)

print ("Content-type:text/html\r\n\r\n")
if request_Type == 'create_MachineSetupServices':
    create_MachineSetupServices()
elif request_Type == 'read_MachineSetupServices':
    read_MachineSetupServices()
else:
    print Json.JSONEncoder().encode({"test"})
