function Request() {
    var request = {
        url: "",
        parameters: {},
        Type: ""
    };
}
Highcharts.setOptions({
    global: {
        useUTC: false
    }
});
$(function() {
    var chart;
    var chartData = []

    var response = [{
        "component": 'CPU',
        "componentPath": 'CPU'
    }, {
        "component": 'Memory',
        "componentPath": 'Memory'
    }, {
        "component": 'Disk',
        "componentPath": 'Disk'
    }, {
        "component": 'DF',
        "componentPath": 'DF'
    }]
    $('#ddlComponent').append(new Option('-- Select --', 0));
    $.each(response, function(i, item) {
        $('#ddlComponent').append(new Option(item.component, item.componentPath));
    });

});

function CallPythonService(request) {
	//request.parameters.uuid=uuid;
    $.ajax({
        type: "Get",
        url: request.url,
        contentType: 'application/json',
        dataType: 'json',
        headers: {
            'Access-Control-Allow-Origin': '*'
        },
        data: request.parameters,
        success: function(response) {
            BindResponseData(request.Type, response);
        },
        error: function(ex) {
            if(!isProduction){
				console.log(ex);
			}
        }
    });
}

function BindResponseData(Type, response) {
    if (Type == 'ddlGraphType') {
        response = $.grep(response, function(elem) {
            return elem.folderName.toLowerCase().indexOf($('#ddlComponent').val().toLowerCase()) > -1;
        });

        $('#ddlGraphType option').remove();
        $('#ddlGraphType').append(new Option('-- Select --', 0));
        $.each(response, function(i, item) {
            $('#ddlGraphType').append(new Option(item.folderName, item.folderPath));
        });
        $('#ddlSubGraph option').remove();
    } else if (Type == 'ddlSubGraph') {
        $('#ddlSubGraph option').remove();
        $('#ddlSubGraph').append(new Option('-- Select --', 0));
        $.each(response, function(i, item) {
            $('#ddlSubGraph').append(new Option(item.folderName, item.folderPath));
        });
    }
}
$('#ddlGraphType').change(function() {
    GetAllFoldersByPath('ddlSubGraph', $(this).val());
});
$('#ddlSubGraph').change(function() {
    //GetAllFoldersByPath('ddlSubGraph',$(this).val());
});
$('#ddlComponent').change(function() {
    GetAllFoldersByPath('ddlGraphType', 'Sanuyi/CollectDoutput');
});

function GetAllFoldersByPath(ddlName, RequestType) {
    var request = new Request();
    request.url = "cgi/cgi_collectD_graphs.py";
    request.Type = ddlName;
    request.parameters = {
        "Type": RequestType
    };
    CallPythonService(request);
}

function ShowChart() {
    CallCSVData('../' + $('#ddlSubGraph').val().replace('www/var',''));
}

function StartChart(series) {
    chart = Highcharts.chart('container', {
        chart: {
            type: 'spline',
            zoomType: 'xy',
            //backgroundColor: "#9e9e9e",
            animation: Highcharts.svg, // don't animate in old IE
            marginRight: 10,
            events: {
                load: function() {
                    var series = this.series[0];
                    var series1 = this.series[1];
                    var series2 = this.series[2];
                    var series3 = this.series[3];
                    var series4 = this.series[4];
                    var series5 = this.series[5];
                    var series6 = this.series[6];
                    var series7 = this.series[7];
                    var i = 1;
                    setInterval(function() {
                        //UpdateFromCSVtoJSON('../Sanuyi/reports.csv');
                        var x = i + 1;
                        i = i + 1;
                        //y = Math.random()*100;
                        if (false) {
                            // series.addPoint([x, Math.random()*100], true, true);	
                            // series1.addPoint([x, Math.random()*100], true, true);
                            // series2.addPoint([x, Math.random()*100], true, true);
                            // series3.addPoint([x, Math.random()*100], true, true);
                            series.addPoint(seriesData[0].data.slice(-1)[0], true, true);
                            series1.addPoint(seriesData[1].data.slice(-1)[0], true, true);
                            series2.addPoint(seriesData[2].data.slice(-1)[0], true, true);
                            series3.addPoint(seriesData[3].data.slice(-1)[0], true, true);
                            series4.addPoint(seriesData[4].data.slice(-1)[0], true, true);
                            series5.addPoint(seriesData[5].data.slice(-1)[0], true, true);
                            series6.addPoint(seriesData[6].data.slice(-1)[0], true, true);
                            series7.addPoint(seriesData[7].data.slice(-1)[0], true, true);
                        }
                    }, 10000);
                }
            }
        },
        title: {
            text: $('#ddlComponent').val() + ' Analytics',
            style: {
                "color": "black",
                "fontSize": "20px",
                fontWeight: 'bold'
            },
        },
        xAxis: {
            type: 'datetime',
            dateTimeLabelFormats: {
			  day: "%e. %b",
			  month: "%b '%y",
			  year: "%Y"
			},
            tickInterval: 1,
            title: {
                text: 'Time',
                style: {
                    "color": "black",
                    "fontSize": "15px",
                    fontWeight: 'bold'
                },
            },

        },
        yAxis: {
            // max: 100,
            // min: 0,
            title: {
                text: 'Utilization',
                style: {
                    "color": "black",
                    "fontSize": "15px",
                    fontWeight: 'bold'
                },
            },
            gridLineWidth: 0,
            plotLines: [{
                value: 0,
                width: 1,
                color: '#808080'
            }]
        },
        // tooltip: {
            // formatter: function() {
                // // return '<b>' + this.series.name + '</b><br/>' +
                // // Highcharts.dateFormat('%Y-%m-%d %H:%M:%S', this.x) + '<br/>' +
                // // Highcharts.numberFormat(this.y, 2);
                // return this.series.name + ' - ' + this.y
            // }
        // },
        legend: {
            enabled: true,

        },
        //colors: ["red", "green","blue","black","orange",""],
        exporting: {
            enabled: false
        },
        series: series,
        plotOptions: {
            series: {
                showCheckbox: false,
                marker: {
                    enabled: false
                },
                events: {
                    checkboxClick: function(event) {
                        if (event.checked) {
                            this.show();
                            this.legendSymbol.hide();
                        } else {
                            this.hide();
                            this.legendSymbol.hide();
                        }
                    }
                }
            }
        },
    });


    $('#plain').click(function() {
        chart.update({
            chart: {
                inverted: false,
                polar: false
            },
            subtitle: {
                text: 'Plain'
            }
        });
    });

}

function CallCSVData(csvPath) {
    $.ajax({
        url: csvPath,
        success: function(csv) {
            chartData = CSV2JSON(csv);
            StartChart(ConvertToSeriesData(chartData, $('#ddlComponent').val()));
        }
    });
}

function ConvertToSeriesData(Data, reportType) {
    if (reportType == 'Disks') {
        
    } else if (reportType == 'CPU') {
        seriescpuData = [{
            name: 'CPU',
            selected: false,
            data: []
        }];

        $.each(Data, function(index, item) {
		  if(!isNaN(item.value)){
			var d = new Date(0);
			d.setUTCSeconds(item.epoch);
            seriescpuData[0].data.push([Date.UTC(d.getFullYear(), d.getMonth(), d.getDate(),d.getHours(),d.getMinutes(),d.getSeconds(),d.getMilliseconds()),item.value]);
		  }
        });
        seriescpuData[0].data = seriescpuData[0].data.slice(0, 1000);

        return (seriescpuData);
    } else if (reportType == 'Disk') {
		var seriescpuData=[];
		if($('#ddlSubGraph').val().toLowerCase().indexOf('disk_io_time') > -1)
		{
			seriescpuData = [{
				name: 'IO Time',
				selected: false,
				data: []
			},
			{
				name: 'WEIGHTED IO Tme',
				selected: false,
				data: []
			}];

			$.each(Data, function(index, item) {
				// seriescpuData[0].data.push(item['io_time']);
				// seriescpuData[1].data.push(item['weighted_io_time']);
				
				if(!isNaN(item.io_time)){
					var d = new Date(0);
					d.setUTCSeconds(item.epoch);
					seriescpuData[0].data.push([Date.UTC(d.getFullYear(), d.getMonth(), d.getDate(),d.getHours(),d.getMinutes(),d.getSeconds(),d.getMilliseconds()),item.io_time]);
					seriescpuData[1].data.push([Date.UTC(d.getFullYear(), d.getMonth(), d.getDate(),d.getHours(),d.getMinutes(),d.getSeconds(),d.getMilliseconds()),item.weighted_io_time]);
			  }
			});
			
			seriescpuData[0].data = seriescpuData[0].data.slice(0, 1000);
			seriescpuData[1].data = seriescpuData[1].data.slice(0, 1000);
			return (seriescpuData);
		}
		else if($('#ddlSubGraph').val().toLowerCase().indexOf('disk_merged') > -1 ||  $('#ddlSubGraph').val().toLowerCase().indexOf('disk_octets') > -1 || $('#ddlSubGraph').val().toLowerCase().indexOf('disk_ops') > -1 || $('#ddlSubGraph').val().toLowerCase().indexOf('disk_time') > -1)
		{
			seriescpuData = [{
				name: 'Read',
				selected: false,
				data: []
			},
			{
				name: 'Write',
				selected: false,
				data: []
			}];

			$.each(Data, function(index, item) {
				// seriescpuData[0].data.push(item['read']);
				// seriescpuData[1].data.push(item['write']);
				if(!isNaN(item.read)){
					var d = new Date(0);
					d.setUTCSeconds(item.epoch);
					seriescpuData[0].data.push([Date.UTC(d.getFullYear(), d.getMonth(), d.getDate(),d.getHours(),d.getMinutes(),d.getSeconds(),d.getMilliseconds()),item.read]);
					seriescpuData[1].data.push([Date.UTC(d.getFullYear(), d.getMonth(), d.getDate(),d.getHours(),d.getMinutes(),d.getSeconds(),d.getMilliseconds()),item.write]);
				}
			});
			seriescpuData[0].data = seriescpuData[0].data.slice(0, 1000);
			seriescpuData[1].data = seriescpuData[1].data.slice(0, 1000);
			return (seriescpuData);
		}
		else if($('#ddlSubGraph').val().toLowerCase().indexOf('pending_operations') > -1)
		{
			seriescpuData = [{
				name: 'Read',
				selected: false,
				data: []
			},
			{
				name: 'Write',
				selected: false,
				data: []
			}];

			$.each(Data, function(index, item) {
				//seriescpuData[0].data.push(item['value']);
				if(!isNaN(item.value)){
					var d = new Date(0);
					d.setUTCSeconds(item.epoch);
					seriescpuData[0].data.push([Date.UTC(d.getFullYear(), d.getMonth(), d.getDate(),d.getHours(),d.getMinutes(),d.getSeconds(),d.getMilliseconds()),item.value]);
					}
			});
			seriescpuData[0].data = seriescpuData[0].data.slice(0, 1000);
			
			return (seriescpuData);
		}
        
    } else if (reportType == 'Memory') {
        seriescpuData = [{
            name: 'Memory',
            selected: false,
            data: []
        }];

        $.each(Data, function(index, item) {
            //seriescpuData[0].data.push({'x':item.epoch * 1000,'y':item.value});
            //seriescpuData[0].data.push(item['value']);
			if(!isNaN(item.value)){
					var d = new Date(0);
					d.setUTCSeconds(item.epoch);
					seriescpuData[0].data.push([Date.UTC(d.getFullYear(), d.getMonth(), d.getDate(),d.getHours(),d.getMinutes(),d.getSeconds(),d.getMilliseconds()),item.value]);
					}
        });
        seriescpuData[0].data = seriescpuData[0].data.slice(0, 1000);

        return (seriescpuData);
    } else if (reportType == 'DF') {
        seriescpuData = [{
            name: 'DF',
            selected: false,
            selected: false,
            data: []
        }];

        $.each(Data, function(index, item) {
            //seriescpuData[0].data.push({'x':item.epoch * 1000,'y':item.value});
            //seriescpuData[0].data.push(item['value']);
			if(!isNaN(item.value)){
					var d = new Date(0);
					d.setUTCSeconds(item.epoch);
					seriescpuData[0].data.push([Date.UTC(d.getFullYear(), d.getMonth(), d.getDate(),d.getHours(),d.getMinutes(),d.getSeconds(),d.getMilliseconds()),item.value]);
					}
        });
        seriescpuData[0].data = seriescpuData[0].data.slice(0, 1000);

        return (seriescpuData);
    } 
}


function CSVToArray(strData, strDelimiter) {
    // Check to see if the delimiter is defined. If not,
    // then default to comma.
    strDelimiter = (strDelimiter || ",");
    // Create a regular expression to parse the CSV values.
    var objPattern = new RegExp((
        // Delimiters.
        "(\\" + strDelimiter + "|\\r?\\n|\\r|^)" +
        // Quoted fields.
        "(?:\"([^\"]*(?:\"\"[^\"]*)*)\"|" +
        // Standard fields.
        "([^\"\\" + strDelimiter + "\\r\\n]*))"), "gi");
    // Create an array to hold our data. Give the array
    // a default empty first row.
    var arrData = [
        []
    ];
    // Create an array to hold our individual pattern
    // matching groups.
    var arrMatches = null;
    // Keep looping over the regular expression matches
    // until we can no longer find a match.
    while (arrMatches = objPattern.exec(strData)) {
        // Get the delimiter that was found.
        var strMatchedDelimiter = arrMatches[1];
        // Check to see if the given delimiter has a length
        // (is not the start of string) and if it matches
        // field delimiter. If id does not, then we know
        // that this delimiter is a row delimiter.
        if (strMatchedDelimiter.length && (strMatchedDelimiter != strDelimiter)) {
            // Since we have reached a new row of data,
            // add an empty row to our data array.
            arrData.push([]);
        }
        // Now that we have our delimiter out of the way,
        // let's check to see which kind of value we
        // captured (quoted or unquoted).
        if (arrMatches[2]) {
            // We found a quoted value. When we capture
            // this value, unescape any double quotes.
            var strMatchedValue = arrMatches[2].replace(
                new RegExp("\"\"", "g"), "\"");
        } else {
            // We found a non-quoted value.
            var strMatchedValue = arrMatches[3];
        }
        // Now that we have our value string, let's add
        // it to the data array.
        arrData[arrData.length - 1].push(strMatchedValue);
    }
    // Return the parsed data.
    return (arrData);
}

function CSV2JSON(csv) {
    var array = CSVToArray(csv);
    var objArray = [];
    for (var i = 1; i < array.length; i++) {
        objArray[i - 1] = {};
        for (var k = 0; k < array[0].length && k < array[i].length; k++) {
            var key = array[0][k];
            objArray[i - 1][key] = isNaN(array[i][k]) ? array[i][k] : parseFloat(array[i][k])
        }
    }

    var json = JSON.stringify(objArray);
    var str = json.replace(/},/g, "},\r\n");
    chartData = objArray;
    return objArray;
}

//ShowChart();