var StorageDetails = { Total: 16*1024, SPUsed: 0, Free: 16,Selected:0,SPPoolLevel:1 };
var TFDetails = { Total: 4*1024, SPUsed: 0, Free: 0,Selected:0,SSDTierLevel:0 };
var savedStatusSP=0;
var savedStatusFT=0;
var savedPools=[];
function Request() {
    var request = {
        url: "",
        parameters: {},
        TypeType: ""
    };    
    return request;
}
function SPSetUp() {
	$('#txtHDDAvailable').val(ConvertGBtoTB(StorageDetails.Total - StorageDetails.Selected) +' Raw storage available');
}
function TFSetUp() {	
	TFDetails.Selected = (TFDetails.Total  * TFDetails.SSDTierLevel)/100;
	$('#txtSSDAvailable').val(ConvertGBtoTB(TFDetails.Total -TFDetails.Selected) +' Raw storage available');
}
function ConvertGBtoTB(gbValue)
{
	return (gbValue/1024) + ' TB'
}
$(function () {
	GetPoolList();
	$('#divDisableSP').css('display','none');
});
function CallPythonService(request) {
	request.parameters.uuid=parent.uuid;
    $.ajax({
        type: "Get",
        url: request.url,
        contentType: 'application/json',
        dataType: 'json',
        headers: { 'Access-Control-Allow-Origin': '*' },
        data: request.parameters,
        success: function (response) {
            BindResponseData(request.Type,response);
        },
        error: function (ex) {
            if(!isProduction){
				console.log(ex);
			}
        }
    });
}

function BindResponseData(Type, response) {
    if (Type === 'CreatePool') {
		window.parent.notify(response.description,response.description,response.status);	
		GetPoolList();
		window.parent.GetAllDataBySelectedSection('StoragePools');
		//alert(response.description)
	}
	else if(Type == 'GetPool')
	{
		var poolType = $('#ddlPoolType').val();
		
		var hddObject={};
		var SSDObject={};
		
		for(var i=0;i<response.length;i++)
		{
			if($('#hdnIsCreatePage').val())
				$('#ddlPoolType option[value="'+response[i].name+'"]').text(response[i].name+' (Already configured)');
			savedPools.push(response[i].name);
		}
		hddObject = jQuery.grep(response, function(n, i) {
                return (n.name == 'HDD POOL');
            });
		SSDObject = jQuery.grep(response, function(n, i) {
                return (n.name == 'SSD POOL');
            });
		if(hddObject.length > 0 && poolType=='HDD POOL')
		{	
			StorageDetails.Total =16*1024;	
			StorageDetails.Selected=hddObject[0].pool_storage;
			
			var hddAccelarationPercent = hddObject[0].acceleration.match(/\d+/)[0];
			TFDetails.Selected= 4*1024 - ((4*1024*hddAccelarationPercent)/100) ;//- SSDObject[0].pool_storage *1024;
			
			var SPid='#divSP'+hddObject[0].level;
			var FTid = hddObject[0].acceleration != 'No'? '#divFT'+hddObject[0].acceleration.match(/\d+/)[0]:'#divFT'+0;
			savedStatusSP=hddObject[0].state;
			
			$('#chkCompression').prop('checked', hddObject[0].compression == 'Yes' ? true:false);
			$('#chkAccelaeration').prop('checked', hddObject[0].acceleration.indexOf('Yes')>-1?true:false);
			$('#chkDeduplication').prop('checked', hddObject[0].deduplication == 'Yes'?true:false);
			$('#spnStatus').text('HDD Pool Already configured, can edit in Edit Page');
		}
		else if(poolType=='HDD POOL'){
			if(SSDObject!=null && SSDObject.length>0)
			{
				//var hddAccelarationPercent = hddObject[0].acceleration.match(/\d+/)[0];
				TFDetails.Total= 4*1024 - SSDObject[0].pool_storage * 1024
				TFDetails.Selected = 0;
				
			}
			StorageDetails.Total =16*1024;
			var SPid='#divSP0';
			var FTid = '#divFT0';
			savedStatusSP=0;
			
			$('#chkCompression').prop('checked', false);
			$('#chkAccelaeration').prop('checked', false);
			$('#chkDeduplication').prop('checked', false);
			$('#spnStatus').text('');
			// if(pageName == 'edit' || pageName == 'delete')
			// {
				// $("#ddlPoolType option[value='1']").remove();
			// }
		}
		if(SSDObject.length > 0 && poolType=='SSD POOL')
		{
			if(hddObject !=null && hddObject.length >0){
				var hddAccelarationPercent = hddObject[0].acceleration.match(/\d+/)[0];
				StorageDetails.Total= 4*1024 -  (TFDetails.Total*hddAccelarationPercent)/100;
				StorageDetails.selected = SSDObject[0].pool_storage * 1024
			}
			else
			{
				StorageDetails.Total = 4*1024;
				StorageDetails.selected = SSDObject[0].pool_storage;
			}
			//StorageDetails.Total= hddObject[0].pool_storage;
			TFDetails.Selected=SSDObject[0].pool_storage;		
			var SPid='#divSP'+SSDObject[0].level;
			var FTid = '#divFT0';
			savedStatusFT=SSDObject[0].state;
			
			$('#chkCompression').prop('checked', SSDObject[0].compression == 'Yes' ? true:false);
			$('#chkAccelaeration').prop('checked', SSDObject[0].acceleration == 'Yes'?true:false);
			$('#chkDeduplication').prop('checked', SSDObject[0].deduplication == 'Yes'?true:false);
			$('#spnStatus').text("SSD Pool Already configured, can edit in Edit Page");
		}	
		else if(poolType=='SSD POOL')
		{
			if(hddObject !=null && hddObject.length >0){
				var hddAccelarationPercent = hddObject[0].acceleration.match(/\d+/)[0];
				StorageDetails.Total= TFDetails.Total -  (TFDetails.Total*hddAccelarationPercent)/100;
			}
			StorageDetails.Total = 4*1024;
			StorageDetails.Selected = 0;
			TFDetails.Selected=0;		
			var SPid='#divSP0';
			var FTid = '#divFT0';
			savedStatusFT=0;
			
			$('#chkCompression').prop('checked', false);
			$('#chkAccelaeration').prop('checked', false);
			$('#chkDeduplication').prop('checked', false);
			$('#spnStatus').text('');
			// if(pageName == 'edit' || pageName == 'delete')
			// {
				// $("#ddlPoolType option[value='2']").remove();
			// }
		}	
		
		$(SPid).trigger( "click" );
		$(FTid).trigger( "click" );
		$('#chkAccelaeration').trigger("change");
		
		 SPSetUp();
		 TFSetUp();
	
	}
	else if(Type == 'Delete')
	{
		GetPoolList();
		window.parent.GetAllDataBySelectedSection('StoragePools');
		window.parent.notify(response.description,response.description,response.status);			
	}
}

$('#chkAccelaeration').change(function(){
	if($('#chkAccelaeration').is(":checked") == true){
		$('#divDisableFT').css('display','none');
		$('#imgTieringFastier').css('background-color','white');
	}
	else{
		$('#divDisableFT').css('display','block');
		$('#imgTieringFastier').css('background-color','#ddd');		
		$('#divFT0').trigger( "click" );
	}
	SPSetUp();
	TFSetUp();	
});

$('#ddlPoolType').change(function(){
	var poolType = $('#ddlPoolType').val();
	if(savedPools.indexOf($('#ddlPoolType').val()) > -1 && $('#hdnIsCreatePage').val())
	{
		$('#btnSavePool').attr("onclick","alert('Already Configured')");
		//return false;
	}
	else if($('#hdnIsCreatePage').val())
	{
		$('#btnSavePool').attr("onclick","SavePool()");
	}
		
	if(poolType == 'HDD POOL')
	{
		$('#divDisableFT').css('display','none');
		$('#chkAccelaeration').attr('disabled',false);
		$('#divAccelaration').removeClass('disabled');
		$('#chkAccelaeration').trigger("change");
		$('#txtSSDAvailable').show();
	}
	else
	{
		$('#divDisableFT').css('display','block');
		$('#divAccelaration').addClass('disabled');
		$('#chkAccelaeration').prop("checked",false).attr('disabled',true);
		$('#txtSSDAvailable').hide();
	}
	GetPoolList();
});

function DeletePool()
{
	var poolType = $('#ddlPoolType').val();
	
	if( poolType == 'Select Pool')
	{
		alert('Please select Pool')
		return false;
	}
	
	var answer = confirm ("Are you sure Want to Delete "+ poolType + ', deleting the pool will lose all data ! click Ok to continue..');
	if (answer)
	{
		var request = new Request();
        request.url = "cgi/cgi_CreatepoolSetup.py";
        request.parameters = {            
			'PoolType':poolType,
			'RequestType':'Delete'
        };
        request.Type = "Delete";
        CallPythonService(request);     
	}
}
function SetTFDialPosition(dialType,SSDType)
{
	$('.clsTFBold').css('font-weight','normal');	
	
	TFDetails.SSDTierLevel = SSDType;
	var id='#divFT'+SSDType
	$(id).css('font-weight','bold');
	
	SPSetUp();
	TFSetUp();
}
function SetSPDialPosition(dialType,levelType)
{
	$('.clsSPBold').css('font-weight','normal');
	if(levelType == 'zero')
	{
		StorageDetails.Selected=0;
		$('#divSP0').css('font-weight','bold');	
		StorageDetails.SPPoolLevel	=0;
	}
	if(levelType == 'single')
	{
		StorageDetails.Selected= 1*1024;
		$('#divSP1').css('font-weight','bold');	
		StorageDetails.SPPoolLevel	=1;
	}
	else if(levelType == 'double'){
		StorageDetails.Selected=2*1024;
		$('#divSP2').css('font-weight','bold');	
		StorageDetails.SPPoolLevel	=2;	
	}
	else if(levelType == 'triple'){
		StorageDetails.Selected=3*1024;
		$('#divSP3').css('font-weight','bold');	
		StorageDetails.SPPoolLevel	=3;	
	}
	if($('#ddlPoolType').val() == 'HDD POOL')
		StorageDetails.Selected = StorageDetails.Selected*2
	SPSetUp();
	TFSetUp();
}
function SavePool()
{
		var poolType = $('#ddlPoolType').val();
		if( poolType == 'Select Pool')
		{
			alert('Please select Pool')
			return false;
		}
		if(savedStatusSP == 1 && poolType == 'HDD POOL')
		{
			GetPoolList();
			alert('Cannot update Saved Pool');
			return false;
		}
		if(savedStatusFT == 1 && poolType == 'SSD POOL')
		{
			GetPoolList();
			alert('Cannot update Saved Pool');
			return false;
		}
		
		if(poolType == 'HDD POOL')
		{
			var params={
			'PoolName': poolType,//$('#txtSPPoolName').val(),
			'PoolSize': StorageDetails.Selected / 1024,
			'PoolLevel': StorageDetails.SPPoolLevel,
			'Compression':$('#chkCompression').is(":checked") == true? 'Yes':'No',
			'Accelaration':$('#chkAccelaeration').is(":checked") == true? 'Yes'+' ('+TFDetails.SSDTierLevel+'%) - '+ConvertGBtoTB(TFDetails.Selected):'No',
			'Deduplication':$('#chkDeduplication').is(":checked") == true? 'Yes':'No',
			'RequestType':'Save'
			}
		}
		else
		{
			var params={
			'PoolName': poolType, //$('#txtSSDTierName').val(),
			'PoolSize': (StorageDetails.Selected)/1024, // TFDetails.Selected,
			'PoolLevel':StorageDetails.SPPoolLevel, // TFDetails.SSDTierLevel,			
			'Compression':$('#chkCompression').is(":checked") == true? 'Yes':'No',
			'Accelaration':$('#chkAccelaeration').is(":checked") == true? 'Yes':'No',
			'Deduplication':$('#chkDeduplication').is(":checked") == true? 'Yes':'No',
			'RequestType':'Save'
			}
		}
	    var request = new Request();
        request.url = "cgi/cgi_CreatepoolSetup.py";
        request.parameters = params;
        request.Type = "CreatePool";
        CallPythonService(request);        
}
function UpdatePool()
{
	var poolType = $('#ddlPoolType').val();
	if( poolType == 'Select Pool')
	{
		alert('Please select Pool')
		return false;
	}
	var params={
			'PoolName': $('#ddlPoolType').val(), 
			'Compression':$('#chkCompression').is(":checked") == true? 'Yes':'No',
			'Deduplication':$('#chkDeduplication').is(":checked") == true? 'Yes':'No',
			'Accelaration':$('#chkAccelaeration').is(":checked") == true? 'Yes'+' ('+TFDetails.SSDTierLevel+'%) - '+(TFDetails.Total -TFDetails.Selected)/1024 +' TB':'No',
			'PoolLevel':StorageDetails.SPPoolLevel,
			'RequestType':'Update'
			}
	var request = new Request();
	request.url = "cgi/cgi_CreatepoolSetup.py";
	request.parameters = params;
	request.Type = "CreatePool";
	CallPythonService(request); 
}
function GetPoolList()
{
	var request=new Request();
	request.url = "cgi/cgi_Pool_Get.py";
	request.Type = 'GetPool';
	request.parameters = {        
	};
	CallPythonService(request);
}
 