let CCM_REFRESH_TIME = 10000;
let LICENSE_REFRESH_TIME = 10000;

$(document).ready(function () {
    getInfo("getStatus");
    //getInfo("getResources");
    //getInfo("getApps");
    getInfo("getCCMStatus");
    getInfo("getLicenseStatus");
    getInfo("getHostServers");
    getInfo("getAlerts");
    getInfo("getSchedules");
    getInfo("getApplianceDetails")
    GetChartBySelectedSection('MegaRAID POOL');
    //getDirInfo();
	setInterval(function(){ getInfo("getCCMStatus"); }, CCM_REFRESH_TIME);
	setInterval(function () { getInfo("getLicenseStatus"); }, LICENSE_REFRESH_TIME);
    oemConfig = JSON.parse(sessionStorage.getItem("OEMType"))	
    switch(oemConfig.device){
		case "Prowler2":
            $("#applience-img").attr('src',"images/image_2023_03_07T19_54_40_855Z.png");
			// $("#liMEGA").removeClass("active").addClass("custom-disabled hide");
			// $("#liHDD").addClass("active");
			// $("#liHDD,#liSSD,#liNVM,#liISCSI").removeClass("custom-disabled hide");
            // GetChartBySelectedSection('HDD POOL');
			break;
		case 'Prowler1':
            $("#applience-img").attr('src',"images/R6000Cheetah_new.png")
			break;
		case 'Raptor':
            $("#applience-img").attr('src',"images/00_2crba_2u12bay-3c-server.12_1.png")
			break;
	}
    var pool = ''
    
   
    if(oemConfig.iSCSI){
        $("#liISCSI").removeClass("custom-disabled hide");
        pool = "iSCSI POOL"
    }
    if(oemConfig.NVMeOF){
        $("#liNVM").removeClass("custom-disabled hide");
        pool = "NVMeOF POOL"
    }
    if(oemConfig.SDD){
        $("#liSSD").removeClass("custom-disabled hide");
        pool ="SSD POOL"
    }
    if(oemConfig.HDD){
        $("#liHDD").removeClass("custom-disabled hide");
        pool = "HDD POOL"
    }
    if(oemConfig.MegaRAID){
        $("#liMEGA").removeClass("custom-disabled hide");
        pool = "MegaRAID POOL"
    }
    switch(pool){
        case 'MegaRAID POOL':
            $("#liMEGA").addClass("active");
            break;
        case 'HDD POOL':
            $("#liHDD").addClass("active");
            break;
        case 'NVMeOF POOL':
            $("#liNVM").addClass("active");
            break;
        case 'iSCSI POOL':
            $("#liISCSI").addClass("active");
            break;
        case 'SSD POOL':
            $("#liSSD").addClass("active");
            break;
    }
    GetChartBySelectedSection(pool);
    
});

function getDirInfo()
{
    $.ajax({
        type:"GET",
        url:'cgi/cgi_folde_free_space.py',
        success:function(responsedata)
        {
            alert("got response as "+"'"+responsedata+"'");
            
        }
    })
}
function Request() {
    var request = {
        url: "",
        parameters: {},
        Type: ""
    };
    return request;
}

function CallPythonService(request) {
    request.parameters.uuid = uuid;
    $.ajax({
        type: "Get",
        url: request.url,
        contentType: 'application/json',
        headers: {
            'Access-Control-Allow-Origin': '*'
        },
        dataType: 'json',
        data: request.parameters,
        success: function (response) {
            BindResponseData(request.Type, response);
        },
        error: function (ex) {
            console.log(ex);
        }
    });
}

function BindResponseData(Type, response) {
    if (Type === 'getAlerts') {
        $("#alerts").html(response['alerts'])
    } else if (Type === 'getApps') {

        $("#activeApps").html(response['active'])
        $("#suspendedApps").html(response['suspended'])
    } 
    else if (Type === 'getCCMStatus') {
	
	//response["description"] = JSON.stringify("{"+response["description"]+"}")
	//response["description"] = JSON.parse(response["description"])
		$('#ccmStatus_after_response').html('');
		var sources = ["images/right.png", "images/Warning.png", "images/Cross.png"]
		var styles = ["", "animation: blink normal 2s infinite ease-out;", "animation: blink normal 2s infinite ease-out;"]
		
		if(response["status"] == 'success'){
			//ccm is running

			var image_source = sources[0];
			var style = styles[0]; // "color: green;";
					$("#ccmStatus").attr('src', image_source).attr('style', style);

		}
		else{
			var image_source = sources[2];
			var style = styles[2];
				$("#ccmStatus").attr('src', image_source).attr('style', style);
		}
    } 
    else if (Type === 'getLicenseStatus') {
		var styles = ["", "animation: blink normal 2s infinite ease-out;", "animation: blink normal 2s infinite ease-out; color: red;"]
        var status = response['status'];
        if (status == 'success') {
            is_license = response["description"].split(",")[1].includes("Not OK");
			if(!is_license){
				 var style = "color: green;";
						 $("#licenseStatus").html('PRESENT').attr('style', style);
				}
			else{
				var style = styles[2];
						$("#licenseStatus").html('NOT PRESENT').attr('style', style);
			}
        }
        else {
            var style = styles[2];
            $("#licenseStatus").html('NOT PRESENT').attr('style', style);
        }
    }
    else if (Type === 'getHostServers') {

        $("#hostserver").html(response['hostservers'])
    } else if (Type === 'getResources') {

        var vCPU = response["usedVcpu"]
        var RAM = response["usedRAM"] + ' GB'
        var Storage = response["usedStorage"] + ' GB'

        $("#vcpu").html(vCPU)
        $("#ram").html(RAM)
        $("#usedStorage").html(Storage)

    } else if (Type === 'getSchedules') {

        $("#schedules").html(response['schedules'])
    } else if (Type === 'getStatus') {

        var sources = ["images/right.png", "images/Warning.png", "images/Cross.png"]
        var styles = ["", "animation: blink normal 2s infinite ease-out;", "animation: blink normal 2s infinite ease-out;"]
        var imgSource = sources[response["state"]]
        var style = styles[response["state"]]

        $('#healthStatus').attr('src', imgSource).attr('style', style);
        $("#softwareVersion").html(response['version'])
		$("#buildVersion").html(response['build'])
		$("#systemUptime").html(response['uptime'])
        $("#systemBootTime").html(response["boottime"])

    } else if (Type === 'getStorage') {
		
		var styles = ["", "animation: blink normal 2s infinite ease-out;", "animation: blink normal 2s infinite ease-out; color: red;"]
        var status = 'success';
        if (status == 'success') {
            var canister_status_data = response.canister//"Not OK";//response data
			if(canister_status_data=="Native"){
				 var style = "color: green;";
						 $("#canister_status").html('NATIVE').attr('style', style);
				}
            else if(canister_status_data=="Foreign"){
                var style = "color: orange;";
                        $("#canister_status").html('FOREIGN').attr('style', style);
               }
			else if(canister_status_data=="No Disks"){
                var style = "color: orange;";
                    $("#canister_status").html('NO DISKS').attr('style', style);
            }
			else if(canister_status_data=="UnKnown"){
                var style = styles[2];
						$("#canister_status").html('UnKnown').attr('style', style);
            }
			else if(canister_status_data=="Checking"){
                var style = "color: orange;";
						$("#canister_status").html('CHECKING').attr('style', style);
            }			
			else{
				var style = styles[2];
						$("#canister_status").html('ABSENT').attr('style', style);
			}
        }
        else {
            var style = styles[2];
            $("#canister_status").html('ABSENT').attr('style', style);
        }
        
        
 	var totalCapacity = response.total_storage + ' GB'
        $("#totalCapacity").html(totalCapacity);

        //var storagePools = "HDD " + hddpools + " / SSD " + ssdpools
        var storagePools = response.pools + ' nos.'
        $("#storagePools").html(storagePools);

        //var volumes = "HDD " + hddvolumes + " / SSD " + ssdvolumes
        var volumes = response.volumes + ' nos.'
        $("#volumes").html(volumes);

        var Protection = response.disks + " / " + response.total_disks + " Disks"
        $("#protection").html(Protection);

        var available = response.available;
        var used = response.allocated;

        renderGraphs(available, used, selectedPool);
		
        var totalCapacity = response.total_storage + ' GB'
        $("#totalCapacity").html(totalCapacity);

        //var storagePools = "HDD " + hddpools + " / SSD " + ssdpools
        var storagePools = response.pools + ' nos.'
        $("#storagePools").html(storagePools);

        //var volumes = "HDD " + hddvolumes + " / SSD " + ssdvolumes
        var volumes = response.volumes + ' nos.'
        $("#volumes").html(volumes);

        var Protection = response.disks + " / " + response.total_disks + " Disks"
        $("#protection").html(Protection);

        var available = response.available;
        var used = response.allocated;

        renderGraphs(available, used, selectedPool);

    } else if (Type === 'getApplianceDetails') {
        var header = "";
        response['drives']['attributes'].forEach(element => {
            header = header + '<th>' + element + '</th>'
        });
        var tableHeader = '<table border="1" class="table table-striped table-bordered" id="tblResult"><thead><tr class="tbheader">'+header+'</tr></thead><tbody id="tblbody"></tbody></table>'
		$('#driveData').html(tableHeader);
		$.each(response['drives']['data'], function (i, item) {
            var records = '';
            response['drives']['attributes'].forEach(element => {
                records= records+'<td>'+item[element]+'</td>'
            });
            records = '<tr>' + records + '</tr';
			$('#tblbody').append(records);
		});
		$('#tblResult').DataTable({searching: false, paging: false, info: false});

        $("#txtMakeModel").html(response['make_model'])
        $("#txtCPU").html(response['cpu'])
        $("#txtMemoryCapacity").html(response['memory_capacity'])
        $("#txtDriveModels").html(response['drive_models'])
        $("#dataStorage").html(response['data_freespace']+" GB")
        $("#xdataStorage").html(response['xdata_freespace']+" GB")
        //response['data_freespace']=" "+(parseInt(response['data_freespace']))+" GB"
        //response['xdata_freespace']=" "+(parseInt(response['xdata_freespace']))+" GB"
	response['data_freespace']=" "+response['data_freespace']+" GB"
	response['xdata_freespace']=" "+response['xdata_freespace']+" GB"
         $("#freeSpace1").html("data:"+response['data_freespace'])
         $("#freeSpace2").html("xdata:"+response['xdata_freespace'])
        $('#txtDriveModels').hover(function(ev){
            $('#driveData').stop(true,true).fadeIn();
        },function(ev){
            $('#driveData').stop(true,true).fadeOut();
        }).mousemove(function(ev){
            $('#driveData').css({left:ev.layerX+10,top:ev.layerY+10});
        });
    }
}

function getInfo(Type) {
    var requestType = Type;
    var request = new Request();
    request.url = 'cgi/cgi_index.py';
    request.parameters = {
        'requestType': requestType
    };
    request.Type = Type;
    CallPythonService(request);
}

function renderGraphs(available, used, title = 'Capacity') {
    var tooltipmsg = "%v GB";
    if(available==0 && used==0){
        tooltipmsg = "0 GB";
        available = 100;
    }
    var myConfig = {
        type: 'pie',
        legend: {
            align: "center",
            "vertical-align": "bottom",
        },
        plot: {
            borderColor: "#f3f3f4",
            borderWidth: 2,
            tooltip: {
                text: tooltipmsg
            },
            valueBox: {
                rules: [{
                    rule: "%node-percent-value <= 0",
                    visible: "false"
                },
                {
                    rule: "%node-percent-value <= 10",
                    y: 115
                }
                ]
            },
            animation: {
                effect: 2,
                method: 8,
                speed: 900,
                sequence: 1,
                delay: 300
            }
        },
        title: {
            text: title
        },
        globals: {
            fontFamily: 'gigergiger'
        },
        "background-color": "#f3f3f4",
        series: [{
            values: [available],
            text: "Available",
            "background-color": "#0a0246"
        },
        {
            values: [used],
            text: "Used",
            "background-color": "#ed1c24"
        },

        ]
    };

    zingchart.render({
        id: 'myChart1',
        data: myConfig,
        height: '100%',
        width: '100%'
    });
}

var selectedPool = '';

function GetChartBySelectedSection(pool) {
    selectedPool = pool;
    var requestType = "getStorage";
    var request = new Request();
    
       request.url = 'cgi/cgi_index.py';
    
    request.parameters = {
        'requestType': requestType,
        'PoolType': pool
    };
    request.Type = requestType;
    CallPythonService(request);
}
