var iframeHeightThresold = 200;
var isSystemReady = true;
const url = new URL(window.location.href).searchParams;
var systemInterval;
$("form").submit(function(){
    Login();
	return false;
});
$(document).ready(function(){
	let system = url.get("q")
	if(system == 'system'){
		isSystemReady = false;
		$("#systemRebooting").html("System is getting ready!").addClass("text-danger")
		systemInterval = setInterval(()=> {
			getCCMStatus();
		},10000)
	}
	function getDevice(){
		$.ajax({
			type:"GET",
			url:'cgi/cgi_ValidateUser.py',
			contentType: 'application/json',
			headers: {
				'Access-Control-Allow-Origin': '*'
			},
			dataType: 'json',
			data: {RequestType: 'getDeviceName'},
			success:function(resp)
			{
				var href ="";
				switch(resp.device){
					case "Cheetah":
						$(".brandLogo img").attr("src","images/login-logo.png");
						href ="cheetah-favicon.ico"
						break;
					case "Q_R6000":
						href = "quantum-favicon.ico"
						$(".brandLogo img").attr("src","images/Quantum_Logo_RGB.svg");
						break;
					case "S_7BayTower":
						$(".brandLogo img").attr("src","");
						break;
				}
				var link = document.querySelector("link[rel~='icon']");
				link.href = href;
				// console.log(link)
				
			}
		})
	}
	getDevice();
})
function getCCMStatus(){
	$.ajax({
        type: "Get",
        url: "cgi/cgi_index.py",
        contentType: 'application/json',
        headers: {
            'Access-Control-Allow-Origin': '*'
        },
        dataType: 'json',
        data: {
			requestType : "getCCMStatus"
		},
        success: function (response) {
			if(response.status == 'success'){
				clearInterval(systemInterval)
				isSystemReady = true;
				$("#systemRebooting").html("System is ready, you can loggin now!").addClass("text-danger").removeClass("text-danger")
			}
			else {
				isSystemReady = false
				$("#systemRebooting").html("System is getting ready!").addClass("text-danger")

			}
        },
        error: function (ex) {
            console.log(ex);
        }
    });
}
$(function(){
	$("#txtPassword").keypress(function(e) {
    if(e.which == 13) {
        //alert('You pressed enter!');
		Login();
		}
	});
});
function Request() {
    var request = {
        url: "",
        parameters: {},
        Type: ""
    };
    return request;
}
var user = {"UserName":"","Userid":0,"Name":'',"LoginDate":new Date(),'LastUpdatedDate':new Date(),'userType':3};

function CallPythonService(request) {
    $.ajax({
        type: "Get",
        url: request.url,
        contentType: 'application/json',
        dataType: 'json',
        headers: { 'Access-Control-Allow-Origin': '*' },
        data: request.parameters,
        success: function (response) {
			$(".spinner").addClass("hide");
			$("#login").removeClass("hide");
            BindResponseData(request.Type, response);
        },
        error: function (ex) {		
			$(".spinner").addClass("hide");
			$("#login").removeClass("hide");	
            parent.swal("Error", "Something went wrong", "error");
        }
    });
}
function showPassword(obj) {
	var type = $(obj).siblings('input').attr('type');
	if (type === "password") {
	  $(obj).siblings('input').attr('type',"text");
	} else {
	  $(obj).siblings('input').attr('type',"password");
	}
  }
  function changePasswordPopUp() {
  
	  swal({
		  title: "EULA",
		  html: true,
		  text: `<iframe id="eula" src="Global_Sanuyi_EULA.htm" width="650px" frameborder="0"></iframe>`,
		  showCancelButton: true,
		  confirmButtonText: "Agree",
			cancelButtonText: "Disagree",  
		  closeOnConfirm: false,
		  closeOnCancel: true,
		  customClass:"swal-wide",
		  width: 700,
		  animation: "slide-from-top"
	  },
		  function(isConfirm) {
			  if (isConfirm) {
				  swal({
					  title: "You are required to change the default password!",
					  html: true,
					  text: `<input type='password' class='form-control' id='new-password' placeholder='New password' autocomplete="off" readonly onfocus="this.removeAttribute('readonly');">
							  <input type="checkbox" style="margin:5px;" onclick="showPassword(this)">Show Password<br>
							  <error-output id="error" style="color: red; font-size: 12px; margin-top: 5px;"></error-output>`,
					  showCancelButton: true,
					  closeOnConfirm: false,
					  closeOnCancel: false,
					  width: 250,
					  animation: "slide-from-top"
				  },
					  function(isConfirm) {
						  if (isConfirm) {
							  var userName=$('#txtUserName').val();
							  var password=$('#new-password').val();
							  var old_password=$('#txtPassword').val();
							  try {
								  if(checkpassword(password)) {
									  $('#error').html("");
									  var request = new Request();
									  request.url = 'cgi/cgi_ValidateUser.py';
									  request.parameters = { RequestType:'ChangePassword','userName':btoa(userName), 'password': btoa(password), 'old_password':btoa(old_password)};
									  request.Type = 'ChangePassword';
									  CallPythonService(request);
								  }
							  }
							  catch(e) {
								  $('#error').html(e)
							  }	
						  } else {
							  parent.swal("Cancelled", "", "error");
						  }
				  });
			  }
			  else {
				  parent.swal("Cancelled", "", "error");
			  }
		  });
  }
  function GenerateRandom(length) {
	  var text = "";
	  var possible = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";
	  for(var i = 0; i < length; i++) {
		  text += possible.charAt(Math.floor(Math.random() * possible.length));
	  }
	  return text;
  }
  function checkpassword(password) {
	  let flag = true;
	  let error_str = '';
	  if(password.length < 8) {
		  flag = false;
		  error_str+="Error: Password must contain at least eight characters! <br>";
	  }
	  re = /[0-9]/;
	  if(!re.test(password)){
		  flag = false;
		  error_str+="Error: password must contain at least one number (0-9)! <br>";
	  }
	  re = /[a-z]/;
	  if(!re.test(password)) {
		  flag = false;
		  error_str+="Error: password must contain at least one lowercase letter (a-z)! <br>";
	  }
	  re = /[A-Z]/;
	  if(!re.test(password)) {
		  flag = false;
		  error_str+="Error: password must contain at least one uppercase letter (A-Z)! <br>";
	  }
	  re =/\W|_/g;
	  if(!re.test(password)) {
		  flag = false;
		  error_str+="Error: password must contain at least one special character! <br>";
	  }
	  if(!flag) throw error_str;
	  return true;
  }
  function BindResponseData(Type , response)
  {
	  if(Type == 'ValidateUser' || Type == 'ChangePassword')
	  {
		  if(response.status == 'success')
		  {	
			  if(response.default_password) {
				  changePasswordPopUp();
			  }
			  else {
				  user.SUID = GenerateRandom(8);
				  user.UserName = response.userName;
				  user.Name = response.FirstName ;
				  user.Userid = response.id;
				  user.userType = response.userType;
				  user.LoginDate = Date.parse(new Date());
				  user.LastUpdatedDate = Date.parse(new Date());
				  sessionStorage.setItem("sessionData", JSON.stringify(user));
				  sessionStorage.setItem("configData", JSON.stringify(response.clientConfiguration));
				  sessionStorage.setItem("OEMType", JSON.stringify(response.OEMType));
				  if(Type == 'ChangePassword') swal("Success", "Password changed successfully!", "success");	
				  location.href='index.html' ; //GetUrlParam('returnUrl','index.html');
			  }
		  }else{
			  //alert(response.description);
			  if(response.isUserBlocked){
				  swal("User Locked", response.description, "error");				
				  var courntDown = setInterval(function () {
					  $('.text-muted').html("Please try after " +response.timeLeft +" seconds");
					  if(response.timeLeft !=0)
						  response.timeLeft = response.timeLeft - 1;
					  else
					  {
						  clearInterval(courntDown);
						  swal("User Unlocked", "Please login now", "success");	
					  }
				  }, 1000);
			  }
			  else{
				  clearInterval(courntDown);
				  swal("Warning", response.description, "warning");
			  }
		  }
	  }
  }
  function Login()
  {
	if(isSystemReady){
		$(".spinner").removeClass("hide");
		$("#login").addClass("hide");
		var userName=$('#txtUserName').val();
		var password=$('#txtPassword').val();
		
			var request = new Request();
			request.url = 'cgi/cgi_ValidateUser.py';
			request.parameters = { RequestType:'ValidateUser','userName':btoa(userName), 'password': btoa(password)};
			request.Type = 'ValidateUser';
			CallPythonService(request);	
	}
  }
function userRedirect()
{
	var port = '90';
    
    var currentLocation = window.location.hostname;
    
    var url="http://"+currentLocation+":"+port+"/login.html";			
	
	window.location = url;
}
function GetUrlParam(parameter, defaultvalue){
	
    var urlparameter = defaultvalue;
    if(window.location.href.indexOf(parameter) > -1){
        urlparameter = getUrlVars()[parameter];
        }
    return urlparameter;
}

function getUrlVars() {
    var vars = {};
    var parts = window.location.href.replace(/[?&]+([^=&]+)=([^&]*)/gi, function(m,key,value) {
        vars[key] = value;
    });
    return vars;
}
if(typeof(Storage) == "undefined"){
	alert("Browser Not support");
}

//called from Global_Sanuyi_EULA.htm
function eulaScrollFunction() {

	$('.confirm.btn.btn-lg.btn-primary').attr("disabled", true);
    var $contents = $('#eula').contents();
	$('#eula').contents().on( 'scroll', function(){
		if($('#eula').contents().scrollTop() >= $('#eula').contents().height() - iframeHeightThresold ) {
			$('.confirm.btn.btn-lg.btn-primary').attr("disabled", false);
		}
		else {
			$('.confirm.btn.btn-lg.btn-primary').attr("disabled", true);
		}
	});
}