var SelectedGroup = "";
var CurrentGroupId=0;
var vmImageSizeBytes=0;
var vmImageDownloadedPath=0;
$(window).bind("load", function() {
    var filename = document.location.pathname.split('/').pop();
    //console.log(filename);
    if( filename != 'dockerGroup.html') {
        SelectedGroup = location.hash.substr(1).replace(/%20/g, " ");
        SelectedGroup = SelectedGroup != "" ?  SelectedGroup :'Finance' ;
        LoadSelectedGroup();
    }
});
// $(window).on("beforeunload", function () {
    // return "Please don't leave me!";
// });

function Request() {
    var request = {
        url: "",
        parameters: {},
        Type: ""
    };
    return request;
}

function LoadSelectedGroup()
{    
	var requestType = 'selectOtherGroup';
	if(SelectedGroup == 'My Backups')
		requestType = 'selectMyBakcupGroup';
    var request = new Request();
    request.url = 'cgi/cgi_market.py';
    request.parameters = { 'groupName': SelectedGroup,'requestType':requestType };
    request.Type = 'groups';
    CallPythonService(request);
}
function CallPythonService(request) {
	request.parameters.uuid=uuid;
    $.ajax({
        type: "Get",
        url: request.url,
        contentType: 'application/json',
        dataType: 'json',
        headers: { 'Access-Control-Allow-Origin': '*' },
        data: request.parameters,
        success: function (response) {
            BindResponseData(request.Type, response);
        },
        error: function (ex) {
			if(request.Type == 'download' )
				//alert('Download not complete, image downloading background');
			    return true;
            else
			{
				if(!isProduction){
					console.log(ex);
				}
			}
        }
    });
}
function BindResponseData(Type, response) {
    if (Type === 'groups')
    {
		$('#divOpenSource').html('');
		//$('#divCommercial').html('');
        $.each(response, function (i, item) {
			if(item.downloaded == 'yes')
				var imgPath='images/installed.png'
			else
				var imgPath='images/download.png'
			
            var divData='<a href="#" onclick=ShowVMdetails(' + item.ImageId + ','+item.GroupId +') class="placeList"> <div class="col-xs-3"><img src=".' + item.Path + '" alt="' + item.ImageName + '"></div><div class="col-xs-9 center-Content"> <h4>' + item.ImageName + '</h4> <p>'+item.ImageDesc+'</p> </div><div class="dwd-icon"><img src="'+imgPath+'" alt="Download"></div></a>';
			/*if(item.ImageCost === 'free')
				$('#divOpenSource').append(divData);
		    else
                $('#divCommercial').append(divData);*/
            $('#divOpenSource').append(divData); 
            
        });
        $(".GroupNameTitle").html("Market - "+SelectedGroup);
        $(".GroupName").html(SelectedGroup);
        
    }
    else if (Type === 'vmDetails')
    {
        $("#s_Image_Name").html(SelectedGroup + '- &nbsp;' + response.ImageName);
    $("#Image_Name").html(response.ImageName);
    $("#Path").html(response.Path);
    $("#Image_Cost").html(response.ImageCost);
    $("#Support_Cost").html(response.SupportCost);
    $("#Description").html(response.Description);
    $("#Icon_Path").attr('src', '.' + response.Icon);
    $("#Image_Size").html(response.vmImageSize);
	vmImageSizeBytes=response.vmImageSizeBytes == null ? 0: response.vmImageSizeBytes;
	vmImageDownloadedPath=response.vmImageDownloadedPath
    $("#vmDetails").modal('show');
    $("#btnDownload").attr('onclick', 'vmDownload(' + response.Id +','+CurrentGroupId+ ')');
	$('.downloadingLoader').css('display','none');
    if (response.Downloded == 'yes') {
        $("#Downloded").html('Yes');
        $("#btnDownload").css('display', 'none');
    }
	else if(response.Downloded == 'in progress')
	{
		$("#Downloded").html('In Progress');
        $("#btnDownload").css('display', 'none');
		$('.downloadingLoader').css('display','block');
		var src = 'cgi/cgi_getFileSize.py?fileSize='+vmImageSizeBytes+'&filePath='+vmImageDownloadedPath+''
		$('#ifSrc').attr('src',src);
	}
    else {
        $("#Downloded").html('No');
        $("#btnDownload").css('display', 'block');
    }
    }
    else if (Type === 'download')
    {
		$('.downloadingLoader').css('display', 'none');
		
		if(response.status == 'success'){
        $("#Downloded").html('Yes');
        $("#btnDownload").css('display', 'none');
		$("#Path").html(response.DowloadedPath);
		}
		else{
			alert(response.data)
		}
		LoadSelectedGroup();
		
    }
}

function ShowVMdetails(VMName,groupId) {
	CurrentGroupId=groupId;
    var request = new Request();
    request.url = 'cgi/cgi_market.py';
    request.parameters = { 'imageId': VMName,'groupId':groupId, 'requestType': 'selectVMImage' };
    request.Type = 'vmDetails';
    CallPythonService(request);
}
function vmDownload(image_id,groupId) {
	if (groupId == 16)
		var url='cgi/cgi_downloadImage_myBackups.py';
	else
		var url='cgi/cgi_downloadImage.py';
    var request = new Request();
    request.url = url;
    request.parameters = { 'image_id': image_id, 'type': 'download' },
    request.Type = 'download';
    CallPythonService(request);	
	$('.downloadingLoader').css('display','block');
	
	var src = 'cgi/cgi_getFileSize.py?fileSize='+vmImageSizeBytes+'&filePath='+vmImageDownloadedPath+''
	$('#ifSrc').attr('src',src);
}


