function Request() {
	var request = {
		url: "",
		parameters: {},
		Type: ""
	};
	return request;
}
var selectedUserId = 0;
$(window).bind("load", function () {

});
function CallPythonService(request) {
	request.parameters.uuid = uuid;
	$.ajax({
		type: "Get",
		url: request.url,
		contentType: 'application/json',
		dataType: 'json',
		headers: { 'Access-Control-Allow-Origin': '*' },
		data: request.parameters,
		success: function (response) {
			BindResponseData(request.Type, response);
		},
		error: function (ex) {
			if (!isProduction) {
				console.log(ex);
			}
		}
	});
}
function BindResponseData(Type, response) {
	if (Type == "SaveClientUser") {
		if (response.status == 'success') {
			$('#formAddUser input').val('');
			$("#ddlUser").val('');
			LoadUsers();
		}
		ShowNotif(response.description, response.description, response.status);
	}
	else if (Type == "BindUsers") {
		$("#ddlUser option").remove();
		$("#ddlUser").append($('<option>', {
			value: "",
			text: '--Select--'
		}));
		$.each(response, function (i, item) {
			$('#ddlUser').append($('<option>', {
				value: item.id,
				text: item.userName
			}));
		});
	} else if (Type == 'GetUserDetailsById') {
		response = response[0];
		$('#txtUserName').val(response.userName);
		$('#txtFirstName').val(response.FirstName);
		$('#txtLastName').val(response.LastName);
		$('#txtEmail').val(response.companyEmail);
		$('#txtPhone').val(response.companyPhone);
		$('#txtPwd').val(response.password);
	}
}


function SaveClientUser() {
	var userType = 3;
	if(sessionData.userType == 1)
		userType=2;
	else if(sessionData.userType == 2)
		userType=3;
	
	var isFormValid = $("#formAddUser").validationEngine('validate');
	if (isFormValid) {
		sessionData =JSON.parse(sessionStorage.getItem("sessionData"));
		username = sessionData.UserName;
		var request = new Request();
		request.url = "cgi/cgi_Organization_Manager.py";
		request.parameters = { "RequestType": "create_AdminUser","userId":selectedUserId, "firstName": $('#txtFirstName').val(), "lastName": $('#txtLastName').val(), "userName": $('#txtUserName').val(), "companyEmail": $('#txtEmail').val(), "password": btoa($('#txtPwd').val()), "companyPhone": $('#txtPhone').val(),"userType":userType };
		request.Type = "SaveClientUser";
		request.parameters.createdBy = username;
		CallPythonService(request);
	}
}
function DeleteUser() {
	var isFormValid = $("#formAddUser").validationEngine('validate');
	if (isFormValid) {
		var request = new Request();
		request.url = "cgi/cgi_Organization_Manager.py";
		request.parameters = { "RequestType": "delete_User", "userId": selectedUserId };
		request.Type = "SaveClientUser";
		CallPythonService(request);
	}
}
function LoadUsers() {
	var request = new Request();
	request.url = "cgi/cgi_Organization_Manager.py";
	request.parameters = { "RequestType": "read_User", "userId": 0,"userType":2 };
	request.Type = "BindUsers";
	CallPythonService(request);
}

$('.clsAction').click(function () {
	$('.clsAction').removeClass('alert-danger');
	$(this).addClass('alert-danger');
});

$('#ddlUser').change(function () {
	selectedUserId=0
	if ($('#ddlUser').val() != 0){
		selectedUserId = $('#ddlUser').val();
		GetUserDetailsById($('#ddlUser').val());
	}
});

function GetUserDetailsById(userId) {
	var request = new Request();
	request.url = "cgi/cgi_Organization_Manager.py";
	request.parameters = { "RequestType": 'read_User', "userId": userId };
	request.Type = "GetUserDetailsById";
	CallPythonService(request);
}

function PageNavigate(actionName) {
	$('#divUserList').hide();
	$('#formAddUser input').val('');
	$("#formAddUser input[type=text],input[type=password]").prop("disabled", false);
	$(".clsDisable").prop("disabled", false);
	
	if (actionName == 'Add') {
		selectedUserId=0;
		$('#aActionButton').attr('onclick', 'SaveClientUser()');
	}
	else if (actionName == 'Edit') {
		$('#divUserList').show();
		$(".clsDisable").prop("disabled", true);
		LoadUsers();
		$('#aActionButton').attr('onclick', 'SaveClientUser()');
	} else {
		LoadUsers();
		$('#divUserList').show();
		$("#formAddUser input[type=text],input[type=password]").prop("disabled", true);
		$('#aActionButton').attr('onclick', 'DeleteUser()');
	}
}

function ShowNotif(headerText, message, ntype) {
	var showNotif = true;
	var autoHide = true;
	if (ntype == 'success')
		ntype = 'success';
	else if (ntype == 'fail')
		ntype = 'error';
	else {
		showNotif = false;
		var autoHide = true;
	}
	$.iaoAlert({
		msg: headerText,
		position: 'bottom-right',
		type: ntype,
		mode: "dark",
		closeButton: true,
		closeOnClick: false,
		fadeOnHover: false,
		autoHide: autoHide,
		alertTime: "5000",
		zIndex: '999',
		alertClass: 'h2'
	});
}

$('#aActionAdd').trigger('click');