! function (a) {
    a.fn.validationEngineLanguage = function () { }, a.validationEngineLanguage = {
        newLang: function () {
            a.validationEngineLanguage.allRules = {
                required: {
                    regex: "none",
                    alertText: "* This field is required",
                    alertTextCheckboxMultiple: "* Please Accept Terms And Conditions",
                    alertTextCheckboxe: "* This checkbox is required",
                    alertTextDateRange: "* Both date range fields are required"
                },
                requiredInFunction: {
                    func: function (a, b, c, d) {
                        return "test" == a.val()
                    },
                    alertText: "* Field must equal test"
                },
                forkeydown: {
                    func: function (b) {
                        var c = b.which ? b.which : event.keyCode;
                        return !(46 != c && c > 31 && (c < 48 || c > 57))
                    }
                },
                dateRange: {
                    regex: "none",
                    alertText: "* Invalid ",
                    alertText2: "Date Range"
                },
                dateTimeRange: {
                    regex: "none",
                    alertText: "* Invalid ",
                    alertText2: "Date Time Range"
                },
                minSize: {
                    regex: "none",
                    alertText: "* Minimum",
                    alertText2: " characters allowed"
                },
                minSize4: {
                    regex: "[0-9A-Za-z]{4}([0-9A-Za-z]+ ?)*",
                    alertText: "* Minimum 4 characters allowed",
                    alertText2: " characters allowed"
                },
                maxSize: {
                    regex: "none",
                    alertText: "* Maximum ",
                    alertText2: " characters allowed"
                },
                groupRequired: {
                    regex: "none",
                    alertText: "* You must fill one of the following fields"
                },
                min6: {
                    regex: "[0-9]{6}",
                    alertText: "* Minimum value is "
                },
                max: {
                    regex: "none",
                    alertText: "* Maximum value is "
                },
                past: {
                    regex: "none",
                    alertText: "* Date prior to "
                },
                future: {
                    regex: "none",
                    alertText: "* Date past "
                },
                minSiz5: {
                    regex: "[0-9]{5}",
                    alertText: "Minimum 5 numbers"
                },
                minSiz3: {
                    regex: "[0-9]{3}",
                    alertText: "Minimum 3 numbers"
                },
                maxCheckbox: {
                    regex: "none",
                    alertText: "* Maximum ",
                    alertText2: " options allowed"
                },
                minCheckbox: {
                    regex: "none",
                    alertText: "* Please select ",
                    alertText2: " options"
                },
                equals: {
                    regex: "none",
                    alertText: "* Fields do not match"
                },
                creditCard: {
                    regex: "already exists",
                    alertText: "* Invalid credit card number"
                },
                SscMarkspercentage: {
                    regex: /^([1-9]{1})([0-9]{1})(\.[0-9]{1,2})?$/,
                    alertText: "*Percentage Must be 35 to 100  with Two Decimal Values (Ex: 47.11)!!"
                },
                phone: {
                    regex: /^\(?([7-9]{1})\)?[-. ]?([0-9]{5})[-. ]?([0-9]{4})$/
                },
                Mobile789: {
                    regex: /^\(?([7-9]{1})\)?[-. ]?([0-9]{5})[-. ]?([0-9]{4})$/,
                    alertText: "* Invalid Mobile Number"
                },
                Pincode: {
                    regex: /^\(?([1-9]{1})\)?[-. ]?([0-9]{5})$/,
                    alertText: "* Invalid Pincode"
                },
                ZipCode0: {
                    regex: /^\(?([1-9]{1})\)?[-. ]?([0-9]{5})$/,
                    alertText: "* Invalid Pincode Code"
                },
                Maxpercentage: {
                    regex: /^[1-9][0-9]?$|^100$/,
                    alertText: "*Percentage Must be 10 to 100!!"
                },
                Maxsize50: {
                    regex: /^.{10,50}$/,
                    alertText: "* Size between 10 to 100 "
                },
                password: {
                    regex: /^(?=.*\d)(?=.*[a-z])(?=.*[A-Z])(?=.*[^a-zA-Z0-9])(?!.*\s).{6,15}$/,
                    alertText: "* password should contain min 6 to 15 characters,must be alphanumeric,mixed case and atleast one special character"
                },
                matchPassword: {
                    func: function (b, c, d, e) {
                        return b.val() == a("#Password").val()
                    },
                    alertText: "* Password and Confirm Password must match"
                },
                matchusername: {
                    func: function (b, c, d, e) {
                        return b.val() == a("#txtNewusername").val()
                    },
                    alertText: "* Username and Confirm Username must match"
                },
                email: {
                    regex: /^[_a-zA-Z0-9-]+(\.[_a-zA-Z0-9-]+)*@[a-zA-Z0-9-]+(\.[a-zA-Z0-9-]+)*(\.[a-zA-Z]{2,5})$/,
                    alertText: "* Invalid email address"
                },
                Companyemail: {
                    regex: /^([\w-\.]+@(?!gmail.com)(?!GMAIL.COM)(?!gmail.COM)(?!Gmail.com)(?!yahoo.com)(?!YAHOO.COM)(?!YAHOO.com)(?!yahoo.COM)(?!hotmail.com)(?!outlook.com)(?!OUTLOOK.COM)(?!HOTMAIL.COM)(?!HOTMAIL.com)(?!hotmail.COM)([\w-]+\.)+[\w-]{2,4})?$/,
                    alertText: "* Only Official  email address"
                },
                matchemail: {
                    func: function (b, c, d, e) {
                        return b.val() == a("#EmailId").val().toLowerCase()
                    },
                    alertText: "* email and Confirm email must match"
                },
                year1: {
                    regex: "[0-9]{4}",
                    alertText2: "* Invalid Year ",
                    alertText: "Year Range Must Be 4 Numbers"
                },
                mob: {
                    regex: "[0-9]{10}",
                    alertText2: "* Invalid mobile ",
                    alertText: "Mobile Number Range Must be 10 Numbers"
                },
                percentage: {
                    regex: /^[0-9a-zA-Z.*\/,+']+$/,
                    alertText: "* not valid !!"
                },
                Markspercentage: {
                    regex: /^([1-9]{1})([0-9]{1})(\.[0-9]{1,2})?$/,
                    alertText: "*Percentage Must be 10 to 100  with Two Decimal Values (Ex: 47.11)!!"
                },
                ProRelSysEmail: {
                    regex: /^\w+([\.-]?\w+)*@\w+([\.-]?\w+)*(\.\w{2,4})+$/,
                    alertText: "* Invalid email address"
                },
                url: {
                    regex: /((?:https?\:\/\/|www\.)(?:[-a-z0-9]+\.)*[-a-z0-9]+.*)/i,
                    alertText: "* Invalid Url"
                },
                integer: {
                    regex: /^[\-\+]?\d+$/,
                    alertText: "* Not a valid integer"
                },
                number: {
                    regex: /^[\-\+]?(([0-9]+)([\.,]([0-9]+))?|([\.,]([0-9]+))?)$/,
                    alertText: "* Invalid floating decimal number"
                },
                date: {
                    regex: /^\d{4}[\/\-](0?[1-9]|1[012])[\/\-](0?[1-9]|[12][0-9]|3[01])$/,
                    alertText: "* Invalid date, must be in YYYY-MM-DD format"
                },
                ipAddress: {
                    regex: /^((([01]?[0-9]{1,2})|(2[0-4][0-9])|(25[0-5]))[.]){3}(([0-1]?[0-9]{1,2})|(2[0-4][0-9])|(25[0-5]))$/,
                    alertText: "* Invalid IP address"
                },
                Subnet: {
                    regex: /^((([01]?[0-9]{1,2})|(2[0-4][0-9])|(25[0-5]))[.]){3}(([0-1]?[0-9]{1,2})|(2[0-4][0-9])|(25[0-5]))$/,
                    alertText: "* Invalid Subnet Mask"
                },
                GateWay: {
                    regex: /^((([01]?[0-9]{1,2})|(2[0-4][0-9])|(25[0-5]))[.]){3}(([0-1]?[0-9]{1,2})|(2[0-4][0-9])|(25[0-5]))$/,
                    alertText: "* Invalid Gateway"
                },
                Dns: {
                    regex: /^((([01]?[0-9]{1,2})|(2[0-4][0-9])|(25[0-5]))[.]){3}(([0-1]?[0-9]{1,2})|(2[0-4][0-9])|(25[0-5]))$/,
                    alertText: "* Invalid DNS Server"
                },
                NetMask: {
                    regex: /^((([01]?[0-9]{1,2})|(2[0-4][0-9])|(25[0-5]))[.]){3}(([0-1]?[0-9]{1,2})|(2[0-4][0-9])|(25[0-5]))$/,
                    alertText: "* Invalid Netmask"
                },
                ipv4: {
                    regex: /^((([01]?[0-9]{1,2})|(2[0-4][0-9])|(25[0-5]))[.]){3}(([0-1]?[0-9]{1,2})|(2[0-4][0-9])|(25[0-5]))$/,
                    alertText: "* Invalid IP address"
                },
                onlyNumberSp: {
                    regex: /^[0-9\ ]+$/,
                    alertText: "* Numbers only"
                },
                onlyLetterSp: {
                    regex: /^[a-zA-Z\ \']+$/,
                    alertText: "* Letters only"
                },
                onlyLetter: {
                    regex: /^[a-zA-Z]+$/,
                    alertText: "* Letters only"
                },
                onlyLetterNumber: {
                    regex: /^[0-9a-zA-Z]+$/,
                    alertText: "* No special characters allowed"
                },
                Emailexists: {
                    regex: "none",
                    alertText: "Email Id Aleady Exists"
                },
                ajaxUserCall: {
                    url: "ajaxValidateFieldUser",
                    extraData: "name=eric",
                    alertText: "* This user is already taken",
                    alertTextLoad: "* Validating, please wait"
                },
                ajaxUserCallPhp: {
                    url: "phpajax/ajaxValidateFieldUser.php",
                    extraData: "name=eric",
                    alertTextOk: "* This username is available",
                    alertText: "* This user is already taken",
                    alertTextLoad: "* Validating, please wait"
                },
                ajaxNameCall: {
                    url: "ajaxValidateFieldName",
                    alertText: "* This name is already taken",
                    alertTextOk: "* This name is available",
                    alertTextLoad: "* Validating, please wait"
                },
                ajaxNameCallPhp: {
                    url: "phpajax/ajaxValidateFieldName.php",
                    alertText: "* This name is already taken",
                    alertTextLoad: "* Validating, please wait"
                },
                validate2fields: {
                    alertText: "* Please input HELLO"
                },
                dateFormat: {
                    regex: /^\d{4}[\/\-](0?[1-9]|1[012])[\/\-](0?[1-9]|[12][0-9]|3[01])$|^(?:(?:(?:0?[13578]|1[02])(\/|-)31)|(?:(?:0?[1,3-9]|1[0-2])(\/|-)(?:29|30)))(\/|-)(?:[1-9]\d\d\d|\d[1-9]\d\d|\d\d[1-9]\d|\d\d\d[1-9])$|^(?:(?:0?[1-9]|1[0-2])(\/|-)(?:0?[1-9]|1\d|2[0-8]))(\/|-)(?:[1-9]\d\d\d|\d[1-9]\d\d|\d\d[1-9]\d|\d\d\d[1-9])$|^(0?2(\/|-)29)(\/|-)(?:(?:0[48]00|[13579][26]00|[2468][048]00)|(?:\d\d)?(?:0[48]|[2468][048]|[13579][26]))$/,
                    alertText: "* Invalid Date"
                },
                dateTimeFormat: {
                    regex: /^\d{4}[\/\-](0?[1-9]|1[012])[\/\-](0?[1-9]|[12][0-9]|3[01])\s+(1[012]|0?[1-9]){1}:(0?[1-5]|[0-6][0-9]){1}:(0?[0-6]|[0-6][0-9]){1}\s+(am|pm|AM|PM){1}$|^(?:(?:(?:0?[13578]|1[02])(\/|-)31)|(?:(?:0?[1,3-9]|1[0-2])(\/|-)(?:29|30)))(\/|-)(?:[1-9]\d\d\d|\d[1-9]\d\d|\d\d[1-9]\d|\d\d\d[1-9])$|^((1[012]|0?[1-9]){1}\/(0?[1-9]|[12][0-9]|3[01]){1}\/\d{2,4}\s+(1[012]|0?[1-9]){1}:(0?[1-5]|[0-6][0-9]){1}:(0?[0-6]|[0-6][0-9]){1}\s+(am|pm|AM|PM){1})$/,
                    alertText: "* Invalid Date or Date Format",
                    alertText2: "Expected Format: ",
                    alertText3: "mm/dd/yyyy hh:mm:ss AM|PM or ",
                    alertText4: "yyyy-mm-dd hh:mm:ss AM|PM"
                },
                alphaspecialchar: {
                    regex: /^[a-zA-Z\s\([\])\.\-#']*$/,
                    alertText: "Numerics are not allowed!"
                },
                AlphaSpace: {
                    regex: /^[a-zA-Z\ \']+$/,
                    alertText: "* Only Letters Allow !!"
                },
                AlphaNumDot: {
                    regex: /^[0-9a-zA-Z.]+$/,
                    alertText: "*space and  special characters are not allowed Except Dot"
                },
                AlphaSpaceDot: {
                    regex: /^[a-zA-Z.\ \']+$/,
                    alertText: "* Numerics and special characters are not allowed"
                },
                AlphaSpaceDot1: {
                    regex: /^[a-zA-Z.\ \']+$/,
                    alertText: "* Numerics and special characters are not allowed"
                },
                AlphaNumSpaceDot: {
                    regex: /^[0-9a-zA-Z.\ \']+$/,
                    alertText: "* No special characters allowed Except Dot"
                },
                matchPassword: {
                    func: function (b, c, d, e) {
                        return b.val() == a("#txtPassword").val()
                    },
                    alertText: "* Password and Confirm Password must match"
                },
                matchNewPassword1: {
                    func: function (b, c, d, e) {
                        return b.val() == a("#txtNewPassword").val()
                    },
                    alertText: "* Password and Confirm Password must match"
                },
                Stdpassword: {
                    regex: /^(6,15)$/,
                    alertText: "* password should contain min 6 to 15 characters"
                },
                ClgUrlID: {
                    regex: /((?:https?\:\/\/|www\.)(?:[-a-z0-9]+\.)*[-a-z0-9]+.*)/i,
                    alertText: "* Not a valid URL !!"
                },
                minSizePwd: {
                    regex: /^\S{5}\S+$/,
                    alertText: "* Minimum 6 Characters required and Space Not allowed "
                },
                matchPasswordStd: {
                    func: function (b, c, d, e) {
                        return b.val() == a("#txtPassword").val()
                    },
                    alertText: "* Password and Confirm Password must match"
                },
                matchemailStd: {
                    func: function (b, c, d, e) {
                        return b.val() == a("#txtEmail").val()
                    },
                    alertText: "* email and Confirm email must match"
                },
                mobilenumber: {
                    regex: /^([7-9]{1}[0-9]{2})([0-9]{3})([0-9]{4})$/,
                    alertText: "* Not a valid Mobile Number1"
                },
                mobilenumber5: {
                    regex: /^[ ()+]*([0-9][ ()+]*){10}$/,
                    alertText: "* Mobile number should have 10 digits"
                }
            }
        }
    }, a.validationEngineLanguage.newLang()
}(jQuery);