#!/usr/bin/python

import cgi, cgitb
from global_func import *

cgitb.enable()
import sqlite3
import json
from db import *
from globalSettings import *
CCM = false
form = cgi.FieldStorage()
request_Type = form.getvalue('requestType')
cmd_Id = get_ccm_command_id()
import yaml
import subprocess
from logRoutine import *
initLogging()
import time
#print "request_Type: ",request_Type

def UpdateDNSlist():
    DNSlist=[]
    DNStext="# DNS servers \r\n"
    FileName="/etc/resolvconf/resolv.conf.d/head"
    try:
        conn=sqlite3.connect(DBPath)
        conn.text_factory=str
        c=conn.cursor()
        DBopen=True
        query = c.execute("select dns_server from gateway")
        DB_DNSlist = c.fetchall()
        #print DB_DNSlist
        for col in DB_DNSlist:
            DNS=col[0]
            if str(DNS)!="None":
                #print "DNS",DNS
                AdrList=DNS.split(',')
                for adr in AdrList:
                    if (adr in DNSlist):
                        pass
                    else:
                        DNSlist.append(adr)
                        DNStext=DNStext+("nameserver ")
                        DNStext=DNStext+(adr)
                        DNStext=DNStext+("\r\n")
        #sudo resolvconf -u
        #print process1
        #print "DNSlist",DNSlist
        #print "DNStext",DNStext
        c.close()
        process1= subprocess.check_output(['sudo','chmod','666',FileName])        
        process1= subprocess.check_output(['sudo','chown','www-data:www-data',FileName])
        with open(FileName, "w") as f:
            f.write(DNStext)
            f.close()
        process1= subprocess.check_output(['sudo','chown','root:root',FileName])
        process1= subprocess.check_output(['sudo','resolvconf','-u'])            
        return (0)
    except Exception as err:
        print("UpdateDNSlist ()",err)
        if DBopen==True: 
            c.close
        return (-1)
        

def readIPMIportDetails():
    ipAddress, subnetMask, defaultGateway = None, None, None
    try:
        process = subprocess.check_output(["sudo",'ipmitool','lan','print'])
        for line in process.splitlines():
            if "IP Address" in line:
                ipAddress = line.split(':')[-1].strip()
            if "Subnet Mask" in line.strip():
                subnetMask = line.split(':')[-1].strip()
            if "Default Gateway IP" in line.strip():
                defaultGateway = line.split(':')[-1].strip()
    except Exception as e:
        pass
    return ipAddress, subnetMask, defaultGateway

def readLANportDetails(portname):
    ipAddress, subnetMask = None, None
    #ifconfig eth0 | awk '/broadcast/{ print $6;}'
    try:
        process = subprocess.check_output(["ifconfig "+str(portname)+" | awk '/broadcast/{ print $2;}'"],shell=True)
        ipAddress = process.split()[0].strip()
        process = subprocess.check_output(["ifconfig "+str(portname)+" | awk '/netmask/{ print $4;}'"],shell=True)
        subnetMask = process.strip()
    except Exception as e:
        pass
    return ipAddress, subnetMask

def RestoreYAML():
    try:
        src="/etc/netplan/01-netcfg.yaml"
        dst="/etc/netplan/01-netcfg.yaml.bad"
        process = subprocess.Popen(["sudo","cp",src,dst],stdout=subprocess.PIPE)
        process.wait()
        data, err = process.communicate()
        src="/etc/netplan/01-netcfg.yaml.bak"
        dst="/etc/netplan/01-netcfg.yaml"
        process = subprocess.Popen(["sudo","cp",src,dst],stdout=subprocess.PIPE)
        process.wait()
        data, err = process.communicate()
    except Exception as err:
        return(-1)

def BackUpYAML():
    try:
        src="/etc/netplan/01-netcfg.yaml"
        dst="/etc/netplan/01-netcfg.yaml.bak"
        process = subprocess.Popen(["sudo","cp",src,dst],stdout=subprocess.PIPE)
        process.wait()
        data, err = process.communicate()
    except Exception as err:
        return(-1)

def NetplanCheck():
    try:
        process1 = subprocess.check_output(["sudo","netplan","generate"])
        return 0
    except Exception as err:
        return(-1)

def NetplanApply():
    try:
        if UpdateDNSlist() !=0:
            print ("Error Update DSN")
        process = subprocess.Popen(["sudo","netplan","apply"],stdout=subprocess.PIPE)
        process.wait()
        data, err = process.communicate()
        src="/etc/netplan/01-netcfg.yaml"
        dst="/mnt/data/01-netcfg.yaml"
        process = subprocess.Popen(["sudo","cp",src,dst],stdout=subprocess.PIPE)
        process.wait()
        data, err = process.communicate()
        #process = subprocess.check_output(["netplan","apply"])
    except Exception as err:
        return(-1)

def getProcessOutput(cmd):
    process = subprocess.Popen(
        cmd,
        stdout=subprocess.PIPE)
    process.wait()
    data, err = process.communicate()
    return data

def splitStrip(string):
    return string.strip().strip("'")

def validateNetmask(netmask):
    if netmask == "None":
        return {"is_valid" : True}
    valid_netmask = {"128.0.0.0" : "1", "192.0.0.0" : "2", "224.0.0.0" : "3", "240.0.0.0" : "4", "248.0.0.0" : "5", "252.0.0.0" : "6", "254.0.0.0" : "7", "255.0.0.0" : "8", "255.128.0.0" : "9", "255.192.0.0" : "10", "255.224.0.0" : "11", "255.240.0.0" : "12", "255.248.0.0" : "13", "255.252.0.0" : "14", "255.254.0.0" : "15", "255.255.0.0" : "16", "255.255.128.0" : "17", "255.255.192.0" : "18", "255.255.224.0" : "19", "255.255.240.0" : "20", "255.255.248.0" : "21", "255.255.252.0" : "22", "255.255.254.0" :"23","255.255.255.0" : "24", "255.255.255.128" : "25", "255.255.255.192" : "26", "255.255.255.224" : "27", "255.255.255.240" : "28", "255.255.255.248" : "29", "255.255.255.252" : "30", "255.255.255.254" : "31", "255.255.255.255" : "32"}
    if(netmask not in valid_netmask.keys()):
        return {"is_valid" : False, "cidr":""}
    else:
        return {"is_valid" : True, "cidr":valid_netmask[netmask]}

def update_network_yaml():
    #LAN
    lan_ports = {}
    #squery_lan = c.execute("Select e.ip,e.dhcp_enabled,e.name,e.system_name,g.default_gateway_ip, g.dns_server,ifnull(e.mtu_size,0),e.enable_port from eth_ports e, gateway g where e.name in ('LAN1','LAN2','LAN3','LAN4') and g.name = 'LAN' order by e.name") #order by name is important here
    #squery_lan = c.execute("Select e.ip,e.dhcp_enabled,e.name,e.system_name,g.default_gateway_ip, g.dns_server,ifnull(e.mtu_size,0),e.enable_port from eth_ports e, gateway g where (e.name in ('LAN1','LAN2','LAN3','LAN4' and g.name='LAN')) or (e.name='Management' and g.name='Management') order by e.name") #order by name is important here
    squery_lan = c.execute("Select e.ip,e.dhcp_enabled,e.name,e.system_name,g.default_gateway_ip, g.dns_server,ifnull(e.mtu_size,0),e.enable_port, e.netmask from eth_ports e, gateway g where((e.name=g.name) and e.name in ('LAN1','LAN2','LAN3','LAN4','Management')) order by e.name") #order by name is important here
    for col in c:
        if col[3] is not None:
            result = {}
            if (col[7]=='Yes'or col[2]=='Management') and col[0] != None:
                # result['ip_address'] = col[0]+"/24 "
                result['ip_address'] = col[0]+"/"+validateNetmask(col[8])["cidr"] +" "
            
            elif col[0] != None:
                result['ip_address'] = col[0]+"/"+validateNetmask(col[8])["cidr"] +" "
            else:
                result["ip_address"] = None
            result['dhcp'] = col[1]
            result['name'] = col[2]
            result['system_name'] = col[3]
            result['default_gateway_ip'] = col[4]
            result['dns_server'] = col[5]
            result['mtu_size'] = col[6]
            lan_ports[col[3]] = result
    
    if os.path.isfile(network_yaml_path):
        yaml_dict = {}
        with open(network_yaml_path, 'r') as stream:
            try:
                yaml_dict = yaml.safe_load(stream)
                dArgs=loggerArgs("yaml/ethernetPorts","yaml_file",debugLevel,"update")
                ccmLogger(debug,"updating yaml file of ethernetPorts",dArgs)
            except yaml.YAMLError as exc:
                dArgs=loggerArgs("yaml/ethernetPorts","yaml_file",criticalLevel,"update")
                ccmLogger(critical,str(exc),dArgs)
                print(exc)
                # assert False, ccmLogger(critical, str(exc), dArgs)
                return 0

        if yaml_dict is not None and 'network' in yaml_dict.keys():
            if 'ethernets' in yaml_dict['network'].keys():
                ethernets = yaml_dict['network']['ethernets']
                for key, item in lan_ports.items():
                    if key in ethernets.keys():
                        ethernet = ethernets[key]
                        if item['ip_address'] != None:
                            ethernet['addresses'] = [item['ip_address'].strip().strip("'")]
                        else:
                            if 'addresses' in ethernet:
                                del ethernet['addresses']
                        dhcp = True
                        if item['dhcp'].lower() == 'no':dhcp = False
                        ethernet['dhcp4'] = dhcp
                        ethernet['dhcp6'] = False
                        if item['default_gateway_ip'] != None:
                            ethernet['gateway4'] = item['default_gateway_ip']
                        else:
                            ethernet.pop("gateway4", None)
                        ethernet['mtu'] = item['mtu_size']
                        if item['dns_server'] is not None:
                            if 'nameservers' not in ethernet:
                                ethernet['nameservers'] = {}
                            ethernet['nameservers']['addresses'] = list(map(splitStrip, item['dns_server'].split(',')))
                        else:
                            if 'nameservers' in ethernet:
                                del ethernet['nameservers']
                       #ethernet['nameservers']['addresses'] = 
                        yaml_dict['network']['ethernets'][key] = ethernet

            arg1,arg2,arg3="-R","777",'/'.join(network_yaml_path.split('/')[0:-1])
            process = subprocess.Popen(["sudo","chmod",arg1,arg2,arg3],stdout=subprocess.PIPE)
            process.wait()
            data, err = process.communicate()
            # print(yaml_dict)
            with open(network_yaml_path, 'w+') as outfile:
                yaml.dump(yaml_dict, outfile, default_flow_style=None)

    else:
        yaml_dict = {}
        yaml_dict['network'] = {}
        yaml_dict['network']['ethernets'] = {}
        yaml_dict['network']['renderer'] = 'networkd'
        yaml_dict['network']['version'] = 2
        for key, item in lan_ports.items():
            ethernet = {}
            if item['ip_address'] != None:
                ethernet['addresses'] = [item['ip_address'].strip().strip("'")]
            dhcp = True
            if item['dhcp'].lower() == 'no':dhcp = False
            ethernet['dhcp4'] = dhcp
            ethernet['dhcp6'] = False
            if item['default_gateway_ip'] != None:
                ethernet['gateway4'] = item['default_gateway_ip']
            ethernet['mtu'] = item['mtu_size']  
            if item['dns_server'] is not None:
                ethernet['nameservers'] = {}
                ethernet['nameservers']['addresses'] = list(map(splitStrip, item['dns_server'].split(',')))
            yaml_dict['network']['ethernets'][key] = ethernet

        #might have to create a path for the file
        #sudo mkdir -p /etc/netplan/
        arg1,arg2="-p",'/'.join(network_yaml_path.split('/')[0:-1])
        process = subprocess.Popen(["sudo","mkdir",arg1,arg2],stdout=subprocess.PIPE)
        process.wait()
        data, err = process.communicate()
        arg1,arg2,arg3="-R","777",'/'.join(network_yaml_path.split('/')[0:-1])
        process = subprocess.Popen(["sudo","chmod",arg1,arg2,arg3],stdout=subprocess.PIPE)
        process.wait()
        data, err = process.communicate()
        with open(network_yaml_path, 'w+') as outfile:
                yaml.dump(yaml_dict, outfile, default_flow_style=None)
                
            
def Ethport(action,port):
    #print "EthPort",action,port
    if action=="up":
        arg1="link"
        arg2="set"
        cmd="up"
        try:
            process1 = subprocess.check_output(["sudo","ip",arg1,arg2,port,cmd])
            return 0
        except Exception as err:
            return err
            #return -1

    if action=="down":
        arg1="link"
        arg2="set"
        cmd="down"
        try:
            #sudo ip link set port down
            process1 = subprocess.check_output(["sudo","ip",arg1,arg2,port,cmd])
            return 0
        except Exception as err:
            return err
            #return -1
                

def update_wan():
    netmask = form.getvalue('netmask')
    ip_address = form.getvalue('ip_address')
    port = form.getvalue('port_enabled')
    dhcp = form.getvalue('dhcp_enabled')
    name = 'WAN'
    cmd = "update_WAN"
    add_validate(ip_address)
    add_validate(netmask)
    mtu_size = form.getvalue('mtu_size')

    if add_validate(ip_address) == True and add_validate(netmask) == True:
        if CCM==true:
            message = "set,element=eth_ports,element_name={0},args=6,Action={1},netmask={2},ip_address={3}," \
                      "port={4},dhcp={5},mtu_size={6},uuid={7}" \
                .format(name, cmd, netmask, ip_address, port, dhcp,mtu_size, cmd_Id)
            #message = "set,element=eth_ports,element_name=Management,args=6,Action=update_MGT,netmask=255.255.0.0,ip_address=192.168.12.11,gateway=10.0.15.2,dhcp=No,dns=103.12.15.11,uuid="+str(cmd_Id)
            send_ccm_msg(message)
            response = get_ccm_response(cmd_Id)
            print response
            delete_ccm_response(cmd_Id)
        else:
            query_lan=c.execute("update eth_ports set ip = ?,netmask=?,dhcp_enabled=?,enable_port=?,mtu_size=? where name=?",(ip_address,netmask,dhcp,port,mtu_size,name))
            conn.commit()
            print json.JSONEncoder().encode({'status':'success','description':'Saved successfully'})
        dArgs=loggerArgs("eth_ports/" + "ethernetPorts",name,infoLevel,"update")
        ccmLogger(info,"updated wan of " + "eth_ports",dArgs)
    else:
        dArgs=loggerArgs("eth_ports/" + "ethernetPorts",name,errorLevel,"update")
        ccmLogger(error,"Enter valid ipv4 address, all values should be in the range 0-255 in wan of " + "eth_ports",dArgs)
        if add_validate(ip_address) != True:
            print json.JSONEncoder().encode({"status": "fail", "description": str(add_validate(ip_address))})
        else:
            print json.JSONEncoder().encode({"status": "fail", "description": str(add_validate(netmask))})

    res=NetplanCheck()
    if res==0:
        NetplanApply()
    else:
        RestoreYAML()
    c.close()
    conn.close()

def read_wan():
    result = {}
    query_lan = c.execute("Select ip,netmask,dhcp_enabled,enable_port,ifnull(mtu_size,0) from eth_ports where name='WAN'")
    for col in c:
        result['ip_address'] = col[0]
        result['subnet'] = col[1]
        result['dhcp_enabled'] = col[2]
        result['port_enabled'] = col[3]
        result['mtu_size'] = col[4]
    conn.commit()
    c.close()
    conn.close()
    print(json.JSONEncoder().encode(result))



def update_lan():
    netmask = form.getvalue('netmask')
    ip_address = form.getvalue('ip_address')
    if netmask == None and ip_address != None:
        print json.JSONEncoder().encode({'status':'fail','description':'Please Enter Netmask'})
        return 0
    #if netmask != None and ip_address == None:
    #    print json.JSONEncoder().encode({'status':'fail','description':'Please Enter IP Address'})
    #    return 0
    name = form.getvalue('name')
    port = form.getvalue('port_enabled')
    dhcp = form.getvalue('dhcp_enabled')
    mtu_size = form.getvalue('mtu_size')
    gateway = form.getvalue('gateway')
    dns = form.getvalue('dns')
    BackUpYAML()
    add_validate(ip_address)
    add_validate(netmask)
    cmd = "update_LAN"
    query = c.execute("select count(*) from eth_ports where ip=? and name!=?",[ip_address,name])
    count = c.fetchone()[0]
    portEnable=port
    query_portName = c.execute("select system_name from eth_ports where name=?",[name])
    for col in c:
        interfaceName = col[0]
    #print "portEnable=",portEnable
    if portEnable == "Yes":
        port_res = Ethport("up",interfaceName)
    else:
        port_res = Ethport("down",interfaceName)
    if port_res == 0:    
        if dhcp.lower() == 'yes':
            portname = 'n/a'
            query = c.execute("select system_name from eth_ports where name=?",[name])
            for col in c:
                portname = col[0]
            ipmi_ip_address, ipmi_netmask = readLANportDetails(portname)
            if ipmi_ip_address is None or ipmi_ip_address.strip() == '':
                ipmi_ip_address = ip_address
            if ipmi_netmask is None or ipmi_netmask.strip() == '':
                ipmi_netmask = netmask
            if count==0:
                if ip_address != "0.0.0.0":
                    query_lan=c.execute("update eth_ports set ip = ?,netmask=?,dhcp_enabled=?,enable_port=?, mtu_size=? where name=?",(ipmi_ip_address,ipmi_netmask,dhcp,port,mtu_size,name))
                    conn.commit()
                    query_gw_dns=c.execute("update gateway set default_gateway_ip = ?,dns_server=? where name=?",(gateway,dns,name))
                    conn.commit()
                    print json.JSONEncoder().encode({'status':'success','description':'Saved successfully'})
                    update_network_yaml()
                    dArgs=loggerArgs("eth_ports/" + "ethernetPorts",name,infoLevel,"update")
                    ccmLogger(info,"updated lan of " + "eth_ports",dArgs)
                else:
                    print json.JSONEncoder().encode({"status": "fail", "description": "IP address: 0.0.0.0 is reserved to IPMI PORT"})
            else:
                print json.JSONEncoder().encode({"status": "fail", "description": "IP address used by other Port"})
        else: 
            if add_validate(ip_address) == True and add_validate(netmask) == True and validateNetmask(str(netmask))["is_valid"]:
                if CCM == true:
                    message = "set,element=eth_ports, element_name={0},args=6,Action={1},netmask={2},ip_address={3}," \
                            "port={4},gateway={5},dns={6},dhcp={7},mtu_size={8},uuid={9}" \
                        .format(name, cmd, netmask, ip_address, port,gateway,dns, dhcp,mtu_size, cmd_Id)
                    send_ccm_msg(message)
                    response = get_ccm_response(cmd_Id)
                    print response
                    delete_ccm_response(cmd_Id)
                else:
                    if count == 0:
                        if ip_address != "0.0.0.0":
                            query_lan=c.execute("update eth_ports set ip = ?,netmask=?,dhcp_enabled=?,enable_port=?, mtu_size=? where name=?",(ip_address,netmask,dhcp,port,mtu_size,name))
                            conn.commit()
                            query_gw_dns=c.execute("update gateway set default_gateway_ip = ?,dns_server=? where name=?",(gateway,dns,name))
                            conn.commit()
                            print json.JSONEncoder().encode({'status':'success','description':'Saved successfully'})
                            update_network_yaml()
                            dArgs=loggerArgs("eth_ports/" + "ethernetPorts",name,infoLevel,"update")
                            ccmLogger(info,"updated lan of " + "eth_ports",dArgs)
                        else:
                            print json.JSONEncoder().encode({"status": "fail", "description": "IP address: 0.0.0.0 is reserved to IPMI PORT"})
                    else:
                        print json.JSONEncoder().encode({"status": "fail", "description": "IP address used by other Port"})
            else:
                dArgs=loggerArgs("eth_ports/" + "ethernetPorts",name,errorLevel,"update")
                ccmLogger(error,"Enter valid ipv4 address, all values should be in the range 0-255 in lan of " + "eth_ports",dArgs)
                if add_validate(ip_address) != True:
                    print json.JSONEncoder().encode({"status": "fail", "description": str(add_validate(ip_address))})
                else:
                    print json.JSONEncoder().encode({"status": "fail", "description": str(add_validate(netmask))})
    else:
        print json.JSONEncoder().encode({"status": "fail", "description": str(port_res)})
    res=NetplanCheck()
    if res==0:
        if portEnable == "Yes":
            NetplanApply()
            #print "Netplan Apply"
        #else:
            #print "No Netplan Apply"
    else:
        RestoreYAML()
    c.close()
    conn.close()
    if portEnable == "Yes":
        port_res = Ethport("up",interfaceName)
        time.sleep(3)
        port_res = Ethport("down","enp42s0f3u5u3c2")
        #print "portEnable up ",interfaceName
    else:
        port_res = Ethport("down",interfaceName)
        time.sleep(3)
        port_res = Ethport("down","enp42s0f3u5u3c2")        
        #print "portEnable down ",interfaceName


def read_lan():
    lanData = []
    result = {}
    squery_lan = c.execute("Select ip,netmask,dhcp_enabled,enable_port,ep.name,ifnull(mtu_size,0),default_gateway_ip,dns_server from eth_ports  ep inner join gateway g on ep.name=g.name  where ep.name in ('LAN1','LAN2','LAN3','LAN4') order by ep.name") #order by name is important here
    for col in c:
        result['ip_address'] = col[0]
        result['subnet'] = col[1]
        result['dhcp_enabled'] = col[2]
        result['port_enabled'] = col[3]
        result['name'] = col[4]
        result['mtu_size'] = col[5]
        result['default_gateway_ip'] = col[6]
        result['dns_server'] = col[7]
        jsonschema = {"ip_address": col[0], "subnet": col[1], "dhcp_enabled": col[2], "port_enabled": col[3],
                      "name": col[4], 'mtu_size':col[5], 'default_gateway_ip':col[6], "dns_server":col[7]}
        lanData.append(jsonschema)
    conn.commit()
    c.close()
    conn.close()
    print(json.JSONEncoder().encode(lanData))


def update_mgt():
    netmask = form.getvalue('netmask')
    gateway = form.getvalue('gateway')
    dns = form.getvalue('dns')
    dhcp = form.getvalue('dhcp_enabled')
    name = 'Management'
    ip_address = form.getvalue('ip_address')
    mtu_size = form.getvalue('mtu_size')
    cmd = "update_MGT"
    add_validate(ip_address)
    add_validate(netmask)
    #add_validate(gateway,True)
    BackUpYAML()
    query = c.execute("select count(*) from eth_ports where ip=? and name!=?",[ip_address,name])
    count = c.fetchone()[0]
    query_portName = c.execute("select system_name from eth_ports where name=?",[name])
    for col in c:
        interfaceName = col[0]
    portEnable="Yes"
    if portEnable == "Yes":
        port_res = Ethport("up",interfaceName)
    else:
        port_res = Ethport("down",interfaceName)
    
    if port_res == 0:
        if dhcp.lower() == 'yes':
            if count == 0:
                ipmi_ip_address, ipmi_netmask, ipmi_gateway = readIPMIportDetails()
                query_net_dhcp=c.execute("update eth_ports set ip = ?,netmask=?,dhcp_enabled=?,mtu_size=? where name=?",(ipmi_ip_address,ipmi_netmask,dhcp,mtu_size,name))
                conn.commit()
                query_gw_dns=c.execute("update gateway set default_gateway_ip = ?,dns_server=? where name=?",(gateway,dns,name))
                conn.commit()
                print json.JSONEncoder().encode({'status':'success','description':'Saved successfully'})
                update_network_yaml()
                dArgs=loggerArgs("eth_ports/" + "ethernetPorts",name,infoLevel,"update")
                ccmLogger(info,"updated mgt of " + "eth_ports",dArgs)
            else:
                print json.JSONEncoder().encode({"status": "fail", "description": "IP address used by other Port"})
        else: 
            if add_validate(ip_address) == True and add_validate(netmask) == True and validateNetmask(str(netmask))["is_valid"]:
                if CCM == true:
                    message = "set,element=eth_ports, element_name={0},args=6,Action={1},netmask={2},ip_address={3}," \
                            "gateway={4},dhcp={5},dns={6},mtu_size={7},uuid={8}" \
                        .format(name, cmd, netmask, ip_address, gateway, dhcp, dns,mtu_size, cmd_Id)
                    send_ccm_msg(message)
                    response = get_ccm_response(cmd_Id)
                    print response
                    delete_ccm_response(cmd_Id)
                else:
                    if count ==0:
                        query_net_dhcp=c.execute("update eth_ports set ip = ?,netmask=?,dhcp_enabled=?,mtu_size=? where name=?",(ip_address,netmask,dhcp,mtu_size,name))
                        conn.commit()
                        query_gw_dns=c.execute("update gateway set default_gateway_ip = ?,dns_server=? where name=?",(gateway,dns,name))
                        conn.commit()
                        print json.JSONEncoder().encode({'status':'success','description':'Saved successfully'})
                        update_network_yaml()
                        dArgs=loggerArgs("eth_ports/" + "ethernetPorts",name,infoLevel,"update")
                        ccmLogger(info,"updated mgt of " + "eth_ports",dArgs)
                    else:
                        print json.JSONEncoder().encode({"status": "fail", "description": "IP address used by other Port"})
            else:
                dArgs=loggerArgs("eth_ports/" + "ethernetPorts",name,errorLevel,"update")
                ccmLogger(error,"Enter valid ipv4 address, all values should be in the range 0-255 in mgt of " + "eth_ports",dArgs)
                if add_validate(ip_address) != True:
                    print json.JSONEncoder().encode({"status": "fail", "description": str(add_validate(ip_address))})
                else:
                    print json.JSONEncoder().encode({"status": "fail", "description": str(add_validate(netmask))})
    else:
        print json.JSONEncoder().encode({"status": "fail", "description": str(port_res)})
    res=NetplanCheck()
    if res==0:
        if portEnable == "Yes":
        
            NetplanApply()
    else:
        RestoreYAML()
    c.close()
    conn.close()
    if portEnable == "Yes":
        port_res = Ethport("up",interfaceName)
        #print "portEnable up ",interfaceName
    else:
        port_res = Ethport("down",interfaceName)
        #print "portEnable down ",interfaceName        

def read_mgt():
    result = {}
    ipmi_ip_address, ipmi_netmask, ipmi_gateway = readIPMIportDetails()
    query_eth = c.execute(
        "Select ip,netmask,dhcp_enabled,default_gateway_ip,dns_server,ifnull(mtu_size,0) from eth_ports ep inner join gateway g on ep.name=g.name  where ep.name='Management'")
    for col in c:
        result['ip_address'] = col[0]
        result['subnet'] = col[1]
        result['dhcp_enabled'] = col[2]
        result['default_gateway_ip'] = col[3]
        result['dns_server'] = col[4]
        result['mtu_size'] = col[5]
        result['ipmi_ip_address'] = ipmi_ip_address
    conn.commit()
    c.close()
    conn.close()
    print json.JSONEncoder().encode(result)


def update_adm():
    netmask = form.getvalue('netmask')
    ip_address = form.getvalue('ip_address')
    name = 'Admin'
    port = form.getvalue('port_enabled')
    dhcp = form.getvalue('dhcp_enabled')
    mtu_size = form.getvalue('mtu_size')
    cmd = "update_ADM"
    add_validate(ip_address)
    add_validate(netmask)

    if add_validate(ip_address) == True and add_validate(netmask) == True:
        if CCM == true:
            message = "set,element=eth_ports, element_name={0},args=6,Action={1},netmask={2},ip_address={3}," \
                      "port={4},dhcp={5},mtu_size={6},uuid={7}" \
                .format(name, cmd, netmask, ip_address, port, dhcp,mtu_size, cmd_Id)
            send_ccm_msg(message)
            response = get_ccm_response(cmd_Id)
            print response
    #        print json.JSONEncoder().encode({"status":"success","description":"Saved successfully"})
            delete_ccm_response(cmd_Id)
        else:
            query_lan=c.execute("update eth_ports set ip = ?,netmask=?,dhcp_enabled=?,enable_port=?,mtu_size=? where name=?",(ip_address,netmask,dhcp,port,mtu_size,name))
            conn.commit()
            print json.JSONEncoder().encode({"status":"success","description":"Saved successfully"})
        dArgs=loggerArgs("eth_ports/" + "ethernetPorts",name,infoLevel,"update")
        ccmLogger(info,"updated admin of " + "eth_ports",dArgs)
    else:
        dArgs=loggerArgs("eth_ports/" + "ethernetPorts",name,errorLevel,"update")
        ccmLogger(error,"Enter valid ipv4 address, all values should be in the range 0-255 in admin of " + "eth_ports",dArgs)
        if add_validate(ip_address) != True:
            print json.JSONEncoder().encode({"status": "fail", "description": str(add_validate(ip_address))})
        else:
            print json.JSONEncoder().encode({"status": "fail", "description": str(add_validate(netmask))})
    res=NetplanCheck()
    if res==0:
        NetplanApply()
    else:
        RestoreYAML()
    c.close()
    conn.close()


def read_adm():
    result = {}
    query_lan = c.execute("Select ip,netmask,dhcp_enabled,enable_port,ifnull(mtu_size,0) from eth_ports where name='Admin'")
    for col in c:
        result['ip_address'] = col[0]
        result['subnet'] = col[1]
        result['dhcp_enabled'] = col[2]
        result['port_enabled'] = col[3]
        result['mtu_size'] = col[4]
    conn.commit()
    c.close()
    conn.close()
    print(json.JSONEncoder().encode(result))


print ("Content-type:text/html\r\n\r\n")

if request_Type == 'update_wan':
    update_wan()
elif request_Type == 'read_wan':
    read_wan()
elif request_Type == 'update_lan':
    update_lan()
elif request_Type == 'read_lan':
    read_lan()
elif request_Type == 'update_mgt':
    update_mgt()
elif request_Type == 'read_mgt':
    read_mgt()
elif request_Type == 'update_adm':
    update_adm()
elif request_Type == 'read_adm':
    read_adm()
