#!/usr/bin/env python
from email.mime.text import MIMEText
from email.mime.application import MIMEApplication
from email.mime.multipart import MIMEMultipart
from smtplib import SMTP
import smtplib

import cgi, cgitb
from global_gui_EmailConfig import *
import json

form = cgi.FieldStorage()

#Data from configuration
cnfg_gmailUser = cnfg_gmailUser
cnfg_gmailPwd = cnfg_gmailPwd
cnfg_gmailRplyUser = cnfg_gmailRplyUser
cnfg_smtpServer=cnfg_smtpServer
toList = cnfg_toList
ccList=cnfg_ccList
bccList=cnfg_bccList
#Data from configuration-end

attachmentPath='EmailSources/smapleAttachment.txt'
MessageSubject='subject'
MessageBody="""\
<html>
  <head></head>
  <body>
    <p  style="color:black">Hi,<br>
       Alert from Sanuyi<br>
       This is Scheduled Email Alert <br/><br/>
	   Frequency : ##Frequency <br/>
	   Action : ##Action
    </p><br>
	
	<b>
	Warm Regards,<br>
	Sanuyi Team
	</b>
  </body>
</html>
"""

#User Input
if form.getvalue('ToEmail'):
	toList=form.getvalue('ToEmail')
	toMail=(form.getvalue('ToEmail')).split(",")
if form.getvalue('CCEmail'):
	ccList=form.getvalue('CCEmail')
if form.getvalue('ToBcc'):
	bccList=form.getvalue('ToBcc')
if form.getvalue('Subject'):
	MessageSubject=form.getvalue('Subject')
if form.getvalue('Body'):
	MessageBody=form.getvalue('Body')
if form.getvalue('AttachmenPatha'):
	attachmentPath=form.getvalue('AttachmenPath')
#User Input End

def SendEmail(Frequency,Action):
	try:
		#emaillist =[elem.strip().split(',') for elem in toMail]
		msg = MIMEMultipart()
		msg['Subject'] = Frequency + '-'+Action  #MessageSubject
		msg['From'] = cnfg_gmailUser
		msg['Reply-to'] = cnfg_gmailRplyUser
		msg['To'] = toList
		msg['Cc'] = ccList
		msg['Bcc'] = bccList
 
		msg.preamble = 'Multipart massage.\n'
		msgBody=MessageBody.replace("##Frequency",Frequency)
		msgBody=msgBody.replace("##Action",Action)
		part = MIMEText(msgBody,'html')
		msg.attach(part)
 
		part = MIMEApplication(open(str(attachmentPath),"rb").read())
		part.add_header('Content-Disposition', 'attachment', filename=str('SanuyiLogs.txt'))
		msg.attach(part)
 

		server = smtplib.SMTP(cnfg_smtpServer)
		server.ehlo()
		server.starttls()
		server.login(cnfg_gmailUser, cnfg_gmailPwd) 
		server.sendmail(msg['From'], toList.split(',') , msg.as_string())
		return json.JSONEncoder().encode({"status":"success","Description":"Email Sent successfully","toList":[toList,ccList,bccList]})
	except smtplib.SMTPException as e: 
		return json.JSONEncoder().encode({"status":"fail","Description":e})
	except Exception as error: 
		return json.JSONEncoder().encode({"status":"fail","Description":error})

#print "Content-type:text/html\r\n\r\n"
#print SendEmail()
			