#!/usr/bin/python

import cgi,cgitb
import sqlite3
import json
from db import *
from cgi_common_methods import *
cgitb.enable()
result=[]

form = cgi.FieldStorage()

requestType = form.getvalue('requestType')
groupId = form.getvalue('groupId')

if form.getvalue('groupName'):
	groupName = form.getvalue('groupName')
else:
	groupName = "Accounting"

if form.getvalue('imageId'):
	imageId = form.getvalue('imageId')
else:
	imageId = "Not Entered"


def selectVMGroup(): 	
	query=c.execute("select vm_image.id,vm_image.image_name,vm_image.path_image_icon,vm_image.image_cost,vm_image.image_description,vm_image.downloded,vm_group.id FROM vm_group INNER JOIN vm_image ON vm_group.id=vm_image.vm_group_id  where vm_group.group_name=?",[groupName])
	conn.commit()

	for col in c:	
		temp={}
		temp['ImageId'] = col[0]
		temp['ImageName'] = col[1]
		temp['Path'] = col[2]
		temp['ImageCost'] = col[3]
		temp['ImageDesc'] = col[4]
		temp['downloaded'] = col[5]
		temp['GroupId'] = col[6]
		result.append(temp)

	print(json.JSONEncoder().encode(result))
	c.close()
	conn.close()
def selectVMGroupMyBackups(): 	
	query=c.execute("select id,BackupName,'/images/ubuntu3.jpg','free','',download_state,16 from myBackups")	
	conn.commit()

	for col in c:	
		temp={}
		temp['ImageId'] = col[0]
		temp['ImageName'] = col[1]
		temp['Path'] = col[2]
		temp['ImageCost'] = col[3]
		temp['ImageDesc'] = col[4]
		temp['downloaded'] = col[5]
		temp['GroupId'] = col[6]
		result.append(temp)

	print(json.JSONEncoder().encode(result))
	c.close()
	conn.close()

def selectVMImage():
	if groupId == '16':
		query="select BackupName,local_path,download_state,'free','0','',vm_image_size,myBackups.id,'/images/ubuntu3.jpg',download_path,vm_group.group_name from myBackups inner join vm_group on myBackups.vm_group_id=vm_group.id where myBackups.id='"+imageId+"'"
	else:
		query="select image_name,path_app_saved,downloded,image_cost,support_cost,image_description,vm_image_size,vm_image.id,path_image_icon,image_type,vm_group.group_name FROM vm_image inner join vm_group on vm_image.vm_group_id=vm_group.id  where vm_image.id='"+imageId+"'"
	
	query_slct=c.execute(query)
	conn.commit()
	for col in c:
		result={}
		if groupId == '16':
			serverPath = col[9]		
			DowloadedFileName = serverPath[serverPath.rfind('/')+1:]   							
			destination='Sanuyi/appImages' + '/' + col[10]
			vmImageDownloadedPath= destination+'/'+DowloadedFileName
		else:			
			DowloadedFileName = str(col[0])+'.'+str(col[9])			
			destination='Sanuyi/appImages' + '/' + col[10]
			vmImageDownloadedPath = destination+'/'+DowloadedFileName
		
		result['ImageName'] = col[0]
		result['Path'] = col[1]
		result['Downloded'] = col[2]
		result['ImageCost'] = col[3]
		result['SupportCost'] = col[4]
		result['Description'] = col[5]
		result['vmImageSize'] = convert_bytes(col[6])
		result['vmImageSizeBytes'] = col[6]
		result['vmImageDownloadedPath'] = vmImageDownloadedPath
		result['Id'] = col[7]
		result['Icon'] = col[8]

	print (json.JSONEncoder().encode(result))
	c.close()
	conn.close()

def updateVMImage():
	if groupId == '16':
		query="update myBackups set download_state = ? where id=?",('yes',imageId)
	else:
		query="update vm_image set downloded = ? where id=?",('yes',imageId)
	query_update=c.execute()
	conn.commit()
	c.close()
	conn.close()

	print(json.JSONEncoder().encode({'status':'success','data':'successfully downloaded'}))
		

	
print "Content-type:text/json\r\n\r\n"

if requestType == 'selectMyBakcupGroup':
	selectVMGroupMyBackups()
elif requestType == 'selectOtherGroup':
	selectVMGroup()
elif requestType=='selectVMImage':
	selectVMImage()
elif requestType=='updateVMImage':
	updateVMImage() #not using
	
