Highcharts.setOptions({
    global: {
        useUTC: false
    }
});

var progress=false;
var chartData="";
var seriesData = [];

function CallCSVData(csvPath)
{
	$.ajax({
    url: csvPath,
    success: function (csv) {			
		chartData = CSV2JSON(csv);
		
		StartChart(ConvertToSeriesData(chartData,'Disks'));
		StartCPUChart(ConvertToSeriesData(chartData,'CPU'));
		StartErrorsChart(ConvertToSeriesData(chartData,'Errors'));
	}
});
}
function UpdateFromCSVtoJSON(csvPath)
{
	$.ajax({
    url: csvPath,
    success: function (csv) {			
		chartData = CSV2JSON(csv);	
			$.each(chartData, function( index, item ) {
				if(item.Device == 'sdb'){
					// seriesData[0].data.push({'x':item.tps,'y':item['kB_wrtn/s']});
					// seriesData[2].data.push({'x':item.tps,'y':item['kb_read/s']})
					
					seriesData[0].data.push(item['kB_wrtn/s']);
					seriesData[2].data.push(item['kb_read/s'])
				}
				else
				{
					// seriesData[1].data.push({'x':item.tps,'y':item['kB_wrtn/s']});
					// seriesData[3].data.push({'x':item.tps,'y':item['kb_read/s']});
					seriesData[1].data.push(item['kB_wrtn/s']);
					seriesData[3].data.push(item['kb_read/s']);
				}
			});
		}
	});
}

CallCSVData('../Sanuyi/reports.csv');

function ConvertToSeriesData(Data,reportType)
{
	if(reportType == 'Disks'){
	seriesData = [
			{
				name: 'SDB -Write',
				selected: false,
				data: []
			},
			{
				name: 'SDC -Write',
				data: []
			},
			{
				name: 'SDB -Read',
				data: []
			},
			{
				name: 'SDC -Read',
				data: []
			}
	];
	
	$.each(Data, function( index, item ) {
		if(item.Device == 'sdb'){
			// seriesData[0].data.push({'x':item.tps,'y':item['kB_wrtn/s']});
			// seriesData[2].data.push({'x':item.tps,'y':item['kb_read/s']})
			
			seriesData[0].data.push(item['kB_wrtn/s']);
			seriesData[2].data.push(item['kb_read/s'])
		}
		else
		{
			// seriesData[1].data.push({'x':item.tps,'y':item['kB_wrtn/s']});
			// seriesData[3].data.push({'x':item.tps,'y':item['kb_read/s']});
			seriesData[1].data.push(item['kB_wrtn/s']);
			seriesData[3].data.push(item['kb_read/s']);
		}
	});
	
	seriesData[0].data=seriesData[0].data.slice(0, 10);
	seriesData[1].data=seriesData[1].data.slice(0, 10);
	seriesData[2].data=seriesData[2].data.slice(0, 10);
	seriesData[3].data=seriesData[3].data.slice(0, 10);
	return (seriesData);
   }
   else if(reportType == 'CPU'){
	seriescpuData = [
			{
				name: 'CPU',
				selected: false,
				data: []
			},
			{
				name: 'Memory',
				data: []
			},
			{
				name: 'Network',
				data: []
			}
	];
	
	$.each(Data, function( index, item ) {
		if(item.Device == 'sdb'){
			// seriesData[0].data.push({'x':item.tps,'y':item['kB_wrtn/s']});
			// seriesData[2].data.push({'x':item.tps,'y':item['kb_read/s']})
			
			seriescpuData[0].data.push(item['kB_wrtn/s']);
			seriescpuData[2].data.push(item['kb_read/s'])
		}
		else
		{
			// seriesData[1].data.push({'x':item.tps,'y':item['kB_wrtn/s']});
			// seriesData[3].data.push({'x':item.tps,'y':item['kb_read/s']});
			seriescpuData[1].data.push(item['kB_wrtn/s']);
			//seriescpuData[3].data.push(item['kb_read/s']);
		}
	});
	
	seriescpuData[0].data=seriescpuData[0].data.slice(0, 10);
	seriescpuData[1].data=seriescpuData[1].data.slice(0, 10);
	seriescpuData[2].data=seriescpuData[2].data.slice(0, 10);
	//seriesData[3].data=seriesData[3].data.slice(0, 10);
	return (seriescpuData);
   }
   else if (reportType == 'Errors')
   {
	   var errorSeriesData = [
			{
				name: 'Errors',
				selected: false,
				data: []
			}
	];
	
	$.each(Data, function( index, item ) {
		if(item.Device == 'sdb'){
			// seriesData[0].data.push({'x':item.tps,'y':item['kB_wrtn/s']});
			errorSeriesData[0].data.push(item['kB_wrtn/s']);			
		}
		else
		{
			// seriesData[1].data.push({'x':item.tps,'y':item['kB_wrtn/s']});
			// seriesData[3].data.push({'x':item.tps,'y':item['kb_read/s']});
			errorSeriesData[0].data.push(item['kB_wrtn/s']);
			//errorSeriesData[3].data.push(item['kb_read/s']);
		}
	});
	
	errorSeriesData[0].data=errorSeriesData[0].data.slice(0, 10);
	
	return (errorSeriesData);
   }
}


	
	
function StartChart(series){
Highcharts.chart('container', {
    chart: {
        type: 'line',
		//zoomType: 'xy',
		//backgroundColor: "#9e9e9e",
        animation: Highcharts.svg, // don't animate in old IE
        marginRight: 10,
        events: {
            load: function () {
                var series = this.series[0];
				var series1 = this.series[1];
				var series2 = this.series[2];
				var series3 = this.series[3];
				var i = 1;
                setInterval(function () {		
					UpdateFromCSVtoJSON('../Sanuyi/reports.csv');
                     var x = i+1;
						 i=i+1;
                         //y = Math.random()*100;
						 if(progress){
							 // series.addPoint([x, Math.random()*100], true, true);	
							 // series1.addPoint([x, Math.random()*100], true, true);
							// series2.addPoint([x, Math.random()*100], true, true);
							// series3.addPoint([x, Math.random()*100], true, true);
							series.addPoint(seriesData[0].data.slice(-1)[0], true, true);	
							 series1.addPoint(seriesData[1].data.slice(-1)[0], true, true);
							series2.addPoint(seriesData[2].data.slice(-1)[0], true, true);
							series3.addPoint(seriesData[3].data.slice(-1)[0], true, true);
						 }							 
                 }, 1000);
            }
        }
    },
    title: {
        text: 'Disks Analytics',
		style: { "color": "black", "fontSize": "20px" ,fontWeight: 'bold'},
    },
    xAxis: {
        //type: 'datetime',
		
        tickInterval: 1,
		title: {
            text: 'Time',
			style: { "color": "black", "fontSize": "15px" ,fontWeight: 'bold'},
        },
		
    },
    yAxis: {
		max: 100,
        min: 0,
        title: {
            text: 'Utilization',
			style: { "color": "black", "fontSize": "15px",fontWeight: 'bold' },
        },
		gridLineWidth:0,
         plotLines: [{
             value: 0,
			 width: 1,
			color: '#808080'
		}]
    },
    tooltip: {
        formatter: function () {
            // return '<b>' + this.series.name + '</b><br/>' +
                // Highcharts.dateFormat('%Y-%m-%d %H:%M:%S', this.x) + '<br/>' +
                // Highcharts.numberFormat(this.y, 2);
			return this.series.name +' - '+ this.y
        }
    },
    legend: {
        enabled: true,
		
    },
	colors: ["red", "green","blue","black"],
    exporting: {
        enabled: false
    },
    series: series,
	plotOptions: {
            series: {
                showCheckbox: false,
				marker: { enabled: false },
                events: {
		                    checkboxClick: function(event) {
		                        if(event.checked)
		                        	{
		                        	this.show();
		                        	this.legendSymbol.hide();
		                        	}
		                        else{
		                        	this.hide();
		                        	this.legendSymbol.hide();
		                        	}
                            }
		                    }
            }
        },
});
}

$('#start').click(function(){	  
		progress = true;
 });
$('#stop').click(function(){	  
		progress = false;
});


function CSVToArray(strData, strDelimiter) {
    // Check to see if the delimiter is defined. If not,
    // then default to comma.
    strDelimiter = (strDelimiter || ",");
    // Create a regular expression to parse the CSV values.
    var objPattern = new RegExp((
    // Delimiters.
    "(\\" + strDelimiter + "|\\r?\\n|\\r|^)" +
    // Quoted fields.
    "(?:\"([^\"]*(?:\"\"[^\"]*)*)\"|" +
    // Standard fields.
    "([^\"\\" + strDelimiter + "\\r\\n]*))"), "gi");
    // Create an array to hold our data. Give the array
    // a default empty first row.
    var arrData = [[]];
    // Create an array to hold our individual pattern
    // matching groups.
    var arrMatches = null;
    // Keep looping over the regular expression matches
    // until we can no longer find a match.
    while (arrMatches = objPattern.exec(strData)) {
        // Get the delimiter that was found.
        var strMatchedDelimiter = arrMatches[1];
        // Check to see if the given delimiter has a length
        // (is not the start of string) and if it matches
        // field delimiter. If id does not, then we know
        // that this delimiter is a row delimiter.
        if (strMatchedDelimiter.length && (strMatchedDelimiter != strDelimiter)) {
            // Since we have reached a new row of data,
            // add an empty row to our data array.
            arrData.push([]);
        }
        // Now that we have our delimiter out of the way,
        // let's check to see which kind of value we
        // captured (quoted or unquoted).
        if (arrMatches[2]) {
            // We found a quoted value. When we capture
            // this value, unescape any double quotes.
            var strMatchedValue = arrMatches[2].replace(
            new RegExp("\"\"", "g"), "\"");
        } else {
            // We found a non-quoted value.
            var strMatchedValue = arrMatches[3];
        }
        // Now that we have our value string, let's add
        // it to the data array.
        arrData[arrData.length - 1].push(strMatchedValue);
    }
    // Return the parsed data.
    return (arrData);
}

function CSV2JSON(csv) {
    var array = CSVToArray(csv);
    var objArray = [];
    for (var i = 1; i < array.length; i++) {
        objArray[i - 1] = {};
        for (var k = 0; k < array[0].length && k < array[i].length; k++) {
            var key = array[0][k];
            objArray[i - 1][key] = isNaN(array[i][k]) ? array[i][k]: parseFloat(array[i][k])
        }
    }

    var json = JSON.stringify(objArray);
    var str = json.replace(/},/g, "},\r\n");
	chartData=objArray;
    return objArray;
}
function StartCPUChart(series){
Highcharts.chart('container1', {
    chart: {
        type: 'line',
		//zoomType: 'xy',
		//backgroundColor: "#9e9e9e",
        animation: Highcharts.svg, // don't animate in old IE
        marginRight: 10,
        events: {
            load: function () {
                var series = this.series[0];
				var series1 = this.series[1];
				var series2 = this.series[2];
				var series3 = this.series[3];
				var i = 1;
                setInterval(function () {		
					UpdateFromCSVtoJSON('../Sanuyi/reports.csv');
                     var x = i+1;
						 i=i+1;
                         //y = Math.random()*100;
						 if(progress){
							 // series.addPoint([x, Math.random()*100], true, true);	
							 // series1.addPoint([x, Math.random()*100], true, true);
							// series2.addPoint([x, Math.random()*100], true, true);
							// series3.addPoint([x, Math.random()*100], true, true);
							//series.addPoint(seriesData[0].data.slice(-1)[0], true, true);	
							 //series1.addPoint(seriesData[1].data.slice(-1)[0], true, true);
							//series2.addPoint(seriesData[2].data.slice(-1)[0], true, true);
							//series3.addPoint(seriesData[3].data.slice(-1)[0], true, true);
						 }							 
                 }, 1000);
            }
        }
    },
    title: {
        text: 'CPU - MEMORY - NETWORK',
		style: { "color": "black", "fontSize": "20px" ,fontWeight: 'bold'},
    },
    xAxis: {
        //type: 'datetime',
		
        tickInterval: 1,
		title: {
            text: 'Time',
			style: { "color": "black", "fontSize": "15px" ,fontWeight: 'bold'},
        },
		
    },
    yAxis: {
		max: 100,
        min: 0,
        title: {
            text: 'Utilization(%)',
			style: { "color": "black", "fontSize": "15px",fontWeight: 'bold' },
        },
		gridLineWidth:0,
         plotLines: [{
             value: 0,
			 width: 1,
			color: '#808080'
		}]
    },
    tooltip: {
        formatter: function () {
            // return '<b>' + this.series.name + '</b><br/>' +
                // Highcharts.dateFormat('%Y-%m-%d %H:%M:%S', this.x) + '<br/>' +
                // Highcharts.numberFormat(this.y, 2);
			return this.series.name +' - '+ this.y
        }
    },
    legend: {
        enabled: true,
		
    },
	colors: ["red", "green","blue","black"],
    exporting: {
        enabled: false
    },
    series: series,
	plotOptions: {
            series: {
                showCheckbox: false,
				marker: { enabled: false },
                events: {
		                    checkboxClick: function(event) {
		                        if(event.checked)
		                        	{
		                        	this.show();
		                        	this.legendSymbol.hide();
		                        	}
		                        else{
		                        	this.hide();
		                        	this.legendSymbol.hide();
		                        	}
                            }
		                    }
            }
        },
});
}
function StartErrorsChart(series){
Highcharts.chart('container2', {
    chart: {
        type: 'line',
		//zoomType: 'xy',
		//backgroundColor: "#9e9e9e",
        animation: Highcharts.svg, // don't animate in old IE
        marginRight: 10,
        events: {
            load: function () {
                var series = this.series[0];
				
				var i = 1;
                setInterval(function () {		
					UpdateFromCSVtoJSON('../Sanuyi/reports.csv');
                     var x = i+1;
						 i=i+1;
                         //y = Math.random()*100;
						 if(progress){
							 // series.addPoint([x, Math.random()*100], true, true);	
							 
							//series.addPoint(seriesData[0].data.slice(-1)[0], true, true);	
							 
						 }							 
                 }, 1000);
            }
        }
    },
    title: {
        text: 'System Errors',
		style: { "color": "black", "fontSize": "20px" ,fontWeight: 'bold'},
    },
    xAxis: {
        //type: 'datetime',
		
        tickInterval: 1,
		title: {
            text: 'Time',
			style: { "color": "black", "fontSize": "15px" ,fontWeight: 'bold'},
        },
		
    },
    yAxis: {
		max: 100,
        min: 0,
        title: {
            text: 'Error Level',
			style: { "color": "black", "fontSize": "15px",fontWeight: 'bold' },
        },
		gridLineWidth:0,
         plotLines: [{
             value: 0,
			 width: 1,
			color: '#808080'
		}]
    },
    tooltip: {
        formatter: function () {
            // return '<b>' + this.series.name + '</b><br/>' +
                // Highcharts.dateFormat('%Y-%m-%d %H:%M:%S', this.x) + '<br/>' +
                // Highcharts.numberFormat(this.y, 2);
			return this.series.name +' - '+ this.y
        }
    },
    legend: {
        enabled: true,
		
    },
	colors: ["red", "green","blue","black"],
    exporting: {
		enabled: false,
        chartOptions: { // specific options for the exported image
            plotOptions: {
                series: {
                    dataLabels: {
                        enabled: true
                    }
                }
            }
        },
        fallbackToExportServer: false
    },
    series: series,
	plotOptions: {
            series: {
                showCheckbox: false,
				marker: { enabled: false },
                events: {
		                    checkboxClick: function(event) {
		                        if(event.checked)
		                        	{
		                        	this.show();
		                        	this.legendSymbol.hide();
		                        	}
		                        else{
		                        	this.hide();
		                        	this.legendSymbol.hide();
		                        	}
                            }
		                    }
            }
        },
});
}