function Request() {
    var request = {
        url: "",
        parameters: {},
        statusType: "",
		typeNumber: "",
		isSingleStatus:false
    };
    return request;
}
$(window).bind("load", function() { 
	$('#ddlLogType').multiselect({
		includeSelectAllOption:true,
		selectAllText:'All',

	});
	$("#ddlLogType").multiselect('selectAll', false);
    $("#ddlLogType").multiselect('updateButtonText');

	$('#btnSearch').trigger('click',function(){
		return false;
	});
	
});
function GetLogs()
{	
	var logType = $('#ddlLogType').val() != null ? $('#ddlLogType').val().toString():'All';
	
	var request = new Request();
	request.url = "cgi/cgi_CCMLogs.py";
	request.statusType="GetLogs";
	request.parameters={"request_Type":"read_CCMLogs","startDate":$('#txtStartDate').val(),"endDate":$('#txtEndDate').val(),"maxLogLevel":$('#txtLogLevel').val(),"logType":logType}
	CallPythonService(request);	
}

function GetAlerts()
{	
	var logType = $('#ddlLogType').val() != null ? $('#ddlLogType').val().toString():'All';
	
	var request = new Request();
	request.url = "cgi/cgi_CCMLogs.py";
	request.statusType="GetLogs";
	request.parameters={"request_Type":"read_CCMAlerts","startDate":$('#txtStartDate').val(),"endDate":$('#txtEndDate').val(),"maxLogLevel":$('#txtLogLevel').val(),"logType":logType}
	CallPythonService(request);	
}
function CallPythonService(request) {
	request.parameters.uuid=uuid;
    $.ajax({
        type: "Get",
        url: request.url,
        contentType: 'application/json',
        dataType: 'json',
        headers: { 'Access-Control-Allow-Origin': '*' },
        data: request.parameters,
        success: function (response) {
			if(response.status == 'fail')
				notify(response.description,response.description,response.status);
			else
				BindResponseData(request.statusType,response);
        },
        error: function (ex) {
            if(!isProduction){
				console.log(ex);
			}
        }
    });
}
function BindResponseData(statusType, response) {
    if (statusType === 'GetLogs') {    
		var headers = response.headers;
		var propetyName = response.propetyName
        var tableHeader = '<table class="table table-striped table-bordered" id="tblLogsData"><thead><tr class="tbheader">'
		var headerTxt = '';
		$.each(headers, function (i, item) {
			var cls = '';
			if(item == 'Message')
				cls = 'class="messageIDtxt"'
			headerTxt +='<th '+cls+' >'+item+'</th>'
		});		
		tableHeader += headerTxt+'</tr></thead><tbody id="tbodyLogsData"></tbody></table>'
        $('#displayData').html(tableHeader);
        $.each(response.logsData, function (i, item) {
            var records = '<tr>'; //'<tr><td>' + SplitDateTime(item.Date,"date") + '</td><td>' + SplitDateTime(item.Date,"time") + '</td><td>' + 'Element' + '</td><td>' + 'Error' + '</td><td>' + 'State' + '</td><td>' + item.Log + '</td></tr>'
            
			var recordsTxt = '';
			$.each(propetyName, function (i, prop) {
				var cls = '';
				if(prop == 'message')
					cls = 'class="messageIDtxt"'
				recordsTxt +='<td '+cls+' >'+item[prop]+'</td>';
			});
			records += recordsTxt+'</tr>'
			
			$('#tbodyLogsData').append(records);
        });
		$('#tblLogsData').DataTable({
			"columns" : response.colWidth
		});
    }
	else if (statusType === "DownloadLogs" ) {
		var link = document.createElement("a");
		// If you don't know the name or want to use
		// the webserver default set name = ''
		link.setAttribute('download', response['filename']);
		link.href = response['download_file'];
		document.body.appendChild(link);
		link.click();
		link.remove();
		$('#download').html('Download');
		$('#download').removeClass('custom-disabled');
	}   
}
function SplitDateTime(dateTime,type)
{
	var data=dateTime.split("-");
	if(type == 'date')
		return data[0];
	else
		return data[1];
}

Date.prototype.addHours = function(h) {    
   this.setTime(this.getTime() - (h*60*1000)); 
   return this;   
}
function ConvertDateFormat2(YYYmmdd)
{
	var lst=YYYmmdd.split('-');
	return ((parseInt(lst[1])+1) < 10 ? '0'+(parseInt(lst[1])+1) : (parseInt(lst[1])+1))+"/"+lst[2]+"/"+lst[0];
}
function ConvertToLocalDate(UTCDate,UtcTime)
{
	var utcDate = UTCDate+'T'+UtcTime+':00'; //'2011-06-29T16:52:48.000Z';  // ISO-8601 formatted date returned from server
	var localDate = new Date(utcDate);
	localDate.addHours(localDate.getTimezoneOffset())
	return ConvertDateFormat2(localDate.getFullYear()+'-'+ (localDate.getMonth()<10? ('0'+localDate.getMonth()):localDate.getMonth())+'-'+(localDate.getDate()<10?('0'+localDate.getDate()):localDate.getDate()));
}
function ConvertToLocalTime(UTCDate,UtcTime)
{
	var utcDate = UTCDate+'T'+UtcTime+':00'; //'2011-06-29T16:52:48.000Z';  // ISO-8601 formatted date returned from server
	var localDate = new Date(utcDate);
	localDate.addHours(localDate.getTimezoneOffset())
	return (localDate.getHours()<10?('0'+localDate.getHours()):localDate.getHours())+':'+(localDate.getMinutes()<10?('0'+localDate.getMinutes()):localDate.getMinutes());
}

function downloadLogs() {
	$('#download').html('<div class="dot-carousel-white"></div>');
	$('#download').addClass('custom-disabled');
	var request = new Request();
	request.url = "cgi/cgi_CCMLogs.py";
	request.statusType="DownloadLogs";
	request.parameters={"request_Type":"download_logs"}
	CallPythonService(request);	
}