function Request() {
    var request = {
        url: "",
        parameters: {},
        statusType: "",
		typeNumber: "",
		isSingleStatus:false
    };
    return request;
}
var SchDeleteId=0;
var isLocalTimeZone = true;
$(window).bind("load", function() {
    GetEmailSchedule();
	if(!($('#hdnIsAlertPage').val() == true))
		GetDownloads();
	setInterval(function(){ GetEmailSchedule(); }, scheduledListRefresh);
	setInterval(function(){ GetDownloads(); }, downloadListRefresh);
});
function GetEmailSchedule()
{	
	var request = new Request();
	request.url = "cgi/cgi_Scheduler_Manager.py";
	request.statusType="EmailAlerts";
	request.parameters={'requestType':'read_schedule',"type":$('#hdnType').val(),'scheduleId':0}
	CallPythonService(request);	
}
function DeleteSchedule()
{
	
	var request = new Request();
	request.url = "cgi/cgi_Scheduler_Manager.py";
	request.statusType="DeleteSchedule";
	request.parameters={'requestType':'delete_schedule',"scheduleId":SchDeleteId}
	CallPythonService(request);	
	
}

function CallPythonService(request) {
	request.parameters.uuid=uuid;
    $.ajax({
        type: "Get",
        url: request.url,
        contentType: 'application/json',
        dataType: 'json',
        headers: { 'Access-Control-Allow-Origin': '*' },
        data: request.parameters,
        success: function (response) {			
				BindResponseData(request.statusType,response);
        },
        error: function (ex) {
            if(!isProduction){
				console.log(ex);
				alert(ex);	
			}
        }
    });
}
function BindResponseData(statusType, response) {
	
    if (statusType === 'EmailAlerts') {   
		var hdnType  = $('#hdnType').val();
		if($('#hdnIsAlertPage').val())
			response = jQuery.grep(response, function( n, i ) {
				return ( n.action === 'Email Logs');
			});
        
		// var dataTable = $('#tblSchedulerList').DataTable();
		// dataTable.destroy();
		
		var tableHeader = '<table id="tblSchedulerList" id="tblSchedulerList" class="table table-striped table-bordered"><thead><th>Name</th><th>Start Time</th><th>Start Date</th><th>End Date</th><th>Type</th><th>Server</th><th>Frequency</th><th>Status</th><th>%Status</th><th class="centitle noSorting linksWidth">Actions</th></thead><tbody id="tbodySchedulerList"></tbody></table>'
        $('#divScheduleList').html(tableHeader);			
		
        $.each(response, function (i, item) {
            var records = '<tr><td>' + item.name + '</td><td>' + ConvertToLocalTime(item.start_date,item.start_time) + '</td><td>' + ConvertToLocalDate(item.start_date,item.start_time) + '</td><td>' + ConvertToLocalDate(item.end_date,item.start_time) + '</td><td>' + item.action + '</td><td>' + (item.vm_ID != null ? item.vm_ID:'') + '</td><td>' + item.frequency + '</td><td>' + item.status + '</td><td>' + item.PerDone + '</td><td><span class="linksBlk"><a href="schedule.html?type=Edit#'+item.id+'">Edit</a><a href="javascript:void(0);" onclick="DeleteConfirm('+item.id+')">Delete</a><a href="javascript:void(0);" onclick="SchedulerInfo('+item.id+')">Info</a></span></td></tr>'
            $('#tbodySchedulerList').append(records);
        }); 
		
		 var dataTable = $('#tblSchedulerList').DataTable();
		 dataTable.destroy();
		 $('#tblSchedulerList').DataTable();
		
    }
	else if (statusType === 'GetDownloads') {   
		
        var tableHeader = '<table border="1" class="table table-curved tbdata" id="tblAppDownloads"><thead><tr class="tbheader"><th>Image Name</th><th>Group Name</th><th>Download Percentage</th><th>Download Status</th></tr></thead><tbody id="tbodyAppDownloads"></tbody></table>'
        $('#displayDataDownloads').html(tableHeader);
        $.each(response, function (i, item) {
			var imgUrl = item.status == "yes"? "images/installed.png":"images/downloadingicon.gif"
            var records = '<tr><td>' + item.name + '</td><td>' + item.group_name + '</td><td><b>' + (item.download_percentage == null ? 0: item.download_percentage) + '</b> %</td><td>' + (item.status == "yes"? "Completed":"In Progress")+ '<img src="'+imgUrl+'" style="width: 50px;height: 30px;padding-left: 5px;"/>' + '</td></tr>'
            $('#tbodyAppDownloads').append(records);
        });       
		var dataTable = $('#tblAppDownloads').DataTable();
		 dataTable.destroy();
		 $('#tblAppDownloads').DataTable();
    }
	else if(statusType == 'DeleteSchedule')
	{
		if(response.status =='success')
		{
			$('#divMessage').html(response.description);
			$('#popMessage').modal('show');
			//alert(response.description);
			// location.reload();
		}else
			alert(response.description);
	}
	else if(statusType == 'scheduleInfo')
	{
		var dataTable = $('#tblSchedulerInfo').DataTable();
		dataTable.destroy();
		$('#tbodySchedulerInfo').html('');
		$.each(response, function (i, item) {
		var infoRow =`<tr>
				 <td>`+ConvertToLocalDate(item.date,item.time)+`</td>
                <td>`+ConvertToLocalTime(item.date,item.time)+`	</td>
                 <td>`+item.result+`</td>
            </tr> `
		
			$('#tbodySchedulerInfo').append(infoRow);	
		});		
		$('#tblSchedulerInfo').DataTable();
		$('#schedulerInfoPopup').modal('show');	
		
	}
    
}
function DeleteConfirm(schId)
{
	SchDeleteId=schId;
	$('#DeletePop').modal('show');
}
Date.prototype.addHours = function(h) {    
   this.setTime(this.getTime() - (h*60*1000)); 
   return this;   
}
function ConvertDateFormat2(YYYmmdd)
{
	var lst=YYYmmdd.split('-');
	return ((parseInt(lst[1])+1) < 10 ? '0'+(parseInt(lst[1])+1) : (parseInt(lst[1])+1))+"/"+lst[2]+"/"+lst[0];
}
function ConvertToLocalDate(UTCDate,UtcTime)
{
	var utcDate = UTCDate+'T'+UtcTime+':00'; //'2011-06-29T16:52:48.000Z';  // ISO-8601 formatted date returned from server
	var localDate = new Date(utcDate);
	if(isLocalTimeZone)
		localDate.addHours(localDate.getTimezoneOffset())
	return ConvertDateFormat2(localDate.getFullYear()+'-'+ (localDate.getMonth()<10? ('0'+localDate.getMonth()):localDate.getMonth())+'-'+(localDate.getDate()<10?('0'+localDate.getDate()):localDate.getDate()));
}
function ConvertToLocalTime(UTCDate,UtcTime)
{
	var utcDate = UTCDate+'T'+UtcTime+':00'; //'2011-06-29T16:52:48.000Z';  // ISO-8601 formatted date returned from server
	var localDate = new Date(utcDate);
	if(isLocalTimeZone)
		localDate.addHours(localDate.getTimezoneOffset())
	return (localDate.getHours()<10?('0'+localDate.getHours()):localDate.getHours())+':'+(localDate.getMinutes()<10?('0'+localDate.getMinutes()):localDate.getMinutes());
}
$('#chkTimeZone').change(function(){
	if($(this).prop("checked") == true){
		isLocalTimeZone=true;
	}
	else if($(this).prop("checked") == false){
		isLocalTimeZone = false;
	}
	GetEmailSchedule();
});
function GetDownloads()
{
	var request = new Request();
	request.url = "cgi/cgi_DownloadUploads_Get.py";
	request.statusType="GetDownloads";
	request.parameters={"type":"downloads"}
	CallPythonService(request);	
}
function SchedulerInfo(scheduleId)
{
	var request = new Request();
	request.url = "cgi/cgi_Scheduler_Manager.py";
	request.statusType="scheduleInfo";
	request.parameters={"scheduleId":scheduleId,'requestType':'read_scheduleInfo'}
	CallPythonService(request);
}