var scheduleId=0;
var folderSVG = `<svg version="1.1" id="Capa_1" xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" x="0px" y="0px"
viewBox="0 0 468.293 468.293" style="enable-background:new 0 0 468.293 468.293;" xml:space="preserve">
<path style="fill:#F6C358;" d="M206.049,72.574V55.559c0-10.345-8.386-18.732-18.732-18.732H18.732C8.386,36.827,0,45.213,0,55.559
v110.248h468.293v-62.013c0-10.345-8.386-18.732-18.732-18.732H218.537C211.64,85.062,206.049,79.471,206.049,72.574z"/>
<path style="fill:#FCD462;" d="M443.317,431.466H24.976C11.182,431.466,0,420.284,0,406.49V161.35h206.748
c5.268,0,10.293-2.218,13.842-6.111l23.013-25.241c3.549-3.893,8.574-6.111,13.842-6.111h210.848V406.49
C468.293,420.284,457.111,431.466,443.317,431.466z"/>
</svg>`;
var dirs= [];
var responseVolumeList = [];
var editScheduleData = {};
$(window).bind("load", function() {	
	BindVMTableData();
	BindVolumeTableData();
	BindAllHosts();
	//GetScheduleEditData();
});
function Request() {
    var request = {
        url: "",
        parameters: {},
        Type: ""
    };
    return request;
}
function CallPythonService(request) {
	request.parameters.uuid=uuid;
    $.ajax({
        type: "Get",
        url: request.url,
        contentType: 'application/json',
        dataType: 'json',
        headers: { 'Access-Control-Allow-Origin': '*' },
        data: request.parameters,
		beforeSend: function(xhr){
			xhr.setRequestHeader('X-Test-Header', 'test-value');},
        success: function (response) {
            BindResponseData(request.Type, response);
        },
        error: function (ex) {			
            if(!isProduction){
				console.log(ex.responseText);
			}
        }
    });
}
function BindResponseData(type,response)
{		
	if(type=='cgi_Schedule_save')
	{
		$('#divMessage').html(response.description);	
		$('#emailAlert').modal('show');	
	}
	else if(type === 'ALLVM')
	{		
		$('#divVmList').html('');
		
		$.each(response, function (i, item) {
            var imgHtml = '<tr><td class-span-trim" title="'+item.name+'">'+item.name+'</td><td>'+item.appType+'</td><td align="center">'+item.CreateDate+'</td><td>'+GetStatusNameById(item.state)+'</td><td>'+'<input type="radio" name="rdServer" class="clsSelect" value='+item.id+' /></td></tr>';
			$('#divVmList').append(imgHtml);
        });
		 var dataTable = $('#tblAppList').DataTable();
		 dataTable.destroy();
		 $('#tblAppList').DataTable();
		
		$('.clsEditConfirm').click(function(){
			var url=$(this).attr('url');
			var currentState=$(this).attr('state');
			if(currentState !=4)
			{				
				$('#erYES').attr('onclick','location.href="'+url+'"');	
				$('#editRedirect').modal('show');
			}else
				location.href=url;
		});
		$(".class-span-trim").each(function(i){
        var len=$(this).text().trim().length;
        if(len>25)
        {
            $(this).text($(this).text().substr(0,25)+'...');
        }
		});
			}
	else if(type === 'ALLVolumes')
	{

		 var data = new Array;
		 var logTable=null;
		 var headers=[];
		 responseVolumeList = response;
		 $.each(response, function (index, value) {
			if($('#ddlAction').val()==10 && !(value["backup_device"]=="false" && $('#ddlFrequency option:selected').text() == 'At Canister Insert'))
			{
				var tempArray = new Array;
				//tempArray.push('<input type="radio" name="rdVolume" class="clsSelect" id="rdVolume_'+value["id"]+'" value='+value["id"]+' />');
				tempArray.push('<span title="' + value["name"]+ '">' +  trimString(value["name"]) + '</span>');
				tempArray.push(value["type"]);
				tempArray.push(value["createdDate"]);
				tempArray.push(GetStatusNameById(value["state"])); 
				if(value["backup_device"]=="false") {                        
						tempArray.push('<input style="margin-right:10px" type="checkbox" name="rdVolume" class="clsSelect" id="rdVolume_'+value["id"]+'" value='+value["id"]+' /><label for="rdVolume_'+value["id"]+'" style="all: revert;"><span title="' + value["name"]+ '">' +  trimString(value["name"]) + '</span></label><a onclick="openSelectDirectoryPopUp();" title="Selected Directories">'+folderSVG+'</a>');
						tempArray.push('');
				}
				else{
					tempArray.push('');
					tempArray.push('<input style="margin-right:10px" type="checkbox" name="rdDestVolume" class="clsSelect" id="rdDestVolume_'+value["id"]+'" value='+value["id"]+' /><span title="' + value["name"]+ '">' +   trimString(value["name"]) + '</span>'); 		
				}
				data.push(tempArray);
			}
			else if(((value["hostId"]==$('#ddlBackup').val() || $('#ddlBackup').val()=='a4') || value["backup_device"]=="false") && !(value["backup_device"]=="false" && $('#ddlFrequency option:selected').text() == 'At Canister Insert'))
			{
				var tempArray = new Array;
				//tempArray.push('<input type="radio" name="rdVolume" class="clsSelect" id="rdVolume_'+value["id"]+'" value='+value["id"]+' />');
				tempArray.push('<span title="' + value["name"]+ '">' +  trimString(value["name"]) + '</span>');
				tempArray.push(value["type"]);
				tempArray.push(value["createdDate"]);
				tempArray.push(GetStatusNameById(value["state"])); 
				if(value["backup_device"]=="false") {                        
						tempArray.push('<input style="margin-right:10px" type="checkbox" name="rdVolume" class="clsSelect" id="rdVolume_'+value["id"]+'" value='+value["id"]+' /><label for="rdVolume_'+value["id"]+'" style="all: revert;"><span title="' + value["name"]+ '">' +  trimString(value["name"]) + '</span></label><a onclick="openSelectDirectoryPopUp();" title="Selected Directories">'+folderSVG+'</a>');
						tempArray.push('');
				}
				else{
					tempArray.push('');
					tempArray.push('<input style="margin-right:10px" type="checkbox" name="rdDestVolume" class="clsSelect" id="rdDestVolume_'+value["id"]+'" value='+value["id"]+' /><span title="' + value["name"]+ '">' +   trimString(value["name"]) + '</span>'); 		
				}
				data.push(tempArray);
			}
        });

		 //headers
		 headers=[
		 	 //{"title":"Select Vol"},
			 {"title":"Name"},
			 {"title":"Type"},
			 {"title":"Created Date"},
			 {"title":"Status"},			 
			 {"title":"Source Vol"},
			 {"title":"Destination Vol"},
		 ];

		logTable=$('#tblVolumeList').DataTable( {	
			destroy:true,	
			scrollX:false,				
	        data: data,
	        columns: headers,
			columnDefs: [
		    	//{ width: 50, targets: 0,orderable: false },
		    	{ width: 100, targets: 0 },
		    	{ width: 60, targets: 1 },
		    	{ width: 100, targets: 2 },
		    	{ width: 60, targets: 3 },
		    	{ width: 120, targets: 4 },
		    	{ width: 120, targets: 5 }
		  	]
	    });	

	    $("#divVolumeList").hide();
		$('#tblVolumeList a').css('pointer-events','none');
		$('#tblVolumeList a').children('svg').css('filter','grayscale(100%)');

		$(".class-span-trim").each(function(i){
			var len=$(this).text().trim().length;
			if(len>25)
			{
				$(this).text($(this).text().substr(0,25)+'...');
			}
		});
		GetScheduleEditData();
		//console.log("All Volumes")
	}
	else if(type == 'EditSchedule')
	{
		var schedule=response[0];
		editScheduleData = schedule;
		$('#txtScheduleName').val(schedule.name);
		// $('#ddlAction').val(schedule.action);
		// $('#ddlBackup').val(schedule.name);
		$("#ddlFrequency option:contains(" + schedule.frequency + ")").attr('selected', 'selected');
		$("#ddlFrequency").trigger("change");
		$("#ddlAction option:contains(" + schedule.action + ")").attr('selected', 'selected');
		
		if(schedule.vm_ID != null){
		var arrayVMList=schedule.vm_ID+','.split(',')
		$('input[type=radio]').each(function(){
			if($.inArray($(this).attr('value'),arrayVMList) >=0)
				$(this).attr('checked',true);
		});
		}
		$('#rdVolume_'+schedule.source_vol_id).attr('checked',true);
		$('#rdDestVolume_'+schedule.dest_vol_id).attr('checked',true);
		//prevVolId = schedule.source_vol_id;
		//updateCheckbox();
		//updateFolderIcon();
		if(schedule.action_element != null)
			$("#ddlBackup option:contains(" + schedule.action_element + ")").attr('selected', 'selected');
		else
			$("#bckServer").css('display','none');
		
		$('#txtStartTime').val(ConvertToLocalTime(schedule.start_date,schedule.start_time));
		$('#txtStartDate').val(ConvertDateFormat3(ConvertToLocalDate(schedule.start_date,schedule.start_time)));
		$('#txtEndDate').val(ConvertDateFormat3(ConvertToLocalDate(schedule.end_date,schedule.start_time)));

		var selectedAction  = $("#ddlAction").val();
				
		if(selectedAction == 2 || selectedAction==3 || selectedAction==4) //2,3,4,8
			$('#divVM').css('display','block');
		else
			$('#divVM').css('display','none');
		
		var actionList = [8,9,10,11,12,15,16]
		//if(selectedAction == 8 || selectedAction==9 || selectedAction==11 ||  selectedAction==12) //2,3,4,8
		//console.log("Selected action : ",volList.includes(parseInt(selectedAction)));
		if(actionList.includes(parseInt(selectedAction)))
		{
			//updateVolumeList();
			$('#divVolumeList').css('display','block');
		}
		else
			$('#divVolumeList').css('display','none');
		updateVolumeList();
		
		selectedVolume = schedule.source_vol_id;
		dirs = schedule.dirs;
		prevVolId = selectedVolume;
		var request = new Request();
		request.url = 'cgi/cgi_Scheduler_Manager.py';
		request.Type = 'cgi_Retrieve_DirectoriesEdit';
		request.parameters = {'requestType':'read_Directories',"volId":selectedVolume};
		CallPythonService(request);
		
	}
	else if(type=='getHosts'){
		$.each(response, function (index, value) {
			if(value["host_type"]=="Backup Server" || value["host_type"]=="Storage Manager")
				$("#ddlBackup").append(new Option(value["name"], value["id"]));
		});
	}
	else if(type=='cgi_Retrieve_Directories')
	{
		console.log("retrieve dir");
		var directories = response['Directory'];
		$('#Directories').empty();
		//console.log("Directories : ", directories);
		var result = '<ul class="directory-list">';
		if(response['status']=='success')
		{
			result += dirsToCheckbox('',directories);
			result += '</ul>';
			$('#Directories').append(result);
			$('#selectDirectories').modal('show');
			updateCheckbox();
		}
		else
		{
			//notify(response.description,response.description,response.status);
			prevVolId = 0;	
			window.parent.notify(response.description,response.description,response.status);
			updateCheckbox();
			updateFolderIcon();
		}
	}
	else if(type=='cgi_Retrieve_DirectoriesEdit')
	{
		console.log("retrieve dir edit");
		var directories = response['Directory'];
		$('#Directories').empty();
		//console.log("Directories : ", directories);
		var result = '<ul class="directory-list">';
		if(response['status']=='success')
		{
			var result = '<ul class="directory-list">';
			if(response['status']=='success')
			{	if(directories) {
					result += dirsToCheckbox('',directories);
					result += '</ul>';
					$('#Directories').append(result);
					updateCheckbox();
					dirs.forEach(function(item, index){
						$('input[value="'+item+'"]').click();
					});
					updateFolderIcon();
				}
			}
		}
		else
		{
			prevVolId = 0;
			//notify(response.description,response.description,response.status);	
			window.parent.notify(response.description,response.description,response.status);
			updateCheckbox();
			updateFolderIcon();
		}
	}
	
}
function trimString(valueString)
{		
		if(valueString==null)
			valueString = "N/A";
		var len=valueString.trim().length;
		var newValueString = valueString;
		if(len>12)
		{
			newValueString = valueString.substr(0,12)+'...';
		}
		return newValueString;
}
function updateVolumeList()
{
	var data = new Array;
	var logTable=null;
	var headers=[];
	var response = responseVolumeList;
	console.log(responseVolumeList);
	$.each(response, function (index, value) {
		console.log(value["hostId"], parseInt($('#ddlBackup').val()), value["backup_device"], $('#ddlAction').val()==10)
		if($('#ddlAction').val()==10 && !(value["backup_device"]=="false" && $('#ddlFrequency option:selected').text() == 'At Canister Insert'))
		{
			var tempArray = new Array;
			//tempArray.push('<input type="radio" name="rdVolume" class="clsSelect" id="rdVolume_'+value["id"]+'" value='+value["id"]+' />');
			tempArray.push('<span title="' + value["name"]+ '">' +  trimString(value["name"]) + '</span>');
			tempArray.push(value["type"]);
			tempArray.push(value["createdDate"]);
			tempArray.push(GetStatusNameById(value["state"])); 
			if(value["backup_device"]=="false") {                        
					tempArray.push('<input style="margin-right:10px" type="checkbox" name="rdVolume" class="clsSelect" id="rdVolume_'+value["id"]+'" value='+value["id"]+' /><label for="rdVolume_'+value["id"]+'" style="all: revert;"><span title="' + value["name"]+ '">' +  trimString(value["name"]) + '</span></label><a onclick="openSelectDirectoryPopUp();" title="Selected Directories">'+folderSVG+'</a>');
					tempArray.push('');
			}
			else{
				tempArray.push('');
				tempArray.push('<input style="margin-right:10px" type="checkbox" name="rdDestVolume" class="clsSelect" id="rdDestVolume_'+value["id"]+'" value='+value["id"]+' /><span title="' + value["name"]+ '">' +   trimString(value["name"]) + '</span>'); 		
			}
			data.push(tempArray);
		}
		else if(((value["hostId"]==$('#ddlBackup').val() || $('#ddlBackup').val()=='a4') || value["backup_device"]=="false") && !(value["backup_device"]=="false" && $('#ddlFrequency option:selected').text() == 'At Canister Insert'))
		{
			var tempArray = new Array;
			//tempArray.push('<input type="radio" name="rdVolume" class="clsSelect" id="rdVolume_'+value["id"]+'" value='+value["id"]+' />');
			tempArray.push('<span title="' + value["name"]+ '">' +  trimString(value["name"]) + '</span>');
			tempArray.push(value["type"]);
			tempArray.push(value["createdDate"]);
			tempArray.push(GetStatusNameById(value["state"])); 
			if(value["backup_device"]=="false") {                        
					tempArray.push('<input style="margin-right:10px" type="checkbox" name="rdVolume" class="clsSelect" id="rdVolume_'+value["id"]+'" value='+value["id"]+' /><label for="rdVolume_'+value["id"]+'" style="all: revert;"><span title="' + value["name"]+ '">' +  trimString(value["name"]) + '</span></label><a onclick="openSelectDirectoryPopUp();" title="Selected Directories">'+folderSVG+'</a>');
					tempArray.push('');
			}
			else{
				tempArray.push('');
				tempArray.push('<input style="margin-right:10px" type="checkbox" name="rdDestVolume" class="clsSelect" id="rdDestVolume_'+value["id"]+'" value='+value["id"]+' /><span title="' + value["name"]+ '">' +   trimString(value["name"]) + '</span>'); 		
			}
			data.push(tempArray);
		}
	});

	//headers
	headers=[
		//{"title":"Select Vol"},
		{"title":"Name"},
		{"title":"Type"},
		{"title":"Created Date"},
		{"title":"Status"},			 
		{"title":"Source Vol"},
		{"title":"Destination Vol"},
	];

	logTable=$('#tblVolumeList').DataTable( {	
		destroy:true,	
		scrollX:false,				
		data: data,
		columns: headers,
		"bAutoWidth": false,
		columnDefs: [
			//{ width: 50, targets: 0,orderable: false },
			{ width: 100, targets: 0 },
			{ width: 60, targets: 1 },
			{ width: 100, targets: 2 },
			{ width: 60, targets: 3 },
			{ width: 120, targets: 4 },
			{ width: 120, targets: 5 }
		]
	});	
	
	// $("#divVolumeList").hide();
	// $('#tblVolumeList a').css('pointer-events','none');
	// $('#tblVolumeList a').children('svg').css('filter','grayscale(100%)');

	$(".class-span-trim").each(function(i){
	var len=$(this).text().trim().length;
	if(len>25)
	{
		$(this).text($(this).text().substr(0,25)+'...');
	}
	});
	var schedule = editScheduleData;
	$('#rdVolume_'+schedule.source_vol_id).attr('checked',true);
	$('#rdDestVolume_'+schedule.dest_vol_id).attr('checked',true);
}
function GetScheduleEditData()
{
	if(location.hash.substr(1) > 0)
	{
		scheduleId=location.hash.substr(1)
	}
	var request = new Request();
    request.url = "cgi/cgi_Scheduler_Manager.py";
	request.parameters={'requestType':'read_schedule','scheduleId':scheduleId}
    request.Type = "EditSchedule";
	if (scheduleId > 0)
	{
		$('#aActionButton').html('Confirm');
		CallPythonService(request);
	}
}
function BindVMTableData(){
	var request = new Request();
        request.url = "cgi/cgi_myserver_getAllVM.py";
        request.Type = "ALLVM";
        CallPythonService(request);
}
function BindVolumeTableData()
{
	var request = new Request();
	request.url ="cgi/cgi_VolumeManager.py"
	request.Type="ALLVolumes";
	request.parameters={"requestType":'read_Volume','volumeId':0};
	CallPythonService(request);
}

function BindAllHosts()
{
	var request = new Request();
	request.url ="cgi/cgi_HostManager.py"
	request.Type="getHosts";
	request.parameters={"requestType":'read_Host',"hostId":0};
	CallPythonService(request);
}

function GetStatusNameById(id)
{
	var on_states = [6,8,10,12];
	var off_states = [4,9,11,13];
	if(off_states.includes(id))
		return 'Off';
	else if(id==5)
		return 'O';
	else if(on_states.includes(id))
		return 'Running';
	else if(id == 7)
		return 'Suspended';
}
$('#ddlFrequency').change(function(){
	if($('#ddlFrequency option:selected').text() == 'Once Only'){
		$('#txtStartDate').val('');
		$('#txtEndDate').val('');
		$('#txtEndDate').attr('disabled','disabled');
		$("#ddlAction option[value=1]").show();
		$("#ddlAction option[value=5]").show();
		$("#ddlAction option[value=6]").show()
	}
	else if($('#ddlFrequency option:selected').text() == 'At Canister Insert'){
		$('#txtStartTime').val('');
		$('#txtStartTime').attr('disabled','disabled');
		$('#txtStartDate').val('');
		$('#txtStartDate').attr('disabled','disabled');
		$('#txtEndDate').val('');
		$('#txtEndDate').attr('disabled','disabled');
		$("#ddlAction option[value=1]").hide();
		$("#ddlAction option[value=5]").hide();
		$("#ddlAction option[value=6]").hide();
		

	}
	else{
		$('#txtStartTime').attr('disabled',false);
		$('#txtEndDate').attr('disabled',false);
		$('#txtStartDate').attr('disabled',false);
		$("#ddlAction option[value=1]").show();
		$("#ddlAction option[value=5]").show();
		$("#ddlAction option[value=6]").show()
	}
	makeDestinationServerDefault();
	updateActionList();
});
$('#txtStartDate').change(function(){
	if($('#ddlFrequency option:selected').text() == 'Once Only'){
		$('#txtEndDate').val($(this).val());
	}
});
function SaveSchedule()
{
	
	var startDate =new Date(ConvertDateFormat($('#txtStartDate').val())+'T'+$('#txtStartTime').val()+':00');
	var endDate =new Date(ConvertDateFormat($('#txtEndDate').val())+'T'+$('#txtStartTime').val()+':00');
	
	var isFormValid = $("#formSchedule").validationEngine('validate');
	if(isFormValid){
		var vmids = "";
		var selectedVolume = '';
		
		vmids = $("input[name='rdServer']:checked").val();
		
		var ddlAction=$('#ddlAction').val();
		if(ddlAction == 2 || ddlAction == 3 || ddlAction == 4) //2,3,4,8
		{
			if(vmids == '')
			{	
				alert('Select atleast one server')
				return false;
			}
			else if(vmids.length > 0)
				vmids=vmids.slice(0, -1);
		}
		else
		{
			vmids='';
		}
		
		selectedVolume = $("input[name='rdVolume']:checked").val();
		var selectedDestVol=$("input[name='rdDestVolume']:checked").val();
		var actions = [8,9,10,11,12] 
		if(actions.includes(parseInt(ddlAction)))
		{
			if((selectedVolume == '' || selectedVolume == undefined) && $('#ddlFrequency option:selected').text() != 'At Canister Insert') {
				alert('Select atleast one Source Volume');return false;
			}

			selectedDestVol=$("input[name='rdDestVolume']:checked").val();

			if(selectedDestVol=='' || selectedDestVol == undefined){
				alert('Select atleast one Destination Volume');
				return false;
			}
		}
		
		//console.log("length "+$('input[name="directories"]:checked').length)
		if(($('input[name="directories"]:checked').length <= 0 && (ddlAction == 15 || ddlAction == 16))  && $('#ddlFrequency option:selected').text() != 'At Canister Insert') 
		{
			alert('Select atleast one Source Destination');
			return false;
		}
		else
		{
			var checkedChild = []
			var sourceDirectories= '';
			$("input[name='directories']:checked").each(function(index){
				$(this).parent().each(function(index1){
					$(this).children('ul').find($("input[name='directories']:checked")).each(function(index2){
						checkedChild.push($(this).val());
					})
				});
			});
			$.each($('input[name="directories"]:checked'), function( index, value ) {
				if(!checkedChild.includes(value.getAttribute('value')))
					sourceDirectories = sourceDirectories + value.getAttribute('value') + ",,";
					//console.log( index + ": " + value.getAttribute('value'));
			});
		}
		var requestType='save_schedule';
		if(scheduleId > 0)
			requestType='update_schedule'
		
	var txtScheduleName=$('#txtScheduleName').val();
	var ddlFrequency=$('#ddlFrequency option:selected').text();
	var txtStartTime=GetUTCTime(startDate);
	var txtStartDate=GetUTCDate(startDate);
	var txtEndDate=GetUTCDate(endDate);
	
	var ddlBackup=$("#ddlBackup option:selected").text();
	if(ddlBackup == '--Select--')
		ddlBackup=""

	
		var request = new Request();
		request.url = 'cgi/cgi_Scheduler_Manager.py';
		request.Type = 'cgi_Schedule_save';
		request.parameters = { 'requestType':requestType,'scheduleName':txtScheduleName,'frequency': ddlFrequency,'startTime': txtStartTime,'startDate': txtStartDate,'action':$('#ddlAction option:selected').text(),'endDate': txtEndDate,'backup':ddlBackup,'VMIds':vmids,"volId":selectedVolume,"volDestId":selectedDestVol,'scheduleId':scheduleId,'sourceDirectories':sourceDirectories};
		CallPythonService(request);			
	}
}
function GetUTCDate(localDate)
{
	var year=localDate.getUTCFullYear() <10 ?('0'+localDate.getUTCFullYear()):localDate.getUTCFullYear();
	var month=localDate.getUTCMonth() <10 ?('0'+localDate.getUTCMonth()):localDate.getUTCMonth();
	var date=localDate.getUTCDate() <10 ?('0'+localDate.getUTCDate()):localDate.getUTCDate();
	month=(parseInt(month)+1) <10 ? '0'+(parseInt(month)+1):(parseInt(month)+1);
	return year+'-'+ month+'-'+date;
}
function GetUTCTime(localDate)
{
	//localDate=localDate.addHours(localDate.getTimezoneOffset());
	return (localDate.getUTCHours()<10 ? ('0'+localDate.getUTCHours()):(localDate.getUTCHours())) +':'+ (localDate.getUTCMinutes()<10 ? ('0'+localDate.getUTCMinutes()):localDate.getUTCMinutes());
}
function ConvertDateFormat(mmddYYYY)
{
	var lst=mmddYYYY.split('/');
	return lst[2]+"-"+lst[0]+"-"+lst[1];
}
function ConvertDateFormat3(yyyymmdd)
{
	var lst=yyyymmdd.split('-');
	return lst[1]+"/"+lst[2]+"/"+lst[0];
}
function ConvertToLocalDate(UTCDate,UtcTime)
{
	var utcDate = UTCDate+'T'+UtcTime+':00'; //'2011-06-29T16:52:48.000Z';  // ISO-8601 formatted date returned from server
	var localDate = new Date(utcDate);
	localDate.addHours(localDate.getTimezoneOffset());
	month = parseInt(localDate.getMonth())+1
	return ConvertDateFormat2(localDate.getFullYear()+'-'+ (month<10? ('0'+month):month)+'-'+(localDate.getDate()<10?('0'+localDate.getDate()):localDate.getDate()));
}
function ConvertToLocalTime(UTCDate,UtcTime)
{
	var utcDate = UTCDate+'T'+UtcTime+':00'; //'2011-06-29T16:52:48.000Z';  // ISO-8601 formatted date returned from server
	var localDate = new Date(utcDate);
	localDate.addHours(localDate.getTimezoneOffset())
	return (localDate.getHours()<10?('0'+localDate.getHours()):localDate.getHours())+':'+(localDate.getMinutes()<10?('0'+localDate.getMinutes()):localDate.getMinutes());
}
function ConvertDateFormat2(YYYddmm)
{
	var lst=YYYddmm.split('-');
	return lst[0]+"-"+lst[1]+"-"+lst[2];
}
Date.prototype.addHours = function(h) {    
   this.setTime(this.getTime() - (h*60*1000)); 
   return this;   
}

$('#ddlAction').change(function(){
	makeDestinationServerDefault();
	updateActionList();
});

function makeDestinationServerDefault() {
	$('#ddlBackup').val('');
}

function updateActionList()
{
	console.log("ddlAction ",$('#ddlAction').val());
	if($('#ddlAction').val() == 2 || $('#ddlAction').val()==7 || $('#ddlAction').val()==11 || $('#ddlAction').val() == 12 || $('#ddlAction').val() == 13 || $('#ddlAction').val() == 14 || $('#ddlAction').val()==15 || $('#ddlAction').val()==16)
		$('#bckServer').css('display','block');
	else{
		$('#ddlBackup option:first-child').attr("selected", "selected");
		$('#bckServer').css('display','none');	
		$("#bckServer").val("--Select--");		
	}

	if(($('#ddlAction').val() == 2 || $('#ddlAction').val()==3 || $('#ddlAction').val()==4) && $("#ddlBackup").val()!="") //2,3,4,8
		$('#divVM').css('display','block');
	else
		$('#divVM').css('display','none');
	
	if($("#ddlBackup").val()=="")
		$('#divVM').css('display','none');
	else 
		$('#divVM').css('display','block');

	if($('#ddlAction').val()==10)
		updateVolumeList();

	if($('#ddlAction').val() == 8 || $('#ddlAction').val()==9 || $('#ddlAction').val()==10)
	{
		if(scheduleId!==0) {
			updateVolumeList();
		}
		$('#divVolumeList').css('display','block');
	}
	else if(($('#ddlAction').val() == 10 || $('#ddlAction').val() == 11 || $('#ddlAction').val()==12 || $('#ddlAction').val()==15 || $('#ddlAction').val()== 16) && $("#ddlBackup").val()!="")
	{
		if(scheduleId!==0)
			updateVolumeList();
		$('#divVolumeList').css('display','block');
	}
	else
		$('#divVolumeList').css('display','none');
}
$('#ddlBackup').change(function(){
	updateBackupList();
});
function updateBackupList()
{
	var actionVal=$("#ddlAction").val();
	if(( actionVal== 2 || actionVal==3 || actionVal==4) && $('#ddlBackup').val()!="")
	{
		//if(scheduleId!==0)
			updateVolumeList();
		$('#divVM').css('display','block');
	}
	else if((actionVal=10 || actionVal == 11 || actionVal==12 || actionVal==15 || actionVal==16) && $('#ddlBackup').val()!="")
	{

		//if(scheduleId!==0)
			updateVolumeList();
		$('#divVolumeList').css('display','block');
	}
	else{
		$('#divVolumeList').css('display','none');
		$('#divVM').css('display','none');
	}
}
$(function(){
Date.prototype.mmddyyyy = function() {
  var yyyy = this.getFullYear().toString();
  var mm = (this.getMonth()+1).toString(); // getMonth() is zero-based
  var dd  = this.getDate().toString();
  return  (mm[1]?mm:"0"+mm[0]) + "/" + (dd[1]?dd:"0"+dd[0])+ "/"+yyyy; // padding
};
var date = new Date();
$('#txtStartDate').focus(function (){
	if($(this).val() ==''){
		$(this).val(date.mmddyyyy());
		$('#txtEndDate').val(date.mmddyyyy());
	}
});
$('#txtEndDate').focus(function (){
	if($(this).val() =='')
		$(this).val(date.mmddyyyy());
});
});


$(document).on('click', "input[name='rdDestVolume']", function(){
	var flag;
	if($(this).is(":checked"))
		flag = 0;
	else
		flag = 1;
	$("input[name='rdDestVolume']").prop("checked",false);
	if(flag==1)
		$(this).prop("checked",false);
	else
		$(this).prop("checked",true);
});

$(document).on('click', "input[name='rdVolume']", function(){
	var flag;
	if($(this).is(":checked"))
		flag = 0;
	else
		flag = 1;
	$("input[name='rdVolume']").prop("checked",false);
	if(flag==1)
		$(this).prop("checked",false);
	else
		$(this).prop("checked",true);
	if($("input[name='rdVolume']:checked").length == 0)
	{
		$("input[name='rdVolume']").siblings('a').css('pointer-events','none');
		$("input[name='rdVolume']").siblings('a').children('svg').css('filter','grayscale(100%)');
	}

	//For directories
	openSelectDirectoryPopUp();
	
});
//to keep track of previous vol id selected for selecting directories
var prevVolId= 0;
function openSelectDirectoryPopUp()
{
	if($("input[name='rdVolume']:checked").length > 0) //Show pop-up only during checking, not while unchecking
	{
		var selectedVolume = $("input[name='rdVolume']:checked").val();
		if(selectedVolume!=prevVolId)
		{
			prevVolId = selectedVolume;
			var request = new Request();
			request.url = 'cgi/cgi_Scheduler_Manager.py';
			request.Type = 'cgi_Retrieve_Directories';
			request.parameters = {'requestType':'read_Directories',"volId":selectedVolume};
			CallPythonService(request);
		}
		else{ //if it is the previously selected volID, theres no need to update the directory list
			$('#selectDirectories').modal('show');
		}
	}	
	/*console.log("Selected directories : ");
	$.each($('input[name="directories"]:checked'), function( index, value ) {
		console.log( index + ": " + value.getAttribute('value'));
	});*/
}
function updateCheckbox() 
{
	var allFolders = $(".directory-list li > ul");
		allFolders.each(function() {

		// add the folder class to the parent <li>
		var folderAndName = $(this).parent();
		folderAndName.addClass("folder");

		// backup this inner <ul>
		var backupOfThisFolder = $(this);
		// then delete it
		$(this).remove();
		// add an <a> tag to whats left ie. the folder name
		folderAndName.children('label').wrapInner("<a href='#' />");
		// then put the inner <ul> back
		folderAndName.append(backupOfThisFolder);

		// now add a slideToggle to the <a> we just added
		folderAndName.children('label').find("a").click(function(e) {
			$(this).parent().siblings("ul").slideToggle(300);
			e.preventDefault();
		});

	});

	//Click on parent folder to retract all
	$(".directory-list li > label > a").click();

	//For checkbox tree to select source directories
	//https://css-tricks.com/indeterminate-checkboxes/
	$('input[name="directories"]').change(function(e) {

		var checked = $(this).prop("checked"),
			container = $(this).parent(),
			siblings = container.siblings();
	
		container.find('input[name="directories"]').prop({
		indeterminate: false,
		checked: checked
		});
	
		function checkSiblings(el) {
	
		var parent = el.parent().parent(),
			all = true;
	
		el.siblings().each(function() {
			let returnValue = all = ($(this).children('input[name="directories"]').prop("checked") === checked);
			return returnValue;
		});
		
		if (all && checked) {
	
			parent.children('input[name="directories"]').prop({
			indeterminate: false,
			checked: checked
			});
	
			checkSiblings(parent);
	
		} else if (all && !checked) {
	
			parent.children('input[name="directories"]').prop("checked", checked);
			parent.children('input[name="directories"]').prop("indeterminate", (parent.find('input[name="directories"]:checked').length > 0));
			checkSiblings(parent);
	
		} else {
	
			el.parents("li").children('input[name="directories"]').prop({
			indeterminate: true,
			checked: false
			});
	
		}
	
		}
		checkSiblings(container);
	});
}
$('#selectDirectories').on('hidden.bs.modal', updateFolderIcon);
function updateFolderIcon()
{
	$("input[name='rdVolume']").siblings('a').css('pointer-events','none');
	$("input[name='rdVolume']").siblings('a').children('svg').css('filter','grayscale(100%)');
	if($('input[name="directories"]:checked').length > 0)
	{
		$("input[name='rdVolume']:checked").siblings('a').css('pointer-events','');
		$("input[name='rdVolume']:checked").siblings('a').children('svg').css('filter','none');
		
		var checkedChild = [];
		$("input[name='directories']:checked").each(function(index){
			$(this).parent().each(function(index1){
				$(this).children('ul').find($("input[name='directories']:checked")).each(function(index2){
					checkedChild.push($(this).val());
				})
			});
		});

		var sourceDirectories= 'Selected Directories: \n\n';
		$.each($('input[name="directories"]:checked'), function( index, value ) {
			if(!checkedChild.includes(value.getAttribute('value')))
				if(value.getAttribute('value') != '')
					sourceDirectories = sourceDirectories + value.getAttribute('value') + " \n";
				else{
					var rootText = $(value).siblings('label').children('a').text().trim();
					sourceDirectories = sourceDirectories + rootText + " \n";
				}
					
			//console.log( index + ": " + value.getAttribute('value'));
		});
		$("input[name='rdVolume']:checked").siblings('a').attr("title", sourceDirectories);
	}
	else
	{
		$("input[name='rdVolume']:checked").siblings('a').attr("title", 'None');
		$('input[name="rdVolume"]:checked').prop('checked', false);
	}
}
function dirsToCheckbox(root,dirs)
{
	//console.log("DIR : ", dirs);
	var result = '';
	result+= `
		<li>
			<input type="checkbox" name="directories" id='`+root+`' value='`+root+`' >
			<label for="tall">`+folderSVG+dirs['name']+`</label>
	<ul>`;
	console.log(root, dirs);
	if(dirs['children'].length == 0 || dirs['children'][0] == null)
	{
		//result+= `<label for="tall" style="opacity: 0.6; font-size: small; pointer-events: none;">-- No sub dir's --</label>`;
                var i=0
	}
	dirs['children'].forEach(function(item, index){
		if(item!=null) {
			var subRoot = root + '/' + item['name'];
			result+=dirsToCheckbox(subRoot,item);
		}
	
	});
	result+= `</ul></li>`;
	return result;
}