function Request() {
    var request = {
        url: "",
        parameters: {},
        Type: ""
    };
    return request;
}
$(function () {
    BindAllNetworks();
});
function CallPythonService(request) {
	request.parameters.uuid=parent.uuid;
    $.ajax({
        type: "Get",
        url: request.url,
        contentType: 'application/json',
        dataType: 'json',
        headers: { 'Access-Control-Allow-Origin': '*' },
        data: request.parameters,
        success: function (response) {
            BindResponseData(request.Type, response);
        },
        error: function (ex) {
            if(!isProduction){
				console.log(ex);
			}
        }
    });
}
function BindResponseData(Type, response) {
    if (Type === 'BindAllNetworks') {
        $('#ddlNetworks option').remove();
        $('#ddlNetworks').append(new Option('-- Select --', 0));
        $.each(response, function (i, item) {
            $('#ddlNetworks').append(new Option(item.name, item.id));
        });
    }
    else if (Type === 'SelectedNetwork') {
        $('#txtCidr').val(response.cidr);
        response.enable_dhcp.toLowerCase() === 'yes' ? $('#rdbYes').prop('checked', true) : $('#rdbNo').prop('checked', true);
    }
    else if (Type === 'UpdateNetwork') {
        if (response.status === 'fail') {
            $('#divResponseDng').html(response.Description);

            $('#divPopUpDanger').modal('show');
        }
        else {
            $('#divResponseDng').html(response.Description);
            $('#divPopUpSuccess').modal('show');
        }
    }
    else if (Type === 'DeleteNetwork') {
        window.parent.notify(response.description,response.description,response.status);
		window.parent.GetAllDataBySelectedSection('Network'); 
		location.reload();
    }
}
$('#ddlNetworks').change(function () {
    $('#txtNetwork').val($("#ddlNetworks option:selected").text())
    var networkId = $(this).val();

    var request = new Request();
    request.url = "cgi/cgi_Network.py";
    request.parameters = { "requestType":"read_NetworkById", "ntw_Id": networkId  };
    request.Type = "SelectedNetwork";
    CallPythonService(request);
});
function BindAllNetworks() {
    var request = new Request();
    request.url = "cgi/cgi_Network.py";
    request.parameters = { "requestType":"read_Networks" };
    request.Type = "BindAllNetworks";
    CallPythonService(request);
}

function DeleteNetwork() {

    var networkId = $('#ddlNetworks').val();
    var request = new Request();
    request.url = "cgi/cgi_Network.py";
    request.parameters = { "requestType":"delete_Network","ntw_Id": networkId };
    request.Type = "DeleteNetwork";
    CallPythonService(request);
}
function ConfirmPopUp(ConfirmType) {
    var networkId = $('#ddlNetworks').val();
    if (networkId > 0) {
        var showConfirm = true;
        if (ConfirmType === 'DeleteNetwork') {
            $('#divConfirmMessage').html("Do you want Delete??");
            $('#divCallBackFn').attr('onclick', "DeleteNetwork()");
            //$('#divNoCallBackFn').attr('onclick', "ResizeNoCallBackFn()");
        }

        if (showConfirm)
            $("#popConfirm").modal('show');
    } else {
        $('#divResponseDng').html('Please Select Network to Delete');
        $('#divPopUpDanger').modal('show');
    }
}


