function Request() {
    var request = {
        url: "",
        parameters: {},
        Type: ""
    };
    return request;
}
$(window).bind("load", function() { 
    BindAllNetworks();
});
function CallPythonService(request) {
	request.parameters.uuid=parent.uuid;
    $.ajax({
        type: "Get",
        url: request.url,
        contentType: 'application/json',
        dataType: 'json',
        headers: { 'Access-Control-Allow-Origin': '*' },
        data: request.parameters,
        success: function (response) {
            BindResponseData(request.Type, response);
        },
        error: function (ex) {
            if(!isProduction){
				console.log(ex);
			}
        }
    });
}
function BindResponseData(Type, response) {
    if (Type === 'BindAllNetworks') {
        $('#ddlNetworks option').remove();
        $('#ddlNetworks').append(new Option('-- Select --', 0));
        $.each(response, function (i, item) {
            $('#ddlNetworks').append(new Option(item.name, item.id));
        });
    }
    else if(Type==='SelectedNetwork')
    {        
        $('#txtCidr').val(response.cidr);
        response.enable_dhcp.toLowerCase() === 'yes' ? $('#rdbYes').prop('checked', true) : $('#rdbNo').prop('checked', true);
    }
    else if(Type==='UpdateNetwork')
    {
        window.parent.notify(response.description,response.description,response.status);
		window.parent.GetAllDataBySelectedSection('Network'); 
    }
}
function BindAllNetworks()
{
    var request = new Request();
    request.url = "cgi/cgi_Network.py";
    request.parameters = { "requestType":"read_Networks"};
    request.Type = "BindAllNetworks";
    CallPythonService(request);
}
$('#ddlNetworks').change(function () {
    $('#txtNetwork').val($("#ddlNetworks option:selected").text())
    var networkId = $(this).val();

    var request = new Request();
    request.url = "cgi/cgi_Network.py";
    request.parameters = { "requestType":"read_NetworkById", "ntw_Id": networkId };
    request.Type = "SelectedNetwork";
    CallPythonService(request);
});

$('#txtNetwork').change(function () {
    if($(this).val() == '' || $(this).val()== undefined)
    {
        $(this).val($("#ddlNetworks option:selected").text());
    }
});
function UpdateNetworkDetails() {
    var isFormValid = $("#EditNetwork").validationEngine('validate');
    if (isFormValid) {
        var networkId = $('#ddlNetworks').val();
        var request = new Request();
        request.url = "cgi/cgi_Network.py";
        request.parameters = { "requestType":"update_Network","ntw_Id": networkId, "ntw_Name": $('#txtNetwork').val(), "cidr_Addr": $('#txtCidr').val(), "dhcp": $("input[type='radio']:checked").val() };
        request.Type = "UpdateNetwork";
        CallPythonService(request);
    }
}
function ConfirmPopUp(ConfirmType) {
    var networkId = $('#ddlNetworks').val();
    if (networkId > 0) {
        var showConfirm = true;
        if (ConfirmType === 'UpdateNetwork') {
            $('#divConfirmMessage').html("Do you want Update??");
            $('#divCallBackFn').attr('onclick', "UpdateNetworkDetails()");
            $('#divNoCallBackFn').attr('onclick', "CallBackFunction('no')");
        }

        if (showConfirm)
            $("#popConfirm").modal('show');
    } else {
        $('#divResponseDng').html('Please Select Network to Delete');
        $('#divPopUpDanger').modal('show');
    }
}
function CallBackFunction(type)
{
    $('#ddlNetworks').trigger('change');
}


