// "1"	"CIFS"
// "2"	"NFS"
// "3"	"iSCSI-Chap"
// "4"	"iSCSI-NoChap"
// "5"	"FTP"
// "6"	"FC"
// "7"	"S3 Object Storage"
// "8"	"iSER-Chap"
// "9"	"iSER-NoChap"
var eyeOpenSVG = `<svg style="width: 1.2vw;" id="Layer_1" data-name="Layer 1" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 512 512">
					<title>Click to show password!</title>
					<path
						d="M320,256a64,64,0,1,1-64-64A64.07,64.07,0,0,1,320,256Zm189.81,9.42C460.86,364.89,363.6,426.67,256,426.67S51.14,364.89,2.19,265.42a21.33,21.33,0,0,1,0-18.83C51.14,147.11,148.4,85.33,256,85.33s204.86,61.78,253.81,161.25A21.33,21.33,0,0,1,509.81,265.42ZM362.67,256A106.67,106.67,0,1,0,256,362.67,106.79,106.79,0,0,0,362.67,256Z" />
					</svg>`;
var eyeClosedSVG = `<svg style="width: 1.2vw;" id="Layer_1" data-name="Layer 1" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 512 512">
<title>Click to hide password!</title>
<path
	d="M409.84,132.33l95.91-95.91A21.33,21.33,0,1,0,475.58,6.25L6.25,475.58a21.33,21.33,0,1,0,30.17,30.17L140.77,401.4A275.84,275.84,0,0,0,256,426.67c107.6,0,204.85-61.78,253.81-161.25a21.33,21.33,0,0,0,0-18.83A291,291,0,0,0,409.84,132.33ZM256,362.67a105.78,105.78,0,0,1-58.7-17.8l31.21-31.21A63.29,63.29,0,0,0,256,320a64.07,64.07,0,0,0,64-64,63.28,63.28,0,0,0-6.34-27.49l31.21-31.21A106.45,106.45,0,0,1,256,362.67ZM2.19,265.42a21.33,21.33,0,0,1,0-18.83C51.15,147.11,148.4,85.33,256,85.33a277,277,0,0,1,70.4,9.22l-55.88,55.88A105.9,105.9,0,0,0,150.44,270.52L67.88,353.08A295.2,295.2,0,0,1,2.19,265.42Z" />
</svg>`;
function HostGrayedOutRules(){
	var hostGrayedOutRules =[{'protocol':1,'rules': [
                                        {'type':'0','user':1,'password':1,'iqn':1,'wwn':1,'url':1} ,
                                        {'type':'Single Host','user':1,'password':1,'iqn':0,'wwn':0,'url':0},
                                        {'type':'Group Host','user':0,'password':0,'iqn':0,'wwn':0,'url':0},
                                        {'type':'Storage Manager','user':1,'password':1,'iqn':1,'wwn':0,'url':0},
                                        {'type':'Download Server','user':1,'password':1,'iqn':0,'wwn':0,'url':0},
                                        {'type':'Backup Server','user':1,'password':1,'iqn':1,'wwn':0,'url':0}
                                    ]
                             },
							 {'protocol':2,'rules':[
                                {'type':'0','user':1,'password':1,'iqn':1,'wwn':1,'url':1},
                                {'type':'Single Host','user':0,'password':0,'iqn':1,'wwn':0,'url':0},
                                 {'type':'Group Host','user':0,'password':0,'iqn':1,'wwn':0,'url':0},
                                 {'type':'Storage Manager','user':0,'password':0,'iqn':1,'wwn':0,'url':0},
                                 {'type':'Download Server','user':0,'password':0,'iqn':1,'wwn':0,'url':0},
                                 {'type':'Backup Server','user':0,'password':0,'iqn':1,'wwn':0,'url':0}
                                                ]
                                            },
							 {'protocol':3,'rules':[
                                {'type':'0','user':1,'password':1,'iqn':1,'wwn':1,'url':1},
                                {'type':'Single Host','user':1,'password':1,'iqn':1,'wwn':0,'url':0},
                                 {'type':'Group Host','user':0,'password':0,'iqn':1,'wwn':0,'url':0},
                                 {'type':'Storage Manager','user':1,'password':1,'iqn':1,'wwn':0,'url':0},
                                 {'type':'Download Server','user':1,'password':1,'iqn':1,'wwn':0,'url':0},
                                 {'type':'Backup Server','user':1,'password':1,'iqn':1,'wwn':0,'url':0}
                                ]
                            },
							 {'protocol':4,'rules':[
                                {'type':'0','user':1,'password':1,'iqn':1,'wwn':1,'url':1},
                                {'type':'Single Host','user':0,'password':0,'iqn':1,'wwn':0,'url':0},
                                 {'type':'Group Host','user':0,'password':0,'iqn':1,'wwn':0,'url':0},
                                 {'type':'Storage Manager','user':0,'password':0,'iqn':1,'wwn':0,'url':0},
                                 {'type':'Download Server','user':0,'password':0,'iqn':1,'wwn':0,'url':0},
                                 {'type':'Backup Server','user':0,'password':0,'iqn':1,'wwn':0,'url':0}
                            ]
                        },
							 {'protocol':5,'rules':[
                                {'type':'0','user':1,'password':1,'iqn':1,'wwn':1,'url':1},
                                {'type':'Single Host','user':1,'password':1,'iqn':0,'wwn':0,'url':0},
                                 {'type':'Group Host','user':1,'password':1,'iqn':0,'wwn':0,'url':0},
                                 {'type':'Storage Manager','user':1,'password':1,'iqn':0,'wwn':0,'url':0},
                                 {'type':'Download Server','user':1,'password':1,'iqn':0,'wwn':0,'url':0},
                                 {'type':'Backup Server','user':1,'password':1,'iqn':0,'wwn':0,'url':0}
                                        ]
                                    },
							 {'protocol':6,'rules':[
                                {'type':'0','user':1,'password':1,'iqn':1,'wwn':1,'url':1},
                                {'type':'Single Host','user':0,'password':0,'iqn':0,'wwn':1,'url':0},
                                 {'type':'Group Host','user':0,'password':0,'iqn':0,'wwn':1,'url':0},
                                 {'type':'Storage Manager','user':0,'password':0,'iqn':0,'wwn':1,'url':0},
                                 {'type':'Download Server','user':0,'password':0,'iqn':0,'wwn':1,'url':0},
                                 {'type':'Backup Server','user':0,'password':0,'iqn':0,'wwn':1,'url':0}
                                        ]
                                    },
							 {'protocol':7,'rules':[
                                {'type':'0','user':1,'password':1,'iqn':1,'wwn':1,'url':1},
                                {'type':'Single Host','user':1,'password':1,'iqn':0,'wwn':0,'url':1},
                                 {'type':'Group Host','user':1,'password':1,'iqn':0,'wwn':0,'url':1},
                                 {'type':'Storage Manager','user':1,'password':1,'iqn':0,'wwn':0,'url':1},
                                 {'type':'Download Server','user':1,'password':1,'iqn':0,'wwn':0,'url':1},
                                 {'type':'Backup Server','user':1,'password':1,'iqn':0,'wwn':0,'url':1}
                                        ]
                                    },
							 {'protocol':8,'rules':[
                                {'type':'0','user':1,'password':1,'iqn':1,'wwn':1,'url':1},
                                {'type':'Single Host','user':1,'password':1,'iqn':1,'wwn':0,'url':0},
                                 {'type':'Group Host','user':0,'password':0,'iqn':1,'wwn':0,'url':0},
                                 {'type':'Storage Manager','user':1,'password':1,'iqn':1,'wwn':0,'url':0},
                                 {'type':'Download Server','user':1,'password':1,'iqn':1,'wwn':0,'url':0},
                                 {'type':'Backup Server','user':1,'password':1,'iqn':1,'wwn':0,'url':0}
                                        ]
                                    },
							 {'protocol':9,'rules':[
                                {'type':'0','user':1,'password':1,'iqn':1,'wwn':1,'url':1},
                                {'type':'Single Host','user':0,'password':0,'iqn':1,'wwn':0,'url':0},
                                 {'type':'Group Host','user':0,'password':0,'iqn':1,'wwn':0,'url':0},
                                 {'type':'Storage Manager','user':0,'password':0,'iqn':1,'wwn':0,'url':0},
                                 {'type':'Download Server','user':0,'password':0,'iqn':1,'wwn':0,'url':0},
                                 {'type':'Backup Server','user':0,'password':0,'iqn':1,'wwn':0,'url':0}
                                        ]
                                    },
							 {'protocol':999,'rules':[
                                 {'type':'0','user':1,'password':1,'iqn':1,'wwn':1,'url':1},
                                 {'type':'Single Host','user':1,'password':1,'iqn':1,'wwn':1,'url':1},
                                 {'type':'Group Host','user':1,'password':1,'iqn':1,'wwn':1,'url':1},
                                 {'type':'Storage Manager','user':1,'password':1,'iqn':1,'wwn':1,'url':1},
                                 {'type':'Download Server','user':1,'password':1,'iqn':1,'wwn':1,'url':1},
                                 {'type':'Backup Server','user':1,'password':1,'iqn':1,'wwn':1,'url':1}
                                ]
                            } // this rule for org group
							];
	return hostGrayedOutRules;
}
var selectedProtocol = 0;
var hostActionPage = '';
var selectedHost = 0
function Request() {
    var request = {
        url: "",
        parameters: {},
        statusType: "",
		typeNumber: "",
		isSingleStatus:false
    };
    
    return request;
}
$(window).bind("load", function() {
    BindAllHosts();
	if(location.hash.substr(1) !="")
		$('#divBackButton').show();
	else
		$('#divBackButton').hide();
});
function CallPythonService(request) {
	request.parameters.uuid=uuid;
    $.ajax({
        type: "Get",
        url: request.url,
        contentType: 'application/json',
        dataType: 'json',
        headers: { 'Access-Control-Allow-Origin': '*' },
        data: request.parameters,
        success: function (response) {			
				BindResponseData(request.statusType,response);
        },
        error: function (ex) {
            if(!isProduction){
				console.log(ex);
			}
        }
    });
}
function BindResponseData(statusType, response) {
	
    if(statusType=='SaveHost')
	{
		if(response.status !='fail'){
			HostPageNavigate();
			BindAllHosts();
			selectedHost = 0;
			swal("Success", response.description , "success");
		}
		else
		{
			swal("Error", response.description , "error");
		}		
		
	}
	else if(statusType == 'getProtocol')
	{
		$("#ddlHostType option").remove();	
		$('#ddlHostType').append(new Option('-- Select --',''));
		$.each(response, function (i, item) {
            $('#ddlHostType').append(new Option(item.protocolName, item.id));            
        }); 
		//SetUpGrayedOutRules(1);
		return;
	}
	else if(statusType == 'getHosts')
	{
		$("#ddlHostNames option").remove();	
		$('#ddlHostNames').append(new Option('-- Select --', ''));
		
		var table = $('#tblHostServer').DataTable();
		 table.destroy();
		$('#tbodyVolumeManager').html('');
		
		$('#tbodyHostServer').html('');
		$.each(response, function (i, item) {
			let passwordCell = `<td></td>`;
			if(GetString(item.pw).length > 0) {
				if(item.password_hidden) {
				passwordCell = `<td width="13%">
											<div class="hidetext" >`+ trimString(GetString(item.pw)) + 
											`<a onclick="showPassword(this, `+ item.id +`);" title="">`+eyeOpenSVG+`</a></div>
									</td>`;
				}
				else {
					// $(obj).attr('onclick','').css('cursor','not-allowed').css('opacity',0.5);
					passwordCell = `<td width="13%">
											<div class="" >`+ trimString(GetString(item.pw)) + 
											`<a onclick="showPassword(this, `+ item.id +`);" title="">`+eyeClosedSVG+`</a></div>
									</td>`;
				}
					
			}		
			var host = `<tr>
									<td width="3%"><input class="clsHostRecord" name="rdHost" value="`+item.id+`" type="radio"  id="chkHost_`+item.id+`"></td>
                                       <td width="13%">
									   <div title="`+item.name+`">`+ trimString(item.name) + `</div>
                                       </td>
                                       <td width="10%">
                                          `+item.host_type+`
                                       </td>
									   <td width="10%">`+item.protocol_name+`</td>
									   <td width="13%">
											   <div title="`+GetString(item.user_name)+`">`+ trimString(GetString(item.user_name)) + `</div>
										</td>
									   `+passwordCell+`
                                       <td width="10%">
                                          `+GetString(item.iqn)+`
                                       </td>
                                       <td width="10%">
                                          `+GetString(item.wwn)+`
                                       </td>
									   <td width="10%">
									   		<div title="`+GetString(item.url)+`">`+ trimString(GetString(item.url)) + `</div>
                                       </td>
                                    </tr>`
			$('#tbodyHostServer').append(host);			
            $('#ddlHostNames').append(new Option(item.name, item.id));   
			$('.clsHostRecord').bind('change',function(){
				selectedHost = $(this).attr('value');
			});			
			
        }); 
		
			var table = $('#tblHostServer').DataTable();
			 table.destroy();
			$('#tblHostServer').DataTable(GetTableConfig('hostServer'));
			
	}
	else if(statusType == 'getHostsForVolume')
	{
		$("#ddlVolumeHost option").remove();	
		$('#ddlVolumeHost').append(new Option('-- Select --', ''));
		$.each(response, function (i, item) {			
			$('#ddlVolumeHost').append(new Option(item.name, item.id)); 
        }); 
		//$('#ddlVolumeHost').multiselect();
		return;
	}
	else if(statusType == 'getProtocolForVolume')
	{
		$("#ddlVolumeProtocol option").remove();	
		$('#ddlVolumeProtocol').append(new Option('-- Select --', ''));
		$.each(response, function (i, item) {
            $('#ddlVolumeProtocol').append(new Option(item.protocolName, item.id));            
        }); 
		return;
	}
	else if(statusType == 'getStoragePools')
	{
		$("#ddlVolumePool option").remove();	
		$('#ddlVolumePool').append(new Option('-- Select --', ''));
		$.each(response, function (i, item) {
            $('#ddlVolumePool').append(new Option(item.name, item.id));            
        }); 
		return;
	}
	else if(statusType == 'getEthernetPorts')
	{
		$("#ddlvolumePorts option").remove();	
		$('#ddlvolumePorts').append(new Option('-- Select --', ''));
		$.each(response, function (i, item) {
            $('#ddlvolumePorts').append(new Option(item.name, item.id));            
        }); 
		return;
	}
	else if(statusType == 'getHostById')
	{
		var host= response[0];
		$('#ddlHostType').val(host.protocol_id);
		$('#txtHostUser').val(host.user_name);
		$('#txtHostPwd').val(host.pw);
		$('#txtHostIQN').val(host.iqn);
		$('#txtHostWWN').val(host.wwn);
		$('#txtHostUrl').val(host.url);
		$("#ddlUserType").val(host.host_type);
		if(host.name.indexOf('@') == 0){
			$('#ddlGroups').val(host.name);
			$('#divGroups').show();
			$('#divSingleUser').hide();
		}
		else
		{
			$('#txtHostName').val(host.name);
			$('#divGroups').hide();
			$('#divSingleUser').show();
		}
		
		SetUpGrayedOutRules(host.protocol_id);
		return;
	}
	else if(statusType == 'SaveVolume')
	{		
		
		if(response.status !='fail'){
			VolumeMgrPageNavigate('cancel');
			BindVolumeSavedData();
			selectedHost = 0;
			swal("Success", response.description , "success");
		}
		else
		{
			swal("Error", response.description , "error");
		}		
	}
	else if(statusType == 'changeVolumeState')
	{
		BindVolumeSavedData();
		swal("Success", response.description , "success");
	}
	else if(statusType == 'SaveSnapVolume')
	{	
		if(response.status == 'fail')
		{
			swal("Error", response.description , "error");			
		}	
		else{
			BindVolumeSavedData();	
			selectedHost = 0;
			swal("success", response.description , "success");
		}
		
	}
	else if(statusType == 'getVolumeSavedData')
	{
		$("#ddlVolumeNames option").remove();
		$('#ddlVolumeNames').append(new Option('-- Select --', ''));
		
		//$('#ddlVolumeNames').trigger('change');
		
		 var table = $('#tblVolumeManager').DataTable();
		 table.destroy();
		$('#tbodyVolumeManager').html('');
			
		$.each(response, function (i, item) {
			var dedup = item.dedup == 'true' ?'Yes':'No';
			var compression = item.compression == 'true'?'Yes':'No';
			var onClass = item.state == 6 ? 'blinkled':'';
			var offClass = item.state == 4 ? 'blinkled':'';
			var isDisabled = item.type != 'Native'? '':''
			var len=$(this).text().trim().length;
			item.nametxt = item.name;
			if(item.name.length>10)
			{
				item.nametxt = item.name.substr(0,12)+'...';
			}		
			strVolume = `<tr>
												<td width="30px"><input class="clsVolumeRecord" name="rdVolume" value="`+item.id+`" type="radio" volType="`+item.type+`" id="chkVolume_`+item.id+`" `+isDisabled+`></td>
                                                <td><span class="overflow" title="`+item.name+`">`+item.nametxt+`</span></td>
                                                <td>`+item.type+`</td>
                                                <td>`+item.size+`</td>
                                                <td><span class="overflow" title="`+item.poolName+`">`+item.poolName+`</span></td>
                                                <td>`+item.lun+`</td>
                                                <td>`+dedup+`</td>
                                                <td>`+compression+`</td>
                                                <td>`+item.protocolName+`</td>
                                                <td><span class="overflow" title="`+item.hostName+`">`+item.hostName+`</span></td>
                                                <td>`+item.portName+`</td>
                                                <td align="center">
                                                    <span class="linksBlk"> 
                                          <a href="javascript:void(0);" class=" yellowBG">
                                          <img src="images/screen-shot-icon.png" alt="Snap" title="Snap" onclick="SnapShotVolume(`+item.id+`,'`+item.name+`')"></a>
											  <a href="javascript:void(0);" class=" yellowBG">
                                          <img src="images/infoIcon.png" alt="infoIcon" title="Info" onclick="VolumeInfo(`+item.size+`)"></a>  
										  <a href="javascript:void(0);" class="`+onClass+`">
											<img src="images/power-On.png" alt="Start" title="Start" onclick="OnOffVolume(`+item.id+`,`+6+`,'`+item.type+`')">
										  </a>
                                          <a href="javascript:void(0);" class="`+offClass+`">
											<img src="images/power-Off.png" alt="Stop" title="Stop" onclick="OnOffVolume(`+item.id+`,`+4+`,'`+item.type+`')">
										  </a>

                                          </span>
                                                </td>
                                            </tr>`;
			$('#tbodyVolumeManager').append(strVolume);			
			if(item.type == 'Native')
				$('#ddlVolumeNames').append(new Option(item.name, item.id));
		}); 
		 
		 var table = $('#tblVolumeManager').DataTable();
		 table.destroy();
		$('#tblVolumeManager').DataTable();
		
		$('.clsVolumeRecord').on("change",function(){
			selectedHost = $(this).attr('value');
			//alert(selectedVolume);
		});
		return;
	}
	else if(statusType == 'getVolumeById')
	{
		var volume =response[0];
		$('#ddlVolumeNames').val(volume.id);
		$('#txtVolumeSize').val(volume.size);
		$('#ddlVolumeProtocol').val(volume.protocolId);
		$('#ddlVolumePool').val(volume.poolId);
		$('#ddlVolumeHost').val(volume.hostId);
		$('#txtVolumeLUN').val(volume.lun);
		$('#ddlvolumePorts').val(volume.portId);
		$('#chkDedup').prop('checked',volume.dedup =="true"?true:false);// volume.dedup
		$('#chkCompression').prop('checked', volume.compression =="true"?true:false);
		//"size":$('#txtVolumeSize').val(),"protocolId":$('#ddlVolumeProtocol').val(),"poolId":$('#ddlVolumePool').val(),"hostId":$('#ddlVolumeHost').val(),"lun":$('#txtVolumeLUN').val(),"portId":$('#ddlvolumePorts').val()
		return;
	}	
	else if(statusType === 'GetOrgGroups')
	{
		$("#ddlGroups option").remove();
			$('#ddlGroups').append($('<option>', { 
				value: "",
				text : 'Select Group' 
			}));
		$.each(response, function(i, item) {            
            $('#ddlGroups').append($('<option>', { 
				value: '@'+item.name ,
				text : '@'+item.name 
			}));
		});
	}
}
function trimString(valueString)
{		
		if(valueString==null)
			valueString = "N/A";
		var len=valueString.trim().length;
		var newValueString = valueString;
		if(len>20)
		{
			newValueString = valueString.substr(0,20)+'...';
		}
		return newValueString;
}
function SaveHost()
{
	var isFormValid = $("#formHostServer").validationEngine('validate');
	if(!isFormValid)
		return;
	var hostName = $('#txtHostName').val();
	if($('#ddlUserType').val() == "Group Host")
		hostName = $('#ddlGroups').val();
		
	var request = new Request();
	request.url ="cgi/cgi_HostManager.py"
	request.statusType="SaveHost";
	request.parameters={"requestType":'create_Host',"hostType":$('#ddlUserType').val(),"hostName":hostName,"protocol":$('#ddlHostType').val(),"user":$('#txtHostUser').val(),"password":$('#txtHostPwd').val(),"iqn":$('#txtHostIQN').val(),"wwn":$('#txtHostWWN').val(),"url":$('#txtHostUrl').val()};
	CallPythonService(request);
}
function UpdateHost()
{
	var isFormValid = $("#formHostServer").validationEngine('validate');
	if(!isFormValid)
		return;
	var hostName = $('#txtHostName').val();
	if($('#ddlUserType').val() == "Group Host")
		hostName = $('#ddlGroups').val();
	var request = new Request();
	request.url ="cgi/cgi_HostManager.py"
	request.statusType="SaveHost";
	request.parameters={"requestType":'update_Host',"hostId":selectedHost,"hostType":$('#ddlUserType').val(),"hostName":hostName,"protocol":$('#ddlHostType').val(),"user":$('#txtHostUser').val(),"password":$('#txtHostPwd').val(),"iqn":$('#txtHostIQN').val(),"wwn":$('#txtHostWWN').val(),"url":$('#txtHostUrl').val()};
	CallPythonService(request);
}
function DeleteHost()
{
	// var isFormValid = $("#formHostServer").validationEngine('validate');
	// if(!isFormValid)
		// return;
	// var request = new Request();
	// request.url ="cgi/cgi_HostManager.py"
	// request.statusType="SaveHost";
	// request.parameters={"requestType":'delete_Host',"hostId":$('#ddlHostNames').val()};
	// CallPythonService(request);
	
	
	
	if(selectedHost > 0){
		
		swal({
		  title: "Are you sure?",
		  text: "You will not be able to recover this Host Server!",
		  type: "warning",
		  showCancelButton: true,
		  confirmButtonClass: "btn-danger",
		  confirmButtonText: "Yes, delete it!",
		  cancelButtonText: "No, cancel please!",
		  closeOnConfirm: false,
		  closeOnCancel: false
		},
		function(isConfirm) {
		  if (isConfirm) {
			var request = new Request();
			request.url ="cgi/cgi_HostManager.py"
			request.statusType="SaveHost";
			request.parameters={"requestType":'delete_Host',"hostId":selectedHost};
			CallPythonService(request);
		  } else {
			swal("Cancelled", "Your Host Server is safe :)", "error");
		  }
		});
	}
	else
	{
		$('.clsVolumePage').removeClass('alert-danger');
		alert('Please select Volume');
	}
		
}
function GetAllProtocol()
{
	var request = new Request();
	request.url ="cgi/cgi_HostManager.py"
	request.statusType="getProtocol";
	request.parameters={"requestType":'read_Protocol'};
	CallPythonService(request);
}
function EditHost(){
	if(selectedHost > 0){
		var request = new Request();
		request.url ="cgi/cgi_HostManager.py"
		request.statusType="getHostById";
		request.parameters={"requestType":'read_Host','hostId':selectedHost};
		
		setTimeout(function(){ CallPythonService(request);$('#divHostNew').show();}, 2000);
		
	}
	else{
		$('.clsHostPage').removeClass('alert-danger');
		alert('Please select Host');
	}
	
	
}
$('#ddlHostType,#ddlUserType').change(function(){
	//$('#txtHostName').val('');
	if($(this).val().toString() == "7") { //only for s3 object
		$('#txtHostUrl').val('');
		$('#txtHostUrl').attr('placeholder','http://0.0.0.0 or URL')
		$('#txtHostUrl').removeClass("validate[required]").addClass("validate[required,custom[url]]");
	}
	else {
		$('#txtHostUrl').attr('placeholder','URL')
		$('#txtHostUrl').removeClass("validate[required,custom[url]]").addClass("validate[required]");
	}
	SetUpGrayedOutRules(1);
});
function SetUpGrayedOutRules(protocolId)
{
	if(hostActionPage == 'Delete')
		return;
	var protocol=$('#ddlHostType').val();
	var host_type = $('#ddlUserType').val();
	var hostGrayedOutRules = new HostGrayedOutRules();
	if(protocol == 0 || protocol == '')
		var rules = hostGrayedOutRules[hostGrayedOutRules.length-1]['rules'];
	else
		var rules = hostGrayedOutRules[protocol-1]['rules'];

    var rule = rules[0];
    rules.forEach(element => {
        if(element['type']==host_type)
            rule = element;
    });
//console.log("Rules : ", rule)
	
	if(rule.user == 0){
		$('#txtHostUser').attr('disabled',true);
		$('#txtHostUser').val('');
	}
	else
		$('#txtHostUser').attr('disabled',false);
	
	if(rule.password == 0){
		$('#txtHostPwd').attr('disabled',true);
		$('#txtHostPwd').val('');
	}
	else
		$('#txtHostPwd').attr('disabled',false);
	
	if(rule.iqn == 0){
		$('#txtHostIQN').attr('disabled',true);
		$('#txtHostIQN').val('');
	}
	else{
		console.log("Rules : ", rule.iqn)
		$('#txtHostIQN').attr('disabled',false);
	}
	
	
	if(rule.wwn == 0){
		$('#txtHostWWN').attr('disabled',true);
		$('#txtHostWWN').val('');
	}
	else
		$('#txtHostWWN').attr('disabled',false);
	
	if(rule.url == 0){
		$('#txtHostUrl').attr('disabled',true);
		$('#txtHostUrl').val('');
	}
	else
		$('#txtHostUrl').attr('disabled',false);

	if(protocol==1 && host_type=='Storage Manager') //only for cifs
	{
		$('#ip_title').html('Server IP');
	}
	else{
		$('#ip_title').html("Allowed IP's");
	}
}

$('.clsHostPage').click(function(){
	$('.clsHostPage').removeClass('alert-danger');
	$(this).addClass('alert-danger');
	//BindAllHosts();	
});

function BindAllHosts()
{
	var request = new Request();
	request.url ="cgi/cgi_HostManager.py"
	request.statusType="getHosts";
	request.parameters={"requestType":'read_Host',"hostId":0};
	CallPythonService(request);
}
function openHostPopup()
{
	//$('#btnHostAdd').trigger('click');
}
function HostPageNavigate(page)
{
	$('#txtHostName').val('')
	$('#txtHostUser').val('');
	$('#txtHostPwd').val('');
	$('#txtHostIQN').val('');
	$('#txtHostWWN').val('');
	$('#txtHostUrl').val('');
	$('#ddlUserType').val(0);
	$('#divGroups').hide();
	$('#divSingleUser').show();
	
	$('.hostFieldCls').attr('disabled',false);
	GetAllProtocol();
	GetAllOrgGroups();	
	
	$('#divHostNew').css('display','none');
	hostActionPage = page;
	
	if(page == 'Add'){
		$('.clsHostNames').css('display','none');
		$('#btnHostAction').attr('onclick','SaveHost()').html('Confirm');
		$('#divHostNew').css('display','block');
		BindAllHosts();
		
	}
	else if(page == 'Edit'){
		$('.clsHostNames').css('display','block');
		$('#btnHostAction').attr('onclick','UpdateHost()').html('Confirm');
		//$('#divHostNew').css('display','block');
	}
	else if(page == 'Delete'){
		$('.clsHostNames').css('display','block');
		$('#btnHostAction').attr('onclick','DeleteHost()').html('Confirm');	
		//$('#divHostNew').css('display','block');
		$('.hostFieldCls').attr('disabled',true);		
	}	
	else
	{
		$('.clsHostPage').removeClass('alert-danger');
	}
}
// Host Manager code End

// Volume Manager code Start
$('.clsVolumePage').click(function(){
	$('.clsVolumePage').removeClass('alert-danger');
	$(this).addClass('alert-danger');
});

function VolumeMgrPageNavigate(page)
{
		$('#txtVolumeSize').val('');
		$('#txtVolumeLUN').val('');
		$('#txtVolumeName').val('');
		$('#chkCompression').attr('checked',false);
		$('#chkDedup').attr('checked',false);
		
		$('#ddlVolumeProtocol').attr('disabled',false);
		$('#ddlVolumeHost').attr('disabled',false);
		$('#ddlvolumePorts').attr('disabled',false);
		$('#chkCompression').attr('disabled',false);
		$('#chkDedup').attr('disabled',false);
		$('#txtVolumeLUN').attr('disabled',false);
		$('#ddlVolumePool').attr('disabled',false);
		$('#txtVolumeSize').attr('disabled',false);
	
	$('#divNewVolumeMgr').hide();
	if(page == 'Add'){
		BindVolumeDefaultData();
		$('#txtVolumeName').show();
		$('#ddlVolumeNames').hide();
		$('#divNewVolumeMgr').show();
		$('#btnVolumeAction').attr('onclick','SaveVoume()');
	}
	else if(page == 'Edit')
	{
		BindVolumeDefaultData();
		$('#txtVolumeName').hide();
		$('#ddlVolumeNames').show();
		//$('#divNewVolumeMgr').show();
		$('#btnVolumeAction').attr('onclick','UpdateVoume()');
		$('#ddlVolumeProtocol').attr('disabled',true);
		$('#ddlVolumeHost').attr('disabled',true);
	}
	else if(page == 'Delete')
	{
		$('#divNewVolumeMgr').hide();
		// BindVolumeDefaultData();
		// $('#txtVolumeName').hide();
		// $('#ddlVolumeNames').show();
		// $('#divNewVolumeMgr').show();
		// $('#btnVolumeAction').attr('onclick','DeleteVoume()');
		
		// $('#ddlVolumeProtocol').attr('disabled',true);
		// $('#ddlVolumeHost').attr('disabled',true);
		// $('#ddlvolumePorts').attr('disabled',true);
		// $('#chkCompression').attr('disabled',true);
		// $('#chkDedup').attr('disabled',true);
		// $('#txtVolumeLUN').attr('disabled',true);
		// $('#ddlVolumePool').attr('disabled',true);
		// $('#txtVolumeSize').attr('disabled',true);
	}
	else if(page== 'cancel')
	{
		$('#divNewVolumeMgr').hide();
		$('.clsVolumePage').removeClass('alert-danger');
	}
	//BindVolumeSavedData();
}
function BindVolumeDefaultData()
{
	selectedProtocol=0;
	var request = new Request();
	request.url ="cgi/cgi_HostManager.py"
	request.statusType="getHostsForVolume";
	request.parameters={"requestType":'read_Host',"hostId":0};
	CallPythonService(request);
	
	var request = new Request();
	request.url ="cgi/cgi_Pool_Get.py"
	request.statusType="getStoragePools";
	request.parameters={"requestType":'read_pool'};
	CallPythonService(request);
	
	var request = new Request();
	request.url ="cgi/cgi_VolumeManager.py"
	request.statusType="getEthernetPorts";
	request.parameters={"requestType":'read_Ethernet_ports'};
	CallPythonService(request);
	
	var request = new Request();
	request.url ="cgi/cgi_HostManager.py"
	request.statusType="getProtocolForVolume";
	request.parameters={"requestType":'read_Protocol'};
	CallPythonService(request);		
	
}
function SaveVoume()
{
	var isFormValid = $("#formVolumeMgr").validationEngine('validate');
	if(!isFormValid)
		return;
	var dedup = $('#chkDedup').is(":checked");
	var compression = $('#chkCompression').is(":checked");
	//var selectedhosts = $('#ddlVolumeHost').val() != null ? $('#ddlVolumeHost').val().toString():'0';
	
	var request = new Request();
	request.url ="cgi/cgi_VolumeManager.py"
	request.statusType="SaveVolume";
	request.parameters={"requestType":'create_Volume',"volumeName":$('#txtVolumeName').val(),"size":$('#txtVolumeSize').val(),"dedup":dedup,"compression":compression,"protocolId":$('#ddlVolumeProtocol').val(),"poolId":$('#ddlVolumePool').val(),"hostId":$('#ddlVolumeHost').val(),"lun":$('#txtVolumeLUN').val(),"portId":$('#ddlvolumePorts').val()};
	CallPythonService(request);
}
function UpdateVoume()
{
	var isFormValid = $("#formVolumeMgr").validationEngine('validate');
	if(!isFormValid)
		return;
	
	var dedup = $('#chkDedup').is(":checked");
	var compression = $('#chkCompression').is(":checked");
	
	var request = new Request();
	request.url ="cgi/cgi_VolumeManager.py"
	request.statusType="SaveVolume";
	request.parameters={"requestType":'update_Volume',"volumeId":selectedVolume,"size":$('#txtVolumeSize').val(),"dedup":dedup,"compression":compression,"protocolId":$('#ddlVolumeProtocol').val(),"poolId":$('#ddlVolumePool').val(),"hostId":$('#ddlVolumeHost').val(),"lun":$('#txtVolumeLUN').val(),"portId":$('#ddlvolumePorts').val()};
	CallPythonService(request);
}
function DeleteVoume()
{
	//alert($('input[name=rdVolume]:checked').val());
	// var isFormValid = $("#formVolumeMgr").validationEngine('validate');
	// if(!isFormValid)
		// return;
	
	if(selectedVolume > 0){
		
		swal({
		  title: "Are you sure?",
		  text: "You will not be able to recover this Volume!",
		  type: "warning",
		  showCancelButton: true,
		  confirmButtonClass: "btn-danger",
		  confirmButtonText: "Yes, delete it!",
		  cancelButtonText: "No, cancel please!",
		  closeOnConfirm: false,
		  closeOnCancel: false
		},
		function(isConfirm) {
		  if (isConfirm) {
			var request = new Request();
			request.url ="cgi/cgi_VolumeManager.py"
			request.statusType="SaveVolume";
			request.parameters={"requestType":'delete_Volume',"volumeId":selectedVolume,"volumeType":$('input[name=rdVolume]:checked').attr('volType')};
			CallPythonService(request);
		  } else {
			swal("Cancelled", "Your Volume is safe :)", "error");
		  }
		});
	}
	else
	{
		$('.clsVolumePage').removeClass('alert-danger');
		alert('Please select Volume');
	}
}
function BindVolumeSavedData()
{
	var request = new Request();
	request.url ="cgi/cgi_VolumeManager.py"
	request.statusType="getVolumeSavedData";
	request.parameters={"requestType":'read_Volume','volumeId':0};
	CallPythonService(request);
}
$('#ddlVolumeNames').change(function(){
	var request = new Request();
	request.url ="cgi/cgi_VolumeManager.py"
	request.statusType="getVolumeById";
	request.parameters={"requestType":'read_Volume','volumeId':$(this).val()};
	CallPythonService(request);
});

function EditVolume(){
	if(selectedVolume > 0){
		
		
		var request = new Request();
		request.url ="cgi/cgi_VolumeManager.py"
		request.statusType="getVolumeById";
		request.parameters={"requestType":'read_Volume','volumeId':selectedVolume};
		
		setTimeout(function(){ CallPythonService(request);$('#divNewVolumeMgr').show();}, 2000);
		
	}
	else{
		$('.clsVolumePage').removeClass('alert-danger');
		alert('Please select Volume');
	}
}

function OnOffVolume(volumeId,state,volumeType)
{
	var request = new Request();
	request.url ="cgi/cgi_VolumeManager.py"
	request.statusType="changeVolumeState";
	request.parameters={"requestType":'onOff_Volume','volumeId':volumeId,"state":state,"volumeType":volumeType};
	CallPythonService(request);
}

$('#txtSnapshotName').on('input',function(){
	if($(this).val().length > 0)
		$('#btnVolumeSnap').show();
	else
		$('#btnVolumeSnap').hide();
})
function VolumeInfo(size)
{
	$('#lblSize').text(size + ' GB');
	$('#volumeInfoPop').modal('show');
}
function SnapShotVolume(volumeId,volumeName)
{	
	swal({
        title: "voluem Snapshot",
        text: "Enter snapshot name:",
        type: "input",
        showCancelButton: true,
		confirmButtonText: 'Confirm',		
        closeOnConfirm: false,
        inputPlaceholder: volumeName,
        inputValue: volumeName + "-ss1"
    }, function(inputValue) {
        if (inputValue === false) return false;
        if (inputValue === "") {
            swal.showInputError("Snapshot name required!");
            return false
        }
		else{
			var serverName = $('#myModalLabelPop').text();
			var request=new Request();
			request.url ="cgi/cgi_VolumeManager.py"
			request.statusType = 'SaveSnapVolume';
			request.parameters = {"requestType":'snapShot_volume',"volumeId":volumeId,"snapShotName":inputValue};			
			CallPythonService(request);		
		}        
    });
}
$('#ddlUserType').change(function(){
	//$('#txtHostName').val('');
	if($('#ddlUserType').val() == "Group Host"){
		$('#divGroups').show();
		$('#divSingleUser').hide();
		GetAllOrgGroups();
	}
	else
	{
		$('#divGroups').hide();
		$('#divSingleUser').show();
	}
	//SetUpGrayedOutRules(0);
});

function GetAllOrgGroups(){
	
	var request = new Request();
	request.url = "cgi/cgi_Organization_Manager.py";
	request.parameters = {"RequestType": 'read_Group', "groupId": 0 };
	request.statusType = "GetOrgGroups";
	CallPythonService(request);
	
}

$('#ddlVolumeProtocol').change(function(){
	selectedProtocol = $(this).val();
	var request = new Request();
	request.url ="cgi/cgi_VolumeManager.py"
	request.statusType="getHostsForVolume";
	request.parameters={"requestType":'read_HostByProtocol',"protocolId":selectedProtocol};
	CallPythonService(request);
}); 
$('.clsVolumeRecord').change(function(){
	selectedVolume = $(this).attr('value');
	alert(selectedVolume);
});
function GetString(str)
{
	if(str == null)
		return '';
	else
		return str;
}

function showPassword(obj,selectedHostID) {
	if($(obj).parent().hasClass('hidetext')) {
		$(obj).parent().removeClass('hidetext');
		$(obj).html(eyeClosedSVG);
		// $(obj).attr('onclick','').css('cursor','not-allowed').css('opacity',0.5);
		// $(obj).attr('onclick','');
		var request = new Request();
		request.url ="cgi/cgi_HostManager.py"
		request.statusType="updatePasswordHidden";
		// 0 - False - Password Not Hidden
		request.parameters={"requestType":'update_passwordHidden',"hostId":selectedHostID, "password_hidden": 0};
		CallPythonService(request);
	}
	else {
		$(obj).parent().addClass('hidetext');
		$(obj).html(eyeOpenSVG);
		var request = new Request();
		request.url ="cgi/cgi_HostManager.py"
		request.statusType="updatePasswordHidden";
		// 0 - False - Password Not Hidden
		request.parameters={"requestType":'update_passwordHidden',"hostId":selectedHostID, "password_hidden": 1};
		CallPythonService(request);
	}
}