var uuid='';
var sessionData = null;
var currentTimezone = "";
var clientConfig = [{"key":'HostServer',"value":true,"id":'menuHostServer'},
					{"key":'VolumeManager',"value":true,"id":'menuVolumeManager'},
					{"key":'MyServers',"value":false,"id":'menuMyServer'},
					{"key":'Market',"value":false,"id":'menuMarket'},
					{"key":'StatusVmStatusIcon',"value":false,"id":'vmStatusIcon'},
					{"key":'StatusVolManagerIcon',"value":false,"id":'VolManagerIcon'},
					{"key":'StatusHostSreverIcon',"value":false,"id":'HostServerIcon'},
					{"key":'StatusAppChart',"value":false,"id":'divAppsChart'},
					{"key":'marketGroupChart',"value":false,"id":'iframeMarket'},
					{"key":'ScheduleListimgDownload',"value":false,"id":'divImgDownloads'},
					{"key":'scheduleActionsApp',"value":false,"id":'','class':'clsAppSchedueActions'},
					{"key":'scheduleActionsVolume',"value":true,"id":'','class':'clsVolumeSchedueActions'}]
var JavascriptTimeZones = [ 'Europe/Andorra', 'Asia/Dubai', 'Asia/Kabul', 'Europe/Tirane', 'Asia/Yerevan', 'Antarctica/Casey', 'Antarctica/Davis', 'Antarctica/DumontDUrville', 'Antarctica/Mawson', 'Antarctica/Palmer', 'Antarctica/Rothera', 'Antarctica/Syowa', 'Antarctica/Troll', 'Antarctica/Vostok', 'America/Argentina/Buenos_Aires', 'America/Argentina/Cordoba', 'America/Argentina/Salta', 'America/Argentina/Jujuy', 'America/Argentina/Tucuman', 'America/Argentina/Catamarca', 'America/Argentina/La_Rioja', 'America/Argentina/San_Juan', 'America/Argentina/Mendoza', 'America/Argentina/San_Luis', 'America/Argentina/Rio_Gallegos', 'America/Argentina/Ushuaia', 'Pacific/Pago_Pago', 'Europe/Vienna', 'Australia/Lord_Howe', 'Antarctica/Macquarie', 'Australia/Hobart', 'Australia/Currie', 'Australia/Melbourne', 'Australia/Sydney', 'Australia/Broken_Hill', 'Australia/Brisbane', 'Australia/Lindeman', 'Australia/Adelaide', 'Australia/Darwin', 'Australia/Perth', 'Australia/Eucla', 'Asia/Baku', 'America/Barbados', 'Asia/Dhaka', 'Europe/Brussels', 'Europe/Sofia', 'Atlantic/Bermuda', 'Asia/Brunei', 'America/La_Paz', 'America/Noronha', 'America/Belem', 'America/Fortaleza', 'America/Recife', 'America/Araguaina', 'America/Maceio', 'America/Bahia', 'America/Sao_Paulo', 'America/Campo_Grande', 'America/Cuiaba', 'America/Santarem', 'America/Porto_Velho', 'America/Boa_Vista', 'America/Manaus', 'America/Eirunepe', 'America/Rio_Branco', 'America/Nassau', 'Asia/Thimphu', 'Europe/Minsk', 'America/Belize', 'America/St_Johns', 'America/Halifax', 'America/Glace_Bay', 'America/Moncton', 'America/Goose_Bay', 'America/Blanc-Sablon', 'America/Toronto', 'America/Nipigon', 'America/Thunder_Bay', 'America/Iqaluit', 'America/Pangnirtung', 'America/Atikokan', 'America/Winnipeg', 'America/Rainy_River', 'America/Resolute', 'America/Rankin_Inlet', 'America/Regina', 'America/Swift_Current', 'America/Edmonton', 'America/Cambridge_Bay', 'America/Yellowknife', 'America/Inuvik', 'America/Creston', 'America/Dawson_Creek', 'America/Fort_Nelson', 'America/Vancouver', 'America/Whitehorse', 'America/Dawson', 'Indian/Cocos', 'Europe/Zurich', 'Africa/Abidjan', 'Pacific/Rarotonga', 'America/Santiago', 'America/Punta_Arenas', 'Pacific/Easter', 'Asia/Shanghai', 'Asia/Urumqi', 'America/Bogota', 'America/Costa_Rica', 'America/Havana', 'Atlantic/Cape_Verde', 'America/Curacao', 'Indian/Christmas', 'Asia/Nicosia', 'Asia/Famagusta', 'Europe/Prague', 'Europe/Berlin', 'Europe/Copenhagen', 'America/Santo_Domingo', 'Africa/Algiers', 'America/Guayaquil', 'Pacific/Galapagos', 'Europe/Tallinn', 'Africa/Cairo', 'Africa/El_Aaiun', 'Europe/Madrid', 'Africa/Ceuta', 'Atlantic/Canary', 'Europe/Helsinki', 'Pacific/Fiji', 'Atlantic/Stanley', 'Pacific/Chuuk', 'Pacific/Pohnpei', 'Pacific/Kosrae', 'Atlantic/Faroe', 'Europe/Paris', 'Europe/London', 'Asia/Tbilisi', 'America/Cayenne', 'Africa/Accra', 'Europe/Gibraltar', 'America/Godthab', 'America/Danmarkshavn', 'America/Scoresbysund', 'America/Thule', 'Europe/Athens', 'Atlantic/South_Georgia', 'America/Guatemala', 'Pacific/Guam', 'Africa/Bissau', 'America/Guyana', 'Asia/Hong_Kong', 'America/Tegucigalpa', 'America/Port-au-Prince', 'Europe/Budapest', 'Asia/Jakarta', 'Asia/Pontianak', 'Asia/Makassar', 'Asia/Jayapura', 'Europe/Dublin', 'Asia/Jerusalem', 'Asia/Kolkata', 'Indian/Chagos', 'Asia/Baghdad', 'Asia/Tehran', 'Atlantic/Reykjavik', 'Europe/Rome', 'America/Jamaica', 'Asia/Amman', 'Asia/Tokyo', 'Africa/Nairobi', 'Asia/Bishkek', 'Pacific/Tarawa', 'Pacific/Enderbury', 'Pacific/Kiritimati', 'Asia/Pyongyang', 'Asia/Seoul', 'Asia/Almaty', 'Asia/Qyzylorda', 'Asia/Qostanay', 'Asia/Aqtobe', 'Asia/Aqtau', 'Asia/Atyrau', 'Asia/Oral', 'Asia/Beirut', 'Asia/Colombo', 'Africa/Monrovia', 'Europe/Vilnius', 'Europe/Luxembourg', 'Europe/Riga', 'Africa/Tripoli', 'Africa/Casablanca', 'Europe/Monaco', 'Europe/Chisinau', 'Pacific/Majuro', 'Pacific/Kwajalein', 'Asia/Yangon', 'Asia/Ulaanbaatar', 'Asia/Hovd', 'Asia/Choibalsan', 'Asia/Macau', 'America/Martinique', 'Europe/Malta', 'Indian/Mauritius', 'Indian/Maldives', 'America/Mexico_City', 'America/Cancun', 'America/Merida', 'America/Monterrey', 'America/Matamoros', 'America/Mazatlan', 'America/Chihuahua', 'America/Ojinaga', 'America/Hermosillo', 'America/Tijuana', 'America/Bahia_Banderas', 'Asia/Kuala_Lumpur', 'Asia/Kuching', 'Africa/Maputo', 'Africa/Windhoek', 'Pacific/Noumea', 'Pacific/Norfolk', 'Africa/Lagos', 'America/Managua', 'Europe/Amsterdam', 'Europe/Oslo', 'Asia/Kathmandu', 'Pacific/Nauru', 'Pacific/Niue', 'Pacific/Auckland', 'Pacific/Chatham', 'America/Panama', 'America/Lima', 'Pacific/Tahiti', 'Pacific/Marquesas', 'Pacific/Gambier', 'Pacific/Port_Moresby', 'Pacific/Bougainville', 'Asia/Manila', 'Asia/Karachi', 'Europe/Warsaw', 'America/Miquelon', 'Pacific/Pitcairn', 'America/Puerto_Rico', 'Asia/Gaza', 'Asia/Hebron', 'Europe/Lisbon', 'Atlantic/Madeira', 'Atlantic/Azores', 'Pacific/Palau', 'America/Asuncion', 'Asia/Qatar', 'Indian/Reunion', 'Europe/Bucharest', 'Europe/Belgrade', 'Europe/Kaliningrad', 'Europe/Moscow', 'Europe/Simferopol', 'Europe/Kirov', 'Europe/Astrakhan', 'Europe/Volgograd', 'Europe/Saratov', 'Europe/Ulyanovsk', 'Europe/Samara', 'Asia/Yekaterinburg', 'Asia/Omsk', 'Asia/Novosibirsk', 'Asia/Barnaul', 'Asia/Tomsk', 'Asia/Novokuznetsk', 'Asia/Krasnoyarsk', 'Asia/Irkutsk', 'Asia/Chita', 'Asia/Yakutsk', 'Asia/Khandyga', 'Asia/Vladivostok', 'Asia/Ust-Nera', 'Asia/Magadan', 'Asia/Sakhalin', 'Asia/Srednekolymsk', 'Asia/Kamchatka', 'Asia/Anadyr', 'Asia/Riyadh', 'Pacific/Guadalcanal', 'Indian/Mahe', 'Africa/Khartoum', 'Europe/Stockholm', 'Asia/Singapore', 'America/Paramaribo', 'Africa/Juba', 'Africa/Sao_Tome', 'America/El_Salvador', 'Asia/Damascus', 'America/Grand_Turk', 'Africa/Ndjamena', 'Indian/Kerguelen', 'Asia/Bangkok', 'Asia/Dushanbe', 'Pacific/Fakaofo', 'Asia/Dili', 'Asia/Ashgabat', 'Africa/Tunis', 'Pacific/Tongatapu', 'Europe/Istanbul', 'America/Port_of_Spain', 'Pacific/Funafuti', 'Asia/Taipei', 'Europe/Kiev', 'Europe/Uzhgorod', 'Europe/Zaporozhye', 'Pacific/Wake', 'America/New_York', 'America/Detroit', 'America/Kentucky/Louisville', 'America/Kentucky/Monticello', 'America/Indiana/Indianapolis', 'America/Indiana/Vincennes', 'America/Indiana/Winamac', 'America/Indiana/Marengo', 'America/Indiana/Petersburg', 'America/Indiana/Vevay', 'America/Chicago', 'America/Indiana/Tell_City', 'America/Indiana/Knox', 'America/Menominee', 'America/North_Dakota/Center', 'America/North_Dakota/New_Salem', 'America/North_Dakota/Beulah', 'America/Denver', 'America/Boise', 'America/Phoenix', 'America/Los_Angeles', 'America/Anchorage', 'America/Juneau', 'America/Sitka', 'America/Metlakatla', 'America/Yakutat', 'America/Nome', 'America/Adak', 'Pacific/Honolulu', 'America/Montevideo', 'Asia/Samarkand', 'Asia/Tashkent', 'America/Caracas', 'Asia/Ho_Chi_Minh', 'Pacific/Efate', 'Pacific/Wallis', 'Pacific/Apia', 'Africa/Johannesburg', 'UTC' ];
$(function () {	
	SetupclientConfig();
    ValidateSession(true);
	loadjscssfile('devScripts/constants.js','js');
	loadjscssfile('Plugins/JAlerts/jTimeout.js','js');
	loadjscssfile('Plugins/JAlerts/jAlert.min.js','js');
	loadjscssfile('Plugins/JAlerts/jAlert.css','css');
	
	$(document).ajaxStart(function(request){
        ValidateSession(false);
    });
	$(document).ajaxSuccess(function(response,x,s){
        if(response.status == 'NoAccess')
			window.location.href = "unAutherizedAccess.html"; 
    });
});

var scriptPath = "devScripts/"

function Request() {
    var request = {
        url: "",
        parameters: {},
        Type: ""
    };
    return request;
}

function CreateProfile(sessionData)
{
	var userManagement = '';
	if(sessionData.userType != 3)
		//userManagement='<a href="userManagement.html">User Management</a>';

	$('.userProfile')[0].innerHTML='<i><img src="images/icon-men.png" alt=""></i><b>'+sessionData.Name+'</b><span>My account</span>';
	$('.profile-details')[0].innerHTML='<a href="userprofile.html">Profile</a>'+'<a href="http://www.quantum.com/R6000Docs" target="_blank">Documentation</a><span class="divider"></span>	<a href="javascript:void(0);" onclick="Logout()">Logout</a>'

	sessionData.LastUpdatedDate = Date.parse(new Date());
	sessionStorage.setItem("sessionData", JSON.stringify(sessionData));

	//For Quantum
    // document.title = "Quantum";
	$('.navbar-brand').html('<a href="index.html"><!-- from securePage.js --> <img src="images/Quantum_Logo_RGB.svg" alt="" style="margin-top: 3%;"/> </a>');
	var link = document.querySelector("link[rel~='icon']");
	if (!link) {
		link = document.createElement('link');
		link.rel = 'icon';
		document.getElementsByTagName('head')[0].appendChild(link);
	}
	link.href = 'favicon.ico';
}
function ValidateSession(isCreateProfile)
{
	sessionData =JSON.parse(sessionStorage.getItem("sessionData"));	
	var sessionTimeOut = sessionTimeOut == undefined  ? parent.sessionTimeOut:sessionTimeOut;
	if (typeof(Storage) !== "undefined" && sessionData != null) {
		$('.main-container').show();
		uuid = sessionData.SUID;		
		if(isCreateProfile)
			CreateProfile(sessionData)
		else
			window.localStorage.timeoutCountdown = sessionTimeOut;
	} else {
		console.log('logout'+ new Date());
		location.href="login.html";
		return false;
	}
}
function SetupclientConfig()
{
	var configData =JSON.parse(sessionStorage.getItem("configData"));
	if (typeof(Storage) !== "undefined" && configData != null) {
		clientConfig = configData.menuIcons;
	}
	clientConfig = ValidatePageAccess(clientConfig);//TODO:remove logic
	//console.log('clientConfig :',clientConfig);
	for(var i=0;i<clientConfig.length;i++)
	{
		if(clientConfig[i].value){
			if(clientConfig[i].id !='')
				$('#'+clientConfig[i].id).show();
			else
				$('.'+clientConfig[i].class).show();
		}
		else{
			if(clientConfig[i].id !='')
				$('#'+clientConfig[i].id).hide();
			else 
				$('.'+clientConfig[i].class).hide();
		}
	}
}
function ValidatePageAccess(config)
{
	sessionData = GetLoginUserDetails();
	if(sessionData.userType ==3)
		//config['profilePageSuperAdminActions'].value = false;
		config.find(o => o.key === 'profilePageSuperAdminActions').value = false;
	return config;
}
function GetLoginUserDetails()
{
	var sessionData =JSON.parse(sessionStorage.getItem("sessionData"));	
	if (typeof(Storage) !== "undefined" && sessionData != null) {
			return sessionData;
		}
		else {
			console.log('logout1'+ new Date());
			location.href="login.html";
			return false;
	}
	return sessionData;
}
function Logout(redirectToLogin)
{
	sessionData =JSON.parse(sessionStorage.getItem("sessionData"));
	username = sessionData.UserName;
	sessionStorage.clear();
	console.log("logging out, redirectToLogin: ", redirectToLogin)
	if (redirectToLogin == undefined || redirectToLogin) {
		var currentPage = window.location.href;
		console.log('logout' + new Date());
		location.href = "login.html";
		//.href="login.html"+'?returnUrl='+currentPage;
		var request = new Request();
		request.url = 'cgi/cgi_ValidateUser.py';
		request.parameters = { RequestType:'LogoutUser','userName':btoa(username)};
		request.parameters.uuid = parent.uuid;
		$.ajax({
			type: "Get",
			url: request.url,
			contentType: 'application/json',
			dataType: 'json',
			headers: { 'Access-Control-Allow-Origin': '*' },
			data: request.parameters,
			success: function (response) {
			},
			error: function (ex) {
				if (!isProduction) {
					console.log(ex);
				}
			}
		});
	}
	
}
function loadjscssfile(filePath, filetype){	
    if (filetype=="js"){ //if filename is a external JavaScript file
        var fileref=document.createElement('script')
        fileref.setAttribute("type","text/javascript")
        fileref.setAttribute("src", filePath)
    }
    else if (filetype=="css"){ //if filename is an external CSS file
        var fileref=document.createElement("link")
        fileref.setAttribute("rel", "stylesheet")
        fileref.setAttribute("type", "text/css")
        fileref.setAttribute("href", filePath)
    }
    if (typeof fileref!="undefined")
        document.getElementsByTagName("head")[0].appendChild(fileref)
}

function GetTableConfig(tableKey)
{
	var tableConfig = {};
	var configData =JSON.parse(sessionStorage.getItem("configData"));	
	if (typeof(Storage) !== "undefined" && configData != null) {
		var results = jQuery.grep(configData.dataTables, function( n, i ) {
		  return ( n.key === tableKey);
		});
		if(results !=null && results.length > 0)
		{
			tableConfig = results[0].config;
		}
		else{
			var results = jQuery.grep(configData.dataTables, function( n, i ) {
			  return ( n.key == 'default');
			});
			tableConfig = results[0].config;
		}
			
	}
	else {
		console.log('logout1'+ new Date());
		location.href="login.html";			
	}
	return tableConfig;
}
function notify(headerText,message,type)
{
	if(type == 'success')
		type='Success';
	else
		type='failure';
	
	$.Notify({
	text : message,
	headerText:headerText,
	type:type,
	position:'bottom-right'
  });
}


$(document).ready(function(){
	url = window.location.pathname;
	filename = url.substring(url.lastIndexOf('/')+1);
	if(filename != "login.html"){
	
		// to create the datetime element    
   	$(".header-container").first().append("<span class=datetime style='user-select: none;' id=datetime></span>");

	var request = new Request();
	request.url = 'cgi/cgi_NTP_ServiceManager.py';
	request.Type = 'NTPServices_Get';
	request.parameters = { 'RequestType':'read_NTPServices'}
	request.parameters.uuid=parent.uuid;
    	$.ajax({
        	type: "Get",
        	url: request.url,
        	contentType: 'application/json',
        	dataType: 'json',
        	headers: { 'Access-Control-Allow-Origin': '*' },
        	data: request.parameters,
        	success: function (response) {
		    
       	 	    currentTimezone = response[0].time_zone;
        	},
       		error: function (ex) {			
        	    if(!isProduction){
				console.log(ex);
			}
       		 }
   	 });
	
	function updateDateTime() {
        var timezoneToShow = currentTimezone ;
        if (currentTimezone == "select timezone" || currentTimezone == "" || currentTimezone  == undefined || !JavascriptTimeZones.includes(currentTimezone)) {
          currentTimezone = Intl.DateTimeFormat().resolvedOptions().timeZone;
	  timezoneToShow += " (Default)"
        }
        let options = {
          timeZone: currentTimezone,
          year: 'numeric',
	 month: 'short',
	 day: 'numeric',
          hour: "numeric",
          minute: "numeric",
          hour12: false,
        };

        let date = (new Date()).toLocaleString('en-US', options);
        document.getElementById("datetime").innerText = date + " " +  timezoneToShow;
      }
	setInterval(() => {
        updateDateTime();
      }, 500);

	updateDateTime();
		}

})


