var StorageDetails = { Total: 16*1024, SPUsed: 0, Free: 16,Selected:0,SPPoolLevel:1 };
var TFDetails = { Total: 4*1024, SPUsed: 0, Free: 0,Selected:0,SSDTierLevel:0 };
var type1Pools = [];//['HDD POOL','iSCSI POOL','NVMeOF POOL'] // pools  that have same configurations
var type2Pools = ['MegaRAID POOL']; //['SSD POOL','MegaRAID POOL'] // pools  that have same configurations
var typePools = type1Pools.concat(type2Pools).sort()
$(function(){ //to dynamically add options
	if($('#hdnIsCreatePage').val()){
		$('#ddlPoolType').html('');
		$('#ddlPoolType').append(`<option value="Select Pool"> 
								Select Pool
								</option>`);
		typePools.forEach(element => {
			$('#ddlPoolType').append(`<option value="${element}"> 
				${element}
				</option>`);
		});
		
	}
	else{
		// if adding or deleting any pool here, pls change in volumeManager.js as well
		$('#ddlPoolType').html('');
		$('#ddlPoolType').append(`<option value="Select Pool"> 
								Select Pool
								</option>`);
		/*$('#ddlPoolType').append(`<optgroup label="HDD POOL" id="HDDopt">
		<option value="NoneHDD" disabled>No items</option>
		</optgroup>`);
		$('#ddlPoolType').append(`<optgroup label="SSD POOL" id="SSDopt">
		<option value="NoneSSD" disabled>No items</option>
		</optgroup>  `);
		$('#ddlPoolType').append(`<optgroup label="iSCSI POOL" id="iSCSIopt">
		<option value="NoneiSCSI" disabled>No items</option>
		</optgroup>`);
		$('#ddlPoolType').append(`<optgroup label="NVMeOF POOL" id="NVMeOFopt">
		<option value="NoneNVMeOF" disabled>No items</option>
		</optgroup>`);*/
		$('#ddlPoolType').append(`<optgroup label="MegaRAID POOL" id="MegaRAIDopt">
		<option value="NoneMegaRAID" disabled>No items</option>
		</optgroup>`);
	}
});
var savedStatusSP=0;
var savedStatusFT=0;
var savedPools=[];
var poolAliasName = [];
var OldName = "";

var poolObject = null;
function PoolObject()
{
		var poolObject = {
		PoolName: "",
		Percentage :{Total:0,Selected:0,ProtectionLevel:0},
		StorageProtection :{Total:0,Selected:0,ProtectionLevel:0},
		AccelarationCache : {Total:0,Selected:0,ProtectionPercent:0},
		AlreadyConsumed:0,
		AvailableRaw:0,
		AvailableDisks:0,
	}
	return poolObject;
} 

function Request() {
    var request = {
        url: "",
        parameters: {},
        TypeType: ""
    };    
    return request;
}
function ShowAvailableStorage() {
	//console.log("Function ShowAvailable called");
	var msg = ' ';
	
	var poolType = $('#ddlPoolType').val();

	var selected = jQuery.grep(poolAliasName, function(n, i) { 
		return (n.systemName == poolType);
	});

	if(type1Pools.includes(poolType) || (selected.length>0 && type1Pools.includes(selectedPool[0].name)))
	{
		/*if(poolObject.StorageProtection.Selected == 0)							//commented becauase we dont have to show storage protection
		{
			$('#txtHDDProtected').val('0GB Storage Protection');
		}
		else
		{
			$('#txtHDDProtected').val(ConvertGBtoTB(poolObject.StorageProtection.Selected) + ' Storage Protection');
		}*/
		if(poolType=='HDD POOL' || (selectedPool !=null && selectedPool.length>0 && selectedPool[0].name=='HDD POOL'))
		{
			msg = "GB Available HDD";
		}
		else if(poolType=='NVMeOF POOL' || (selectedPool !=null && selectedPool.length>0 && selectedPool[0].name=='NVMeOF POOL'))
		{
			msg = "GB Available NVMeOF";
		}
		else if(poolType=='iSCSI POOL' || (selectedPool !=null && selectedPool.length>0 && selectedPool[0].name=='iSCSI POOL'))
		{
			msg = "GB Available iSCSI";
		}
		
		$('#txtHDDAvailable').val(poolObject.AvailableRaw + msg);
		$('#txtSSDAvailable').val(poolObject.AccelarationCache.Total + 'GB Available SSD');
		$('#txtDisks').val(poolObject.AvailableDisks + ' Disks Available');
	}
	else
	{
		    if(poolType=='SSD POOL' || (selectedPool !=null && selectedPool.length>0 && selectedPool[0].name=='SSD POOL'))
			{
				msg = "GB Available SSD";
			}
			else if(poolType=='MegaRAID POOL' || (selectedPool !=null && selectedPool.length>0 && selectedPool[0].name=='MegaRAID POOL'))
			{
				msg = "GB Available MegaRAID";
			}
		$('#txtHDDAvailable').val(poolObject.AvailableRaw + msg);
		$('#txtSSDAvailable').val(poolObject.AvailableDisks + ' Disks Available');
	}
}

function ConvertGBtoTB(gbValue)
{
	return (gbValue).toFixed(2) + ' GB'
}
$(function () {
	//console.log(" Deafault Function called");
	GetPoolList();
	$('#divDisableSP').css('display','none');
	$('.clsSPBold').removeClass('custom-disabled');
});
function CallPythonService(request) {
	//console.log("Function CallPythonService called");
	request.parameters.uuid=parent.uuid;
	//console.log("Acceleration :" + request.parameters.params['AccelarationPercent']);
    $.ajax({
        type: "Get",
        url: request.url,
        contentType: 'application/json',
        dataType: 'json',
        headers: { 'Access-Control-Allow-Origin': '*' },
        data: request.parameters,
        success: function (response) {
            BindResponseData(request.Type,response);
        },
        error: function (ex) {
            if(!isProduction){
				console.log(ex);
			}
        }
    });
}

function BindResponseData(Type, response) {
    if (Type === 'CreatePool') {
		window.parent.notify(response.description,response.description,response.status);	
		$('#ddlPoolType').val('Select Pool');
		GetPoolList();		
		window.parent.GetAllDataBySelectedSection('StoragePools');
		window.location.reload();
	}
	else if(Type == 'GetPool')
	{
		var poolType = $('#ddlPoolType').val();
		poolObject = new PoolObject();
		poolAliasName = response.poolData;
		/*if($('#hdnIsDeletePage').val() || ($('#hdnIsEditPage').val()))
			{
				$('#ddlPoolType option[value="HDD POOL"]').hide();
				$('#ddlPoolType option[value="SSD POOL"]').hide();
				$('#ddlPoolType option[value="iSCSI POOL"]').hide();
				$('#ddlPoolType option[value="NVMeOF POOL"]').hide();
			}*/
		//console.log("Pool Alias Name " +poolAliasName);
		for(var i=0;i<response.poolData.length;i++)
		{
			
			optionText = response.poolData[i].systemName; 
			optionValue = response.poolData[i].systemName;
			optionName = response.poolData[i].name;
			
			if(savedPools.indexOf(optionText)<0) {  //to avoid multiple enteries into the list		  	
				if($('#hdnIsDeletePage').val() || ($('#hdnIsEditPage').val())) {
					// if adding or deleting any pool here, pls change in volumeManager.js, SetUp_Hardware.js as well
					if(optionName == 'HDD POOL') 
					{
						$('#ddlPoolType option[value="NoneHDD"]').remove();
						$('#HDDopt').append(`<option value="${optionValue}"> 
								${optionText}
								</option>`);
					}
					else if(optionName == 'SSD POOL') 
					{
						$('#ddlPoolType option[value="NoneSSD"]').remove();
						$('#SSDopt').append(`<option value="${optionValue}"> 
								${optionText}
								</option>`);
					}
					else if(optionName == 'iSCSI POOL') 
					{
						$('#ddlPoolType option[value="NoneiSCSI"]').remove();
						$('#iSCSIopt').append(`<option value="${optionValue}"> 
								${optionText}
								</option>`);
					}
					else if(optionName == 'NVMeOF POOL') 
					{
						$('#ddlPoolType option[value="NoneNVMeOF"]').remove();
						$('#NVMeOFopt').append(`<option value="${optionValue}"> 
								${optionText}
								</option>`);
					} 
					else if(optionName == 'MegaRAID POOL') 
					{
						$('#ddlPoolType option[value="NoneMegaRAID"]').remove();
						$('#MegaRAIDopt').append(`<option value="${optionValue}"> 
								${optionText}
								</option>`);
					}   
				}			  
				savedPools.push(response.poolData[i].systemName);
			}	
		}
		//console.log("Saved pools " + savedPools);
		var selectedPool = jQuery.grep(response.poolData, function(n, i) { 
			return (n.systemName == poolType);
		});		
		
		$('#divCreateStatus').hide();
		$('#spnStatus').text('');
		$('#spnStatusDel').text('');
		$('#btnDelete').attr("onclick","DeletePool()");
		//$('#btnSavePool').attr("onclick","ShowConfirm()");
		
		if($('#hdnIsDeletePage').val())
		{
			$('#txtHDDAvailable').hide();   //hide all text boxes during delete page
			$('#txtSSDAvailable').hide();
			//$('#txtHDDProtected').hide();
			$('#txtDisks').hide();
			/*if(hddPool !=null && hddPool.length >0){
				$('#ddlPoolType option[value="HDD POOL"]').show();
			}
			if(ssdPool !=null && ssdPool.length >0){
				$('#ddlPoolType option[value="SSD POOL"]').show();
			}*/
		}
		if(poolType == 'Select Pool')
		{
			//console.log("Select Pool");
			$('#divDisableFT').css('display','block');						//hide all dials for select pool option
			$('#imgTieringFastier').css('background-color','#ddd');
			$('#divDisableSP').css('display','block');
			$('#imgStorageProtection').css('background-color','#ddd');	
			$('#divDisableSF').css('display','block');
			$('#imgHDDPercentage').css('background-color','#ddd');
			$('#chkAccelaeration').attr('disabled',true);
			$('#chkDeduplication').attr('disabled',true);
			$('#chkEncryption').attr('disabled',true);
			$('#chkCompression').attr('disabled',true);

		}
		else // if any pool is selected
		{
			$('#divDisableFT').css('display','none');
			$('#imgTieringFastier').css('background-color','white');
			$('#divDisableSP').css('display','none');
			$('#imgStorageProtection').css('background-color','white');	
			$('#divDisableSF').css('display','none');
			$('#imgHDDPercentage').css('background-color','white');
			$('.clsSPBold').removeClass('custom-disabled');
			$('#chkAccelaeration').attr('disabled',false);
			$('#chkEncryption').attr('disabled',false);
			$('#chkDeduplication').attr('disabled',false);
			$('#chkCompression').attr('disabled',false);	
		}
		
		if(type1Pools.includes(poolType)){
			$('#divDisableFT').css('display','block');
			$('#chkAccelaeration').attr('disabled',false);
			$('#divAccelaration').removeClass('disabled');
			$('#imgTieringFastier').css('background-color','#ddd');		
			$('#divFT0').trigger( "click" );
			if(poolType == 'HDD POOL')
			{
				$('#percentageHeading').text('DISK Perecenatge');
				// $('#percentageHeading').text('HDD Perecenatge');
				poolObject.AvailableRaw = response.availableHDDStorage;
				poolObject.AvailableDisks = response.availableDisks;
			}
			else if(poolType == 'NVMeOF POOL')
			{
				$('#percentageHeading').text('DISK Perecenatge');
				// $('#percentageHeading').text('NVMeOF Perecenatge');
				poolObject.AvailableRaw = response.availableMVMeOFStorage;
				poolObject.AvailableDisks = response.availableDisks;
				//poolObject.AccelarationCache.Total = 0;
			}
			else if(poolType == 'iSCSI POOL')
			{
				$('#percentageHeading').text('DISK Perecenatge');
				// $('#percentageHeading').text('iSTOR Perecenatge');
				poolObject.AvailableRaw = response.availableiSTORStorage;
				poolObject.AvailableDisks = response.availableDisks;
				//poolObject.AccelarationCache.Total = 0;
			}
			if(poolObject.AvailableRaw <= 0 && !$('#hdnIsDeletePage').val() && !($('#hdnIsEditPage').val()))
			{
				window.parent.ShowSweetAlert('error','Error','No more raw capacity left!');
				window.location.reload();
			}
			//console.log(response.AllocatedAcceleration);
			poolObject.AccelarationCache.Total = response.availableSSDStorage;
				/*if($('#hdnIsDeletePage').val()){
					window.parent.ShowSweetAlert('error','Error','You can not delete HDD Pool, Please delete SSD Pool First');
					window.location.reload();
					$('#btnDelete').attr("onclick","alert('Please delete HDD POOL first')");
				}*/
		}
		else if(type2Pools.includes(poolType))
		{	
			if(poolType == 'SSD POOL')
			{
				$('#percentageHeading').text('DISK Perecenatge');
				// $('#percentageHeading').text('SSD Perecenatge');
				poolObject.AvailableRaw = response.availableSSDStorage;
				poolObject.AvailableDisks = response.availableDisks;
				//poolObject.AccelarationCache.Total = 0;
			}
			else if(poolType == 'MegaRAID POOL')
			{
				$('#percentageHeading').text('DISK Perecenatge');
				// $('#percentageHeading').text('MegaRAID Perecenatge');
				poolObject.AvailableRaw = response.availableMegaRAIDStorage;
				poolObject.AvailableDisks = response.availableDisks;
				$('#divSP2,#divSP3').addClass('custom-disabled');
				//$('#imgStorageProtection').css('background-color','#ddd');
				//$('#divDisableSP').css('display','block');
				//poolObject.AccelarationCache.Total = 0;
			}
			//console.log(poolObject.AvailableRaw +" "+ response.availableSSDStorage +" "+ response.AllocatedSSD +" "+ response.AllocatedAcceleration);
			if(poolObject.AvailableRaw <= 0 && !$('#hdnIsDeletePage').val() && !($('#hdnIsEditPage').val()))
			{
				window.parent.ShowSweetAlert('error','Error','No more raw capacity left!');
				window.location.reload();
			}
			/*if(hddPool !=null && hddPool.length >0){					//Restriction to create hdd before ssd and others
				var i=1;
			}
			else{
				//$('#spnStatus').text('Please configure HDD POOL first');				
				$('#btnSavePool').attr("onclick","alert('Please Configure HDD POOL first')");
				window.parent.ShowSweetAlert('error','Error','Please Configure HDD POOL First');
				window.location.reload();
			}*/
			poolObject.AccelarationCache.Total = 0;
			$('#chkAccelaeration').attr('disabled',true);
			$('#divDisableFT').css('display','block');
			$('#imgTieringFastier').css('background-color','#ddd');		
			$('#divFT0').trigger( "click" );
			//$('#txtHDDProtected').hide();
			$('#txtDisks').hide();
			$('#divAccelaration').addClass('disabled');
		}
		else //when some pool is selected in edit or delete
		{
			if($('#hdnIsDeletePage').val())
			{
				$('#chkAccelaeration').attr('disabled',true);
				$('#chkCompression').attr('disabled',true);
				$('#chkDeduplication').attr('disabled',true);
				$('#chkEncryption').attr('disabled',true);
			}
			if(selectedPool !=null && selectedPool.length>0 && selectedPool[0].name=='HDD POOL')
			{
				$('#percentageHeading').text('HDD Perecenatge');
				poolObject.AvailableRaw = response.availableHDDStorage;
				poolObject.AvailableDisks = response.availableDisks;
				poolObject.AccelarationCache.Total = response.availableSSDStorage;
				//console.log("total = " +poolObject.AccelarationCache.Total);
				//hddAccelarationPercent = selectedPool[0].
				/*if($('#hdnIsDeletePage').val() && hddPool.length==1 && ssdPool.length>0){											//Restriction to Delete hdd before ssd
					window.parent.ShowSweetAlert('error','Error','You can not delete HDD Pool, Please delete SSD Pool First');
					window.location.reload();
					$('#btnDelete').attr("onclick","alert('Please delete HDD POOL first')");
				}*/
			}
			else if(selectedPool !=null && selectedPool.length>0 && selectedPool[0].name=='SSD POOL')
			{
				$('#percentageHeading').text('SSD Perecenatge');
				poolObject.AvailableRaw = response.availableSSDStorage;
				poolObject.AvailableDisks = response.availableDisks;
				poolObject.AccelarationCache.Total = 0;
			}
			else if(selectedPool !=null && selectedPool.length>0 && selectedPool[0].name=='NVMeOF POOL')
			{
				$('#percentageHeading').text('NVMeOF Perecenatge');
				poolObject.AvailableRaw = response.availableMVMeOFStorage;
				poolObject.AvailableDisks = response.availableDisks;
				poolObject.AccelarationCache.Total = response.availableSSDStorage;
			}
			else if(selectedPool !=null && selectedPool.length>0 && selectedPool[0].name=='iSCSI POOL')
			{
				$('#percentageHeading').text('iSTOR Perecenatge');
				poolObject.AvailableRaw = response.availableiSTORStorage;
				poolObject.AvailableDisks = response.availableDisks;
				poolObject.AccelarationCache.Total = response.availableSSDStorage;
			}
			else if(selectedPool !=null && selectedPool.length>0 && selectedPool[0].name=='MegaRAID POOL')
			{
				$('#percentageHeading').text('DISK Perecenatge');
				poolObject.AvailableRaw = response.availableMegaRAIDStorage;
				poolObject.AvailableDisks = response.availableDisks;
				poolObject.AccelarationCache.Total = 0;
			}
		}

		//when type1 pools is selected in edit or delete
		if(selectedPool !=null && selectedPool.length >0 && type1Pools.includes(selectedPool[0].name))
		{
			$('#percentageHeading').text('DISK Percentage');
			// $('#percentageHeading').text(selectedPool[0].name+ ' Percentage');

			var hddAccelarationPercent = selectedPool[0].acceleration;
			
			poolObject.AccelarationCache.ProtectionPercent = hddAccelarationPercent;
			//console.log("Level" + selectedPool[0].level);
			var SPid='#divSP'+selectedPool[0].level;
			var FTid = selectedPool[0].acceleration != 'No'? '#divFT'+hddAccelarationPercent:'#divFT'+0;
			var SFid = '#divSF'+selectedPool[0].percentage;

			
			$('#chkCompression').prop('checked', selectedPool[0].compression == 'Yes' ? true:false);
			$('#chkAccelaeration').prop('checked', selectedPool[0].acceleration > 0?true:false);
			$('#chkDeduplication').prop('checked', selectedPool[0].deduplication == 'Yes'?true:false);
			$('#chkEncryption').prop('checked', selectedPool[0].encryption == 'Yes'?true:false);
			//$('#spnStatus').text( poolType + ' Already configured, can edit in Edit Page');
			$('#spnStatus').text('');
			$('#divCreateStatus').show();

			if(poolObject.AccelarationCache.ProtectionPercent == 0)
				$('#spnAccelartionStatus').show();
			$('#divDisableSP').css('display','block');
			$('#imgStorageProtection').css('background-color','#ddd');	
			$('#divDisableSF').css('display','block');
			$('#imgHDDPercentage').css('background-color','#ddd');
			$('#divAccelaration').removeClass('disabled');
			if($('#hdnIsDeletePage').val())
			{
				$('#divDisableFT').css('display','block');
				$('#imgTieringFastier').css('background-color','#ddd');	
			}
			if($('#chkAccelaeration').is(":checked") == true){
				$('#divDisableFT').css('display','none');
				$('#imgTieringFastier').css('background-color','white');
				if(poolObject.AccelarationCache.ProtectionPercent == 0)
					$('#spnAccelartionStatus').show();
			}
			else{
				$('#divDisableFT').css('display','block');
				$('#imgTieringFastier').css('background-color','#ddd');		
				$('#divFT0').trigger( "click" );
			}
			if($('#hdnIsDeletePage').val())
			{
				$('#divDisableFT').css('display','block');
				$('#imgTieringFastier').css('background-color','#ddd');	
			}	
			
		}
		//type2 pools selected in edit or delete
		else if(selectedPool !=null && selectedPool.length >0 &&  type2Pools.includes(selectedPool[0].name))
		{
			$('#percentageHeading').text('DISK Percentage');
			// $('#percentageHeading').text(selectedPool[0].name+ ' Percentage');
			
			var SPid='#divSP'+selectedPool[0].level;
			var FTid = '#divFT0'
			var SFid = '#divSF'+selectedPool[0].percentage;
			$('#divSP0').trigger( "click" );
			
			$('#chkCompression').prop('checked', selectedPool[0].compression == 'Yes' ? true:false);
			//console.log( selectedPool[0].acceleration);
			$('#chkAccelaeration').prop('checked', selectedPool[0].acceleration > 0?true:false);
			//console.log( selectedPool[0].acceleration);
			$('#chkDeduplication').prop('checked', selectedPool[0].deduplication == 'Yes'?true:false);
			$('#chkEncryption').prop('checked', selectedPool[0].encryption == 'Yes'?true:false);
			//$('#spnStatus').text( poolType + ' Already configured, can edit in Edit Page');
			$('#spnStatus').text('');
			$('#divCreateStatus').show();

			$('#divDisableFT').css('display','block');					//disable all dials while editing ssd pools
			$('#imgTieringFastier').css('background-color','#ddd');		
			//$('#txtHDDProtected').hide();
			$('#txtDisks').hide();
			$('#divDisableSP').css('display','block');
			$('#imgStorageProtection').css('background-color','#ddd');	
			$('#divDisableSF').css('display','block');
			$('#imgHDDPercentage').css('background-color','#ddd');
			$('#chkAccelaeration').attr('disabled',true);

			$('#divAccelaration').addClass('disabled');
			if(selectedPool[0].name == 'MegaRAID POOL'  && !$('#hdnIsDeletePage').val() )
			{
				$('#percentageHeading').text('DISK Perecenatge');
				poolObject.AvailableRaw = response.availableMegaRAIDStorage;
				poolObject.AvailableDisks = response.availableDisks;
				$('#divSP2,#divSP3').addClass('custom-disabled');
				$('#imgStorageProtection').css('background-color','#fff');
				$('#divDisableSP').css('display','none');
			}
		}
		else{
			var SPid = '#divSP'+0;
			var FTid = '#divFT'+0;
			var SFid = '#divSF'+0;
			
			$('#chkCompression').prop('checked', false);
			$('#chkAccelaeration').prop('checked', false);
			$('#chkDeduplication').prop('checked', false);
			$('#chkEncryption').prop('checked', false);
			//$('#spnStatus').text('');
		}
		$(SPid).trigger( "click" );
		$(FTid).trigger( "click" );
		$(SFid).trigger( "click" );
		//$('#chkAccelaeration').trigger("change");
		
		ShowAvailableStorage();
	}//Type == "GetPool" ends here
	else if(Type == 'Delete')
	{
		GetPoolList();
		window.parent.GetAllDataBySelectedSection('StoragePools');
		window.parent.notify(response.description,response.description,response.status);
		location.reload();
	}
}

$('#chkAccelaeration').change(function(){
	if($('#chkAccelaeration').is(":checked") == true){
		$('#divDisableFT').css('display','none');
		$('#imgTieringFastier').css('background-color','white');
		if(poolObject.AccelarationCache.ProtectionPercent == 0)
			$('#spnAccelartionStatus').show();
	}
	else{
		$('#divDisableFT').css('display','block');
		$('#imgTieringFastier').css('background-color','#ddd');		
		$('#divFT0').trigger( "click" );
	}
	ShowAvailableStorage();
});

$('#ddlPoolType').change(function(){
	//console.log("Change Function called");
	var selectedPoolType = null;
	var poolType = $('#ddlPoolType').val();
	selectedPool = jQuery.grep(poolAliasName, function(n, i) { 
			return (n.systemName == poolType);
		});
	if(selectedPool.length > 0) {
		for(var i=0; i<selectedPool.length; i++)	 
		{	
			//console.log("Reached inside for loop");
			if(poolType === selectedPool[i].systemName) {
				$('#txtPoolName').val(selectedPool[i].systemName); //alias name
				OldName = selectedPool[i].systemName;
			} 
			selectedPoolType =  selectedPool[i].name;
		}
	}
	else {
		$('#txtPoolName').val('');
		$('#txtPoolName').focus();
	}
	
	if(poolType == 'Select Pool')
	{
		$('#txtHDDAvailable').hide();
		$('#txtSSDAvailable').hide();
		$('#txtDisks').hide();
		//$('#txtHDDProtected').hide();
		
	}else{
		$('#txtHDDAvailable').show();
		$('#txtSSDAvailable').show();
		$('#txtDisks').show();
		//$('#txtHDDProtected').show();
	}
	if(savedPools.indexOf(poolType) > -1 && $('#hdnIsCreatePage').val())
	{
		$('#btnSavePool').attr("onclick","alert('Already Configured')");
		//return false;
	}
	else if($('#hdnIsCreatePage').val())
	{
		$('#btnSavePool').attr("onclick","ShowConfirm()");
	}
	
	if($('#hdnIsEditPage').val())
	{
		if(poolType == 'Select Pool')
			$('.clsDisable').attr('disabled',true);
		else
			$('.clsDisable').attr('disabled',false);
		
		if(type1Pools.includes(poolType))
		{
			//console.log("Does it come here");
			 $('#chkAccelaeration').attr('disabled',false);
			 $('#divMainFT>.blank-Layer').hide();
		}
		else if(selectedPool.length>0 && type1Pools.includes(selectedPool[0].name))
		{
			//console.log("Does it come here");
			 $('#chkAccelaeration').attr('disabled',false);
			 $('#divMainFT>.blank-Layer').hide();
		}
		else
		{
			$('#chkAccelaeration').attr('disabled',true);
			$('#divMainFT>.blank-Layer').show();
		}
	}
		
	if(type2Pools.includes(poolType))
	{
		$('#divDisableFT').css('display','none');
		
		if(! $('#hdnIsEditPage').val()){
			$('#chkAccelaeration').attr('disabled',false);
			$('#divAccelaration').removeClass('disabled');
		}
		$('#chkAccelaeration').trigger("change");
		$('#txtSSDAvailable').show();
	}
	else if(selectedPool.length>0 &&  type1Pools.includes(selectedPool[0].name))
	{
		$('#divDisableFT').css('display','none');
		
		if(! $('#hdnIsEditPage').val()){
			$('#chkAccelaeration').attr('disabled',false);
			$('#divAccelaration').removeClass('disabled');
		}
		$('#chkAccelaeration').trigger("change");
		$('#txtSSDAvailable').show();
	}
	else
	{
		$('#divDisableFT').css('display','block');
		$('#divAccelaeration').addClass('disabled');
		$('#chkAccelaeration').prop("checked",false).attr('disabled',true);
	}
	GetPoolList(selectedPoolType);
});

function DeletePool()
{
	var poolType = $('#ddlPoolType').val();
	
	if( poolType == 'Select Pool')
	{
		alert('Please select Pool')
		return false;
	}
	
	var answer = confirm ("Are you sure Want to Delete "+ poolType + ', deleting the pool will lose all data ! click Ok to continue..');
	if (answer)
	{
		var request = new Request();
        request.url = "cgi/cgi_Setup_Pool_Manager.py";
        request.parameters = {            
			'PoolType':poolType,
			'RequestType':'delete_pool'
        };
        request.Type = "Delete";
        CallPythonService(request);     
	}
}
function SetTFDialPosition(dialType,SSDType)
{

	$('.clsTFBold').css('font-weight','normal');
	if(SSDType!=null)	
		poolObject.AccelarationCache.ProtectionPercent = parseInt(SSDType);
	var id='#divFT'+SSDType
	$(id).css('font-weight','bold');
	$('#spnAccelartionStatus').hide();
	
	//Innapropriate Value Error - Resets Storage Protection Level to 0
	/*if( poolObject.AccelarationCache.Total-poolObject.AccelarationCache.Selected <= 0 && $('#ddlPoolType').val() == 'HDD POOL' && poolObject.AvailableRaw - poolObject.Percentage.Total - poolObject.StorageProtection.Selected > 0)
	{
		if(!$('#hdnIsDeletePage').val()) {
			window.parent.ShowSweetAlert('error','Error','Inappropriate Acceleration Value!');	
			$('#divTF0').trigger( "click" );
		}
	}*/ 
	ShowAvailableStorage();
}
function SetSPDialPosition(dialType,levelType)
{
	var poolType = $('#ddlPoolType').val();
	selectedPool = jQuery.grep(poolAliasName, function(n, i) { 
		return (n.systemName == poolType);
	});
	$('.clsSPBold').css('font-weight','normal');
	if(levelType == 'zero')
	{
		$('#divSP0').css('font-weight','bold');	
		poolObject.StorageProtection.ProtectionLevel =0;
	}
	if(levelType == 'single')
	{
		$('#divSP1').css('font-weight','bold');	
		poolObject.StorageProtection.ProtectionLevel =1;
	}
	else if(levelType == 'double'){
		$('#divSP2').css('font-weight','bold');	
		poolObject.StorageProtection.ProtectionLevel=2;	
	}
	else if(levelType == 'triple'){
		$('#divSP3').css('font-weight','bold');	
		poolObject.StorageProtection.ProtectionLevel =3;	
	}
	ShowAvailableStorage();
}
function SetSFDialPosition(dialType,levelType)
{

	$('.clsSFBold').css('font-weight','normal');
	poolObject.Percentage.Selected = parseInt(levelType);
	$('#divSF'+levelType).css('font-weight','bold');
	ShowAvailableStorage();
}
function SavePool()
{
		var poolType = $('#ddlPoolType').val();
		if( poolType == 'Select Pool')
		{
			alert('Please select Pool')
			return false;
		}	
		var params={
		'PoolName': poolType,
		'Percentage':poolObject.Percentage.Selected,
		'PoolLevel': poolObject.StorageProtection.ProtectionLevel,
		'Compression':$('#chkCompression').is(":checked") == true? 'Yes':'No',
		//'Accelaration':poolObject.AccelarationCache.ProtectionPercent, //accelaration,
		'AccelerationPercent':poolObject.AccelarationCache.ProtectionPercent,
		'Deduplication':$('#chkDeduplication').is(":checked") == true? 'Yes':'No',
		'Encryption':$('#chkEncryption').is(":checked") == true? 'Yes':'No',
		'systemName':$('#txtPoolName').val(),
		'AvailableStorage':poolObject.AvailableRaw,
		'availableSSD':poolObject.AccelarationCache.Total,
		'RequestType':'create_pool'
		}
		//console.log("params : " + params['Percentage'] + " " + params['PoolLevel'] + " " + params['AccelerationPercent'] + " "+ params['Deduplication'] + " "+ params['systemName'] + " " );
	    var request = new Request();
        request.url = "cgi/cgi_Setup_Pool_Manager.py";
        request.parameters = params;
        request.Type = "CreatePool";
		CallPythonService(request);
		//console.log("calling python file");        
}
function ShowConfirm(type){
	var poolType = $('#ddlPoolType').val();
	var selected = jQuery.grep(poolAliasName, function(n, i) { 
			return (n.systemName == poolType);
		});
	if(poolObject.Percentage.Selected == 0)
	{
		window.parent.ShowSweetAlert('error','Error','Please choose more than 0% ');
		return false;
	}
	if(typePools.includes($('#txtPoolName').val()) || $('#txtPoolName').val() === "") // check if name is same as the pool types
	{
		window.parent.ShowSweetAlert('error','Error','Please choose a different name for the Pool ');
		
		$('#txtPoolName').trigger("click");
		$('#txtPoolName').focus();
		return false;
	}
	parent.$('#divWarningMsg').attr('class','alert alert-success');
	parent.$('#divWarningMsg').html('Do you want to Save Selected Configuration');
	
	if(type == 'UPDATE')
	{	
		parent.$('#lblCompression').text($('#chkCompression').is(":checked") == true? 'Yes':'No'); 
		parent.$('#lblDedup').text($('#chkDeduplication').is(":checked") == true? 'Yes':'No');
		parent.$('#lblEncryp').text($('#chkEncryption').is(":checked") == true? 'Yes':'No');
		parent.$('#divRawStorage').text(' Raw Storage');
		parent.$('#lblRawStorage').text('');
		parent.$('#lblProtection').text(''); 		
		parent.$('#btnConfirmYes').attr('onclick','window.frames[0].UpdatePool()');
		if(poolObject.AccelarationCache.ProtectionPercent > 0) 
			parent.$('#lblAccPercent').text(poolObject.AccelarationCache.ProtectionPercent + "%");
		else
		{
			if(poolType=='HDD POOL' || (selected.length>0 && selected[0].name=='HDD POOL'))
				parent.$('#lblAccPercent').text('No');
			else
				parent.$('#lblAccPercent').text('N/A');
		}	
	}
	else
	{
		if(poolObject.StorageProtection.ProtectionLevel == 0)
		{
			parent.$('#divWarningMsg').attr('class','alert alert-danger');
			parent.$('#divWarningMsg').html('Are You Sure !! Want to Save the Pool with NONE Protection ??');
			parent.$('#divRawStorage').text(' Raw Storage Percentage');
			parent.$('#lblProtection').text('No Protection');
			
		}
		else
		{
			parent.$('#divRawStorage').text(' Protected Storage Percentage');
			parent.$('#lblProtection').text(poolObject.StorageProtection.ProtectionLevel + ' Level');
		}
		parent.$('#lblCompression').text($('#chkCompression').is(":checked") == true? 'Yes':'No'); 
		parent.$('#lblDedup').text($('#chkDeduplication').is(":checked") == true? 'Yes':'No');
		parent.$('#lblEncryp').text($('#chkEncryption').is(":checked") == true? 'Yes':'No');
		parent.$('#lblRawStorage').text(poolObject.Percentage.Selected + ' %'); 
		
		if(poolObject.AccelarationCache.ProtectionPercent > 0) 
			parent.$('#lblAccPercent').text(poolObject.AccelarationCache.ProtectionPercent + '%');
		else
		{
			//console.log("inside hdd ssd check");
			if(poolType=='HDD POOL' || (selected.length>0 && selected[0].name=='HDD POOL'))
				parent.$('#lblAccPercent').text('No');
			else
				parent.$('#lblAccPercent').text('N/A');
		}	
		parent.$('#btnConfirmYes').attr('onclick','window.frames[0].SavePool()');
	}
	parent.$('#confirmSetupPoolPopup').modal('show');
}
function UpdatePool()
{
	var poolType = $('#ddlPoolType').val();
	if( poolType == 'Select Pool')
	{
		alert('Please select Pool')
		return false;
	}
	var params={
			'PoolName': poolType, 
			'Compression':$('#chkCompression').is(":checked") == true? 'Yes':'No',
			'Deduplication':$('#chkDeduplication').is(":checked") == true? 'Yes':'No',
			'Encryption':$('#chkEncryption').is(":checked") == true? 'Yes':'No',
			'systemName':$('#txtPoolName').val(),
			'AccelerationPercent':poolObject.AccelarationCache.ProtectionPercent,
			'RequestType':'update_pool',
			}
	var request = new Request();
	request.url = "cgi/cgi_Setup_Pool_Manager.py";
	request.parameters = params;
	request.Type = "CreatePool";
	CallPythonService(request); 
}
function GetPoolList(selectedPoolType=null)
{
	if(selectedPoolType==null)
		var poolType = $('#ddlPoolType').val()==""? " ":$('#ddlPoolType').val();
	else
		var poolType = selectedPoolType;
	var request=new Request();
	request.url = "cgi/cgi_Setup_Pool_Manager.py";
	request.Type = 'GetPool';
	request.parameters = { 
		"RequestType": "read_pool",
		"PoolType":poolType      
	};
	CallPythonService(request);
}