#!/usr/bin/python3
#date -d @1234567890
#sudo nano /etc/collectd/collectd.conf
import cgi, cgitb

cgitb.enable()
import sqlite3
import json
import os
import time
import sys
import rrdtool
import subprocess
from db import *

true=1
false=0
GUI=true
CCM=false

def Metrics(Mtype,arg):
    deviceMetrics = []
    if Mtype == 'M':
        if arg=="GUI":
            deviceMetrics = ['memory-buffered.rrd', 'memory-cached.rrd', 'memory-free.rrd', 'memory-slab_recl.rrd',
            'memory-slab_unrecl.rrd', 'memory-used.rrd']
        else:
            deviceMetrics = ['memory-buffered.rrd', 'memory-cached.rrd', 'memory-free.rrd', 'memory-slab_recl.rrd',
            'memory-slab_unrecl.rrd', 'memory-used.rrd']
        
    elif Mtype == 'L':
        if arg=="GUI":
            deviceMetrics = ['load.rrd']
        else:
            deviceMetrics = ['load.rrd']
            
    elif Mtype == "PO":
        if arg=="GUI":
            deviceMetrics = ['free space', 'reserved space', 'used space']
        else:
            deviceMetrics = ['df_complex-free.rrd', 'df_complex-reserved.rrd', 'df_complex-used.rrd']
    elif Mtype == 'C':
        if arg=="GUI":
            deviceMetrics = ['cpu-idle.rrd', 'cpu-interrupt.rrd', 'cpu-nice.rrd', 'cpu-softirq.rrd',
            'cpu-steal.rrd', 'cpu-system.rrd', 'cpu-user.rrd', 'cpu-wait.rrd']
        else:                 
            deviceMetrics = ['cpu-idle.rrd', 'cpu-interrupt.rrd', 'cpu-nice.rrd', 'cpu-softirq.rrd',
            'cpu-steal.rrd', 'cpu-system.rrd', 'cpu-user.rrd', 'cpu-wait.rrd']                         
    elif Mtype == 'P':
        if arg=="GUI":
            deviceMetrics = ['RX-TX packets', 'RX-TX bytes', 'RX-TX errors']        
        else:
            deviceMetrics = ['if_packets.rrd', 'if_octets.rrd', 'if_errors.rrd']
            
    elif Mtype == 'D':
        if arg=="GUI":
            deviceMetrics = ['IO', 'Merged', 'Rd-Wr data', 'Operations' , 'Time', 'Pending']        
        else:
            deviceMetrics = ['disk_io_time.rrd', 'disk_merged.rrd', 'disk_octets.rrd', 'disk_ops.rrd', 'disk_time.rrd', 'pending_operations.rrd']

    elif Mtype == "F":
        if arg == "GUI":
            deviceMetrics = ["fan.rrd"]
        else:
            deviceMetrics = ["fan.rrd"]

    elif Mtype == "T":
        if arg == "GUI":
            deviceMetrics = ["temp_probes.rrd"]
        else:
            deviceMetrics = ["temp_probes.rrd"]

    elif Mtype == "PS":
        if arg=="GUI":
            deviceMetrics = ["psu.rrd"]
        else:
            deviceMetrics = ["psu.rrd"]

    elif Mtype == "docker":
        if arg=="GUI":
            deviceMetrics = ["cpu-usage.rrd","storage-rd.rrd","storage-wr.rrd","network-rd.rrd","network-wr.rrd"]
        else:
            deviceMetrics = ["cpu-usage.rrd","storage-rd.rrd","storage-wr.rrd","network-rd.rrd","network-wr.rrd"]
            
    else:
        deviceMetrics = ['None defined']

        
    return deviceMetrics

if GUI==true:
    import cgi,cgitb
    cgitb.enable()
    
if GUI==true:
    form = cgi.FieldStorage()
    request_Type=form.getvalue('requestType')
    deviceList = form.getvalue('deviceList')
    scale = form.getvalue('scale')
    NumHorizontal_points_in_graph = form.getvalue('NumHorizontal_points_in_graph')
    metrics = form.getvalue('metrics')
else:

    MetricChoices=[]
    print('1. minutes')
    print('2. hours')
    print('3. days')
    print('4. weeks')
    print('5. months')
    choice=int(input("select TimeBase==>"))
    if (choice==1):
        scale = "mins"
        NumHorizontal_points_in_graph = 10
    if (choice==2):
        scale = "hours"
        NumHorizontal_points_in_graph = 60
    if (choice==3):
        scale = "days"
        NumHorizontal_points_in_graph = 60
    if (choice==4):
        scale = "weeks"
        NumHorizontal_points_in_graph = 60
    if (choice==5):
        NumHorizontal_points_in_graph = 60
        scale = "months"
    print('1. Disk Stats')
    print('2. Volume Stats')
    print('3. Pool Stats')
    print('4. Ethernet Stats')
    print('5. Virtual Disk Stats')
    print('6. CPU stats')
    print('7. CPU stats')
    print('8 CPU stats')
    print('9. Fan Stats')
    print('10. Temp_Probe Stats')
    print('11. PSU Stats')
    print('12.DisksRRD Stats')
    print('13.CPURRD stats')
    choice=int(input("select cgi function==>"))
    if (choice==1):
        request_Type='D'
        deviceList ='D'
        MetricChoices=Metrics(deviceList,'GUI')
        print(MetricChoices)
        choice=int(input("select Metric==>"))
        metrics=MetricChoices[choice]
    elif (choice==2):
        request_Type='V'
        deviceList ='V'
    elif (choice==3):
        request_Type='PO'
        deviceList ='PO'
    elif (choice==4):
        request_Type='P'
        deviceList ='P'
    if (choice==5):
        request_Type='VD'
        deviceList ='VD'
    elif (choice==6):
        request_Type='read_CPU'
        deviceList ='C'
        MetricChoices=Metrics(deviceList,'GUI')
        print(MetricChoices)
        choice=int(input("select Metric==>"))
        metrics=MetricChoices[choice]
    elif (choice==7):
        request_Type='read_CPU'
        deviceList ='C'
        MetricChoices=Metrics(deviceList,'GUI')
        print(MetricChoices)
        choice=int(input("select Metric==>"))
        metrics=MetricChoices[choice]
    elif (choice==8):
        request_Type='read_CPU'
        deviceList ='C'
        MetricChoices=Metrics(deviceList,'GUI')
        print(MetricChoices)
        choice=int(input("select Metric==>"))
        metrics=MetricChoices[choice]
    
    elif (choice==9):
        request_Type = "F"
        deviceList = "F"
        MetricChoices = Metrics(deviceList,'GUI')
        print(MetricChoices)
    elif (choice==10):
        request_Type = "T"
        deviceList = "T"
        MetricChoices = Metrics(deviceList,'GUI')
        print(MetricChoices)
    elif (choice==11):
        request_Type = "PS"
        deviceList = "PS"
        MetricChoices = Metrics(deviceList,'GUI')
        print(MetricChoices)
    elif (choice==12):
        request_Type='M'
        deviceList ='M'
        MetricChoices=Metrics(deviceList,'GUI')
        print(MetricChoices)
    elif (choice==13):
        request_Type='CP'
        deviceList ='CP'
        MetricChoices=Metrics(deviceList,'GUI')
        print(MetricChoices)


    print("Request_Type="+str(request_Type))

retentionMins = 60
minutesPerPoint=6

if scale == "mins":
    retentionMins = 60
    minutesPerPoint=6
elif scale == "hours":
    retentionMins = 24 * 60
    minutesPerPoint=30
elif scale == "days":
    retentionMins = int (7 * 24 * 60)
    minutesPerPoint=int (6*60)
elif scale == "weeks":
    retentionMins = int(4*7*24*60)
    minutesPerPoint=int (7*6*60)


def guiDeviceResult(rrdPath,rrdFile,deviceList,GUIdeviceList):
    result_all = dict()
    #minutesPerPoint = retentionMins / int(NumHorizontal_points_in_graph)
    retentionSecs = retentionMins * 60
    #rrdPath = "/var/lib/collectd/rrd/ubuntu"
    i=0
    for device in deviceList:
        rrdDevice = device
        if rrdFile == " ":
            DataFile = rrdPath + "/" + rrdDevice
        else:
            DataFile = rrdPath + rrdDevice + "/" + rrdFile
        now = int(time.time())
        now=now-60
        startTime = now - retentionSecs
        endTime = now
        secondsPerPoint = minutesPerPoint * 60
        startTime=int (startTime/minutesPerPoint)
        startTime=int (startTime*minutesPerPoint)
        endTime=int (endTime/minutesPerPoint)
        endTime=int (endTime*minutesPerPoint)
        (timeInfo, columns, rows) = rrdtool.fetch(DataFile, 'AVERAGE', '-r', str(secondsPerPoint), '-s',
                                                  str(startTime), '-e', str(endTime))
        rows.pop()  # remove the last datapoint because RRD sometimes gives funky values
        #print "printing timeInfo"
        #print timeInfo
        colWidth = len(columns)
        # print "column width=" + str(colWidth)
        # print columns
        #rows.pop()
        #rows.pop
        lenRows = len(rows)
        # print "length of rows =" + str(lenRows)
        # print "column width=" + str(len(columns))
        # print columns
        result = []
        epoch_range = dict()
        epoch_range['epoch_range'] = list(timeInfo)
        result.append(epoch_range)
        cols = dict()
        cols['columns']=columns
        result.append(cols)
        # print len(rows)
        for row in rows:
            # print row
            # print row[0]
            temp = dict()
            if row[0] == None:
                continue
            if (colWidth == 1):
                temp['val1'] = round(float(row[0]), 2)
            if (colWidth == 2):
                temp['val1'] = round(float(row[0]), 2)
                temp['val2'] = round(float(row[1]), 2)
            if (colWidth == 3):
                temp['val1'] = round(float(row[0]), 2)
                temp['val2'] = round(float(row[1]), 2)
                temp['val3'] = round(float(row[2]), 2)
            if (colWidth == 4):
                temp['val1'] = round(float(row[0]), 2)
                temp['val2'] = round(float(row[1]), 2)
                temp['val3'] = round(float(row[2]), 2)
                temp['val4'] = round(float(row[3]), 2)
            if (colWidth > 4):
                temp['row'] = row
            result.append(temp)
        GUIdevice=GUIdeviceList[i]
        i=i+1
        result_all[GUIdevice] = result
    return result_all

def Get_rrdFilesPath():
    #rrdPath = "/home/pilot"
    rrdPath = "/var/www/sanuyi_rrdFiles"
    return rrdPath
    
def Get_rrdPath():
    process1 = subprocess.check_output(["hostname"])
    process1 = process1.replace("\r", "")
    process1 = process1.replace("\n", "")          
    path = "/var/lib/collectd/rrd/"+process1+"/"
    return path

def EpochToTime(epoch):
    mytime = time.strftime('%Y-%m-%d %H:%M:%S', time.localtime(epoch))
    # print mytime

def GetSlot(device):

    if device=="sda":
        return "slot1"
    elif device=="sdb":
        return "slot2"
    elif device=="sdc":
        return "slot3"
    elif device=="sdd":
        return "slot4"
    elif device=="sde":
        return "slot5"
    elif device=="sdf":
        return "slot6"
    elif device=="sdg":
        return "slot7"
    elif device=="sdh":
        return "slot8"
    elif device=="sdi":
        return "slot9"
    elif device=="sdj":
        return "slot10"
    return "slotx"
    
def get_Metrics(Mtype):
    deviceMetrics = []
    arg="GUI"
    deviceMetrics=Metrics(Mtype,arg)
    result = {"metrics": deviceMetrics}
    print(json.JSONEncoder().encode(result))
    

def read_rrd_cpu():
    minutesPerPoint = retentionMins / int(NumHorizontal_points_in_graph)
    retentionSecs = retentionMins * 60
    rrdPath = "/var/lib/collectd/rrd/ubuntu/"
    #metrics = form.getvalue('metrics')
    metrics_Str = str(metrics) 
    result_all = dict()
    ls = subprocess.Popen(["ls", "-p", "/var/lib/collectd/rrd/ubuntu/"], stdout=subprocess.PIPE, )
    grep = subprocess.Popen(["grep", "cpu-"], stdin=ls.stdout, stdout=subprocess.PIPE, )
    endOfPipe = grep.stdout
    for line in endOfPipe:
        #     print (line)
        # for i in range(0,5):
        cpu = str(line)[:-1]
        abs_Path = rrdPath + cpu + metrics_Str +".rrd"
        #print "Printing abs_Path:", abs_Path
        now = int(time.time())
        now = now - 60
        startTime = str(now - retentionSecs)
        endTime = str(now)
        secondsPerPoint = minutesPerPoint * 60
        NumPoints = retentionSecs / secondsPerPoint
        # print ("number of points=" + str(NumPoints))
        (timeInfo, columns, rows) = rrdtool.fetch(abs_Path, 'AVERAGE', '-r', str(secondsPerPoint), '-s',
                                                  startTime, '-e', endTime)
        rows.pop()  # remove the last datapoint because RRD sometimes gives funky values
        # print "printing data"
        # print timeInfo
        colWidth = len(columns)
        # print "column width=" + str(colWidth)
        # print columns
        rows.pop
        rows.pop
        lenRows = len(rows)
        # print "length of rows =" + str(lenRows)
        # print "column width=" + str(len(columns))
        # print columns
        result = []
        epoch_range = dict()
        epoch_range['epoch_range'] = list(timeInfo)
        result.append(epoch_range)

       	cols=dict()
	cols["columns"]=columns
	result.append(cols)
	# print len(rows)
        
	for row in rows:
            #print row
            # print row[0]
            temp = dict()
            if row[0] == None:
                continue
            if (colWidth == 1):
                temp['val1'] = round(float(row[0]), 2)
            if (colWidth == 2):
                temp['val1'] = round(float(row[0]), 2)
                temp['val2'] = round(float(row[1]), 2)
            if (colWidth == 3):
                temp['val1'] = round(float(row[0]), 2)
                temp['val2'] = round(float(row[1]), 2)
                temp['val3'] = round(float(row[2]), 2)
            if (colWidth == 4):
                temp['val1'] = round(float(row[0]), 2)
                temp['val2'] = round(float(row[1]), 2)
                temp['val3'] = round(float(row[2]), 2)
                temp['val4'] = round(float(row[3]), 2)
                
            if (colWidth > 4):
                temp['row'] = row

            result.append(temp)
        result_all[cpu[:-1]] = result

        # result =  json.dumps(result)

    print(json.JSONEncoder().encode(result_all))
    # print result

def DB_Interfaces():
    EthList=[]
    GuiList=[]
    conn=sqlite3.connect(db_filename,check_same_thread=False)
    conn.text_factory=str
    c=conn.cursor()
    query=c.execute("select system_name,name from eth_ports")
    interfaces=c.fetchall()
    for eth in interfaces:
        if str(eth[0])!="null":
            device="interface-"+eth[0]
            EthList.append(device)
            device=eth[1]
            GuiList.append(device)
    #query=c.execute("select name from eth_ports")
    #names=c.fetchall()
    #for eth in names:
        #device=eth[0]
        #GuiList.append(device)
    c.close()
    return EthList,GuiList

def read_rrd_eth():
    rrdPath=Get_rrdPath()
    #metrics = form.getvalue('metrics')
    #Check what user has selected 
    rrdFile="if_octets.rrd"
    if "bytes" in str (metrics):
        rrdFile="if_octets.rrd"  
    if "packets" in str (metrics):
        rrdFile="if_packets.rrd"  
    if "errors" in str (metrics):
        rrdFile="if_errors.rrd"  
    result_all = dict()
    deviceList =DB_Interfaces()[0] 
    GUIdeviceList = DB_Interfaces()[1]
   
    result_all=guiDeviceResult(rrdPath,rrdFile,deviceList,GUIdeviceList)
    print(json.JSONEncoder().encode(result_all))

def read_rrd_pools():
    rrdPath=Get_rrdPath()
    #metrics = form.getvalue('metrics')
    #Check what user has selected 
    rrdFile="df_complex-used.rrd"   # default value
    if "free" in str (metrics):
        rrdFile="df_complex-free.rrd"  
    if "reserved" in str (metrics):
        rrdFile="df_complex-reserved.rrd"  
    if "used" in str (metrics):
        rrdFile="df_complex-used.rrd"  
    result_all = dict()
    GUIdeviceList=[]
    deviceList=[]
    ls = subprocess.Popen(["ls", "-p", "/var/lib/collectd/rrd/ubuntu/"], stdout=subprocess.PIPE, )
    grep = subprocess.Popen(["grep", "df-p2-"], stdin=ls.stdout, stdout=subprocess.PIPE, )
    endOfPipe = grep.stdout
    for line in endOfPipe:
        device = str(line)[:-2]
        deviceList.append(device)
        GUIdeviceList.append(device)
    result_all=guiDeviceResult(rrdPath,rrdFile,deviceList,GUIdeviceList)
    print(json.JSONEncoder().encode(result_all))

def read_rrd_disks():
    rrdPath=Get_rrdPath()
    #metrics = form.getvalue('metrics')
    rrdFile="disk_io_time.rrd"   # default value

    if "IO" in str (metrics):
        rrdFile="disk_io_time.rrd"  
    elif "Merged" in str (metrics):
        rrdFile="disk_merged.rrd"
    elif "Rd-Wr" in str (metrics):
        rrdFile="disk_octets.rrd"
    elif "Operations" in str (metrics):
        rrdFile="disk_ops.rrd"
    elif "Time" in str (metrics):
        rrdFile="disk_time.rrd"
    elif "Pending" in str (metrics):
        rrdFile="pending_operations.rrd"  

    result_all = dict()
    GUIdeviceList=[]
    deviceList=[]
    ls = subprocess.Popen(["ls", "-p", "/var/lib/collectd/rrd/ubuntu/"], stdout=subprocess.PIPE, )
    #ls -p /var/lib/collectd/rrd/ubuntu/
    grep = subprocess.Popen(["grep", "disk-"], stdin=ls.stdout, stdout=subprocess.PIPE, )
    endOfPipe = grep.stdout
    for line in endOfPipe:
        device = str(line)[:-2] # remove \ and lf
        if device[5:].isalpha():
            #print "device=",device[5:]
            deviceList.append(device)
            slot=GetSlot(device[5:])
            GUIdeviceList.append(slot)
    result_all=guiDeviceResult(rrdPath,rrdFile,deviceList,GUIdeviceList)
    print(json.JSONEncoder().encode(result_all))

def read_psu():
    deviceList = ["psu.rrd"]   
    
    rrdPath=Get_rrdFilesPath()
    

    #metrics = form.getvalue('metrics')
    rrdFile="psu.rrd"
    GUIdeviceList=[]
    GUIdeviceList.append("PSU")
    result_all = guiDeviceResult(rrdPath," ",deviceList,GUIdeviceList)
    #result_all=guiDeviceResult(rrdPath,deviceList,GUIdeviceList)
    print(json.JSONEncoder().encode(result_all))

def read_temp():

    deviceList = ["temp_probes.rrd"]
    
    rrdPath=Get_rrdFilesPath()
    #metrics = form.getvalue('metrics')
    #rrdFile=tempRRD
    GUIdeviceList=[]
    GUIdeviceList.append("Temperature")
    result_all = guiDeviceResult(rrdPath," ",deviceList,GUIdeviceList)
    print(json.JSONEncoder().encode(result_all))

def read_fan():

    deviceList = ["fan.rrd"]
    
    rrdPath=Get_rrdFilesPath()
    #metrics = form.getvalue('metrics')
    #rrdFile=tempRRD
    GUIdeviceList=[]
    GUIdeviceList.append("Fan")
    result_all = guiDeviceResult(rrdPath," ",deviceList,GUIdeviceList)
    print(json.JSONEncoder().encode(result_all))

def read_disks():
    deviceList = ["disks.rrd"]
    
    
    rrdPath=Get_rrdFilesPath()
    
    #metrics = form.getvalue('metrics')
    #rrdFile=driveRRD
    GUIdeviceList=[]
    GUIdeviceList.append("Disks")
    result_all = guiDeviceResult(rrdPath," ",deviceList,GUIdeviceList)
    print(json.JSONEncoder().encode(result_all))

def read_cpu():
    deviceList = ["cpu.rrd"]
    
    
    rrdPath=Get_rrdFilesPath()
    
    #metrics = form.getvalue('metrics')
    #rrdFile=driveRRD
    GUIdeviceList=[]
    GUIdeviceList.append("CPU")
    result_all = guiDeviceResult(rrdPath," ",deviceList,GUIdeviceList)
    print(json.JSONEncoder().encode(result_all))

def read_docker():
    deviceList = ["X.rrd"]
    rrdPath=Get_rrdFilesPath()
    #metrics = form.getvalue('metrics')
    #rrdFile=driveRRD
    GUIdeviceList=[]
    GUIdeviceList.append("Docker")
    result_all = guiDeviceResult(rrdPath," ",deviceList,GUIdeviceList)
    print(json.JSONEncoder().encode(result_all))

def get_Apps(deviceList):
    apps = []
    if deviceList == 'docker':
        query=c.execute("select name from virtualmachine where type=?",[deviceList])
        for col in c:
            apps.append(col[0])

    else:
        query=c.execute("select name from virtualmachine where type!='docker'")
        for col in c:
            apps.append(col[0])
    conn.close()
    print(json.JSONEncoder().encode(apps))



print("Content-type:text/html\r\n\r\n")

if request_Type == 'get_Metrics':
    get_Metrics(deviceList)
#elif request_Type == 'C':
#    read_rrd_cpu()
elif request_Type=='get_Apps':
    get_Apps(deviceList)
elif request_Type == 'P':
    read_rrd_eth()
elif request_Type == 'PO':
    read_rrd_pools()
elif request_Type == 'D':  #Divya for each stat type put in the correct type and call a function.
    read_rrd_disks()
elif request_Type == 'PS':
    read_psu()
elif request_Type == 'T':
    read_temp()
elif request_Type == "F":
    read_fan()
elif request_Type == "M":
    read_disks()
elif request_Type == "C":
    read_cpu()
elif request_Type == "docker":
    read_docker()



