#!/usr/bin/python3

import cgi, cgitb
from global_gui_data import *
from globalSettings import *
from global_func import *
from smartData import *
import json
from db import *

cgitb.enable()
import sqlite3
form=cgi.FieldStorage()

request_Type=form.getvalue('requestType')

def read_StatusAll():
	query = c.execute("SELECT name,state,speed,low_threshold,hi_threshold from fan")
	fandata = []
	conn.commit()
	for col in c:
		fandata.append(col[1])

	query = c.execute("SELECT name,state from cpu")
	cpudata=[]
	conn.commit()
	for col in c:
		jsonschema = {"name" : "cpu","state" :col[1]}
		cpudata.append(col[1])
	
	query = c.execute("SELECT name,state,temp,low_threshold,hi_threshold from temp_probes")
	temp_probesdata=[]
	conn.commit()
	for col in c:
		jsonschema = {"name" : "temp_probes","state" :col[1]}
		temp_probesdata.append(col[1])

	query = c.execute("SELECT name,state,speed,ip,netmask,port_id from eth_ports")
	networkdata=[]
	conn.commit()
	for col in c:
		jsonschema = {"name" : "network","state" :col[1]}
		networkdata.append(col[1])

	query = c.execute("SELECT name,state,ac_status,dc_status from psu")
	psudata=[]
	conn.commit()
	for col in c:
		jsonschema = {"name" : "psu","state" :col[1]}
		psudata.append(col[1])

	query = c.execute("SELECT name,state,ac_status,dc_status from psu where name='PSU_1'")
	psudata1=[]
	conn.commit()
	for col in c:
		jsonschema = {"name" : "psu","state" :col[1]}
		psudata1.append(col[1])

	query = c.execute("SELECT name,state,ac_status,dc_status from psu where name='PSU_2'")
	psudata2=[]
	conn.commit()
	for col in c:
		jsonschema = {"name" : "psu","state" :col[1]}
		psudata2.append(col[1])

	query = c.execute("SELECT name,state,vid,pid,prl,serial,size from disks")
	disksdata=[]
	conn.commit()
	for col in c:
		jsonschema = {"name" : "disks","state" :col[1]}
		disksdata.append(col[1])
	conn.close()
	print(json.JSONEncoder().encode({"fans":fandata,"cpu":cpudata,"network":networkdata,"psu":psudata,"psu1":psudata1,"psu2":psudata2,"disks":disksdata,"temp_probes":temp_probesdata}))

def read_StatusFan():
	query = c.execute("SELECT name,state,speed,low_threshold,hi_threshold from fan")
	dbdata = []
	conn.commit()
	for col in c:
		jsonschema = {"name" : col[0],"state" :col[1],"speed" : col[2],"low_threshold" : col[3],"hi_threshold" :col[4]}
		dbdata.append(jsonschema)
	conn.close()
	print(json.JSONEncoder().encode(dbdata))

def read_StatusTemp_probes():
	query = c.execute("SELECT name,state,temp,low_threshold,hi_threshold from temp_probes")
	dbdata = []
	conn.commit()
	for col in c:
		jsonschema = {"name" : col[0],"state" :col[1],"temp" : col[2],"low_threshold" : col[3],"hi_threshold" :col[4]}
		dbdata.append(jsonschema)
	conn.close()
	print(json.JSONEncoder().encode(dbdata))
	
def read_StatusCPU():
	'''query = c.execute("SELECT name,state,temp,low_threshold,hi_threshold from temp_probes")
	dbdata = []
	conn.commit()
	for col in c:
		jsonschema = {"name" : col[0],"state" :col[1],"temp" : col[2],"low_threshold" : col[3],"hi_threshold" :col[4]}
		dbdata.append(jsonschema)
	conn.close()
	print json.JSONEncoder().encode(dbdata)'''

	query = c.execute("SELECT cpu.name,cpu.state,cpu.controller_id,(case when cpu.location is NULL then 'N/A' else cpu.location end)location,\
		(case when cpu.cores is NULL then 'N/A' else cpu.cores end)cores,(case when cpu.cache_Size is NULL then 'N/A' else cpu.cache_Size end),\
			(case when cpu.temperature is NULL then 'N/A' else cpu.temperature end),(case when cpu.vendorId is NULL then 'N/A' else cpu.vendorId end),\
				(case when cpu.modelNum is NULL then 'N/A' else cpu.modelNum end),(case when cpu.cpu_Mhz is NULL then 'N/A' else cpu.cpu_Mhz end),controller.name from cpu inner join controller on controller.id=cpu.controller_id")
	dbdata = []
	conn.commit()
	for col in c:
		jsonschema = {"name" : col[0],"state" :col[1],"controllerName" : col[10],"location" : col[3],"cores" :col[4],"cacheSize":col[5],"temperature":col[6],"vendorId":col[7],"modelNum":col[8],"cpuMhz":col[9]}
		dbdata.append(jsonschema)
	conn.close()
	print(json.JSONEncoder().encode(dbdata))
	
def read_StatusNetwork():
	query = c.execute("SELECT name,state,speed,ip,netmask,port_id from eth_ports")
	dbdata = []
	conn.commit()
	for col in c:
		jsonschema = {"name" : col[0],"state" :col[1],"speed" : col[2],"ip" : col[3],"netmask" :col[4],"port_id" :col[5]}
		dbdata.append(jsonschema)
	conn.close()
	print(json.JSONEncoder().encode(dbdata))

def read_StatusPSU():
	query = c.execute("SELECT name,state,ac_status,dc_status from psu")
	dbdata = []
	conn.commit()
	for col in c:
		jsonschema = {"name" : col[0],"state" :col[1],"ac_status" : col[2],"dc_status" : col[3]}
		dbdata.append(jsonschema)
	conn.close()
	print(json.JSONEncoder().encode(dbdata))

def read_StatusPSU1():
	query = c.execute("SELECT name,state,ac_status,dc_status from psu where name='PSU_1'")
	dbdata = []
	conn.commit()
	for col in c:
		jsonschema = {"name" : col[0],"state" :col[1],"ac_status" : col[2],"dc_status" : col[3]}
		dbdata.append(jsonschema)
	conn.close()
	print(json.JSONEncoder().encode(dbdata))

def read_StatusPSU2():
	query = c.execute("SELECT name,state,ac_status,dc_status from psu where name='PSU_2'")
	dbdata = []
	conn.commit()
	for col in c:
		jsonschema = {"name" : col[0],"state" :col[1],"ac_status" : col[2],"dc_status" : col[3]}
		dbdata.append(jsonschema)
	conn.close()
	print(json.JSONEncoder().encode(dbdata))

def read_StatusDisks():	
	query = c.execute("SELECT name,state,vid,pid,prl,serial,size,id,location,wwn,(case when rotation=0 then 'SSD' else 'HDD' end) rotation from disks")
	dbdata = []
	conn.commit()
	for col in c:
		jsonschema = {"name" : col[0],"state" :col[1],"vid" : col[2],"pid" : col[3],"prl" :col[4],"serial" :col[5],"size" :col[6],"id":col[7],"location":col[8],"wwn":col[9],"rotation":col[10],"status":"OK"}
		dbdata.append(jsonschema)
	conn.close()
	print(json.JSONEncoder().encode(dbdata))

def read_DisksSMART_Data():
	mockdata	= [{"id":0,"headerData":{"HealthStatus":"Normal","Temprature":"53deg C","TestResult":"Success","SectorErrorCount":89},"Attributes":[{"Name":"Start/Stop Count","value":"3","Normalized":"26","Threshold":"1","worst":"99","Type":"Old Age","Assessment":"OK"},{"Name":"Spin Retry Count","value":"35","Normalized":"66","Threshold":"6","worst":"99","Type":"Pre Fail","Assessment":"OK"},{"Name":"Power On Time","value":"3","Normalized":"66","Threshold":"9","worst":"99","Type":"Pre Fail","Assessment":"OK"},{"Name":"Read error Rate","value":"3","Normalized":"66","Threshold":"9","worst":"99","Type":"Pre Fail","Assessment":"OK"},{"Name":"Seek error rate","value":"3","Normalized":"66","Threshold":"9","worst":"99","Type":"Pre Fail","Assessment":"OK"},{"Name":"Power On errors","value":"3","Normalized":"45","Threshold":"9","worst":"87","Type":"Pre Fail","Assessment":"OK"},{"Name":"SSD Erase fail count","value":"44","Normalized":"37","Threshold":"99","worst":"7","Type":"Pre Fail","Assessment":"OK"},{"Name":"Power loss protection failure","value":"32","Normalized":"66","Threshold":"9","worst":"99","Type":"Pre Fail","Assessment":"OK"},{"Name":"Head stablility","value":"34","Normalized":"66","Threshold":"9","worst":"80","Type":"Pre Fail","Assessment":"OK"},{"Name":"High fly writes","value":"3","Normalized":"66","Threshold":"9","worst":"99","Type":"Pre Fail","Assessment":"OK"},{"Name":"Load cycle count","value":"3","Normalized":"66","Threshold":"9","worst":"99","Type":"Pre Fail","Assessment":"OK"},{"Name":"G sense error rate","value":"3","Normalized":"1","Threshold":"9","worst":"99","Type":"Pre Fail","Assessment":"Fail"}]},
				   {"id":1,"headerData":{"HealthStatus":"Good","Temprature":"4deg C","TestResult":"Success","SectorErrorCount":50},"Attributes":[{"Name":"Start/Stop Count","value":"3","Normalized":"26","Threshold":"1","worst":"99","Type":"Old Age","Assessment":"OK"},{"Name":"Spin Retry Count","value":"8","Normalized":"66","Threshold":"6","worst":"99","Type":"Pre Fail","Assessment":"OK"},{"Name":"Power On Time","value":"3","Normalized":"66","Threshold":"9","worst":"99","Type":"Pre Fail","Assessment":"OK"},{"Name":"Read error Rate","value":"3","Normalized":"66","Threshold":"9","worst":"99","Type":"Pre Fail","Assessment":"OK"},{"Name":"Seek error rate","value":"3","Normalized":"66","Threshold":"9","worst":"99","Type":"Pre Fail","Assessment":"OK"},{"Name":"Power On errors","value":"3","Normalized":"66","Threshold":"9","worst":"99","Type":"Pre Fail","Assessment":"OK"},{"Name":"SSD Erase fail count","value":"3","Normalized":"66","Threshold":"9","worst":"99","Type":"Pre Fail","Assessment":"OK"},{"Name":"Power loss protection failure","value":"3","Normalized":"66","Threshold":"9","worst":"99","Type":"Pre Fail","Assessment":"OK"},{"Name":"Head stablility","value":"3","Normalized":"66","Threshold":"9","worst":"99","Type":"Pre Fail","Assessment":"OK"},{"Name":"High fly writes","value":"3","Normalized":"66","Threshold":"9","worst":"99","Type":"Pre Fail","Assessment":"OK"},{"Name":"Load cycle count","value":"3","Normalized":"66","Threshold":"9","worst":"99","Type":"Pre Fail","Assessment":"OK"},{"Name":"G sense error rate","value":"3","Normalized":"66","Threshold":"9","worst":"99","Type":"Pre Fail","Assessment":"OK"}]},
				   {"id":2,"headerData":{"HealthStatus":"Weak","Temprature":"53deg C","TestResult":"Success","SectorErrorCount":8},"Attributes":[{"Name":"Start/Stop Count","value":"3","Normalized":"26","Threshold":"1","worst":"99","Type":"Old Age","Assessment":"OK"},{"Name":"Spin Retry Count","value":"76","Normalized":"66","Threshold":"6","worst":"99","Type":"Pre Fail","Assessment":"OK"},{"Name":"Power On Time","value":"3","Normalized":"66","Threshold":"9","worst":"99","Type":"Pre Fail","Assessment":"OK"},{"Name":"Read error Rate","value":"3","Normalized":"66","Threshold":"9","worst":"99","Type":"Pre Fail","Assessment":"OK"},{"Name":"Seek error rate","value":"3","Normalized":"66","Threshold":"9","worst":"99","Type":"Pre Fail","Assessment":"OK"},{"Name":"Power On errors","value":"3","Normalized":"66","Threshold":"9","worst":"99","Type":"Pre Fail","Assessment":"OK"},{"Name":"SSD Erase fail count","value":"3","Normalized":"66","Threshold":"9","worst":"99","Type":"Pre Fail","Assessment":"OK"},{"Name":"Power loss protection failure","value":"3","Normalized":"66","Threshold":"9","worst":"99","Type":"Pre Fail","Assessment":"OK"},{"Name":"Head stablility","value":"3","Normalized":"66","Threshold":"9","worst":"99","Type":"Pre Fail","Assessment":"OK"},{"Name":"High fly writes","value":"3","Normalized":"66","Threshold":"9","worst":"99","Type":"Pre Fail","Assessment":"OK"},{"Name":"Load cycle count","value":"3","Normalized":"66","Threshold":"9","worst":"99","Type":"Pre Fail","Assessment":"OK"},{"Name":"G sense error rate","value":"3","Normalized":"66","Threshold":"9","worst":"99","Type":"Pre Fail","Assessment":"OK"}]},
				   {"id":3,"headerData":{"HealthStatus":"Good","Temprature":"3deg C","TestResult":"Success","SectorErrorCount":45},"Attributes":[{"Name":"Start/Stop Count","value":"3","Normalized":"26","Threshold":"1","worst":"99","Type":"Old Age","Assessment":"OK"},{"Name":"Spin Retry Count","value":"35","Normalized":"66","Threshold":"6","worst":"99","Type":"Pre Fail","Assessment":"OK"},{"Name":"Power On Time","value":"3","Normalized":"66","Threshold":"9","worst":"99","Type":"Pre Fail","Assessment":"OK"},{"Name":"Read error Rate","value":"3","Normalized":"66","Threshold":"9","worst":"99","Type":"Pre Fail","Assessment":"OK"},{"Name":"Seek error rate","value":"3","Normalized":"66","Threshold":"9","worst":"99","Type":"Pre Fail","Assessment":"OK"},{"Name":"Power On errors","value":"3","Normalized":"66","Threshold":"9","worst":"99","Type":"Pre Fail","Assessment":"OK"},{"Name":"SSD Erase fail count","value":"3","Normalized":"66","Threshold":"9","worst":"99","Type":"Pre Fail","Assessment":"OK"},{"Name":"Power loss protection failure","value":"3","Normalized":"66","Threshold":"9","worst":"99","Type":"Pre Fail","Assessment":"OK"},{"Name":"Head stablility","value":"3","Normalized":"66","Threshold":"9","worst":"99","Type":"Pre Fail","Assessment":"OK"},{"Name":"High fly writes","value":"3","Normalized":"66","Threshold":"9","worst":"99","Type":"Pre Fail","Assessment":"OK"},{"Name":"Load cycle count","value":"3","Normalized":"66","Threshold":"9","worst":"99","Type":"Pre Fail","Assessment":"OK"},{"Name":"G sense error rate","value":"3","Normalized":"66","Threshold":"9","worst":"99","Type":"Pre Fail","Assessment":"OK"}]},
				   {"id":4,"headerData":{"HealthStatus":"Normal","Temprature":"33deg C","TestResult":"Success","SectorErrorCount":40},"Attributes":[{"Name":"Start/Stop Count","value":"3","Normalized":"26","Threshold":"1","worst":"99","Type":"Old Age","Assessment":"OK"},{"Name":"Spin Retry Count","value":"35","Normalized":"66","Threshold":"6","worst":"99","Type":"Pre Fail","Assessment":"OK"},{"Name":"Power On Time","value":"3","Normalized":"66","Threshold":"9","worst":"99","Type":"Pre Fail","Assessment":"OK"},{"Name":"Read error Rate","value":"3","Normalized":"66","Threshold":"9","worst":"99","Type":"Pre Fail","Assessment":"OK"},{"Name":"Seek error rate","value":"3","Normalized":"66","Threshold":"9","worst":"99","Type":"Pre Fail","Assessment":"OK"},{"Name":"Power On errors","value":"3","Normalized":"66","Threshold":"9","worst":"99","Type":"Pre Fail","Assessment":"OK"},{"Name":"SSD Erase fail count","value":"3","Normalized":"66","Threshold":"9","worst":"99","Type":"Pre Fail","Assessment":"OK"},{"Name":"Power loss protection failure","value":"3","Normalized":"66","Threshold":"9","worst":"99","Type":"Pre Fail","Assessment":"OK"},{"Name":"Head stablility","value":"3","Normalized":"66","Threshold":"9","worst":"99","Type":"Pre Fail","Assessment":"OK"},{"Name":"High fly writes","value":"3","Normalized":"66","Threshold":"9","worst":"99","Type":"Pre Fail","Assessment":"OK"},{"Name":"Load cycle count","value":"3","Normalized":"66","Threshold":"9","worst":"99","Type":"Pre Fail","Assessment":"OK"},{"Name":"G sense error rate","value":"3","Normalized":"66","Threshold":"9","worst":"99","Type":"Pre Fail","Assessment":"OK"}]},
				   {"id":5,"headerData":{"HealthStatus":"Fail","Temprature":"100deg C","TestResult":"Fail","SectorErrorCount":9},"Attributes":[{"Name":"Start/Stop Count","value":"3000","Normalized":"26","Threshold":"1","worst":"99","Type":"Old Age","Assessment":"OK"},{"Name":"Spin Retry Count","value":"35","Normalized":"66","Threshold":"6","worst":"99","Type":"Pre Fail","Assessment":"OK"},{"Name":"Power On Time","value":"3","Normalized":"66","Threshold":"9","worst":"99","Type":"Pre Fail","Assessment":"OK"},{"Name":"Read error Rate","value":"3","Normalized":"66","Threshold":"9","worst":"99","Type":"Pre Fail","Assessment":"OK"},{"Name":"Seek error rate","value":"3","Normalized":"66","Threshold":"9","worst":"99","Type":"Pre Fail","Assessment":"OK"},{"Name":"Power On errors","value":"3","Normalized":"66","Threshold":"9","worst":"99","Type":"Pre Fail","Assessment":"OK"},{"Name":"SSD Erase fail count","value":"3","Normalized":"66","Threshold":"9","worst":"99","Type":"Pre Fail","Assessment":"OK"},{"Name":"Power loss protection failure","value":"3","Normalized":"66","Threshold":"9","worst":"99","Type":"Pre Fail","Assessment":"OK"},{"Name":"Head stablility","value":"3","Normalized":"66","Threshold":"9","worst":"99","Type":"Pre Fail","Assessment":"OK"},{"Name":"High fly writes","value":"3","Normalized":"66","Threshold":"9","worst":"99","Type":"Pre Fail","Assessment":"OK"},{"Name":"Load cycle count","value":"3","Normalized":"66","Threshold":"9","worst":"99","Type":"Pre Fail","Assessment":"OK"},{"Name":"G sense error rate","value":"3","Normalized":"66","Threshold":"9","worst":"99","Type":"Pre Fail","Assessment":"OK"}]},
				   ]
	print(json.JSONEncoder().encode(mockdata))
def read_SSDFull_Data():
	mockdata = [{"id":1,"Name":"HDD1","field1":"val1","field2":"val2","field3":"val3"},
				{"id":2,"Name":"HDD2","field1":"val1","field2":"val2","field3":"val3"},
				{"id":3,"Name":"HDD3","field1":"val1","field2":"val2","field3":"val3"}]
	print(json.JSONEncoder().encode(mockdata))
def read_SSD():
	'''mockdata = [{"id":1,"Name":"HDD1","field1":"val1","field2":"val2","field3":"val3"},
				{"id":2,"Name":"HDD2","field1":"val1","field2":"val2","field3":"val3"},
				{"id":3,"Name":"HDD3","field1":"val1","field2":"val2","field3":"val3"}]
	print json.JSONEncoder().encode(mockdata)'''
	query = c.execute("SELECT name,state,vid,pid,prl,serial,size,id,wwn,location from disks")
	dbdata = []
	conn.commit()
	for col in c:
		jsonschema = {"name" : col[0],"state" :col[1],"vid" : col[2],"pid" : col[3],"prl" :col[4],"serial" :col[5],"size" :col[6],"id":col[7],"wwn":col[8],"location":col[9]}
		dbdata.append(jsonschema)
	conn.close()
	print(json.JSONEncoder().encode(dbdata))
	
def read_HDD():
	mockdata = [{"id":1,"Name":"HDD1","field1":"val1","field2":"val2","field3":"val3"},
				{"id":2,"Name":"HDD1","field1":"val1","field2":"val2","field3":"val3"},
				{"id":3,"Name":"HDD1","field1":"val1","field2":"val2","field3":"val3"}]
	print(json.JSONEncoder().encode(mockdata))
	
def read_StoragePools():
	dbquery="select id,name,(case when name='HDD POOL' then '16 ' else '4 TB' end) capacity,pool_storage,0 available,deduplication,compression,(case when acceleration_storage > 0 then cast(acceleration_storage as text)|| ' TB' else 'No' end) from multi_device"	
	query = c.execute(dbquery)
	dbdata = []
	conn.commit()
	for col in c:
		jsonschema = {"id":col[0],"pool" : col[1],"capacity" :col[2],"protection" : str(col[3]),"available" : str(computeAvailableStorage(col[1]))+' TB',"dedup" :col[5],"compression" : col[6],"acceleration" : str(col[7]),"cache_RD":0,"cache_WRITE":0}
		dbdata.append(jsonschema)
	conn.close()
	print(json.JSONEncoder().encode({"data":dbdata}))
	
def read_PoolsFull_Data():
	mockdata = [{"id":1,"ProtocolName":"CIFS","Total":16,"StorageCapacity":8,"UsedCapacity":3,"RemainingCapacity":5},
				{"id":2,"ProtocolName":"NFS","Total":16,"StorageCapacity":8,"UsedCapacity":3,"RemainingCapacity":5},
				{"id":3,"ProtocolName":"iSCSI-Chap","Total":16,"StorageCapacity":8,"UsedCapacity":3,"RemainingCapacity":5},
				{"id":4,"ProtocolName":"iSCSI-NoChap","Total":16,"StorageCapacity":8,"UsedCapacity":3,"RemainingCapacity":5},
				{"id":5,"ProtocolName":"FTP","Total":16,"StorageCapacity":8,"UsedCapacity":3,"RemainingCapacity":5},
				{"id":6,"ProtocolName":"FC","Total":16,"StorageCapacity":8,"UsedCapacity":3,"RemainingCapacity":5}
				]
	print(json.JSONEncoder().encode(mockdata))
	
print("Content-type:text/html\r\n\r\n")

if request_Type == 'read_StatusAll':
	read_StatusAll()
elif request_Type == 'read_Fans':
	read_StatusFan()
elif request_Type == 'read_Temp_probes':
	read_StatusTemp_probes()
elif request_Type == 'read_CPU':
	read_StatusCPU()
elif request_Type == 'read_Network':
	read_StatusNetwork()
elif request_Type == 'read_PSU':
	read_StatusPSU()
elif request_Type == 'read_PSU1':
	read_StatusPSU1()
elif request_Type == 'read_PSU2':
	read_StatusPSU2()
elif request_Type == 'read_Disks':
	read_StatusDisks()
elif request_Type == 'read_DisksSMART_Data':
	read_DisksSMART_Data()
elif request_Type == 'read_StoragePools':
	read_StoragePools()
elif request_Type == 'read_PoolsFull_Data':
	read_PoolsFull_Data()
elif request_Type == 'read_SSD':
	read_SSD()
elif request_Type == 'read_SSDFull_Data':
	read_SSDFull_Data()
elif request_Type == 'read_HDD':
	read_HDD()




