#!/usr/bin/python3

import cgi,cgitb
from global_func import *
cgitb.enable()
import sqlite3
import json
from db import *


form = cgi.FieldStorage()
request_Type=form.getvalue('requestType')

def create_VDisk():
	vDiskName=form.getvalue('vDiskName')
	poolId=form.getvalue('poolId') 
	poolSize=form.getvalue('poolSize')
	dedup=form.getvalue('dedup') 
	compression=form.getvalue('compression')	
	
	VMId=form.getvalue('VMId')
	
	query_lan=c.execute("select count(*) from vm_storage where name=? and vm_id=?",[vDiskName,VMId])
	nameCount = c.fetchone()[0]
	conn.commit()
	
	if nameCount == 0:
		query_SP=c.execute("insert into  volume(name,multi_device_id,size,deduplication,compression,cr_date,edit_date) values(?,?,?,?,?,datetime(),datetime())",[vDiskName,poolId,poolSize,dedup,compression])
		conn.commit()
		volumeId = c.lastrowid
		
		query_SP=c.execute("insert into  vm_storage(name,state,volume_id,vm_id,cr_date) values(?,?,?,?,datetime())",[vDiskName,0,volumeId,VMId])
		conn.commit()
		print(json.JSONEncoder().encode({'status':'success','description':'Saved successfully'}))
	else:				
		print(json.JSONEncoder().encode({'status':'fail','description':'Disk Name Already Exists'}))
		
	c.close()
	conn.close()
	
def read_VDisk():	
	VMId = form.getvalue('VMId')
	
	dbquery="""SELECT vol.id,vol.name,size,multi_device_id,md.system_name,vol.deduplication,vol.compression from volume vol inner join multi_device md on vol.multi_device_id=md.id
			inner join vm_storage vs on vs.volume_id=vol.id
			where vs.vm_id="""+ str(VMId) 
	query = c.execute(dbquery)
	dbdata = []
	conn.commit()
	for col in c:
		jsonschema = {"id":col[0],"name" : col[1],"size" :col[2],"pool_id" : col[3],"Pool_name":col[4],"dedup" : col[5],"compression":col[6]}
		dbdata.append(jsonschema)
	conn.close()
	print(json.JSONEncoder().encode(dbdata))
def read_AttacheDdevice():
	VMId = form.getvalue('VMId')
	
	dbquery=""" select d.id,d.name,vs.state,d.size,d.stor_man_id,p.name,sm.name from vm_storage vs 
	inner join device d on d.id=vs.device_id  
	inner join stor_man sm on sm.id=d.stor_man_id
	inner join protocol p on p.id=sm.protocol
	where device_id is not null and vs.vm_id="""+ str(VMId) 
	query = c.execute(dbquery)
	dbdata = []
	conn.commit()
	for col in c:
		jsonschema = {"id":col[0],"name" : col[1],"state" :col[2],"size" : col[3],"stor_man_Id":col[4],"protocol" : col[5],"stor_man_name":col[6]}
		dbdata.append(jsonschema)
	conn.close()
	print(json.JSONEncoder().encode(dbdata))
	
def delete_VDisk():
	volumeIds = form.getvalue('volumeIds')
	
	query_FT=c.execute("Delete from vm_storage where volume_id in (?)",[volumeIds])
	conn.commit()
	
	query_FT=c.execute("Delete from volume where id in (?)",[volumeIds])
	conn.commit()		
	print(json.JSONEncoder().encode({'status':'success','description':'Deleted successfully'}))
	c.close()
	conn.close()

def attach_device():
	VMId=form.getvalue('VMId')
	deviceIds=form.getvalue('deviceIds')
	
	query_FT=c.execute("Delete from vm_storage where device_id is not null and vm_id in (?)",[VMId])
	conn.commit()
	
	query_SP=c.execute("insert into vm_storage(name,state,device_id,vm_id,cr_date) select null,1,id,?,datetime() from device where id in (?)",[VMId,deviceIds])
	conn.commit()
	c.close()
	conn.close()
	print(json.JSONEncoder().encode({'status':'success','description':'Devices Attached successfully'}))

print("Content-type:text/html\r\n\r\n")
if request_Type == 'read_VDisk':
	read_VDisk()
elif request_Type == 'delete_VDisk':
	delete_VDisk()
elif request_Type == 'create_VDisk':
	create_VDisk()
elif request_Type == 'attach_device':
	attach_device()
elif request_Type == 'read_AttacheDdevice':
	read_AttacheDdevice()