#!/usr/bin/python3

import cgi,cgitb
from global_func import *
cgitb.enable()
import sqlite3
import json
from db import *


form = cgi.FieldStorage()
request_Type=form.getvalue('requestType')

def create_Host():
	hostType=form.getvalue('hostType')
	hostName=form.getvalue('hostName')
	protocol=form.getvalue('protocol') 
	user=form.getvalue('user') 
	password=form.getvalue('password') 
	iqn=form.getvalue('iqn') 
	wwn	=form.getvalue('wwn')
	url	=form.getvalue('url')
	
	query_lan=c.execute("select count(*) from host where name='"+ str(hostName)+"' And protocol="+str(protocol))
	nameCount = c.fetchone()[0]
	conn.commit()
	
	if nameCount == 0:
		query_SP=c.execute("insert into  host(name,host_type,protocol,user_name,iqn,pw,wwn,url,cr_date) values(?,?,?,?,?,?,?,?,datetime())",[hostName,hostType,protocol,user,iqn,password,wwn,url])
		conn.commit()		
		print(json.JSONEncoder().encode({'status':'success','description':'Saved successfully'}))
	else:				
		print(json.JSONEncoder().encode({'status':'fail','description':'Host Name Already Exists'}))
		
	c.close()
	conn.close()

def update_Host():
	hostType=form.getvalue('hostType')
	hostName=form.getvalue('hostName')
	protocol=form.getvalue('protocol') 
	user=form.getvalue('user') 
	password=form.getvalue('password') 
	iqn=form.getvalue('iqn')
	wwn	=form.getvalue('wwn')
	hostId = form.getvalue('hostId')
	url	=form.getvalue('url')
	
	query_lan=c.execute("select count(*) from host where name='"+ str(hostName)+"' and protocol="+str(protocol)+" and id <> "+str(hostId))
	nameCount = c.fetchone()[0]
	conn.commit()
	
	if nameCount == 0:
		query_SP=c.execute("update host set name=?,host_type=?,protocol=?,user_name=?,iqn=?,pw=?,wwn=?,url=?,cr_date=datetime() where id=?",[hostName,hostType,protocol,user,iqn,password,wwn,url,hostId])
		conn.commit()		
		print(json.JSONEncoder().encode({'status':'success','description':'Updated successfully'}))
	else:				
		print(json.JSONEncoder().encode({'status':'fail','description':'Host Name Already Exists'}))
		
	c.close()
	conn.close()
	
def read_Host():		
	hostId = form.getvalue('hostId')
	if hostId != str(0):
		dbquery="SELECT h.id,h.name,h.protocol,h.user_name,h.iqn,h.pw,h.wwn,url,p.name,h.host_type from host  h inner join protocol p on h.protocol = p.id where h.id="+str(hostId)
	else:
		dbquery="SELECT h.id,h.name,h.protocol,h.user_name,h.iqn,h.pw,h.wwn,url,p.name,h.host_type from host h inner join protocol p on h.protocol = p.id order by h.id desc"
	query = c.execute(dbquery)
	dbdata = []
	conn.commit()
	for col in c:
		jsonschema = {"id":col[0],"name" : col[1],"protocol_id":col[2],"user_name":col[3],"iqn":col[4],"pw":col[5],"wwn":col[6],"url":col[7],"protocol_name":col[8],"host_type":col[9]}
		dbdata.append(jsonschema)
	conn.close()
	print(json.JSONEncoder().encode(dbdata))

def delete_Host():
	hostId = form.getvalue('hostId')
	
	query = "Delete from Host where id in ("+str(hostId)+")"
	query_FT=c.execute(query)
	conn.commit()		
	print(json.JSONEncoder().encode({'status':'success','description':'Deleted successfully'}))
	c.close()
	conn.close()

def read_Protocol():
	dbquery="SELECT id,name from protocol"
	query = c.execute(dbquery)
	dbdata = []
	conn.commit()
	for col in c:
		jsonschema = {"id":col[0],"protocolName" : col[1]}
		dbdata.append(jsonschema)
	conn.close()
	print(json.JSONEncoder().encode(dbdata))

print("Content-type:text/html\r\n\r\n")
if request_Type == 'read_Host':
	read_Host()
elif request_Type == 'delete_Host':
	delete_Host()
elif request_Type == 'create_Host':
	create_Host()
elif request_Type == 'update_Host':
	update_Host()
elif request_Type == 'read_Protocol':
	read_Protocol()
