#!/usr/bin/python3

import cgi,cgitb
from global_func import *
cgitb.enable()
import sqlite3
import json
from db import *


form = cgi.FieldStorage()
request_Type=form.getvalue('requestType')

def create_Storage():
	name=form.getvalue('name')
	protocolId=form.getvalue('protocolId') 
	hostId=form.getvalue('hostId') 
	StatusId=form.getvalue('StatusId') 
	
	query_lan=c.execute("select count(*) from stor_man where name='"+ str(name)+"'")
	nameCount = c.fetchone()[0]
	conn.commit()
	
	if nameCount == 0:
		query_SP=c.execute("insert into  stor_man(name,protocol,host_id,state,cr_date) values(?,?,?,?,datetime())",[name,protocolId,hostId,0])
		conn.commit()		
		print(json.JSONEncoder().encode({'status':'success','description':'Saved successfully'}))
	else:				
		print(json.JSONEncoder().encode({'status':'fail','description':'Host Name Already Exists'}))
		
	c.close()
	conn.close()

def read_Storage():
	storageId = form.getvalue('storageId')
	if storageId == '0':
		dbquery="SELECT id,name,protocol,host_id,state from stor_man"
	else:
		dbquery="SELECT id,name,protocol,host_id,state from stor_man where id="+str(storageId)
	query = c.execute(dbquery)
	dbdata = []
	conn.commit()
	for col in c:
		jsonschema = {"id":col[0],"name" : col[1],"protocol":col[2],"host_id":col[3],"state":col[4],"dummy":'-'}
		dbdata.append(jsonschema)
	print(json.JSONEncoder().encode(dbdata))

def OnOff_Device():
	state=form.getvalue('state') 
	deviceId = form.getvalue('deviceId')	
	
	query=c.execute("update device set state=? where id=?",[state,deviceId])
	conn.commit()
	
	if 	state == str(0):
		print(json.JSONEncoder().encode({'status':'success','description':'Device is OFF'}))
	else:				
		print(json.JSONEncoder().encode({'status':'success','description':'Device is ON'}))

def ConnectDisconnectSM_Storage():
	storageId = form.getvalue('storageId')	
	 
	query=c.execute("update stor_man set state = (case when state=1 then 0 else 1 end) where id=?",[storageId])
	conn.commit()
	print(json.JSONEncoder().encode({'status':'success','description':'Updated Successfully'}))
		
def delete_Storage():
	storageId = form.getvalue('storageId')
	
	query_lan=c.execute("select count(*) from stor_man where state=1 and id='"+ str(storageId)+"'")
	state = c.fetchone()[0]
	conn.commit()
	if state > 0:
		print(json.JSONEncoder().encode({'status':'fail','description':'Cannot Delete Used Storage'}))
		return
	
	query=c.execute("delete from stor_man where id=?",[storageId])
	conn.commit()
	
	print(json.JSONEncoder().encode({'status':'success','description':'Deleted successfully'}))

def read_Devices():
	storageId = form.getvalue('storageId')
	
	dbquery="SELECT d.id,d.name,d.sys_name,d.state,p.name protocol from device d  join stor_man sm on sm.id=d.stor_man_id  inner join protocol p on p.id=sm.protocol  where stor_man_id="+str(storageId)
	query = c.execute(dbquery)
	dbdata = []
	conn.commit()
	for col in c:
		jsonschema = {"id":col[0],"name" : col[1],"sys_name":col[2],"state":col[3],"protocol":col[4],"dummy":'-'}
		dbdata.append(jsonschema)
	
	print(json.JSONEncoder().encode(dbdata))
	
print("Content-type:text/html\r\n\r\n")

try:
	if request_Type == 'create_Storage':
		create_Storage()
	elif request_Type == 'read_Storage':
		read_Storage()
	elif request_Type == 'OnOff_Device':
		OnOff_Device()
	elif request_Type == 'delete_Storage':
		delete_Storage()
	elif request_Type == 'ConnectDisconnectSM_Storage':
		ConnectDisconnectSM_Storage()
	elif request_Type == 'read_Devices':
		read_Devices()
	
except BaseException as e:
	print(e.message) #Better to implement error logging
finally:
	conn.close()