#!/usr/bin/python3

import cgi, cgitb
from global_gui_data import *
from globalSettings import *
from global_func import *
import json
from db import *

cgitb.enable()
import sqlite3


form = cgi.FieldStorage()
SectionName=form.getvalue('SectionName')
	
def get_dbdata():
	if SectionName == 'Network':
		dbquery="select id,name,cidr,enable_dhcp from network"	
		query = c.execute(dbquery)
		dbdata = []
		conn.commit()
		for col in c:
			jsonschema = {"col0":col[0],"col1" : col[1],"col2" :col[2],"col3":col[3]}
			dbdata.append(jsonschema)
		conn.close()
		return json.JSONEncoder().encode({"Title":"Network","Section":SectionName,"header":["Name","CIDR","Enable DHCP"],"colWidth":[4,4,4],"data":dbdata})

	
	elif SectionName == 'OrgGroup':
		dbquery="select id,Name,Description from OrgGroup"	
		query = c.execute(dbquery)
		dbdata = []
		conn.commit()
		for col in c:
			jsonschema = {"col0":col[0],"col1" : col[1],"col2" :col[2],"col3":"ViewRoles("+str(col[0])+")"}
			dbdata.append(jsonschema)
		conn.close()
		return json.JSONEncoder().encode({"Title":"Organization Groups","Section":SectionName,"header":["Name","Description","Action"],"colWidth":[4,4,4],"data":dbdata})
		
	elif SectionName == 'OrgRole':
		dbquery="select id,Name,Description from OrgRole"	
		query = c.execute(dbquery)
		dbdata = []
		conn.commit()
		for col in c:
			jsonschema = {"col0":col[0],"col1" : col[1],"col2" :col[2],"col3":"ViewUsers("+str(col[0])+")"}
			dbdata.append(jsonschema)
		conn.close()
		return json.JSONEncoder().encode({"Title":"Organization Roles","Section":SectionName,"header":["Name","Description","Action"],"colWidth":[4,4,4],"data":dbdata})
		
	elif SectionName == 'OrgUsers':
		dbquery="select id,userName,FirstName,LastName,contactEmail from person"	
		query = c.execute(dbquery)
		dbdata = []
		conn.commit()
		for col in c:
			jsonschema = {"col0":col[0],"col1" : col[1],"col2" :col[2],"col3" : col[3],"col4" :col[4]}
			dbdata.append(jsonschema)
		conn.close()
		return json.JSONEncoder().encode({"Title":"Organization Peoples","Section":SectionName,"header":["User Name","First Name","Last Name","Email"],"colWidth":[3,3,3,3],"data":dbdata})
		
	elif SectionName == 'StoragePools':
		dbquery="select id,name,(case when name='HDD POOL' then '16 TB' else '4 TB' end) capacity,level,0 available,deduplication,compression,(case when acceleration_storage > 0 then ROUND(acceleration_storage,2)|| ' GB' WHEN acceleration_storage <= 0 AND name='HDD POOL' then 'No' else 'N/A' end),system_name,calculatedraw from multi_device"	
		query = c.execute(dbquery)
		dbdata = []
		conn.commit()
		for col in c:
			jsonschema = {"col0":col[0],"col1":str(col[8]), "col2" : col[1],"col3" :str(col[9]) + ' GB',"col4" : '0',"col5" :'N/A',"col6" :str(col[3]),"col7" :'#',"col8" :col[5],"col9" : col[6],"col10" : str(col[7])}
			dbdata.append(jsonschema)
		conn.close()
		return json.JSONEncoder().encode({"Title":"Storage Pools","Section":SectionName,"header":["Pool","Type","Raw Storage","Protected Storage","Status","Level","#Disks","Dedup","Compression","Acceleration / Cache"],"colWidth":[2,2,2,2,2,2,2,2,2,2],"data":dbdata})
		
	elif SectionName == 'BackupServices':
		dbquery="select id,destination_name,ip_address,account_name from backup"	
		query = c.execute(dbquery)
		dbdata = []
		conn.commit()
		for col in c:
			jsonschema = {"col0":col[0],"col1" : col[1],"col2" :col[2],"col3" : col[3]}
			dbdata.append(jsonschema)
		conn.close()
		return json.JSONEncoder().encode({"Title":"Services","Section":SectionName,"header":["Destination","IP Address","Account Name"],"colWidth":[4,4,4],"data":dbdata})

	elif SectionName == 'EmailServices':
		dbquery="select id,recipient_email,sender_email,smtp_server,port,alert_type from email_logs"	
		#dbquery="select id,sender_email,smtp_server,port,alert_type from email_logs"	
		query = c.execute(dbquery)
		dbdata = []
		conn.commit()
		for col in c:
			jsonschema = {"col0":col[0],"col1":col[1],"col2":col[2],"col3":col[3],"col4":col[4],"col5":col[5].replace(';',', ')}
			dbdata.append(jsonschema)
		conn.close()
		return json.JSONEncoder().encode({"Title":"Services","Section":SectionName,"header":["Recipient Email","Sender Email","SMTP Server","Port","Alert Type"],"colWidth":[3,3,2,2,2],"data":dbdata})

	elif SectionName == 'CBAServices':
		dbquery = "SELECT id,userName,host,port,enableCBA from cbaServer"
		query = c.execute(dbquery)
		dbdata = []
		conn.commit()
		for col in c:
			jsonschema = {"col0":col[0],"col1":col[1],"col2":col[2],"col3":col[3],"col4":col[4]}
			dbdata.append(jsonschema)
		conn.close()
		return json.JSONEncoder().encode({"Title":"Services","Section":SectionName,"header":["User name","Host","Port","Enable CBA"],"colWidth":[3,3,3,3],"data":dbdata})

	elif SectionName == 'KMIPServices':
		dbquery = "SELECT id,userName,host,port from kmipServer"
		query = c.execute(dbquery)
		dbdata = []
		conn.commit()
		for col in c:
			jsonschema = {"col0":col[0],"col1":col[1],"col2":col[2],"col3":col[3]}
			dbdata.append(jsonschema)
		conn.close()
		return json.JSONEncoder().encode({"Title":"Services","Section":SectionName,"header":["User name","Host","Port"],"colWidth":[4,4,4],"data":dbdata})
	
	elif SectionName == 'Hardware':
		dbquery="select 0,'Fan1','0','0'"	
		query = c.execute(dbquery)
		dbdata = []
		conn.commit()
		for col in c:
			jsonschema = {"col0":col[0],"col1" : col[1],"col2" :col[2],"col3" : col[3]}
			dbdata.append(jsonschema)
		conn.close()
		return json.JSONEncoder().encode({"Title":"Hardware","Section":SectionName,"header":["Name","Att1","Att2"],"colWidth":[4,4,4],"data":dbdata})
	
	elif SectionName == 'HardwareTemperature':
		dbquery='''Select id,name,ifnull(location,'System'),ifnull(temperature,0),ifnull(low_threshold,0),ifnull(hi_threshold,0),ifnull(min,0),ifnull(max,0),ifnull([default],0) from cpu
					union all
				Select id,name,ifnull(location,'System'),ifnull(temp,0),ifnull(low_threshold,0),ifnull(hi_threshold,0),ifnull(t_min,0),ifnull(t_max,0),ifnull([temp_default],0) from disks
					union all
				Select id,name,ifnull(location,'System'),ifnull(temp,0),ifnull(low_threshold,0),ifnull(hi_threshold,0),ifnull(t_min,0),ifnull(t_max,0),ifnull([default],0) from temp_probes
		'''	
		query = c.execute(dbquery)
		dbdata = []
		conn.commit()
		for col in c:
			jsonschema = {"col0":col[0],"col1" : col[1],"col2" :col[2],"col3" : NameConversions('Temperature',col[3]),"col4" : col[8],"col5" :col[4],"col6" : col[5]}
			dbdata.append(jsonschema)
		conn.close()
		return json.JSONEncoder().encode({"Title":"Hardware","Section":SectionName,"header":["Name","Location","Temperature","Default","Low Threshold(%)","High Threshold(%)"],"colWidth":[2,2,2,2,2,2],"data":dbdata})
		
	elif SectionName == 'HardwareFans':
		dbquery='''Select id,name,location,ifnull([default],0),ifnull(low_threshold,0),ifnull(hi_threshold,0),ifnull(t_min,0),ifnull(t_max,0),ifnull(speed,0) from fan
		'''	
		query = c.execute(dbquery)
		dbdata = []
		conn.commit()
		for col in c:
			jsonschema = {"col0":col[0],"col1" : col[1],"col2" :col[2],"col3" : col[8],"col4" : col[3],"col5" :col[4],"col6" : col[5]}
			dbdata.append(jsonschema)
		conn.close()
		return json.JSONEncoder().encode({"Title":"Hardware","Section":SectionName,"header":["Name","Location","Speed","Default","Low Threshold(%)","High Threshold(%)"],"colWidth":[2,2,2,2,2,2],"data":dbdata})
		
	elif SectionName == 'HardwareNetwork':
		dbquery='''Select id,name,location,ifnull(tx_rx_monitor,0),ifnull(err_threshold,0),ifnull(err_max,0),ifnull(tx_rx_default,0) from eth_ports
		'''	
		query = c.execute(dbquery)
		dbdata = []
		conn.commit()
		for col in c:
			jsonschema = {"col0":col[0],"col1" : col[1],"col2" :col[2],"col3" : NameConversions('Monitor',col[3]),"col4" : col[6],"col5" :col[4]}
			dbdata.append(jsonschema)
		conn.close()
		return json.JSONEncoder().encode({"Title":"Hardware","Section":SectionName,"header":["Name","Location","Monitor","Default Error rate","Error Threshold(%)"],"colWidth":[2,2,2,3,3],"data":dbdata})
		
	
	elif SectionName == 'HardwareStroage':
		dbquery='''Select id,name,ifnull(location,'System'),ifnull(tx_rx_monitor,0),ifnull(err_threshold,0),ifnull(err_max,0),ifnull(tx_rx_default,0) from multi_device
		union all
		Select id,name,ifnull(location,'System'),ifnull(tx_rx_monitor,0),ifnull(err_threshold,0),ifnull(err_max,0),ifnull([default],0) from disks
		'''	
		query = c.execute(dbquery)
		dbdata = []
		conn.commit()
		for col in c:
			jsonschema = {"col0":col[0],"col1" : col[1],"col2" :col[2],"col3" : NameConversions('Monitor',col[3]),"col4" : col[6],"col5" :col[4]}
			dbdata.append(jsonschema)
		conn.close()
		return json.JSONEncoder().encode({"Title":"Hardware","Section":SectionName,"header":["Name","Location","Monitor","Default Error rate(per min)","Error Threshold(%)"],"colWidth":[2,2,2,3,3],"data":dbdata})
	
	elif SectionName == 'PortGroups':
		dbquery="Select id,name,ip,netmask,enable_port,dhcp_enabled from eth_ports order by name"	
		query = c.execute(dbquery)
		dbdata = []
		conn.commit()
		for col in c:
			jsonschema = {"col0":col[0],"col1" : col[1],"col2" :col[2],"col3" : col[3],"col4" :col[4],"col5" : col[5]}
			dbdata.append(jsonschema)
		conn.close()
		return json.JSONEncoder().encode({"Title":"Ethernet Status","Section":SectionName,"header":["Name","IP Address","Net Mask","Enabled","DHCP"],"colWidth":[3,3,2,2,2],"data":dbdata})
	
		
def NameConversions(Title,type):
	if Title == 'Temperature':
		if type == 'F':
			return 'Fahrenheit'
		elif type == 'Celcius':
			return 'Celcius'
		else:
			return TemperatureType  #read default type from globalSettings
	elif Title == 'Monitor':
		if type == 0:
			return 'OFF'
		elif type == 1:
			return 'ON'
		else:
			return ''
			

def fakedata():
	mockdata	= []
	return json.JSONEncoder().encode(mockdata)



print("Content-type:text/html\r\n\r\n")


if (gui_data=='DB'):
	print(get_dbdata())	

elif(gui_data=='FAKE'):
	print(fakedata())

else:
	print("Invalid INPUT")


