#!/usr/bin/python3
# -*- coding: utf-8 -*-

import subprocess
import re
import time
import cgi
import cgitb
cgitb.enable()
import json

form = cgi.FieldStorage()

if form.getvalue('disk_name'):
    disk_name = form.getvalue('disk_name')
else:
    disk_name = 'Not entered'

disk_name = 'sda'


def getSmartData(disk):
    disk = '/dev/' + str(disk)

    #print disk
    process1=subprocess.check_output(["sudo","smartctl","-a",disk]).splitlines()[2:]
#    process2 = subprocess.check_output(["sudo","smartctl","-A",disk]).splitlines()[6:-1]
    process2 = process1
        # print process1

    process1_List = []
    jsonres = {}
    logsData = []
    headersData =[]
    attributesData = []
    process2_List=[]
    smartAttributesData=[]
    processKeys=[]

    searchoutput = [
        'SMART support is',
        'SMART support is',
        'Temperature Warning',
        'Read Cache is',
        'Writeback Cache is',
        'SMART Health Status',
        'Current Drive Temperature',
        'Drive Trip Temperature',
        'Manufactured in week 37 of year 2009',
        'Specified cycle count over device lifetime',
        'Accumulated start-stop cycles',
        'Elements in grown defect list',
        'Non-medium error count',
        'Number of background scans performed',
        'Number of background medium scans performed',
        'read',
        'write',
        'verify']

    attributeSearchOutput = [
        'Raw_Read_Error_Rate',
        'Spin_Up_Time',
        'Start_Stop_Count',
        'Reallocated_Sector_Ct',
        'Seek_Error_Rate',
        'Power_On_Hours',
        'Spin_Retry_Count',
        'Calibration_Retry_Count',
        'Power_Cycle_Count',
        'Power-Off_Retract_Count',
        'Load_Cycle_Count',
        'Temperature_Celsius',
        'Reallocated_Event_Count',
        'Current_Pending_Sector',
        'Offline_Uncorrectable',
        'UDMA_CRC_Error_Count',
        'Multi_Zone_Error_Rate'
        ]
        
    for line in process1:
        res = re.sub(' +', ' ', line)
        process1_List.append(res)

    for i in process1_List:
        output = i.strip(' ').split(': ', 1)
        key = output[0]
        #print " KEY ::: ",key
        processKeys.append(key) 


        if key in searchoutput:
            if key.startswith('Manufactured'):
                Manufactured = key.split('in')
                key = Manufactured[0]
                val = Manufactured[1]
            elif key.endswith("is"):
                key=key.strip("is")
                val=output[1]
                
            else:
                val=output[1]
                key = key

            if key == 'read':
                errorReadLogs = val.split(' ')
                logsData.append({"name":"read","fast":errorReadLogs[0],"delayed":errorReadLogs[1],"reread":errorReadLogs[2],"totErrCorrected":errorReadLogs[3],"gbProcessed":errorReadLogs[5],"totUnCorrectedErr":errorReadLogs[6]})

            elif key == 'write':
                errorWriteLogs = val.split(' ')
                logsData.append({"name":"write","fast":errorWriteLogs[0],"delayed":errorWriteLogs[1],"reread":errorWriteLogs[2],"totErrCorrected":errorWriteLogs[3],"gbProcessed":errorWriteLogs[5],"totUnCorrectedErr":errorWriteLogs[6]})

            elif key == 'verify':
                errorVerifyLogs = val.split(' ')
                logsData.append({"name":"verify","fast":errorVerifyLogs[0],"delayed":errorVerifyLogs[1],"reread":errorVerifyLogs[2],"totErrCorrected":errorVerifyLogs[3],"gbProcessed":errorVerifyLogs[5],"totUnCorrectedErr":errorVerifyLogs[6]})

            #elif key in jsonres.keys():
            #    val0 = jsonres[key]				
            #    jsonres[key] = val0 + ',' + val
                #processKeys.append(key)
            else:
                if key in ['SMART Health Status','Current Drive Temperature','Non-medium error count','Temperature Warning']:
                    headersData.append({"key":key,"value":val})
                else:
                    smartAttributesData.append({"name":key,"flag":"N/A","value":val,"worst":"N/A","thresh":"N/A","type":"N/A","updated":"N/A","when_failed":"N/A","raw_value":"N/A"})
                    #attributesData.append({"key":key,"value":val})
                    #jsonres[key] = val
    else:
            pass

    for line in process2:
        res = re.sub(' +', ' ', line)
        process2_List.append(res)

    for i in process2_List:
    	try:
            attributeLogs= i.strip(" ").split(" ")[1:]
            #print "key::",output[0]
            key=attributeLogs[0]
            processKeys.append(key)
            if key in attributeSearchOutput:
                smartAttributesData.append({"name":attributeLogs[0],"flag":attributeLogs[1],"value":attributeLogs[2],"worst":attributeLogs[3],"thresh":attributeLogs[4],"type":attributeLogs[5],"updated":attributeLogs[6],"when_failed":attributeLogs[7],"raw_value":attributeLogs[8]})
            else:
                pass
        except:
            attributeLogs = i.split(":")
            key=attributeLogs[0]
            #val=attributeLogs[1]
            #print "attribute logs key::",key
            #print "attribute logs val::",val
            processKeys.append(key)


    for key in (searchoutput+attributeSearchOutput):
        if  key not in processKeys and key in ['SMART Health Status','Current Drive Temperature','Non-medium error count','Temperature Warning']:
            headersData.append({"key":key,"value":"N/A"})
        elif key not in processKeys and key.endswith("is"):
            smartAttributesData.append({"name":key.strip("is"),"flag":"N/A","value":"N/A","worst":"N/A","thresh":"N/A","type":"N/A","updated":"N/A","when_failed":"N/A","raw_value":"N/A"})

        elif key not in processKeys and (key not in ["read","write","verify"]):
            smartAttributesData.append({"name":key,"flag":"N/A","value":"N/A","worst":"N/A","thresh":"N/A","type":"N/A","updated":"N/A","when_failed":"N/A","raw_value":"N/A"})
        else:
            pass

    if(len(logsData) == 0):
        logsData = [{"name":"read","fast":"N/A","delayed":"N/A","reread":"N/A","totErrCorrected":"N/A","gbProcessed":"N/A","totUnCorrectedErr":"N/A"},
		{"name":"write","fast":"N/A","delayed":"N/A","reread":"N/A","totErrCorrected":"N/A","gbProcessed":"N/A","totUnCorrectedErr":"N/A"},
		{"name":"verify","fast":"N/A","delayed":"N/A","reread":"N/A","totErrCorrected":"N/A","gbProcessed":"N/A","totUnCorrectedErr":"N/A"}
		]
    jsonres["logsData"] = logsData				#Error logs
    jsonres["headersData"] = headersData		#Top 4 headers
    jsonres["attributesData"] =attributesData	#Remaining disk attributes
    jsonres["smartAttributesData"] = smartAttributesData

    #Property bindings and header titles - dont change property values
    #change name field for friendly names
    jsonres["propertyBinding"] = {"headers" :[{"name":"Health Status","property":"SMART Health Status"},{"name":"Temperature","property":"Current Drive Temperature"},{"name":"Sector Error count","property":"Non-medium error count"},{"name":"Temperature Warning","property":"Temperature Warning"}],
    							  "errorLogs":[{"name":"","property":"name"},{"name":"Fast","property":"fast"},{"name":"Delayed","property":"delayed"},{"name":"Rereads/rewrites","property":"reread"},{"name":"Total Errors corrected","property":"totErrCorrected"},{"name":"GB Processed","property":"gbProcessed"},{"name":"Total uncorrected errors","property":"totUnCorrectedErr"}],
    							  "attributes":[{"name":"Attribute","property":"key"},{"name":"value","property":"value"}],
								  "smartAttributes":[{"name":"Attribute","property":"name"},{"name":"value","property":"value"},{"name":"Flag","property":"flag"},{"name":"worst","property":"worst"},{"name":"thresh","property":"thresh"},{"name":"type","property":"type"},{"name":"updated","property":"updated"},{"name":"when failed","property":"when_failed"},{"name":"Raw value","property":"raw_value"}],
    							 }

    return jsonres

#print "Content-type:text/html\r\n\r\n"
#print getSmartData(disk_name)
