#!/usr/bin/python3
from global_func import *
GUI, CCM = get_ccm_status()
import cgi, cgitb

cgitb.enable()
import sqlite3
import json
from db import *
from logRoutine import *
initLogging()
from globalSettings import *
from clearTextPwd import *
import base64
form = cgi.FieldStorage()

cmd_Id = get_ccm_command_id()


if GUI == True:
    request_Type = form.getvalue('RequestType')
else:
    print("1. Read CBA Services")
    print("2. create_CBAServices")
    choice = int(input("Select cgi => "))
    if choice == 1:
        request_Type = "read_CBAServices"
    if choice == 2:
        request_Type = "create_CBAServices"
def btoa(name):
    name_bytes = name.encode('utf-8')
    encoded_name_bytes = base64.b64encode(name_bytes)
    encoded_password = encoded_name_bytes.decode('utf-8')

    return encoded_password

def create_CBAServices():
    db_filename = DBPath
    conn=sqlite3.connect(db_filename)
    conn.text_factory=str
    c=conn.cursor()
    if GUI == True:
        enCBA = form.getvalue('enCBA')
        enSSH = form.getvalue('enSSH')
        cbaUpload = form.getvalue('cbaUpload')
        cbaUpdate = form.getvalue('cbaUpdate')
        cbaUploadType = form.getvalue('cbaUploadType')
        cbaUpdateType = form.getvalue('cbaUpdateType')
        userId = form.getvalue('userId')
        user_password = form.getvalue('password')
    else:
        enCBA = input('Enter enCBA => ')
        enSSH = input('Enter enSSH => ')
        cbaUploadType = input('Enter upload type (minutes/hours) => ')
        cbaUpload = int(input('Enter upload time (1,2,3...) => '))
        cbaUpdateType = input('Enter update type (minutes/hours) => ')
        cbaUpdate = int(input('Enter update time (1,2,3...) => '))
        c.execute("Select id,userName from person")
        resp = c.fetchall()
        print(resp)
        userId = input('Enter userId => ')
        user_password = btoa(input('Enter password => '))

   
    user_password = (base64.b64decode(user_password)).decode("utf-8")
    
    
    query_pwd = c.execute("select password from person where id=?",[userId])
    db_Pwd = c.fetchone()[0]
    conn.commit()

    isEnPwd = is_EncodedString_base64(db_Pwd)
    if isEnPwd :
        EncryptGUIpwd = pwd_encoding(user_password)
        user_password = EncryptGUIpwd
    query=c.execute("SELECT * from person where id=? and password=?",[userId,user_password])
    isValidCredentials=c.fetchall()
    if not isValidCredentials:
        print (json.JSONEncoder().encode({"status": "fail", "description": "Invalid user password"}))
        c.close()
        conn.close()
        return

    if enCBA!="" and enSSH!="":
        if CCM == True:
            cmd = "update_cba_ssh"
            cmd_Id = get_ccm_command_id()
            message = "set,element=cbaServer,element_name={0},args=4,Action={1},enableCBA={2},enableSSH={3},cbaUpload={4},cbaUpdate={5},cbaUploadType={6},cbaUpdateType={7},uuid={8}" \
                .format("cba_ssh", cmd, enCBA, enSSH,cbaUpload,cbaUpdate,cbaUploadType,cbaUpdateType,cmd_Id)
            send_ccm_msg(message)
            response = get_ccm_response(cmd_Id)
            print (response)
            delete_ccm_response(cmd_Id)

        else:
            query_lan = c.execute("delete from cbaServer")
            conn.commit()
            query_lan = c.execute(
                "insert into cbaServer (enableCBA, enableSSH,cbaUpload,cbaUpdate,cbaUploadType,cbaUpdateType) values(?,?,?,?,?,?)",
                [enCBA, enSSH,cbaUpload,cbaUpdate,cbaUploadType,cbaUpdateType])
            conn.commit()
            dArgs=loggerArgs("cbaServer/" + "CBA_SSH_serviceManager","enable CBA = {} enable SSH = {}".format(enCBA, enSSH),infoLevel,"create")
            ccmLogger(info,"successfully created enable CBA = {} enable SSH = {}".format(enCBA, enSSH),dArgs)
            print (json.JSONEncoder().encode({"status": "success", "description": "Saved successfully"}))
    else:
        dArgs=loggerArgs("cbaServer/" + "CBA_SSH_serviceManager","enable CBA = {} enable SSH = {}".format(enCBA, enSSH),errorLevel,"create")
        ccmLogger(error,"Fill All mandatory fields",dArgs)
        print (json.JSONEncoder().encode({"status": "fail", "description": "Fill All mandatory fields"}))

    c.close()
    conn.close()

def read_CBAServices():
    enableSSH, enableCBA = '', ''
    db_filename = DBPath
    conn=sqlite3.connect(db_filename)
    conn.text_factory=str
    c=conn.cursor()
    try:
        dbquery = "SELECT id, enableCBA, enableSSH,cbaUpload,cbaUpdate,cbaUploadType,cbaUpdateType from cbaServer"
        query = c.execute(dbquery)
        dbdata = []
        conn.commit()
        for col in c:
            id, enableCBA, enableSSH,cbaUpload,cbaUpdate,cbaUploadType,cbaUpdateType = col[0], col[1], col[2], col[3],col[4],col[5],col[6]
        
        jsonschema = {"id": id, "enableCBA": enableCBA, "enableSSH": enableSSH,"cbaUpload" : cbaUpload ,"cbaUpdate" : cbaUpdate,"cbaUploadType":cbaUploadType,"cbaUpdateType": cbaUpdateType}
        dbdata.append(jsonschema)
        c.close()
        conn.close()
        print (json.JSONEncoder().encode(dbdata))
    except Exception as e:
        c.close()
        conn.close()
        print (json.JSONEncoder().encode(dbdata))


print ("Content-type:text/html\r\n\r\n")
if request_Type == 'create_CBAServices':
    create_CBAServices()
elif request_Type == 'read_CBAServices':
    read_CBAServices()
else:
    print (json.JSONEncoder().encode({"test":"test"}))
