#!/usr/bin/python3

import cgi, cgitb
from global_func import *

cgitb.enable()
import sqlite3
import json
from db import *
from logRoutine import *
initLogging()

form = cgi.FieldStorage()
request_Type = form.getvalue('RequestType')
cmd_Id = get_ccm_command_id()

CCM = False
def create_CBAServices():

    userName = form.getvalue('userName')
    password = form.getvalue('password')
    host = form.getvalue('host')
    portNumber = form.getvalue('portNumber')
    enCBA = form.getvalue('enCBA')

    if host !="" and portNumber!="" and enCBA!="" and userName!="" and password!="":
        if CCM:
            cmd = "SaveCBA"
            message = "set,element=services,element_name={0},args=7,Action={1},userName={2}," \
                    "pwd={3},host={4},port={5},enCBA={6},uuid={7}" \
                .format(sender, cmd, userName, password, host, portNumber, enCBA, cmd_Id)
            send_ccm_msg(message)
            response = get_ccm_response(cmd_Id)
            dArgs=loggerArgs("cbaServer/" + "CBA_serviceManager",userName,infoLevel,"create")
            ccmLogger(info,response["description"],dArgs)
            print (response)
            delete_ccm_response(cmd_Id)
        else:
            query_lan = c.execute("delete from cbaServer")
            conn.commit()
            query_lan = c.execute(
                "insert into cbaServer (userName,pwd,host,port,enableCBA) values(?,?,?,?,?)",
                [userName, password, host, portNumber, enCBA])
            conn.commit()
            dArgs=loggerArgs("cbaServer/" + "CBA_serviceManager",userName,infoLevel,"create")
            ccmLogger(info,"successfully created " + userName,dArgs)
            print (json.JSONEncoder().encode({"status": "success", "description": "Saved successfully"}))
    else:
        dArgs=loggerArgs("cbaServer/" + "CBA_serviceManager",userName,errorLevel,"create")
        ccmLogger(error,"Fill All mandatory fields",dArgs)
        print (json.JSONEncoder().encode({"status": "fail", "description": "Fill All mandatory fields"}))

    c.close()
    conn.close()

def read_CBAServices():
    id, userName, password, host, port, enableCBA = '', '', '', '', '', ''
    dbquery = "SELECT id,userName,pwd,host,port,enableCBA from cbaServer"
    query = c.execute(dbquery)
    dbdata = []
    conn.commit()
    for col in c:
        id, userName, password, host, port, enableCBA = col[0], col[1], col[2], col[3], col[4], col[5]
    
    jsonschema = {"id": id, "userName": userName, "password": password, "host": host,
                    "port": port,"enableCBA": enableCBA}
    dbdata.append(jsonschema)
    conn.close()
    print (json.JSONEncoder().encode(dbdata))


print ("Content-type:text/html\r\n\r\n")
if request_Type == 'create_CBAServices':
    create_CBAServices()
elif request_Type == 'read_CBAServices':
    read_CBAServices()
else:
    print (json.JSONEncoder().encode({"test"}))
