#!/usr/bin/python

import cgi,cgitb
cgitb.enable()
from globalSettings import *
import csv
import json
#import datetime
from datetime import datetime
import shutil
import subprocess
import os

from global_func import *
cmd_Id = get_ccm_command_id()

DATE_FORMAT_LOGROUTINE = '%d/%m/%Y-%H:%M:%S'
DATE_FORMAT_FOR_GUI = '%b %d, %Y, %H:%M:%S'
form = cgi.FieldStorage()

request_Type=form.getvalue('request_Type')

startDate=form.getvalue('startDate')
endDate=form.getvalue('endDate')
maxLogLevel=form.getvalue('maxLogLevel')
logType=form.getvalue('logType')

csvlimit = 50
limitcsv = False
SANUYI_LOGS_ZIP = "/var/www/gui@Q/Quantum/sanuyiLogs.zip"
# SANUYI_LOGS_FOLDER = "/var/www/gui@Q/Quantum/sanuyiLogs"
SANUYI_LOGS_FOLDER = "R6000_Logs"
EMAIL_LOG_ZIP_PASSWORD = "hello123"

def sanuyiLogsZipName():
    dbquery = "SELECT serial_number from system "
    query = c.execute(dbquery)
    dbdata = []
    serial_number = ""
    for col in c:
        serial_number = col[0]
    downloadFileName = "R6000_"+str(serial_number)+".zip"
    SANUYI_LOGS_ZIP1 = "/var/www/gui@Q/Quantum/"+downloadFileName
    return SANUYI_LOGS_ZIP1

def create_zip_file_with_logs():
    temp_folder_name = SANUYI_LOGS_FOLDER
    zip_file_name = sanuyiLogsZipName()#SANUYI_LOGS_ZIP
    if os.path.isfile(zip_file_name):
        os.remove(zip_file_name)
    if os.path.isdir(temp_folder_name):
        try:
            shutil.rmtree(temp_folder_name)
        except OSError as e:
            print ("Error: %s - %s." % (e.filename, e.strerror))
    def createFolderIfnotExists(path):
        if not os.path.exists(path):
            os.makedirs(path, 0o777)
    createFolderIfnotExists(temp_folder_name)
    dbquery = "SELECT serial_number from system "
    query = c.execute(dbquery)
    dbdata = []
    serial_number = ""
    for col in c:
        serial_number = col[0]
    
    multi_device_data = []                
    query = c.execute("select * from multi_device")
    conn.commit()
    columnNames = list(map(lambda x: x[0], query.description))
    for col in c:
        rowDict = dict(zip(columnNames, col))
        multi_device_data.append(rowDict)
        
    volume_data = []
    query = c.execute("select * from volume")
    conn.commit()
    columnNames = list(map(lambda x: x[0], query.description))
    for col in c:
        rowDict = dict(zip(columnNames, col))
        volume_data.append(rowDict)
        
    host_server_data = []
    query = c.execute("select * from host")
    conn.commit()
    columnNames = list(map(lambda x: x[0], query.description))
    for col in c:
        rowDict = dict(zip(columnNames, col))
        host_server_data.append(rowDict)
    
    license_info = "NA"
    cmd="test_response"
    name="License"
    action="check"
    message="set,element=test_response,element_name={0},args=2,action={1},uuid={2}".format(name,action,cmd_Id)
    send_ccm_msg(message) 
    response = json.loads(get_ccm_response(cmd_Id))
    if response["status"] == 'success':
        is_license = response["description"].split(",")[-1].split(':')[-1].strip()
        if "NOT OK" in is_license:
            license_info = 'NOT PRESENT'
        else:
            license_info = 'PRESENT'
    else:
        license_info = 'NOT PRESENT'
    additional_data = {
        "multi_device_data" : multi_device_data,
        "volume_data" : volume_data,
        "host_server_data" : host_server_data,
        "serial_number" : {"serial_number": serial_number},
        "license_info" : {"license_info": license_info}
    }
    for key, data in additional_data.items():
        json_filename = os.path.join(temp_folder_name, key+'.json')
        with open(json_filename,'w') as f:
            json.dump(data, f, indent=2)
    #copying files
    #change permision to /var/log
    process2 = subprocess.check_output(['sudo','chmod','-R', '777', '/var/log/'])
    sys_log_path = "/var/log/syslog"
    kern_log_path = "/var/log/kern.log"
    auth_log = "/var/log/auth.log"
    failLog = "/var/log/faillog"
    redisLog="/var/log/redis/redis-server.log"
    apache2_Access_log = "/var/log/apache2/access.log"
    apache2_Error_log = "/var/log/apache2/error.log"
    file_names = [LogsFilePath, AlertsFilePath, network_yaml_path,sys_log_path,kern_log_path,auth_log,failLog,redisLog,apache2_Access_log,apache2_Error_log]
    for file in file_names:
        process1 = subprocess.check_output(['sudo','chmod', '777', file])
        shutil.copy(file, temp_folder_name)
    # copy rrd folder
    destination = shutil.copytree(rrdPath, os.path.join(temp_folder_name, "sanuyi_rrdFiles"))
    # dmseg
    dmseg_file = os.path.join(temp_folder_name, "dmesg.txt")
    process1 = subprocess.check_output(["dmesg", '-T'])
    with open(dmseg_file, 'w') as f:
        f.write(process1)
    # sudo apt install zip
    #  zip -r --password password file2.zip hardware-testing/
    arg1 = "/usr/bin/zip"
    arg2 = "-r"
    arg3 = "--password"
    arg4 = EMAIL_LOG_ZIP_PASSWORD
    arg5 = zip_file_name
    arg6 = temp_folder_name
    arg7 = '-j'
    # process1 = subprocess.check_output(["cd",arg6])
    try:
        process1 = subprocess.check_output([arg1, arg2, arg3, arg4, arg5, arg6])
    except:
        process1 = subprocess.check_output([arg1, arg2, arg3, arg4, arg5, arg6], shell=True)
    try:
        shutil.rmtree(temp_folder_name)
    except OSError as e:
        print ("Error: %s - %s." % (e.filename, e.strerror))
    return zip_file_name

def read_CCMLogs():	
    displayTextList = ['Date Time','Element','Element Name','Log Level','State','Action','Message']
    colWidth = [{ "width": "10%" },{ "width": "10%" },{ "width": "10%" },{ "width": "5%" },{ "width": "5%" },{ "width": "15%" },{ "width": "25%" }]
    propertyNameList = ['datetime','element','elementname','loglevel','sate','action','message']
    
    with open(LogsFilePath, 'rb') as csvfile:
        filereader = reversed(list(csv.reader(csvfile, delimiter='@')))
        i = 0
        header = []
        out_data = []
        header = propertyNameList
        for row in filereader:
            i+=1
            if i > csvlimit and limitcsv:
                break
            row = [elem for elem in row if elem]
            #print row
            #row[0:2] = [row[0]]
            _dict = {}
            for elem, header_elem in zip(row, header):
                if header_elem.strip() == "datetime":
                    elem = datetime.strptime(elem.strip(),DATE_FORMAT_LOGROUTINE).strftime(DATE_FORMAT_FOR_GUI)
                _dict[header_elem.strip()] = elem.strip()
            out_data.append(_dict)	
    
        # shutil.copyfile(LogsFilePath,"/var/www/gui@Q/Quantum/SystemLogs.log")
        print json.JSONEncoder().encode({
            'logsData':ApplyFilter(out_data),'headers':displayTextList,'propetyName':propertyNameList,
            'colWidth':colWidth
        })

def read_CCMAlerts():	
    displayTextList = ['Date Time','Element','Element Name','Log Level','State','Action','Message']
    colWidth = [{ "width": "10%" },{ "width": "10%" },{ "width": "10%" },{ "width": "5%" },{ "width": "5%" },{ "width": "10%" },{ "width": "30%" }]
    propertyNameList = ['datetime','element','elementname','loglevel','sate','action','message']
    
    with open(AlertsFilePath, 'rb') as csvfile:
        filereader = reversed(list(csv.reader(csvfile, delimiter='@')))
        i = 0
        header = []
        out_data = []
        header = propertyNameList
        for row in filereader:
            i+=1
            if i > csvlimit and limitcsv :
                break
            row = [elem for elem in row if elem]
            #print row
            #row[0:2] = [row[0]]
            _dict = {}
            for elem, header_elem in zip(row, header):
                if header_elem.strip() == "datetime":
                    elem = datetime.strptime(elem.strip(),DATE_FORMAT_LOGROUTINE).strftime(DATE_FORMAT_FOR_GUI)
                _dict[header_elem.strip()] = elem.strip()
            out_data.append(_dict)	
    #print datetime.strptime('15/03/2019-19:34:46', '%d/%m/%Y-%H:%M:%S')
    print json.JSONEncoder().encode({'logsData':ApplyFilter(out_data),'headers':displayTextList,'propetyName':propertyNameList, 'colWidth':colWidth})

    
def ApplyFilter(logs):
    if str(logType) != '':
        logTypeFilters = logType.split(",")
        
    if str(logType) != '' and str(logType) != 'All':
        logs = [x for x in logs if x['sate'] in logTypeFilters]
    
    if str(maxLogLevel) != '' and str(maxLogLevel) != 'None':
        logs = [x for x in logs if int(x['loglevel']) <= int(maxLogLevel)]
    
    if str(startDate) != '' and str(startDate) != 'None':		
        #print datetime.strptime(str(startDate), '%m/%d/%Y')
        logs = [x for x in logs if datetime.strptime(x['datetime'], '%d/%m/%Y-%H:%M:%S') >= datetime.strptime(str(startDate), '%m/%d/%Y')]
        
    if str(endDate) != '' and str(endDate) != 'None':
        #print datetime.strptime(str(endDate)+" 23:59:59", '%m/%d/%Y %H:%M:%S')	
        logs = [x for x in logs if datetime.strptime(x['datetime'], '%d/%m/%Y-%H:%M:%S') <= datetime.strptime(str(endDate)+" 23:59:59", '%m/%d/%Y %H:%M:%S')]
        
    return logs
    
def download_logs():
    zipFileName = create_zip_file_with_logs()
    web_zip_path = zipFileName.replace(webServerRoot,'')
    # shutil.copyfile(LogsFilePath,"/var/www/gui@Q/Quantum/SystemLogs.log")
    print json.JSONEncoder().encode({
        'download_file':web_zip_path, 'filename':os.path.basename(zipFileName)
    })
    
print ("Content-type:text/html\r\n\r\n")
# if request_Type == 'download_logs':
    # download_logs()
try:
    if request_Type == 'read_CCMLogs':
        read_CCMLogs()
    elif request_Type == 'read_CCMAlerts':
        read_CCMAlerts()
    elif request_Type == 'download_logs':
        download_logs()
except BaseException as e:
    #print json.JSONEncoder().encode({'status':'fail','description':'Eror occured, Please refer log file more info'})
    print json.JSONEncoder().encode({'status':'fail','description':str(e)})
    timeNow =  datetime.now()
    f= open("./log.txt","a+")
    f.write(str(timeNow)+" "+ str(e.message)+ "\r\n")
