#!/usr/bin/python
# -*- coding: utf-8 -*-

GUI=False
CCM=True

if GUI==True:
    import cgi,cgitb
    cgitb.enable()
import uuid
import string
import random
import os
import subprocess
from subprocess import call
import time
import json

import sqlite3
import json
from globalSettings import DBPath
if GUI==True:
    form = cgi.FieldStorage()
    request_Type = form.getvalue('RequestType')
else:
    print ('1. Restart')
    print ('2. Reboot & Burn ISO')
    print ('3  exit')
    choice=int(input("select cgi function==>"))
    if (choice==1):
        request_Type='restart'
    if (choice==2):
        request_Type='reboot'
    if (choice==3):
        exit (0)
        
        
def get_ccm_command_id():
    command_id=id_generator()
    return (command_id)

def ccm_msg_length(message):
    length="0000"
    tail="</msg>"
    length_message=len(message)
    length_message=length_message+len(tail) # add in the tail length </msg>
    if length_message<=9:
        k=length.rfind("0")
    elif length_message<=99:
        k=length.rfind("00")
    elif length_message<=999:
        k=length.rfind("000")
    msg_length=length[:k]+str(length_message)
    return msg_length

#</msg>0099set,element=multi_device,element_name=mrp1,args=3,action=PoolDelete,SystemName=mrp1,uuid=6RM6</msg>

def send_wd_msg(message):
    msg_length = ccm_msg_length(message)
    socket_cmd = "</msg>{0}{1}</msg>".format(msg_length, message)
    try:
        WDpath="/var/www/cgiWD.sh"
        process1 = subprocess.call(["sudo",WDpath,socket_cmd])
    except Exception as err:
        print ("send_ccm_msg except ",err)

def get_wd_response(uuid):
    filename="ccm_response.txt"
    wd_path="/var/www/"
    ccm_response_file= wd_path+str(uuid)+filename
    file=0
    while (file < 100):
        if os.path.isfile(ccm_response_file):
            file=101
        else:
            file=file+1
            time.sleep(.1)
            if file==99:
                return (json.JSONEncoder().encode({'status':'fail','description':'Command Timeout'}))
                
    fo = open(ccm_response_file, "r")
    CcmResponse=fo.read()
    fo.close()
    os.remove(ccm_response_file)
    return CcmResponse


def id_generator(size=4, chars=string.ascii_uppercase + string.digits):
    return ''.join(random.choice(chars) for _ in range(size))

def get_ccm_command_id():
    command_id=id_generator()
    return (command_id)


def restartServer():
    userId = form.getvalue('userId')
    password = form.getvalue('password')
    decoded_password = password.decode('base64')
    password = decoded_password
    conn=sqlite3.connect(DBPath)
    conn.text_factory=str
    c=conn.cursor()
    try:
        query=c.execute("SELECT * from person where id=? and password=?",[userId,password])
        isValidCredentials=c.fetchall()
        c.close()
        conn.close()    
        if isValidCredentials:
            cmd_Id = get_ccm_command_id()
            message="set,element=code,args=2,action=reboot,uuid={0}".format(cmd_Id)
            send_wd_msg(message) 
            response = get_wd_response(cmd_Id)
            print (response)
        else:
            print (json.JSONEncoder().encode({"status": "error", "description": "Invalid Credentials"}))
        c.close()
        conn.close()
    except Exception as e:
        c.close()
        conn.close()

def rebootServer():
    DBPath="/mnt/data/quantumDB.db"
    if GUI==True:
        userId = form.getvalue('userId')
        password = form.getvalue('password')
        decoded_password = password.decode('base64')
        password = decoded_password
        conn=sqlite3.connect(DBPath)
        conn.text_factory=str
        c=conn.cursor()
        try:
            query=c.execute("SELECT * from person where id=? and password=?",[userId,password])
            isValidCredentials=c.fetchall()
            c.close()
            conn.close()
            path="/mnt/data/iso"
        except:
            c.close()
            conn.close()
    else:
        conn=sqlite3.connect(DBPath)
        conn.text_factory=str
        c=conn.cursor()
        try:
            userName="admin"
            password="Naveen@123"
            query=c.execute("SELECT * from person where userName=? and password=?",[userName,password])
            isValidCredentials=c.fetchall()
            c.close()
            conn.close()
            path="/home/sanuyi/wd"
        except:
            c.close()
            conn.close()

    if isValidCredentials:
        if GUI==True:
            cmd_Id = get_ccm_command_id()
            message="set,element=iso,args=2,element_name=R6000.iso,action=burn,path={0},uuid={1}".format(path,cmd_Id)
            send_wd_msg(message) 
            response = get_wd_response(cmd_Id)
            print (response)
        else:
            LoopMax=30
            loop=0
            test=True
            while (test==True and loop < LoopMax):
                file_size = os.path.getsize(DBPath)
                print("quantumDB.db file Size is :", file_size, "bytes")
                cmd_Id = get_ccm_command_id()
                message="set,element=iso,args=2,element_name=R6000.iso,action=burn,path={0},uuid={1}".format(path,cmd_Id)
                send_wd_msg(message) 
                response = get_wd_response(cmd_Id)
                print (response)
                y=json.loads(response)
                if (y["status"])=="success":
                    loop=loop+1
                    time.sleep(2)
                    cmd_Id = get_ccm_command_id()
                    message="set,element=isoCheck,args=2,element_name=R6000.iso,action=check,path={0},uuid={1}".format(path,cmd_Id)
                    send_wd_msg(message) 
                    response = get_wd_response(cmd_Id)
                    print (response)
                    y=json.loads(response)
                    if (y["status"])=="success":
                        test=True
                        time.sleep(60)
                    else:
                        test=False
                else:
                    loop=LoopMax
                    test=False
    else:
        print (json.JSONEncoder().encode({"status": "error", "description": "Invalid Credentials"}))


print ("Content-type:text/html\r\n\r\n")
if request_Type == 'restart':
    restartServer()
elif request_Type == 'reboot':
    rebootServer()
