#!/usr/bin/python3
import sys
if len(sys.argv) > 1 and sys.argv[1] == "--terminal":
	GUI=False
	CCM=False
else:
	GUI=True
	CCM=False
import cgi, cgitb
import sqlite3
import json
import os

from global_func import get_ccm_command_id,send_ccm_msg,delete_ccm_response,get_ccm_response
from globalSettings import DBPath
cgitb.enable()
form = cgi.FieldStorage()
if GUI == True:
    request_Type = form.getvalue('RequestType')
else:
    print("1. read_NTPServices()")
    print("2. create_NTPServices()")

    choice = int(input("Select cgi funcation => "))
    if(choice == 1):
        request_Type = "read_NTPServices"
    elif(choice == 2):
        request_Type = "create_NTPServices"
    else:
        request_Type = ""


cmd_Id = get_ccm_command_id()
timezone = "UTC"
def getNtpServer(time_zone_val):
    ntpServerDict = {
        "-4":"us.pool.ntp.org",
        "-5":"us.pool.ntp.org",
        "-6":"us.pool.ntp.org",
        "-7":"us.pool.ntp.org",
        "1":"ie.pool.ntp.org",
        "5.5":"in.pool.ntp.org",
        "2":"europe.pool.ntp.org"
    }
    if time_zone_val in ntpServerDict.keys():
        return ntpServerDict[time_zone_val]
    else:
        return "pool.ntp.org"

def create_NTPServices():
    #time_zone_val = form.getvalue('time_zone_val')
    if GUI:
        time_zone = form.getvalue('time_zone')
        #ntp_time_zone = form.getvalue('ntp_time_zone')
        #gmtAdjustment = str(form.getvalue('gmtAdjustment'))
        #ntp_server = getNtpServer(gmtAdjustment)
        ntp_server = form.getvalue('ntp_server')
    else:
        time_zone = input('Enter time_zone => ')
        ntp_server = input('Enter ntp_server => ')
    
    if ntp_server !="" and time_zone!="":
        if CCM:
            cmd = "SaveKMIP"
            message = "set,element=services,element_name={0},args=4,Action={1}," \
                    "time_zone={2},ntp_server={3},uuid={4}" \
                .format("ntServices", cmd,time_zone,ntp_server,cmd_Id)
            send_ccm_msg(message)
            response = get_ccm_response(cmd_Id)
            print (response)
            delete_ccm_response(cmd_Id)
        else:
            conn = sqlite3.connect(DBPath,check_same_thread= False)
            conn.text_factory = str
            c = conn.cursor()
            try:
                query_lan = c.execute("delete from ntpServer")
                conn.commit()
                os.system('sudo timedatectl set-timezone {}'.format(time_zone))
                query_lan = c.execute(
                    "insert into ntpServer (time_zone,ntp_server) values(?,?)",
                    [time_zone, ntp_server])
                conn.commit()
                c.close()
                conn.close()
                print (json.JSONEncoder().encode({"status": "success", "description": "Saved successfully", "time_zone":time_zone}))
                
            except Exception as e:
                c.close()
                conn.close()
                print (json.JSONEncoder().encode({"status": "fail", "description": "Error while saving", "time_zone":time_zone}))
            
    else:
        print (json.JSONEncoder().encode({"status": "fail", "description": "Fill All mandatory fields"})
)
def read_NTPServices():
    #dbquery = "SELECT time_zone_val,time_zone,ntp_server,ntp_time_zone from ntpServer"
    time_zone, ntp_server = '', ''
    dbdata = []
    conn = sqlite3.connect(DBPath,check_same_thread=False)
    conn.text_factory = str
    c = conn.cursor()
    try:
        dbquery = "SELECT time_zone,ntp_server from ntpServer"
        query = c.execute(dbquery)
        
        conn.commit()
        for col in c:
            #jsonschema = {"id": col[0], "time_zone": col[1], "ntp_server": col[2], 'ntp_time_zone':col[3]}
            time_zone= col[0]
            ntp_server= col[1]
        jsonschema = {"time_zone":time_zone, "ntp_server": ntp_server}
        dbdata.append(jsonschema)
        c.close()
        conn.close()
    except Exception as e:
        c.close()
        conn.close()
    print (json.JSONEncoder().encode(dbdata))


print ("Content-type:text/html\r\n\r\n")
if request_Type == 'create_NTPServices':
    create_NTPServices()
elif request_Type == 'read_NTPServices':
    read_NTPServices()
else:
    print (json.JSONEncoder().encode({"test":"test"}))
