#!/usr/bin/python3   

import sqlite3
import json
from globalSettings import DBPath
gui_data = 'DB'
def getRemaining(poolSize,poolID):
    conn = sqlite3.connect(DBPath,check_same_thread=False)
    conn.text_factory = str
    c=conn.cursor()
    used = 0
    remaining =0   
    try:
        c=conn.cursor()
        dbquery=c.execute("select sum(size) from volume where multi_device_id=?",[poolID])
        resp=c.fetchone()[0]
        if (isinstance(resp, int))==True:
            used=int(resp)
        c.close
        conn.close()

        remaining=poolSize-used
        #print "used",used
        #print "poolSize",poolSize
        #print "remaining",remaining
    except Exception as e:
        c.close()
        conn.close()
    return used,remaining

	
def get_dbdata():
    conn = sqlite3.connect(DBPath,check_same_thread=False)
    conn.text_factory = str
    c=conn.cursor()
    dbdata = []
    try:
        dbquery="SELECT id,name,level,pool_storage,state,compression,acceleration,deduplication,system_name,ifnull(pool_storage,0) from multi_device"
        query = c.execute(dbquery)
        conn.commit()
        for col in c:
            poolID = col[0]
            vals= getRemaining(int(col[9]),poolID)
            used=str(vals[0])
            remaining= str(vals[1])
            jsonschema = {  "id":col[0],"name" : col[1],"level" :col[2],"pool_storage" : col[3],"state":col[4],"compression" :col[5],
                            "acceleration" : col[6],"deduplication":col[7],"systemName" : col[8], "remaining":remaining
                        }
            dbdata.append(jsonschema)
        c.close()
        conn.close()
    except Exception as e:
        c.close()
        conn.close()
    return json.JSONEncoder().encode(dbdata)

print ("Content-type:text/html\r\n\r\n")


if (gui_data=='DB'):
	print (get_dbdata())
else:
	print ("Invalid INPUT")


