#!/usr/bin/python3   
import sys
if len(sys.argv) > 1 and sys.argv[1] == "--terminal":
	GUI=False
	CCM=False
else:
	GUI=True
	CCM=False
import cgi, cgitb
from global_gui_data import *
from globalSettings import *
from global_func import *
from clientConfiguration import *
from cgi_OEM import *
import json
import uuid
from clearTextPwd import *
import base64
cgitb.enable()
import sqlite3
form=cgi.FieldStorage()
from logRoutine import *

initLogging()
if GUI == True:
    userName = form.getvalue('userName')
    password = form.getvalue('password')
    request_Type = form.getvalue('RequestType')
else:
    userName = "YWRtaW4= "
    password = "TmF2ZWVuQDEyMw== "
    print("1. Validate User")
    # print("2. Change Password")
    print("2. Logout User")
    print("3. Get Device Name")
    choice = int(input("Select Choice => "))
    if choice == 1:
        request_Type = "ValidateUser"
    # elif choice == 2:
    #     request_Type = "ChangePassword"
    elif choice == 2:
        request_Type = "LogoutUser"
    elif choice == 3:
        request_Type = "getDeviceName"

cmd_Id = get_ccm_command_id()
def UpdateCCM_PW(user,pw):
    name="UpdatePW"
    try:
        message="set,element=test_response,element_name={0},args=3,user={1},pw={2},uuid={3}".format(name,user,pw,cmd_Id)
        send_ccm_msg(message) 
        response = get_ccm_response(cmd_Id)
        #print response
        return 0
    except Exception as e:
        return -1

def btoa(name):
    name_bytes = name.encode('utf-8')
    encoded_name_bytes = base64.b64encode(name_bytes)
    encoded_password = encoded_name_bytes.decode('utf-8')

    return encoded_password

def ValidateUser():
    conn=sqlite3.connect(DBPath)
    conn.text_factory=str
    c=conn.cursor()
    try:
        NodeType = Get_MachineID()
        if GUI == True:
            userName = form.getvalue('userName')
            password = form.getvalue('password')
        else:
            userName = btoa(input("Enter User Name => "))
            password = btoa(input("Enter Password => "))
        if userName==None or password==None:
            print(json.JSONEncoder().encode({"status":"fail","description":"Empty UserName/Password"}))
            return
        else:
            # pass
            decoded_password = (base64.b64decode(password)).decode("utf-8")
            password = decoded_password
            decoded_username = (base64.b64decode(userName)).decode("utf-8")
            userName = decoded_username 
        C_userName = userName
        C_password = password
        ##print uuid.uuid4()
        query_lan=c.execute("Select count(*) from person where userName=? or contactEmail=?",[str(userName),str(userName)])
        isUserExist =c.fetchone()[0]
        conn.commit()
        if isUserExist==0:
            print(json.JSONEncoder().encode({"status":"fail","description":"User Name does not exists"}))
            return
        #print (isUserExist)
        query_pwd = c.execute("select password from person where userName='"+str(userName+"'"))
        db_Pwd = c.fetchone()[0]
        conn.commit()
        isEnPwd = is_EncodedString_base64(db_Pwd)
        if db_Pwd == DEFAULT_PASSWORD:
            password = password
                
        elif not isEnPwd :
            EncPwd = pwd_encoding(password)
            updatePwd = c.execute("update person set password = '"+EncPwd+"' ")
            conn.commit()
            password = EncPwd

        else:
            #password = db_Pwd
            EncryptGUIpwd = pwd_encoding(password)
            password = EncryptGUIpwd
        query = "SELECT id,userName,FirstName,LastName,contactEmail from person where (userName='"+str(userName) +"' or contactEmail='"+str(userName) +"') and password='"+ str(password) + "'"
        #print query
        query_lan=c.execute(query)
        isValidCredentials =c.fetchall()
        conn.commit()
        
        if isUserExist > 0:
            if isValidCredentials:
                default_password = False
                if password == DEFAULT_PASSWORD:
                    default_password = True
                attemptResult = ValidateAttempts(True)
                if attemptResult == False:
                    return
                    
                query = "update person set login_time= datetime(),num_attempt=0 where userName='"+str(userName)+"' or contactEmail='"+str(userName)+"'"
                query_exec=c.execute(query)
                conn.commit()
                
                query = c.execute("SELECT id,userName,FirstName,LastName,contactEmail from person where (userName='"+str(userName) +"' or contactEmail='"+str(userName) +"') and password='"+str(password)+"'")
                jsonUser ={}
                conn.commit()
                for col in c:
                    jsonUser = {"status":"success","id":col[0],"userName" : col[1],"FirstName" :col[2],"LastName" : col[3],"contactEmail" : col[4],"client":NodeType,"clientConfiguration":GetClientConfig(NodeType),"default_password":default_password,'OEMType':GetOEMConfig(NodeType)}               
                
                if not default_password:
                    dArgs=loggerArgs("Login","User logged in",infoLevel,"Logged in")
                    ccmLogger(info,"User: '" + str(userName) + "' has logged in",dArgs) 
                
                UpdateCCM_PW(C_userName,C_password)
                print (json.JSONEncoder().encode(jsonUser))

            else:
                ValidateAttempts(False)
                print (json.JSONEncoder().encode({"status":"fail","description":"Invalid Credentials"}))
        else:
            print (json.JSONEncoder().encode({"status":"fail","description":"User Name does not exists"}))  

        c.close()
        conn.close()
    except Exception as e:
        c.close()
        conn.close()
        print(e)
        print (json.JSONEncoder().encode({"status":"fail","description":"DB is generating.... Please try in few mins with Default Password !!"}))
        
def ChangePassword():
    conn=sqlite3.connect(DBPath)
    conn.text_factory=str
    c=conn.cursor()
    try:
        NodeType = Get_MachineID()
        if GUI ==True:
            userName = form.getvalue('userName')
            password = form.getvalue('password')
            old_password = form.getvalue('old_password')
        else:
            userName = btoa(input("Enter User Name => "))
            password = btoa(input("Enter Password => "))
            old_password = btoa(input("Enter Old Password => "))
        decoded_old_password = (base64.b64decode(old_password)).decode("utf-8")
        old_password = decoded_old_password
        decoded_password = (base64.b64decode(password)).decode("utf-8")
        password = decoded_password
        decoded_username = (base64.b64decode(userName)).decode("utf-8")
        userName = decoded_username
        C_userName=userName
        C_password=password
        
        query_lan=c.execute("Select count(*) from person where userName=? or contactEmail=?",[str(userName),str(userName)])
        isUserExist =c.fetchone()[0]
        conn.commit()
        #print (isUserExist)
        query = "SELECT id,userName,FirstName,LastName,contactEmail from person where (userName='"+str(userName) +"' or contactEmail='"+str(userName) +"') and password='"+ str((old_password)) + "'"
        #print query
        query_lan=c.execute(query)
        isValidCredentials =c.fetchall()
        conn.commit()

        if isUserExist > 0:
            if isValidCredentials:
                default_password = False
                if password == DEFAULT_PASSWORD:
                    default_password = True

                attemptResult = ValidateAttempts(True)
                if attemptResult == False:
                    return
                
                Encryptpassword=dbSavePwd(password)
                password = Encryptpassword
                
                query = "update person set password='"+str(password)+"' where userName='"+str(userName)+"' or contactEmail='"+str(userName)+"'"
                query_exec=c.execute(query)
                conn.commit()

                query = "update person set login_time= datetime(),num_attempt=0 where userName='"+str(userName)+"' or contactEmail='"+str(userName)+"'"
                query_exec=c.execute(query)
                conn.commit()
                
                query = c.execute("SELECT id,userName,FirstName,LastName,contactEmail from person where (userName='"+str(userName) +"' or contactEmail='"+str(userName) +"') and password='"+str(password)+"'")
                jsonUser ={}
                conn.commit()
                for col in c:
                    jsonUser = {"status":"success","id":col[0],"userName" : col[1],"FirstName" :col[2],"LastName" : col[3],"contactEmail" : col[4],"client":NodeType,"clientConfiguration":GetClientConfig(NodeType),"default_password":default_password,'OEMType':GetOEMConfig(NodeType)}

                if not default_password:
                    dArgs=loggerArgs("Login","Password update",infoLevel,"Password update")
                    ccmLogger(info,"Password updated by " + str(userName),dArgs)
                    dArgs=loggerArgs("Login","User logged in",infoLevel,"logged in")
                    ccmLogger(info,"User: '" + str(userName) + "' has logged in",dArgs)
                    
                UpdateCCM_PW(C_userName,C_password)
                print (json.JSONEncoder().encode(jsonUser))
                
            else:
                ValidateAttempts(False)
                print (json.JSONEncoder().encode({"status":"fail","description":"Invalid Credentials"}))
        else:
            print (json.JSONEncoder().encode({"status":"fail","description":"User Name does not exists"}))
        c.close()
        conn.close()
    except Exception as e:
        c.close()
        conn.close()

def ValidateAttempts(isValidUser):  
    conn=sqlite3.connect(DBPath)
    conn.text_factory=str
    c=conn.cursor()
    try:
        FailedAttemptsCount = 0
        TimeLeftInSeconds = 0
        query = "select num_attempt, (CAST(strftime('%s', CURRENT_TIMESTAMP) as integer) - CAST(strftime('%s', login_time) as integer)) duration from person where userName='"+str(userName)+"' or contactEmail='"+str(userName)+"'"
        query_exec=c.execute(query)
        conn.commit()
        for col in c:
            FailedAttemptsCount=col[0]
            TimeLeftInSeconds = col[1]
        
        if isValidUser == True:
            if (FailedAttemptsCount == 1 and TimeLeftInSeconds < 10):
                print (json.JSONEncoder().encode({"status":"fail","description":"Please try after "+str(10 - TimeLeftInSeconds)+" seconds","isUserBlocked":True,"timeLeft":10 - TimeLeftInSeconds}))
                return False
            elif (FailedAttemptsCount == 2 and TimeLeftInSeconds < 20):
                print (json.JSONEncoder().encode({"status":"fail","description":"Please try after "+str(20 - TimeLeftInSeconds)+" seconds","isUserBlocked":True,"timeLeft":20 - TimeLeftInSeconds}))
                return False
            elif (FailedAttemptsCount >= 3 and TimeLeftInSeconds < 60):
                print (json.JSONEncoder().encode({"status":"fail","description":"Please try after "+str(60 - TimeLeftInSeconds)+" seconds","isUserBlocked":True,"timeLeft":60 - TimeLeftInSeconds}))
                return False
            
        elif isValidUser == False:
            query = "update person set login_time= datetime(),num_attempt=num_attempt+1 where userName='"+str(userName)+"' or contactEmail='"+str(userName)+"'"
            query_exec=c.execute(query)
            conn.commit()
        c.close()
        conn.close()
    except Exception as e:
        c.close()
        conn.close()
    
def LogoutUser():
    if GUI == True:
        userName = form.getvalue('userName')
    else:
        userName = "YWRtaW4= "
    decoded_username = (base64.b64decode(userName)).decode("utf-8")
    userName = decoded_username
    uuid = form.getvalue('uuid')
    dArgs=loggerArgs("Logout","User logged out",infoLevel,"Logged out")
    ccmLogger(info,"User: '" + str(userName) + "' has logged out of session ID: '" + str(uuid) + "'",dArgs)
    print (json.JSONEncoder().encode({"status":"success","description":"Logged Out Successfully!"}))

def getDeviceName():
    print (json.JSONEncoder().encode({"device":OEMType}))

print ("Content-type:text/html\r\n\r\n")

if request_Type == 'ValidateUser':
    ValidateUser()
elif request_Type == 'ChangePassword':
    ChangePassword()
elif request_Type == "LogoutUser":
    LogoutUser()
if request_Type == "getDeviceName":
    getDeviceName()



