#!/usr/bin/python3
# -*- coding: utf-8 -*-

from cgi_Global_myserver_totResources import *
import cgi
import cgitb
import sqlite3
import ftplib
import os
import json
import datetime
from globalSettings import DBPath
cgitb.enable()

#this function will convert bytes to MB.... GB... etc
def convert_bytes(num):    
    if num != None:
        for x in ['Bytes', 'KB', 'MB', 'GB', 'TB']:
            if num < 1024.0:
                return '%3.1f %s' % (num, x)
            num /= 1024.0
    else:
        return '0 Bytes'

#this function will return the file size
def Get_file_size(file_path,fileSize):    
    if os.path.isfile(file_path):
        file_info = os.stat(file_path)
        sizeinBytes = file_info.st_size
        return (sizeinBytes * 100 / long(fileSize))
		
def GetfilesizeByPath(file_path):    
    if os.path.isfile(file_path):
        file_info = os.stat(file_path)
        sizeinBytes = file_info.st_size
        return sizeinBytes

def GetDownloadingImages():
	downloadList=[]
	conn=sqlite3.connect(DBPath)
	conn.text_factory=str
	c=conn.cursor()
	query = c.execute(""" Select * from 
						(
						SELECT id,image_name,path_app_saved,vm_image_size,vm_group_id,downloded,download_percentage from vm_image where downloded ='in progress'
						UNION
						SELECT id,BackupName,local_path,vm_image_size,vm_group_id,download_state,download_percentage from myBackups where download_state ='in progress'
						)
						""")
	dbdata = []
	conn.commit()
	for col in c:
		downloadList.append({"id" : col[0],"name" :col[1],"path_app_saved" : col[2],"image_size" : col[3],"group_id" : col[4],"download_percentage" :col[5]})		
	c.close()
	conn.close()
	return downloadList
	
def CalculateDownloadedPercent():
    conn=sqlite3.connect(DBPath)
    conn.text_factory=str
    c=conn.cursor()
    try:
        downloadingImages = GetDownloadingImages()
        for di in downloadingImages:
            if di['group_id'] == 16:
                downloadPercent = Get_file_size(di['path_app_saved'],di['image_size'])
                query_lan=c.execute("update BackupHistory set download_percentage=? where id=?",[downloadPercent,di['id']])
                conn.commit()
            else:
                downloadPercent = Get_file_size(di['path_app_saved'],di['image_size'])
                query_lan=c.execute("update vm_image set download_percentage=? where id=?",[downloadPercent,di['id']])
                conn.commit()
        c.close()
        conn.close()
    except Exception as e:
        
        c.close()
        conn.close()
			
CalculateDownloadedPercent()
		



			