#!/usr/bin/python3

import cgi,cgitb
import sqlite3
import ftplib
import os
import json
import zipfile
from globalSettings import *
import test_DockerSDK
cgitb.enable()

form = cgi.FieldStorage()
if form.getvalue('image_id'):
	image_id = form.getvalue('image_id')
else:
	image_id = "Not Entered"

FtpServer= FTPServerURL
ServerUser = FTPServerUser
ServerPwd = FTPServerPwd
source=''	#'/image1'
SourceFilename=''	#'xdd.tar.gz'
destination= AppImagesPath 
DowloadedFileName=''	#'image1.zip'

conn=sqlite3.connect(DBPath)
conn.text_factory=str
c=conn.cursor()
try:
	query_lan=c.execute("Select count(*) from vm_image where downloded='in progress'")
	inProgressCount =0 #c.fetchone()[0]
	conn.commit()


	#query_lan=c.execute("Select file_name,path_app_saved,app_download_server,image_type,vm_group.group_name,vm_image.image_name from vm_image inner join vm_group on vm_image.vm_group_id=vm_group.id  where vm_image.id="+image_id)
	query_lan=c.execute("Select file_name,path_app_saved,app_download_server,image_type,vm_group.group_name,vm_image.image_name from vm_image inner join vm_group on vm_image.vm_group_id=vm_group.id  where vm_image.id="+image_id)
	for col in c:
		if str(col[3]) == 'docker':
			extension = 'zip'
		else:
			extension = str(col[3])

		SourceFilename = str(col[0])+'.'+extension
		DowloadedFileName = str(col[5])+'.'+extension #old logic   str(col[0])+'.'+str(col[3])	
		source = str(col[2])
		destination=destination + '/' + col[4]
		image_name = str(col[5])
		#group_name = col[4]
		image_type = col[3]
		
	conn.commit()
	c.close()
	conn.close()
except Exception as e:
	c.close()
	conn.close()


if not os.path.exists(destination) and source !='' and source !='None':
    os.makedirs(destination)


def DownloadImage():	
	conn=sqlite3.connect(DBPath)
	conn.text_factory=str
	c=conn.cursor()	
	try:
		ftp =ftplib.FTP(FtpServer)
		ftp.login(ServerUser,ServerPwd)
		isPathExists=source.replace(source[:1], '') in ftp.nlst()
		if isPathExists:
			ftp.cwd(source)
			#print(ftp.nlst())
			isFileExists = SourceFilename in ftp.nlst()
			if isFileExists:
				ftp.quit()
				query_update=c.execute("update vm_image set downloded = ?,path_app_saved=?,download_percentage=0 where id=?",('in progress',destination+'/'+DowloadedFileName,image_id))
				conn.commit()
				#test_DockerSDK.download_buildImage(FtpServer,ServerUser,ServerPwd,destination,DowloadedFileName,SourceFilename,source,extension,image_name,group_name)
				test_DockerSDK.download_buildImage(FtpServer,ServerUser,ServerPwd,destination,DowloadedFileName,SourceFilename,source,extension,image_name,image_type)
				update_vmImage(DowloadedFileName)
			else:
				print(json.JSONEncoder().encode({'status':'fail','data':'Image not available, Will available soon...'}))
		else:
			print(json.JSONEncoder().encode({'status':'fail','data':'Image not available, Will available soon...'}))
	except Exception as e:
		c.close()
		conn.close()

def update_vmImage(DowloadedFileName):
	conn=sqlite3.connect(DBPath)
	conn.text_factory=str
	c=conn.cursor()
	try:
		if(extension=='zip'):
			filenames = SourceFilename.split('.')  #if the file is a zip file, the extracted folder name is stored in 'path_app_saved'
			DowloadedFileName = filenames[0]     #we are assuming that there is only one folder inside the downloaded zip
		query_update=c.execute("update vm_image set downloded = ?,path_app_saved=?,download_percentage=100 where id=?",('yes',destination+'/'+DowloadedFileName,image_id))  #old logic +'/'+DowloadedFileName
		conn.commit()
		c.close()
		conn.close()

		print(json.JSONEncoder().encode({'status':'success','data':'successfully downloaded','DowloadedPath':destination+'/'+DowloadedFileName}))
	except Exception as e:
		c.close()
		conn.close()
print ("Content-type:text/html\r\n\r\n")
#print source
conn=sqlite3.connect(DBPath)
conn.text_factory=str
c=conn.cursor()
try:
	if source !='' and source !='None':
		if inProgressCount == 0:
			try:
				DownloadImage()
			except Exception as e:
				query_update=c.execute("update vm_image set downloded = ? where id=?",('no',image_id))
				conn.commit()
				print(json.JSONEncoder().encode({'status':'fail','data':str(e)}))
		else:
			print(json.JSONEncoder().encode({'status':'fail','data':'Another image downloading Inprogress, Please try after some time'}))
			
	else:
		print(json.JSONEncoder().encode({'status':'fail','data':'Image not available, Will available soon...'}))
	c.close()
	conn.close()
except Exception as e:
	c.close()
	conn.close()
