#!/usr/bin/python3

import cgi,cgitb
import sqlite3
import json
import datetime
from globalSettings import DBPath

res_ntw_Dtls=[]


form=cgi.FieldStorage()


if form.getvalue('server_name'):
	server_name=form.getvalue('server_name')
else:
	server_name="Not Entered"

def serverDetails(name):
	conn=sqlite3.connect(DBPath)
	conn.text_factory=str
	c=conn.cursor()
	try:
		query=("select ntw.name,ntw.cidr,vm.name,vm.state,ntw.id "+\
			"from network as ntw "+\
			"join veth_port as vep "+\
			"on ntw.id=vep.network_id "+\
			"join vm_network as vmntw "+\
			"on vep.id=vmntw.veth_id "+\
			"and vmntw.veth_id=vmntw.veth_id "+\
			"join virtualmachine as vm "\
			"on vmntw.vm_id=vm.id "+\
			"where vm.name='"+name+"'")
		#print query
		result=c.execute(query)

		conn.commit()

		for res in c:
			temp={}
			temp["NetworkName"]=res[0]
			temp["cidr"]=res[1]
			temp["ServerName"]=res[2]
			temp["State"]=res[3]		#State of Virtual machine 4=ON,5=Starting,6=OFF,7=Suspended
			temp["networkId"]=res[4]
			res_ntw_Dtls.append(temp)

		print (json.JSONEncoder().encode(res_ntw_Dtls))
		c.close()
		conn.close()
	except Exception as e:
		c.close()
		conn.close()


print ("Content-type:text/html\r\n\r\n")
serverDetails(server_name)