#!/usr/bin/python3

import sys
if len(sys.argv) > 1 and sys.argv[1] == "--terminal":
	GUI=False
	CCM=False
else:
	GUI=True
	CCM=False
	
import cgi,cgitb
import sqlite3
import datetime
import json
from globalSettings import DBPath
cgitb.enable()

#res_available=[]

form=cgi.FieldStorage()
server_name=form.getvalue('server_name')




def sys_tot_CMS():
	conn = sqlite3.connect(DBPath)
	conn.text_factory = str
	c = conn.cursor()
	try:
		q_sysTot_cms=c.execute("select total_vcpu,total_memoryGB,total_storageGB from system where name='System1'")
		res_sysTot_cms = []
		for val in c:
			res_sysTot_cms=val
		c.close()
		conn.close()
		return res_sysTot_cms
	except Exception as e:
		c.close()
		conn.close()

def sys_usd_CMS():
	conn = sqlite3.connect(DBPath)
	conn.text_factory = str
	c = conn.cursor()
	try:
		q_sysUsd_cms=c.execute("select used_vcpu,used_memoryGB,used_storageGB from system where name='System1'")
		res_sysUsd_cms = []
		for val in c:
			res_sysUsd_cms=val
		c.close()
		conn.close()
		return res_sysUsd_cms	
	except Exception as e:
		c.close()
		conn.close()

def available_Resources():	

	tot_CMS=sys_tot_CMS()
	usd_CMS=sys_usd_CMS()
	temp={}
	temp["vcpu"]=tot_CMS[0]-usd_CMS[0]
	temp["memoryGB"]=tot_CMS[1]-usd_CMS[1]
	temp["storageGB"]=(tot_CMS[2]-usd_CMS[2])/1024
	
	used={}
	used["vcpu"]=usd_CMS[0]
	used["memoryGB"]=usd_CMS[1]
	used["storageGB"]=(usd_CMS[2])/1024
	
	print(json.JSONEncoder().encode({"free":temp,"used":used}))

print("Content-type:text/html\r\n\r\n")
available_Resources()






