#!/usr/bin/python

import cgi, cgitb
from global_func import *

cgitb.enable()
import sqlite3
import json
from db import *
from logRoutine import *
initLogging()
from globalSettings import *
from clearTextPwd import *

form = cgi.FieldStorage()
request_Type = form.getvalue('RequestType')
cmd_Id = get_ccm_command_id()

CCM = True
def create_CBAServices():
    enCBA = form.getvalue('enCBA')
    enSSH = form.getvalue('enSSH')

    userId = form.getvalue('userId')
    user_password = form.getvalue('password')
    user_password = user_password.decode('base64')
    db_filename = DBPath
    conn=sqlite3.connect(db_filename)
    conn.text_factory=str
    c=conn.cursor()
    
    query_pwd = c.execute("select password from person where id=?",[userId])
    db_Pwd = c.fetchone()[0]
    conn.commit()

    isEnPwd = is_EncodedString_base64(db_Pwd)
    if isEnPwd :
        EncryptGUIpwd = pwd_encoding(user_password)
        user_password = EncryptGUIpwd

    query=c.execute("SELECT * from person where id=? and password=?",[userId,user_password])
    isValidCredentials=c.fetchall()
    if not isValidCredentials:
        print json.JSONEncoder().encode({"status": "fail", "description": "Invalid user password"})
        c.close()
        conn.close()
        return

    if enCBA!="" and enSSH!="":
        if CCM == True:
            cmd = "update_cba_ssh"
            cmd_Id = get_ccm_command_id()
            message = "set,element=cbaServer,element_name={0},args=4,Action={1},enableCBA={2},enableSSH={3},uuid={4}" \
                .format("cba_ssh", cmd, enCBA, enSSH, cmd_Id)
            send_ccm_msg(message)
            response = get_ccm_response(cmd_Id)
            print response
            delete_ccm_response(cmd_Id)

        else:
            query_lan = c.execute("delete from cbaServer")
            conn.commit()
            query_lan = c.execute(
                "insert into cbaServer (enableCBA, enableSSH) values(?,?)",
                [enCBA, enSSH])
            conn.commit()
            dArgs=loggerArgs("cbaServer/" + "CBA_SSH_serviceManager","enable CBA = {} enable SSH = {}".format(enCBA, enSSH),infoLevel,"create")
            ccmLogger(info,"successfully created enable CBA = {} enable SSH = {}".format(enCBA, enSSH),dArgs)
            print json.JSONEncoder().encode({"status": "success", "description": "Saved successfully"})
    else:
        dArgs=loggerArgs("cbaServer/" + "CBA_SSH_serviceManager","enable CBA = {} enable SSH = {}".format(enCBA, enSSH),errorLevel,"create")
        ccmLogger(error,"Fill All mandatory fields",dArgs)
        print json.JSONEncoder().encode({"status": "fail", "description": "Fill All mandatory fields"})

    c.close()
    conn.close()

def read_CBAServices():
    enableSSH, enableCBA = '', ''
    db_filename = DBPath
    conn=sqlite3.connect(db_filename)
    conn.text_factory=str
    c=conn.cursor()
    dbquery = "SELECT id, enableCBA, enableSSH from cbaServer"
    query = c.execute(dbquery)
    dbdata = []
    conn.commit()
    for col in c:
        id, enableCBA, enableSSH = col[0], col[1], col[2]
    
    jsonschema = {"id": id, "enableCBA": enableCBA, "enableSSH": enableSSH}
    dbdata.append(jsonschema)
    c.close()
    conn.close()
    print json.JSONEncoder().encode(dbdata)


print ("Content-type:text/html\r\n\r\n")
if request_Type == 'create_CBAServices':
    create_CBAServices()
elif request_Type == 'read_CBAServices':
    read_CBAServices()
else:
    print Json.JSONEncoder().encode({"test"})
