#!/usr/bin/python

import cgi, cgitb
from global_func import *

cgitb.enable()
import sqlite3
import json
from db import *
from logRoutine import *
initLogging()

import os

form = cgi.FieldStorage()
request_Type = form.getvalue('RequestType')
cmd_Id = get_ccm_command_id()
CCM = false
timezone = "UTC"
def getNtpServer(time_zone_val):
    ntpServerDict = {
        "-4":"us.pool.ntp.org",
        "-5":"us.pool.ntp.org",
        "-6":"us.pool.ntp.org",
        "-7":"us.pool.ntp.org",
        "1":"ie.pool.ntp.org",
        "5.5":"in.pool.ntp.org",
        "2":"europe.pool.ntp.org"
    }
    if time_zone_val in ntpServerDict.keys():
        return ntpServerDict[time_zone_val]
    else:
        return "pool.ntp.org"

def create_NTPServices():
    #time_zone_val = form.getvalue('time_zone_val')
    time_zone = form.getvalue('time_zone')
    #ntp_time_zone = form.getvalue('ntp_time_zone')
    #gmtAdjustment = str(form.getvalue('gmtAdjustment'))
    #ntp_server = getNtpServer(gmtAdjustment)
    ntp_server = form.getvalue('ntp_server')
    
    if ntp_server !="" and time_zone!="":
        if CCM:
            cmd = "SaveKMIP"
            message = "set,element=services,element_name={0},args=7,Action={1}," \
                    "time_zone={2},ntp_server={3},uuid={4}" \
                .format(sender, cmd,time_zone_val,time_zone, ntp_server, cmd_Id)
            send_ccm_msg(message)
            response = get_ccm_response(cmd_Id)
            dArgs=loggerArgs("ntpServer/" + "NTP_serviceManager","NTP",infoLevel,"create")
            ccmLogger(info,response["description"],dArgs)
            print response
            delete_ccm_response(cmd_Id)
        else:
            query_lan = c.execute("delete from ntpServer")
            conn.commit()
	    os.system('sudo timedatectl set-timezone {}'.format(time_zone))
            query_lan = c.execute(
                "insert into ntpServer (time_zone,ntp_server) values(?,?)",
                [time_zone, ntp_server])
            conn.commit()
            dArgs=loggerArgs("ntpServer/" + "NTP_serviceManager","NTP",infoLevel,"create")
            ccmLogger(info,"Saved successfully " + str(ntp_server),dArgs)
            print json.JSONEncoder().encode({"status": "success", "description": "Saved successfully", "time_zone":time_zone})
    else:
        dArgs=loggerArgs("ntpServer/" + "NTP_serviceManager","NTP",errorLevel,"create")
        ccmLogger(error,"Fill All mandatory fields",dArgs)
        print json.JSONEncoder().encode({"status": "fail", "description": "Fill All mandatory fields"})

    c.close()
    conn.close()

def read_NTPServices():
    #dbquery = "SELECT time_zone_val,time_zone,ntp_server,ntp_time_zone from ntpServer"
    time_zone, ntp_server = '', ''
    dbquery = "SELECT time_zone,ntp_server from ntpServer"
    query = c.execute(dbquery)
    dbdata = []
    conn.commit()
    for col in c:
        #jsonschema = {"id": col[0], "time_zone": col[1], "ntp_server": col[2], 'ntp_time_zone':col[3]}
        time_zone= col[0]
        ntp_server= col[1]
    jsonschema = {"time_zone":time_zone, "ntp_server": ntp_server}
    dbdata.append(jsonschema)
    conn.close()
    print json.JSONEncoder().encode(dbdata)


print ("Content-type:text/html\r\n\r\n")
if request_Type == 'create_NTPServices':
    create_NTPServices()
elif request_Type == 'read_NTPServices':
    read_NTPServices()
else:
    print Json.JSONEncoder().encode({"test"})
