#!/usr/bin/python   

import cgi, cgitb
from global_gui_data import *
import json
from db import *

cgitb.enable()
import sqlite3


def getRemaining(poolSize,poolID):
    c=conn.cursor()
    used = 0
    remaining =0   
    dbquery=c.execute("select sum(size) from volume where multi_device_id=?",[poolID])
    resp=c.fetchone()[0]
    if (isinstance(resp, int))==True:
        used=int(resp)
    c.close

    remaining=poolSize-used
    #print "used",used
    #print "poolSize",poolSize
    #print "remaining",remaining
    return used,remaining

	
def get_dbdata():
    dbquery="SELECT id,name,level,pool_storage,state,compression,acceleration,deduplication,system_name,ifnull(pool_storage,0) from multi_device"
    query = c.execute(dbquery)
    dbdata = []
    conn.commit()
    for col in c:
        poolID = col[0]
        vals= getRemaining(int(col[9]),poolID)
        used=str(vals[0])
        remaining= str(vals[1])
        jsonschema = {  "id":col[0],"name" : col[1],"level" :col[2],"pool_storage" : col[3],"state":col[4],"compression" :col[5],
                        "acceleration" : col[6],"deduplication":col[7],"systemName" : col[8], "remaining":remaining
                    }
        dbdata.append(jsonschema)
    conn.close()
    return json.JSONEncoder().encode(dbdata)

def fakedata():
	mockdata	= []
	return json.JSONEncoder().encode(mockdata)



print "Content-type:text/html\r\n\r\n"


if (gui_data=='DB'):
	print get_dbdata()	

elif(gui_data=='FAKE'):
	print fakedata()

else:
	print "Invalid INPUT"


