#!/usr/bin/python

from global_func import *
import sqlite3
import json
from db import *
#States in vm and volumes are defined as 4-OFF,5-STARTING,6-ON,7-SUSPENDED

GUI=False
CCM=True
if GUI==True:
    import cgi,cgitb
    cgitb.enable()

IQN="iqn.2018-04.com.quantum:vdisk"


def MakeVolumes():
    Loop=0
    nbVols=int(raw_input("Number of Vols ==>"))
    nbLoops=int(raw_input("Number of Loops ==>"))
    #cifs=1
    #nfs=2
    #iSCSI_Chap=3
    #iSCSI_NoChap=4    
    p=int(raw_input("protocol 1(cifs), 2(nfs) 3(iSCSI_CHAP), 4(iSCSI_NoChap)==>"))
    HostName=raw_input("Host ==>")    
    if (p ==1 or p==2 or p==3 or p==4):
        print "protocol OK ",p
    else:
        print "protocol NOT OK ",p
        exit(0)
    test=raw_input("Test Type (c)reate (d)elete (b)oth ")

    if (test=='c' or test=='d' or test=='b'):
        while(Loop<nbLoops):
            poolName="mrp1"
            size=50
            MakeVol(nbVols,poolName,HostName,size,Loop,test,p)
            Loop=Loop+1
            print ("Loop=",Loop)
            time.sleep(5)
    else:
        print "invalid Option",test
        exit (0)
    exit(0)


def MakeVol(nbVols,poolName,HostName,size,Loop,test,protocolId):

    db_filename = DBPath
    conn=sqlite3.connect(db_filename)
    conn.text_factory=str
    c=conn.cursor()

    fo = open("makevol.txt","ab")
    fo.seek(0, os.SEEK_END)    
    query=c.execute("select id from multi_device where system_name='"+ str(poolName)+"'")
    resp=c.fetchone()
    print resp
    if resp !=str("None"):
        poolId=resp[0]
    print poolName,poolId

    query=c.execute("select id from host where name='"+ str(HostName)+"'")
    resp=c.fetchone()
    print resp    
    if resp!="None":
        hostId=resp[0]
    print HostName,hostId

    dedup="No"
    compression="No"
    backup_device="false" 
    #protocolId =protocol
    lun=1
    portId=1
    i=0
    if (test=='c' or test=='b'):
        while (i<nbVols):
    #Step 1 create Volume    
#volumeName=backup1&size=10&dedup=false&compression=false&backup_device=false&protocolId=2&poolId=6&hostId=4&lun=5&portId=2&uuid=m9eJO30B
            cmd="VolCreate"
            if (protocolId ==nfs):
                VolType='F'
                volumeName="nfs"+str(i)
            elif (protocolId ==cifs):
                VolType='F'
                volumeName="cifs"+str(i)
            else:
                VolType='B'
                volumeName="lvtest"+str(i)
            cmd_Id = get_ccm_command_id()
            message="set,element=volume,element_name={0},args=8,action={1},VolSize={2},VolType={3},PoolID={4},lun={5},Dedup={6},Compression={7},prot={8},backup_device={9},uuid={10}".\
            format(volumeName,cmd,size,VolType,poolId,lun,dedup,compression,protocolId,backup_device,cmd_Id)
            print ("Create Volume",volumeName)
            send_ccm_msg(message) 
            response = get_ccm_response(cmd_Id)
            print response
            delete_ccm_response(cmd_Id)
            query=c.execute("select id from Volume where name='"+ str(volumeName)+"'")
            resp= c.fetchone()
            if str(resp) != str("None"):
                volumeId= resp[0]
                query_SP=c.execute("update volume set backup_device=? where id=?",[backup_device,volumeId])
                conn.commit()
                query_SP=c.execute("insert into  export(port_id,vol_id,host_id,lun) values(?,?,?,?)",[portId,volumeId,hostId,lun])
                conn.commit()
            logData=str(Loop)+":"+cmd+":"+volumeName
            fo.write(logData)
            fo.write("\n")
            fo.write (response)
            fo.write("\n")
            i=i+1

    #Step 2 Turn on Volume

            time.sleep(1)
            cmd_Id = get_ccm_command_id()
            cmd="VolStart"
            message="set,element=volume,element_name={0},args=3,action={1},PoolID={2},prot={3},uuid={4}".\
            format(volumeName,cmd,poolId,protocolId,cmd_Id)
            print ("Turn On Volume",volumeName)
            send_ccm_msg(message) 
            response = get_ccm_response(cmd_Id)
            print response
            logData=str(Loop)+":"+cmd+":"+volumeName
            fo.write(logData)
            fo.write("\n")
            fo.write(response)
            fo.write("\n")

    i=0
    if (test=='d' or test=='b'):    
        while (i<nbVols):
            time.sleep(1)
            if (protocolId ==nfs):
                VolType='F'
                volumeName="nfs"+str(i)
            elif (protocolId ==cifs):
                VolType='F'
                volumeName="cifs"+str(i)
            else:
                VolType='B'
                volumeName="lvtest"+str(i)
                
            query=c.execute("select id from Volume where name='"+ str(volumeName)+"'")
            resp=c.fetchone()
            if resp!="None":
                volumeId = resp[0]
                cmd="VolStop"
    #Step 3 Turn off Volume
                cmd_Id = get_ccm_command_id()
                message="set,element=volume,element_name={0},args=3,action={1},PoolID={2},prot={3},uuid={4}".\
                format(volumeName,cmd,poolId,protocolId,cmd_Id)
                print ("Turn Off Volume",volumeName)
                send_ccm_msg(message) 
                response = get_ccm_response(cmd_Id)
                print response
                logData=str(Loop)+":"+cmd+":"+volumeName
                fo.write(logData)
                fo.write("\n")
                fo.write(response)
                fo.write("\n")
                time.sleep(1)
                query_lan=c.execute("select count(*) from Volume where state=6 and id='"+ str(volumeId)+"'")
                state = c.fetchone()[0]
                conn.commit()
                if state == 0:
    #Step 4 Delete Volume
                    print ("Delete Volume",volumeName)
                    query=c.execute("select multi_device_id from Volume where id='"+ str(volumeId)+"'")
                    poolId = c.fetchone()[0]
                    cmd="VolDelete"
                    cmd_Id = get_ccm_command_id()
                    message="set,element=volume,element_name={0},args=2,action={1},prot={2},PoolID={3},uuid={4}".\
                    format(volumeName,cmd,protocolId,poolId,cmd_Id)            
                    send_ccm_msg(message) 
                    response = get_ccm_response(cmd_Id)
                    delete_ccm_response(cmd_Id)
                    print response
            else:
                    print json.JSONEncoder().encode({'status':'fail','description':'Cannot Delete running Volume'})
            logData=str(Loop)+":"+cmd+":"+volumeName
            fo.write(logData)
            fo.write("\n")
            fo.write(response)
            fo.write("\n")
            i=i+1
    c.close()
    conn.close()
    fo.flush()
    fo.close()
    
#import ccm_constants
if GUI==True:
    form = cgi.FieldStorage()
    request_Type=form.getvalue('requestType')
    volOff=4
    volStarting=5
    volOn=6
    VolSuspended=7
    cifs=1
    nfs=2
    iSCSI_Chap=3
    iSCSI_NoChap=4
    ftp=5
    fc=6
    

else:
    volOff=4
    volStarting=5
    volOn=6
    VolSuspended=7
    cifs=1
    nfs=2
    iSCSI_Chap=3
    iSCSI_NoChap=4
    ftp=5
    fc=6
    print '1. read_Volume'
    print '2. delete_Volume'
    print '3. create_Volume'
    print '4. update_Volume'
    print '5. read_Ethernet_ports'
    print '6. onOff_Volume'
    print '7. snapShot_volume'
    print '8 read_HostByProtocol'
    print '9 read_read_VolumeInfo'
    print '10 Test Volumes'
    choice=int(raw_input("select cgi function==>"))
    if (choice==1):
        request_Type='read_Volume'
    if (choice==2):
        request_Type='delete_Volume'
    if (choice==3):
        request_Type='create_Volume'
    if (choice==4):
        request_Type='update_Volume'
    if (choice==5):
        request_Type='read_Ethernet_ports'
    if (choice==6):
        request_Type='onOff_Volume'
    if (choice==7):
        request_Type='snapShot_volume'
    if (choice==8):
        request_Type='read_HostByProtocol'
    if (choice==9):
        request_Type='read_VolumeInfo'
    if (choice==10):
        MakeVolumes()
    print "Reques_Type="+str(request_Type)
cmd_Id = get_ccm_command_id()


def form_getvalue(val):
    if (val=='volumeName'):
        vol=str(raw_input("input Volume Name==>"))
        return vol
    elif (val=='size'):
        return 10
    elif (val=='poolId'):
        id=raw_input("Pool ID==>")
        return id
    elif (val=='hostId'):
        id=raw_input("Host ID==>")
        return id
    elif (val=='dedup'):
        return 'false'
    elif (val=='compression'):
        return 'false'
    elif (val=='protocolId'): 
        pid=raw_input("input protocol ID, 1 for File 3 for Block ==>")
        return pid
    elif (val=='lun'):
        myLun=raw_input("input Lun number==>")
        return myLun
    elif (val=='portId'):
        return 1
    elif (val=='state'):
        state_val=raw_input("4 for Off 6 for On==>")
        return state_val
    elif (val=='snapShotName'):
        vol=str(raw_input("input SnapShot Volume Name==>"))
        return vol
    elif (val=='volumeId'):
        volID=raw_input("input Volume ID==>")
        return volID
    elif (val=='backup_device'):
        bkup=raw_input("backup (f)alse, t(rue)==>")
        return bkup        
    elif (val=='volumeType'):
        volID=raw_input("0=Native ==>")
        return "Native"
    return 'null'


def create_Volume():
    if (GUI==True):
        volumeName=form.getvalue('volumeName')
        size=form.getvalue('size') 
        poolId=form.getvalue('poolId') 
        hostId=form.getvalue('hostId') 
        dedup=form.getvalue('dedup') 
        compression=form.getvalue('compression')
        backup_device=form.getvalue('backup_device')
        protocolId =form.getvalue('protocolId') 
        lun=form.getvalue('lun') 
        portId=form.getvalue('portId') 
    else:
        volumeName=form_getvalue('volumeName')
        size=form_getvalue('size') 
        poolId=form_getvalue('poolId') 
        hostId=form_getvalue('hostId') 
        dedup=form_getvalue('dedup') 
        compression=form_getvalue('compression')
        backup_device=form_getvalue('backup_device')         
        protocolId =form_getvalue('protocolId') 
        lun=form_getvalue('lun') 
        portId=form_getvalue('portId')
    
    query_lan=c.execute("select count(*) from Volume where name='"+ str(volumeName)+"'")
    nameCount = c.fetchone()[0]
    conn.commit()
    if nameCount == 0:
        if int(protocolId)==int(iSCSI_Chap):
            VolType="B"
        elif int(protocolId)==int(iSCSI_NoChap):
            VolType="B"
        else:
            VolType="F"
        if (CCM==True):
            cmd="VolCreate"
            message="set,element=volume,element_name={0},args=8,action={1},VolSize={2},VolType={3},PoolID={4},lun={5},Dedup={6},Compression={7},prot={8},backup_device={9},uuid={10}".\
            format(volumeName,cmd,size,VolType,poolId,lun,dedup,compression,protocolId,backup_device,cmd_Id)
            send_ccm_msg(message) 
            response = get_ccm_response(cmd_Id)
            #print json.JSONEncoder().encode({'status':'success','description':'Saved XYZ  successfully'})
            print response

        if (CCM==False):
            query=c.execute("insert into  Volume(name,state,size,deduplication,compression,multi_device_id,cr_date) values(?,?,?,?,?,?,datetime())",[volumeName,4,size,dedup,compression,poolId])
            conn.commit()

        query=c.execute("select id from Volume where name='"+ str(volumeName)+"'")
        resp= c.fetchone()
        if str(resp) != str("None"):
            volumeId= resp[0]
            query_SP=c.execute("update volume set backup_device=? where id=?",[backup_device,volumeId])
            conn.commit()
            query_SP=c.execute("insert into  export(port_id,vol_id,host_id,lun) values(?,?,?,?)",[portId,volumeId,hostId,lun])
            conn.commit()
            if (CCM==False):
                print json.JSONEncoder().encode({'status':'success','description':'Volume created successfully'})
    
    else:
        print json.JSONEncoder().encode({'status':'fail','description':'Volume Name Already Exists'})
    c.close()
    conn.close()

def update_Volume():
    volumeName=form.getvalue('volumeName')
    size=form.getvalue('size') 
    poolId=form.getvalue('poolId') 
    hostId=form.getvalue('hostId') 
    protocolId =form.getvalue('protocolId')
    compression=form.getvalue('compression')
    dedup =form.getvalue('dedup')   
    lun=form.getvalue('lun') 
    portId=form.getvalue('portId') 
    volumeId = form.getvalue('volumeId')
    backup_device = form.getvalue('backup_device')
    
    query_lan=c.execute("select count(*) from Volume where state=6 and id='"+ str(volumeId)+"'")
    state = c.fetchone()[0]
    conn.commit()
    if state > 0:
        print json.JSONEncoder().encode({'status':'fail','description':'Cannot update running Volume'})
        return
        
    query_lan=c.execute("select count(*) from Volume where id='"+ str(volumeId)+"'")
    nameCount = c.fetchone()[0]
    conn.commit()
    
    if nameCount > 0:
        query_SP=c.execute("update Volume set size=?,deduplication=?,compression=?,backup_device=?,multi_device_id=?,edit_date=datetime() where id=?",[size,dedup,compression,backup_device,poolId,volumeId])
        conn.commit()
        query_SP=c.execute("update export set port_id=?,host_id=?,lun=? where vol_id=?",[portId,hostId,lun,volumeId])
        conn.commit()
        
        print json.JSONEncoder().encode({'status':'success','description':'Updated successfully'})
    else:               
        print json.JSONEncoder().encode({'status':'fail','description':'Volume does''t Exists'})
        
    c.close()
    conn.close()
    
def read_Volume():      
    volumeId = form.getvalue('volumeId')
    if volumeId != str(0):
        dbquery=""" SELECT v.id,v.name,hp.id ,v.multi_device_id,e.host_id,e.lun,e.port_id,v.size,
                ep.name portName,h.name hostName,hp.name protocolName,md.system_name poolName,v.deduplication,v.compression,v.state,'Native',date(v.cr_date) createdDate,v.cr_date,'Volume',
                v.backup_device
                from volume v  
                join export e on e.vol_id=v.id 
                join eth_ports ep on ep.id = e.port_id
                join host h on h.id = e.host_id
                join protocol hp on hp.id = (select  protocol from host where host.id = e.host_id limit 1)
                join multi_device md on md.id = v.multi_device_id where v.id=""" +str(volumeId)
    else:
        dbquery=""" SELECT v.id,v.name,hp.id ,v.multi_device_id,e.host_id,e.lun,e.port_id,v.size,
                ep.name portName,h.name hostName,hp.name protocolName,md.system_name poolName,v.deduplication,v.compression,v.state,'Native',date(v.cr_date) createdDate,v.cr_date,'Volume',
                v.backup_device 
                from volume v 
                join export e on e.vol_id=v.id 
                join eth_ports ep on ep.id = e.port_id
                join host h on h.id = e.host_id
                join protocol hp on hp.id = (select  protocol from host where host.id = e.host_id limit 1)
                join multi_device md on md.id = v.multi_device_id
                
                union all
                
                SELECT vsn.id,vsn.name,hp.id ,v.multi_device_id,e.host_id,e.lun,e.port_id,v.size,
                ep.name portName,h.name hostName,hp.name protocolName,md.system_name poolName,v.deduplication,v.compression,vsn.state,'Local',date(v.cr_date) createdDate,vsn.cr_date,'Volume',
                v.backup_device
                from volume v 
                join export e on e.vol_id=v.id 
                join eth_ports ep on ep.id = e.port_id
                join host h on h.id = e.host_id
                join protocol hp on hp.id = (select  protocol from host where host.id = e.host_id limit 1)
                join multi_device md on md.id = v.multi_device_id
                join volume_snapshot vsn on vsn.vol_id = v.id
                                        
                union all
                
                SELECT v.id,v.name,0 ,v.multi_device_id,vm.id,'-' lun,0 portid,v.size,
                '-' portName,vm.name hostName,'-' protocolName,md.system_name poolName,v.deduplication,v.compression,ifnull(v.state,4),'Native',date(v.cr_date) createdDate,v.cr_date,'App',
                v.backup_device 
                from volume v 
                join vm_storage vs on vs.volume_id = v.id
                join virtualmachine vm on vm.id=vs.vm_id
                join multi_device md on md.id = v.multi_device_id
                
                order by v.cr_date desc
                """
    #print dbquery
    query = c.execute(dbquery)
    dbdata = []
    conn.commit()
    for col in c:
        jsonschema = {"id":col[0],"name" : col[1],"protocolId":col[2],"poolId":col[3],"hostId":col[4],"lun":col[5],"portId":col[6],"size":col[7],"portName":col[8],"hostName":col[9],"protocolName":col[10],"poolName":col[11],"dedup":col[12],"compression":col[13],"state":col[14],"type":col[15],"createdDate":col[16],"diskType":col[18],"backup_device":col[19]}
        dbdata.append(jsonschema)
    conn.close()
    print json.JSONEncoder().encode(dbdata)

def delete_Volume():

    if (GUI==True):
        volumeId = form.getvalue('volumeId')
        volumeType = form.getvalue('volumeType')

    else:
        volumeId = form_getvalue('volumeId')
        volumeType = form_getvalue('volumeType')

        
    if volumeType == 'Native':  
        query_lan=c.execute("select count(*) from Volume where state=6 and id='"+ str(volumeId)+"'")
        state = c.fetchone()[0]
        conn.commit()
        if state > 0:
            print json.JSONEncoder().encode({'status':'fail','description':'Cannot Delete running Volume'})
            return
        
        query=c.execute("select name from Volume where id='"+ str(volumeId)+"'")
        volumeName = c.fetchone()[0]
        query=c.execute("select multi_device_id from Volume where id='"+ str(volumeId)+"'")
        poolId = c.fetchone()[0]
        query=c.execute("select host_id from export where vol_id='"+ str(volumeId)+"'")
        hostId= c.fetchone()[0]
        query=c.execute("select protocol from host where id='"+ str(hostId)+"'")
        protocolId = c.fetchone()[0]
        
        cmd="VolDelete"
        message="set,element=volume,element_name={0},args=2,action={1},prot={2},PoolID={3},uuid={4}".\
        format(volumeName,cmd,protocolId,poolId,cmd_Id)            
        send_ccm_msg(message) 
        response = get_ccm_response(cmd_Id)
        print response
        
        if (CCM==False):
            query=c.execute("delete from volume where id='"+ str(volumeId)+"'")
            conn.commit()
            query=c.execute("delete from export where vol_id='"+ str(volumeId)+"'")
            conn.commit()
            #query = "Delete from Volume where id in ("+str(volumeId)+")"
            #query_FT=c.execute(query)
            #conn.commit()
            query = "Delete from vm_storage where volume_id in ("+str(volumeId)+")"
            query_FT=c.execute(query)
            conn.commit()
            #query = "Delete from export where vol_id in ("+str(volumeId)+")"
            #query_FT=c.execute(query)
            #conn.commit()
            #TODO: need to cleanup
            query = "Delete from volume_snapshot where vol_id in ("+str(volumeId)+")"
            query_FT=c.execute(query)
        conn.commit()
        c.close()
        conn.close()
    else:
        query_lan=c.execute("select count(*) from volume_snapshot where state=6 and id='"+ str(volumeId)+"'")
        state = c.fetchone()[0]
        conn.commit()
        if state > 0:
            print json.JSONEncoder().encode({'status':'fail','description':'Cannot Delete running Volume'})
            return
        # select vol_id from volume_snapshot where name="V2-ss3"
        query=c.execute("select name,vol_id from volume_snapshot where id='"+ str(volumeId)+"'")
        resp=c.fetchone()
        snapShotName = resp[0]
        VolId = resp[1]
        
    
        query=c.execute("select name,multi_device_id from volume where id='"+ str(VolId)+"'")
        resp=c.fetchone()
        volumeName = resp[0]
        poolId = resp[1]
        cmd="VolDeleteSnap"
        message="set,element=volume,element_name={0},args=4,action={1},PoolID={2},SnapName={3},uuid={4}".\
        format(volumeName,cmd,poolId,snapShotName,cmd_Id)
        send_ccm_msg(message) 
        response = get_ccm_response(cmd_Id)
        print response
        #query = "Delete from volume_snapshot where id in ("+str(volumeId)+")"
        #query_FT=c.execute(query)
        #conn.commit()
        #print json.JSONEncoder().encode({'status':'success','description':'Deleted successfully'})
        c.close()
        conn.close()
        

def onOff_Volume(): 

    if (GUI==True):
        volumeState=form.getvalue('state') 
        volumeId = form.getvalue('volumeId')
        volumeType = form.getvalue('volumeType')
    else:
        volumeState=form_getvalue('state') 
        volumeId = form_getvalue('volumeId')
        volumeType = form_getvalue('volumeType')

    if volumeType == 'Native':  

        query=c.execute("select name,multi_device_id from volume where id='"+ str(volumeId)+"'")
        resp= c.fetchone()
        volumeName = resp[0]
        poolId = resp[1]
        query=c.execute("select host_id from export where vol_id='"+ str(volumeId)+"'")
        hostId= c.fetchone()[0]
        query=c.execute("select protocol from host where id='"+ str(hostId)+"'")
        protocolId = c.fetchone()[0]
        conn.commit()
    
        if int(volumeState) == int(volOff):
    #turn off the volume
            cmd="VolStop"
        else:
            cmd="VolStart"
        message="set,element=volume,element_name={0},args=3,action={1},PoolID={2},prot={3},uuid={4}".\
        format(volumeName,cmd,poolId,protocolId,cmd_Id)           
        send_ccm_msg(message) 
        response = get_ccm_response(cmd_Id)
        print response
        #query=c.execute("update Volume set state=?,edit_date=datetime() where id=?",[volumeState,volumeId])
        #conn.commit()
###        

    else:
        query=c.execute("select name,vol_id from volume_snapshot where id='"+ str(volumeId)+"'")
        resp=c.fetchone()
        snapShotName = resp[0]
        VolId = resp[1]
        query=c.execute("select name,multi_device_id from volume where id='"+ str(VolId)+"'")
        resp=c.fetchone()
        volumeName = resp[0]
        poolId = resp[1]
        query=c.execute("select name from volume where id='"+ str(VolId)+"'")
        volumeName = c.fetchone()[0]
        query=c.execute("select host_id from export where vol_id='"+ str(VolId)+"'")
        hostId= c.fetchone()[0]
        query=c.execute("select protocol from host where id='"+ str(hostId)+"'")
        protocolId = c.fetchone()[0]
        conn.commit()
        if int(volumeState) == int(volOff):
    #turn off the volume
            cmd="VolStopSnap"
        else:
            cmd="VolStartSnap"
            
        message="set,element=volume,element_name={0},args=4,action={1},PoolID={2},prot={3},SnapName={4},uuid={5}".\
        format(volumeName,cmd,poolId,protocolId,snapShotName,cmd_Id)           
        send_ccm_msg(message) 
        response = get_ccm_response(cmd_Id)
        print response
        #query=c.execute("update volume_snapshot set state=?,edit_date=datetime() where id=?",[volumeState,volumeId])
        #conn.commit()

    #if int(volumeState) == int(volOff):
        #print json.JSONEncoder().encode({'status':'success','description':'Volume is OFF'})
    #else:               
        #print json.JSONEncoder().encode({'status':'success','description':'Volume is ON'})
        
    c.close()
    conn.close()
    
    
def snapShot_volume():

    volumeId = form.getvalue('volumeId')
    snapShotName = form.getvalue('snapShotName')    
    
    query_lan=c.execute("select count(*) from volume_snapshot where name='"+ str(snapShotName)+"'")
    nameCount = c.fetchone()[0]
    conn.commit()
    
    if nameCount == 0:
        cmd="VolCreateSnap"
        query=c.execute("select name from Volume where id='"+ str(volumeId)+"'")
        volumeName = c.fetchone()[0]
        query=c.execute("select multi_device_id from Volume where id='"+ str(volumeId)+"'")
        poolId = c.fetchone()[0]
        
        message="set,element=volume,element_name={0},args=4,action={1},PoolID={2},SnapName={3},uuid={4}".\
        format(volumeName,cmd,poolId,snapShotName,cmd_Id)
        send_ccm_msg(message) 
        response = get_ccm_response(cmd_Id)
        #print json.JSONEncoder().encode({'status':'success','description':'Saved XYZ  successfully'})
        print response        
        #query_SP=c.execute("insert into  volume_snapshot(name,state,vol_id,cr_date) values(?,?,?,datetime())",[snapShotName,4,volumeId])
        #conn.commit()       
        #print json.JSONEncoder().encode({'status':'success','description':'Saved successfully'})
    else:               
        print json.JSONEncoder().encode({'status':'fail','description':'Volume Name Already Exists'})
        
    c.close()
    conn.close()
def read_HostByProtocol():  
        
    protocolId = form.getvalue('protocolId')    
    dbquery="SELECT id,name,protocol,user_name,iqn,pw,wwn from host where protocol="+str(protocolId)
    
    query = c.execute(dbquery)
    dbdata = []
    conn.commit()
    for col in c:
        jsonschema = {"id":col[0],"name" : col[1],"protocol_id":col[2],"user_name":col[3],"iqn":col[4],"pw":col[5],"wwn":col[6]}
        dbdata.append(jsonschema)
    conn.close()
    print json.JSONEncoder().encode(dbdata)
    
def read_Ethernet_ports():
    dbdata = []
    query = "Select id,name from eth_ports"
    query_FT=c.execute(query)
    conn.commit()       
    for col in c:
        jsonschema = {"id":col[0],"name" : col[1]}
        dbdata.append(jsonschema)
    c.close()
    conn.close()
    print json.JSONEncoder().encode(dbdata)
    
    
def read_VolumeInfo():
    gVolOff=4
    gVolOn=6
    gVolStarting=5
    gVolSuspended=7
    
    if GUI==True:
        volumeId = form.getvalue('volumeId')
        volumeType = form.getvalue('volumeType')
    else:
        volumeId = form_getvalue('volumeId')
        volumeType = form_getvalue('volumeType')

    dbquery="SELECT name,size,state, backup_device from volume where id="+str(volumeId)
    query = c.execute(dbquery)
    conn.commit()
    for col in c:
        VolumeName = col[0]
        size= col[1]
        state = col[2]
        backup_device = col[3]

    query=c.execute("select host_id from export where vol_id='"+ str(volumeId)+"'")
    hostId= c.fetchone()[0]
    
    query=c.execute("select name,iqn,protocol from host where id='"+ str(hostId)+"'")
    conn.commit()
    for col in c:
        HostName = col[0]
        iqn= col[1]
        protocol = col[2]
        
    if state==gVolOff:
        VolState="OFF"
    elif state==gVolOn:
        VolState="ON"
    elif state==gVolStarting:
        VolState="Volume starting"
    elif state==gVolSuspended:
        VolState="Volume suspended"
    else:
        VolState="UN-DEFINED"

    if int(protocol)==int(iSCSI_Chap):
        TargetName = IQN+str(VolumeName)
        TargetType= "iSCSI_Chap"
    elif int(protocol)==int(iSCSI_NoChap):
        TargetName = IQN+str(VolumeName)
        TargetType= "iSCSI_NoChap"
    elif int(protocol)==int(2):
        TargetName="/mnt/"+VolumeName
        TargetType= "File share"
    else:
        TargetName="/cifs/"+VolumeName
        TargetType= "File share"
        

    gb_size=str(size)+" gb"
    #This function should return data in below format.
                   #{"propertyName":"Free","propertyValue":"150 GB"},
                   #{"propertyName":"Compressed","propertyValue":"1.5X"},
                   #{"propertyName":"Dedup","propertyValue":"2.3X"}, 
                   
    mockdata    = [{"propertyName":"Volume name","propertyValue":VolumeName},
                   {"propertyName":"Volume size","propertyValue":gb_size},
                   {"propertyName":"Volume state","propertyValue":VolState},
                   {"propertyName":"Target type","propertyValue":TargetType},
                   {"propertyName":"Target name","propertyValue":TargetName},
                   {"propertyName":"Host name","propertyValue":HostName},
                   {"propertyName":"Host iqn","propertyValue":iqn}
                   ]
    print json.JSONEncoder().encode(mockdata)
    
print "Content-type:text/html\r\n\r\n"
if request_Type == 'read_Volume':
    read_Volume()
elif request_Type == 'delete_Volume':
    delete_Volume()
elif request_Type == 'create_Volume':
    create_Volume()
elif request_Type == 'update_Volume':
    update_Volume()
elif request_Type == 'read_Ethernet_ports':
    read_Ethernet_ports()
elif request_Type == 'onOff_Volume':
    onOff_Volume()
elif request_Type == 'snapShot_volume':
    snapShot_volume()
elif request_Type == 'read_HostByProtocol':
    read_HostByProtocol()
elif request_Type == 'read_VolumeInfo':
    read_VolumeInfo()
    


