#!/usr/bin/python
from cgi_Global_myserver_totResources import *
import test_DockerSDK

import sqlite3
import cgi,cgitb
cgitb.enable()
import time
import json
from db import *


form = cgi.FieldStorage()

server_name=form.getvalue('server_name')
#vcpu=form.getvalue('cores')
#memory=form.getvalue('memory')
#disk_size=form.getvalue('disk_size')

available_storage=sys_storage()
available_vcpu=sys_vcpu()
available_memory=sys_memory()

current_state=form.getvalue('state')
sleepTime=5

def stateStarting_5():
	time.sleep(sleepTime)
	query_update_state=c.execute("update virtualmachine set state=5 where name=?",[server_name])
	conn.commit()
	print (json.JSONEncoder().encode({"status":"success","description":"Virtual Machine Starting...","state":"5" }))

def stateON_6():	
	query_update_state=c.execute("update virtualmachine set state=6,started_date=date() where name=?",[server_name])
	conn.commit()
	time.sleep(sleepTime)
	print (json.JSONEncoder().encode({"status":"success","description":"Virtual Machine is ON","state":"6"  }))


def vm_launch():
	#states 4=off 5=starting 6=on 7=suspended
	#states 4=off 5=starting 6=on 7=suspended
	query_vmName=c.execute("select name from virtualmachine where name=?",[server_name])
	vmName=c.fetchall()
	if not vmName:
		print (json.JSONEncoder().encode({"status":"fail","description":"No Server exists with the given name, Please Save and Launch VM"}))
	else:
		query_get_states=c.execute("select state,num_cores,memory_GB,vm_disk_size from virtualmachine where name=?",[server_name])
		resources=c.fetchall()[0]
		state=resources[0]
		vcpu=resources[1]
		memory=resources[2]
		disk_size=resources[3]

		if (state)==4:
			print (json.JSONEncoder().encode({"status":"success","description":"Click Yes to Launch Virtual Machine","state":"4","sleepTime":sleepTime }))
		elif(state)==5:
			print (json.JSONEncoder().encode({"status":"success","description":"Virtual Machine current state is Pause. Do you want to Start?? ","state":"5","sleepTime":sleepTime}))
		elif(state)==6:
			print (json.JSONEncoder().encode({"status":"success","description":"Virtual Machine is already ON","state":"6"}))
		
		else:
			print json.JSONEncoder().encode(({"status":"fail","description":"save is required"}))
			
print "Content-type:text/html\r\n\r\n"

if current_state=="0":
	vm_launch()
	resources_vm_running()
elif(current_state == "4"):
	errorMessage=""
	query_get_states=c.execute("select state,num_cores,memory_GB,vm_disk_size from virtualmachine where name=?",[server_name])
	resources=c.fetchall()[0]
	state=resources[0]
	vcpu=resources[1]
	memory=resources[2]
	disk_size=resources[3]
	if int(vcpu) > int(available_vcpu):
		#print (json.JSONEncoder().encode({"status":"fail","description":"InSufficient VCPU's"}))
		errorMessage+= "InSufficient VCPU's, "

	elif int(available_vcpu) == 0:
		#print (json.JSONEncoder().encode({"status":"fail","description":"InSufficient VCPU's. Turn off some VM's to Launch"}))
		errorMessage+="InSufficient VCPU's. Turn off some VM's to Launch, "

	if float(memory) > float(available_memory):
		#print (json.JSONEncoder().encode({"status":"fail","description":"Insufficient Memory"}))
		errorMessage+="Insufficient Memory, "

	elif float(available_memory) == 0:
		#print(jsin.JSONEncoder().encode({"status":"fail","description":"Insufficient memory. Turn off some VM's to Launch"}))
		errorMessage+="Insufficient memory. Turn off some VM's to Launch"
	msgLength = len(errorMessage)
	if msgLength>0:
		print(json.JSONEncoder().encode({"status":"fail","description":errorMessage}))
	else:
		stateStarting_5()
		resources_vm_running()

elif(current_state == "5"):
	#query_get_image=c.execute("select vm_group.group_name from virtualmachine inner join vm_image on virtualmachine.vm_image_id=vm_image.id inner join vm_group on vm_image.vm_group_id=vm_group.id where virtualmachine.name=?",[server_name])
	query_get_image=c.execute("select vm_image.image_type from virtualmachine inner join vm_image on virtualmachine.vm_image_id=vm_image.id where virtualmachine.name=?",[server_name])
	resources=c.fetchall()[0]
	image_type=resources[0]
	#if group_name=='Docker':
	if image_type=='docker':
		test_DockerSDK.launch_docker_vm(server_name)
	stateON_6()
	resources_vm_running()





 
