#!/usr/bin/python

from global_func import *
import sqlite3
import json
from db import *
import subprocess
import os
import time
CIFS=1
NFS=2
iSCSI_Chap=3
iSCSI_NoChap=4
FTP=5
FC=6
GUI=False
#GUI=True
CCM=True
gVolOff=4
gVolOn=6
    
if GUI==True:
    import cgi,cgitb
    cgitb.enable()

if GUI==True:
    form = cgi.FieldStorage()
    request_Type=form.getvalue('requestType')

else:
    print '1. create_Storage'
    print '2. read_Storage'
    print '3. OnOff_Device'
    print '4. delete_Storage '
    print '5. ConnectDisconnect SM_Storage '
    print '6. edit SM_Storage '

    choice=int(raw_input("select cgi function==>"))
    if (choice==1):
        request_Type='create_Storage'
    elif (choice==2):
        request_Type='read_Storage'
    elif (choice==3):
        request_Type='OnOff_Device'
    elif (choice==4):
        request_Type='delete_Storage'
    elif (choice==5):
        request_Type='ConnectDisconnectSM_Storage'
    elif (choice==6):
        request_Type='update_Storage'
    print "Reques_Type="+str(request_Type)


def form_getvalue(val):
    if (val=='name'):
        name=str(raw_input("input StorMan Name==>"))
        return name
    elif (val=='protocolId'):
        protID=str(raw_input("input ProtID (CIFS=1, NFS=2, iSCSI_Chap=3, iSCSI_NoChap=4)==>"))
        return protID
    elif (val=='hostId'):
        hostID=str(raw_input("input HostID ==>"))
        return hostID
    elif (val=='Status'):
        status=str(raw_input("input Status ==>"))
        return status
    elif (val=='storageId'):
        storageId=str(raw_input("input StorMan Id ==>"))
        return storageId
    elif (val=='state'):
        state=str(raw_input("input state 0=Off, 1=On ==>"))
        return state
    elif (val=='deviceId'):
        deviceId=str(raw_input("input deviceId ==>"))
        return deviceId
    elif (val=='action'):
        action=str(raw_input("input action C/D ==>"))
        return action
    elif (val=='remoteDir'):
        remoteDir=str(raw_input("input remoteDir ==>"))
        return remoteDir
    else: 
        print "Unknown Value"


def sprint (a,b):
    if GUI==False:
        if b!=0:
            print a,b
        else:
            print a
    else:
        return
def DB_updateStorManDevice(StorMan_id,iDisk):

    try:
        c=conn.cursor()
        #name TEXT,sys_name TEXT,state INT,cr_date DATETIME,edit_date DATETIME,del_date DATETIME,stor_man_id INT,size INT,
        sprint("DB_updateStorManDevice",0)
        system_name="iDisk"
        query=c.execute("select id from device where name='{}".format(iDisk)+"'")
        resp=c.fetchone()
        if str(resp) != str("None"):
            DeviceId=resp[0]
            sprint("DeviceId=",DeviceId)
            sprint("Update Device=",str(iDisk))
            name=iDisk
            state=0
            size=100
            query=c.execute("update device set sys_name=?,name=?,state=?,size=?,stor_man_id=?,edit_date=datetime() where id=?",\
            [system_name,name,state,size,StorMan_id,DeviceId])
        else:
            sprint("Create Device=",str(iDisk))
            name=iDisk
            state=0
            size=100
            query=c.execute("insert into device(sys_name,name,state,size,stor_man_id,cr_date) values(?,?,?,?,?,datetime())",\
            [system_name,name,state,size,StorMan_id]) 
        conn.commit()
        c.close()
        return 0
    except Exception as err:
        sprint(("DB_updateStorManDevice ",err)) 
        return -1


def create_Storage():
    if GUI==True:
        name=form.getvalue('name')
        protocolId=form.getvalue('protocolId') 
        hostId=form.getvalue('hostId') 
        Status=form.getvalue('Status')
        remoteDir=form.getvalue('remoteDir')
    else:
        name=form_getvalue('name')
        protocolId=form_getvalue('protocolId') 
        hostId=form_getvalue('hostId') 
        Status=form_getvalue('Status')
        remoteDir=form_getvalue('remoteDir')
        
    query_lan=c.execute("select count(*) from stor_man where name='"+ str(name)+"'")
    nameCount = c.fetchone()[0]
    conn.commit()

    if nameCount == 0:
        query_SP=c.execute("insert into  stor_man(name,protocol,host_id,state,cr_date,remote_share) values(?,?,?,?,datetime(),?)",[name,protocolId,hostId,0,remoteDir])
        conn.commit()
        StorManId=c.lastrowid
        dbquery="SELECT iqn from host where id="+str(hostId)
        query = c.execute(dbquery)
        iqn = c.fetchone()[0]
        conn.commit()
        sprint("iqn",iqn)
        #ALTER TABLE schedule ADD dirs varchar(40);
        #ALTER TABLE stor_man ADD remote_share varchar(40);
        if ((int(protocolId)==int(iSCSI_Chap)) or (int(protocolId) ==int(iSCSI_NoChap))):
            try:
                iface="null"
                iSCSIdiskList=[]
                sprint("iqn",iqn)
                result=iSCSIadm_Discover(iqn,iface)
                #print "step 1"
                if result!="null":
                    iDisks=result.splitlines()
                    for iDisk in iDisks:
                        #print "step 2"
                        disk = iDisk.split("iqn")
                        iSCSIdisk= "iqn"+disk[1]
                        iSCSIdiskList.append(iSCSIdisk)
                        sprint(iSCSIdisk,0)
                    for iDisk in iSCSIdiskList:
                        sprint ("step 3",iDisk)
                        sprint ("step 3",hostId)
                        result=DB_updateStorManDevice(StorManId,iDisk)
                        sprint(result,iDisk)
            except Exception as err:
                sprint("Err",err)
                print json.JSONEncoder().encode({'status':'fail','description':'Host Name Incorrect'})
                return

        print json.JSONEncoder().encode({'status':'success','description':'Saved successfully'})

    else:               
        print json.JSONEncoder().encode({'status':'fail','description':'Host Name Already Exists'})

    c.close()
    conn.close()

def update_Storage():
    if GUI==True:
        storageId = form.getvalue('storageId')
        name=form.getvalue('name')
        protocolId=form.getvalue('protocolId') 
        hostId=form.getvalue('hostId') 
        Status=form.getvalue('Status')
        remoteDir=form.getvalue('remoteDir')
    else:
        storageId = form_getvalue('storageId')
        name=form_getvalue('name')
        protocolId=form_getvalue('protocolId') 
        hostId=form_getvalue('hostId') 
        Status=form_getvalue('Status')
        remoteDir=form_getvalue('remoteDir')

    query_lan=c.execute("select count(*) from stor_man where state=1 and id='"+ str(storageId)+"'")
    state = c.fetchone()[0]
    conn.commit()
    if state > 0:
        print(json.JSONEncoder().encode({'status':'fail','description':'Cannot edit in use storage'}))
        return

    query_lan=c.execute("select count(*) from stor_man where name=? and id!=?",[name, storageId])
    nameCount = c.fetchone()[0]
    conn.commit()
    
    if nameCount == 0:
        query_SP=c.execute("update stor_man set name=?,protocol=?,host_id=?,state=?,edit_date=datetime(),remote_share=? where id=?",[name,protocolId,hostId,0,remoteDir,storageId])
        conn.commit()       
        print(json.JSONEncoder().encode({'status':'success','description':'Updated successfully'}))
    else:               
        print(json.JSONEncoder().encode({'status':'fail','description':'Host Name Already Exists'}))
        
    c.close()
    conn.close()

def read_Storage():
    if GUI==True:
        storageId = form.getvalue('storageId')
    else:
        storageId = form_getvalue('storageId')

    if storageId == '0':
        dbquery="""
        SELECT sm.id,sm.name,sm.protocol,sm.host_id,sm.state,sm.remote_share,h.name, ifnull(h.iqn,'n/a'), ifnull(h.url,'n/a'),  p.name, count(d.id)
        from stor_man sm, host h, protocol p, device d
        where h.id=sm.host_id and p.id=sm.protocol and d.stor_man_id=sm.id
        group by sm.id"""
    else:
        dbquery="""
        SELECT sm.id,sm.name,sm.protocol,sm.host_id,sm.state,sm.remote_share,h.name, ifnull(h.iqn,'n/a'), ifnull(h.url,'n/a'),  p.name, count(d.id)
        from stor_man sm, host h, protocol p, device d
        where h.id=sm.host_id and p.id=sm.protocol and d.stor_man_id=sm.id  and sm.id={}
        group by sm.id""".format(storageId)
    query = c.execute(dbquery)
    dbdata = []
    conn.commit()
    for col in c:
        jsonschema = {
            "id":col[0],"name" : col[1],"protocol":col[2],"host_id":col[3],"state":col[4],"remoteDir":col[5],
            "host_name":col[6], "host_ip":col[7], "host_url":col[8], "protocol_name":col[9], "num_devices":col[10], 
            "port":'-', "dummy":'-'}
        dbdata.append(jsonschema)
    print json.JSONEncoder().encode(dbdata)



def OnOff_Device():
    if GUI==True:
        state=form.getvalue('state') 
        deviceId = form.getvalue('deviceId')
    else:
        state=form_getvalue('state') 
        deviceId = form_getvalue('deviceId')
    sprint ("state", state)
    sprint ("deviceId",deviceId)
    
    if state==str(0):   #Turn OFF device
        sprint ("deviceId OFF",deviceId)
        retVal=DeviceConnect('D',deviceId)

    elif state==str(1):   #Turn OFF device
        sprint ("deviceId ON",deviceId)
        retVal=DeviceConnect('C',deviceId)

    if retVal==0:
        sprint ("deviceId Update",deviceId)
        query=c.execute("update device set state=? where id=?",[state,deviceId])
        conn.commit()


def fake_pool_create():
        PoolName="HDD POOL"
        PoolSystemName="HDD POOL"
        PoolSize =100
        PoolLevel=0
        zfsCompression="false"
        zfsAcceleration=0
        zfsDedup="false"
        PoolAccelerationStorage=0

        query_SP = c.execute(
        "insert into multi_device(name,pool_storage,level,state,cr_date,edit_date,compression,acceleration,deduplication,acceleration_storage,system_name) \
        values(?,?,?,1,datetime(),datetime(),?,?,?,?,?)",[PoolName, PoolSize, PoolLevel, zfsCompression, zfsAcceleration, zfsDedup,PoolAccelerationStorage,PoolSystemName])
        conn.commit()
        
        
def ConnectDisconnectSM_Storage():

    if GUI==True:
        storManId = form.getvalue('storageId')
    else:
        storManId = form_getvalue('storageId')

    dbquery="SELECT sm.state,sm.name,h.name,h.iqn,sm.remote_share,sm.protocol,h.id from stor_man sm join host h on h.id=sm.host_id where sm.id="+str(storManId)
    query = c.execute(dbquery)
    dbdata = []
    conn.commit()
    for col in c:
        state = col[0]
        SMname=[1]
        host_name = col[2]
        host_iqn = col[3]
        remote_share = col[4]
        protocol = col[5]
        hostId = col[6]

    if GUI==False:
        sprint ("step1",0)
        print "STEP 1","state:",state,"StormanID",storManId,"host:",host_name,"IQN",host_iqn,"Share:",remote_share,"Prot",protocol,"HostID",hostId

    if state == 0:
        action="C"
    elif state == 1:
        action="D"
        
    cmd_Id = get_ccm_command_id()
    #print "X"
    #sprint("action : ",action)
    sprint(host_iqn, remote_share)
    #print "Y"
    SMname="null"
    if action=="C":   #connection
        x='C'
        sprint ("connect",action)
        if protocol==NFS:
            cmd="connect"
            message="set,element=StorMan,element_name={0},args=8,cmd={1},action={2},HostID={3},HostName={4},HostIQN={5},Share={6},prot={7},StorManID={8},uuid={9}".\
            format(SMname,cmd,action,hostId,host_name,host_iqn,remote_share,protocol,storManId,cmd_Id)
            send_ccm_msg(message) 
            response = get_ccm_response(cmd_Id)
            print response
            return 0

        if ((int(protocol)==int(iSCSI_Chap)) or (int(protocol) ==int(iSCSI_NoChap))):
            cmd="connect"
            message="set,element=StorMan,element_name={0},args=8,cmd={1},action={2},HostID={3},HostName={4},HostIQN={5},Share={6},prot={7},StorManID={8},uuid={9}".\
            format(SMname,cmd,action,hostId,host_name,host_iqn,remote_share,protocol,storManId,cmd_Id)
            send_ccm_msg(message) 
            response = get_ccm_response(cmd_Id)
            print response
            return 0

    elif action=="D":   #dis-connection
        #print "disconnect"
        #print "D"
        if protocol==NFS:
            cmd="connect"
            message="set,element=StorMan,element_name={0},args=8,cmd={1},action={2},HostID={3},HostName={4},HostIQN={5},Share={6},prot={7},StorManID={8},uuid={9}".\
            format(SMname,cmd,action,hostId,host_name,host_iqn,remote_share,protocol,storManId,cmd_Id)
            send_ccm_msg(message) 
            response = get_ccm_response(cmd_Id)
            print response
            return 0
            
        if ((int(protocol)==int(iSCSI_Chap)) or (int(protocol) ==int(iSCSI_NoChap))):
            cmd="connect"
            message="set,element=StorMan,element_name={0},args=8,cmd={1},action={2},HostID={3},HostName={4},HostIQN={5},Share={6},prot={7},StorManID={8},uuid={9}".\
            format(SMname,cmd,action,hostId,host_name,host_iqn,remote_share,protocol,storManId,cmd_Id)
            send_ccm_msg(message) 
            response = get_ccm_response(cmd_Id)
            print response
            return 0


def DeviceConnect(x,deviceId):

    sprint ("DeviceConnect",deviceId)
    query=c.execute("select stor_man_id from device where id='"+ str(deviceId)+"'")
    resp=c.fetchone()
    if str(resp) != str("None"):
            storManId = resp[0]        
            sprint ("storManId",storManId)
    else:
            print json.JSONEncoder().encode({'status':'fail','description':'invalid Device ID'})
            return -1

    dbquery="SELECT sm.state,h.name,h.iqn,sm.remote_share,sm.protocol,h.id from stor_man sm join host h on h.id=sm.host_id where sm.id="+str(storManId)
    query = c.execute(dbquery)
    dbdata = []
    conn.commit()
    for col in c:
        state = col[0]
        host_name = col[1]
        host_iqn = col[2]
        remote_share = col[3]
        protocol = col[4]
        hostId = col[5]
        action="C"

    if GUI==False:
        sprint ("step1",0)
        #print "STEP 1","state:",state,"host:",host_name,"IQN",host_iqn,"Share:",remote_share,"Prot",protocol,"HostID",hostId
    if x=='C':
        action="C"
    elif x=='D':
        action="D"
    sprint("action : ",action)
    sprint(host_iqn, remote_share)
    if protocol==NFS:
        retVal=DeviceConnectNFS(deviceId,action,host_name,host_iqn,hostId,remote_share,protocol)
        return retVal
    elif ((int(protocol)==int(iSCSI_Chap)) or (int(protocol) ==int(iSCSI_NoChap))):
        retVal=DeviceConnectiSCSI(deviceId,action,host_name,host_iqn,hostId,remote_share,protocol)
        return retVal
    elif protocol==CIFS:
        retVal=DeviceConnectCIFS(deviceId,action,host_name,host_iqn,hostId,remote_share,protocol)
        return retVal
    else:
        return -1

def DeviceConnectCIFS(deviceId,action,host_name,host_iqn,hostId,remote_share,protocol):
    return 0

def DeviceConnectNFS(deviceId,action,host_name,host_iqn,hostId,remote_share,protocol):

    SMname="null"
    cmd="device"
    cmd_Id = get_ccm_command_id()
    message="set,element=StorMan,element_name={0},args=4,cmd={1},action={2},DeviceID={3},uuid={4}".\
        format(SMname,cmd,action,deviceId,cmd_Id)
    send_ccm_msg(message) 
    response = get_ccm_response(cmd_Id)
    print response
    return 0

def DeviceConnectiSCSI(deviceId,action,host_name,host_iqn,hostId,remote_share,protocol):

    SMname="null"
    cmd="device"
    cmd_Id = get_ccm_command_id()
    message="set,element=StorMan,element_name={0},args=4,cmd={1},action={2},DeviceID={3},uuid={4}".\
        format(SMname,cmd,action,deviceId,cmd_Id)
    send_ccm_msg(message) 
    response = get_ccm_response(cmd_Id)
    print response
    return 0

def delete_Storage():

    if GUI==true:
        storageId = form.getvalue('storageId') 
    else:
        storageId = form_getvalue('storageId')
    
    query_lan=c.execute("select count(*) from stor_man where state=1 and id='"+ str(storageId)+"'")
    state = c.fetchone()[0]
    conn.commit()
    if state > 0:
        print json.JSONEncoder().encode({'status':'fail','description':'Cannot Delete Used Storage'})
        return
    
    query=c.execute("delete from stor_man where id=?",[storageId])
    conn.commit()
    
    print json.JSONEncoder().encode({'status':'success','description':'Deleted successfully'})

def read_Devices():
    if GUI==true:
        storageId = form.getvalue('storageId') 
    else:
        storageId = form_getvalue('storageId')
    
    dbquery="""SELECT d.id,d.name,d.sys_name,d.state,p.name,d.size, h.name
    from host h, device d  join stor_man sm on sm.id=d.stor_man_id  inner join protocol p on p.id=sm.protocol  
    where h.id = sm.host_id and d.stor_man_id="""+str(storageId)
    query = c.execute(dbquery)
    dbdata = []
    conn.commit()
    for col in c:
        size = int(col[5])
        available = size #need to update here
        per_used = int(((size-available)/size)*100)
        jsonschema = {
            "id":col[0],"name" : col[1],"sys_name":col[2],"state":col[3],"protocol":col[4],"size":size,"available":available,
            "per_used":per_used,"target":col[6],"dummy":'-'}
        dbdata.append(jsonschema)
    
    print json.JSONEncoder().encode(dbdata)
    
print "Content-type:text/html\r\n\r\n"

try:
    if request_Type == 'create_Storage':
        create_Storage()
    elif request_Type == 'read_Storage':
        read_Storage()
    elif request_Type == 'OnOff_Device':
        OnOff_Device()
    elif request_Type == 'delete_Storage':
        delete_Storage()
    elif request_Type == 'ConnectDisconnectSM_Storage':
        ConnectDisconnectSM_Storage()
    elif request_Type == 'read_Devices':
        read_Devices()
    elif request_Type == 'update_Storage':
        update_Storage()
    
except BaseException as e:
    print(json.JSONEncoder().encode({'status':'fail','description':str(e)}))
    #pass
finally:
    conn.close()
