var scheduleHistoryInfo = [];
var scheduleInfo = [];
var logTable = null;
var selectedRow = {};
function Request() {
	var request = {
		url: "",
		parameters: {},
		statusType: "",
		typeNumber: "",
		isSingleStatus: false
	};
	return request;
}
var SchDeleteId = 0;
var isLocalTimeZone = true;
$(window).bind("load", function () {
	GetEmailSchedule();
	if (!($('#hdnIsAlertPage').val() == true))
		GetDownloads();
	setInterval(function(){ UpdateScheduleStatus(); }, scheduledListRefresh); //defined in constants.js
	setInterval(function () { GetDownloads(); }, downloadListRefresh);
});
function UpdateScheduleStatus() {
	var request = new Request();
	request.url = "cgi/cgi_Scheduler_Manager.py";
	request.statusType = "UpdateScheduleTable";
	request.parameters = { 'requestType': 'read_schedule', "type": $('#hdnType').val(), 'scheduleId': 0 }
	CallPythonService(request);
}
function GetEmailSchedule() {
	var request = new Request();
	request.url = "cgi/cgi_Scheduler_Manager.py";
	request.statusType = "EmailAlerts";
	request.parameters = { 'requestType': 'read_schedule', "type": $('#hdnType').val(), 'scheduleId': 0 }
	CallPythonService(request);
}
function DeleteSchedule() {

	var request = new Request();
	request.url = "cgi/cgi_Scheduler_Manager.py";
	request.statusType = "DeleteSchedule";
	request.parameters = { 'requestType': 'delete_schedule', "scheduleId": SchDeleteId }
	CallPythonService(request);

}

function CallPythonService(request) {
	request.parameters.uuid = uuid;
	$.ajax({
		type: "Get",
		url: request.url,
		contentType: 'application/json',
		dataType: 'json',
		headers: { 'Access-Control-Allow-Origin': '*' },
		data: request.parameters,
		success: function (response) {
			BindResponseData(request.statusType, response);
		},
		error: function (ex) {
			if (!isProduction) {
				console.log(ex);
			}
		}
	});
}
function BindResponseData(statusType, response) {

	if (statusType === 'EmailAlerts') {
		scheduleInfo = response;
		var hdnType = $('#hdnType').val();
		if ($('#hdnIsAlertPage').val())
			response = jQuery.grep(response, function (n, i) {
				return (n.action === 'Email Logs');
			});

        /*
		 var dataTable = $('#tblSchedulerList').DataTable();
		 dataTable.destroy();
		
		var tableHeader = '<table id="tblSchedulerList" id="tblSchedulerList" class="table table-striped table-bordered"><thead><th>Name</th><th>Start Time</th><th>Start Date</th><th>End Date</th><th>Type</th><th>Server</th><th>Frequency</th><th>Status</th><th>%Status</th><th class="centitle noSorting linksWidth">Actions</th></thead><tbody id="tbodySchedulerList"></tbody></table>'
        $('#divScheduleList').html(tableHeader);			
		
        $.each(response, function (i, item) {
            var records = '<tr><td>' + item.name + '</td><td>' + ConvertToLocalTime(item.start_date,item.start_time) + '</td><td>' + ConvertToLocalDate(item.start_date,item.start_time) + '</td><td>' + ConvertToLocalDate(item.end_date,item.start_time) + '</td><td>' + item.action + '</td><td>' + (item.vm_ID != null ? item.vm_ID:'') + '</td><td>' + item.frequency + '</td><td>' + item.status + '</td><td>' + item.PerDone + '</td><td><span class="linksBlk"><a href="schedule.html?type=Edit#'+item.id+'">Edit</a><a href="javascript:void(0);" onclick="DeleteConfirm('+item.id+')">Delete</a><a href="javascript:void(0);" onclick="SchedulerInfo('+item.id+')">Info</a></span></td></tr>'
            $('#tbodySchedulerList').append(records);
        }); 
		
		 var dataTable = $('#tblSchedulerList').DataTable();
		 dataTable.destroy();
		 $('#tblSchedulerList').DataTable(GetTableConfig('schedule'));
		*/

		var data = new Array;
		var headers = [];

		$.each(response, function (index, value) {
			var tempArray = new Array;
			var schedule_id = value["id"];
			tempArray.push('<span class="overflow" title="'+value["name"]+'">'+ value["name"] + '</span>');
			tempArray.push(ConvertToLocalTime(value["start_date"], value["start_time"]));
			tempArray.push(ConvertToLocalDate(value["start_date"], value["start_time"]));
			tempArray.push(ConvertToLocalDate(value["end_date"], value["start_time"]));
			tempArray.push(value["action"]);
			tempArray.push('<span class="overflow" title="'+value["source_vol"]+'">'+ value["source_vol"] + '</span>');
			tempArray.push('<span class="overflow" title="'+value["dest_vol"]+'">'+ value["dest_vol"]+ '</span>');
			tempArray.push(value["vm_ID"]);
			tempArray.push(value["frequency"]);
			// tempArray.push(value["status"]);
			tempArray.push('<span class="" id="'+ getScheduleStatusID(schedule_id) +'">'+ value["status"] + '</span>');
			// tempArray.push(value["PerDone"]);
			tempArray.push('<span class="" id="'+ getSchedulePerDoneID(schedule_id) +'">'+ value["PerDone"] + '</span>');
			tempArray.push('<span class="" id="">'+ value["bw_throttle"] + '</span>');
			tempArray.push('<span class="linksBlk"><a href="schedule.html?type=Edit#' + value["id"] + '">Edit</a><a href="javascript:void(0);" onclick="DeleteConfirm(' + value["id"] + ')">Delete</a><a href="javascript:void(0);" onclick="SchedulerInfo(' + value["id"] + ')">Info</a></span>');
			if(value["frequency"]=="At Canister Insert")
			{
				tempArray[3]='<span class="overflow" title="'+value["end_date"]+'">'+ value["end_date"] + '</span>'
			}
			data.push(tempArray);
		});

		//headers
		headers = [
			{ "title": "Name" },
			{ "title": "Start Time" },
			{ "title": "Start Date" },
			{ "title": "End Date" },
			{ "title": "Type" },
			{ "title": "Source Vol" },
			{ "title": "Dest Vol/Srvr" },
			{ "title": "Server" },
			{ "title": "Freq" },
			{ "title": "Status" },
			{ "title": "%Status" },
			{ "title": "B/W Throttle " },
			{ "title": "Actions" }
		];

		/*logTable=$('#tblSchedulerList').DataTable( {	
			destroy:true,	
			scrollX:true,				
	        data: data,
	        columns: headers,
			columnDefs: [
		    	{ width: 100, targets: 0 },
		    	{ width: 100, targets: 1 },
		    	{ width: 100, targets: 2 },
		    	{ width: 100, targets: 3 },
		    	{ width: 200, targets: 4 },
		    	{ width: 200, targets: 5 },
		    	{ width: 200, targets: 6 },
		    	{ width: 100, targets: 7 },
		    	{ width: 100, targets: 8 },
		    	{ width: 100, targets: 9 },
		    	{ width: 100, targets: 10 },
		    	{ width: 150, targets: 11,orderable: false}
		  	],
		  	"initComplete": function(settings, json) {
		        $('.dataTables_scrollBody thead tr').css({visibility:'collapse'});
		    }
		});*/
		
		logTable = $('#tblSchedulerList').DataTable({
			destroy: true,
			scrollX: false,
			data: data,
			columns: headers,
			columnDefs: [
				{ width: 40, targets: 0 },
				{ width: 100, targets: 1 },
				{ width: 95, targets: 2 },
				{ width: 80, targets: 3 },
				{ width: 80, targets: 4 },
				{ width: 50, targets: 5 },
				{ width: 40, targets: 6 },
				{ width: 70, targets: 7 },
				{ width: 90, targets: 8 },
				{ width: 65, targets: 9 },
				{ width: 75, targets: 10 },
				{ width: 70, targets: 11 },
				{ width: 150, targets: 12, orderable: false }
			],
			"initComplete": function (settings, json) {
				$('.dataTables_scrollBody thead tr').css({ visibility: 'collapse' });
			}
		});

	}
	else if (statusType === 'UpdateScheduleTable') {
		// id="status_schedule_'+ schedule_id
		// id="perdone_schedule_'+ schedule_id
		$.each(response, function (index, value) {
			var schedule_id = value["id"];
			if($('#'+getScheduleStatusID(schedule_id))) {
				$('#'+getScheduleStatusID(schedule_id)).html(value["status"]);
			}
			if($('#'+getSchedulePerDoneID(schedule_id))) {
				$('#'+getSchedulePerDoneID(schedule_id)).html(value["PerDone"]);
			}

		});
	}
	else if (statusType === 'GetDownloads') {

		var tableHeader = '<table border="1" class="table table-curved tbdata" id="tblAppDownloads"><thead><tr class="tbheader"><th>Image Name</th><th>Group Name</th><th>Download Percentage</th><th>Download Status</th></tr></thead><tbody id="tbodyAppDownloads"></tbody></table>'
		$('#displayDataDownloads').html(tableHeader);
		$.each(response, function (i, item) {
			var imgUrl = item.status == "yes" ? "images/installed.png" : "images/downloadingicon.gif"
			var records = '<tr><td>' + item.name + '</td><td>' + item.group_name + '</td><td><b>' + (item.download_percentage == null ? 0 : item.download_percentage) + '</b> %</td><td>' + (item.status == "yes" ? "Completed" : "In Progress") + '<img src="' + imgUrl + '" style="width: 50px;height: 30px;padding-left: 5px;"/>' + '</td></tr>'
			$('#tbodyAppDownloads').append(records);
		});
		var dataTable = $('#tblAppDownloads').DataTable();
		dataTable.destroy();
		$('#tblAppDownloads').DataTable(GetTableConfig('scheduleAppDownloads'));
	}
	else if (statusType == 'DeleteSchedule') {
		if (response.status == 'success') {
			$('#divMessage').html(response.description);
			$('#popMessage').modal('show');
			//alert(response.description);
			// location.reload();
		} else
			alert(response.description);
	}
	else if (statusType == 'scheduleInfo') {
		scheduleHistoryInfo = response;
		var dataTable = $('#tblSchedulerInfo').DataTable();
		dataTable.destroy();
		$('#tbodySchedulerInfo').html('');
		$.each(response, function (i, item) {
			var infoRow = `<tr>
				<td><input type="radio" name="rdScHistory" id="rdScHistory_`+ item.id + `" value=` + item.id + ` /></td>
				 <td>`+ ConvertToLocalDate(item.date, item.time) + `</td>
                <td>`+ ConvertToLocalTime(item.date, item.time) + `	</td>
                <td>`+ item.dest_vol + `	</td>
                 <td>`+ item.result + `</td>
            </tr> `

			$('#tbodySchedulerInfo').append(infoRow);
		});
		$('#tblSchedulerInfo').DataTable(GetTableConfig('scheduleInfo'));
		$('#schedulerInfoPopup').modal('show');

	}
	else if (statusType == 'restore_schedule') {
		if(response.status == "fail"){
				swal("Warning", response.description,"warning")}
		else{
		$('#divMessage').html(response.description);
		$('#popMessage').modal('show');
		}
	}
}
function trimString(valueString)
{		
		if(valueString==null)
			valueString = "N/A";
		var len=valueString.trim().length;
		var newValueString = valueString;
		if(len>15)
		{
			newValueString = valueString.substr(0,15)+'...';
		}
		return newValueString;
}
function DeleteConfirm(schId) {
	SchDeleteId = schId;
	$('#DeletePop').modal('show');
}
Date.prototype.addHours = function (h) {
	this.setTime(this.getTime() - (h * 60 * 1000));
	return this;
}
function ConvertDateFormat2(YYYmmdd) {
	var lst = YYYmmdd.split('-');
	return ((parseInt(lst[1]) + 1) < 10 ? '0' + (parseInt(lst[1]) + 1) : (parseInt(lst[1]) + 1)) + "/" + lst[2] + "/" + lst[0];
}
function ConvertToLocalDate(UTCDate, UtcTime) {
	var utcDate = UTCDate + 'T' + UtcTime + ':00'; //'2011-06-29T16:52:48.000Z';  // ISO-8601 formatted date returned from server
	var localDate = new Date(utcDate);
	if (isLocalTimeZone)
		localDate.addHours(localDate.getTimezoneOffset())
	return ConvertDateFormat2(localDate.getFullYear() + '-' + (localDate.getMonth() < 10 ? ('0' + localDate.getMonth()) : localDate.getMonth()) + '-' + (localDate.getDate() < 10 ? ('0' + localDate.getDate()) : localDate.getDate()));
}
function ConvertToLocalTime(UTCDate, UtcTime) {
	var utcDate = UTCDate + 'T' + UtcTime + ':00'; //'2011-06-29T16:52:48.000Z';  // ISO-8601 formatted date returned from server
	var localDate = new Date(utcDate);
	if (isLocalTimeZone)
		localDate.addHours(localDate.getTimezoneOffset())
	return (localDate.getHours() < 10 ? ('0' + localDate.getHours()) : localDate.getHours()) + ':' + (localDate.getMinutes() < 10 ? ('0' + localDate.getMinutes()) : localDate.getMinutes());
}
$('#chkTimeZone').change(function () {
	if ($(this).prop("checked") == true) {
		isLocalTimeZone = true;
	}
	else if ($(this).prop("checked") == false) {
		isLocalTimeZone = false;
	}
	GetEmailSchedule();
});
function GetDownloads() {
	var request = new Request();
	request.url = "cgi/cgi_DownloadUploads_Get.py";
	request.statusType = "GetDownloads";
	request.parameters = { "type": "downloads" }
	CallPythonService(request);
}
function SchedulerInfo(scheduleId) {
	selectedRow = jQuery.grep(scheduleInfo, function (n, i) {
		return (n.id === scheduleId);
	});
	var request = new Request();
	request.url = "cgi/cgi_Scheduler_Manager.py";
	request.statusType = "scheduleInfo";
	request.parameters = { "scheduleId": scheduleId, 'requestType': 'read_scheduleInfo' }
	CallPythonService(request);
}

$(document).on('click', 'input[type=radio]', function () {
	$("#restore-btn").css("background", "#ed1c24");
	$("#restore-btn").css("pointerEvents", "auto");
});

$('#schedulerInfoPopup').on('hidden.bs.modal', function () {
	$("#restore-btn").css("background", "grey");
	$("#restore-btn").css("pointerEvents", "none");
});

$("#restore-btn").click(function () {
	var info = [];
	var id = parseInt($("input[name='rdScHistory']:checked").val());
	info = jQuery.grep(scheduleHistoryInfo, function (n, i) {
		return (n.id === id);
	});
	var request = new Request();
	request.url = "cgi/cgi_Scheduler_Manager.py";
	request.statusType = "restore_schedule";
	request.parameters = { 'requestType': 'restore_schedule', 'scheduleId': id, 'sch_result': info[0].result, 'sch_SrcVol': selectedRow[0].source_vol, 'sch_DestVol': info[0].dest_vol }
	CallPythonService(request);
});

function getScheduleStatusID(id) {

	return "schedule_status_" + id;

}

function getSchedulePerDoneID(id) {

	return "schedule_perdone_" + id;

}
