var serverConfig = {
    vcpu: 0,
    memory: 0,
    storage: 0.00,
    currentState: 0,
    progressbarTime: 0,
    packageType: "",
    IsNewRequest: true,
    ShowResize: false
};
var availableSources = {
    vcpu: 0,
    memory: 0,
    storage: 0.00,
    currentState: 0,
    progressbarTime: 0,
    packageType: "",
    packageRequest: 1
};
var UsedSources = {
    vcpu: 0,
    memory: 0,
    storage: 0.00
};
var TotalSources = {
    vcpu: 0,
    memory: 0,
    storage: 0.00
};
var SelectedConfig = {
    vcpu: 0,
    memory: 0,
    storage: 0,
    VMId: 0
};
var rangeTextValues = {
    vcpu: 0,
    memory: 0,
    storage: 0
};
var firstRequest = true;
var isNewVDisk = false;
var userSelectedGroups = [];
var allDBGroups = [];
var savedDevices = [];
var savedMultiDeviceIds = [];
//var serverConfig = { vcpu: 0, memory: 0, storage: 0, progressbarTime: 0 };
//var availableSources = { vcpu: 0, memory: 0, storage: 0, currentState: 0, progressbarTime: 0, packageType: "", packageRequest: 1 };
var confirmMessages = {
    DisplayMessage: "",
    CallBackFn: function () { }
}
var networkIds = [];
//BindAvailableResources();
ProfileSetUp();
BindAllNetworks();
$(function () {
    GetImageNames();
    BindSystemUsage();
    if (location.hash.substr(1) > 0) {
        ShowImgDetatils(location.hash.substr(1));
        $('#spanTitle').html('Edit');
        //window.location.replace("#");
    }
});

function Request() {
    var request = {
        url: "",
        parameters: {},
        Type: "",
        ShowResize: false
    };
    return request;
}
$(function () {
    var vcpuSlider = document.getElementById("rangeVcpu");
    var memorySlider = document.getElementById("rangeMemory");
    var storageSlider = document.getElementById("rangeStorage");


    vcpuSlider.addEventListener("mousemove", VCPUChageEvent, false);
    memorySlider.addEventListener("mousemove", MemoryChageEvent, false);
    storageSlider.addEventListener("mousemove", StorageChageEvent, false);
    //storageSlider.addEventListener("mousewheel", VCPUChageEvent, false);

    function VCPUChageEvent() {
        if (parseInt($(this).val()) != UsedSources.vcpu) {
            var tempVcpu = serverConfig.vcpu
            serverConfig.vcpu = parseInt($(this).val()); //+ UsedSources.vcpu;
            if (serverConfig.vcpu <= availableSources.vcpu + UsedSources.vcpu)
                ProfileSetUp();
            else
                serverConfig.vcpu = tempVcpu;
        }
    }

    function MemoryChageEvent() {
        if (parseFloat($(this).val()) != UsedSources.memory) {
            var tempMemory = serverConfig.memory;
            serverConfig.memory = parseFloat($(this).val()); //parseInt($(this).val());
            if (serverConfig.memory <= availableSources.memory + UsedSources.memory)
                ProfileSetUp();
            else
                serverConfig.memory = tempMemory;
        }
    }

    function StorageChageEvent() {
        //if (serverConfig.storage != parseFloat($(this).val())) {
        //if((parseInt($(this).val())- UsedSources.storage + SelectedConfig.storage) >= 500){
        if (parseFloat($(this).val()) != UsedSources.storage) {
            var tempStorage = serverConfig.storage;
            serverConfig.storage = parseFloat($(this).val());
            if (serverConfig.storage <= (availableSources.storage + UsedSources.storage)) {
                ProfileSetUp();
            } else
                serverConfig.storage = tempStorage;
            //}
        }
        //}
    }

    //setTimeout(function () {
    //    var tempVcpu = serverConfig.vcpu
    //    serverConfig.vcpu = UsedSources.vcpu
    //    if (serverConfig.vcpu <= availableSources.vcpu + UsedSources.vcpu)
    //        ProfileSetUp();
    //    else
    //        serverConfig.vcpu = tempVcpu;
    //    //$('#rangeVcpu').val(serverConfig.vcpu);

    //    var tempMemory = serverConfig.memory;
    //    serverConfig.memory = UsedSources.memory
    //    if (serverConfig.memory <= availableSources.memory + UsedSources.memory)
    //        ProfileSetUp();
    //    else
    //        serverConfig.memory = tempMemory;

    //    var tempStorage = serverConfig.storage;
    //    serverConfig.storage = UsedSources.storage
    //    if (serverConfig.storage <= (availableSources.storage + UsedSources.storage)) {
    //        ProfileSetUp();
    //    } else
    //        serverConfig.storage = tempStorage;        
    //}, 500);

    //$('.rotarySwitchVcpu').on('change', function () {
    //    var tempVcpu = serverConfig.vcpu
    //    serverConfig.vcpu = parseInt($(this).val()) + 1;
    //    if (serverConfig.vcpu <= availableSources.vcpu)
    //        ProfileSetUp();
    //    else
    //        serverConfig.vcpu = tempVcpu;
    //});
    //$('.rotarySwitchMemory').on('change', function () {
    //    var tempMemory = serverConfig.memory;
    //    serverConfig.memory = parseInt($(this).val()) * 1 + 1;
    //    if (serverConfig.memory <= availableSources.memory)
    //        ProfileSetUp();
    //    else
    //        serverConfig.memory = tempMemory;
    //});
    //$('.rotarySwitchStorage').on('change', function () {
    //    var tempStorage = serverConfig.storage;
    //    serverConfig.storage = parseInt($(this).val()) * 1024 + 1024;
    //    if (serverConfig.storage <= availableSources.storage * 1024) {
    //        ProfileSetUp();
    //    } else
    //        serverConfig.storage = tempStorage;
    //});
});

function ProfileSetUp() {
    $('#divVcpu').css('min-height', 100 - (TotalSources.vcpu != 0 ? (serverConfig.vcpu * 100 / TotalSources.vcpu) : 0) + '%');
    $('#divMemory').css('min-height', 100 - (serverConfig.memory * 100 / TotalSources.memory) + '%');
    $('#divStorage').css('min-height', 100 - ((serverConfig.storage) * 100 / (TotalSources.storage)) + '%');

    $('#divVcpuUsed').css('min-height', (TotalSources.vcpu != 0 ? (UsedSources.vcpu * 100 / TotalSources.vcpu) : 0) + '%');
    $('#divMemoryUsed').css('min-height', (TotalSources.memory != 0 ? (UsedSources.memory * 100 / TotalSources.memory) : 0) + '%');
    $('#divStorageUsed').css('min-height', (TotalSources.storage != 0 ? ((UsedSources.storage) * 100 / (TotalSources.storage)) : 0) + '%');

    $('#divCpuArrow').html(serverConfig.vcpu - UsedSources.vcpu + ' vCPU');
    $('#VcpuPointer').css('bottom', (TotalSources.vcpu != 0 ? (serverConfig.vcpu * 100 / TotalSources.vcpu) : 0) - 4 + '%');
    $('#divmemoryArrow').html(serverConfig.memory - UsedSources.memory + 'G');
    $('#memoryPointer').css('bottom', (serverConfig.memory * 100 / TotalSources.memory) - 4 + '%');
    $('#divstorageArrow').html((serverConfig.storage - UsedSources.storage + SelectedConfig.storage).toFixed(2) + 'G'); //html((serverConfig.storage - UsedSources.storage).toFixed(2) + 'G');
    $('#StoragPointer').css('bottom', ((serverConfig.storage) * 100 / (TotalSources.storage)) - 4 + '%');
    //$('#divVcpu').css('min-height', 100 - (TotalSources.vcpu != 0 ? (serverConfig.vcpu * 100 / TotalSources.vcpu) : 0) + '%');
    //$('#divMemory').css('min-height', 100 - (serverConfig.memory * 100 / TotalSources.memory) + '%');
    //$('#divStorage').css('min-height', 100 - (serverConfig.storage * 100 / (TotalSources.storage)) + '%');

    //$('#divVcpuUsed').css('min-height', (TotalSources.vcpu != 0 ? (UsedSources.vcpu * 100 / TotalSources.vcpu) : 0) + '%');
    //$('#divMemoryUsed').css('min-height', (TotalSources.memory != 0 ? (UsedSources.memory * 100 / TotalSources.memory) : 0) + '%');
    //$('#divStorageUsed').css('min-height', (TotalSources.storage != 0 ? (UsedSources.storage * 100 / (TotalSources.storage)) : 0) + '%');

    //$('#divCpuArrow').html(serverConfig.vcpu - UsedSources.vcpu + ' vCPU');
    //$('#VcpuPointer').css('bottom', (TotalSources.vcpu != 0 ? (serverConfig.vcpu * 100 / TotalSources.vcpu) : 0) - 4 + '%');
    //$('#divmemoryArrow').html(serverConfig.memory - UsedSources.memory + 'G');
    //$('#memoryPointer').css('bottom', (serverConfig.memory * 100 / TotalSources.memory) - 4 + '%');
    //$('#divstorageArrow').html((serverConfig.storage - UsedSources.storage).toFixed(2) + 'G');
    //$('#StoragPointer').css('bottom', (serverConfig.storage * 100 / (TotalSources.storage)) - 4 + '%');
}

function ProfileSetUpbyVM(VirtualServername) {
    var request = new Request();
    request.url = "cgi/cgi_myserver_launch_getDetails.py";
    request.Type = 'bindServerInfo';
    request.parameters = {
        "server_name": VirtualServername
    };
    CallPythonService(request);
}

function ResizeNoCallBackFn() {
    //var request = new Request();
    //request.url = "cgi/cgi_myserver_launch_getDetails.py";
    //request.Type = 'ResizeNoCallBack';
    //request.parameters = { "server_name": $('#myModalLabelPop').text() };
    //CallPythonService(request);
    ConfirmPopUp('resizeVM');
}

function CallPythonService(request) {
    request.parameters.uuid = uuid;
    $.ajax({
        type: "Get",
        url: request.url,
        contentType: 'application/json',
        dataType: 'json',
        headers: {
            'Access-Control-Allow-Origin': '*'
        },
        data: request.parameters,
        success: function (response) {
            BindResponseData(request.Type, response);
        },
        error: function (ex) {
            if (!isProduction) {
                console.log(ex);
            }
        }
    });
}

function RedirectToSingle(VMID) {
    window.location.href = "vmstatus.html?type=view#" + VMID;
    //location.reload();
}

function BindResponseData(Type, response) {
    if (Type === 'AllImages') {
        $('#divImgs').html('');
        if (location.hash.substr(1) > 0) {
            response = jQuery.grep(response, function (n, i) {
                return (n.id == location.hash.substr(1));
            });
            $('#divSingleVM').css('display', 'block');
        }
        $.each(response, function (i, item) {
            var imgHtml = '<div class="col-xs-6"> <a href="#" class="redBox" data-toggle="modal" onclick="RedirectToSingle(' + item.id + ')" url="ShowImgDetatils(' + item.id + ')"><figure><img src=".' + item.iconPath + '" alt="' + item.name + '"></figure><h5>' + item.name + '</h5></a> </div>'
            $('#divImgs').append(imgHtml);
        });
        //window.location.replace("#");
    } else if (Type == 'GetPool') {
        $(".ddlPool option").remove();
        $('.ddlPool').append(new Option('-- Select --', ''));

        var optGroup = `<optgroup label="HDD POOL" id="HDDopt">
			<option value="NoneHDD" disabled>No items</option>
		</optgroup>
		<optgroup label="SSD POOL" id="SSDopt">
			<option value="NoneSSD" disabled>No items</option>
		</optgroup>    
		<optgroup label="iSCSI POOL" id="iSCSIopt">
			<option value="NoneiSCSI" disabled>No items</option>
		</optgroup>
		<optgroup label="NVMeOF POOL" id="NVMeOFopt">
			<option value="NoneNVMeOF" disabled>No items</option>
        </optgroup>`

        $('.ddlPool').append(optGroup);

        $.each(response, function (i, item) {

            optionText = item.systemName;
            optionValue = item.id;
            optionName = item.name;

            if (optionName == 'HDD POOL') {
                $('.ddlPool option[value="NoneHDD"]').remove();
                $('#HDDopt').append(`<option value="${optionValue}"> 
                        ${optionText}
                        </option>`);
            }
            else if (optionName == 'SSD POOL') {
                $('.ddlPool option[value="NoneSSD"]').remove();
                $('#SSDopt').append(`<option value="${optionValue}"> 
                        ${optionText}
                        </option>`);
            }
            else if (optionName == 'iSCSI POOL') {
                $('.ddlPool option[value="NoneiSCSI"]').remove();
                $('#iSCSIopt').append(`<option value="${optionValue}"> 
                        ${optionText}
                        </option>`);
            }
            else if (optionName == 'NVMeOF POOL') {
                $('.ddlPool option[value="NoneNVMeOF"]').remove();
                $('#NVMeOFopt').append(`<option value="${optionValue}"> 
                        ${optionText}
                        </option>`);
            }
        });
        //GetVmVDisks(); // binds v disks from db
    }
    else if (Type == 'GetVmVDisks') {
        if (isNewVDisk) {
            $('#tblhead').html('<thead><tr class="tbheader"><th width="20%">Name</th><th width="20%">Size</th> <th>Dedup</th> <th>Compression</th><th>Pool</th><th>Action</th></tr></thead>');
            isNewVDisk = false;
        }

        var dataTable = $('#tblVdisks').DataTable();
        dataTable.destroy();
        $('#tblVidksBody').html('');
        $.each(response, function (i, item) {
            var dedup = item.dedup == 'true' ? 'Yes' : 'No';
            var compression = item.compression == 'true' ? 'Yes' : 'No';
            var records = '<tr><td>' + item.name + '</td><td>-</td><td>' + item.size + ' G</td><td>' + dedup + '</td><td>' + compression + '</td><td>' + item.Pool_name + '</td><td><input name="clsVolumeId" value="' + item.id + '" class="checkbox clsVolumeId" id="chk_Vol1" type="checkbox"></td></tr>'
            $('#tblVidksBody').append(records);
        });

        var dataTable = $('#tblVdisks').DataTable();
        dataTable.destroy();
        $('#tblVdisks').DataTable(GetTableConfig('AttachedDisks'));

    }
    else if (Type == 'read_AttacheDdevice') {
        savedDevices = [];
        savedMultiDeviceIds = [];
        var dataTable = $('#tblDeviceList').DataTable();
        dataTable.destroy();
        $('#tbodySavedDevicesList').html('');
        $.each(response, function (i, item) {
            savedDevices.push(item.id);
            if (savedMultiDeviceIds.indexOf(item.stor_man_Id) == -1)
                savedMultiDeviceIds.push(item.stor_man_Id);

            var onClass = item.state == 1 ? '' : 'hide';
            var offClass = item.state == 0 ? '' : 'hide';
            var stateText = item.state == 0 ? 'Offline' : 'Online';
            var isDisabled = item.state == 0 ? 'disabled' : '';
            item.nametxt = item.name;
            if (item.name.length > 10) {
                item.nametxt = item.name.substr(0, 12) + '...';
            }

            var strStorage = `<tr>												
                                                <td><span class="overflow" title="`+ item.name + `">` + item.nametxt + `</span></td>
                                                <td>`+ stateText + `</td>
												<td>`+ item.size + `</td>
												<td>-</td>
												<td>-</td>
												<td>`+ item.stor_man_name + `</td>                                                                          
                                                <td><input name="clsVolumeId" value="9" class="checkbox clsVolumeId" id="chk_Vol1" type="checkbox" checked="true" disabled></td>
                                            </tr>`;
            $('#tbodySavedDevicesList').append(strStorage);
        });
        var dataTable = $('#tblDeviceList').DataTable();
        dataTable.destroy();
        $('#tblDeviceList').DataTable(GetTableConfig('AttachedDevices'));
    }
    else if (Type == 'SaveVDisk') {
        if (response.status == 'success') {
            isNewVDisk = true;
            GetVmVDisks();
            EnableAddVDisk();
            swal("Success", response.description, "success");
        }
        else
            swal("warning", response.description, "warning");
    }

    else if (Type == 'ShowPopUp') {
        $('#myModalLabelPop').html(response.VirtualServername);
        //$('#imgIconPop').html('<img src=".' + response.iconPath + '">');
        $('#groupPop').html(response.GroupName);
        $('#imagePop').html(response.ImageName);
        $('#vcpuPop').html(response.vcpu);
        $('#memoryPop').html(response.memory);
        $('#storagePop').html(response.storage);
        $('#pathPop').html(response.path);
        $('#CreatedDatePop').html(response.cr_date);
        $('#startedDatePop').html(response.start_date);
        $('#attachedDisksPop').html((response.attachedDisks).slice(1));
        $('#remotebackupPop').html(response.last_remoteBck);
        $('#localbackupPop').html(response.last_localBck);
        $('#currentStatePop').html(GetState(response.state));
        $('#selectedGroups').html(response.mappedGroups.selectedGroupNames.join(', '));

        userSelectedGroups = response.mappedGroups.selectedGroups;

        $('#SVMGroup').html(response.GroupName);
        $('#redirectConsole').attr("onclick", "RedirectToConsole('" + response.ImageName + "','" + response.portNo + "')");
        $('#SVMImage').html(response.ImageName);
        $('#SVMvCPU').html(response.vcpu);
        $('#SVMMemory').html(response.memory);
        $('#SVMStorage').html(response.storage);
        $('#SVMPath').html(response.path);
        $('#SVMDesc').html(response.Desc);
        $('#SVMPrice').html(response.Price);
        GetServerDetails(response.VirtualServername);
        //off vm here if running-moved to getserverdeatils function
    } else if (Type === 'bindServerInfo') {
        serverConfig.vcpu = response.vcpu;
        serverConfig.memory = response.memory;
        serverConfig.storage = response.storage;
        //ProfileSetUp();
        BindAvailableResources();
        var config = '</br><ul><li>VCPU:' + response.vcpu + '</li><li>Memory (GB):' + response.memory + '</li><li>Storage (GB):' + response.storage + '</li></ul>';
        $("#divResult").append(config);
    } else if (Type === 'ResizeNoCallBack') {
        //serverConfig.vcpu = response.vcpu;
        //serverConfig.memory = response.memory;
        //serverConfig.storage = response.storage;
        //ProfileSetUp();
        BindAvailableResources();
    } else if (Type === 'SystemUsage') {
        $('#vcpuUsed').html('Used   : <i>' + response.vcpu.Used_vCPU + '</i>');
        $('#vcpuAvailable').html('Available : <i>' + response.vcpu.Available_vCPU + '</i>');
        $('#vcpuTotal').html('Total : <i>' + response.vcpu.Total_vCPU + '<i>');
        $('#MemoryUsed').html('Used : <i>' + response.memory.Used_Memory.toFixed(2) + ' GB</i>');
        $('#MemoryAvailable').html('Available : <i>' + response.memory.Available_Memory.toFixed(2) + ' GB</i>');
        $('#MemoryTotal').html('Total : <i>' + response.memory.Total_Memory.toFixed(2) + ' GB</i>');
        $('#StorageUsed').html('Used : <i>' + response.storage.Used_Storage.toFixed(2) + ' TB</i>');
        $('#StorageAvailable').html('Available : <i>' + response.storage.Available_Storage.toFixed(2) + ' TB</i>');
        $('#StorageTotal').html('Total : <i>' + response.storage.Total_Storage.toFixed(2) + ' TB</i>');

        $('#sliderVcpu').css('transform', 'rotate(' + ((response.vcpu.Used_vCPU * 100 / response.vcpu.Total_vCPU) * 2.6 - 130) + 'deg)');
        $('#sliderStorage').css('transform', 'rotate(' + ((response.storage.Used_Storage * 100 / response.storage.Total_Storage) * 2.6 - 130) + 'deg)');
        $('#sliderMemory').css('transform', 'rotate(' + ((response.memory.Used_Memory * 100 / response.memory.Total_Memory) * 2.6 - 130) + 'deg)');


        $('#vcpuSlider').val(response.vcpu.Used_vCPU * 100 / response.vcpu.Total_vCPU);
        $('#storageSlider').val(response.storage.Used_Storage * 100 / response.storage.Total_Storage);
        $('#memorySlider').val(response.memory.Used_Memory * 100 / response.memory.Total_Memory);
        //Range Slider starts here
        var rangeSlider = function () {
            var slider = $(".range-slider"),
                range = $(".range-slider__range"),
                value = $(".range-slider__value");

            slider.each(function () {
                value.each(function () {
                    var value = $(this).prev().attr("value");
                    $(this).html(value);
                });

                range.on("input", function () {
                    $(this).next(value).html(this.value);
                });
            });
        };

        rangeSlider();

    } else if (Type === 'AvailableResource') {
        availableSources.vcpu = response.free.vcpu;
        availableSources.storage = response.free.storageGB * 1024;
        availableSources.memory = response.free.memoryGB;

        UsedSources.vcpu = response.used.vcpu;
        UsedSources.storage = response.used.storageGB * 1024;
        UsedSources.memory = response.used.memoryGB;

        TotalSources.vcpu = availableSources.vcpu + UsedSources.vcpu;
        TotalSources.memory = availableSources.memory + UsedSources.memory;
        TotalSources.storage = availableSources.storage + UsedSources.storage;

        SelectedConfig.vcpu = serverConfig.vcpu;
        SelectedConfig.memory = serverConfig.memory;
        SelectedConfig.storage = serverConfig.storage;

        serverConfig.vcpu = serverConfig.vcpu + UsedSources.vcpu;
        serverConfig.memory = serverConfig.memory + UsedSources.memory;
        serverConfig.storage = serverConfig.storage + UsedSources.storage - SelectedConfig.storage;

        $('#vcpuF').text(availableSources.vcpu);
        $('#memoryF').text(availableSources.memory.toFixed(2) + ' GB');
        $('#storageF').text((availableSources.storage / 1024).toFixed(2) + ' TB');
        $('#vcpuT').text(UsedSources.vcpu);
        $('#memoryT').text(UsedSources.memory.toFixed(2) + ' GB');
        $('#storageT').text((UsedSources.storage / 1024).toFixed(2) + ' TB');
        $('#vcpuS').text(SelectedConfig.vcpu);
        $('#memoryS').text((SelectedConfig.memory).toFixed(2) + ' GB');
        $('#storageS').text(((SelectedConfig.storage) / 1024).toFixed(2) + ' TB');

        //$('#vcpuS').text(SelectedConfig.vcpu + serverConfig.vcpu);
        //$('#memoryS').text((SelectedConfig.memory + serverConfig.memory).toFixed(2) + ' GB');
        //$('#storageS').text(((SelectedConfig.storage + serverConfig.storage) / 1024).toFixed(2) + ' TB');
        SetUpResouceDials();
        ProfileSetUp();
    } else if (Type === 'AllNetwork') {
        $.each(response, function (i, item) {
            if (networkIds.indexOf(item.id) === -1)
                //$("#divNetworkCidr").append('<div class="repeatBox"><div class="checkBox-Item"><input name="chkNetwork" type="checkbox" value="" class="checkbox" id="chk_' + item.id + '"></div><div class="form-Container"><input name="" type="text" id="txtNetwork" class="form-control" title="' + item.network_name + '" value="' + item.network_name + '" disabled="disabled"></div><div class="form-Container"><input name="" type="text" id="txtCidr" class="form-control" title="' + item.cidr + '" value="' + item.cidr + '" disabled="disabled"></div> </div>');
                $("#divNetworkCidr").append('<div class="repeatBox"><div class="checkBox-Item"><input name="chkNetwork" type="checkbox" value="" class="checkbox" id="chk_' + item.id + '"></div><div class="form-Container"><input name="txtNetwork" type="text" class="form-control" title="' + item.network_name + '" value="' + item.network_name + '" disabled="disabled"></div><div class="form-Container"><input name="txtCidr" type="text" class="form-control" title="' + item.cidr + '" value="' + item.cidr + '" disabled="disabled"></div> </div>');
        });
        BindLedStates(availableSources.currentState)
    } else if (Type === 'resizeUpdateDB') {
        $('#divMessage').html('');
        $('#divMessage').html(response.message);
        if (response.Description != undefined)
            $('#divMessage').append(response.Description);
        $('#messagePopUP').modal('show');
        ShowUpdatedVMDetailsRefresh();
        //$('#resizeAll').modal('hide');
        if (serverConfig.ShowResize)
            ConfirmPopUp('resizeVM');
        //BindAvailableResources();
    } else if (Type === 'OffVM') {
        $("#divResponse").attr('class', '');
        $('#divFooterMsg').html('');
        if (response.status === 'success') {
            serverConfig.progressbarTime = response.sleepTime;
            $("#divResponse").addClass('alert alert-success');
            $("#divResponse").html('<b>' + response.description + '</b>');
            $("#vmLaunchPopUp").modal('show');
            CallNextStateOffVM(response.state);
        } else if (response.status === 'fail') {
            $("#divProgress").css("display", "none");
            $("#divResponse").addClass('alert alert-danger');
            $("#divResponse").html(response.description);
            $("#vmLaunchPopUp").modal('show');
        }
    } else if (Type === 'ServerDetails') {
        $('#divNetworkCidr').html('');
        networkIds = [];
        $.each(response, function (i, item) {
            //$("#divNetworkCidr").append('<div class="repeatBox"><div class="checkBox-Item"><input name="chkNetwork" type="checkbox" value="" class="checkbox" id="chk_' + item.networkId + '" checked=true></div><div class="form-Container"><input name="" type="text" id="txtNetwork" class="form-control" title="' + item.NetworkName + '" value="' + item.NetworkName + '" disabled="disabled"></div><div class="form-Container"><input name="" type="text" id="txtCidr" class="form-control" title="' + item.cidr + '" value="' + item.cidr + '" disabled="disabled"></div> </div>');
            $("#divNetworkCidr").append('<div class="repeatBox"><div class="checkBox-Item"><input name="chkNetwork" type="checkbox" value="" class="checkbox" id="chk_' + item.networkId + '" checked=true></div><div class="form-Container"><input name="txtNetwork" type="text" class="form-control" title="' + item.NetworkName + '" value="' + item.NetworkName + '" disabled="disabled"></div><div class="form-Container"><input name="txtCidr" type="text" class="form-control" title="' + item.cidr + '" value="' + item.cidr + '" disabled="disabled"></div> </div>');
            networkIds.push(item.networkId);
        });
        if (Object.keys(response).length > 0) {
            $('#txtvmName').html(response[0].ServerName);
            availableSources.currentState = response[0].State;
            BindLedStates(response[0].State);

            // off VM if running for edit
            if (location.search.split('type=')[1] == 'Edit' && firstRequest == true && availableSources.currentState != 4) {

                SetVMOff();  //As per new changes no need to stop vm while coming to edit page
            }
            firstRequest = false;
        }
        BindAllNetworks();
    } else if (Type === 'launchVM') {
        $("#divResponse").attr('class', '');

        if (response.status === 'success') {
            $("#divResponse").addClass('alert alert-success');
            $("#divResponse").html('<b>' + response.description + '</b>');

            $("#vmLaunchPopUp").modal('show');
            CallNextStateLaunchVM(parseInt(response.state));
        } else if (response.status === 'fail') {
            $("#divProgress").css("display", "none");
            $("#divResponse").addClass('alert alert-danger');
            $("#divResponse").html(response.description);
            $("#vmLaunchPopUp").modal('show');
            $(".clsClose").attr("data-dismiss", "modal").attr('disabled', false);
        }

    } else if (Type === 'PauseResetVM') {
        $('#divMessage').html(response.Description);
        $('#messagePopUP').modal('show');
        if (response.status === 'success') {
            availableSources.currentState = response.currentState;
            BindLedStates(response.currentState);
            BindAvailableResources();
        }
    } else if (Type === 'DeleteVM') {
        $('#divMessage').html(response.Description);
        if (response.status === 'success') {
            $('.btnAction').attr('onclick', 'location.reload()');
            $('#messagePopUP').attr('data-backdrop', 'static');
            $('#divNetworkCidr').html('');
            GetImageNames();
            BindAllNetworks();
        }
        $('#messagePopUP').modal('show');
        //location.reload();
    }
    else if (Type == 'DeleteVDisk') {
        swal("Deleted", "Deleted successfully", "success");
        isNewVDisk = true;
        GetVmVDisks();
        EnableAddVDisk();
        GetPoolList();
    }
    else if (Type === 'launchVMconfirm') {
        $("#divResult").attr('class', '');
        $(".divbtn").hide();
        if (response.status === 'success') {
            $("#divResult").addClass('alert alert-success');
            /////////////////////////////////
            if (response.state != 6) {
                var request = new Request();
                request.url = "cgi/cgi_myserver_launch_getDetails.py";
                request.Type = 'bindServerInfo';
                request.parameters = {
                    "server_name": $('#myModalLabelPop').text()
                };
                CallPythonService(request);
            }
            /////////////////////////////////////            
            var description = response.state == 6 ? response.description : response.description;
            $("#divResult").html(description);

            serverConfig.currentState = response.state;
            serverConfig.progressbarTime = response.sleepTime;
            serverConfig.currentState == 6 ? ($('#divOK').show(), $("#divTitle").html('<strong>Status</strong>')) : ($('#divNO').show(), $('#divYES').show(), $("#divTitle").html('<strong>Confirmation</strong>'));
            $("#vmLaunchConfirm").modal('show');
        } else {
            $("#divResult").addClass('alert alert-danger');
            $("#divResult").html(response.description);
            $("#divTitle").html('<strong>Error</strong>');
            $('#divOK').show();
            $("#vmLaunchConfirm").modal('show');
        }
    } else if (Type === 'CreateSnap') {
        setTimeout(function () {
            $("#loader").attr('style', 'display:none');
            if (response.status == 'success')
                //swal("Success", response.name + " Snapshot Created", "success");
                swal({
                    type: 'success',
                    html: true,
                    title: 'Success',
                    text: '<b><a href="vmstatus.html?type=view#' + response.vmId + '" title="click here to View Snapshot">' + response.name + '</a></b> Snapshot Created'
                })
            else
                swal("Error", response.message, "error");
        }, 8000);
    }
    else if (Type == 'backupServer') {
        $("#loader").attr('style', 'display:none');
        if (response.status == 'success')
            swal("Progress...", response.data, "info");
        else
            swal("Error...", response.data, "error");
    }
    else if (Type == 'ShowAppGroups') {
        allDBGroups = response;
        var table = $('#tblOrgGroups').DataTable();
        table.destroy();
        var groupsData = `<thead><th>#</th><th>Group Name</th><th>Description</th><th>Status</th></thead><tbody id="tbodyGroupsData" ></tbody>`
        $('#tblOrgGroups').html(groupsData);
        $.each(allDBGroups, function (i, item) {
            var selectedStatus = userSelectedGroups.indexOf(item.id) != -1 ? 'checked' : '';
            var mappedStatus = userSelectedGroups.indexOf(item.id) != -1 ? 'Selected' : '';
            var rowData = '<tr><td><input type="checkbox" value="' + item.id + '" class="clsOrgGroups" name="clsOrgGroups" ' + selectedStatus + '/></td><td>' + item.name + '</td><td>' + item.description + '</td><td>' + mappedStatus + '</td></tr>';
            $('#tbodyGroupsData').append(rowData);
        });
        $('.clsOrgGroups').bind('change', function () {
            if (this.checked) {
                userSelectedGroups.push(parseInt(this.value));
            }
            else {
                var valuesToRemove = [parseInt(this.value)]
                userSelectedGroups = userSelectedGroups.filter(item => !valuesToRemove.includes(item))
            }

            // $('#txtSelectedGroups').val(GetSelectedGroupNames());
            // $('#txtSelectedGroups').attr('title',GetSelectedGroupNames());
        });
        $('#tblOrgGroups').DataTable();
    }
    else if (Type == 'getAllStorageManagers') {
        $("#ddlStorageManager option").remove();
        // $('#ddlStorageManager').append($('<option>', { 
        // value: '',
        // text : ' Select ' 
        // }));
        $.each(response, function (i, item) {
            $('#ddlStorageManager').append($('<option>', {
                value: item.id,
                text: item.name
            }));
        });
        $('#ddlStorageManager').multiselect();


        $('#ddlStorageManager').multiselect("select", savedMultiDeviceIds);
        GetDevicesList(savedMultiDeviceIds.toString());
    }
    else if (Type == 'GetDeviceListBySMId') {
        $('#tbodyDevices').html('');
        $('#divDevicesMessage').show();
        $('#divDevicesMessage').html('Select devices to attach').removeClass('blinkingRed').addClass('blinking');

        if (response.length == 0) {
            $('#tbodyDevices').html('<tr><td colspan="5">No Devices Available</td></tr>');
            $('#divDevicesMessage').hide();
        }
        $.each(response, function (i, item) {
            var onClass = item.state == 1 ? '' : 'Online';
            var offClass = item.state == 0 ? '' : 'Offline';
            var stateText = item.state == 0 ? 'Offline' : 'Online';
            var isDisabled = item.state == 0 ? 'disabled' : '';
            item.nametxt = item.name;
            if (item.name.length > 10) {
                item.nametxt = item.name.substr(0, 12) + '...';
            }
            var isSaved = savedDevices.indexOf(item.id) != -1 ? 'checked' : ''
            var strStorage = `<tr>												
                                                <td><span class="overflow" title="`+ item.name + `">` + item.nametxt + `</span></td>
                                                <td>`+ stateText + `</td>
												<td>`+ item.size + `</td>
												<td>`+ item.protocol + `</td>
                                                <td><input name="clsVolumeId" value="`+ item.id + `" class="checkbox clsDeviceId" id="chk_Device" type="checkbox" ` + isSaved + ` "" ` + isDisabled + `></td>                           
                                                <td class="hide" align="center">
                                                    <span class="linksBlk"> 
                                          
											  <a href="javascript:void(0);" class=" yellowBG">
                                          <img src="images/infoIcon.png" alt="infoIcon" title="Info" onclick="VolumeInfo(`+ item.id + `,'` + item.type + `')"></a>  
										   
										   <label class="radio-switch `+ offClass + `" title="Click to Turn On Device">
												<input type="checkbox" name="VolumeToggele"  onclick="OnOffDevice(`+ item.id + `,` + 1 + `,'` + item.type + `')">
												<span class="slider"></span>
											</label>
											
											<label class="radio-switch `+ onClass + `" title="Click to Turn Off Device">
												<input type="checkbox" name="VolumeToggele" onclick="OnOffDevice(`+ item.id + `,` + 0 + `,'` + item.type + `')" checked>
												<span class="slider"></span>
											</label>

                                          </span>
                                                </td>
                                            </tr>`;
            $('#tbodyDevices').append(strStorage);
            $('.clsDeviceId').bind('change', function () {
                $('#divDevicesMessage').html('Click Confirm to save changes').addClass('blinkingRed').removeClass('blinking');
            });
        });
        $('#divDevicesList').show();
    }
    else if (Type == 'attach_device') {
        $('#divDevicesList').hide();
        isNewVDisk = true;
        GetVmVDisks();
        EnableAddVDisk()
        notify(response.description, response.description, response.status);
        ShowAttachedDevices();
    }
    else {
        notify(response.description, response.description, response.status);
    }
}

function ShowUpdatedVMDetails() {
    if (serverConfig.VMId > 0) {
        var request = new Request();
        request.url = "cgi/cgi_myServersView_details.py";
        request.parameters = {
            'id': serverConfig.VMId
        };
        request.Type = "ShowPopUp";
        CallPythonService(request);
        $('#popImgDetatils').modal('show');
    }

}

function ShowUpdatedVMDetailsRefresh() {
    if (serverConfig.VMId > 0) {
        var request = new Request();
        request.url = "cgi/cgi_myServersView_details.py";
        request.parameters = {
            'id': serverConfig.VMId
        };
        request.Type = "ShowPopUp";
        CallPythonService(request);
    }

}

function ShowImgDetatils(id) {
    serverConfig.VMId = id;
    var request = new Request();
    request.url = "cgi/cgi_myServersView_details.py";
    request.parameters = {
        'id': id
    };
    request.Type = "ShowPopUp";
    CallPythonService(request);

}

function GetImageNames() {
    var request = new Request();
    request.url = "cgi/cgi_myServersView_getNames.py";
    request.Type = "AllImages";
    CallPythonService(request);
}

function GetServerDetails(vmName) {
    var request = new Request();
    request.url = "cgi/cgi_myServerView_get_ntwDetails.py";
    request.parameters = {
        'server_name': vmName
    };
    request.Type = "ServerDetails";
    $('#txtvmName').html(vmName);
    CallPythonService(request);
}

function BindSystemUsage() {
    var request = new Request();
    request.url = "cgi/cgi_myServer_SystemUsage.py";
    request.Type = "SystemUsage";
    CallPythonService(request);
}

function BindAvailableResources() {
    var request = new Request();
    request.url = "cgi/cgi_totalResource_Available.py";
    request.Type = 'AvailableResource';
    CallPythonService(request);
}

function SetUpResouceDials() {
    $('#rangeVcpu').attr('max', availableSources.vcpu + UsedSources.vcpu);
    $('#rangeMemory').attr('max', availableSources.memory + UsedSources.memory);
    $('#rangeStorage').attr('max', (availableSources.storage + UsedSources.storage));
    $('#rangeVcpu').attr('min', UsedSources.vcpu);
    $('#rangeMemory').attr('min', UsedSources.memory);
    $('#rangeStorage').attr('min', (UsedSources.storage - SelectedConfig.storage));
    $('#rangeVcpu').val(serverConfig.vcpu);
    $('#rangeMemory').val(serverConfig.memory);
    $('#rangeStorage').val(serverConfig.storage);

    //var rangeSlider = function () {
    //    var slider = $(".range-sliderd"),
    //      range = $(".range-slider__range"),
    //      value = $(".range-slider__value");

    //    slider.each(function () {
    //        value.each(function () {
    //            var value = $(this).prev().attr("value");
    //            $(this).html(value);
    //        });

    //        range.on("input", function () {
    //            $(this).next(value).html(this.value);
    //        });
    //    });
    //};

    //rangeSlider();
}
function GetState(id) {
    if (id == 4)
        return 'Off';
    else if (id == 6)
        return 'On'
    else if (id == 5)
        return 'Pause'
    else
        return ''
}

function ModifyServerConfiguration(ResourceType) {
    $('#txtUpdate').attr('oninput', '');
    $('#txtUpdate').attr('step', 1);
    if (ResourceType === 'vcpu') {
        $('#lblType').html('VCPU');
        $('.lblSizeType').html('VCPU');
        $('#txtUsed').val(UsedSources.vcpu);
        $('#txtUpdate').val(serverConfig.vcpu - UsedSources.vcpu);
        $('#txtUpdate').attr('max', availableSources.vcpu);
        $('#txtUpdate').attr('oninput', "this.value=this.value.replace(/[^0-9]/g,'');");
        $('#txtAvailable').val(availableSources.vcpu);
    } else if (ResourceType === 'memory') {
        $('#lblType').html('Memory');
        $('.lblSizeType').html('GB');
        $('#txtUsed').val(UsedSources.memory);
        $('#txtUpdate').val(serverConfig.memory - UsedSources.memory);
        $('#txtUpdate').attr('max', availableSources.memory);
        $('#txtUpdate').attr('step', 0.5);
        $('#txtAvailable').val(availableSources.memory);
    } else if (ResourceType === 'storage') {
        $('#lblType').html('Storage');
        $('.lblSizeType').html('GB');
        $('#txtUsed').val(UsedSources.storage);
        $('#txtUpdate').val(serverConfig.storage - UsedSources.storage + SelectedConfig.storage);
        $('#txtUpdate').attr('oninput', "this.value=this.value.replace(/[^0-9]/g,'');");
        $('#txtUpdate').attr('max', availableSources.storage);
        $('#txtAvailable').val(availableSources.storage);
    }
    serverConfig.resourceType = ResourceType
    $('#updatePopUp').modal('show');
}

function UpdateServerConfig() {
    if (serverConfig.resourceType === 'vcpu') {
        if (parseInt($('#txtUpdate').val()) > 0) {
            if (parseInt($('#txtUpdate').val()) <= availableSources.vcpu)
                serverConfig.vcpu = parseInt($('#txtUpdate').val()) + UsedSources.vcpu;
            else
                $('#ResourceUpdatePop').modal('show');
            //serverConfig.vcpu = availableSources.vcpu+UsedSources.vcpu;
        } else
            $('#ResourceUpdateLowPop').modal('show');
        $('#rangeVcpu').val(serverConfig.vcpu);
    } else if (serverConfig.resourceType === 'memory') {
        if (parseFloat($('#txtUpdate').val()) >= 0.5) {
            if (parseFloat($('#txtUpdate').val()) <= availableSources.memory)
                serverConfig.memory = parseFloat($('#txtUpdate').val()) + UsedSources.memory;
            else
                $('#ResourceUpdatePop').modal('show');
            //serverConfig.memory = availableSources.memory + UsedSources.memory;
        } else
            $('#ResourceUpdateLowPop').modal('show');
        $('#rangeMemory').val(serverConfig.memory);
    } else if (serverConfig.resourceType === 'storage') {
        if (parseInt($('#txtUpdate').val()) >= 500) {
            if (parseInt($('#txtUpdate').val()) <= availableSources.storage)
                serverConfig.storage = parseInt($('#txtUpdate').val()) + UsedSources.storage - SelectedConfig.storage;
            else
                $('#ResourceUpdatePop').modal('show');
            //serverConfig.storage = availableSources.storage + UsedSources.storage;
        } else
            $('#ResourceUpdateLowPop').modal('show');
        $('#rangeStorage').val(serverConfig.storage);
    }
    //$('#resizeAll').modal('hide');
    $('#resizeAll').modal('show');
    ProfileSetUp();
}

function BindAllNetworks() {
    var request = new Request();
    request.url = "cgi/cgi_myserver_get_GIN.py";
    request.Type = 'AllNetwork';
    request.parameters = {
        "getType": "network"
    };
    CallPythonService(request);
}

function UpdateResizedConfig(Type) {
    if (Type === 'All') {
        var arr = [];
        $('input.checkbox:checkbox:checked').each(function () {
            arr.push($(this).attr('id').match(/\d+/)[0]);
        });
        if (arr.length > 0) {
            //var request = new Request();
            //request.url = "cgi/cgi_myServerEdit_resizeUpdate.py";
            //request.Type = 'resizeUpdateDB';
            //request.parameters = { "server_name": $('#myModalLabelPop').text(), "vCPUs": serverConfig.vcpu, "memory": serverConfig.memory, "storage": serverConfig.storage };
            //CallPythonService(request);


            var networkIds = arr.toString() != null ? arr.toString() : "0";
            var request = new Request();
            request.url = "cgi/cgi_myServerEdit_updateNetwork.py";
            request.Type = 'resizeUpdateDB';
            request.parameters = {
                "server_name": $('#myModalLabelPop').text(),
                network_ids: arr.toString()
            };
            serverConfig.ShowResize = false;
            CallPythonService(request);
        } else
            alert('Atleast one Network Required');
    } else {
        var request = new Request();
        request.url = "cgi/cgi_myServerEdit_resizeUpdate.py";
        request.Type = 'resizeUpdateDB';
        request.parameters = {
            "server_name": $('#myModalLabelPop').text(),
            "vCPUs": serverConfig.vcpu - UsedSources.vcpu,
            "memory": serverConfig.memory - UsedSources.memory,
            "storage": serverConfig.storage - UsedSources.storage + SelectedConfig.storage
        };
        serverConfig.ShowResize = true;
        CallPythonService(request);
    }
}

function SetVMOff() {
    var state = 0;
    if (availableSources.currentState === 7)
        state = 7;
    var request = new Request();
    request.url = "cgi/cgi_myServerEdit_setVM_OFF.py";
    request.Type = 'OffVM';
    request.parameters = {
        "server_name": $('#myModalLabelPop').text(),
        "state": 0
    };
    CallPythonService(request);
}
$('#btnState').click(function () {
    var state = parseInt(availableSources.currentState);
    if (state === 6 || state === 7) {
        $('#vmOffPopup').modal('show');
    } else if (state === 4) {
        LaunchVirtualMachine();
    }
});

function StartProgressBar() {
    var width = 1;
    var id = setInterval(frame, serverConfig.progressbarTime * 10);

    function frame() {
        if (width >= 100) {
            clearInterval(id);
        } else {
            width++;
            $('#myBar').css('width', width + '%');
            $('#myBar').html('' + width + '%' + '')
        }
    }
}

function CallNextStateLaunchVM(currentState) {
    var serverName = $('#myModalLabelPop').text();
    if (currentState == 4) {
        $("#divResponse").addClass('alert alert-success');
        $("#divResponse").html('<b>' + 'Virtual Machine ' + serverName + ' is ready to Start with selected configuration' + '</b>');
        $("#vmLaunchPopUp").modal('show');
    }
    if (currentState == 5) {
        $("#divResponse").addClass('alert alert-success');
        $("#divResponse").html('<b>' + 'Virtual Machine Starting...' + '</b>');
        $("#vmLaunchPopUp").modal('show');
    }
    if (currentState != 6) {
        $("#divProgress").css("display", "block");
        StartProgressBar();
        $(".clsClose").removeAttr('data-dismiss').attr('disabled', true);
        var request = new Request();
        request.url = "cgi/cgi_myserver_launch.py";
        request.Type = 'launchVM';
        request.parameters = {
            "server_name": serverName,
            "state": currentState
        };
        CallPythonService(request);
    } else {
        $("#divProgress").css("display", "none");
        $(".clsClose").attr("data-dismiss", "modal").attr('disabled', false);

        BindLedStates(parseInt(currentState));
        availableSources.currentState = parseInt(currentState);
        BindAvailableResources();
    }
}

function CallNextStateOffVM(currentState) {
    var serverName = $('#txtServerName').val();
    //if (currentState == 7) {
    //    $("#divResponse").addClass('alert alert-success');
    //    $("#divResponse").html('<b>' + 'Virtual Machine ' + serverName + ' is ready to Suspend' + '</b>');
    //    $("#vmLaunchPopUp").modal('show');
    //}
    //if (currentState == 5) {
    //    $("#divResponse").addClass('alert alert-success');
    //    $("#divResponse").html('<b>' + 'Virtual Machine Starting...' + '</b>');
    //    $("#vmLaunchPopUp").modal('show');
    //}
    if (currentState != 4) {
        $("#divProgress").css("display", "block");
        StartProgressBar();
        $(".clsClose").removeAttr('data-dismiss').attr('disabled', true);
        var request = new Request();
        request.url = "cgi/cgi_myServerEdit_setVM_OFF.py";
        request.Type = 'OffVM';
        request.parameters = {
            "server_name": $('#myModalLabelPop').text(),
            "state": currentState
        };
        CallPythonService(request);
    } else {
        $("#divProgress").css("display", "none");
        $(".clsClose").attr("data-dismiss", "modal").attr('disabled', false);
        $('#divFooterMsg').html('The VM will still be in the OFF state when selecting OK');
        BindLedStates(parseInt(currentState));
        availableSources.currentState = parseInt(currentState);
        BindAvailableResources();
    }
}

function LaunchVirtualMachine() {

    var serverName = $('#myModalLabelPop').text();
    var request = new Request();
    request.url = "cgi/cgi_myserver_launch.py";
    request.Type = 'launchVMconfirm';
    request.parameters = {
        "server_name": serverName,
        "state": 0
    };
    CallPythonService(request);

}

function DeleteVM() {
    var serverName = $('#myModalLabelPop').text();
    var request = new Request();
    request.url = "cgi/cgi_myServerEdit_deleteVM.py";
    request.Type = 'DeleteVM';
    request.parameters = {
        "server_name": serverName
    };
    CallPythonService(request);
}

function PauseResetVM() {
    var serverName = $('#myModalLabelPop').text();
    var request = new Request();
    if (availableSources.currentState == 7) {
        request.url = "cgi/cgi_myServerEdit_pauseVM.py";
        request.Type = 'PauseResetVM';
        request.parameters = {
            "server_name": serverName,
            "type": 'reset'
        };
        CallPythonService(request);
    } else {
        request.url = "cgi/cgi_myServerEdit_pauseVM.py";
        request.Type = 'PauseResetVM';
        request.parameters = {
            "server_name": serverName,
            "type": 'pause'
        };
        CallPythonService(request);
    }

}

function BindLedStates(currentState) {
    $('#btnPause').attr('class', 'smbtn red yellow');

    if (currentState === 6) {
        $('#btnState').attr('class', 'smbtn led-green');
        $('#btnState').attr('title', 'On');
        $('#btnState').text('On');
    } else if (currentState === 4) {
        $('#btnState').attr('class', 'smbtn led-red');
        $('#btnState').attr('title', 'Off');
        $('#btnState').text('Off');
    } else if (currentState === 7) {
        $('#btnState').attr('class', 'smbtn green');
        $('#btnState').attr('title', 'Pause');
        $('#btnState').text('On');


        $('#btnPause').attr('class', 'smbtn led-yellow');
        //$('#btnPause').attr('title', 'Pause');
        //$('#btnPause').text('pause');
    }
    if (currentState === 6 || currentState === 0 || currentState === 7) {
        $('input[type=checkbox]').each(function () {
            $(this).attr('disabled', 'disabled');
            $(this).attr('title', 'Turn Off to select network');
        });
    } else {
        $('input[type=checkbox]').each(function () {
            $(this).removeAttr('disabled', 'disabled');
            $(this).removeAttr('title');
        });
    }
    BindSystemUsage();
}

function ConfirmPopUp(ConfirmType) {
    if (availableSources.currentState != 0) {
        var showConfirm = true;
        if (ConfirmType === 'UpdateConfig') {
            $('#divConfirmMessage').html("Do you want Update Resources??");
            $('#divCallBackFn').attr('onclick', "UpdateResizedConfig('resize')");
            $('#divNoCallBackFn').attr('onclick', "ResizeNoCallBackFn()");

        } else if (ConfirmType === 'DeleteVM') {
            if (availableSources.currentState == 4) {
                $('#divConfirmMessage').html("Do you want Delete Virtual Machine??");
                $('#divCallBackFn').attr('onclick', "DeleteVM()");
                $('#divNoCallBackFn').attr('onclick', "javascript:void(0);");
            } else if (availableSources.currentState == 6) {
                $('#divMessage').html('Cannot Delete a Running App. Please Turnoff & Delete');
                $('#messagePopUP').modal('show');
                showConfirm = false;
            } else {
                $('#divMessage').html('Cannot Delete a Paused App. Please Turnoff & Delete');
                $('#messagePopUP').modal('show');
                showConfirm = false;
            }
        } else if (ConfirmType === 'UpdateServerDetails') {
            if (availableSources.currentState == 4) {
                $('#divConfirmMessage').html("Do you want to Update Server Details??");
                $('#divCallBackFn').attr('onclick', "UpdateResizedConfig('All')");
                $('#divNoCallBackFn').attr('onclick', "GetServerDetails('" + $('#myModalLabelPop').text() + "')");
            } else if (availableSources.currentState == 6) {
                $('#divMessage').html('Cannot Update a Running App. Please Turnoff & Update');
                $('#messagePopUP').modal('show');
                showConfirm = false;
            } else {
                $('#divMessage').html('Cannot Update a Paused App. Please Turnoff & Update');
                $('#messagePopUP').modal('show');
                showConfirm = false;
            }
        } else if (ConfirmType === 'pauseReset') {
            if (availableSources.currentState != 4) {
                if (availableSources.currentState === 7)
                    $('#divConfirmMessage').html("Do you want to Restart Virtual machine??");
                else
                    $('#divConfirmMessage').html("Do you want to Pause Virtual machine??");
                $('#divCallBackFn').attr('onclick', "PauseResetVM()");
                $('#divNoCallBackFn').removeAttr('onclick');
            } else {
                $('#divMessage').html('Can not pause Off App');
                $('#messagePopUP').modal('show');
                showConfirm = false;
            }
        } else if (ConfirmType === 'resizeVM') {
            if (availableSources.currentState === 4) {
                $("#resizeAll").modal('show');
                ProfileSetUpbyVM($('#myModalLabelPop').text());
                //BindAvailableResources();
                showConfirm = false;
            } else if (availableSources.currentState == 6) {
                $('#divMessage').html('Cannot Resize a Running App. Please Turnoff & Resize');
                $('#messagePopUP').modal('show');
                showConfirm = false;
            } else {
                $('#divMessage').html('Cannot Resize a Paused App. Please Turnoff & Resize');
                $('#messagePopUP').modal('show');
                showConfirm = false;
            }


        }

        if (showConfirm)
            $("#popConfirm").modal('show');
    } else {
        $('#divMessage').html('Please Select Virtual Machine to perform actions');
        $('#messagePopUP').modal('show');
    }
}

function CreateSnapShot() {
    swal({
        title: "App Snapshot",
        text: "Enter snapshot copy name:",
        type: "input",
        showCancelButton: true,
        closeOnConfirm: false,
        inputPlaceholder: $('#myModalLabelPop').text(),
        inputValue: $('#myModalLabelPop').text() + "-ss1"
    }, function (inputValue) {
        if (inputValue === false) return false;
        if (inputValue === "") {
            swal.showInputError("Snapshot copy name required!");
            return false
        }
        else {
            var serverName = $('#myModalLabelPop').text();
            var request = new Request();
            request.url = "cgi/cgi_CreateSnapshot.py";
            request.Type = 'CreateSnap';
            request.parameters = {
                "server_name": serverName,
                "snapshot_name": inputValue,
                "type": 'local'
            };
            CallPythonService(request);
            $("#loader").attr('style', 'display:block');
        }
        //swal("Success", inputValue + " Snapshot Created", "success");
    });
}

function CreateAppBackup() {
    var AppName = ($('#myModalLabelPop').text()) + "-rep1";
    swal({
        title: "App Backup",
        text: "<div style='text-align: left;'><div>Remote Backup name:" + "<input type='text' style='width:200px;margin-left: 24px;border: 1px solid #ccc;border-radius: 4px;' id='txtbckupname' value='" + AppName + "'/></div><div style='padding-top: 4px;padding-bottom: 4px'>Backup Server: <select id='ddlbckupServer' style='width:200px;margin-left: 80px;border: 1px solid #ccc;border-radius: 4px;'><option>Sanuyi Cloud</option><option>AWS</option><option>Ingram Cloud</option></select></div>Backup Attached vDisk:<input type='radio' name='rbyn' style='margin-left: 9px;'> Yes <label style='width:5px'></label><input type='radio' name='rbyn'> No </div>",
        //type: "input",
        html: true,
        showCancelButton: true,
        closeOnConfirm: false,
        inputPlaceholder: $('#myModalLabelPop').text(),
        inputValue: $('#myModalLabelPop').text() + "-rep1"
    }, function (inputValue) {
        if (inputValue === false) return false;
        if ($('#txtbckupname').val() === "") {
            swal.showInputError("Backup name required!");
            return false
        }
        var backupName = $('#txtbckupname').val();
        var backupServer = $('#ddlbckupServer').val();

        var request = new Request();
        request.url = "cgi/cgi_backupServer.py";
        request.Type = 'backupServer';
        request.parameters = {
            "backupName": backupName,
            "backupServer": backupServer,
            "VMId": serverConfig.VMId
        };
        CallPythonService(request);
        $("#loader").attr('style', 'display:block');
        //swal("Progress...", $('#txtbckupname').val() + " Remote Backup in process 5% complete, ETA 4hrs 10mins", "info");
    });
}

function CreateVDisk() {
    // swal({
    // title: "vDisk",
    // text: "Add Storage:",
    // type: "input",
    // showCancelButton: true,
    // closeOnConfirm: false,
    // inputPlaceholder: "Enter Storage Size",
    // inputValue: ""
    // }, function(inputValue) {
    // if (inputValue === false) return false;
    // if (inputValue === "") {
    // swal.showInputError("Storage Size required!");
    // return false
    // }
    // swal("Success", "vDisk Created with storage " + inputValue, "success");
    // });
    isNewVDisk = true;
    GetVmVDisks();
    ShowAttachedDevices();
    $('#divNewDisk').hide();
    $('#divDevicesList').hide();
    $('#btnAddVdisk').attr('disabled', false);
    $('#btnAttachVMDevices').attr('disabled', false);
    $('#vDiskPool').modal('show');

    $('#divAttachedDisks').show();
    $('#divSavedDevicesList').show();
}

function DeleteVDisk() {
    var arr = []
    $('input.clsVolumeId:checkbox:checked').each(function () {
        arr.push($(this).attr('value'));
    });

    if (arr.toString() == '') {
        swal("Cancelled", "Please select atleast one disk", "warning");
        return false;
    }
    swal({
        title: "Are you sure?",
        text: "You want to Delete, Delete will loose all data and cannot be recovered !",
        type: "warning",
        showCancelButton: true,
        confirmButtonClass: "btn-danger",
        confirmButtonText: "Yes, delete it!",
        cancelButtonText: "No, cancel",
        closeOnConfirm: false,
        closeOnCancel: false
    },

        function (isConfirm) {
            if (isConfirm) {
                var request = new Request();
                request.url = "cgi/cgi_AttachVDisk.py";
                request.Type = 'DeleteVDisk';
                request.parameters = {
                    "volumeIds": arr.toString(), "requestType": "delete_VDisk"
                };
                CallPythonService(request);

            } else {
                swal("Cancelled", "Your Disks are safe :)", "error");
            }
        });
}
function SaveVDisk() {
    var VdiskName = $('#txtVdiskName').val()
    var ddlPoolId = $('#ddlPool1').val()
    var PoolSize = $('#txtPoolSize').val()
    var dedup = $('#chkDedup').is(":checked");
    var compression = $('#chkCompression').is(":checked");
    if (VdiskName == '' || PoolSize == '') {
        swal("Warning", "All fields are mandatory", "warning")
        return false;
    }

    var request = new Request();
    request.url = "cgi/cgi_AttachVDisk.py";
    request.Type = 'SaveVDisk';
    request.parameters = {
        "vDiskName": VdiskName, "poolId": ddlPoolId, "poolSize": PoolSize, "dedup": dedup, "compression": compression, "VMId": serverConfig.VMId, "requestType": "create_VDisk"
    };
    CallPythonService(request);
    //swal("Success", "Disks added successfully", "success")
}
function GetPoolList() {
    var request = new Request();
    request.url = "cgi/cgi_Pool_Get.py";
    request.Type = 'GetPool';
    request.parameters = {
        "requestType": ""
    };
    CallPythonService(request);
}
function GetVmVDisks() {
    var request = new Request();
    request.url = "cgi/cgi_AttachVDisk.py";
    request.Type = 'GetVmVDisks';
    request.parameters = {
        "VMId": serverConfig.VMId, "requestType": "read_VDisk"
    };
    CallPythonService(request);
}
$('#btnAddVdisk').click(function () {
    $('#btnAddVdisk').attr('disabled', true);
    $('#btnAttachVMDevices').attr('disabled', true);

    $('#tblhead thead').append('<td><input type="hidden" id="hdnSPPoolId"><input type="text" id="txtVdiskName" class="form-control validate[required]" placeholder="Disk Name"></td><td><input type="text" id="txtPoolSize" class="form-control validate[required]" placeholder="100 G"></td><td align="center"><input type="checkbox" class="customcheckbox" id="chkDedup"></input></td><td align="center"><input type="checkbox" class="customcheckbox" id="chkCompression"></input></td></td><td><select class="form-control ddlPool" id="ddlPool1"></select></td><td><span class="linksBlk"><a href="javascript:void(0);" onclick="SaveVDisk()">Confirm</a><a href="javascript:void(0);" onclick="isNewVDisk=true;GetVmVDisks();EnableAddVDisk()">Canecl</a></span></td>');
    GetPoolList();
    $('#txtVdiskName').focus();
    $('#divNewDisk').show();

    $('#divSavedDevicesList').hide();
});
$('#btnAttachVMDevices').click(function () {
    $('#btnAddVdisk').attr('disabled', true);
    $('#btnAttachVMDevices').attr('disabled', true);

    $('#tblhead thead').append('<td><input type="hidden" id="hdnSPPoolId"><input type="text" id="txtVdiskName" class="form-control validate[required]" placeholder="Disk Name" disabled></td><td><input type="text" id="txtPoolSize" class="form-control validate[required]" placeholder="100 G" disabled></td><td align="center"><input type="checkbox" class="customcheckbox" id="chkDedup" disabled></input></td><td align="center"><input type="checkbox" class="customcheckbox" id="chkCompression" disabled></input></td></td><td width="20%" class="multiSelectBox"><select multiple="multiple" id="ddlStorageManager" ></select></td><td><span class="linksBlk"><a href="javascript:void(0);" onclick="SaveAttachDevices()">Confirm</a><a href="javascript:void(0);" onclick="isNewVDisk=true;GetVmVDisks();EnableAddVDisk()">Canecl</a></span></td>');
    GetStorageManagerList();
    $('#txtVdiskName').focus();
    $('#divNewDisk').show();

    $('#ddlStorageManager').bind('change', function () {
        //storageMid = $(this).val();
        var storageMid = $('#ddlStorageManager').val() != null ? $('#ddlStorageManager').val().toString() : '0';
        GetDevicesList(storageMid);
    });

    $('#divAttachedDisks').hide();
});
function EnableAddVDisk() {
    $('#btnAddVdisk').attr('disabled', false);
    $('#btnAttachVMDevices').attr('disabled', false);
    $('#divNewDisk').hide();
    $('#divDevicesList').hide();

    $('#divAttachedDisks').show();
    $('#divSavedDevicesList').show();
}

function showVMLogs() {
    var request = new Request();
    request.url = "cgi/cgi_App_Manager.py";
    request.Type = 'GetVmVDisks';
    request.parameters = {
        "VMId": serverConfig.VMId, "requestType": "read_AppLogs"
    };
    CallPythonService(request);
}
function ShowAppGroups() {
    var request = new Request();
    request.url = "cgi/cgi_Organization_Manager.py";
    request.parameters = { "RequestType": 'read_Group', "groupId": 0 };
    request.Type = "ShowAppGroups";
    CallPythonService(request);
    $('#orgSetupGroupsPopup').modal('show');
}
function SaveSelectedGroups() {
    var request = new Request();
    request.url = "cgi/cgi_App_Manager.py";
    request.parameters = { "requestType": 'update_AppLinkGroups', "appId": serverConfig.VMId, "selectedGroups": userSelectedGroups.toString() };
    request.Type = "UpdateAppGroups";
    CallPythonService(request);
    $('#orgSetupGroupsPopup').modal('show');
}
function GetStorageManagerList() {
    var request = new Request();
    request.url = "cgi/cgi_StorageManager.py"
    request.Type = "getAllStorageManagers";
    request.parameters = { "requestType": 'read_Storage', "storageId": 0 };
    CallPythonService(request);
}
function GetDevicesList(storageId) {
    var request = new Request();
    request.url = "cgi/cgi_StorageManager.py"
    request.Type = "GetDeviceListBySMId";
    request.parameters = { "requestType": 'read_Devices', "storageId": storageId };
    CallPythonService(request);
}
function SaveAttachDevices() {
    var arr = []
    $('input.clsDeviceId:checkbox:checked').each(function () {
        arr.push($(this).attr('value'));
    });

    if (arr.toString() == '') {
        swal("Cancelled", "Please select atleast one Device to attach", "warning");
        return false;
    }
    swal({
        title: "Are you sure?",
        text: "You want to Attach selected Devices",
        type: "warning",
        showCancelButton: true,
        confirmButtonClass: "btn-danger",
        confirmButtonText: "Yes, Attach!",
        cancelButtonText: "No, cancel",
        closeOnConfirm: true,
        closeOnCancel: true
    },

        function (isConfirm) {
            if (isConfirm) {
                var request = new Request();
                request.url = "cgi/cgi_AttachVDisk.py";
                request.Type = 'attach_device';
                request.parameters = {
                    "requestType": "attach_device", "VMId": serverConfig.VMId, "deviceIds": arr.toString()
                };
                CallPythonService(request);

            } else {
                swal("Cancelled", "Selected Devices are not attached to VM :)", "error");
            }
        });
}
function ShowAttachedDevices() {
    var request = new Request();
    request.url = "cgi/cgi_AttachVDisk.py";
    request.Type = 'read_AttacheDdevice';
    request.parameters = {
        "requestType": "read_AttacheDdevice", "VMId": serverConfig.VMId
    };
    CallPythonService(request);
}
