var selectedStorage = 0;
var selectedProtocol = 0;
var hostActionPage = '';
var selectedHost = 0;
var selectedDevice = {name:"",id:0};

function HostGrayedOutRules(){
	var hostGrayedOutRules =[{'protocol':1,'remote_share':1},
							 {'protocol':2,'remote_share':1},
							 {'protocol':3,'remote_share':0},
							 {'protocol':4,'remote_share':0},
							 {'protocol':5,'remote_share':0},
							 {'protocol':6,'remote_share':0},
							 {'protocol':7,'remote_share':0},
							{'protocol':8,'remote_share':0},
							 {'protocol':9,'remote_share':0},
							 {'protocol':999,'remote_share':1} 
							];
	return hostGrayedOutRules;
}

function Request() {
    var request = {
        url: "",
        parameters: {},
        statusType: "",
		typeNumber: "",
		isSingleStatus:false
    };
    
    return request;
}
$(window).bind("load", function() {
	GetStorageDetails();
	BindAllProtocols();
	BindAllHosts();
	if(location.hash.substr(1) !="")
		$('#divBackButton').show();
	else
		$('#divBackButton').hide();
});
function CallPythonService(request) {
	request.parameters.uuid=uuid;
    $.ajax({
        type: "Get",
        url: request.url,
        contentType: 'application/json',
        dataType: 'json',
        headers: { 'Access-Control-Allow-Origin': '*' },
        data: request.parameters,
        success: function (response) {			
				BindResponseData(request.statusType,response);
        },
        error: function (ex) {
            if(!isProduction){
				console.log(ex);
			}
        }
    });
}

function BindResponseData(statusType, response) {
	if (statusType == 'getProtocol')
	{
		$("#ddlProtocol option").remove();	
		$('#ddlProtocol').append(new Option('Select',''));
		$.each(response, function (i, item) {
            $('#ddlProtocol').append(new Option(item.protocolName, item.id));
        });
	}
	else if(statusType == 'getHosts')
	{
		$("#ddlStorageTarget option").remove();	
		$('#ddlStorageTarget').append(new Option('-- Select --',''));
		$.each(response, function (i, item) {
			if(item.protocol_id == selectedProtocol || selectedProtocol==0)
            	$('#ddlStorageTarget').append(new Option(item.name, item.id));            
        });
	}
	else if(statusType == 'getAllStorage')
	{
		var table = $('#tblStorageManager').DataTable();
		table.destroy();
		$('#tbodyStorageManager').html('');
		$.each(response, function (i, item) {
			var isDisabled = item.state == 1 ? '':'hide';
			var stateTxt = item.state == 1 ? 'Online':'Offline';
			var isDisabled = '';
			item.nametxt = trimString(item.name,20);
			strStorage = `<tr>
												<td width="30px"><input onclick="selectedVolume=`+item.id+`" class="clsStorageRecord" name="rdVolume" value="`+item.id+`" type="radio" volType="`+item.type+`" id="chkVolume_`+item.id+`" `+isDisabled+`></td>
                                                <td><span title="`+item.name+`">`+item.nametxt+`</span></td>
												<td>`+stateTxt+`</td>
                                                <td>`+item.host_name+`</td>
												<td>`+item.host_ip+`</td>
                                                <td>`+item.host_url+`</td>
                                                <td>`+item.port+`</td>
                                                <td>`+item.protocol_name+`</td>
                                                <td>`+item.remoteDir+`</td>
                                                <td>`+item.num_devices+`</td>
                                                <td align="center">
                                                    <span class="">
													<a href="#" onclick="ShowSMDeives(`+item.id+`,'`+item.name+`')" class="smbtn yellow oval" title="App shared Groups" data-toggle="modal"><span>Devices</span></a>
												  </span>
										  
                                                </td>
                                            </tr>`;
			$('#tbodyStorageManager').append(strStorage);
				$('.clsStorageRecord').on('change',function(){
			selectedStorage = $(this).attr('value');
		});
			
		});
		table = $('#tblStorageManager').DataTable();
		table.destroy();
		$('#tblStorageManager').DataTable(GetTableConfig('volumeManager'));
		
		
	}
	else if(statusType == 'SaveStorage')
	{
		
		if(response.status !='fail')
		{
			NavigateToPage();
			GetStorageDetails();
			swal("Success", response.description , "success");
			$('.clsSMPage').removeClass('alert-danger');
		}else
		{
			swal("Error", response.description , "error");
		}
		
	}
	else if(statusType == 'editStorage')
	{
		
		if(response.status !='fail')
		{
			NavigateToPage();
			GetStorageDetails();
			swal("Success", response.description , "success");
			$('.clsSMPage').removeClass('alert-danger');
		}else
		{
			swal("Error", response.description , "error");
		}
		
	}
	else if(statusType == 'ConnectDisconnectSM')
	{
		if(response.status !='fail')
		{
			//NavigateToPage();
			GetStorageById();
			GetStorageDetails();
			
			swal("Success", response.description , "success");
			//$('.clsSMPage').removeClass('alert-danger');
		}else
		{
			swal("Error", response.description , "error");
		}
	}
	else if(statusType == 'ScanSM')
	{
		if(response.status !='fail')
		{
			//NavigateToPage();
			GetStorageById();
			GetStorageDetails();
			
			swal("Success", response.description , "success");
			//$('.clsSMPage').removeClass('alert-danger');
		}else
		{
			swal("Error", response.description , "error");
		}
	}
	else if(statusType =='getStorage')
	{
		storage = response[0];
		$('#txtName').val(storage.name);
		$('#txtRemoteDir').val(storage.remoteDir);
		$('#ddlProtocol').val(storage.protocol);
		$('#ddlStorageTarget').val(storage.host_id);
		$('#ddlStatus').val(storage.state);
		if(storage.state == 0){
			var btnText = 'Connect';
			$('#btnScan').addClass('custom-disabled');
		}
		else {
			var btnText = 'Disconnect';
			$('#btnScan').removeClass('custom-disabled');
		}
		
		//$('#btnAction').attr('onclick','SaveSM()').html(btnText);
		$('#btnConnect').attr('onclick','ConnectDisconnectSM()').html(btnText);
		gray_out_rules(storage.protocol);
	}
	else if(statusType == 'OnOffDevice')
	{
		swal("Success", response.description , "success");
		ShowSMDeives(selectedDevice.id,selectedDevice.name);
	}
	else if(statusType == 'deviceInfo')
	{
		$('#divDeviceInfo').html('');
		$.each(response, function (i, item) {
		var infoData=`<div class="form-group">
						<div class="col-lg-12 padding-0">
							<div class="col-xs-4 padding-0">
								<h4><b>`+item.propertyName+`:</b></h4>
							</div>
							<div class="col-xs-4 padding-0">
								<h4>`+item.propertyValue+`</h4>
							</div>
						</div>
                       </div>`;
			$('#divDeviceInfo').append(infoData);
		});
		$('#deviceInfoPop').modal('show');
	}
	else if(statusType == 'deleteStorage')
	{
		if(response.status !='fail'){
			selectedStorage = 0;
			GetStorageDetails();
			swal("Success", response.description , "success");
		}
		else
		{
			swal("Error", response.description , "error");
		}
	}
	else if (statusType == 'GetDeviceListBySMId')
	{
		var table = $('#tblDevices').DataTable();
		table.destroy();
		$('#tbodyDevices').html('');
		
		$.each(response, function (i, item) {
			var onClass = item.state == 1 ? '':'hide';
			var offClass = item.state == 0 ? '':'hide';
			item.nametxt = trimString(item.source,25);
			
		var strStorage = `<tr>												
                                                <td><span title="`+item.source+`">`+item.nametxt+`</span></td>
                                                <td><span title="`+item.target+`">`+trimString(item.target,18)+`</span></td>
												<td>`+item.protocol+`</td>
                                                <td>`+item.size+`</td>
                                                <td>`+item.available+`</td>
												<td>`+item.per_used+`</td>                                              
                                                <td align="center">
                                                    <span class="linksBlk"> 
                                          
											  <a href="javascript:void(0);" class=" yellowBG">
                                          <img src="images/infoIcon.png" alt="infoIcon" title="Info" onclick="DeviceInfo(`+item.id+`)"></a>  
										   
										   <label class="radio-switch `+offClass+`" title="Click to Turn On Device">
												<input type="checkbox" name="VolumeToggele"  onclick="OnOffDevice(`+item.id+`,`+1+`)">
												<span class="slider"></span>
											</label>
											
											<label class="radio-switch `+onClass+`" title="Click to Turn Off Device">
												<input type="checkbox" name="VolumeToggele" onclick="OnOffDevice(`+item.id+`,`+0+`)" checked>
												<span class="slider"></span>
											</label>

                                          </span>
                                                </td>
                                            </tr>`;
				$('#tbodyDevices').append(strStorage);						
		});
		table = $('#tblDevices').DataTable({
			"bAutoWidth": false,
            "columns": [
                { "width": "20%" },
                { "width": "15%" },
                null,
                { "width": "12%" },
				{ "width": "15%" },
                { "width": "10%" },
                { "width": "15%" }
            ]
        });
		//table.destroy();
		//$('#tblDevices').DataTable(GetTableConfig('volumeManager'));
		
		$('#DevicesPopup').modal('show');	
	}
}
$('.clsStorageRecord').change(function(){
	selectedStorage = $(this).attr('value');
});
$('.clsSMPage').click(function(){
	$('.clsSMPage').removeClass('alert-danger');
	$(this).addClass('alert-danger');
});
function NavigateToPage(page)
{
	$('#stroageManagerAdd').css('display','none');
	$('#divStatus').css('display','block');
	$('#divRemoteDir').css('display','block');
	
	$('#txtName').val('');
	$('#ddlProtocol').val('');
	$('#ddlStorageTarget').val('');
	$('#ddlStatus').val(0);
	
	if(page == 'Add'){
		selectedStorage = 0;
		$('#divRemoteDir').css('display','block');
		$('#divStatus').css('display','none');
		$('#btnAction').attr('onclick','SaveSM()').html('Confirm');
		$('#stroageManagerAdd').css('display','block');
		$('#btnConnect').css('display','none');
		$('#btnScan').css('display','none');		
	}
	else if(page == 'Edit')
	{
		$('#divRemoteDir').css('display','block');
		$('#divStatus').css('display','block');
		$('#btnAction').attr('onclick','EditSM()').html('Confirm');
		$('#stroageManagerAdd').css('display','block');
		$('#btnConnect').css('display','block');
		$('#btnScan').css('display','block');
		
		if(selectedStorage != 0)
			GetStorageById();
		else{
			$('#stroageManagerAdd').css('display','none');
			$('.clsSMPage').removeClass('alert-danger');
			alert('Please select Storage');
		}
	}
	else
	{
		$('.clsSMPage').removeClass('alert-danger');
	}
}
function BindAllProtocols()
{
	var request = new Request();
	request.url ="cgi/cgi_HostManager.py"
	request.statusType="getProtocol";
	request.parameters={"requestType":'read_Protocol'};
	CallPythonService(request);
}
function BindAllHosts()
{
	var request = new Request();
	request.url ="cgi/cgi_HostManager.py"
	request.statusType="getHosts";
	request.parameters={"requestType":'read_Host',"hostId":0};
	CallPythonService(request);
}

function SaveSM()
{
	var isFormValid = $("#formStorageManager").validationEngine('validate');
	if(!isFormValid)
		return;
	var StatusId = 0;
	
	var request = new Request();
	request.url ="cgi/cgi_StorageManager.py"
	request.statusType="SaveStorage";
	request.parameters={"requestType":'create_Storage',"name":$('#txtName').val(),"protocolId":$('#ddlProtocol').val(),"hostId":$('#ddlStorageTarget').val(),"status":StatusId,"remoteDir":$('#txtRemoteDir').val()};
	CallPythonService(request);
}
function EditSM()
{
	var isFormValid = $("#formStorageManager").validationEngine('validate');
	if(!isFormValid)
		return;
	var StatusId = 0;
	
	var request = new Request();
	request.url ="cgi/cgi_StorageManager.py"
	request.statusType="editStorage";
	request.parameters={"requestType":'update_Storage',"storageId":selectedStorage,"name":$('#txtName').val(),"protocolId":$('#ddlProtocol').val(),"hostId":$('#ddlStorageTarget').val(),"status":StatusId,"remoteDir":$('#txtRemoteDir').val()};
	CallPythonService(request);
}
function GetStorageDetails()
{
	var request = new Request();
	request.url ="cgi/cgi_StorageManager.py"
	request.statusType="getAllStorage";
	request.parameters={"requestType":'read_Storage',"storageId":0};
	CallPythonService(request);
}
function GetStorageById()
{
	var request = new Request();
	request.url ="cgi/cgi_StorageManager.py"
	request.statusType="getStorage";
	request.parameters={"requestType":'read_Storage',"storageId":selectedStorage};
	CallPythonService(request);
}

function DeleteStorage()
{
	
	if(selectedStorage > 0){
		
		swal({
		  title: "Are you sure?",
		  text: "You want to delete Storage and its snapshots!",
		  type: "warning",
		  showCancelButton: true,
		  confirmButtonClass: "btn-danger",
		  confirmButtonText: "Yes, delete it!",
		  cancelButtonText: "No, cancel please!",
		  closeOnConfirm: false,
		  closeOnCancel: false
		},
		function(isConfirm) {
		  if (isConfirm) {
			var request = new Request();
			request.url ="cgi/cgi_StorageManager.py"
			request.statusType="deleteStorage";
			request.parameters={"requestType":'delete_Storage',"storageId":selectedStorage};
			CallPythonService(request);
		  } else {
			swal("Cancelled", "Your Storage is safe :)", "error");
		  }
		});
	}
	else
	{
		alert('Please select Storage for delete');
		return;
	}
	
}
function OnOffDevice(id,status)
{
	var request = new Request();
	request.url ="cgi/cgi_StorageManager.py"
	request.statusType="OnOffDevice";
	request.parameters={"requestType":'OnOff_Device',"deviceId":id,"state":status};
	CallPythonService(request);
}
function ConnectDisconnectSM()
{
	var request = new Request();
	request.url ="cgi/cgi_StorageManager.py"
	request.statusType="ConnectDisconnectSM";
	request.parameters={"requestType":'ConnectDisconnectSM_Storage',"storageId":selectedStorage};
	CallPythonService(request);
}
function scan_StorMan()
{
	var request = new Request();
	request.url ="cgi/cgi_StorageManager.py"
	request.statusType="ScanSM";
	request.parameters={"requestType":'ScanSM_Storage',"storageId":selectedStorage};
	CallPythonService(request);	
}
function ShowSMDeives(id,SMName)
{
	$('#spnTitle').html("Storage Manager: "+SMName);
	selectedDevice.id = id;
	selectedDevice.name = SMName;
	var request = new Request();
	request.url ="cgi/cgi_StorageManager.py"
	request.statusType="GetDeviceListBySMId";
	request.parameters={"requestType":'read_Devices',"storageId":id};
	CallPythonService(request);
}

$('#ddlProtocol').on('change',function(){
	selectedProtocol = $(this).val();
	BindAllHosts();
	gray_out_rules(selectedProtocol);
});

function gray_out_rules(selectedProtocol)
{
	var hostGrayedOutRules = new HostGrayedOutRules();
	if(selectedProtocol == 0)
		var rule = hostGrayedOutRules[hostGrayedOutRules.length-1]; //last item
	else
		var rule = hostGrayedOutRules[selectedProtocol-1];

	if(rule.remote_share == 0){
		$('#txtRemoteDir').attr('disabled',true);
		$('#txtRemoteDir').val('');
	}
	else
		$('#txtRemoteDir').attr('disabled',false);
}

function trimString(valueString, restrict_len)
{		
		if(valueString==null)
			valueString = "N/A";
		valueString = String(valueString);
		var len=valueString.length;
		var newValueString = valueString;
		if(len > restrict_len)
		{
			newValueString = valueString.substr(0,restrict_len-3)+'...';
		}
		return newValueString;
}

function DeviceInfo(deviceId)
{
	var request = new Request();
	request.url ="cgi/cgi_StorageManager.py"
	request.statusType="deviceInfo";
	request.parameters={"requestType":'read_DeviceInfo','deviceId':deviceId};
	CallPythonService(request);
	
	
}