#!/usr/bin/python3

import cgi
import cgitb
from globalSettings import *
import json
from db import *
import sqlite3
import subprocess
import os
from global_func import *
from collections import OrderedDict 

GUI=True
CCM=True

wErrCommandFailed=-1
if GUI==True:
    import cgi,cgitb
    cgitb.enable()
    form = cgi.FieldStorage()
    request_Type=form.getvalue('requestType')
else:
    request_Type='eject_Disk'
    
def sprint (a,b):

    if GUI==False:
        if b!=0:
            print(a,b)
        else:
            print(a)
    else:
        return
        
def CreateSystemVolume(vgName,VolName):

    VolType="F"
    dev="/dev/"+vgName+"/"+VolName
    try:
        LVM_arg1="-n"
        LVM_arg2=VolName
        LVM_arg3="-L"
        LVM_arg4='1G'
        LVM_arg5=vgName
        LVM_arg6="-y"
        try:
            #lvcreate -n system -L 1G mrp1 -y
            process1 = subprocess.check_output(["sudo","lvcreate",LVM_arg1,LVM_arg2,LVM_arg3,LVM_arg4,LVM_arg5,LVM_arg6])
            sprint(process1,0)
        except Exception as err:
            sprint("lvcreat Except ",err)

        if (VolType=="F"):
            dev="/dev/"+vgName+"/"+VolName
            sprint("device=",dev)
            LVM_arg1="-t"
            LVM_arg2="ext4"
            #mkfs.ext4 -O uninit_bg=1 -E lazy_itable_init=1
            try:
                process1 = subprocess.check_output(["sudo","mkfs",LVM_arg1,LVM_arg2,dev])
                sprint(process1,0)
            except Exception as err:
                sprint("mkfs Except ",err)
                return(wErrCommandFailed)
        return(0)

    except Exception as err:
        print("CreateSystemVolume ",err)
        return(wErrCommandFailed)


def onOff_Disk():
    print((json.JSONEncoder().encode({'status': 'fail', 'description': 'Disk Cannot be turned off'})))


def DiskInfo():
    if GUI==True:
        disk_id = form.getvalue('diskid')
    else:
        disk_id = form_getvalue('diskid')


    data_dict = OrderedDict()
    data_dict['id'] = disk_id
    
    query = "select d.vid, d.pid, d.prl, d.serial, ifnull(d.low_threshold,'n/a'), ifnull(d.temp_default,'n/a'), d.temp, ifnull(d.hi_threshold,'n/a'), d.t_max, d.state, ifnull(m.system_name,'n/a') from disks d left join multi_device m on  d.multi_device_id=m.id where d.id="+str(disk_id)    
    query = c.execute(query)
    conn.commit()
    
    for col in c:
        data_dict['VID'] = col[0]
        data_dict['PID'] = col[1]
        data_dict['PRL'] = col[2]
        data_dict['Serial'] = col[3]
        if (col[5]=="c" or col[5]=="C"):
            units="Celcius"
        elif (col[5]=="f" or col[5]=="F"):
            units="Farenheit"
        else:
            units="n/a"
        data_dict['Temperature in '] = units
        data_dict['Low Temp. Threshold'] = col[4]
        data_dict['Disk Temperature'] = col[6]
        data_dict['Hi Temp. Threshold'] = col[7]
        data_dict['Max Temp. Threshold'] = col[8]
        if col[9]==0:
            state="Good"
        if col[9]==1:
            state="Degraded"
        if col[9]==2:
            state="Critical"
        data_dict['State'] = state
        data_dict['Pool'] = col[10]
                   
    print((json.JSONEncoder().encode({'status': 'fail', 'description': "success", 'data':data_dict})))
    
def read_DiskInfo():
    disk_id = form.getvalue('diskid')
    data_dict = OrderedDict()
    data_dict['id'] = disk_id
    query = "select vid, pid, prl, serial, wwn, system_name, location from disks where id="+str(disk_id)
    c.execute(query)
    for col in c:
        data_dict['VID'] = col[0]
        data_dict['PID'] = col[1]
        data_dict['PRL'] = col[2]
        data_dict['Serial'] = col[3]
        data_dict['WWN'] = col[4]
        data_dict['System Name'] = col[5]
        data_dict['Location'] = col[6]
    print((json.JSONEncoder().encode({'status': 'fail', 'description': "success", 'data':data_dict})))


def eject_Disk():
    error=False
    c=conn.cursor()
    dbquery=c.execute("select system_name from multi_device where name='MegaRAID POOL'")
    resp=c.fetchone()
    if str(resp) != str("None"):
        vgName=resp[0]
    else:
        print((json.JSONEncoder().encode({'status': 'fail', 'description': 'No MegaRAID Volume '})))
        c.close(c)
        return(0)
        
    c.close()
    VolName='system'
    #Check we are broadcom device wwn
    mount='/mnt/system'
    try:
        isdir = os.path.isdir(mount)
        sprint("isdir",(isdir))
        if isdir==False:
            mount="/mnt/"+VolName
            try:
                arg1="-p"
                flag1='-R'
                flag2='777'
                process1 = subprocess.check_output(["sudo","mkdir",arg1,mount])
                process1 = subprocess.check_output(["chown","www-data:www-data",mount])
                process1 = subprocess.check_output(["chmod",flag1,flag2,mount])
            except Exception as err:
                sprint(("mkdir-2 Except ",err))
                error=True

    except Exception as err:
        sprint("mkdir-1 Except ",err)
        error=True

    try:
        sprint("step",2)
        dev="/dev/"+vgName+"/"+VolName
        isfile = os.path.isfile(dev)
        sprint(dev,isfile)

        if isfile!=True:
            sprint("Calling CreateSystemVolume",0)
            CreateSystemVolume(vgName,VolName)

        sprint("step",3)
        ismount = os.path.ismount(mount)
        if ismount==False:
            try:
                process1 = subprocess.check_output(["sudo","mount",dev,mount])
                sprint(process1,0)
            except Exception as err:
                sprint(("mount Except ",err))
                error=True
            try:
                arg2=mount
                process1 = subprocess.check_output(["sudo","mountpoint",arg2]) #Check if mountpoint exists
                sprint (process1,0)
            except Exception as err:
                sprint("mountpoint Except ",err)
                error=True
        sprint("step",4)
        #Copy quantumDB.db
        try:
            db=DBPath
            dst=mount+'/'+"quantumDB.db"
            process = subprocess.check_output(["sudo","cp",db,dst])
        except Exception as err:
            sprint("cp DB Except ",err)
            error=True

        if error==True:
            print((json.JSONEncoder().encode({'status': 'fail', 'description': 'No Canister or Canister removal error'})))

        else:
            if (CCM==True):
                cmd="PoolStop"
                PoolName="all"
                PoolType="MegaRAID POOL"
                cmd_Id = get_ccm_command_id()
                message="set,element=multi_device,element_name={0},args=3,action={1},SystemName={2},uuid={3}".\
                format(PoolName,cmd,PoolName,cmd_Id)
                send_ccm_msg(message) 
                response = get_ccm_response(cmd_Id)
                print (response)
            else:
                print((json.JSONEncoder().encode({'status': 'success', 'description': 'Canister Ready for removal'})))
    except Exception as err:
        print((json.JSONEncoder().encode({'status': 'fail', 'description': 'Canister NOT Ready for removal'})))
        sprint("mount Except ",err)
        return(wErrCommandFailed)

def hotSwap():
    print((json.JSONEncoder().encode({'status': 'fail', 'description': 'NO IMPLEMENTATION'})))

print("Content-type:text/html\r\n\r\n")

if request_Type == 'onOff_Disk':
    onOff_Disk()
elif request_Type == 'eject_Disk':
    eject_Disk()
elif request_Type == 'hotswap':
    hotSwap()
elif request_Type == 'diskInfo':
    DiskInfo()