#!/usr/bin/python
print "Content-type:text/html\r\n\r\n"
import cgi,cgitb
from global_func import *
cgitb.enable()
import sqlite3
import json, os
import subprocess
from db import *
from globalSettings import *
from logRoutineWO import loggerArgs, init_logger, DelHandler, ccmLogger
import ipaddress
import re
from clearTextPwd import *
import ConfigParser
#from globalTest import TEST
LogEnabled=False

CIFS=1
NFS=2
iSCSI_Chap=3
iSCSI_NoChap=4
FTP=5
FC=6
protocol_S3 = 7
iSER_Chap = 8
iSER_NoChap = 9
NFS_RDMA =10

INFO = 0
WARNING = 1
ERROR = 2
CRITICAL = 3
DEBUG = 4

infoLevel=20
errorLevel=10

TEST=False



if TEST==True:
    GUI=False
    CCM=True
else:
    GUI=True
    CCM=True

GUI=True
CCM=True

if GUI==True:
    import cgi,cgitb
    cgitb.enable()
    
if GUI==True:
    form = cgi.FieldStorage()
    request_Type=form.getvalue('requestType')
    
if (GUI==False and TEST==False):
    print '1. read_Host()'
    print '2. delete_Host()'
    print '3. create_Host()'
    print '4. update_Host()'
    print '5. read_Protocol()'
    choice=int(raw_input("select cgi function==>"))
    if (choice==1):
        request_Type='read_Host'
    elif (choice==2):
        request_Type='delete_Host'
    elif (choice==3):
        request_Type='create_Host'
    elif (choice==4):
        request_Type='update_Host'
    elif (choice==5):
        request_Type='read_Protocol'

def form_getvalue(val):

    if val=='hostType':
        print '1. Single Host'
        print '2. Group Host'
        print '3. Storage Manager'
        print '4. Download Server'
        print '5. Backup Server'
        val=int(raw_input("input hostType==>"))
        if val==1:
            hostType='Single Host'
        if val==2:
            hostType='Group Host'
        if val==3:
            hostType='Storage Manager'
        if val==4:
            hostType='Download Server'
        if val==5:
            hostType='Backup Server'
        return hostType
        
    elif val=='hostName':
        val=str(raw_input("input hostName==>"))
        return val

    elif val=='protocol':
        print '1. iSCSI'
        print '2. iSCSI CHAP'
        print '3. iSER'
        print '4. iSER Chap'
        print '5. NFS'
        print '6. CIFS'
        print '7. FTP'
        print '8. AWS'
        val=str(raw_input("input protocol==>"))
        if val==1:
            p=iSCSI_NoChap
        elif val==2:
            p=iSCSI_Chap
        elif val==3:
            p=iSER_Chap
        elif val==4:
            p=iSER_NoChap
        elif val==5:
            p=NFS
        elif val==6:
            p=CIFS
        elif val==7:
            p=FTP
        elif val==8:
            p=protocol_S3
        else:
            p=-1
        return p

    elif val=='user':
        val=str(raw_input("input User==>"))
        return val
        
    elif val=='iqn':
        val=str(raw_input("input iqn==>"))
        return val
        
    elif val=='wwn':
        val=str(raw_input("input wwn==>"))
        return val
        
    elif val=='url':
        val=str(raw_input("input url==>"))
        return val
        
    elif val=='password':
        val=str(raw_input("input password==>"))
        return val
        
    elif val=='hostId':
        query_lan=c.execute("select id,name from host ")
        resp = c.fetchall()
        print resp
        val=int(raw_input("input hostId==>"))
        return val

def CheckS3(iqn,password,url):

    return 0


def CheckNameByID(id):
    return 0

def CheckName(name):
    if len(name)>12:
        return -1
    if len(name)<1:
        return -2
    return 0
    
def CheckPW(pw):
    MAX=False
    MIN=True
    if (len(pw)<6 and MIN==True):
        return -1
    if (len(pw)>16 and MAX==True):
        return -2
    return 0
    
def CheckIP(iqn):
    try:
        ip=iqn.split("/")
    except:
        return -2
    len_ip=len(ip)
    if (len_ip==1 or len_ip==2):
        u_iqn = unicode(ip[0], "utf-8")
        #print "u_iqn=",u_iqn
        try:
            Adr=ipaddress.ip_address(u_iqn)
            ipAdr=str(Adr).split("/")
            #print "ip=",ipAdr[0]
            if str(ipAdr[0])!=str(ip[0]):
                #print "ip format incorrect"
                return -1
        except Exception as err:
            #print err
            #print "ip is not valid" 
            return -2
        if len_ip==2:
            u_iqn = unicode(iqn, "utf-8")
            try:
                net=ipaddress.ip_network(u_iqn)
                return 0
                #print "network",net
            except Exception as err:
                #print err
                #print "network is not valid"
                return -3
        else:
            return 0
    else:
        return -4
        
def check_share_name(name, protocol):
    if protocol == CIFS:
        regular_exp = "^[a-zA-Z0-9{!$ .@(~#)}&%_-]*$"  # Alpha numeric with a dash
    
    elif protocol == NFS:
        regular_exp = "^[a-z0-9-]*$"  # lower alpha numeric with a dash

    elif protocol in [iSCSI_Chap,iSCSI_NoChap]:
        regular_exp = "^[a-z0-9]*$"  # lower alpha numeric without a dash
    else:
        regular_exp = "^\b$"  # A regular expression that never matches with anything
    
    if re.search(regular_exp, name):
        return 0
    else:
        if protocol == CIFS:
            return -1
        elif protocol == NFS:
            return -2
        elif protocol in [iSCSI_Chap,iSCSI_NoChap]:
            return -3
        else:
            return 1

def execute_command(command):
    FNULL = open(os.devnull, 'w')
    proc = subprocess.Popen([command],shell=True,stdout=FNULL,stderr=subprocess.STDOUT)

def createFolderIfnotExists(path):
    if not os.path.exists(path):
        os.makedirs(path, mode=0o777)
        #execute_command('sudo mkdir -m 777 -p '+str(path))

def configparser():

    createFolderIfnotExists('/'.join(rclone_config_path.split('/')[0:-1]))
    myconfig = ConfigParser.RawConfigParser()
    return myconfig

def create_Host():
    if GUI==True:
        hostType=form.getvalue('hostType')
        hostName=form.getvalue('hostName')
        protocol=form.getvalue('protocol') 
        user=form.getvalue('user') 
        password=form.getvalue('password') 
        iqn=form.getvalue('iqn') 
        wwn	=form.getvalue('wwn')
        url	=form.getvalue('url')
    else:
        hostType=form_getvalue('hostType')
        hostName=form_getvalue('hostName')
        protocol=form_getvalue('protocol') 
        user=form_getvalue('user') 
        password=form_getvalue('password') 
        iqn=form_getvalue('iqn') 
        wwn	=form_getvalue('wwn')
        url	=form_getvalue('url')
    
    if CheckName(hostName)!=0:
        print json.JSONEncoder().encode({'status':'fail','description':'Name must be > 1 and less than 12 characters'})
        c.close()
        conn.close()
        return
        
    query_lan=c.execute("select count(*) from host where name='"+ str(hostName)+"' And protocol="+str(protocol))
    nameCount = c.fetchone()[0]
    conn.commit()

    if (int(protocol)==CIFS or int(protocol)==iSCSI_Chap or int(protocol)==iSER_Chap  or int(protocol)==FTP):
        if CheckPW(password) !=0:
            print json.JSONEncoder().encode({'status':'fail','description':'Invalid Password, must be 12-16 characters long'})
            c.close()
            conn.close()
            return
        else:
            password = pwd_encoding(password)

    if (int(protocol)==NFS or int(protocol)==iSCSI_Chap or int(protocol)==iSCSI_NoChap or int(protocol)==iSER_Chap or int(protocol)==iSER_NoChap or int(protocol)==FTP):
        res=CheckIP(iqn)
        if res!=0:
            if res==-1:
                print json.JSONEncoder().encode({'status':'fail','description':'Invalid IP address format'})
            if res==-2:
                print json.JSONEncoder().encode({'status':'fail','description':'Invalid IP address'})
            if res==-3:
                print json.JSONEncoder().encode({'status':'fail','description':'Invalid Network value'})            
            c.close()
            conn.close()
            return

    if (int(protocol)==protocol_S3):
        if CheckS3(iqn,password,url)!=0:
            print json.JSONEncoder().encode({'status':'fail','description':'Invalid S3 credentials'})
            c.close()
            conn.close()
            return
            
    if (int(protocol)==CIFS or int(protocol)==NFS or int(protocol)==iSCSI_Chap or int(protocol)==iSCSI_NoChap):
        if hostName.startswith(" ") or hostName.endswith(" "):
            print json.JSONEncoder().encode({'status':'fail','description':'space as the first or as the last character is not supported'})
            return
        res = check_share_name(hostName, int(protocol))
        if res!=0:
            if res==-1:#cifs
                print json.JSONEncoder().encode({'status':'fail','description':'CIFS shares may contain alpha, numeric, and the "-" (dash) character.'})
            elif res==-2:#nfs
                print json.JSONEncoder().encode({'status':'fail','description':'NFS shares may contain lower-case alpha, numeric, and the "-" (dash) character'})
            elif res==-3:#iSCSI_Chap and nochap
                print json.JSONEncoder().encode({'status':'fail','description':'iSCSI_Chap/iSCSI_NoChap shares may contain lower-case alpha and numeric'})
            else:
                print json.JSONEncoder().encode({'status':'fail','description':'Invalid Host Name'})
            c.close()
            conn.close()
            return

    if nameCount == 0:
        if(int(protocol)==int(protocol_S3)):
            #create rclone config
            config=configparser()
            config.read(rclone_config_path)
            flag = config.remove_section(hostName)

            with open(rclone_config_path,"w+") as f:
                    config.write(f)

            config.add_section(hostName)
            config.set(hostName, 'type', 's3')
            config.set(hostName, 'env_auth', 'false')
            config.set(hostName, 'access_key_id', user)
            # config.set(hostName, 'region', '')
            config.set(hostName, 'secret_access_key', password)
            config.set(hostName, 'endpoint', url)
            # config.set(hostName, 'location_constraint', '')
            # config.set(hostName, 'acl', '')
            # config.set(hostName, 'server_side_encryption', '')
            # config.set(hostName, 'storage_class', '')

            with open(rclone_config_path,"a+") as f:
                config.write(f)
            #link main config to www config


        query_SP=c.execute("insert into  host(name,host_type,protocol,user_name,iqn,pw,wwn,url,cr_date) values(?,?,?,?,?,?,?,?,datetime())",[hostName,hostType,protocol,user,iqn,password,wwn,url])
        conn.commit()
        dArgs=loggerArgs("host/" + "hostManager",hostName,infoLevel,"create")
        if LogEnabled==True:
            ccmLogger(logger,INFO,"successfully created host " + hostName,dArgs)
        print json.JSONEncoder().encode({'status':'success','description':'Saved successfully'})
    else:
        dArgs=loggerArgs("host/" + "hostManager",hostName,errorLevel,"create")
        if LogEnabled==True:
            ccmLogger(logger,ERROR,"Host Name Already Exists",dArgs)
        print json.JSONEncoder().encode({'status':'fail','description':'Host Name Already Exists'})

    c.close()
    conn.close()

def update_Host():
    if GUI==True:
        hostType=form.getvalue('hostType')
        hostName=form.getvalue('hostName')
        protocol=form.getvalue('protocol') 
        user=form.getvalue('user') 
        password=form.getvalue('password') 
        iqn=form.getvalue('iqn')
        wwn=form.getvalue('wwn')
        hostId = form.getvalue('hostId')
        url=form.getvalue('url')
    else:
        hostType=form_getvalue('hostType')
        hostName=form_getvalue('hostName')
        protocol=form_getvalue('protocol') 
        user=form_getvalue('user') 
        password=form_getvalue('password') 
        iqn=form_getvalue('iqn')
        wwn=form_getvalue('wwn')
        hostId = form_getvalue('hostId')
        url=form_getvalue('url')

    if CheckNameByID(hostId)!=0:
        print json.JSONEncoder().encode({'status':'fail','description':'Name must be > 1 and less than 12 characters'})
        c.close()
        conn.close()
        return

    query_lan=c.execute("select count(*) from host where name='"+ str(hostName)+"' and protocol="+str(protocol)+" and id <> "+str(hostId))
    nameCount = c.fetchone()[0]
    conn.commit()

    if CheckName(hostName)!=0:
        print json.JSONEncoder().encode({'status':'fail','description':'Name must be > 1 and less than 12 characters'})
        c.close()
        conn.close()
        return

    if (int(protocol)==CIFS or int(protocol)==iSCSI_Chap or int(protocol)==iSER_Chap  or int(protocol)==FTP):
        if CheckPW(password) !=0:
            print json.JSONEncoder().encode({'status':'fail','description':'Invalid Password, must be 12-16 characters long'})
            c.close()
            conn.close()
            return
        else:
            password = pwd_encoding(password)
        # if not is_EncodedString_base64(password):
        #     password = pwd_encoding(password)        
        # elif password.startswith("hello"):
        #     password = pwd_encoding(password)
        # elif password.isalnum():
        #     password = pwd_encoding(password)
        # else:
        #     password = password

    if (int(protocol)==NFS or int(protocol)==iSCSI_Chap or int(protocol)==iSCSI_NoChap or int(protocol)==iSER_Chap or int(protocol)==iSER_NoChap or int(protocol)==FTP):
        res=CheckIP(iqn)
        if res!=0:
            if res==-1:
                print json.JSONEncoder().encode({'status':'fail','description':'Invalid IP address format'})
            if res==-2:
                print json.JSONEncoder().encode({'status':'fail','description':'Invalid IP address'})
            if res==-3:
                print json.JSONEncoder().encode({'status':'fail','description':'Invalid Network value'})            
            c.close()
            conn.close()
            return

    if (int(protocol)==protocol_S3):
        if CheckS3(iqn,password,url)!=0:
            print json.JSONEncoder().encode({'status':'fail','description':'Invalid S3 credentials'})
            c.close()
            conn.close()
            return
    
    if (int(protocol)==CIFS or int(protocol)==NFS or int(protocol)==iSCSI_Chap or int(protocol)==iSCSI_NoChap):
        if hostName.startswith(" ") or hostName.endswith(" "):
            print json.JSONEncoder().encode({'status':'fail','description':'space as the first or as the last character is not supported'})
            return
        res = check_share_name(hostName, int(protocol))
        if res!=0:
            if res==-1:#cifs
                print json.JSONEncoder().encode({'status':'fail','description':'CIFS shares may contain alpha, numeric, and the "-" (dash) character.'})
            elif res==-2:#nfs
                print json.JSONEncoder().encode({'status':'fail','description':'NFS shares may contain lower-case alpha, numeric, and the "-" (dash) character'})
            elif res==-3:#iSCSI_Chap and nochap
                print json.JSONEncoder().encode({'status':'fail','description':'iSCSI_Chap/iSCSI_NoChap shares may contain lower-case alpha and numeric'})
            else:
                print json.JSONEncoder().encode({'status':'fail','description':'Invalid Host Name'})
            c.close()
            conn.close()
            return

    if nameCount == 0:
        if(int(protocol)==int(protocol_S3)):
            #create rclone config
            config=configparser()
            config.read(rclone_config_path)
            flag = config.remove_section(hostName)

            with open(rclone_config_path,"w+") as f:
                    config.write(f)

            config.add_section(hostName)
            config.set(hostName, 'type', 's3')
            config.set(hostName, 'env_auth', 'false')
            config.set(hostName, 'access_key_id', user)
            config.set(hostName, 'secret_access_key', password)
            config.set(hostName, 'endpoint', url)

            with open(rclone_config_path,"a+") as f:
                config.write(f)

        query_SP=c.execute("update host set name=?,host_type=?,protocol=?,user_name=?,iqn=?,pw=?,wwn=?,url=?,cr_date=datetime() where id=?",[hostName,hostType,protocol,user,iqn,password,wwn,url,hostId])
        conn.commit()
        dArgs=loggerArgs("host/" + "hostManager",hostName,infoLevel,"update")
        if LogEnabled==True:        
            ccmLogger(logger,INFO,"Updated successfully",dArgs)
        print json.JSONEncoder().encode({'status':'success','description':'Updated successfully'})
    else:
        dArgs=loggerArgs("host/" + "hostManager",hostName,errorLevel,"update")
        if LogEnabled==True:
            ccmLogger(logger,ERROR,"Host Name updated",dArgs)
        print json.JSONEncoder().encode({'status':'fail','description':'Host Name Already Exists'})

    c.close()
    conn.close()
    
def read_Host():
    if GUI==True:
        hostId = form.getvalue('hostId')
    else:
        hostId = form_getvalue('hostId')
        
    if hostId != str(0):
        dbquery="SELECT h.id,h.name,h.protocol,h.user_name,h.iqn,h.pw,h.wwn,url,p.name,h.host_type,ifnull(h.password_hidden,1) from host  h inner join protocol p on h.protocol = p.id where h.id="+str(hostId)
    else:
        dbquery="SELECT h.id,h.name,h.protocol,h.user_name,h.iqn,h.pw,h.wwn,url,p.name,h.host_type,ifnull(h.password_hidden,1) from host h inner join protocol p on h.protocol = p.id order by h.id desc"
    query = c.execute(dbquery)
    dbdata = []
    conn.commit()
    for col in c:
        pwd = col[5]
        if pwd==None:
            pass
        elif pwd.startswith("hello"):
            pwd = pwd
        else:
            pwd = readDBPwd(pwd)
        jsonschema = {"id":col[0],"name" : col[1],"protocol_id":col[2],"user_name":col[3],"iqn":col[4],"pw":pwd,"wwn":col[6],"url":col[7],"protocol_name":col[8],"host_type":col[9], "password_hidden":col[10]}
        #jsonschema = {"id":col[0],"name" : col[1],"protocol_id":col[2],"user_name":col[3],"iqn":col[4],"pw":col[5],"wwn":col[6],"url":col[7],"protocol_name":col[8],"host_type":col[9], "password_hidden":col[10]}
        dbdata.append(jsonschema)
    c.close()
    conn.close()
    print json.JSONEncoder().encode(dbdata)

def delete_Host():
    if GUI==True:
        hostId = form.getvalue('hostId')
    else:
        hostId = form_getvalue('hostId')
    config=configparser()
    host_name, host_protocol = '',0
    query_lan=c.execute("select name, protocol from host where id = "+str(hostId))
    for col in c:
        host_name = col[0]
        host_protocol = col[1]
    conn.commit()
    if(int(host_protocol)==int(protocol_S3)):
        config.read(rclone_config_path)
        flag = config.remove_section(host_name)
        with open(rclone_config_path,"w+") as f:
                config.write(f)
    
    query_lan=c.execute("select count(*) from export where host_id="+str(hostId))
    Count = c.fetchone()[0]
    conn.commit()
    if Count == 0:
        query = "Delete from Host where id in ("+str(hostId)+")"
        query_FT=c.execute(query)
        conn.commit()
        dArgs=loggerArgs("host/" + "hostManager","delete_Host",infoLevel,"delete")
        if LogEnabled==True:        
            ccmLogger(logger,INFO,"Deleted successfully",dArgs)
        print json.JSONEncoder().encode({'status':'success','description':'Deleted successfully'})
    else:
        dArgs=loggerArgs("host/" + "hostManager","delete_Host",infoLevel,"delete")
        if LogEnabled==True:        
            ccmLogger(logger,INFO,"Host has dependent Volumes, Delete failed.",dArgs)
        print json.JSONEncoder().encode({'status':'fail','description':'Host has dependent Volumes'})
    c.close()
    conn.close()

def read_Protocol():
    #not_in_query = '(' + str(FTP)+ ',' +str(FC)+','+ str(iSER_Chap)+','+ str(iSER_NoChap)+','+ str(NFS_RDMA)+ ')' #',' + str(protocol_S3)+ ')'
    not_in_query = '(' + str(FTP)+ ',' +str(FC)+','+ str(iSER_Chap)+','+ str(iSER_NoChap)+','+ str(NFS_RDMA)+ ',' + str(protocol_S3)+ ')'
    dbquery="SELECT id,name from protocol where id not in " + not_in_query
    query = c.execute(dbquery)
    dbdata = []
    conn.commit()
    for col in c:
        jsonschema = {"id":col[0],"protocolName" : col[1]}
        dbdata.append(jsonschema)
    c.close()
    conn.close()
    print json.JSONEncoder().encode(dbdata)

def update_passwordHidden():
    hostId = form.getvalue('hostId')
    password_hidden = form.getvalue('password_hidden')
    dbquery="update host set password_hidden = " + password_hidden + " where id = " + hostId
    query = c.execute(dbquery)
    conn.commit()
    c.close()
    conn.close()
    print json.JSONEncoder().encode({'status':'success','description':'Password Hidden - updated successfully'})
if TEST==True:
    logger=init_logger("cgi")
if request_Type == 'read_Host':
    read_Host()
elif request_Type == 'delete_Host':
    delete_Host()
elif request_Type == 'create_Host':
    create_Host()
elif request_Type == 'update_Host':
    update_Host()
elif request_Type == 'read_Protocol':
    read_Protocol()
elif request_Type == 'update_passwordHidden':
    update_passwordHidden()
if TEST==True:
    DelHandler(logger[0])
    DelHandler(logger[1])

