#!/usr/bin/python

import cgi, cgitb
from global_func import *

cgitb.enable()
import sqlite3
import json
from db import *
from logRoutine import *
initLogging()

form = cgi.FieldStorage()
request_Type = form.getvalue('RequestType')
cmd_Id = get_ccm_command_id()

CCM = False
def create_KMIPServices():

    userName = form.getvalue('userName')
    password = form.getvalue('password')
    host = form.getvalue('host')
    portNumber = form.getvalue('portNumber')

    if host !="" and portNumber!="" and userName!="" and password!="":
        if CCM:
            cmd = "SaveKMIP"
            message = "set,element=services,element_name={0},args=7,Action={1},userName={2}," \
                    "pwd={3},host={4},port={5},uuid={6}" \
                .format(sender, cmd, userName, password, host, portNumber, cmd_Id)
            send_ccm_msg(message)
            response = get_ccm_response(cmd_Id)
            dArgs=loggerArgs("kmipServer/" + "KMIP_serviceManager",userName,infoLevel,"create")
            ccmLogger(info,response["description"],dArgs)
            print response
            delete_ccm_response(cmd_Id)
        else:
            query_lan = c.execute("delete from kmipServer")
            conn.commit()
            query_lan = c.execute(
                "insert into kmipServer (userName,pwd,host,port) values(?,?,?,?)",
                [userName, password, host, portNumber])
            conn.commit()
            dArgs=loggerArgs("kmipServer/" + "KMIP_serviceManager",userName,infoLevel,"create")
            ccmLogger(info,"Saved successfully " + userName,dArgs)
            print json.JSONEncoder().encode({"status": "success", "description": "Saved successfully"})
    else:
        dArgs=loggerArgs("kmipServer/" + "KMIP_serviceManager",userName,errorLevel,"create")
        ccmLogger(error,"Fill All mandatory fields",dArgs)
        print json.JSONEncoder().encode({"status": "fail", "description": "Fill All mandatory fields"})

    c.close()
    conn.close()

def read_KMIPServices():
    id, userName, password, host, port = '', '', '', '', ''
    dbquery = "SELECT id,userName,pwd,host,port from kmipServer"
    query = c.execute(dbquery)
    dbdata = []
    conn.commit()
    for col in c:
        id, userName, password, host, port = col[0], col[1], col[2], col[3], col[4]
    jsonschema = {"id": id, "userName": userName, "password": password, "host": host,
                    "port": port}
    dbdata.append(jsonschema)
    conn.close()
    print json.JSONEncoder().encode(dbdata)


print ("Content-type:text/html\r\n\r\n")
if request_Type == 'create_KMIPServices':
    create_KMIPServices()
elif request_Type == 'read_KMIPServices':
    read_KMIPServices()
else:
    print Json.JSONEncoder().encode({"test"})
