#!/usr/bin/python
from cgi_Global_myserver_totResources import *
import cgi,cgitb
import sqlite3
import ftplib
import os
import json
import datetime
from db import *
from globalSettings import *
from cgi_common_methods import *
cgitb.enable()

form = cgi.FieldStorage()
if form.getvalue('backupName'):
	backupName = form.getvalue('backupName')
else:
	backupName = "Not Entered"
	
if form.getvalue('backupServer'):
	backupServer = form.getvalue('backupServer')
else:
	backupServer = "Not Entered"
VMId = form.getvalue('VMId')
status=False;
filePath = ""

FtpServer=''#'oppermanns.com'
ServerUser = FTPServerUser
ServerPwd = FTPServerPwd
sourcePath=''	
SourceFilename=''	
remote_path=RemoteFTPPath
DestinationFilename=""
BackupServerId=0

#Logic for getting App info for createing Snapshot -- start

date=datetime.date.today().strftime("%Y-%m-%d")
res_group=[]
res_image=[]
veth_id_list=[]
vm_id_list=[]
vm_network_name_list=[]

available_storage=sys_storage()
available_vcpu=sys_vcpu()
available_memory=sys_memory()

query_fetch_vmid=c.execute("select vm_image_id,num_cores,memory_GB,vm_disk_size,id from virtualmachine where id=?",[VMId])
for col in c:		
	image_id = col[0]
	vcpu=col[1]
	memory = col[2]
	disk_size = col[3]
	parent_VM_id=col[4]
conn.commit()

server_name=backupName

query_fetch_ntwNames=c.execute("select network.name from vm_network inner join veth_port on vm_network.id=veth_port.id inner join network on network.id=veth_port.network_id where vm_network.vm_id=?",[parent_VM_id] )
for nwnames in c:
	nw_name=nwnames[0]
	vm_network_name_list.append(nw_name)		
conn.commit()

#Logic for getting App info for createing Snapshot -- End


query_lan=c.execute("Select ip_address,account_name,password,id from backup where destination_name=?",[backupServer])
for col in c:		
	FtpServer=col[0]
	ServerUser=col[1]
	ServerPwd=col[2]
	BackupServerId=col[3]	
conn.commit()

query_lan=c.execute("Select name,saved_path,vm_image.image_type from virtualmachine inner join vm_image on virtualmachine.vm_image_id==vm_image.id where virtualmachine.id=?",[VMId])
for col in c:		
	vmName=col[0]
	sourcePath=col[1]
	SourceFilename=(col[0].replace(" ", "_"))+'.'+col[2]
	DestinationFilename = (backupName.replace(" ", "_"))+'.'+col[2]
	filePath = sourcePath+"/"+SourceFilename
	
conn.commit()
#print sourcePath+SourceFilename
	

def BackupVMServer():	
	ftp_connection = ftplib.FTP(FtpServer, ServerUser, ServerPwd)
	remote_path = RemoteFTPPath
	#ftp_connection.mkd("Sanuyi")
	#print remote_path
	ftp_connection.cwd(remote_path)
	
	fh = open(sourcePath+"/"+SourceFilename, 'rb')
	ftp_connection.storbinary('STOR '+DestinationFilename, fh)
	fh.close()
	InsertBackupHistory()
	#print status


def InsertBackupHistory():
	query_update=c.execute("insert into myBackups (BackupServerId,VMId,download_Path,backup_time,BackupName,cr_date,edit_date,vm_group_id,vm_image_size) values(?,?,?,date(),?,date(),date(),16,?)",(BackupServerId,VMId,remote_path+DestinationFilename,backupName,GetfilesizeByPath(filePath))) 
	
	query_lan1=c.execute("update virtualmachine set last_remote_backup=Date() where id=?",[parent_VM_id])
	conn.commit()
	#c.close()
	#conn.close()
	print(json.JSONEncoder().encode({'status':'success','data':'Backup in progress'}))

	
print "Content-type:text/html\r\n\r\n"


query_lan=c.execute("select count(*) from myBackups where BackupName=?",[backupName])
nameCount = c.fetchone()[0]
conn.commit()


if nameCount == 0:	
	BackupVMServer()
else:
	print(json.JSONEncoder().encode({'status':'fail','data':'Backup name already exists'}))



