import json
from globalSettings import *

privatier = {"dataTables":[					
					{"key":"default","config":{"paging": True,"ordering": True,"searching":True,"lengthMenu": [[10, 25, 50, -1], [10, 25, 50, "All"]]}},
					#Schedule page
					{"key":"schedule","config":{"paging": True,"ordering": True,"searching":False,"lengthMenu": [[5, 25, 50, -1], [5, 25, 50, "All"]]}},
					{"key":"scheduleInfo","config":{"paging": True,"ordering": False,"searching":True,"lengthMenu": [[5, 25, 50, -1], [5, 25, 50, "All"]]}},
					{"key":"scheduleAppDownloads","config":{"paging": True,"ordering": False,"searching":True,"lengthMenu": [[5, 25, 50, -1], [5, 25, 50, "All"]]}},
					
					#setup page
					{"key":"setUpHardware","config":{"paging": True,"ordering": False,"searching":True,"lengthMenu": [[5, 25, 50, -1], [5, 25, 50, "All"]]}},
					{"key":"setUpPortGroups","config":{"paging": True,"ordering": False,"searching":True,"lengthMenu": [[5, 25, 50, -1], [5, 25, 50, "All"]]}},
					{"key":"setUpNetwork","config":{"paging": True,"ordering": False,"searching":True,"lengthMenu": [[5, 25, 50, -1], [5, 25, 50, "All"]]}},
					{"key":"setUpStoragePools","config":{"paging": True,"ordering": True,"searching":True,"lengthMenu": [[5, 25, 50, -1], [5, 25, 50, "All"]]}},
					{"key":"setUpOrgGroup","config":{"paging": True,"ordering": False,"searching":True,"lengthMenu": [[5, 25, 50, -1], [5, 25, 50, "All"]]}},
					{"key":"setUpOrgRole","config":{"paging": True,"ordering": False,"searching":True,"lengthMenu": [[5, 25, 50, -1], [5, 25, 50, "All"]]}},
					{"key":"setUpOrgUsers","config":{"paging": True,"ordering": False,"searching":True,"lengthMenu": [[5, 25, 50, -1], [5, 25, 50, "All"]]}},
					{"key":"setUpBackupServices","config":{"paging": False,"ordering": False,"searching":True,"lengthMenu": [[5, 25, 50, -1], [5, 25, 50, "All"]]}},
					
					{"key":"hostServer","config":{"paging": True,"ordering": False,"searching":True,"lengthMenu": [[5, 25, 50, -1], [5, 25, 50, "All"]]}},
					{"key":"volumeManager","config":{"paging": True,"ordering": False,"searching":False,"lengthMenu": [[5, 25, 50, -1], [5, 25, 50, "All"]]}},
					
					#Status page
					{"key":"fans","config":{"paging": True,"ordering": False,"searching":True,"lengthMenu": [[5, 25, 50, -1], [5, 25, 50, "All"]]}},
					{"key":"cpu","config":{"paging": True,"ordering": False,"searching":True,"lengthMenu": [[5, 25, 50, -1], [5, 25, 50, "All"]]}},
					{"key":"network","config":{"paging": True,"ordering": False,"searching":True,"lengthMenu": [[5, 25, 50, -1], [5, 25, 50, "All"]]}},
					{"key":"psu","config":{"paging": False,"ordering": False,"searching":False,"lengthMenu": [[5, 25, 50, -1], [5, 25, 50, "All"]]}},
					{"key":"psu1","config":{"paging": False,"ordering": False,"searching":False,"lengthMenu": [[5, 25, 50, -1], [5, 25, 50, "All"]]}},
					{"key":"psu2","config":{"paging": False,"ordering": False,"searching":False,"lengthMenu": [[5, 25, 50, -1], [5, 25, 50, "All"]]}},
					{"key":"disks","config":{"paging": True,"ordering": False,"searching":True,"lengthMenu": [[25, 50, -1], [25, 50, "All"]]}},
					{"key":"HDD","config":{"paging": False,"ordering": False,"searching":True,"lengthMenu": [[5, 25, 50, -1], [5, 25, 50, "All"]]}},
					{"key":"SSD","config":{"paging": True,"ordering": False,"searching":True,"lengthMenu": [[5, 25, 50, -1], [5, 25, 50, "All"]]}},
					{"key":"StoragePools","config":{"paging": True,"ordering": False,"searching":False,"lengthMenu": [[5, 25, 50, -1], [5, 25, 50, "All"]]}},
					
					#my servers
					{"key":"AppsList","config":{"paging": True,"ordering": False,"searching":True,"lengthMenu": [[5, 25, 50, -1], [5, 25, 50, "All"]]}},
					
					],
					
				"menuIcons" : [
					{"key":'HostServer',"value":False,"id":'menuHostServer'},
					{"key":'VolumeManager',"value":False,"id":'menuVolumeManager'},
					{"key":'MyServers',"value":True,"id":'menuMyServer'},
					{"key":'Market',"value":True,"id":'menuMarket'},
					{"key":'StatusVmStatusIcon',"value":True,"id":'vmStatusIcon'},
					{"key":'StatusVolManagerIcon',"value":True,"id":'VolManagerIcon'},
					{"key":'StatusHostSreverIcon',"value":True,"id":'HostServerIcon'},
					{"key":'StatusAppChart',"value":True,"id":'divAppsChart'},
					{"key":'marketGroupChart',"value":True,"id":'iframeMarket'},
					{"key":'ScheduleListimgDownload',"value":True,"id":'divImgDownloads'},
					{"key":'scheduleActionsApp',"value":True,"id":'','class':'clsAppSchedueActions'},
					{"key":'scheduleActionsVolume',"value":True,"id":'','class':'clsVolumeSchedueActions'}]	
				}

echostreams = {"dataTables":[					
					{"key":"default","config":{"paging": True,"ordering": True,"searching":True,"lengthMenu": [[10, 25, 50, -1], [10, 25, 50, "All"]]}},
					#Schedule page
					{"key":"schedule","config":{"paging": True,"ordering": True,"searching":True,"lengthMenu": [[10, 25, 50, -1], [10, 25, 50, "All"]]}},
					{"key":"scheduleInfo","config":{"paging": True,"ordering": False,"searching":True,"lengthMenu": [[5, 25, 50, -1], [5, 25, 50, "All"]]}},
					{"key":"scheduleAppDownloads","config":{"paging": False,"ordering": False,"searching":True,"lengthMenu": [[5, 25, 50, -1], [5, 25, 50, "All"]]}},
					
					#setup page
					{"key":"setUpHardware","config":{"paging": True,"ordering": False,"searching":True,"lengthMenu": [[5, 25, 50, -1], [5, 25, 50, "All"]]}},
					{"key":"setUpPortGroups","config":{"paging": True,"ordering": False,"searching":True,"lengthMenu": [[5, 25, 50, -1], [5, 25, 50, "All"]]}},
					{"key":"setUpNetwork","config":{"paging": True,"ordering": False,"searching":True,"lengthMenu": [[5, 25, 50, -1], [5, 25, 50, "All"]]}},
					{"key":"setUpStoragePools","config":{"paging": True,"ordering": True,"searching":True,"lengthMenu": [[5, 25, 50, -1], [5, 25, 50, "All"]]}},
					{"key":"setUpOrgGroup","config":{"paging": True,"ordering": False,"searching":True,"lengthMenu": [[5, 25, 50, -1], [5, 25, 50, "All"]]}},
					{"key":"setUpOrgRole","config":{"paging": True,"ordering": False,"searching":True,"lengthMenu": [[5, 25, 50, -1], [5, 25, 50, "All"]]}},
					{"key":"setUpOrgUsers","config":{"paging": True,"ordering": False,"searching":True,"lengthMenu": [[5, 25, 50, -1], [5, 25, 50, "All"]]}},
					{"key":"setUpBackupServices","config":{"paging": False,"ordering": False,"searching":True,"lengthMenu": [[5, 25, 50, -1], [5, 25, 50, "All"]]}},
					
					{"key":"hostServer","config":{"paging": True,"ordering": False,"searching":True,"lengthMenu": [[5, 25, 50, -1], [5, 25, 50, "All"]]}},
					{"key":"volumeManager","config":{"paging": True,"ordering": False,"searching":False,"lengthMenu": [[5, 25, 50, -1], [5, 25, 50, "All"]]}},
					
					#Status page
					{"key":"fans","config":{"paging": True,"ordering": False,"searching":True,"lengthMenu": [[5, 25, 50, -1], [5, 25, 50, "All"]]}},
					{"key":"cpu","config":{"paging": True,"ordering": False,"searching":True,"lengthMenu": [[5, 25, 50, -1], [5, 25, 50, "All"]]}},
					{"key":"network","config":{"paging": True,"ordering": False,"searching":True,"lengthMenu": [[5, 25, 50, -1], [5, 25, 50, "All"]]}},
					{"key":"psu","config":{"paging": False,"ordering": False,"searching":False,"lengthMenu": [[5, 25, 50, -1], [5, 25, 50, "All"]]}},
					{"key":"psu1","config":{"paging": True,"ordering": False,"searching":True,"lengthMenu": [[5, 25, 50, -1], [5, 25, 50, "All"]]}},
					{"key":"psu2","config":{"paging": True,"ordering": False,"searching":True,"lengthMenu": [[5, 25, 50, -1], [5, 25, 50, "All"]]}},
					{"key":"disks","config":{"paging": True,"ordering": False,"searching":True,"lengthMenu": [[5, 25, 50, -1], [5, 25, 50, "All"]]}},
					{"key":"HDD","config":{"paging": False,"ordering": False,"searching":True,"lengthMenu": [[5, 25, 50, -1], [5, 25, 50, "All"]]}},
					{"key":"SSD","config":{"paging": True,"ordering": False,"searching":True,"lengthMenu": [[5, 25, 50, -1], [5, 25, 50, "All"]]}},
					{"key":"StoragePools","config":{"paging": True,"ordering": False,"searching":False,"lengthMenu": [[5, 25, 50, -1], [5, 25, 50, "All"]]}},
					
					#my servers
					{"key":"AppsList","config":{"paging": True,"ordering": False,"searching":False,"lengthMenu": [[5, 25, 50, -1], [5, 25, 50, "All"]]}},
					
					],
					
				"menuIcons" : [
					{"key":'HostServer',"value":True,"id":'menuHostServer'},
					{"key":'VolumeManager',"value":True,"id":'menuVolumeManager'},
					{"key":'MyServers',"value":False,"id":'menuMyServer'},
					{"key":'Market',"value":False,"id":'menuMarket'},
					{"key":'StatusVmStatusIcon',"value":False,"id":'vmStatusIcon'},
					{"key":'StatusVolManagerIcon',"value":False,"id":'VolManagerIcon'},
					{"key":'StatusHostSreverIcon',"value":False,"id":'HostServerIcon'},
					{"key":'StatusAppChart',"value":False,"id":'divAppsChart'},
					{"key":'marketGroupChart',"value":True,"id":'iframeMarket'},
					{"key":'ScheduleListimgDownload',"value":True,"id":'divImgDownloads'},
					{"key":'scheduleActionsApp',"value":True,"id":'','class':'clsAppSchedueActions'},
					{"key":'scheduleActionsVolume',"value":False,"id":'','class':'clsVolumeSchedueActions'}]	
				};

quantum = {"dataTables":[					
					{"key":"default","config":{"paging": True,"ordering": True,"searching":True,"lengthMenu": [[10, 25, 50, -1], [10, 25, 50, "All"]]}},
					#Schedule page
					{"key":"schedule","config":{"paging": True,"ordering": True,"searching":True,"lengthMenu": [[10, 25, 50, -1], [10, 25, 50, "All"]]}},
					{"key":"scheduleInfo","config":{"paging": True,"ordering": False,"searching":True,"lengthMenu": [[5, 25, 50, -1], [5, 25, 50, "All"]]}},
					{"key":"scheduleAppDownloads","config":{"paging": True,"ordering": False,"searching":True,"lengthMenu": [[5, 25, 50, -1], [5, 25, 50, "All"]]}},
					
					#setup page
					{"key":"setUpHardware","config":{"paging": True,"ordering": False,"searching":True,"lengthMenu": [[5, 25, 50, -1], [5, 25, 50, "All"]]}},
					{"key":"setUpPortGroups","config":{"paging": True,"ordering": False,"searching":True,"lengthMenu": [[5, 25, 50, -1], [5, 25, 50, "All"]]}},
					{"key":"setUpNetwork","config":{"paging": True,"ordering": False,"searching":True,"lengthMenu": [[5, 25, 50, -1], [5, 25, 50, "All"]]}},
					{"key":"setUpStoragePools","config":{"paging": True,"ordering": True,"searching":True,"lengthMenu": [[5, 25, 50, -1], [5, 25, 50, "All"]]}},
					{"key":"setUpOrgGroup","config":{"paging": True,"ordering": False,"searching":True,"lengthMenu": [[5, 25, 50, -1], [5, 25, 50, "All"]]}},
					{"key":"setUpOrgRole","config":{"paging": True,"ordering": False,"searching":True,"lengthMenu": [[5, 25, 50, -1], [5, 25, 50, "All"]]}},
					{"key":"setUpOrgUsers","config":{"paging": True,"ordering": False,"searching":True,"lengthMenu": [[5, 25, 50, -1], [5, 25, 50, "All"]]}},
					{"key":"setUpBackupServices","config":{"paging": False,"ordering": False,"searching":True,"lengthMenu": [[5, 25, 50, -1], [5, 25, 50, "All"]]}},
					
					{"key":"hostServer","config":{"paging": True,"ordering": False,"searching":True,"lengthMenu": [[5, 25, 50, -1], [5, 25, 50, "All"]]}},
					{"key":"volumeManager","config":{"paging": True,"ordering": False,"searching":False,"lengthMenu": [[5, 25, 50, -1], [5, 25, 50, "All"]]}},
					
					#Status page
					{"key":"fans","config":{"paging": True,"ordering": False,"searching":True,"lengthMenu": [[5, 25, 50, -1], [5, 25, 50, "All"]]}},
					{"key":"cpu","config":{"paging": True,"ordering": False,"searching":True,"lengthMenu": [[5, 25, 50, -1], [5, 25, 50, "All"]]}},
					{"key":"network","config":{"paging": True,"ordering": False,"searching":True,"lengthMenu": [[5, 25, 50, -1], [5, 25, 50, "All"]]}},
					{"key":"psu","config":{"paging": False,"ordering": False,"searching":False,"lengthMenu": [[5, 25, 50, -1], [5, 25, 50, "All"]]}},
					{"key":"psu1","config":{"paging": True,"ordering": False,"searching":True,"lengthMenu": [[5, 25, 50, -1], [5, 25, 50, "All"]]}},
					{"key":"psu2","config":{"paging": True,"ordering": False,"searching":True,"lengthMenu": [[5, 25, 50, -1], [5, 25, 50, "All"]]}},
					{"key":"disks","config":{"paging": True,"ordering": False,"searching":True,"lengthMenu": [[5, 25, 50, -1], [5, 25, 50, "All"]]}},
					{"key":"HDD","config":{"paging": False,"ordering": False,"searching":True,"lengthMenu": [[5, 25, 50, -1], [5, 25, 50, "All"]]}},
					{"key":"SSD","config":{"paging": True,"ordering": False,"searching":True,"lengthMenu": [[5, 25, 50, -1], [5, 25, 50, "All"]]}},
					{"key":"StoragePools","config":{"paging": True,"ordering": False,"searching":False,"lengthMenu": [[5, 25, 50, -1], [5, 25, 50, "All"]]}},
					
					#my servers
					{"key":"AppsList","config":{"paging": True,"ordering": False,"searching":False,"lengthMenu": [[5, 25, 50, -1], [5, 25, 50, "All"]]}},
					
					],
					
				"menuIcons" : [
					{"key":'HostServer',"value":True,"id":'menuHostServer'},
					{"key":'VolumeManager',"value":True,"id":'menuVolumeManager'},
					{"key":'MyServers',"value":False,"id":'menuMyServer'},
					{"key":'Market',"value":False,"id":'menuMarket'},
					{"key":'StatusVmStatusIcon',"value":False,"id":'vmStatusIcon'},
					{"key":'StatusVolManagerIcon',"value":False,"id":'VolManagerIcon'},
					{"key":'StatusHostSreverIcon',"value":False,"id":'HostServerIcon'},
					{"key":'StatusFastierIcon',"value":False,"id":'fastierIcon'},
					{"key":'StatusAppChart',"value":False,"id":'divAppsChart'},
					{"key":'marketGroupChart',"value":True,"id":'iframeMarket'},
					{"key":'ScheduleListimgDownload',"value":False,"id":'divImgDownloads'},
					{"key":'scheduleActionsApp',"value":True,"id":'','class':'clsAppSchedueActions'},
					{"key":'scheduleActionsVolume',"value":False,"id":'','class':'clsVolumeSchedueActions'}]	
				};

clients = {"privatier":privatier,"echostreams":echostreams,"quantum":quantum}

def GetClientConfig(TenantName):
	return clients[TenantName]
	
def CheckPageAccess(RolePermission,pagePath):
	accessPermissions = clients[ClientName]
	#logic for validate user has permission to accesss requested page
	return {"status":"NoAccess"}
	
#print GetClientConfig("privatier")
