import cgi,cgitb
import sqlite3
import ftplib
import os
import json
import zipfile
import sys
import docker
import subprocess
from globalSettings import *

#print "Content-type:text/html\r\n\r\n"


def buildFunction(FtpServer, ServerUser, ServerPwd, destination,DowloadedFileName, SourceFilename, source, extension, image_id,image_name,vm_group_id):
    ftp =ftplib.FTP(FtpServer)
    ftp.login(ServerUser,ServerPwd)
    isPathExists=source.replace(source[:1], '') in ftp.nlst()
    if isPathExists:
        ftp.cwd(source)
        isFileExists = SourceFilename in ftp.nlst()
        if isFileExists:
            filedata = open(os.path.join(destination,DowloadedFileName),'wb')
            ftp.retrbinary('RETR '+SourceFilename,filedata.write)

        filedata.close()
        ftp.quit()

        if str(extension)=="zip":
            path_to_zip_file = str(os.path.join(destination,DowloadedFileName))
            #print("zipfile : " + path_to_zip_file)
            directory_to_extract_to = str(destination)
            with zipfile.ZipFile(os.path.join(destination,DowloadedFileName), 'r') as zip_ref:
                    zip_ref.extractall(directory_to_extract_to)
            os.remove(path_to_zip_file)

    #if(str(vm_group_id)=='18'):
    if(str(image_id)=='62'):
        filenames = SourceFilename.split('.')   #Only when folder inside the zip has the same name as zip
        command = "sudo docker build -t " + str(image_name) + " " + str(destination) + "/" + str(filenames[0]) + "/"
        with open(os.devnull, 'w') as f:	
            subprocess.call([command],shell=True, stdout =f)


def runFunction(port,image_id,image_name,vm_group_id,group_name,server_name):

    db_filename= DBPath #"/var/www/sanuyi_ii/gui/sanuyiDB.db"


    conn=sqlite3.connect(db_filename)
    conn.text_factory=str
    c=conn.cursor()

    containerID=''
    
    #if(str(vm_group_id)=='18'):
    if(str(image_id)=='62'):
        destination = os.path.join(AppServersPath,str(group_name))
        if not os.path.exists(destination):
            os.makedirs(destination,0777)
        destination = os.path.join(destination,str(server_name))
        if not os.path.exists(destination):
            os.makedirs(destination,0777)
    
        RunCommand = "sudo docker create -p "+str(port)+":80 --name "+str(server_name)+" "+str(image_name)
        txtFilePath = os.path.join(destination,"ContainerID.txt")
        with open(txtFilePath,'w') as f2:
            subprocess.call([RunCommand],shell=True, stdout =f2)

        with open(txtFilePath, 'r') as f3:
            containerID = f3.readline()
            break

    return containerID
        
def launchFunction(server_name,image_id,vm_group_id):        
    #if(str(vm_group_id)=='18'):
    if(str(image_id)=='62'):
        command = "sudo docker start " + str(server_name)
        with open(os.devnull, 'w') as f:	
            subprocess.Popen([command],shell=True, stdout =f)




    
