document.getElementById("rehomeVal").disabled = true;
var timezones = ['Africa/Abidjan', 'Africa/Accra', 'Africa/Addis_Ababa', 'Africa/Algiers', 'Africa/Asmara', 'Africa/Bamako', 'Africa/Bangui', 'Africa/Banjul', 'Africa/Bissau', 'Africa/Blantyre', 'Africa/Brazzaville', 'Africa/Bujumbura', 'Africa/Cairo', 'Africa/Casablanca', 'Africa/Ceuta', 'Africa/Conakry', 'Africa/Dakar', 'Africa/Dar_es_Salaam', 'Africa/Djibouti', 'Africa/Douala', 'Africa/El_Aaiun', 'Africa/Freetown', 'Africa/Gaborone', 'Africa/Harare', 'Africa/Johannesburg', 'Africa/Juba', 'Africa/Kampala', 'Africa/Khartoum', 'Africa/Kigali', 'Africa/Kinshasa', 'Africa/Lagos', 'Africa/Libreville', 'Africa/Lome', 'Africa/Luanda', 'Africa/Lubumbashi', 'Africa/Lusaka', 'Africa/Malabo', 'Africa/Maputo', 'Africa/Maseru', 'Africa/Mbabane', 'Africa/Mogadishu', 'Africa/Monrovia', 'Africa/Nairobi', 'Africa/Ndjamena', 'Africa/Niamey', 'Africa/Nouakchott', 'Africa/Ouagadougou', 'Africa/Porto-Novo', 'Africa/Sao_Tome', 'Africa/Tripoli', 'Africa/Tunis', 'Africa/Windhoek', 'America/Adak', 'America/Anchorage', 'America/Anguilla', 'America/Antigua', 'America/Araguaina', 'America/Argentina/Buenos_Aires', 'America/Argentina/Catamarca', 'America/Argentina/Cordoba', 'America/Argentina/Jujuy', 'America/Argentina/La_Rioja', 'America/Argentina/Mendoza', 'America/Argentina/Rio_Gallegos', 'America/Argentina/Salta', 'America/Argentina/San_Juan', 'America/Argentina/San_Luis', 'America/Argentina/Tucuman', 'America/Argentina/Ushuaia', 'America/Aruba', 'America/Asuncion', 'America/Atikokan', 'America/Bahia', 'America/Bahia_Banderas', 'America/Barbados', 'America/Belem', 'America/Belize', 'America/Blanc-Sablon', 'America/Boa_Vista', 'America/Bogota', 'America/Boise', 'America/Cambridge_Bay', 'America/Campo_Grande', 'America/Cancun', 'America/Caracas', 'America/Cayenne', 'America/Cayman', 'America/Chicago', 'America/Chihuahua', 'America/Costa_Rica', 'America/Creston', 'America/Cuiaba', 'America/Curacao', 'America/Danmarkshavn', 'America/Dawson', 'America/Dawson_Creek', 'America/Denver', 'America/Detroit', 'America/Dominica', 'America/Edmonton', 'America/Eirunepe', 'America/El_Salvador', 'America/Fort_Nelson', 'America/Fortaleza', 'America/Glace_Bay', 'America/Goose_Bay', 'America/Grand_Turk', 'America/Grenada', 'America/Guadeloupe', 'America/Guatemala', 'America/Guayaquil', 'America/Guyana', 'America/Halifax', 'America/Havana', 'America/Hermosillo', 'America/Indiana/Indianapolis', 'America/Indiana/Knox', 'America/Indiana/Marengo', 'America/Indiana/Petersburg', 'America/Indiana/Tell_City', 'America/Indiana/Vevay', 'America/Indiana/Vincennes', 'America/Indiana/Winamac', 'America/Inuvik', 'America/Iqaluit', 'America/Jamaica', 'America/Juneau', 'America/Kentucky/Louisville', 'America/Kentucky/Monticello', 'America/Kralendijk', 'America/La_Paz', 'America/Lima', 'America/Los_Angeles', 'America/Lower_Princes', 'America/Maceio', 'America/Managua', 'America/Manaus', 'America/Marigot', 'America/Martinique', 'America/Matamoros', 'America/Mazatlan', 'America/Menominee', 'America/Merida', 'America/Metlakatla', 'America/Mexico_City', 'America/Miquelon', 'America/Moncton', 'America/Monterrey', 'America/Montevideo', 'America/Montserrat', 'America/Nassau', 'America/New_York', 'America/Nipigon', 'America/Nome', 'America/Noronha', 'America/North_Dakota/Beulah', 'America/North_Dakota/Center', 'America/North_Dakota/New_Salem', 'America/Nuuk', 'America/Ojinaga', 'America/Panama', 'America/Pangnirtung', 'America/Paramaribo', 'America/Phoenix', 'America/Port-au-Prince', 'America/Port_of_Spain', 'America/Porto_Velho', 'America/Puerto_Rico', 'America/Punta_Arenas', 'America/Rainy_River', 'America/Rankin_Inlet', 'America/Recife', 'America/Regina', 'America/Resolute', 'America/Rio_Branco', 'America/Santarem', 'America/Santiago', 'America/Santo_Domingo', 'America/Sao_Paulo', 'America/Scoresbysund', 'America/Sitka', 'America/St_Barthelemy', 'America/St_Johns', 'America/St_Kitts', 'America/St_Lucia', 'America/St_Thomas', 'America/St_Vincent', 'America/Swift_Current', 'America/Tegucigalpa', 'America/Thule', 'America/Thunder_Bay', 'America/Tijuana', 'America/Toronto', 'America/Tortola', 'America/Vancouver', 'America/Whitehorse', 'America/Winnipeg', 'America/Yakutat', 'America/Yellowknife', 'Antarctica/Casey', 'Antarctica/Davis', 'Antarctica/DumontDUrville', 'Antarctica/Macquarie', 'Antarctica/Mawson', 'Antarctica/McMurdo', 'Antarctica/Palmer', 'Antarctica/Rothera', 'Antarctica/Syowa', 'Antarctica/Troll', 'Antarctica/Vostok', 'Arctic/Longyearbyen', 'Asia/Aden', 'Asia/Almaty', 'Asia/Amman', 'Asia/Anadyr', 'Asia/Aqtau', 'Asia/Aqtobe', 'Asia/Ashgabat', 'Asia/Atyrau', 'Asia/Baghdad', 'Asia/Bahrain', 'Asia/Baku', 'Asia/Bangkok', 'Asia/Barnaul', 'Asia/Beirut', 'Asia/Bishkek', 'Asia/Brunei', 'Asia/Chita', 'Asia/Choibalsan', 'Asia/Colombo', 'Asia/Damascus', 'Asia/Dhaka', 'Asia/Dili', 'Asia/Dubai', 'Asia/Dushanbe', 'Asia/Famagusta', 'Asia/Gaza', 'Asia/Hebron', 'Asia/Ho_Chi_Minh', 'Asia/Hong_Kong', 'Asia/Hovd', 'Asia/Irkutsk', 'Asia/Jakarta', 'Asia/Jayapura', 'Asia/Jerusalem', 'Asia/Kabul', 'Asia/Kamchatka', 'Asia/Karachi', 'Asia/Kathmandu', 'Asia/Khandyga', 'Asia/Kolkata', 'Asia/Krasnoyarsk', 'Asia/Kuala_Lumpur', 'Asia/Kuching', 'Asia/Kuwait', 'Asia/Macau', 'Asia/Magadan', 'Asia/Makassar', 'Asia/Manila', 'Asia/Muscat', 'Asia/Nicosia', 'Asia/Novokuznetsk', 'Asia/Novosibirsk', 'Asia/Omsk', 'Asia/Oral', 'Asia/Phnom_Penh', 'Asia/Pontianak', 'Asia/Pyongyang', 'Asia/Qatar', 'Asia/Qostanay', 'Asia/Qyzylorda', 'Asia/Riyadh', 'Asia/Sakhalin', 'Asia/Samarkand', 'Asia/Seoul', 'Asia/Shanghai', 'Asia/Singapore', 'Asia/Srednekolymsk', 'Asia/Taipei', 'Asia/Tashkent', 'Asia/Tbilisi', 'Asia/Tehran', 'Asia/Thimphu', 'Asia/Tokyo', 'Asia/Tomsk', 'Asia/Ulaanbaatar', 'Asia/Urumqi', 'Asia/Ust-Nera', 'Asia/Vientiane', 'Asia/Vladivostok', 'Asia/Yakutsk', 'Asia/Yangon', 'Asia/Yekaterinburg', 'Asia/Yerevan', 'Atlantic/Azores', 'Atlantic/Bermuda', 'Atlantic/Canary', 'Atlantic/Cape_Verde', 'Atlantic/Faroe', 'Atlantic/Madeira', 'Atlantic/Reykjavik', 'Atlantic/South_Georgia', 'Atlantic/St_Helena', 'Atlantic/Stanley', 'Australia/Adelaide', 'Australia/Brisbane', 'Australia/Broken_Hill', 'Australia/Darwin', 'Australia/Eucla', 'Australia/Hobart', 'Australia/Lindeman', 'Australia/Lord_Howe', 'Australia/Melbourne', 'Australia/Perth', 'Australia/Sydney', 'Europe/Amsterdam', 'Europe/Andorra', 'Europe/Astrakhan', 'Europe/Athens', 'Europe/Belgrade', 'Europe/Berlin', 'Europe/Bratislava', 'Europe/Brussels', 'Europe/Bucharest', 'Europe/Budapest', 'Europe/Busingen', 'Europe/Chisinau', 'Europe/Copenhagen', 'Europe/Dublin', 'Europe/Gibraltar', 'Europe/Guernsey', 'Europe/Helsinki', 'Europe/Isle_of_Man', 'Europe/Istanbul', 'Europe/Jersey', 'Europe/Kaliningrad', 'Europe/Kiev', 'Europe/Kirov', 'Europe/Lisbon', 'Europe/Ljubljana', 'Europe/London', 'Europe/Luxembourg', 'Europe/Madrid', 'Europe/Malta', 'Europe/Mariehamn', 'Europe/Minsk', 'Europe/Monaco', 'Europe/Moscow', 'Europe/Oslo', 'Europe/Paris', 'Europe/Podgorica', 'Europe/Prague', 'Europe/Riga', 'Europe/Rome', 'Europe/Samara', 'Europe/San_Marino', 'Europe/Sarajevo', 'Europe/Saratov', 'Europe/Simferopol', 'Europe/Skopje', 'Europe/Sofia', 'Europe/Stockholm', 'Europe/Tallinn', 'Europe/Tirane', 'Europe/Ulyanovsk', 'Europe/Uzhgorod', 'Europe/Vaduz', 'Europe/Vatican', 'Europe/Vienna', 'Europe/Vilnius', 'Europe/Volgograd', 'Europe/Warsaw', 'Europe/Zagreb', 'Europe/Zaporozhye', 'Europe/Zurich', 'Indian/Antananarivo', 'Indian/Chagos', 'Indian/Christmas', 'Indian/Cocos', 'Indian/Comoro', 'Indian/Kerguelen', 'Indian/Mahe', 'Indian/Maldives', 'Indian/Mauritius', 'Indian/Mayotte', 'Indian/Reunion', 'Pacific/Apia', 'Pacific/Auckland', 'Pacific/Bougainville', 'Pacific/Chatham', 'Pacific/Chuuk', 'Pacific/Easter', 'Pacific/Efate', 'Pacific/Enderbury', 'Pacific/Fakaofo', 'Pacific/Fiji', 'Pacific/Funafuti', 'Pacific/Galapagos', 'Pacific/Gambier', 'Pacific/Guadalcanal', 'Pacific/Guam', 'Pacific/Honolulu', 'Pacific/Kiritimati', 'Pacific/Kosrae', 'Pacific/Kwajalein', 'Pacific/Majuro', 'Pacific/Marquesas', 'Pacific/Midway', 'Pacific/Nauru', 'Pacific/Niue', 'Pacific/Norfolk', 'Pacific/Noumea', 'Pacific/Pago_Pago', 'Pacific/Palau', 'Pacific/Pitcairn', 'Pacific/Pohnpei', 'Pacific/Port_Moresby', 'Pacific/Rarotonga', 'Pacific/Saipan', 'Pacific/Tahiti', 'Pacific/Tarawa', 'Pacific/Tongatapu', 'Pacific/Wake', 'Pacific/Wallis', 'UTC', '']
function Request() {
    var request = {
        url: "",
        parameters: {},
        Type: ""
    };
    return request;
}
var grayOutRules = [
	{'id':0,"ip_addr":{'display':false,'text':'IP Address'},'port':{'display':false,'text':'Port'},'acc_name':{'display':false,'text':'Account Name'},'password':{'display':false,'text':'Password'},'certificate':{'display':false,'text':'Certificate'}},
	{'id':1,"ip_addr":{'display':true,'text':'IP Address'},'port':{'display':false,'text':'Port'},'acc_name':{'display':true,'text':'Account Name'},'password':{'display':true,'text':'Password'},'certificate':{'display':true,'text':'Certificate'}},
	{'id':2,"ip_addr":{'display':true,'text':'IP Address'},'port':{'display':false,'text':'Port'},'acc_name':{'display':true,'text':'Account Name'},'password':{'display':true,'text':'Password'},'certificate':{'display':true,'text':'Certificate'}},
	{'id':3,"ip_addr":{'display':true,'text':'IP Address'},'port':{'display':false,'text':'Port'},'acc_name':{'display':true,'text':'Account Name'},'password':{'display':true,'text':'Password'},'certificate':{'display':true,'text':'Certificate'}},
	{'id':4,"ip_addr":{'display':true,'text':'IP Address'},'port':{'display':true,'text':'Port'},'acc_name':{'display':true,'text':'Test Key'},'password':{'display':true,'text':'Secret Key'},'certificate':{'display':false,'text':'Certificate'}},
	{'id':999,"ip_addr":{'display':false,'text':'IP Address'},'port':{'display':false,'text':'Port'},'acc_name':{'display':false,'text':'Account Name'},'password':{'display':false,'text':'Password'},'certificate':{'display':false,'text':'Certificate'}}
];
$(function(){
	GetEmailServices();
	GetCBAServices();
	GetKMIPServices();
	GetNTPServices();
	GetMachineSetupServices();
	$('#timeZoneList').html('');
	$('#timeZoneList').append(`<option value=" ">Select Time Zone</option>`);
	timezones.forEach(element => {
		$('#timeZoneList').append(`<option value="${element}">
			${element}</option>
		`);
	});
	$('[name="timeZoneList"]').val('Africa/Asmara');
});
function CallPythonService(request) {
	request.parameters.uuid=parent.uuid;
    $.ajax({
        type: "Get",
        url: request.url,
        contentType: 'application/json',
        dataType: 'json',
        headers: { 'Access-Control-Allow-Origin': '*' },
        data: request.parameters,
        success: function (response) {
            BindResponseData(request.Type, response);
        },
        error: function (ex) {			
            if(!isProduction){
				console.log(ex);
			}
        }
    });
}
function BindResponseData(type,response)
{	
	if(response.status=='success' && type == 'updateCanister'){
		$('#txtMachineCanisterSerialNumber').val(response.serial_number);
	}
	if(response.status=='fail'){
		var elements = document.getElementsByClassName('switch-label'); // get all elements
		for(var i = 0; i < elements.length; i++){
			elements[i].style.backgroundColor = "#00b4f0";
		}
 		document.getElementById("rehomeVal").disabled = false;
		 $("#rehomeVal").prop('checked',false)

	}
    console.log(response)
	if(type == "EmailServices_Get")
	{
	response=response[0];
	try {
		var alerts = response.alert_type.split(';');
		var state = response.state;
		$('#txtSender').val(response.sender_email);
		$('#txtRecipient').val(response.recipient_email);
		$('#txtPassword').val(response.password);
		$('#txtSMTPServer').val(response.smtp_server);
		$('#txtPortNumber').val(response.port);
		$("input[name='rbEmailValidation']").each(function () {
			if (state==0)
			{
				$('#rbValidationyes').attr('checked',true);
			}
			else
			{
				$('#rbValidationNo').attr('checked',true);
			}
		});
		$("input[name='rbalert']").each(function () {		
			if (jQuery.inArray($(this).attr('value'), alerts) !=-1) {
				$(this).attr('checked',true);
			}
		});
	}
	catch(e) {
		return false
	}
	if(response.password !=null)
		$('#rbAuthyes').attr('checked',true);
	else
		$('#rbAuthNo').attr('checked',true);
	$("input[name='rbAuth']").trigger("change");
	
	}


	else if(type == "MachineServices_Get")
	{
		if(response.length >0){
			response=response[0];
			if(response.canister_serial!=response.serial_number){
				document.getElementById('rehome').style.visibility = 'visible';
				document.getElementById("rehomeVal").disabled = false;
				var elements = document.getElementsByClassName('switch-label'); // get all elements
				for(var i = 0; i < elements.length; i++){
					elements[i].style.backgroundColor = "#00b4f0";
				}
			}
			
			$('#txtMachineSysName').val(response.system_name);
			$('#txtMachineControllerName').val(response.controller_name);
			$('#txtMachineSerialNumber').val(response.serial_number);
			$('#txtMachineCanisterSerialNumber').val(response.canister_serial);
			
            console.log(response.serial_number)
            if(response.serial_number == response.canister_serial){
                document.getElementById("rehomeVal").disabled = true;
            }
			if(response.canister_serial==null){
				document.getElementById('rehome').style.visibility = 'visible';
				//document.getElementById("rehomeVal").disabled = true;
				document.getElementById("txtMachineCanisterSerialNumber").value = "None";
				var elements = document.getElementsByClassName('switch-label'); // get all elements
				for(var i = 0; i < elements.length; i++){
					elements[i].style.backgroundColor = "#eceeef";
				}


			}
		}
		else
		{
			$('#txtMachineSysName').val('');
			$('#txtMachineControllerName').val('');
			$('#txtMachineSerialNumber').val('');
		}
	}


	else if(type == "BackupServices_Get")
	{
		if(response.length >0){
			response=response[0];		
			$('#txtIPAddress').val(response.ip_address);
			$('#txtPort').val(response.port);
			$('#txtAccountName').val(response.account_name);
			$('#txtbckPassword').val(response.password);
			$("#txtCertificate").val(response.certificate_path);
		}
		else
		{
			$('#txtIPAddress').val('');
			$('#txtPort').val('');
			$('#txtAccountName').val('');
			$('#txtbckPassword').val('');
			$("#txtCertificate").val('');
		}
	}
	else if(type == "CBAServices_Get")
	{
		response=response[0];
		var enableCBA = response.enableCBA;
		var enableSSH = response.enableSSH;

		// $("input[name='rbEnSSH'], input[name='rbEnCBA']").each(function () {
		// 	console.log($(this))
		// 	$(this).prop('checked', false);
		// });

		$("input[name='rbEnCBA']").each(function () {		
			if($(this).attr('value') == enableCBA) {
				$(this).prop('checked',true);
			}
		});
		
		$("input[name='rbEnSSH']").each(function () {		
			if($(this).attr('value') == enableSSH) {
				$(this).prop('checked',true);
			}
		});
	}
	else if(type == "KMIPServices_Get")
	{
		response=response[0];
		$('#kmipUserName').val(response.userName);
		$('#kmipPassword').val(response.password);
		$('#kmipHost').val(response.host);
		$('#kmipPortNumber').val(response.port);
	}
	
	else if(type == "NTPServices_Get")
	{	
		parent.currentTimezone = response[0].time_zone;
		
		response=response[0];
		/*$("#ntpTimeZone > option").each(function() {		
			if($(this).attr('timeZoneId') == response.id) {
				$(this).attr("selected", "selected");
			}
		});*/
		$('#txtNTPServer').val(response.ntp_server);
		$('#timeZoneList').val(response.time_zone);
	}
	else
	{	
		if(type == "NTPServices" && response.status == "success"){
			parent.currentTimezone = response.time_zone;
		}
		else if(type == 'CBAServices') {
			GetCBAServices();
		}
		
		//$('#divMessage').html(response.description);	
		//$('#emailAlert').modal('show');
		window.parent.$('#loading').hide();
		parent.swal.close()
		window.parent.notify(response.description,response.description,response.status);
		var types = ['NTPServices','KMIPServices','CBAServices','EmailServices','BackupServices','MachineSetupService']
		if(types.includes(type))
			window.parent.GetAllDataBySelectedSection(type,true,'Services');
		else
			window.parent.GetAllDataBySelectedSection('EmailServices',true,'Services');
		// /console.log('BackupServices',true,'Services');
		window.parent.document.getElementById('start').click();
		
	}
}
function SaveEmailAlert()
{
	var isFormValid = $("#formEmail").validationEngine('validate');
	if(isFormValid){
		$('#loading').show();
	var sender=$('#txtSender').val();
	var emailRecipient=$('#txtRecipient').val();
	var password=$('#txtPassword').val();
	var smtpServer=$('#txtSMTPServer').val();
	var portNumber=$('#txtPortNumber').val();
	var emailValidation= $("input[name='rbEmailValidation']:checked").attr("value");
	var alertType=""; //$("input[name='rbalert']:checked").val();
	$("input[name='rbalert']:checked").each(function () {
			alertType = alertType + $(this).attr("value") + ";";
	});
	if(alertType.length > 0)
		alertType=alertType.slice(0, -1);
	else
	{alert('Select atleast one alert type'); return false;}
	
		var request = new Request();
		request.url = 'cgi/cgi_Services_Manager.py';
		request.parameters = { 'RequestType':'create_EmailServices', 'sender':sender,'emailRecipient': emailRecipient,'password': password,'smtpServer': smtpServer,'portNumber':portNumber,'alertType': alertType,'emailValidation':emailValidation};
		request.Type = 'EmailServices';
		CallPythonService(request);			
	}
}
function SaveMachineSetup()
{
	var isFormValid = $("#formMachineSetupServices").validationEngine('validate');
	if(isFormValid){
	var system_name=$('#txtMachineSysName').val();
	var controller_name=$('#txtMachineControllerName').val();
	var canister_serial = $('#txtMachineCanisterSerialNumber').val()
	
	var request = new Request();
	request.url = 'cgi/cgi_MachineSetupService.py';
	request.parameters = { 'RequestType':'create_MachineSetupServices', 'system_name':system_name,'controller_name': controller_name};
	request.Type = 'MachineSetupService';
	CallPythonService(request);			
	}
}
function SaveBackupService()
{
	if($('#ddlSchedule').val() >0){
	var isFormValid = $("#formBackServices").validationEngine('validate');
	if(isFormValid){
	var ddlSchedule=$('#ddlSchedule option:selected').text();
	var txtIPAddress=$('#txtIPAddress').val();
	var txtport=$('#txtPort').val();
	var txtAccountName=$('#txtAccountName').val();
	var txtbckPassword=$('#txtbckPassword').val();
	var txtCertificate=$("#txtCertificate").val();
		window.parent.$('#loading').show();
		var request = new Request();
		request.url = 'cgi/cgi_Services_Manager.py';
		request.parameters = { 'RequestType':'create_BackupServices', 'backupDest': ddlSchedule,'iPAddress': txtIPAddress,'port':txtport,'accountName': txtAccountName,'bckPassword':txtbckPassword,'certificate': txtCertificate};
		request.Type = 'BackupServices';
		CallPythonService(request);			
	}
	}else
		alert('Select Backup Destination');
}
function SaveCBAService()
{
	var isFormValid = $("#formCBASSHServices").validationEngine('validate');
	if (isFormValid) {
		parent.swal({
			title: "Please enter the password",
			html: true,
			text: "<input type='password' class='form-control' id='confirm-password' placeholder='Password'>",
			showCancelButton: true,
			closeOnConfirm: false,
		  	closeOnCancel: false,
			width: 100,
			animation: "slide-from-top"
		},
			function(isConfirm) {
				if (isConfirm) {
					var password = btoa(parent.$('#confirm-password').val());
					console.log("CBA_SSH Pwd",password)
					var sessionData =JSON.parse(sessionStorage.getItem("sessionData"));	
					var user_id = sessionData['Userid'];
					var enCBA = $("input[name='rbEnCBA']:checked").val();
					var enSSH = $("input[name='rbEnSSH']:checked").val();

					var request = new Request();
					request.url = 'cgi/cgi_CBA_SSH_ServiceManager.py';
					request.parameters = { 'RequestType': 'create_CBAServices', 'enCBA': enCBA, 'enSSH': enSSH, "userId":user_id, "password":password};
					request.Type = 'CBAServices';
					CallPythonService(request);
				} else {
				  	parent.swal("Cancelled", "", "error");
				}
		});
		
	}
}
function SaveKMIPService()
{
	var isFormValid = $("#formKMIPServices").validationEngine('validate');
	if (isFormValid) {
		var userName = $('#kmipUserName').val();
		var password = $('#kmipPassword').val();
		var host=$('#kmipHost').val();
		var portNumber = $('#kmipPortNumber').val();
		
		var request = new Request();
		request.url = 'cgi/cgi_KMIP_ServiceManager.py';
		request.parameters = { 'RequestType': 'create_KMIPServices', 'userName': userName,'password': password, 'host': host, 'portNumber': portNumber};
		request.Type = 'KMIPServices';
		CallPythonService(request);
	}
}
function SaveNTPService()
{
	//var isFormValid = $("#formKMIPServices").validationEngine('validate');
	var isFormValid = $("#formNTPServices").validationEngine('validate');
	if (isFormValid) {
		//var time_zone_id = $('#ntpTimeZone option:selected').attr('timeZoneId');
		//var gmtAdjustment = $('#ntpTimeZone').val();
		//var ntp_time_zone = $('#ntpTimeZone option:selected').text();
		var time_zone = $('#timeZoneList').val();
		var ntp_server = $('#txtNTPServer').val()
		if(time_zone == " ")
		{
			alert('Please select some time zone')
		}
		var request = new Request();
		request.url = 'cgi/cgi_NTP_ServiceManager.py';
		
		
		//request.parameters = { 'RequestType': 'create_NTPServices','time_zone': time_zone,'time_zone_val': time_zone_id,'ntp_time_zone':ntp_time_zone,'gmtAdjustment':gmtAdjustment};
		request.parameters = { 'RequestType': 'create_NTPServices','time_zone': time_zone,'ntp_server':ntp_server};
		request.Type = 'NTPServices';
		CallPythonService(request);
	}
}
$("input[name='rbAuth']").change(function(){
	var selectedButton= $("input[name='rbAuth']:checked").val();
	if(selectedButton == 'yes')
		$('#divpwd').css('display','block');
	else{
		$('#txtPassword').val('');
		$('#divpwd').css('display','none');
		}
});
$('#ddlSchedule').change(function(){
	var id=$(this).val();
	if(id!=0)
		$('#divbackUpService').css('display','block');
	else
		$('#divbackUpService').css('display','none');
	perform_rules_for_backup(id);
});
function validateEmail(email) {
  var re = /^(([^<>()[\]\\.,;:\s@\"]+(\.[^<>()[\]\\.,;:\s@\"]+)*)|(\".+\"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;
  return re.test(email);
}
function GetEmailServices()
{
		var request = new Request();
		request.url = 'cgi/cgi_Services_Manager.py';
		request.Type = 'EmailServices_Get';
		request.parameters = { 'RequestType':'read_EmailServices'}
		CallPythonService(request);
}
function GetMachineSetupServices()
{
		var request = new Request();
		request.url = 'cgi/cgi_MachineSetupService.py';
		request.Type = 'MachineServices_Get';
		request.parameters = { 'RequestType':'read_MachineSetupServices'}
		CallPythonService(request);
}
function GetCBAServices()
{
		var request = new Request();
		request.url = 'cgi/cgi_CBA_SSH_ServiceManager.py';
		request.Type = 'CBAServices_Get';
		request.parameters = { 'RequestType':'read_CBAServices'}
		CallPythonService(request);
}
function GetKMIPServices()
{
		var request = new Request();
		request.url = 'cgi/cgi_KMIP_ServiceManager.py';
		request.Type = 'KMIPServices_Get';
		request.parameters = { 'RequestType':'read_KMIPServices'}
		CallPythonService(request);
}
function GetNTPServices()
{
		var request = new Request();
		request.url = 'cgi/cgi_NTP_ServiceManager.py';
		request.Type = 'NTPServices_Get';
		request.parameters = { 'RequestType':'read_NTPServices'}
		CallPythonService(request);
}
$('#ddlSchedule').change(function(){
		var ScheduleType=$('#ddlSchedule option:selected').text();
		var request = new Request();
		request.url = 'cgi/cgi_Services_Manager.py';
		request.parameters = {'RequestType':'read_BackupServices', 'destType':ScheduleType}
		request.Type = 'BackupServices_Get';
		CallPythonService(request);
});

$('.collapse').on('shown.bs.collapse', function() {
	$(".collapsible").find('.arrow').removeClass().addClass('arrow down');
	var id = $(this).attr('id');
	$(".collapsible").each(function(){
		//console.log($(this).attr('aria-controls'),id)
		if($(this).attr('aria-controls')==id)
		{
			if($(this).attr('aria-expanded')=='true')
			{
				$(this).find('.arrow').removeClass('down').addClass('up');
			}
			$('html, body').animate({
				scrollTop: $(this).offset().top
			}, 1000);
		}
	});
});
$(".collapsible").on('click',function(){
	//console.log($(this).attr('serviceType'))
	window.parent.GetAllDataBySelectedSection($(this).attr('serviceType'),true,'Services');
});
$('.collapse').on('hidden.bs.collapse', function() {
	$(".collapsible").find('.arrow').removeClass().addClass('arrow down');
});
var $myGroup = $('.main-container');
$myGroup.on('show.bs.collapse','.collapse', function() {
    $myGroup.find('.collapse.in').collapse('hide');
});

function update_div_lbl(div, div_show, label, label_txt, input_id)
{
	var disp_mssg = div_show? 'block':'none';
	$('#'+div).css('display',disp_mssg);
	$('#'+label).html(label_txt);
	$('#'+input_id).attr('placeholder',label_txt);
}
function perform_rules_for_backup(id){
	if(parseInt(id) < grayOutRules.length)
		var rules = grayOutRules[id];
	else
		var rules = grayOutRules[grayOutRules.length-1];

	var xx = rules['ip_addr'];
	update_div_lbl("div_ip_addr",xx['display'], "lbl_ip_addr", xx['text'], "txtIPAddress");
	xx = rules['port'];
	update_div_lbl("div_port",xx['display'], "lbl_port", xx['text'], "txtPort");
	xx = rules['acc_name'];
	update_div_lbl("divAccName",xx['display'], "lbl_AccName", xx['text'], "txtAccountName");
	xx = rules['password'];
	update_div_lbl("divBkpPassword",xx['display'], "lbl_Password", xx['text'], "txtbckPassword");
	xx = rules['certificate'];
	update_div_lbl("divCertificate",xx['display'], "lbl_certificate", xx['text'], "txtCertificate");
}


function updateCanSl() {
    let canisterSerial = $("#txtMachineCanisterSerialNumber").val();
    let machineSerial = $("#txtMachineSerialNumber").val();
    if(canisterSerial != machineSerial) {
        swal({
            title: "Please enter the password",
            html: true,
            text: "<input type='password' class='form-control' id='confirm-password' placeholder='Password'>",
            showCancelButton: true,
            closeOnConfirm: false,
            closeOnCancel: false,
            width: 100,
            animation: "slide-from-top"
        },
            function(isConfirm) {
                if (isConfirm) {
                    // var password = btoa(parent.$('#confirm-password').val()); This is setting default password 
                    var password = btoa($('#confirm-password').val()); // This is calling correct password
                    var sessionData =JSON.parse(sessionStorage.getItem("sessionData"));	
                    var user_id = sessionData['Userid'];
                    var title = $(this).attr('data-original-title');
                    var CanVal=$('#txtMachineCanisterSerialNumber').val();
                    var SerialVal=$('#txtMachineSerialNumber').val();
                    var request = new Request();
                    request.url = 'cgi/cgi_MachineSetupService.py';
                    console.log("Password::::",password)
                    request.parameters = { 'RequestType':'updateCanister', 'canister_serial':CanVal,"userId":user_id, "password":password};
                    request.Type = 'updateCanister';
                    CallPythonService(request);
                  	
                    var elements = document.getElementsByClassName('switch-label'); // get all elements
                    for(var i = 0; i < elements.length; i++){
                        elements[i].style.backgroundColor = "#eceeef";
                    }
                    document.getElementById("rehomeVal").disabled = true;
                    swal.close();
                } else {
                    parent.swal("Cancelled", "", "error");
                    var elements = document.getElementsByClassName('switch-label'); // get all elements
                    for(var i = 0; i < elements.length; i++){
                        elements[i].style.backgroundColor = "#eceeef";
                    }

                    swal.close();
                    // document.getElementById("rehomeVal").bootstrapToggle({off:'Disabled'});
                    $("#rehomeVal").prop('checked',false)
		var elements = document.getElementsByClassName('switch-label'); // get all elements
		for(var i = 0; i < elements.length; i++){
			elements[i].style.backgroundColor = "#00b4f0";
		}


                }
        });
    }
}
