function Request() {
    var request = {
        url: "",
        parameters: {},
        statusType: "",
		typeNumber: "",
		isSingleStatus:false
    };
    return request;
}
$(window).bind("load", function() {
    GetBackupList();
});
function GetBackupList()
{	
	var request = new Request();
	request.url = "cgi/cgi_backupServerGet.py";
	request.statusType="backuserverGet";	
	CallPythonService(request);	
}


function CallPythonService(request) {
	request.parameters.uuid=uuid;
    $.ajax({
        type: "Get",
        url: request.url,
        contentType: 'application/json',
        dataType: 'json',
        headers: { 'Access-Control-Allow-Origin': '*' },
        data: request.parameters,
        success: function (response) {			
				BindResponseData(request.statusType,response);
        },
        error: function (ex) {
            if(!isProduction){
				console.log(ex);
			}
        }
    });
}
function BindResponseData(statusType, response) {
	
    if (statusType === 'backuserverGet') {     
		//commented for future ref
		
        // var tableHeader = '<table border="1" class="table table-curved tbdata" id="tblhead"><thead><tr class="tbheader"><th>Name</th><th>Type</th><th>Created Date</th><th>Backup Server</th><th>Status</th></tr></thead><tbody></tbody></table>'
        // $('#displayData').html(tableHeader);
        // $.each(response, function (i, item) {
            // var records = '<tr><td>' + item.backupname + '</td><td>' + 'Remote' + '</td><td>' + ConvertDateFormat2(item.backupTime) + '</td><td>' + item.backupserverid + '</td><td>' + item.status + '</td></tr>'
            // $('#tblhead').append(records);
        // });
		var dataTable = $('#tblResult').DataTable();
		dataTable.destroy();

		var tableHeader = '<table border="1" class="table table-curved tbdata" id="tblResult"><thead><tr class="tbheader"><th>Name</th><th>Start Time</th><th>Start Date</th><th>End Date</th><th>Type</th><th>Server</th><th>Frequency</th><th>Status</th><th>Actions</th></tr></thead><tbody id="tblbody"></tbody></table>'
        $('#displayData').html(tableHeader);
        $.each(response, function (i, item) {
            var records = '<tr><td>' + item.backupname + '</td><td>' + 'NA' + '</td><td>' + ConvertDateFormat2(item.backupTime) + '</td><td>' + 'NA' + '</td><td>' + 'Remote' + '</td><td>' + (item.VMName != null ? item.VMName:'') + '</td><td>' + 'NA' + '</td><td>' + item.status + '</td><td><span class="linksBlk"><a href="javascript:void(0)">Edit</a><a href="javascript:void(0);" onclick="DeleteSchedule('+item.id+')">Delete</a></span></td></tr>'
            $('#tblbody').append(records);
        });	
		
		$('#tblResult').DataTable();
    }
	

    
}
Date.prototype.addHours = function(h) {    
   this.setTime(this.getTime() - (h*60*1000)); 
   return this;   
}
function ConvertDateFormat2(YYYmmdd)
{
	var lst=YYYmmdd.split('-');
	return lst[1]+"/"+lst[2]+"/"+lst[0];
}
function ConvertToLocalDate(UTCDate,UtcTime)
{
	var utcDate = UTCDate+'T'+UtcTime+':00'; //'2011-06-29T16:52:48.000Z';  // ISO-8601 formatted date returned from server
	var localDate = new Date(utcDate);
	localDate.addHours(localDate.getTimezoneOffset())
	return ConvertDateFormat2(localDate.getFullYear()+'-'+ (localDate.getMonth()<10? ('0'+localDate.getMonth()):localDate.getMonth())+'-'+(localDate.getDate()<10?('0'+localDate.getDate()):localDate.getDate()));
}
function ConvertToLocalTime(UTCDate,UtcTime)
{
	var utcDate = UTCDate+'T'+UtcTime+':00'; //'2011-06-29T16:52:48.000Z';  // ISO-8601 formatted date returned from server
	var localDate = new Date(utcDate);
	localDate.addHours(localDate.getTimezoneOffset())
	return (localDate.getHours()<10?('0'+localDate.getHours()):localDate.getHours())+':'+(localDate.getMinutes()<10?('0'+localDate.getMinutes()):localDate.getMinutes());
}
