var selectedComponent='';
var selectedSubComponent = '';
var selectedComponentCode='';
var typeOfTemp = "";
var mapImgId =0;
var specfictype=''; //to determine type of storage mainly
var hardwareSubComponent = {defaultValue:0,maxValidValue:0,minValidValue:0,lowthreshold:0,highthreshold:0,isMaxValid:false,isMinValid:false,isTempValidator:false};
var temperatureValues = {FahrenheitValue:0,CelciusValue:0,selectedTemperatureType:0}
function Request() {
    var request = {
        url: "",
        parameters: {},
        Type: ""
    };
    return request;
}
$(function(){
	GetCPUData();
	GetAllSubComponents();
});
function CallPythonService(request) {
	request.parameters.uuid=parent.uuid;
    $.ajax({
        type: "Get",
        url: request.url,
        contentType: 'application/json',
        dataType: 'json',
        headers: { 'Access-Control-Allow-Origin': '*' },
        data: request.parameters,
        success: function (response) {
            BindResponseData(request.Type, response);
        },
        error: function (ex) {
            if(!parent.isProduction){
				console.log(ex);
			}
        }
    });
}
function BindResponseData(Type, response) {
	if(Type == 'read_AllSubComponents')
	{
		var optionGroups = `<option value=''>Select One</option>  
							<optgroup label="CPU" id="tempCPUOpt">
								<option value="NoneTempCPU" disabled>No items</option>
							</optgroup>
							<optgroup label="Temp Probes" id="temp_probesOpt">
								<option value="NoneTemp_probe" disabled>No items</option>
							</optgroup>
							<optgroup label="Disks" id="TempDisksOpt">
								<option value="NoneTempDisks" disabled>No items</option>
							</optgroup>`;	
		$("#ddlTemperature option").remove();
		$('#ddlTemperature').html(optionGroups);
		$.each(response.temperature, function(i, item) {            
            var optionName = item.type;
			var opt='';
			if(optionName == 'CPU'){
				$('#ddlTemperature option[value="NoneTempCPU"]').remove();
				opt='tempCPUOpt';
			}
			else if(optionName == 'Temp_Probes'){
				$('#ddlTemperature option[value="NoneTemp_probe"]').remove();
				opt='temp_probesOpt';
			}
			else if(optionName == 'Disks'){
				$('#ddlTemperature option[value="NoneTempDisks"]').remove();
				opt='TempDisksOpt';
			}
			$('#'+opt).append($('<option>', { 
				value: item.name,
				text : item.name,
				typeOfOption : optionName 
			}));
            /*
			$('#ddlTemperature').append($('<option>', { 
				value: item,
				text : item 
			}));*/
		});
		
		$("#ddlFans option").remove();
		$('#ddlFans').append($('<option>', { 
				value: "",
				text : "Select One" 
			}));
		$.each(response.fans, function(i, item) {       
            $('#ddlFans').append($('<option>', { 
				value: item,
				text : item 
			}));
		});
		
		$("#ddlNetwork option").remove();
		$('#ddlNetwork').append($('<option>', { 
				value: "",
				text : "Select One" 
			}));
		$.each(response.network, function(i, item) {            
            $('#ddlNetwork').append($('<option>', { 
				value: item,
				text : item 
			}));
		});
		optionGroups = `<option value=''>Select One</option>
							<!--<optgroup label="HDD POOL" id="HDDopt">
								<option value="NoneHDD" disabled>No items</option>
							</optgroup>
							<optgroup label="SSD POOL" id="SSDopt">
								<option value="NoneSSD" disabled>No items</option>
							</optgroup>    
							<optgroup label="iSCSI POOL" id="iSCSIopt">
								<option value="NoneiSCSI" disabled>No items</option>
							</optgroup>
							<optgroup label="NVMeOF POOL" id="NVMeOFopt">
								<option value="NoneNVMeOF" disabled>No items</option>
							</optgroup>-->
							<optgroup label="MegaRAID POOL" id="MegaRAIDopt">
								<option value="NoneMegaRAID" disabled>No items</option>
							</optgroup>
							<optgroup label="Disks" id="Disksopt">
								<option value="NoneDisks" disabled>No items</option>
							</optgroup>`;
		$("#ddlStorage option").remove();
		$('#ddlStorage').html(optionGroups);
		$.each(response.storage, function(i, item) {    
			optionName = item.type;
			var opt='';
			var typeOfStorage = 'Pools';
			if(optionName == 'HDD POOL'){
				$('#ddlStorage option[value="NoneHDD"]').remove();
				opt='HDDopt';
			}
			else if(optionName == 'SSD POOL'){
				$('#ddlStorage option[value="NoneSSD"]').remove();
				opt='SSDopt';
			}
			else if(optionName == 'iSCSI POOL'){
				$('#ddlStorage option[value="NoneiSCSI"]').remove();
				opt='iSCSIopt';
			}
			else if(optionName == 'NVMeOF POOL'){
				$('#ddlStorage option[value="NoneNVMeOF"]').remove();
				opt='NVMeOFopt';
			}
			else if(optionName == 'MegaRAID POOL') 
			{
				$('#ddlStorage option[value="NoneMegaRAID"]').remove();
				opt='MegaRAIDopt';
			} 
			else if(optionName == 'Disks'){
				$('#ddlStorage option[value="NoneDisks"]').remove();
				opt='Disksopt';
				typeOfStorage = 'Disks';
			}
			$('#'+opt).append($('<option>', { 
				value: item.name,
				text : item.name,
				typeOfOption : typeOfStorage 
			}));
            /*$('#ddlStorage').append($('<option>', { 
				value: item,
				text : item,
				typeOfStorage : 'Pools' 
			}));*/
		});
		/*$.each(response.storage.Disks, function(i, item) { 
			$('#Disksopt').append($('<option>', { 
				value: item.name,
				text : item.name,
				typeOfStorage : 'Disks' 
			}));           
            $('#ddlStorage').append($('<option>', { 
				value: item,
				text : item,
				typeOfStorage : 'Disks'  
			}));
		});*/
	}
	
	if(Type == 'ReadSubComponent')
	{
		
		if(selectedComponent == 'Temperature'){
			
			hardwareSubComponent = new Object();
			hardwareSubComponent.minValidValue = response.min;
			hardwareSubComponent.maxValidValue = response.max;
			if (typeOfTemp == "Disks") {
				hardwareSubComponent.defaultValue = response.max;
				parent.$('#default_label').html('T_max');
			}
			else {
				hardwareSubComponent.defaultValue = response.default_val;
				parent.$('#default_label').html('Default');
			}
			
			hardwareSubComponent.lowthreshold = response.low_threshold;
			hardwareSubComponent.highthreshold = response.hi_threshold;
			
			minThresholdValidator(response.low_threshold);
			maxThresholdValidator(response.hi_threshold);
			DisplayErrorMessage();
			
			var currentTempType = response.TemperatureType;
			var selectedTemperatureType = '';
			if(currentTempType == 'Fahrenheit')
			{
				selectedTemperatureType = 'f';
				var farenheit = hardwareSubComponent.defaultValue;
				var celcius = convertTemp('Celcius',hardwareSubComponent.defaultValue);
			}else
			{
				selectedTemperatureType = 'c';
				var farenheit = convertTemp('Fahrenheit',hardwareSubComponent.defaultValue);
				var celcius = hardwareSubComponent.defaultValue;
			}
			
			temperatureValues.FahrenheitValue = farenheit;
			temperatureValues.CelciusValue = celcius;
			temperatureValues.selectedTemperatureType = selectedTemperatureType
			
			hardwareSubComponent.isTempValidator =true;
			
			parent.$('#spnNameTemp').text(response.name);
			parent.$('#spnLocationTemp').text(response.location);
			parent.$('#spnDefaultTemp').text(celcius+'°C / '+farenheit +'°F');
			parent.$('#ddlMonitorTemp').val(selectedTemperatureType);
			parent.$('#txtLowThresholdTemp').val(response.low_threshold);
			parent.$('#txtHighThresholdTemp').val(response.hi_threshold);	
			
			parent.$("#txtLowThresholdTemp").trigger("change");
			parent.$("#txtHighThresholdTemp").trigger("change");
			
		}
		else if(selectedComponent == 'Network'){
			
			hardwareSubComponent = new Object();
			hardwareSubComponent.minValidValue = 0;
			//hardwareSubComponent.maxValidValue = response.err_max;
			//hardwareSubComponent.defaultValue = response.tx_rx_default;
			hardwareSubComponent.maxValidValue = response.tx_rx_default;
			hardwareSubComponent.defaultValue = response.err_threshold;	
			
			minThresholdValidator(response.low_threshold);
			maxThresholdValidator(response.hi_threshold);
			DisplayErrorMessage();
			
			parent.$('#spnName').text(response.name);
			parent.$('#spnLocation').text(response.location);
			//parent.$('#spnDefault').text(response.tx_rx_default);
			parent.$('#spnDefault').text(response.err_threshold);
			parent.$('#ddlMonitor').val(response.tx_rx_monitor);
			//parent.$('#txtHighThreshold').val(response.err_threshold);	
			parent.$('#txtHighThreshold').val(response.tx_rx_default);
			
			parent.$("#txtLowThreshold").trigger("change");
			parent.$("#txtHighThreshold").trigger("change");
			
		}
		else if(selectedComponent == 'Storage'){
			
			hardwareSubComponent = new Object();
			hardwareSubComponent.minValidValue = 0;
			//hardwareSubComponent.maxValidValue = response.err_max;
			//hardwareSubComponent.defaultValue = response.tx_rx_default;
			hardwareSubComponent.maxValidValue = response.tx_rx_default;
			hardwareSubComponent.defaultValue = response.err_threshold;
			
			minThresholdValidator(response.low_threshold);
			maxThresholdValidator(response.hi_threshold);
			DisplayErrorMessage();
			
			parent.$('#spnName').text(response.name);
			parent.$('#spnLocation').text(response.location);
			//parent.$('#spnDefault').text(response.tx_rx_default);
			parent.$('#spnDefault').text(response.err_threshold);
			parent.$('#ddlMonitor').val(response.tx_rx_monitor);
			//parent.$('#txtHighThreshold').val(response.err_threshold);	
			parent.$('#txtHighThreshold').val(response.tx_rx_default);
			parent.$("#txtLowThreshold").trigger("change");
			parent.$("#txtHighThreshold").trigger("change");
			
		}
		else if(selectedComponent == 'Fans')
		{
			hardwareSubComponent = new Object();
			hardwareSubComponent.minValidValue = response.t_min;
			hardwareSubComponent.maxValidValue = response.t_max;
			hardwareSubComponent.defaultValue = response.default_val;
			
			minThresholdValidator(response.low_threshold);
			maxThresholdValidator(response.hi_threshold);
			DisplayErrorMessage();
			
			parent.$('#spnNameFans').text(response.name);
			parent.$('#spnLocationFans').text(response.location);
			parent.$('#spnDefaultFans').text(response.default_val);
			parent.$('#ddlSpeedFans').text(response.speed);
			parent.$('#txtLowThresholdFans').val(response.low_threshold);
			parent.$('#txtHighThresholdFans').val(response.hi_threshold);	
			
			parent.$("#txtLowThresholdFans").trigger("change");
			parent.$("#txtHighThresholdFans").trigger("change");
		}
	}
    if(Type == 'UpdateSubComponent') 
	{		
		$('.clsComponent').val('');
		window.localStorage.removeItem("data");
		window.parent.notify("Success",response.description,response.status);
		window.parent.GetAllDataBySelectedSection(selectedComponentCode,true,'Hardware');
	}
	else if(Type == 'GetCPU')
	{
		var cpuData = response[0];
		$('#txtCPUMidTemp').val(cpuData.mid_threshold);
		$('#txtCPUHighTemp').val(cpuData.hi_threshold);
		$("input[name='rdTemperatureType'][value='"+cpuData.temperatureType+"']").prop('checked', true);
	}
	else if(Type == 'hardwareAdminOperations')
	{
		window.parent.swal(response.description,"",response.status);
	}
}

$(".clsComponent").on('click',function(ev){
	/*if(ev.offsetY > 0 || $(this).val()==''){
		return false;
	}*/
    var component =this.attributes.component.nodeValue;
	var subComponent =$(this).val();
	//console.log(subComponent,'testing' )
	if(subComponent ==window.localStorage.getItem("data")){
		window.localStorage.removeItem("data");
		subComponent =""
	}
	//console.log(subComponent,'2testing' )
	if(component == 'Temperature'&&subComponent)
	{
		window.localStorage.setItem("data",subComponent)
		typeOfTemp = $(this).find('option:selected').attr('typeOfOption');
		ReadSubComponentData(component,subComponent,typeOfTemp);
		parent.$('#hardwareTemperature').modal("show");
		parent.$('.clsHardwareTitle').html(component +' - '+subComponent );		

	}
	else if(component == 'Network'&&subComponent)
	{
		window.localStorage.setItem("data",subComponent)
		ReadSubComponentData(component,subComponent,'');
		parent.$('#hardwarePorts').modal("show");
		parent.$('.clsHardwareTitle').html(component +' - '+subComponent );
	}
	else if(component == 'Fans'&&subComponent)
	{
			
		window.localStorage.setItem("data",subComponent)	
		ReadSubComponentData(component,subComponent,'');
		parent.$('#hardwareFans').modal("show");
		parent.$('.clsHardwareTitle').html(component +' - '+subComponent );		
	}
	else if(component == 'Storage'&&subComponent)
	{
		window.localStorage.setItem("data",subComponent)
		var typeOfStorage = $(this).find('option:selected').attr('typeOfOption');
		ReadSubComponentData(component,subComponent,typeOfStorage);
		parent.$('#hardwarePorts').modal("show");
		parent.$('.clsHardwareTitle').html(component +' - '+subComponent );
	}
});
/*$('.clsComponent').change(function()
{
	console.log("change : ", $(this).val());
	var component =this.attributes.component.nodeValue;
	var subComponent =$(this).val();
	
	if(component == 'Temperature')
	{
		ReadSubComponentData(component,subComponent);
		parent.$('#hardwareTemperature').modal("show");
		parent.$('.clsHardwareTitle').html(component +' - '+subComponent );		

	}
	else if(component == 'Network')
	{
		ReadSubComponentData(component,subComponent);
		parent.$('#hardwarePorts').modal("show");
		parent.$('.clsHardwareTitle').html(component +' - '+subComponent );
	}
	else if(component == 'Fans')
	{
		ReadSubComponentData(component,subComponent);
		parent.$('#hardwareFans').modal("show");
		parent.$('.clsHardwareTitle').html(component +' - '+subComponent );		
	}
	else if(component == 'Storage')
	{
		ReadSubComponentData(component,subComponent);
		parent.$('#hardwarePorts').modal("show");
		parent.$('.clsHardwareTitle').html(component +' - '+subComponent );
	}
});
*/

function ReadSubComponentData(component,subComponent,type)
{
	
	selectedComponent=component;
	selectedSubComponent = subComponent;
	specfictype=type;
	var request = new Request();
	request.url = "cgi/cgi_Hardware_Manager.py";
	request.parameters = { "RequestType": 'read_SubComponent',"component":component,"subComponent":subComponent,"type":type};
	request.Type = "ReadSubComponent";
	CallPythonService(request);
}

function SaveSubComponent()
{	
	var parameters ={};
	if(selectedComponent == 'Network')
	{
		parameters = { "RequestType": 'update_SubComponent',"component":selectedComponent,"subComponent":selectedSubComponent,
							"tx_rx_default":parent.$('#txtHighThreshold').val(),"tx_rx_monitor":parent.$('#ddlMonitor').val()};
	}
	else if(selectedComponent == 'Fans')
	{
		parameters = { "RequestType": 'update_SubComponent',"component":selectedComponent,"subComponent":selectedSubComponent,
						   "low_threshold":parent.$('#txtLowThresholdFans').val(),"hi_threshold":parent.$('#txtHighThresholdFans').val()};
	}
	else if(selectedComponent == 'Storage')
	{
		parameters = { "RequestType": 'update_SubComponent',"component":selectedComponent,"subComponent":selectedSubComponent,
						   "tx_rx_default":parent.$('#txtHighThreshold').val(),"tx_rx_monitor":parent.$('#ddlMonitor').val(),"type":specfictype};
	}
	else if(selectedComponent == 'Temperature')
	{
		parameters = { "RequestType": 'update_SubComponent',"component":selectedComponent,"subComponent":selectedSubComponent,
						   "low_threshold":parent.$('#txtLowThresholdTemp').val(),"hi_threshold":parent.$('#txtHighThresholdTemp').val(),"temperature":parent.$('#ddlMonitorTemp').val(),"type":specfictype};
	}
	var request = new Request();
	request.url = "cgi/cgi_Hardware_Manager.py";
	request.parameters = parameters
	request.Type = "UpdateSubComponent";
	CallPythonService(request);
	
}
function CancelSubComponent(){
	window.localStorage.removeItem("data");
	$('.clsComponent').val('');
}
parent.$('#ddlMonitorTemp').change(function(){
	temperatureValues.selectedTemperatureType = $(this).val();
	if($(this).val() == 'F')
	{
		window.parent.$('#ddlMonitorTemp').removeClass('clsInvalid');
		hardwareSubComponent.defaultValue = temperatureValues.FahrenheitValue;
	}
	else if($(this).val() == 'C')
	{
		window.parent.$('#ddlMonitorTemp').removeClass('clsInvalid');
		hardwareSubComponent.defaultValue = temperatureValues.CelciusValue;
	}
	else
	{
		
	}
	window.parent.$("#txtLowThresholdTemp").trigger("change");
	window.parent.$("#txtHighThresholdTemp").trigger("change");
});

function GetCPUData(component,subComponent)
{
    var isFormValid = $("#formOrgGroup").validationEngine('validate');
    if (true) {
        var request = new Request();
        request.url = "cgi/cgi_Hardware_Manager.py";
        request.parameters = { "RequestType": 'read_Component',"component":component,"subComponent":subComponent};
        request.Type = "GetCPU";
        CallPythonService(request);
    }
}
function UpdateCPU()
{
	var isFormValid = $("#formOrgGroup").validationEngine('validate');
	if(true)
	{
		var request = new Request();
        request.url = "cgi/cgi_Hardware_Manager.py";
        request.parameters = { "RequestType": 'update_CPU',"id":1,"temperatureType":$("input[name='rdTemperatureType']:checked").val(),"mid_threshold":$('#txtCPUMidTemp').val(),"hi_threshold":$('#txtCPUHighTemp').val()};
        request.Type = "UpdateCPU";
        CallPythonService(request);
	}
}
$('input[name = "rdTemperatureType"]').change(function(){
	var selectedTemp = $("input[name='rdTemperatureType']:checked").val();
	$('#txtCPUMidTemp').val(convertTemp(selectedTemp,$('#txtCPUMidTemp').val()));
	$('#txtCPUHighTemp').val(convertTemp(selectedTemp,$('#txtCPUHighTemp').val()));
});

function convertTemp(degree,currentValue) {
  if (degree == "Fahrenheit") {
    return Math.round(currentValue * 9 / 5 + 32);
  } else {
    return Math.round((currentValue -32) * 5 / 9);
  }
}
function GetAllSubComponents()
{
	var request = new Request();
	request.url = "cgi/cgi_Hardware_Manager.py";
	request.parameters = { "RequestType": 'read_AllSubComponents'};
	request.Type = "read_AllSubComponents";
	CallPythonService(request);
	
}

parent.$(".maxThresholdValidator").bind('keyup change click', function (e) {
	window.parent.$('#ddlMonitorTemp').removeClass('clsInvalid');
	hardwareSubComponent.highthreshold = $(this).val();
			
	if(hardwareSubComponent.isTempValidator && (temperatureValues.selectedTemperatureType == 0 || temperatureValues.selectedTemperatureType == null))
	{
		//hardwareSubComponent.isMaxValid = false;
		DisplayErrorMessage();
		window.parent.$('#ddlMonitorTemp').addClass('clsInvalid');
		return false;
	}
	if(selectedComponent=='Temperature' || selectedComponent=='Fans') 
	{
		if(maxThresholdValidator($(this).val()) && parseInt(hardwareSubComponent.lowthreshold) <= parseInt($(this).val()) && parseInt(hardwareSubComponent.lowthreshold) > 0 ) {
			if(minThresholdValidator(hardwareSubComponent.lowthreshold))
				parent.$('.minThresholdValidator').removeClass('clsInvalid');
			$(this).removeClass('clsInvalid');
		}
		else{
			hardwareSubComponent.isMaxValid = false;
			$(this).addClass('clsInvalid');
		}
	}
	else if(selectedComponent=='Network' || selectedComponent=='Storage')
	{
		//if(maxThresholdValidator($(this).val()) && ($(this).val() > 0 && $(this).val() <=100))
		if(maxThresholdValidator($(this).val()) && ($(this).val() > 0 && $(this).val() <parseInt(hardwareSubComponent.defaultValue)))
		{
			$(this).removeClass('clsInvalid');
		}
		else
		{
			hardwareSubComponent.isMaxValid = false;
			$(this).addClass('clsInvalid');
		}
	}

	DisplayErrorMessage()
});	

parent.$('.minThresholdValidator').bind('keyup change click', function (e) {
	hardwareSubComponent.lowthreshold = $(this).val();
	window.parent.$('#ddlMonitorTemp').removeClass('clsInvalid');

	if(hardwareSubComponent.isTempValidator && (temperatureValues.selectedTemperatureType == 0 || temperatureValues.selectedTemperatureType == null))
	{
		//hardwareSubComponent.isMinValid = false;
		DisplayErrorMessage();
		parent.$(".maxThresholdValidator").addClass('clsInvalid');
		return false;
	}
	//console.log("parent.$('#txtHighThresholdTemp').val() : ", parent.$('#txtHighThresholdTemp').val(), ' ',$(this).val() , ' ' ,parseInt(hardwareSubComponent.highthreshold) >= parseInt($(this).val()));
	
	if(( minThresholdValidator($(this).val()) ) && ( parseInt(hardwareSubComponent.highthreshold) >= parseInt($(this).val()) ) && ( parseInt($(this).val()) > 0 )){
		if(maxThresholdValidator(hardwareSubComponent.highthreshold))
			parent.$(".maxThresholdValidator").removeClass('clsInvalid');
		$(this).removeClass('clsInvalid');
	}
	else{
		hardwareSubComponent.isMinValid = false;
		$(this).addClass('clsInvalid');
	}
	DisplayErrorMessage()
});


function DisplayErrorMessage()
{
	if(hardwareSubComponent.isMaxValid && hardwareSubComponent.isMinValid){
		window.parent.$('.divMessage').addClass('hide');
		window.parent.$('.clsSubComponentSave').removeClass('hide');
	}
	else{
		window.parent.$('.divMessage').removeClass('hide');
		window.parent.$('.clsSubComponentSave').addClass('hide');
	}
}

function minThresholdValidator(userInput)
{
	if(userInput == undefined)
		userInput=0;
	
	var result =false;
	//var actualValue = (hardwareSubComponent.defaultValue * userInput)/100;
	var actualValue = parseInt(userInput);
	
	//console.log("actualValue : ", actualValue, " hardwareSubComponent.defaultValue : ", hardwareSubComponent.defaultValue," hardwareSubComponent.minValidValue : ",hardwareSubComponent.minValidValue, ' ', (actualValue + parseInt(hardwareSubComponent.defaultValue)) >= parseInt(hardwareSubComponent.minValidValue) );
	if((actualValue + hardwareSubComponent.defaultValue) >= hardwareSubComponent.minValidValue)
		result =  true
	else
		result = false;
	
	//Since are not validating it, we will return true always
	//comment the below line to validate
	result = true
	hardwareSubComponent.isMinValid = result;
	return result;
}

function maxThresholdValidator(userInput)
{
	var result =false;
	//var actualValue = (hardwareSubComponent.defaultValue * userInput)/100;
	var actualValue = parseInt(userInput);
	var value = (actualValue + parseInt(hardwareSubComponent.defaultValue));
	
	// console.log("actualValue : ", actualValue, " value : ", value," hardwareSubComponent.maxValidValue : ",hardwareSubComponent.maxValidValue, ' ', value <= parseInt(hardwareSubComponent.maxValidValue));

	if((actualValue + hardwareSubComponent.defaultValue) <= hardwareSubComponent.maxValidValue)
		result =  true
	else
		result = false;

	//Since are not validating it, we will return true always
	//comment the below line to validate
	result = true
	hardwareSubComponent.isMaxValid = result;
	return result;
}

$('.clsComponent').click(function(){
	selectedComponentCode=this.attributes.dataKey.nodeValue;
	window.parent.GetAllDataBySelectedSection(selectedComponentCode,true,'Hardware');
});

$('.collapse').on('shown.bs.collapse', function() {
	$(".collapsible").find('.arrow').removeClass().addClass('arrow down');
	var id = $(this).attr('id');
	$(".collapsible").each(function(){
		//console.log($(this).attr('aria-controls'),id)
		if($(this).attr('aria-controls')==id)
		{
			if($(this).attr('aria-expanded')=='true')
			{
				$(this).find('.arrow').removeClass('down').addClass('up');
			}
			$('html, body').animate({
				scrollTop: $(this).offset().top
			}, 1000);
		}
	});
});

$('.collapse').on('hidden.bs.collapse', function() {
	$(".collapsible").find('.arrow').removeClass().addClass('arrow down');
});
var $myGroup = $('.main-container');
$myGroup.on('show.bs.collapse','.collapse', function() {
    $myGroup.find('.collapse.in').collapse('hide');
});

var uploadType = "";
function hardwareAdminOperations(tasktype) {
	if(tasktype==="upload-license") {
		uploadType = $(this).attr('uploadtype');
		parent.$('#divResponse_').html('Please choose the licence and click on upload button').removeClass('alert-danger').addClass('alert-success');
		parent.$('#divFileUpload').find('.modal-title').find('strong').html('License Upload');
		openFileUpload("fileUpload.html");
		parent.$('#divFileUpload').find('.modal-footer').hide();
		parent.$('#aDownload').show(); //dont require for both
	}
	else if(tasktype==="upload-certificate")
	{
		uploadType = $(this).attr('uploadtype');
		parent.$('#divResponse_').html('Please choose the certificate and click on upload button').removeClass('alert-danger').addClass('alert-success');
		parent.$('#divFileUpload').find('.modal-title').find('strong').html('Certificate Upload');
		openFileUpload("CertificateUpload.html");
		parent.$('#divFileUpload').find('.modal-footer').hide();
		parent.$('#aDownload').show();
	}
	else if(tasktype==="upload-firmware") {
		uploadType = $(this).attr('uploadtype');
		parent.$('#divResponse_').html('Please choose the package and click on upload button').removeClass('alert-danger').addClass('alert-success');
		parent.$('#divFileUpload').find('.modal-title').find('strong').html('Package Upload');
		openFileUpload("packageUpload.html");
		parent.$('#divFileUpload').find('.modal-footer').hide();
		parent.$('#aDownload').hide();
	}
	else if(tasktype==="reboot" || tasktype==="restart") {
		parent.swal({
			title: "Please enter the password",
			html: true,
			text: "<input type='password' class='form-control' id='confirm-password' placeholder='Password'>",
			showCancelButton: true,
			closeOnConfirm: false,
		  	closeOnCancel: false,
			width: 100,
			animation: "slide-from-top"
		},
			function(isConfirm) {
				if (isConfirm) {
					var password = btoa(parent.$('#confirm-password').val());
					var sessionData =JSON.parse(sessionStorage.getItem("sessionData"));	
					var user_id = sessionData['Userid'];
					var request = new Request();
					request.url = "cgi/cgi_Hardware_Admin.py";
					request.parameters = { "RequestType": tasktype, "userId":user_id, "password":password};
					request.Type = "hardwareAdminOperations";
					CallPythonService(request);
				} else {
				  	parent.swal("Cancelled", "", "error");
				}
		});
	}
}