var userSelectedGroup ={Id:0,Name:''};
var userSelectedGroups=[];
var userSelectedRoles=[];
var allDBGroups = [];
var allDBRoles = [];
var GroupLevels = [];
var orgChartData = {};
var chartConfig = {bShowGroups:true,bShowRoles:true,bShowUsers:true,bExpandAll:false}

function Request() {
    var request = {
        url: "",
        parameters: {},
        Type: ""
    };
    return request;
}
$(function(){
	GetUsers();
	GetRoles();
	GetGroupDetails();
	GetGroupsForEdit();
	GetOrganizationData();
	
	$("#chkGroups").prop("checked", chartConfig.bShowGroups);
	$("#chkRoles").prop("checked", chartConfig.bShowRoles);
	$("#chkUsers").prop("checked", chartConfig.bShowUsers);
	$("#chkExpandAll").prop("checked", chartConfig.bExpandAll);	
});
function CallPythonService(request) {
	request.parameters.uuid=parent.uuid;
    $.ajax({
        type: "Get",
        url: request.url,
        contentType: 'application/json',
        dataType: 'json',
        headers: { 'Access-Control-Allow-Origin': '*' },
        data: request.parameters,
        success: function (response) {
            BindResponseData(request.Type, response);
        },
        error: function (ex) {
            if(!isProduction){
				console.log(ex);
			}
        }
    });
}
function BindResponseData(Type, response) {
    if (Type === "GroupSave") {
        window.parent.notify(response.description,response.description,response.status);
		window.parent.GetAllDataBySelectedSection('OrgGroup',true);
    }   
	else if(Type === 'UserSave')
	{		
		window.parent.notify(response.description,response.description,response.status);
		window.parent.GetAllDataBySelectedSection('OrgUsers',true);
	}
	else if(Type === 'RoleSave')
	{		
		window.parent.notify(response.description,response.description,response.status);
		window.parent.GetAllDataBySelectedSection('OrgRole',true);
	}
	else if(Type === 'ValdateUserName')
	{
		$('#divUserNameMsg').css('display','block');
		if(response.status == 'success')
			$('#lblUserNameMsg').text(response.description).css('color','green');
		else
			$('#lblUserNameMsg').text(response.description).css('color','red');
	}
	else if(Type == 'GetGroupsForOrgChart')
	{
		PrepareOrgChartData(response);
	}
	else if(Type == 'GetOrgData')
	{
		orgChartData=response
	}
	else if(Type === 'GetGroup')
	{
		$("#ddlGroup option").remove();	
		$.each(response, function(i, item) {            
            $('#ddlGroup').append($('<option>', { 
				value: item.id,
				text : item.Name 
			}));
		});
		$("#ddlGroup").val(userSelectedGroup.Id);
	}
	else if(Type == 'GetRolesForEdit')
	{
		$("#ddlRoles option").remove();	
		$("#ddlRoles").append($('<option>', { 
				value: "",
				text : '--Select--' 
			}));
		$.each(response, function(i, item) {            
            $('#ddlRoles').append($('<option>', { 
				value: item.id,
				text : item.name 
			}));
		});
		allDBRoles = response;
	}
	else if(Type == 'GetGroupsForEdit')
	{
		allDBGroups = response;
		$("#ddlGroupEdit option").remove();	
		$("#ddlGroupEdit").append($('<option>', { 
				value: "",
				text : '--Select--' 
			}));
		$.each(response, function(i, item) {            
            $('#ddlGroupEdit').append($('<option>', { 
				value: item.id,
				text : item.name 
			}));
		});
	}
	else if(Type == 'GetUsers')
	{
		$(".clsUsersBind option").remove();
			$(".clsUsersBind").append($('<option>', { 
				value: "",
				text : 'Select User (User name - First Name - Last Name) '
			}));
		$.each(response, function(i, item) {            
            $('.clsUsersBind').append($('<option>', { 
				value: item.id,
				text : item.userName +'-'+ item.FirstName +'-'+ item.LastName
			}));
		});
	}
	else if(Type == 'GetUsersByRole')
	{
		parent.$('#spnHeadertitle').text('User List');
		var table = parent.$('#tblSelectedData').DataTable();
		table.destroy();
		var usersData = `<thead><th>User Name</th><th>First Name</th><th>Last Name</th><th>Email</th></thead><tbody id="tbodySelectedData" ></tbody>`
		parent.$('#tblSelectedData').html(usersData);
		//window.parent
		$.each(response, function (i, item) {
			var rawData = '<tr><td>'+item.userName+'</td><td>'+item.FirstName+'</td><td>'+item.LastName+'</td><td>'+item.userEmail+'</td></tr>';
			parent.$('#tbodySelectedData').append(rawData);
		});
		parent.$('#tblSelectedData').DataTable();
		parent.$('#setUpSelectedPopUp').modal('show');
	}
	else if(Type == 'GetRolesByGroup')
	{
		parent.$('#spnHeadertitle').text('Roles List');
		var table = parent.$('#tblSelectedData').DataTable();
		table.destroy();
		var usersData = `<thead><th>Name</th><th>Description</th></thead><tbody id="tbodySelectedData" ></tbody>`
		parent.$('#tblSelectedData').html(usersData);
		//window.parent
		$.each(response, function (i, item) {
			var rawData = '<tr><td>'+item.name+'</td><td>'+item.description+'</td></tr>';
			parent.$('#tbodySelectedData').append(rawData);
		});
		parent.$('#tblSelectedData').DataTable();
		parent.$('#setUpSelectedPopUp').modal('show');
	}
	else if(Type == 'GetGroupsForOrganize')
	{
		GroupLevels = response.savedLinkGroups;
		
		$('#tbodyOrganize').html('');
		$.each(response.DBGroups, function (i, item) {
			var rawData = '<tr><td>'+item.Name+'</td><td>Reports To</td><td><select class="form-control clsGroupsList clsGroupLinkId" groupId='+item.id+' id="ddlGroup_'+item.id+'" level="-1"></select></td><td id="spnLevel'+item.id+'">'+item.level+'</td><td><a href="javaScript:void(0)" onclick="ViewRoles('+item.id+')">View</td></tr>';
			$('#tbodyOrganize').append(rawData);
		});
		
		$(".clsGroupsList option").remove();
		$('.clsGroupsList').append($('<option>', {
				value: "",
				text : ' -- Select --' 
			}));
		$('.clsGroupsList').append($('<option>', {
				value: "*",
				text : '*' 
			}));
		$.each(response.DBGroups, function(i, item) {            
            $('.clsGroupsList').append($('<option>', { 
				value: item.id,
				text : item.Name 
			}));			
		});
		$(".clsGroupsList").val('');
		
		$.each(response.savedLinkGroups, function(i, item) { 
			 $("#ddlGroup_"+item.groupId).val(item.linkGroupId);
		 });
		//$('#tblOrgGroupOrganize').DataTable();
		
		$('.clsGroupLinkId').bind('change',function(){
			var groupId = this.attributes.groupid.nodeValue;
			var linkedGroupId = this.value;
			//UpdateGroupLevels(groupId,linkedGroupId);
		});
	}
	else if (Type == 'save_GroupOrganize')
	{
		window.parent.notify(response.description,response.description,response.status);
		location.reload();
	}
	else if(Type == 'GetUserDetailsById')
	{
	response=response[0];
	$('#txtUserName').val(response.userName);
	$('#txtMiddleName').val(response.MiddleName);
	$('#txtFirstName').val(response.FirstName);
	$('#txtLastName').val(response.LastName);
	$('#txtContactEmail').val(response.userEmail);
	$('#txtContactPhone').val(response.Phone);
	$('#txtCompanyEmail').val(response.companyEmail);
	$('#txtCompanyPhone').val(response.companyPhone);
	$("#ddlEmploymentStatus").val(response.employmentStatus);
	$('#txtPwd').val(response.password);
	$('#ddlManager').val(response.manager_id);
	
	$('#txtAddress1').val(response.address1);
	$('#txtAddress2').val(response.address2);
	$('#txtCity').val(response.city);
	$('#txtState').val(response.state_providence);
	$("#txtCountry").val(response.country);
	$('#txtPostalCode').val(response.postalcode);
	$('#fileName').html(" - "+response.userName+".png");
	if(response.profilePicPath !=null && response.profilePicPath !== "None")
		$('#imgProfilePic').attr('src',response.profilePicPath);
	else
		$('#imgProfilePic').attr('src',"images/default.png");

	
	$.each(response.userSelectedGroupsRoles, function (i, item) {
		userSelectedGroups.push({"id":item.groupId,"roleId":item.roleId});
		userSelectedRoles.push(item.roleId);
	});	
	
	$('#txtSelectedRoles').val(GetSelectedRoleNames());
	$('#txtSelectedRoles').attr('title',GetSelectedRoleNames());
	
	// $('#txtSelectedGroups').val(GetSelectedGroupNames());
	// $('#txtSelectedGroups').attr('title',GetSelectedGroupNames());
	
	$('#txtSelectedGroups').val(GetSelectedGroupNamesForUser());
	$('#txtSelectedGroups').attr('title',GetSelectedGroupNamesForUser());
	
	
	}
	else if(Type == 'GetGroupByid')
	{
		response=response[0];
		$('#txtGroupName').val(response.name);
		$('#txtGroupDesc').val(response.description);
		
	}
	else if(Type == 'GetRoleById')
	{
		response=response[0];
		$('#txtRoleName').val(response.name);
		$('#txtRoleDesc').val(response.description);
		
		userSelectedGroups = response.selectedGroups;
		$('#txtSelectedGroups').val(GetSelectedGroupNames());
		$('#txtSelectedGroups').attr('title',GetSelectedGroupNames());
	}
	else if(Type == 'DeleteUser')
	{
		window.parent.notify(response.description,response.description,response.status);
		if(response.status == 'success'){
			GetUsers();
			$("#formOrgUsers input").val('');
			$("#formOrgUsers img").val('');
			$("#formOrgUsers input").attr('placeholder','');
		}
		document.location.href = document.location.href;
		window.parent.GetAllDataBySelectedSection('OrgUsers',true);
	} 
	else if(Type == 'DeleteGroup')
	{
		window.parent.notify(response.description,response.description,response.status);	
		if(response.status == 'success'){
			GetGroupsForEdit();
			$("#formOrgGroup input").val('');
			$("#formOrgGroup textarea").val('');
		}		
		window.parent.GetAllDataBySelectedSection('OrgGroup',true);
	}
	else if(Type == 'DeleteRole')
	{
		window.parent.notify(response.description,response.description,response.status);	
		if(response.status == 'success'){				
			location.reload();
		}
		window.parent.GetAllDataBySelectedSection('OrgRole',true);
	}
	else if(Type == 'GetGroupsForMapping')
	{
		allDBGroups = response;
		parent.$('#lblPopTitle').html('Groups List');
		var table = parent.$('#tblOrgGroups').DataTable();
		table.destroy();
		var groupsData = `<thead><th>#</th><th>Group Name</th><th>Description</th><th>Status</th></thead><tbody id="tbodyGroupsData" ></tbody>`
		parent.$('#tblOrgGroups').html(groupsData);
		$.each(response, function (i, item) {
			var selectedStatus = userSelectedGroups.indexOf(item.id) !=-1 ? 'checked':'';
			var mappedStatus = userSelectedGroups.indexOf(item.id) !=-1 ? 'Selected':'';
			var rowData = '<tr><td><input type="checkbox" value="'+ item.id+'" class="clsOrgGroups" name="clsOrgGroups" '+selectedStatus+'/></td><td>'+item.name+'</td><td>'+item.description+'</td><td>'+mappedStatus+'</td></tr>';
			parent.$('#tbodyGroupsData').append(rowData);
		});
		parent.$('.clsOrgGroups').bind('change',function(){
			if(this.checked){
				userSelectedGroups.push(parseInt(this.value));
			}
			else
			{
				var valuesToRemove = [parseInt(this.value)]
				userSelectedGroups = userSelectedGroups.filter(item => !valuesToRemove.includes(item))
			}
			
			$('#txtSelectedGroups').val(GetSelectedGroupNames());
			$('#txtSelectedGroups').attr('title',GetSelectedGroupNames());
		});
		parent.$('#tblOrgGroups').DataTable();
		
		parent.$('#orgSetupGroupsPopup').modal('show');
	}
	else if(Type == 'GetManagerRoles')
	{
		var userInfo = response[0].userSelectedGroupsRoles;
		parent.$('#lblPopTitle').html('Roles List');
		var table = parent.$('#tblOrgGroups').DataTable();
		table.destroy();
		var groupsData = `<thead><th>Role Name</th><th>Group Name</th><th>Description</th></thead><tbody id="tbodyGroupsData" ></tbody>`
		parent.$('#tblOrgGroups').html(groupsData);
		$.each(userInfo, function (i, item) {
			var groupDetails = GetGroupDetailsById(item.groupId);
			var roleDetails = GetRoleDetailsById(item.roleId);
			var rowData = '<tr><td>'+roleDetails.name+'</td><td>'+groupDetails.name+'</td><td>'+roleDetails.description+'</td></tr>';
			parent.$('#tbodyGroupsData').append(rowData);
		});
		
		parent.$('#tblOrgGroups').DataTable();		
		parent.$('#orgSetupGroupsPopup').modal('show');
	}
	else if(Type == 'GetGroupsForMappingForUser')
	{
		allDBGroups = response;
		parent.$('#lblPopTitle').html('Groups List');
		var table = parent.$('#tblOrgGroups').DataTable();
		table.destroy();
		var groupsData = `<thead><th>#</th><th>Group Name</th><th>Role Name</th><th>Description</th><th>Status</th></thead><tbody id="tbodyGroupsData" ></tbody>`
		parent.$('#tblOrgGroups').html(groupsData);
		parent.$('#chkAll').bind('change',function(){
			if(this.checked)
				parent.$('.clsOrgGroups').prop('checked',true);
			else
				parent.$('.clsOrgGroups').prop('checked',false)
		});
		$.each(response, function (i, item) {
			var obj = userSelectedGroups.filter(function(filterItem){
				return (filterItem.id == item.id) && (item.roleId == filterItem.roleId);
			});
			var selectedStatus = obj.length>0 ? 'checked':'';
			var mappedStatus = obj.length>0 ? 'Selected':'';
			var rowData = '<tr><td><input type="checkbox" value="'+ item.id+'" roleId="'+item.roleId+'" class="clsOrgGroups" name="clsOrgGroups" '+selectedStatus+'/></td><td>'+item.name+'</td><td>'+item.roleName+'</td><td>'+item.description+'</td><td>'+mappedStatus+'</td></tr>';
			parent.$('#tbodyGroupsData').append(rowData);
		});
		parent.$('.clsOrgGroups').bind('change',function(){
			if(this.checked){
				userSelectedGroups.push({"id":parseInt(this.value),"roleId":parseInt(this.attributes.roleId.nodeValue)});
			}
			else
			{
				var valuesToRemove = [{"id":parseInt(this.value),"roleId":this.attributes.roleId.nodeValue}]
				userSelectedGroups = userSelectedGroups.filter(item => valuesToRemove.indexOf(item) !=-1);				
			}		
			$('#txtSelectedGroups').val(GetSelectedGroupNamesForUser());
			$('#txtSelectedGroups').attr('title',GetSelectedGroupNamesForUser());
		});
		parent.$('#tblOrgGroups').DataTable();
		
		parent.$('#orgSetupGroupsPopup').modal('show');
	}
	else if(Type == 'GetRolesForMapping')
	{
		allDBRoles = response;
		parent.$('#lblPopTitle').html('Roles List');
		var table = parent.$('#tblOrgGroups').DataTable();
		table.destroy();
		var groupsData = `<thead><th>#</th><th>Role Name</th><th>Description</th><th>Status</th></thead><tbody id="tbodyGroupsData" ></tbody>`
		parent.$('#tblOrgGroups').html(groupsData);
		$.each(response, function (i, item) {
			var selectedStatus = userSelectedRoles.indexOf(item.id) !=-1 ? 'checked':'';
			var mappedStatus = userSelectedRoles.indexOf(item.id) !=-1 ? 'Selected':'';
			var rowData = '<tr><td><input type="checkbox" value="'+ item.id+'" class="clsOrgGroups" name="clsOrgGroups" '+selectedStatus+'/></td><td>'+item.name+'</td><td>'+item.description+'</td><td>'+mappedStatus+'</td></tr>';
			parent.$('#tbodyGroupsData').append(rowData);
		});
		parent.$('.clsOrgGroups').bind('change',function(){
			if(this.checked){
				userSelectedRoles.push(parseInt(this.value));
			}
			else
			{
				var valuesToRemove = [parseInt(this.value)]
				userSelectedRoles = userSelectedRoles.filter(item => !valuesToRemove.includes(item))
			}
			
			$('#txtSelectedRoles').val(GetSelectedRoleNames());
			$('#txtSelectedRoles').attr('title',GetSelectedRoleNames());
			GetSelectedGroupNamesForUser();
		});
		parent.$('#tblOrgGroups').DataTable();
		
		parent.$('#orgSetupGroupsPopup').modal('show');
	}	
}


function GetSelectedGroupNames()
{	
	var groupNames = [];
	var allSelectedGroups = jQuery.grep(allDBGroups, function(n, i) {
			return (userSelectedGroups.indexOf(n.id) != -1);
		});
	$.each(allSelectedGroups,function(i,item){
		groupNames.push(item.name);
	});
	return groupNames.toString();
}

function GetSelectedGroupNamesForUser()
{	
	var groupNames = [];	
	
	$.each(userSelectedGroups,function(i,item){
		if(userSelectedRoles.indexOf(item.roleId) > -1)
		{
			groupNames.push(GetRoleDetailsById(item.roleId).name+"@"+GetGroupDetailsById(item.id).name);
		}
	});
	$('#txtSelectedGroups').val(groupNames.toString());
	$('#txtSelectedGroups').attr('title',groupNames.toString());
	return groupNames.toString();
}

function GetSelectedRoleNames()
{
	var roleNames = [];
	var allSelectedRoles = jQuery.grep(allDBRoles, function(n, i) {
			return (userSelectedRoles.indexOf(n.id) != -1);
		});
	$.each(allSelectedRoles,function(i,item){
		roleNames.push(item.name);
	});
	return roleNames.toString();
}

function SaveGroupDetails()
{
    var isFormValid = $("#formOrgGroup").validationEngine('validate');
    if (isFormValid) {
        var request = new Request();
        request.url = "cgi/cgi_Organization_Manager.py";
        request.parameters = { "RequestType": 'create_Group',"groupName": $('#txtGroupName').val(), "groupDescription": $('#txtGroupDesc').val(),"groupId":$('#ddlGroupEdit').val() !=undefined ?$('#ddlGroupEdit').val():0 };
        request.Type = "GroupSave";
        CallPythonService(request);
    }
}
function GetGroupDetails()
{		
		var request = new Request();
        request.url = "cgi/cgi_Organization_Manager.py";
        request.parameters = {"RequestType": 'read_Group', "groupId": 0 };
        request.Type = "GetGroup";
        CallPythonService(request);
}
function GetGroupsForEdit()
{
	var request = new Request();
	request.url = "cgi/cgi_Organization_Manager.py";
	request.parameters = {"RequestType": 'read_Group', "groupId": 0 };
	request.Type = "GetGroupsForEdit";
	CallPythonService(request);		
}
function GetGroupsDetailsById(groupId)
{
		var request = new Request();
        request.url = "cgi/cgi_Organization_Manager.py";
        request.parameters = {"RequestType": 'read_Group',"groupId": groupId };
        request.Type = "GetGroupByid";
        CallPythonService(request);
}
$('#txtUserName').blur(function(){
	var userName = $('#txtUserName').val()
	if(userName !='' && userName.indexOf(' ') == -1){
		var request = new Request();
        request.url = "cgi/cgi_Organization_Manager.py";
        request.parameters = {"RequestType": 'validate_User',"userName": userName};
        request.Type = "ValdateUserName";
        CallPythonService(request);
	}
});
$('#ddlUser').change(function(){
	if($('#ddlUser').val() !=0)
		GetUserDetailsById($('#ddlUser').val());
	userSelectedGroups = [];
});
$('#ddlGroupEdit').change(function(){
	if($(this).val() !=0)
		GetGroupsDetailsById($(this).val());	
});
$('#ddlGroup').change(function(){
	$('#txtGroupName').val($("#ddlGroup option:selected").text());
});
function SaveUserDetails()
{
	var isFormValid = $("#formOrgUsers").validationEngine('validate');

    if (isFormValid) {
		$('#loading').css('display','block');

		var SelectedRoles = [];
		var SelectedGroups = [];
		
		$.each(userSelectedGroups,function(i,item){
			if(userSelectedRoles.indexOf(item.roleId) > -1)
			{
				SelectedRoles.push(item.roleId);
				SelectedGroups.push(item.id);
			}			
		});		
		
		var data = new FormData();
		jQuery.each(jQuery('#fileUpload')[0].files, function(i, file) {
			data.append('file-'+i, file);
		});
		var username = $('#txtUserName').val().toLowerCase().trim();
		data.append('userName', username);

		var request = new Request();
		request.url = "cgi/cgi_Organization_Manager.py";
		request.parameters = { "RequestType": 'create_User',"userName":username,
		"firstName": $('#txtFirstName').val() , "middleName": $('#txtMiddleName').val(),"lastName": $('#txtLastName').val(),
		"contactEmail": $('#txtContactEmail').val(), "contactPhone": $('#txtContactPhone').val(),
		"companyEmail": $('#txtCompanyEmail').val(), "companyPhone": $('#txtCompanyPhone').val(),		 
		"employmentStatus":$('#ddlEmploymentStatus').val(),"password": $('#txtPwd').val(), "selectedRoles": SelectedRoles.toString(),
		"selectedGroups":SelectedGroups.toString(), "managerId":$('#ddlManager').val(),"imgPath":"None",
		"address1":$('#txtAddress1').val(),"address2":$('#txtAddress2').val(),"city":$('#txtCity').val(),"state":$('#txtState').val(),
		"country":$('#txtCountry').val(),"postalCode":$('#txtPostalCode').val(),
		"userId":$('#ddlUser').val() !=undefined ?$('#ddlUser').val():0 };
		request.Type = "UserSave";

		if(jQuery('#fileUpload')[0].files.length > 0)
		{
			jQuery.ajax({ //first upload image and get the path
				url: 'cgi/UploadPic.py',
				data: data,
				cache: false,
				contentType: false,
				processData: false,
				method: 'POST',
				type: 'POST', // For jQuery < 1.9
				dataType: 'json',
				success: function(response){
					if(response.status == "success")
					{	
						$('#loading').css("display", "none");
						request.parameters.imgPath = response.id;
						if(SelectedRoles !="")
							CallPythonService(request);
						else
							OrgUsersConfirmation(request);
					}
					else{
						window.parent.notify(response.description,response.description,response.status)
					}
				},
				error: function (ex) {
					var mssg = "error occured while saving image";
					window.parent.notify(mssg, mssg, 'fail');
				}
			});
		}
		else{
			$('#loading').css("display", "none");
			if(SelectedRoles !="")
				CallPythonService(request);
			else
				OrgUsersConfirmation(request);
		}
    }
}
function OrgUsersConfirmation(request)
{	
	parent.swal({
		title: "Confirmation",
		text: "You haven't selected any Organization groups, Are you sure want to continue...",			
		showCancelButton: true,
		closeOnConfirm: true,
		confirmButtonText:"Continue"
	}, function() {
		CallPythonService(request);
	});
}
function GetUsers()
{
		var request = new Request();
        request.url = "cgi/cgi_Organization_Manager.py";
        request.parameters = {"RequestType": 'read_User',"userId": 0};
        request.Type = "GetUsers";
        CallPythonService(request);
}
function ViewUsers(roleId)
{
		var request = new Request();
        request.url = "cgi/cgi_Organization_Manager.py";
        request.parameters = {"RequestType": 'read_UsersByRole',"roleId": roleId};
        request.Type = "GetUsersByRole";
        CallPythonService(request);
}
function ViewRoles(groupId)
{
		var request = new Request();
        request.url = "cgi/cgi_Organization_Manager.py";
        request.parameters = {"RequestType": 'read_RolesByGroup',"groupId": groupId};
        request.Type = "GetRolesByGroup";
        CallPythonService(request);
}
function GetUserDetailsById(userId)
{
		var request = new Request();
        request.url = "cgi/cgi_Organization_Manager.py";
        request.parameters = {"RequestType": 'read_User',"userId": userId};
        request.Type = "GetUserDetailsById";
        CallPythonService(request);
}
function DeleteUser()
{
	var isFormValid = $("#formOrgUsers").validationEngine('validate');
    if (isFormValid) {
		var request = new Request();
        request.url = "cgi/cgi_Organization_Manager.py";
        request.parameters = {"RequestType": 'delete_User',"userId": $('#ddlUser').val()	};
        request.Type = "DeleteUser";
        CallPythonService(request);
	}
}
function DeleteGroup()
{
	var isFormValid = $("#formOrgGroup").validationEngine('validate');
    if (isFormValid) {
		var request = new Request();
        request.url = "cgi/cgi_Organization_Manager.py";
        request.parameters = {"groupId":$('#ddlGroupEdit').val(),"RequestType": 'delete_Group'	};
        request.Type = "DeleteGroup";
        CallPythonService(request);
	}
}
function GetGroupsForMapping()
{
	var request = new Request();
	request.url = "cgi/cgi_Organization_Manager.py";
	request.parameters = {"RequestType": 'read_Group', "groupId": 0 };
	request.Type = "GetGroupsForMapping";
	CallPythonService(request);
}
function GetRolesForMapping()
{
	var request = new Request();
	request.url = "cgi/cgi_Organization_Manager.py";
	request.parameters = {"RequestType": 'read_Role', "roleId": 0 };
	request.Type = "GetRolesForMapping";
	CallPythonService(request);
}
function SaveRoleDetails()
{
    var isFormValid = $("#formOrgRole").validationEngine('validate');
    if (isFormValid) {
        var request = new Request();
        request.url = "cgi/cgi_Organization_Manager.py";
        request.parameters = { "RequestType": 'create_Role',"roleName": $('#txtRoleName').val(), "roleDescription": $('#txtRoleDesc').val(),"selectedGroups":userSelectedGroups.toString(),"roleId":$('#ddlRoles').val() !=undefined ?$('#ddlRoles').val():0 };
        request.Type = "RoleSave";
        CallPythonService(request);
    }
}
function DeleteRole()
{
	var request = new Request();
	request.url = "cgi/cgi_Organization_Manager.py";
	request.parameters = {"RequestType": 'delete_Role', "roleId": $('#ddlRoles').val() };
	request.Type = "DeleteRole";
	CallPythonService(request);
}
function GetOrgGroupOrganize()
{
	var request = new Request();
	request.url = "cgi/cgi_Organization_Manager.py";
	request.parameters = {"RequestType": 'read_GroupOrganize'};
	request.Type = "GetGroupsForOrganize";
	CallPythonService(request);
}
function SaveOrgGroupOrganize()
{
	if(!GetGorupLevels())
		return false;
	
	var groupsIds = [];
	var linkGroupIds = [];
	var levels = [];
	$( ".clsGroupLinkId" ).each(function( i ) { 
		groupsIds.push(this.attributes.groupid.nodeValue);
		linkGroupIds.push(this.value);
		if(this.attributes.level.nodeValue == -1)
		{
			alert('Invalid Selections,Circular mapping not allowed. Please verify hierarchy')
			return false;
		}
		else
			levels.push(this.attributes.level.nodeValue);
	});
	
	var request = new Request();
	request.url = "cgi/cgi_Organization_Manager.py";
	request.parameters = {"RequestType": 'create_GroupOrganize', "groupsIds": groupsIds.toString(),"linkGroupIds":linkGroupIds.toString(),"groupLevels" :levels.toString()};
	request.Type = "save_GroupOrganize";
	CallPythonService(request);
}
function GetRoles()
{
	var request = new Request();
	request.url = "cgi/cgi_Organization_Manager.py";
	request.parameters = {"RequestType": 'read_Role',"roleId": 0};
	request.Type = "GetRolesForEdit";
	CallPythonService(request);	
}
$('#ddlRoles').change(function(){
	var request = new Request();
	request.url = "cgi/cgi_Organization_Manager.py";
	request.parameters = {"RequestType": 'read_Role',"roleId": $(this).val()};
	request.Type = "GetRoleById";
	CallPythonService(request);	
});

function UpdateGroupLevels(groupId,linkedGroupId)
{
	var selectedGroupLevels = []
	var group={};	
	$(".clsGroupLinkId" ).each(function( i ) {    
		group = {"groupId":this.attributes.groupid.nodeValue,"linkGroupId":this.value,"level":-1};
		selectedGroupLevels.push(group);
	});
	$('#spnLevel'+groupId).html(groupId);
	GroupLevels;
}
function GetGorupLevels()
{
	currentLevel = -1;
	var selectedGroupLevels = []
	var group={};	
	$(".clsGroupLinkId" ).each(function( i ) {    
		group = {"groupId":this.attributes.groupid.nodeValue,"linkGroupId":this.value,"level":-1};
		selectedGroupLevels.push(group);
	});
	
	var emptyCheck = selectedGroupLevels.filter(function(item) {
	  return item.linkGroupId == '';
	});
	if(emptyCheck.length>0)
	{
		alert('Please select reporting group for all groups');
		return false;
	}
	
	var sameGroup = selectedGroupLevels.filter(function(item) {
	  return item.linkGroupId == item.groupId;
	});
	if(sameGroup.length>0)
	{
		alert('Group and reporting group should not be same');
		return false;
	}
	
	var topLevel = selectedGroupLevels.filter(function(item) {
	  return item.linkGroupId == '*';
	});
	if(topLevel.length == 0){
		alert('Please select top level group');
		return false;
	}
	else if(topLevel.length >1)
	{
		alert('Please select only one top level group');
		return false;
	}
	else if(topLevel.length == 1)
	{
		topLevel[0].level = 0;
		currentLevel = 0;
		
		$('#ddlGroup_'+topLevel[0].groupId).attr('level',currentLevel);
		$('#spnLevel6'+topLevel[0].groupId).html(currentLevel);
	}
	
	SetGroupLevel(selectedGroupLevels,topLevel[0].groupId,0);
	return true;
}
function SetGroupLevel(selectedGroupLevels,currentLevelGroupId,currentLevel)
{
	var nextReportingLevel = selectedGroupLevels.filter(function(item) {
	  return item.linkGroupId == currentLevelGroupId;
	});
	
	$.each(nextReportingLevel,function(i,item){
		item.level = currentLevel+1;
		$('#ddlGroup_'+item.groupId).attr('level',item.level);
		$('#spnLevel6'+item.groupId).html(item.level);
		SetGroupLevel(selectedGroupLevels,item.groupId,item.level)
	});
}
function GetGroupsForMappingByRoles()
{	
		if(userSelectedRoles.toString() == '')
		{
			alert('Please Select Roles')
			return false;
		}			
		
		var request = new Request();
        request.url = "cgi/cgi_Organization_Manager.py";
        request.parameters = {"RequestType": 'read_GroupsByRoles',"roleIds": userSelectedRoles.toString()};
        request.Type = "GetGroupsForMappingForUser";
        CallPythonService(request);
}
function GetManagerRoles()
{
	var userId = $('#ddlManager').val();
	var request = new Request();
	request.url = "cgi/cgi_Organization_Manager.py";
	request.parameters = {"RequestType": 'read_User',"userId":userId};
	request.Type = "GetManagerRoles";
	CallPythonService(request);
}
function GetOrgChart()
{
	var request = new Request();
	request.url = "cgi/cgi_Organization_Manager.py";
	request.parameters = {"RequestType": 'read_GroupOrganize'};
	request.Type = "GetGroupsForOrgChart";
	CallPythonService(request);
}

function GetOrganizationData()
{
	var request = new Request();
	request.url = "cgi/cgi_Organization_Manager.py";
	request.parameters = {"RequestType": 'read_GroupOrganize'};
	request.Type = "GetOrgData";
	CallPythonService(request);
}


function PrepareOrgChartData(groupsData)
{
	orgChartData = groupsData;
	allDBGroups =  groupsData.DBGroups;
	var topLevelGroup = groupsData.savedLinkGroups.filter(function(item) {
	  return item.linkGroupId == '*';
	});
	var groupDetails = GetGroupDetailsById(topLevelGroup[0].groupId)
	
	var jsonChart = {
						text:{
							name: "Group: "+groupDetails.Name,
							title: groupDetails.Description
						},
						stackChildren: true,
						//image: "./profilePics/9.jpg",
						children:GetHierarchyData(topLevelGroup[0],groupsData.savedLinkGroups)
                    }
					
	
	var chart_config = {
        chart: {
            container: "#basic-example",
            
            connectors: {
                type: 'step',
				// style: {
						// 'stroke': '#8080FF',
						// 'arrow-end': 'block-wide-long'
					// }
            },
			node: {
                
				HTMLclass: 'nodeExample1'
            },
            animation: {
                nodeAnimation: "easeOutBounce",
                nodeSpeed: 700,
                connectorsAnimation: "bounce",
                connectorsSpeed: 700
            }
        },
		nodeStructure: jsonChart
	}
	new Treant( chart_config );
	$('.collapse-switch').html('View');
	$('.collapse-switch').attr('title','View Roles and Users');
	$('.collapse-switch').click(function(){
		if($(this).html() == 'Hide')
			$(this).html('View');
		else
			$(this).html('Hide');
	});
}
function GetHierarchyData(nodeData,savedLinks)
{
	var childrenNodes = [];
	//var items =[]
	var allMyChilds = savedLinks.filter(function(item){
		return item.linkGroupId ==nodeData.groupId && item.level == nodeData.level+1;
	});
	var allMyChildRoles = orgChartData.savedRoleLinks.filter(function(item){
		return item.groupId ==nodeData.groupId;
	});
	
	
	// $.each(allMyChilds,function(i,item){
		// items.push({"id":item.groupId,"type":item.type});
	// });
	
	// $.each(allMyChildRoles,function(i,item){
		// items.push({"id":item.roleId,"type":item.type});
	// });
	
	//allMyChilds.concat(allMyChildRoles);
	//allMyChilds.push(allMyChildRoles);
	
	if(chartConfig.bShowGroups)
	{
		$.each(allMyChilds,function(i,item){
			var groupDetails = GetGroupDetailsById(item.groupId);
			var isCollapsed =chartConfig.bExpandAll ? false : GetHierarchyData(item,savedLinks).length > 0;
			childrenNodes.push({
							text:{
								name: "Group: " +groupDetails.Name,
								title: groupDetails.Description,
								contact:' '							
							},	
							stackChildren: true,							
								collapsed: isCollapsed,
							//image: "./profilePics/"+(nodeData.level+1)+".jpg",
							children:GetHierarchyData(item,savedLinks),
						});
		});
	}
	if(chartConfig.bShowRoles)
	{
		$.each(allMyChildRoles,function(i,item){
			var roleDetails = GetRoleDetailsById(item.roleId);
			var isCollapsed1 = chartConfig.bExpandAll ? false : GetChildUsers(item.roleId,nodeData.groupId).length > 0;
			childrenNodes.push({
							text:{
								name: "Role: " + roleDetails.name,
								title: roleDetails.description,
								contact:' '							
							},
							stackChildren: true,
							collapsed: isCollapsed1,						
							//image: "./profilePics/"+1+".jpg",
							children:GetChildUsers(item.roleId,nodeData.groupId)
						});
		});	
	}
	return childrenNodes;
}

function GetChildUsers(roleId,groupId)
{
	var users = orgChartData.savedUserLinks.filter(function(item) {
	  return item.roleId == roleId && item.groupId == groupId;
	});
	childrenNodes= [];
	
	if(!chartConfig.bShowUsers)
		return childrenNodes;
	
	$.each(users,function(i,item){
		var userDetails = GetuserDetailsById(item.userId);
		childrenNodes.push({
						text:{
							name: "User: " + userDetails.FirstName,
							title: "user Name: "+userDetails.userName,
							contact:' '							
						},
						//image: "./profilePics/"+1+".jpg",
						//children:GetChildUsers(item.roleId,nodeData.groupId)
                    });
	});
	return childrenNodes
}

function GetuserDetailsById(userId)
{
	var users = orgChartData.DBUsers.filter(function(item) {
	  return item.id == userId;
	});
	return users[0];
}
function GetGroupDetailsById(groupId)
{
	var groups = allDBGroups.filter(function(item) {
	  return item.id == groupId;
	});
	return groups[0];
}

function GetRoleDetailsById(roleId)
{
	var roles = orgChartData.DBRoles.filter(function(item) {
	  return item.id == roleId;
	});
	return roles[0];
}
// $("#fileUpload").on('change',function(){
    // alert(this.files[0].name);
// });

function SetImagePath(input)
{
	$('#imgProfilePic').attr('src','images/default.png');
	//console.log($('#fileUpload')[0].files[0].name);
	$('#fileName').html(" - " + trimString($('#fileUpload')[0].files[0].name,15));
	if (input.files && input.files[0]) {
            var reader = new FileReader();

            reader.onload = function (e) {
                $('#imgProfilePic')
                    .attr('src', e.target.result);
				
            };

            reader.readAsDataURL(input.files[0]);
        }
		//alert($('#fileUpload').val());
	//$('#imgProfilePic').attr('src',path);
}
function trimString(valueString, lengthValue) {
    var len = String(valueString).trim().length;
    var newValueString = valueString;
    if (len > lengthValue) {
        newValueString = String(valueString).substr(0, lengthValue) + '...';
    }
    return newValueString;
}
$('.clsChartConfig').change(function(){
	chartConfig.bShowGroups = $('#chkGroups').is(':checked');
	chartConfig.bShowRoles = $('#chkRoles').is(':checked');
	chartConfig.bShowUsers = $('#chkUsers').is(':checked');
	chartConfig.bExpandAll = $('#chkExpandAll').is(':checked');
});