var portConfig = { currentTab: "" };
$('[data-toggle="tooltip"]').tooltip();
//OpenTab('MgtPort');
OpenTab('LanPort');
function Request() {
    var request = {
        url: "",
        parameters: {},
        PortType: "",
        Type:"",
		isShowSavedStatus:true
    };
    return request;
}
function CallPythonService(request) {
	request.parameters.uuid=parent.uuid;
    $.ajax({
        type: "Get",
        url: request.url,
        contentType: 'application/json',
        dataType: 'json',
        headers: { 'Access-Control-Allow-Origin': '*' },
        data: request.parameters,
        success: function (response) {
            BindResponseData(request.PortType,request.Type, response,request);
        },
        error: function (ex) {
            if(!isProduction){
				console.log(ex);
			}
        }
    });
}
function OpenLanTab(tab,portNum){
	$('.LanImgHideShow').addClass('hide');
	$('.LanDivHideShow').addClass('hide');
	$('#imgLanPort'+portNum).removeClass('hide');
	$('#tabl_lan'+portNum).removeClass('hide');	
}
function OpenTab(TabName)
{
    var request = new Request();
    if(TabName === 'MgtPort')
    {
        request.url = "cgi/cgi_EthernetPorts_Manager.py";
        request.PortType = TabName;
        portConfig.currentTab = TabName;
        request.Type = "get";
		request.parameters = {"requestType":"read_mgt"}
    }
    else if(TabName === 'LanPort')
    {
        request.url = "cgi/cgi_EthernetPorts_Manager.py";
        request.PortType = TabName;
        portConfig.currentTab = TabName;
        request.Type = "get";
		request.parameters = {"requestType":"read_lan"}
    }
    else if (TabName === 'WanPort')
    {
        request.url = "cgi/cgi_EthernetPorts_Manager.py";
        request.PortType = TabName;
        portConfig.currentTab = TabName;
        request.Type = "get";
		request.parameters = {"requestType":"read_wan"}
    }
    else if (TabName === 'BmcPort') {
        request.url = "cgi/cgi_EthernetPorts_Manager.py";
        request.PortType = TabName;
        portConfig.currentTab = TabName;
        request.Type = "get";
		request.parameters = {"requestType":"read_adm"}
    }
    CallPythonService(request);
}
function BindResponseData(TabName,RequestType, response,request) {
	if(!request.isShowSavedStatus)
		return;
    if (TabName === 'MgtPort' && RequestType === 'get')
    {       
        $('#txtIpAddress_mgt').val(response.ip_address);
        console.log(response.ip_address);
        $('#ipmiconsole').click(function() {
            window.open("http://"+response.ipmi_ip_address, '_blank').focus();
        });
	$('#ipmiconsole').attr('data-original-title',response.ip_address);
        $('#txtSubNetMask_mgt').val(response.subnet);
        $('#txtDefaultGateway_mgt').val(response.default_gateway_ip);
        $('#txtDnsServer_mgt').val(response.dns_server);
        $('#txtMtuSize_mgt').val(response.mtu_size);
        $('#txtMtuSize_mgt').attr('disabled','disabled');
        response.dhcp_enabled.toLowerCase() === 'yes' ? $('#mgtRadiobtn_yes').prop('checked', true) : $('#mgtRadiobtn_no').prop('checked', true);
        if (response.dhcp_enabled.toLowerCase() === 'yes') {
            $('#txtIpAddress_mgt').attr('disabled','disabled');
            $('#txtSubNetMask_mgt').attr('disabled','disabled');
        }
        else {
            $('#txtIpAddress_mgt').attr('disabled',false);
            $('#txtSubNetMask_mgt').attr('disabled',false);
        }
    }
    else if (RequestType === 'save')//(TabName === 'MgtPort' && RequestType === 'save')
    {   
        OpenTab(TabName);
		window.parent.notify(response.description,response.description,response.status);
		window.parent.GetAllDataBySelectedSection('PortGroups');
    }
    else if(TabName === 'LanPort' && RequestType === 'get')
    {
		for(var i=0;i<response.length;i++){
			$('#txtIpAddress_lan'+(i+1)).val(response[i].ip_address);
			$('#txtSubNetMask_lan'+(i+1)).val(response[i].subnet);
            $('#txtMtuSize_lan'+(i+1)).val(response[i].mtu_size);
            $('#txtMtuSize_lan'+(i+1)).attr('disabled','disabled');
			$('#txtDefaultGateway_lan'+(i+1)).val(response[i].default_gateway_ip);
            $('#txtDnsServer_lan'+(i+1)).val(response[i].dns_server);

			response[i].port_enabled.toLowerCase() === 'yes' ? $('#lanRadiobtnPort_yes'+(i+1)).prop('checked', true) : $('#lanRadiobtnPort_no'+(i+1)).prop('checked', true);
			response[i].dhcp_enabled.toLowerCase() === 'yes' ? $('#lanRadiobtnDHCP_yes'+(i+1)).prop('checked', true) : $('#lanRadiobtnDHCP_no'+(i+1)).prop('checked', true);
            if (response[i].dhcp_enabled.toLowerCase() === 'yes') {
                $('#txtIpAddress_lan'+(i+1)).attr('disabled','disabled');
                $('#txtSubNetMask_lan'+(i+1)).attr('disabled','disabled');
            }
            else {
                $('#txtIpAddress_lan'+(i+1)).attr('disabled',false);
                $('#txtSubNetMask_lan'+(i+1)).attr('disabled',false);
            }
        }
	}
    else if (TabName === 'WanPort' && RequestType === 'get') {
        $('#txtIpAddress_wan').val(response.ip_address);
        $('#txtSubNetMask_wan').val(response.subnet);
        $('#txtMtuSize_wan').val(response.mtu_size);
        response.port_enabled.toLowerCase() === 'yes' ? $('#wanRadiobtnPort_yes').prop('checked', true) : $('#wanRadiobtnPort_no').prop('checked', true);
        response.dhcp_enabled.toLowerCase() === 'yes' ? $('#wanRadiobtnDHCP_yes').prop('checked', true) : $('#wanRadiobtnDHCP_no').prop('checked', true);
    }
    else if (TabName === 'BmcPort' && RequestType === 'get') {
        $('#txtIpAddress_bmc').val(response.ip_address);
        $('#txtSubNetMask_bmc').val(response.subnet);
        $('#txtMtuSize_bmc').val(response.mtu_size);
        response.port_enabled.toLowerCase() === 'yes' ? $('#bmcRadiobtnPort_yes').prop('checked', true) : $('#bmcRadiobtnPort_no').prop('checked', true);
        response.dhcp_enabled.toLowerCase() === 'yes' ? $('#bmcRadiobtnDHCP_yes').prop('checked', true) : $('#bmcRadiobtnDHCP_no').prop('checked', true);
    }
	
}
function ShowConfirmation()
{
    var isFormValid = false;
    if (portConfig.currentTab === 'MgtPort')
        isFormValid = $("#formMgtPort").validationEngine('validate');
    else if (portConfig.currentTab === 'LanPort')
        isFormValid = $("#formLanPort").validationEngine('validate');
    else if (portConfig.currentTab === 'WanPort')
        isFormValid = $("#formWanPort").validationEngine('validate');
    else if (portConfig.currentTab === 'BmcPort')
        isFormValid = $("#formBmcPort").validationEngine('validate');
    if (isFormValid)
        $("#PopUpConfirm").modal('show');
}

function SavePortConfiguration() {
   
    var request = new Request();
    if (portConfig.currentTab === 'MgtPort') {
        var isFormValid = $("#formMgtPort").validationEngine('validate');
        if (isFormValid) {
            request.url = "cgi/cgi_EthernetPorts_Manager.py";
            request.parameters = {"requestType":"update_mgt", "netmask": $('#txtSubNetMask_mgt').val(), "gateway": $('#txtDefaultGateway_mgt').val(), "dns": $('#txtDnsServer_mgt').val(), "dhcp_enabled": $(".mgtRadiobtn_mgtCls:checked").val(), "ip_address": $('#txtIpAddress_mgt').val(),  "mtu_size":$('#txtMtuSize_mgt').val() };
            request.PortType = portConfig.currentTab;
            request.Type = "save";
            CallPythonService(request);
        }
    }
    else if (portConfig.currentTab === 'LanPort')
    {
        var isFormValid = $("#formLanPort").validationEngine('validate');
        var all_lans = $('.LanImgHideShow');
        var selected_lan = 'null';
        console.log("all_lans: ", all_lans)
        for(let i = 0; i<all_lans.length ; i++) {
            element = all_lans[i];
            if(!$(element).hasClass("hide")) {
                selected_lan  = $(element).attr('alt');
            }
        }
        if (isFormValid) {
            if(selected_lan == "Lanport 1") {
                request.url = "cgi/cgi_EthernetPorts_Manager.py";
                request.parameters = {"requestType":"update_lan", "name":'LAN1',"netmask": $('#txtSubNetMask_lan1').val(), "port_enabled": $('input[name=EnablePort_lan1]:checked').val(), "gateway": $('#txtDefaultGateway_lan1').val(), "dns": $('#txtDnsServer_lan1').val(), "dhcp_enabled": $('input[name=EnableDHCP_lan1]:checked').val(), "ip_address": $('#txtIpAddress_lan1').val(),  "mtu_size":$('#txtMtuSize_lan1').val() };
                request.PortType = portConfig.currentTab;
                request.Type = "save";
                CallPythonService(request);
            }

			else if(selected_lan == "Lanport 2") {
                request = new Request();
                request.url = "cgi/cgi_EthernetPorts_Manager.py";
                request.parameters = {"requestType":"update_lan", "name":'LAN2',"netmask": $('#txtSubNetMask_lan2').val(), "port_enabled": $('input[name=EnablePort_lan2]:checked').val(), "gateway": $('#txtDefaultGateway_lan2').val(), "dns": $('#txtDnsServer_lan2').val(), "dhcp_enabled": $('input[name=EnableDHCP_lan2]:checked').val(), "ip_address": $('#txtIpAddress_lan2').val(),  "mtu_size":$('#txtMtuSize_lan2').val() };
                request.PortType = portConfig.currentTab;
                request.Type = "save";
                CallPythonService(request);
            }
			
            else if(selected_lan == "Lanport 3") {
                request = new Request();
                request.url = "cgi/cgi_EthernetPorts_Manager.py";
                request.parameters = {"requestType":"update_lan", "name":'LAN3',"netmask": $('#txtSubNetMask_lan3').val(), "port_enabled": $('input[name=EnablePort_lan3]:checked').val(), "gateway": $('#txtDefaultGateway_lan3').val(), "dns": $('#txtDnsServer_lan3').val(), "dhcp_enabled": $('input[name=EnableDHCP_lan3]:checked').val(), "ip_address": $('#txtIpAddress_lan3').val(), "mtu_size":$('#txtMtuSize_lan3').val() };
                request.PortType = portConfig.currentTab;
                request.Type = "save";			
                CallPythonService(request);
            }

            else if(selected_lan == "Lanport 4") {
                request = new Request();
                request.url = "cgi/cgi_EthernetPorts_Manager.py";
                request.parameters = {"requestType":"update_lan", "name":'LAN4',"netmask": $('#txtSubNetMask_lan4').val(), "port_enabled": $('input[name=EnablePort_lan4]:checked').val(), "gateway": $('#txtDefaultGateway_lan4').val(), "dns": $('#txtDnsServer_lan4').val(), "dhcp_enabled": $('input[name=EnableDHCP_lan4]:checked').val(), "ip_address": $('#txtIpAddress_lan4').val(),  "mtu_size":$('#txtMtuSize_lan4').val() };
                request.PortType = portConfig.currentTab;
                request.Type = "save";			
                CallPythonService(request);
            }
        }
    }
    else if (portConfig.currentTab === 'WanPort') {
        var isFormValid = $("#formWanPort").validationEngine('validate');
        if (isFormValid) {
            request.url = "cgi/cgi_EthernetPorts_Manager.py";
            request.parameters = {"requestType":"update_wan",  "netmask": $('#txtSubNetMask_wan').val(), "port_enabled": $('input[name=EnablePort_wan]:checked').val(), "dhcp_enabled": $('input[name=EnableDHCP_wan]:checked').val(), "ip_address": $('#txtIpAddress_wan').val(), "mtu_size":$('#txtMtuSize_wan').val() };
            request.PortType = portConfig.currentTab;
            request.Type = "save";
            CallPythonService(request);
        }
    }
    else if (portConfig.currentTab === 'BmcPort') {
        var isFormValid = $("#formBmcPort").validationEngine('validate');
        if (isFormValid) {
            request.url = "cgi/cgi_EthernetPorts_Manager.py";
            request.parameters = {"requestType":"update_adm", "netmask": $('#txtSubNetMask_bmc').val(), "port_enabled": $('input[name=EnablePort_bmc]:checked').val(), "dhcp_enabled": $('input[name=EnableDHCP_bmc]:checked').val(), "ip_address": $('#txtIpAddress_bmc').val(), "mtu_size":$('#txtMtuSize_bmc').val()};
            request.PortType = portConfig.currentTab;
            request.Type = "save";
            CallPythonService(request);
        }
    }
    
}