var hostGrayedOutRules =[{'protocol':1,'user':1,'password':1,'iqn':0,'wwn':0},
						 {'protocol':2,'user':1,'password':1,'iqn':0,'wwn':0},
						 {'protocol':3,'user':0,'password':0,'iqn':1,'wwn':0},
						 {'protocol':4,'user':1,'password':1,'iqn':1,'wwn':0},
						 {'protocol':5,'user':1,'password':1,'iqn':0,'wwn':0},
						 {'protocol':6,'user':0,'password':0,'iqn':0,'wwn':1}
						];
var selectedProtocol = 0;
var hostActionPage = '';
function Request() {
    var request = {
        url: "",
        parameters: {},
        statusType: "",
		typeNumber: "",
		isSingleStatus:false
    };
    
    // $('#displayData').css('overflow', 'scroll');
    // $('#displayData').css('height', '450px');
    // $('#displayData').css('width', '568px');
	
	 // $('#tblheadsingle').css('overflow', 'scroll');
     // $('#tblheadsingle').css('height', '450px');
     // $('#tblheadsingle').css('width', '568px');
    
    return request;
}
$(window).bind("load", function() {
	BindAllStatus();
	ShowChart();
});
function BindAllStatus()
{
	var request = new Request();
	request.url = "cgi/cgi_statusView.py";
	request.parameters ={"requestType":'read_StatusAll'};
	request.statusType="All";
	CallPythonService(request);	
}
function GetRequestType(statusType)
{
	if (statusType === 'fans') {
         return  "read_Fans";
    }
    else if (statusType === 'temp_probes') {
        return   "read_Temp_probes";
    }
    else if (statusType === 'network')
    {
        return  "read_Network";
    }
	else if (statusType === 'cpu') {
        return  "read_CPU";
    }
	else if (statusType === 'psu') {
        return  "read_PSU";
    } 
    else if (statusType === 'psu1') {
        return  "read_PSU1";
    }    
    else if (statusType === 'psu2') {
        return  "read_PSU2";
    }
    else if (statusType === 'disks')
    {
        return   "read_Disks";
    }
	else if (statusType === 'HDD') {
        return  "read_HDD";
    }
    else if (statusType === 'SSD')
    {
        return   "read_SSD";
    }
	else if (statusType === 'StoragePools')
    {
        return   "read_StoragePools";
    }
	else if (statusType === 'Canister')
    {
        return   "read_Canister_Details";
    }
}
function ShowStatus(statusType) {
    var request = new Request();    
	if(statusType !='StoragePools1')
	{
		request.url="cgi/cgi_statusView.py";
		request.parameters ={"requestType":GetRequestType(statusType)};
	}
	else
	{
		request.url="cgi/cgi_setup_SectionData_Get.py?SectionName=StoragePools";
		request.parameters ={"requestType":GetRequestType(statusType)};
	}
	
	
    if (request.url != "") {
        request.statusType = statusType;
        CallPythonService(request);
    }
}
function CallPythonService(request) {
	request.parameters.uuid=uuid;
    $.ajax({
        type: "Get",
        url: request.url,
        contentType: 'application/json',
        dataType: 'json',
        headers: { 'Access-Control-Allow-Origin': '*' },
        data: request.parameters,
        success: function (response) {
			if(request.isSingleStatus)
				BindSingleStatus(request.statusType,request.typeNumber,response);
			else if(request.statusType === "DiskSMART")
				BindDiskSMARTData(response,request.parameters.disk)
			else if(request.statusType === "CanisterSMART")
				BindDiskSMARTData(response,request.parameters.slot)
			else if(request.statusType == "SSDFullData")
				BindSSDFullData(response,request.parameters.SSDId)
			else if(request.statusType == "StoragePoolsFullData")
				BindPoolsFullData(response,request.parameters.poolId)
			else if(request.statusType == "doNothing")
				console.log("Doing nothing");
			else if(request.statusType == "ReadComponent")
				BindComponentStatus(request.parameters.title, response)

			/*else if(request.statusType == "getApps")
				BindApps(request.statusType,response);*/
			else
				BindResponseData(request.statusType,response);
        },
        error: function (ex) {
            if(!isProduction){
				console.log(ex);
			}
        }
    });
}
function BindResponseData(statusType, response) {
	var showPopUp=true;
    var result = SetIconPath(response);
	$('#divSMARTinfo').html('');
    $('#btRefresh').attr('onclick', '');
    if (statusType === 'fans') {
        $('#displayHeader').html('Fan Status View');               
        $('#btRefresh').attr('onclick', 'RefreshData("fans")');
		
		var dataTable = $('#tblResult').DataTable();
		dataTable.destroy();
		
        var tableHeader = '<table border="1" class="table table-striped table-bordered" id="tblResult"><thead><tr class="tbheader"><th>Fan</th><th>State</th><th>Name</th><th>Speed</th><th>Low Threshold</th><th>High Threshold</th></tr></thead><tbody id="tblbody"></tbody></table>'
        $('#displayData').html(tableHeader);
        $.each(result, function (i, item) {
            var records = '<tr><td>' + item.Slot + '</td><td><img src="' + item.IconPath + '" alt="'+item.state+'" id="state" class="dvstate"></td><td>' + item.name + '</td><td>' + item.speed + '</td><td>' + item.low_threshold + '</td><td>' + item.hi_threshold + '</td></tr>'
            $('#tblbody').append(records);
        });  
		$('#tblResult').DataTable(GetTableConfig(statusType));		
    }
    else if (statusType == 'temp_probes')
    {
        $('#displayHeader').html('Temperature Status View');
        $('#btRefresh').attr('onclick', 'RefreshData("temp_probes")');
		
		var dataTable = $('#tblResult').DataTable();
		dataTable.destroy();
		
        var tableHeader = '<table border="1" class="table table-curved tbdata" id="tblResult"><thead><tr class="tbheader"><th>Temp</th><th>State</th><th>Name</th><th>Temp</th><th>Low Threshold</th><th>High Threshold</th></tr></thead><tbody id="tblbody"></tbody></table>'
        $('#displayData').html(tableHeader);
        $.each(response, function (i, item) {
            var records = '<tr><td>' + item.Slot + '</td><td><img src="' + item.IconPath + '" alt="' + item.state + '" id="state" class="dvstate"></td><td>' + item.name + '</td><td>' + item.temp + '</td><td>' + item.low_threshold + '</td><td>' + item.hi_threshold + '</td></tr>'
            $('#tblbody').append(records);
        });
		
		$('#tblResult').DataTable(GetTableConfig(statusType));
    }
    else if (statusType == 'network') {
        $('#displayHeader').html('Network Status View');
        $('#btRefresh').attr('onclick', 'RefreshData("network")');
		
		var dataTable = $('#tblResult').DataTable();
		dataTable.destroy();
		
        var tableHeader = '<table border="1" class="table table-striped table-bordered" id="tblResult"><thead><tr class="tbheader"><th>Port</th><th>State</th><th>Name</th><th>Speed</th><th>IP</th><th>Netmask</th><th>Port Id</th></tr></thead><tbody id="tblBody"></tbody></table>'
        $('#displayData').html(tableHeader);
        $.each(response, function (i, item) {
            var records = '<tr><td>' + item.Slot + '</td><td><img src="' + item.IconPath + '" alt="' + item.state + '" id="state" class="dvstate"></td><td>' + item.name + '</td><td>' + item.speed + '</td><td>' + item.ip + '</td><td>' + item.netmask + '</td><td>' + item.port_id + '</td></tr>'
            $('#tblBody').append(records);
        });        
		
		$('#tblResult').DataTable(GetTableConfig(statusType));
    }
    else if (statusType == 'psu') {
        $('#displayHeader').html('PSU Status View');
        $('#btRefresh').attr('onclick', 'RefreshData("psu")');
		
		var dataTable = $('#tblResult').DataTable();
		dataTable.destroy();
		
        var tableHeader = '<table border="1" class="table table-curved tbdata" id="tblResult"><thead><tr class="tbheader"><th>PSU</th><th>State</th><th>Name</th><th>AC Status</th><th>DC Status</th></tr></thead><tbody id="tblbody"></tbody></table>'
        $('#displayData').html(tableHeader);
        $.each(response, function (i, item) {
            var records = '<tr><td>' + item.Slot + '</td><td><img src="' + item.IconPath + '" alt="' + item.state + '" id="state" class="dvstate"></td><td>' + item.name + '</td><td>' + item.ac_status + '</td><td>' + item.dc_status + '</td></tr>'
            $('#tblbody').append(records);
        });
		
		$('#tblResult').DataTable(GetTableConfig(statusType));
    }
	else if (statusType == 'cpu') {
        $('#displayHeader').html('CPU Status View');
        $('#btRefresh').attr('onclick', 'RefreshData("cpu")');
		
		var dataTable = $('#tblResult').DataTable();
		dataTable.destroy();
		
        var tableHeader = '<table border="1" class="table table-curved tbdata" id="tblResult"><thead><tr class="tbheader"><th>CPU</th><th>State</th><th>Name</th><th>Controller</th><th>Location</th><th>Cores</th><th>Cache Size</th><th>Temprature</th><th>Vendor</th><th>Model Number</th><th>Cpu(mhz)</th></tr></thead><tbody id="tblbody"></tbody></table>'
        $('#displayData').html(tableHeader);
        $.each(response, function (i, item) {
            var records = '<tr><td>' + item.Slot + '</td><td><img src="' + item.IconPath + '" alt="' + item.state + '" id="state" class="dvstate"></td><td>' + item.name + '</td><td>' + item.controllerName + '</td><td>' + item.location + '</td><td>' + item.cores + '</td><td>' + item.cacheSize + '</td><td>' + item.temperature + '</td><td>' + item.vendorId + '</td><td>' + item.modelNum + '</td><td>' + item.cpuMhz + '</td></tr>'
            $('#tblbody').append(records);
        });
		
		$('#tblResult').DataTable(GetTableConfig(statusType));
    }
    else if (statusType == 'psu2') {
        $('#displayHeader').html('PSU2 Status View');
        $('#btRefresh').attr('onclick', 'RefreshData("psu2")');
		
		var dataTable = $('#tblResult').DataTable();
		
		dataTable.destroy();
		
        var tableHeader = '<table border="1" class="table table-curved tbdata" id="tblResult"><thead><tr class="tbheader"><th>PSU</th><th>State</th><th>Name</th><th>AC Status</th><th>DC Status</th></tr></thead><tbody id="tblbody"></tbody></table>'
        $('#displayData').html(tableHeader);
        $.each(response, function (i, item) {
            var records = '<tr><td>' + item.Slot + '</td><td><img src="' + item.IconPath + '" alt="' + item.state + '" id="state" class="dvstate"></td><td>' + item.name + '</td><td>' + item.ac_status + '</td><td>' + item.dc_status + '</td></tr>'
            $('#tblbody').append(records);
        });
		
		$('#tblResult').DataTable(GetTableConfig(statusType));
    }
    else if (statusType == 'disks')
    {
        $('#displayHeader').html('Disk Status View');
        $('#btRefresh').attr('onclick', 'RefreshData("disks")');
		
		var dataTable = $('#tblResult').DataTable();
		dataTable.destroy();
		
        //var tableHeader = '<table border="1" class="table table-curved tbdata hoverTable" id="tblResult"><thead><tr class="tbheader"><th></th><th>Disk</th><th>State</th><th>Name</th><th>Type</th><th>Size</th><th>Vendor ID</th><th>Product ID</th><th>Prl</th><th>Serial#</th><th>Status</th><th>Action</th></tr></thead><tbody id="tblbody"></tbody></table>'
        var tableHeader = '<table border="1" class="table table-curved tbdata hoverTable" id="tblResult"><thead><tr class="tbheader"><th>Disk</th><th>State</th><th>Name</th><th>Type</th><th>Size</th><th>Vendor ID</th><th>Product ID</th><th>Prl</th><th>Serial#</th><th>Status</th><th>Action</th></tr></thead><tbody id="tblbody"></tbody></table>'
        $('#displayData').html(tableHeader);
		$('#displayData').css('height', '250px');
		$.each(response, function (i, item) {//item.id
			var wwn = GetString(item.wwn); //item.wwn
            //var records = '<tr onclick="ShowDiskSMARTData(\''+item.wwn+'\')" title="Click here for more info" class="diskrownum_'+i+'"><td>' + item.location + '</td><td><img src="' + item.IconPath + '" alt="' + item.state + '" id="state" class="dvstate"></td><td>' + item.wwn + '</td><td>' + item.rotation + '</td><td>' + item.size + '</td><td>' + item.vid + '</td><td>' + item.pid + '</td><td>' + item.prl + '</td><td>' + item.serial + '</td><td>' + item.status + '</td></tr>'
			var records = `<tr onclick="ShowDiskSMARTData(\``+item.name+`\`,'`+item.location+`')" title="Click here for more info" class="diskrownum_`+i+`">
			<!--<td><input type="radio" name="diskUpload" id="disk_`+ wwn + `" value=\`` + wwn + `\` /></td>-->
			<td><span title="` + GetString(item.location) + `">`+trimString(GetString(item.location),10)+`</span></td>
			<td><img src="` + item.IconPath + `" alt="` + item.state + `" id="state" class="dvstate"></td>
			<td><span title="` + wwn + `">`+trimString(wwn,15)+`</span></td>
			<td>` + item.rotation + `</td>
			<td>` + item.size + `</td>

			<td>` + item.vid + `</td>
			<!--<td><span title="` + GetString(item.vid) +  `">`+trimString(GetString(item.vid),10)+`</span></td>-->
			
			<td><span title="` + GetString(item.pid) + `">`+trimString(GetString(item.pid),12)+`</span></td>
			<td><span title="` + GetString(item.prl) +`">`+trimString(GetString(item.prl),12)+`</span></td>
			
			<td><span title="` + GetString(item.serial) +`">`+trimString(GetString(item.serial),10)+`</span></td>
			<td>` + item.status + `</td>
			<td width="15%" align="center">
				<span class="linksBlkPop"> 
				
				<label class="radio-switch" title="Click to Turn On Volume">
					<input type="checkbox" onclick="OnOffDisks(\`` + wwn + `\`,'off')" name="VolumeToggele">
					<span class="slider"></span>
				</label>
				
				<label class="radio-switch hide" title="Click to Turn Off Volume">
					<input type="checkbox" onclick="OnOffDisks(\`` + wwn + `\`,'on')" name="VolumeToggele" checked>
					<span class="slider"></span>
                </label>

                <a href="javascript:void(0);" onclick="openConfigfileUpload(\`` + wwn + `\`)" data-dismiss="modal" id="upload-btn" class="yellowBGPop">
				<img src="images/upload-icon.png" alt="Upload" title="Upload"></a> 
                
                <a href="javascript:void(0);" class="yellowBGPop" onclick="ejectDisk(\`` + wwn + `\`)">
				<img src="images/eject-icon.png" alt="Eject" title="Eject"></a> 

				</span>
			</td>
			</tr>`
            //var records = '<tr onclick="ShowDiskSMARTData(\''+item.id%5+'\')" title="Click here for more info" class="diskrownum_'+i+'"><td>' + item.location + '</td><td><img src="' + item.IconPath + '" alt="' + item.state + '" id="state" class="dvstate"></td><td>' + item.wwn + '</td><td>' + 'HDD' + '</td><td>' + item.size + '</td><td>' + item.vid + '</td><td>' + item.pid + '</td><td>' + item.prl + '</td><td>' + item.serial + '</td><td>' + 'OK' + '</td></tr>'
			
            $('#tblbody').append(records);
        });

		$('#tblResult').DataTable(GetTableConfig(statusType));
		var footer=`
		<div class="col-xs-9 btnsBox" style="padding-bottom: 0px;">
                        <div class="row pull-right">
                            <a href="javascript:void(0)" onclick="openConfigfileUpload()" class="red-button mr-Rt20"
							id="upload-btn" data-dismiss="modal">Upload</a>
                        </div>
                    </div>
		`;
		var footer=`
		<div class="col-xs-9 btnsBox" style="padding-bottom: 0px;">
						<span class="linksBlk pull-right"> 
						<a href="javascript:void(0);" class=" yellowBG">
						<img src="images/screen-shot-icon.png" alt="Snap" title="Snap"></a>
							<a href="javascript:void(0);" class=" yellowBG">
						<img src="images/infoIcon.png" alt="infoIcon" title="Info"></a>  
						 
						 <label class="radio-switch hide" title="Click to Turn On Volume">
							  <input type="checkbox" name="VolumeToggele">
							  <span class="slider"></span>
						  </label>
						  
						  <label class="radio-switch" title="Click to Turn Off Volume">
							  <input type="checkbox" name="VolumeToggele" checked>
							  <span class="slider"></span>
						  </label>

						</span>
                    </div>
		`;
		//$('#displayData').append(footer);
		//$("#upload-btn").css("background", "grey");
		//$("#upload-btn").css("pointerEvents", "none");
    }
	else if (statusType == 'SSD')
    {
        $('#displayHeader').html('SSD Status View');
        $('#btRefresh').attr('onclick', 'RefreshData("SSD")');
		
		var dataTable = $('#tblResult').DataTable();
		dataTable.destroy();
		
        var tableHeader = '<table border="1" class="table table-curved tbdata hoverTable" id="tblResult"><thead><tr class="tbheader"><th>Name</th><th>Write Cache</th><th>Read Cache</th><th>Data</th><th>Type</th></tr></thead><tbody id="tblbody"></tbody></table>'
        $('#displayData').html(tableHeader);
		$('#displayData').css('height', '250px');
        $.each(response, function (i, item) {
            var records = '<tr onclick="ShowSSDData('+i+')" class="diskrownum_'+i+'"><td>' + item.location + '</td><td>' + item.writeCache + '</td><td>' + item.readCache + '</td><td>' + item.dataSize + '</td><td>' + item.type + '</td></tr>'
            $('#tblbody').append(records);
        });
		$('#tblResult').DataTable(GetTableConfig(statusType));
    }
	else if (statusType == 'StoragePools')
    {
		response.data = SetIconPath(response.data);
        $('#displayHeader').html('Storage Pool View');
        $('#btRefresh').attr('onclick', 'RefreshData("StoragePools")');
		
		var dataTable = $('#tblResult').DataTable();
		dataTable.destroy();
		
        var tableHeader = `<table border="1" class="table table-striped table-bordered hoverTable" id="tblResult">
		<thead>
			<tr class="tbheader"><th>Pool</th><th>State</th><th>Redundancy</th><th>Raid Level</th>
				<th>Disk missing</th><th>Storage Capacity</th><th>Used Storage</th>
				<th>Remaining Capacity</th><th>Compression</th><th>Dedup</th><th>Cache Read</th><th>Cache Write</th><th>Type</th>
			</tr>
		</thead><tbody id="tblBody"></tbody></table>`;

        $('#displayData').html(tableHeader);
        $.each(response.data, function (i, item) {			
            //var records = '<tr onclick="ShowStoragePoolsData(\''+item.pool+'\')"  class="diskrownum_'+item.id+'"><td>' +item.pool + '</td><td><img src="' + item.IconPath + '" alt="' + item.state + '" id="state" class="dvstate"></td><td>' +item.redundancy + '</td><td>' +item.diskMissing + '</td><td>' + (ConvertToFloat(item.capacity)-ConvertToFloat(item.protection)) + '</td><td>' + 0 + '</td><td>' + (ConvertToFloat(item.capacity)-ConvertToFloat(item.protection)) + '</td><td>' + item.compression + '</td><td>' + item.dedup + '</td><td>' + item.cache_RD + '</td><td>' + item.cache_WRITE + '</td><td>' + item.type + '</td></tr>'
            //var records = '<tr onclick="ShowStoragePoolsData(\''+item.system_name+'\')"  class="diskrownum_'+item.id+'"><td>' +item.system_name + '</td><td><img src="' + item.IconPath + '" alt="' + item.state + '" id="state" class="dvstate"></td><td>' +item.redundancy + '</td><td>' +item.diskMissing + '</td><td>' + (ConvertToFloat(item.capacity)-ConvertToFloat(item.protection)) + '</td><td>' + 0 + '</td><td>' + (ConvertToFloat(item.capacity)-ConvertToFloat(item.protection)) + '</td><td>' + item.compression + '</td><td>' + item.dedup + '</td><td>' + item.cache_RD + '</td><td>' + item.cache_WRITE + '</td><td>' + item.type + '</td></tr>'
            var records = '<tr <!--onclick="ShowStoragePoolsData(\''+item.system_name+'\')"  class="diskrownum_'+item.id+'"-->><td>' +item.system_name + '</td><td><img src="' + item.IconPath + '" alt="' + item.state + '" id="state" class="dvstate"></td><td>' +item.redundancy + '</td><td>' +item.raidlvl + '</td><td>' +item.diskMissing + '</td><td>' + item.capacity + '</td><td>' + item.used + '</td><td>' + item.remaining + '</td><td>' + item.compression + '</td><td>' + item.dedup + '</td><td>' + item.cache_RD + '</td><td>' + item.cache_WRITE + '</td><td>' + item.type + '</td></tr>'
            $('#tblBody').append(records);
        });
		
		$('#tblResult').DataTable(GetTableConfig(statusType));
    }
	else if (statusType == 'Canister')
    {
        $('#displayHeader').html('4 Bay Canister');
        $('#btRefresh').attr('onclick', 'RefreshData("Canister")');
		
		try {
			var dataTable = $('#tblResult').DataTable();
			ataTable.destroy();
		} catch (error) {
			var i=0;
		}
		
		var headerData = ''
		response.attributes.forEach(element => {
			headerData+= "<th>" +element+ "</th>";
		});
		headerData = headerData == ''? '<th>Name</th><th>Size</th>' : headerData;
        var tableHeader = `<table border="1" class="table table-striped table-bordered hoverTable" id="tblResult">
		<thead>
			<tr class="tbheader">
			`+headerData+`
			</tr>
		</thead><tbody id="tblBody"></tbody></table>`;

        $('#displayData').html(tableHeader);

        $.each(response.data, function (i, item) {
			var rowdata = '';
				response.attributes.forEach(element => {
					rowdata+=`<td>`+item[element]+"</td>"
				});
			var records= `<tr onclick="ShowCanisterSMARTData(\``+item['EID:Slt']+`\`)" title="Click here for more info" class="canisterrownum_`+i+`">`+rowdata+'</tr>'			
            $('#tblBody').append(records);
        });
		
		$('#tblResult').DataTable(GetTableConfig(statusType));
    }
	else if(statusType==='All')
	{		
	showPopUp=false;
	DisplayAllStatus(response);	
	}
	else if(statusType=='SaveHost')
	{
		if(response.status != 'fail')
			HostPageNavigate();
		alert(response.description);
		BindAllHosts();
		return;
	}
	else if(statusType == 'getProtocol')
	{
		$("#ddlHostType option").remove();	
		$('#ddlHostType').append(new Option('-- Select --',''));
		$.each(response, function (i, item) {
            $('#ddlHostType').append(new Option(item.protocolName, item.id));            
        }); 
		//SetUpGrayedOutRules(1);
		return;
	}
	else if(statusType == 'getHosts')
	{
		$("#ddlHostNames option").remove();	
		$('#ddlHostNames').append(new Option('-- Select --', ''));
		$('#tbodyHostData').html('');
		$.each(response, function (i, item) {
			
			var host = `<tr class="text-left">
                                       <td class="col-xs-2 class-span-trim text-left">
                                          `+item.name+`
                                       </td>
									   <td class="col-xs-2 text-left">`+item.protocol_name+`</td>
                                       <td class="col-xs-2 text-left">`+GetString(item.user_name)+`</td>
                                       <td class="col-xs-2 text-left">
                                          `+GetString(item.pw)+`
                                       </td>
                                       <td class="col-xs-2 text-left">
                                          `+GetString(item.iqn)+`
                                       </td>
                                       <td class="col-xs-2 text-left">
                                          `+GetString(item.wwn)+`
                                       </td>
                                    </tr>`
			$('#tbodyHostData').append(host);
			
            $('#ddlHostNames').append(new Option(item.name, item.id));            
        }); 
		return;
	}
	else if(statusType == 'getHostsForVolume')
	{
		$("#ddlVolumeHost option").remove();	
		$('#ddlVolumeHost').append(new Option('-- Select --', ''));
		$.each(response, function (i, item) {			
			$('#ddlVolumeHost').append(new Option(item.name, item.id)); 
        }); 
		//$('#ddlVolumeHost').multiselect();
		return;
	}
	else if(statusType == 'getProtocolForVolume')
	{
		$("#ddlVolumeProtocol option").remove();	
		$('#ddlVolumeProtocol').append(new Option('-- Select --', ''));
		$.each(response, function (i, item) {
            $('#ddlVolumeProtocol').append(new Option(item.protocolName, item.id));            
        }); 
		return;
	}
	else if(statusType == 'getStoragePools')
	{
		$("#ddlVolumePool option").remove();	
		$('#ddlVolumePool').append(new Option('-- Select --', ''));
		$.each(response, function (i, item) {
            $('#ddlVolumePool').append(new Option(item.name, item.id));            
        }); 
		return;
	}
	else if(statusType == 'getEthernetPorts')
	{
		$("#ddlvolumePorts option").remove();	
		$('#ddlvolumePorts').append(new Option('-- Select --', ''));
		$.each(response, function (i, item) {
            $('#ddlvolumePorts').append(new Option(item.name, item.id));            
        }); 
		return;
	}
	else if(statusType == 'getHostById')
	{
		var host= response[0];
		$('#txtHostName').val(host.name);
		$('#ddlHostType').val(host.protocol_id);
		$('#txtHostUser').val(host.user_name);
		$('#txtHostPwd').val(host.pw);
		$('#txtHostIQN').val(host.iqn);
		$('#txtHostWWN').val(host.wwn);
		
		SetUpGrayedOutRules(host.protocol_id);
		return;
	}
	else if(statusType == 'SaveVolume')
	{
		BindVolumeSavedData();		
		alert(response.description);
		if(response.status !='fail')
			VolumeMgrPageNavigate('cancel');
		return;
	}
	else if(statusType == 'changeVolumeState')
	{
		BindVolumeSavedData();
		alert(response.description);
		return;
	}
	else if(statusType == 'SaveSnapVolume')
	{	
		if(response.status == 'fail')
		{
			swal("Error", response.description , "error");			
		}	
		else{
			BindVolumeSavedData();	
			swal("success", response.description , "success");
		}
		return;
	}
	else if(statusType == 'getVolumeSavedData')
	{
		$("#ddlVolumeNames option").remove();
		$('#ddlVolumeNames').append(new Option('-- Select --', ''));
		
		//$('#ddlVolumeNames').trigger('change');
		
		$('#tbodyVolumeData').html('');
		$.each(response, function (i, item) {
			var dedup = item.dedup == 'true' ?'Yes':'No';
			var compression = item.compression == 'true'?'Yes':'No';
			var onClass = item.state == 6 ? 'blinkled':'';
			var offClass = item.state == 4 ? 'blinkled':'';
			var len=$(this).text().trim().length;
			item.nametext = item.name
			if(item.name.length>10)
			{
				item.name = item.name.substr(0,12)+'...';
			}
		var strVolume =`<tr class="text-left">
                                       <td class="col-xs-1 class-span-trim text-left" title="`+item.nametext+`">
                                          `+item.name+`
                                       </td>
									   <td class="col-xs-1 text-left">`+item.type+`</td>
                                       <td class="col-xs-1 text-left">`+item.size+`</td>
                                       <td class="col-xs-1 text-left">
                                          `+item.poolName+`
                                       </td>
                                       <td class="col-xs-1 text-left">
                                          `+item.lun+` 
                                       </td>
                                       <td class="col-xs-1 text-left">
                                          `+dedup+`
                                       </td>
									   <td class="col-xs-1 text-left">
                                          `+compression+`
                                       </td>
									   <td class="col-xs-1">
                                          `+item.protocolName+`
                                       </td>
                                       <td class="col-xs-1 ">
                                          `+item.hostName+`
                                       </td>
                                       <td class="col-xs-1 text-left"> 
                                          `+item.portName+`
                                       </td>
                                       <td class="col-xs-2" align="center">
                                          <span class="linksBlk"> 
                                          <a href="javascript:void(0);" class=" yellowBG">
                                          <img src="images/screen-shot-icon.png" alt="Snap" title="Snap" onclick="SnapShotVolume(`+item.id+`,'`+item.name+`')"></a>
											  <a href="javascript:void(0);" class=" yellowBG">
                                          <img src="images/infoIcon.png" alt="infoIcon" title="Info" onclick="VolumeInfo(`+item.size+`)"></a>  
										  <a href="javascript:void(0);" class="`+onClass+`">
											<img src="images/power-On.png" alt="Start" title="Start" onclick="OnOffVolume(`+item.id+`,`+6+`)">
										  </a>
                                          <a href="javascript:void(0);" class="`+offClass+`">
											<img src="images/power-Off.png" alt="Stop" title="Stop" onclick="OnOffVolume(`+item.id+`,`+4+`)">
										  </a>
                                        
                                          </span>
                                       </td>
                                    </tr>`;
			$('#tbodyVolumeData').append(strVolume);
			if(item.type == 'Native')
				$('#ddlVolumeNames').append(new Option(item.name, item.id));
		}); 
		
		return;
	}
	else if(statusType == 'getVolumeById')
	{
		var volume =response[0];
		
		$('#txtVolumeSize').val(volume.size);
		$('#ddlVolumeProtocol').val(volume.protocolId);
		$('#ddlVolumePool').val(volume.poolId);
		$('#ddlVolumeHost').val(volume.hostId);
		$('#txtVolumeLUN').val(volume.lun);
		$('#ddlvolumePorts').val(volume.portId);
		$('#chkDedup').prop('checked',volume.dedup =="true"?true:false);// volume.dedup
		$('#chkCompression').prop('checked', volume.compression =="true"?true:false);
		//"size":$('#txtVolumeSize').val(),"protocolId":$('#ddlVolumeProtocol').val(),"poolId":$('#ddlVolumePool').val(),"hostId":$('#ddlVolumeHost').val(),"lun":$('#txtVolumeLUN').val(),"portId":$('#ddlvolumePorts').val()
		return;
	}
	else if(statusType == 'getMetricsByDevice')
	{
		
		$("#ddlDeviceMetric option").remove();	
		//$('#ddlDeviceMetric').append(new Option('Select',''));
		$.each(response.metrics, function (i, item) {
            $('#ddlDeviceMetric').append(new Option(item.replace('.rrd','')), item);            
        });
		$('#aMetricInfo').attr('data-original-title',$("#ddlDeviceMetric").val()+ ' info content here');
		return;
	}
	else if(statusType == 'getMetricsByDevice')
	{
		
	}
	$('#tblhead').on("click",function(){
		$('#tblhead tr').removeClass('highlighted');
    $(this).addClass('highlighted');
	});
    $('#tblhead thead').css('background', 'red');
    $('#tblhead thead').css('color', 'white');
	$("#tblhead").tableHeadFixer();
	if(showPopUp)
     $('#displayPopUp').modal('show');
}
/*function BindApps(statusType,response)
{
	if(statusType == 'getApps')
	{
		$("#ddlApplication option").remove();	
		//$('#ddlDeviceMetric').append(new Option('Select',''));
		$.each(response, function (i, item) {
            $('#ddlApplication').append(new Option(item, item));            
		});
		$('#ddlApplication').click();
	}
}*/
function ConvertToFloat(str)
{
	return str.replace(' TB','');
}
$(document).on('click', 'input[name="diskUpload"]', function () {
	$("#upload-btn").css("background", "#ed1c24");
	$("#upload-btn").css("pointerEvents", "auto");
});
function SetIconPath(response)
{
    var result = [];
    $.each(response, function (i, item) {
        switch(item.state)
        {
            case 0:
                item.IconPath = "./images/green-switch.png";
                item.Slot = i + 1;
                break;
            case 1:
                item.IconPath = "./images/orange-switch.png";
                item.Slot = i + 1;
                break;
            case 2:
                item.IconPath = "./images/red-switch.png";
                item.Slot = i + 1;
                break;
            case 3:
                item.IconPath = "./images/yellow-switch.png";
                item.Slot = i + 1;
                break;
        }
        result.push(item);
    });
    return result;
}
function RefreshData(type)
{
    ShowStatus(type);    
}
function DisplayAllStatus(response)
{
	var htmlData=GetFinalStatus(response.fans);
	$('#divFan').html(htmlData);
	htmlData=GetFinalStatus(response.temp_probes);
	$('#divTemp_probes').html(htmlData);
	htmlData=GetFinalStatus(response.network);
	$('#divNetwork').html(htmlData);
	/*htmlData=GetFinalStatus(response.psu1);
	$('#divPsu1').html(htmlData);
	htmlData=GetFinalStatus(response.psu2);
	$('#divPsu2').html(htmlData);*/
	htmlData=GetFinalStatus(response.psu);
	$('#divPsu').html(htmlData);
	htmlData=GetFinalStatus(response.disks);
	$('#divDisks').html(htmlData);
	htmlData=GetFinalStatus(response.cpu);
	$('#divCpu').html(htmlData);
	
	$('#divBackup').html('<div class="greenFlash">Ok</div>');
	$('#divAlerts').html('<div class="greenFlash">Ok</div>');
	$('#divVmStatus').html('<div class="greenFlash">Ok</div>');
	$('#divFastier').html('<div class="greenFlash">Ok</div>');
	$('#divStoragePoll').html('<div class="greenFlash">Ok</div>');
	
}
function GetFinalStatus(states)
{
	var redcheck=states.indexOf(2);
	var orangecheck=states.indexOf(1);
	var greencheck=states.indexOf(0);
	var htmlData='';
	if(redcheck !=-1)
		htmlData='<div class="redFlash">Alert</div>';
	else if(orangecheck !=-1)
		htmlData='<div class="orangeFlash">Warning</div>';
	else if(greencheck !=-1)
		htmlData='<div class="greenFlash">Ok</div>';
	else
		htmlData='<div class="orangeFlash">N/A</div>';
	return htmlData;
}
function GetStatusbyType(type,typeNumber)
{
	var request = new Request();
	request.parameters = {"requestType":GetRequestType(type)};
	request.url = 'cgi/cgi_statusView.py';	
	request.statusType=type;
	request.typeNumber=typeNumber;
	request.isSingleStatus=true;
	CallPythonService(request);	
}
function BindSingleStatus(statusType,typeNumber,response)
{
	var result = SetIconPath(response);
		//$('#displayHeadersingle').html('Disk '+ typeNumber);
		if(statusType === 'disks' )
		{
			//$('#btRefresh').attr('onclick', 'RefreshData("disks")');
			var tableHeader = '<table border="1" class="table table-curved tbdata" id="tblheadsingle"><thead><tr class="tbheader"><th>Disk</th><th>State</th><th>Name</th><th>Type</th><th>Size</th><th>Vendor ID</th><th>Product ID</th><th>Prl</th><th>Serial#</th><th>Status</th></tr></thead><tbody id="tblbody"></tbody></table>'
			$('#displayDatasingle').html(tableHeader);
			$.each(response, function (i, item) {
				if(item.wwn==typeNumber){
					$('#displayHeadersingle').html(item.name);
					var records = '<tr  class="diskrownum_'+i+'"><td>' + item.location + '</td><td><img src="' + item.IconPath + '" alt="' + item.state + '" id="state" class="dvstate"></td><td>' + item.wwn + '</td><td>' + item.rotation + '</td><td>' + item.size + '</td><td>' + item.vid + '</td><td>' + item.pid + '</td><td>' + item.prl + '</td><td>' + item.serial + '</td><td>' + item.status + '</td></tr>'
					$('#tblheadsingle').append(records);
				}
			});
		}
		else if(statusType === 'psu1' )
		{
			$('#displayHeadersingle').html('PSU '+typeNumber);
			//$('#btRefresh').attr('onclick', 'RefreshData("psu1")');
			var tableHeader = '<table border="1" class="table table-curved tbdata" id="tblheadsingle"><thead><tr class="tbheader"><th>State</th><th>Name</th><th>AC Status</th><th>DC Status</th></tr></thead><tbody></tbody></table>'
			$('#displayDatasingle').html(tableHeader);
			$.each(response, function (i, item) {
				if(item.name === 'PSU'+typeNumber || item.name === 'PSU_'+typeNumber){
					var records = '<tr><td><img src="' + item.IconPath + '" alt="' + item.state + '" id="state" class="dvstate"></td><td>' + item.name + '</td><td>' + item.ac_status + '</td><td>' + item.dc_status + '</td></tr>'
					$('#tblheadsingle').append(records);
				}
			});
		}
		else if(statusType === 'psu2' )
		{
			$('#displayHeadersingle').html('PSU '+typeNumber);
			//$('#btRefresh').attr('onclick', 'RefreshData("psu1")');
			var tableHeader = '<table border="1" class="table table-curved tbdata" id="tblheadsingle"><thead><tr class="tbheader"><th>State</th><th>Name</th><th>AC Status</th><th>DC Status</th></tr></thead><tbody></tbody></table>'
			$('#displayDatasingle').html(tableHeader);
			$.each(response, function (i, item) {
				if(item.name === 'PSU'+typeNumber || item.name === 'PSU_'+typeNumber){
					var records = '<tr><td><img src="' + item.IconPath + '" alt="' + item.state + '" id="state" class="dvstate"></td><td>' + item.name + '</td><td>' + item.ac_status + '</td><td>' + item.dc_status + '</td></tr>'
					$('#tblheadsingle').append(records);
				}
			});
		}
		else if(statusType === 'fans')
		{
			typeNumber="_1";
			$('#displayHeadersingle').html('Fan'+typeNumber);               
			//$('#btRefresh').attr('onclick', 'RefreshData("fans")');
			var tableHeader = '<table border="1" class="table table-curved tbdata" id="tblheadsingle"><thead><tr class="tbheader"><th>State</th><th>Name</th><th>Speed</th><th>Low Threshold</th><th>High Threshold</th></tr></thead><tbody></tbody></table>'
			$('#displayDatasingle').html(tableHeader);
			$.each(result, function (i, item) {
				if(item.name === 'Fan'+typeNumber){
					var records = '<tr><td><img src="' + item.IconPath + '" alt="'+item.state+'" id="state" class="dvstate"></td><td>' + item.name + '</td><td>' + item.speed + '</td><td>' + item.low_threshold + '</td><td>' + item.hi_threshold + '</td></tr>'
					$('#tblheadsingle').append(records);
				}
			}); 
		}
		else if(statusType === 'network')
		{
			$('#displayHeadersingle').html(typeNumber);
			//$('#btRefresh').attr('onclick', 'RefreshData("network")');
			var tableHeader = '<table border="1" class="table table-curved tbdata" id="tblheadsingle"><thead><tr class="tbheader"><th>State</th><th>Name</th><th>Speed</th><th>IP</th><th>Netmask</th><th>Port Id</th></tr></thead><tbody></tbody></table>'
			$('#displayDatasingle').html(tableHeader);
			$.each(response, function (i, item) {
				if(item.name === typeNumber){
					var records = '<tr><td><img src="' + item.IconPath + '" alt="' + item.state + '" id="state" class="dvstate"></td><td>' + item.name + '</td><td>' + item.speed + '</td><td>' + item.ip + '</td><td>' + item.netmask + '</td><td>' + item.port_id + '</td></tr>'
					$('#tblheadsingle tbody').append(records);
				}
			});    
		}
		else if(statusType === 'HDD')
		{
			$('#displayHeadersingle').html(statusType+typeNumber); 
			var tableHeader = '<table border="1" class="table table-curved tbdata" id="tblheadsingle"><thead><tr class="tbheader"><th>State</th><th>Name</th><th>Speed</th><th>IP</th><th>Netmask</th><th>Port Id</th></tr></thead><tbody></tbody></table>'
			//$('#displayDatasingle').html(tableHeader);
			$.each(response, function (i, item) {
				if(item.location === typeNumber){
					var records = '<tr><td><img src="' + item.IconPath + '" alt="' + item.state + '" id="state" class="dvstate"></td><td>' + item.name + '</td><td>' + item.speed + '</td><td>' + item.ip + '</td><td>' + item.netmask + '</td><td>' + item.port_id + '</td></tr>'
					//$('#tblheadsingle tbody').append(records);
				}
			});  
		}
		else if(statusType === 'SSD')
		{
			$('#displayHeadersingle').html(statusType+typeNumber); 
			/*var tableHeader = '<table border="1" class="table table-curved tbdata" id="tblheadsingle"><thead><tr class="tbheader"><th>State</th><th>Name</th><th>Speed</th><th>IP</th><th>Netmask</th><th>Port Id</th></tr></thead><tbody></tbody></table>'
			//$('#displayDatasingle').html(tableHeader);
			$.each(response, function (i, item) {
				if(item.name === typeNumber){
					var records = '<tr><td><img src="' + item.IconPath + '" alt="' + item.state + '" id="state" class="dvstate"></td><td>' + item.name + '</td><td>' + item.speed + '</td><td>' + item.ip + '</td><td>' + item.netmask + '</td><td>' + item.port_id + '</td></tr>'
					//$('#tblheadsingle tbody').append(records);
				}
			});*/
			var tableHeader = '<table border="1" class="table table-curved tbdata" id="tblheadsingle"><thead><tr class="tbheader"><th>Disk</th><th>State</th><th>Name</th><th>Type</th><th>Size</th><th>Vendor ID</th><th>Product ID</th><th>Prl</th><th>Serial#</th><th>Status</th></tr></thead><tbody id="tblbody"></tbody></table>'
			$('#displayDatasingle').html(tableHeader);
			$.each(response, function (i, item) {
				if(i==typeNumber){
					$('#displayHeadersingle').html(item.name);
					var records = '<tr  class="diskrownum_'+i+'"><td>' + item.location + '</td><td><img src="' + item.IconPath + '" alt="' + item.state + '" id="state" class="dvstate"></td><td>' + item.wwn + '</td><td>' + "SSD" + '</td><td>' + item.size + '</td><td>' + item.vid + '</td><td>' + item.pid + '</td><td>' + item.prl + '</td><td>' + item.serial + '</td><td>' + "OK" + '</td></tr>'
					$('#tblheadsingle').append(records);
				}
			});   
		}
		
		$('#tblheadsingle thead').css('background', 'red');
		$('#tblheadsingle thead').css('color', 'white');
		$("#tblheadsingle").tableHeadFixer();
		$('#displayPopUpsingle').modal('show');
}
function BindComponentStatus(component, response)
{
	$('#displayHeadersingle').html(component); 
	var headerData = ''
	response.attributes.forEach(element => {
		headerData+= "<th>" +element+ "</th>";
	});
	var tableHeader = `<table border="1" class="table table-curved tbdata" id="tblheadsingle">
						<thead><tr class="tbheader">
						`+headerData+`
						</tr></thead><tbody id="tblbody"></tbody></table>`;
	$('#displayDatasingle').html(tableHeader);
	var records = '';
	$.each(response.data, function (i, item) {
			var rowdata = '';
			response.attributes.forEach(element => {
				rowdata+="<td>"+item[element]+"</td>"
			});
			records+= '<tr>'+rowdata+'</tr>'
	});   
	$('#tblbody').append(records);

	$('#tblheadsingle thead').css('background', 'red');
	$('#tblheadsingle thead').css('color', 'white');
	$("#tblheadsingle").tableHeadFixer();
	$('#displayPopUpsingle').modal('show');
}
function ShowDiskSMARTData(disk, slot)
{
	var request = new Request();
	request.url ="cgi/cgi_statusView.py"
	request.statusType="DiskSMART";
	request.parameters={"disk":disk,"requestType":'read_DisksSMART_Data',"slot":slot};
	CallPythonService(request);
}
function ShowCanisterSMARTData(slot)
{
	var request = new Request();
	request.url ="cgi/cgi_statusView.py"
	request.statusType="CanisterSMART";
	request.parameters={"slot":slot,"requestType":'read_CanisterSMART_Data'};
	CallPythonService(request);
}
function ShowSSDData(ssdId)
{
	var request = new Request();
	request.url ="cgi/cgi_statusView.py"
	request.statusType="SSDFullData";
	request.parameters={"SSDId":ssdId,"requestType":'read_SSDFull_Data'};
	CallPythonService(request);
}
function ShowStoragePoolsData(poolId)
{
	var request = new Request();
	request.url ="cgi/cgi_statusView.py"
	request.statusType="StoragePoolsFullData";
	request.parameters={"poolId":poolId,"requestType":'read_PoolsFull_Data'};
	CallPythonService(request);
}

function BindDiskSMARTData(response,diskId)
{
	
	//var data=response[diskId];
	//var data=response[Math.floor(Math.random() * 5)]; //random from 0-5 to show dummy data
	var data = response[0];
	if(data.status == 'success' && data.attributes.length > 0)
	{
		var cls='.diskrownum_'+diskId;
		$(cls).addClass('highlighted');
		$('#tblResult tr').removeClass('highlighted');
		$('#displayData').css('height', '170px');
		var headerdata = '';
		data.attributes.forEach(element => {
			headerdata+='<th>'+element+'</th>';
		});
		var htmlData=`<div class="table2 cardContainer"><div class="row">  <div class="col-lg-3">  <div class="card">  <h3>Health Status</h3>  <div class="cardBody">  <h4>`+data.headerData.HealthStatus+`</h4>  </div>  </div>  </div>  <div class="col-lg-3">  <div class="card">  <h3>Temprature</h3>  <div class="cardBody">  <h4>`+data.headerData.Temprature+`</h4>  </div>  </div>  </div>  <div class="col-lg-3">  <div class="card">  <h3>Self Test Result</h3>  <div class="cardBody">  <h4>`+data.headerData.TestResult+`</h4>  </div>  </div>  </div>  <div class="col-lg-3">  <div class="card">  <h3>Sector Error count</h3>  <div class="cardBody">  <h4>`+data.headerData.SectorErrorCount+`</h4>  </div>  </div>  </div></div>    <div class="clearfix"></div><div id="displayData" style="display: block; width: 568px; overflow: scroll; height: 200px;">  
						<table width="100%" border="0" class="table-bordered" id="tblDisksSmart">  
							<thead>
								<tr>
									<!--<th>Attribute</th><th>Value</th><th>Normalized</th><th>Threshold</th><th>Worst</th><th>Type</th><th>Assesment</th>-->
									`+headerdata+`
								</tr>
							</thead>
							<tbody id="divDisksRows">   
							</tbody>
						</table>
					</div></div>`;
		$('#divSMARTinfo').html(htmlData);
		var rows='';
		$.each(data.data, function (i, item) {
			var rowdata = '';
			data.attributes.forEach(element => {
				rowdata+="<td>"+item[element]+"</td>"
			});
				
			//var rows='<tr>    <td>'+item.Name+'</td>    <td>'+item.value+'</td> <td>'+item.Normalized+'</td>   <td>'+item.Threshold+'</td>    <td>'+item.worst+'</td>    <td>'+item.Type+'</td> <td>'+item.Assessment+'</td>      </tr> ';
			rows='<tr>'+rowdata+'</tr> ';
			$('#tblDisksSmart tbody').append(rows);
		}); 
		$("#tblDisksSmart").tableHeadFixer();
	}
	else if(data.status == 'fail')
	{
		var htmlData='<div class="table2 cardContainer"><div class="row">  <div class="col-lg-3">  <div class="card">  <h3>Health Status</h3>  <div class="cardBody">  <h4>n/a</h4>  </div>  </div>  </div>  <div class="col-lg-3">  <div class="card">  <h3>Temprature</h3>  <div class="cardBody">  <h4>n/a</h4>  </div>  </div>  </div>  <div class="col-lg-3">  <div class="card">  <h3>Self Test Result</h3>  <div class="cardBody">  <h4>n/a</h4>  </div>  </div>  </div>  <div class="col-lg-3">  <div class="card">  <h3>Sector Error count</h3>  <div class="cardBody">  <h4>n/a</h4>  </div>  </div>  </div></div>    <div class="clearfix"></div><div id="displayData" class="Blink" style="text-align: center; color: red;"><h2>'+data.message+'</h2></div></div>';
		$('#divSMARTinfo').html(htmlData);
	}
}
function GetValueByKey(dataObject,key)
{
	let obj = dataObject.find(o => o.key === key);
	if(obj == undefined)
		return "N/A";
	return obj.value;
}

function BindSSDFullData(response,ssdID)
{
	var cls='.diskrownum_'+ssdID;
	$('#tblResult tr').removeClass('highlighted');
    $(cls).addClass('highlighted');
	
	$('#displayData').css('height', '170px');
	var htmlData='<div class="table2 cardContainer"><div class="clearfix"></div><div id="displayData" style="display: block; width: 568px; overflow: scroll; height: 200px;">  <table width="100%" border="0" class="table-bordered" id="tblDisksSmart">  <thead><tr>    <th>Attribute</th>    <th>Value</th>    <th>Normalized</th>    <th>Threshold</th>    <th>Worst</th> <th>Type</th> <th>Assesment</th></tr></thead><tbody id="divDisksRows">   </tbody></table></div></div>';
	$('#divSMARTinfo').html(htmlData);
	$.each(response, function (i, item) {
		var rows='<tr>    <td>'+item.Name+'</td>    <td>'+item.value+'</td> <td>'+item.Normalized+'</td>   <td>'+item.Threshold+'</td>    <td>'+item.worst+'</td>    <td>'+item.Type+'</td> <td>'+item.Assessment+'</td>      </tr> ';
		$('#tblDisksSmart tbody').append(rows);
	}); 
	$("#tblDisksSmart").tableHeadFixer();
}
function BindPoolsFullData(response,poolId)
{
	var cls='.diskrownum_'+poolId;
	$('#tblResult tr').removeClass('highlighted');
    $(cls).addClass('highlighted');
	
	$('#displayData').css('height', '170px');
	var htmlData='<div class="table2 cardContainer"><div class="clearfix"></div><div id="displayData" style="display: block; width: 568px; overflow: scroll; height: 200px;">  <table width="100%" border="0" class="table-bordered" id="tblDisksSmart">  <thead><tr>    <th>Disk</th>    <th>State</th>    <th>Size (GB)</th>    <th>WWN</th>    <th>Status</th></tr></thead><tbody id="divDisksRows">   </tbody></table></div></div>';
	$('#divSMARTinfo').html(htmlData);
	var result = SetIconPath(response);
	$.each(response, function (i, item) {
		var rows='<tr>    <td>'+item.name+'</td>    <td><img src="' + item.IconPath + '" alt="'+item.state+'" id="state" class="dvstate"></td> <td>'+item.size+'</td>   <td>'+item.wwn+'</td>    <td>'+item.status+'</td></tr> ';
		$('#tblDisksSmart tbody').append(rows);
	}); 
	$("#tblDisksSmart").tableHeadFixer();
}		
// $('#tblhead tr').click(function(e) {
    // $('#tblhead tr').removeClass('highlighted');
    // $(.diskrownum_).addClass('highlighted');
// });

function SaveHost()
{
	var isFormValid = $("#formHostServer").validationEngine('validate');
	if(!isFormValid)
		return;
	var request = new Request();
	request.url ="cgi/cgi_HostManager.py"
	request.statusType="SaveHost";
	request.parameters={"requestType":'create_Host',"hostName":$('#txtHostName').val(),"protocol":$('#ddlHostType').val(),"user":$('#txtHostUser').val(),"password":$('#txtHostPwd').val(),"iqn":$('#txtHostIQN').val(),"wwn":$('#txtHostWWN').val()};
	CallPythonService(request);
}
function UpdateHost()
{
	var isFormValid = $("#formHostServer").validationEngine('validate');
	if(!isFormValid)
		return;
	var request = new Request();
	request.url ="cgi/cgi_HostManager.py"
	request.statusType="SaveHost";
	request.parameters={"requestType":'update_Host',"hostId":$('#ddlHostNames').val(),"hostName":$('#txtHostName').val(),"protocol":$('#ddlHostType').val(),"user":$('#txtHostUser').val(),"password":$('#txtHostPwd').val(),"iqn":$('#txtHostIQN').val(),"wwn":$('#txtHostWWN').val()};
	CallPythonService(request);
}
function DeleteHost()
{
	var isFormValid = $("#formHostServer").validationEngine('validate');
	if(!isFormValid)
		return;
	var request = new Request();
	request.url ="cgi/cgi_HostManager.py"
	request.statusType="SaveHost";
	request.parameters={"requestType":'delete_Host',"hostId":$('#ddlHostNames').val()};
	CallPythonService(request);
}
function GetAllProtocol()
{
	var request = new Request();
	request.url ="cgi/cgi_HostManager.py"
	request.statusType="getProtocol";
	request.parameters={"requestType":'read_Protocol'};
	CallPythonService(request);
}
$('#ddlHostNames').change(function(){
	var request = new Request();
	request.url ="cgi/cgi_HostManager.py"
	request.statusType="getHostById";
	request.parameters={"requestType":'read_Host',"hostId":$(this).val()};
	CallPythonService(request);
});
$('#ddlHostType').change(function(){
	//$('#txtHostName').val('');
	
	SetUpGrayedOutRules(1);
});
function SetUpGrayedOutRules(protocolId)
{
	if(hostActionPage == 'Delete')
		return;
	var protocol=$('#ddlHostType').val();
	var rule = hostGrayedOutRules[protocol-1];
	
	if(rule.user == 0){
		$('#txtHostUser').attr('disabled',true);
		$('#txtHostUser').val('');
	}
	else
		$('#txtHostUser').attr('disabled',false);
	
	if(rule.password == 0){
		$('#txtHostPwd').attr('disabled',true);
		$('#txtHostPwd').val('');
	}
	else
		$('#txtHostPwd').attr('disabled',false);
	
	if(rule.iqn == 0){
		$('#txtHostIQN').attr('disabled',true);
		$('#txtHostIQN').val('');
	}
	else
		$('#txtHostIQN').attr('disabled',false);
	
	
	if(rule.wwn == 0){
		$('#txtHostWWN').attr('disabled',true);
		$('#txtHostWWN').val('');
	}
	else
		$('#txtHostWWN').attr('disabled',false);
}

$('.clsHostPage').click(function(){
	$('.clsHostPage').removeClass('alert-danger');
	$(this).addClass('alert-danger');
	BindAllHosts();	
});

function BindAllHosts()
{
	var request = new Request();
	request.url ="cgi/cgi_HostManager.py"
	request.statusType="getHosts";
	request.parameters={"requestType":'read_Host',"hostId":0};
	CallPythonService(request);
}
function openHostPopup()
{
	//$('#btnHostAdd').trigger('click');
}
function HostPageNavigate(page)
{
	$('#txtHostName').val('')
	$('#txtHostUser').val('');
	$('#txtHostPwd').val('');
	$('#txtHostIQN').val('');
	$('#txtHostWWN').val('');
	
	$('.hostFieldCls').attr('disabled',false);
	GetAllProtocol();
	$('#divHostNew').css('display','none');
	hostActionPage = page;
	
	if(page == 'Add'){
		$('.clsHostNames').css('display','none');
		$('#btnHostAction').attr('onclick','SaveHost()').html('Confirm');
		$('#divHostNew').css('display','block');
		BindAllHosts();
		
	}
	else if(page == 'Edit'){
		$('.clsHostNames').css('display','block');
		$('#btnHostAction').attr('onclick','UpdateHost()').html('Confirm');
		$('#divHostNew').css('display','block');
	}
	else if(page == 'Delete'){
		$('.clsHostNames').css('display','block');
		$('#btnHostAction').attr('onclick','DeleteHost()').html('Confirm');	
		$('#divHostNew').css('display','block');
		$('.hostFieldCls').attr('disabled',true);		
	}	
	else
	{
		$('.clsHostPage').removeClass('alert-danger');
	}
}
// Host Manager code End

// Volume Manager code Start
$('.clsVolumePage').click(function(){
	$('.clsVolumePage').removeClass('alert-danger');
	$(this).addClass('alert-danger');
});

function VolumeMgrPageNavigate(page)
{
		$('#txtVolumeSize').val('');
		$('#txtVolumeLUN').val('');
		$('#txtVolumeName').val('');
		
		
		$('#ddlVolumeProtocol').attr('disabled',false);
		$('#ddlVolumeHost').attr('disabled',false);
		$('#ddlvolumePorts').attr('disabled',false);
		$('#chkCompression').attr('disabled',false);
		$('#chkDedup').attr('disabled',false);
		$('#txtVolumeLUN').attr('disabled',false);
		$('#ddlVolumePool').attr('disabled',false);
		$('#txtVolumeSize').attr('disabled',false);
	
	$('#divNewVolumeMgr').hide();
	if(page == 'Add'){
		BindVolumeDefaultData();
		$('#txtVolumeName').show();
		$('#ddlVolumeNames').hide();
		$('#divNewVolumeMgr').show();
		$('#btnVolumeAction').attr('onclick','SaveVoume()');
	}
	else if(page == 'Edit')
	{
		BindVolumeDefaultData();
		$('#txtVolumeName').hide();
		$('#ddlVolumeNames').show();
		$('#divNewVolumeMgr').show();
		$('#btnVolumeAction').attr('onclick','UpdateVoume()');
		$('#ddlVolumeProtocol').attr('disabled',true);
		$('#ddlVolumeHost').attr('disabled',true);
	}
	else if(page == 'Delete')
	{
		BindVolumeDefaultData();
		$('#txtVolumeName').hide();
		$('#ddlVolumeNames').show();
		$('#divNewVolumeMgr').show();
		$('#btnVolumeAction').attr('onclick','DeleteVoume()');
		
		$('#ddlVolumeProtocol').attr('disabled',true);
		$('#ddlVolumeHost').attr('disabled',true);
		$('#ddlvolumePorts').attr('disabled',true);
		$('#chkCompression').attr('disabled',true);
		$('#chkDedup').attr('disabled',true);
		$('#txtVolumeLUN').attr('disabled',true);
		$('#ddlVolumePool').attr('disabled',true);
		$('#txtVolumeSize').attr('disabled',true);
	}
	else if(page== 'cancel')
	{
		$('#divNewVolumeMgr').hide();
		$('.clsVolumePage').removeClass('alert-danger');
	}
	BindVolumeSavedData();
}
function BindVolumeDefaultData()
{
	selectedProtocol=0;
	var request = new Request();
	request.url ="cgi/cgi_HostManager.py"
	request.statusType="getHostsForVolume";
	request.parameters={"requestType":'read_Host',"hostId":0};
	CallPythonService(request);
	
	var request = new Request();
	request.url ="cgi/cgi_Pool_Get.py"
	request.statusType="getStoragePools";
	request.parameters={"requestType":'read_pool'};
	CallPythonService(request);
	
	var request = new Request();
	request.url ="cgi/cgi_VolumeManager.py"
	request.statusType="getEthernetPorts";
	request.parameters={"requestType":'read_Ethernet_ports'};
	CallPythonService(request);
	
	var request = new Request();
	request.url ="cgi/cgi_HostManager.py"
	request.statusType="getProtocolForVolume";
	request.parameters={"requestType":'read_Protocol'};
	CallPythonService(request);
	
}
function SaveVoume()
{
	var isFormValid = $("#formVolumeMgr").validationEngine('validate');
	if(!isFormValid)
		return;
	var dedup = $('#chkDedup').is(":checked");
	var compression = $('#chkCompression').is(":checked");
	//var selectedhosts = $('#ddlVolumeHost').val() != null ? $('#ddlVolumeHost').val().toString():'0';
	
	var request = new Request();
	request.url ="cgi/cgi_VolumeManager.py"
	request.statusType="SaveVolume";
	request.parameters={"requestType":'create_Volume',"volumeName":$('#txtVolumeName').val(),"size":$('#txtVolumeSize').val(),"dedup":dedup,"compression":compression,"protocolId":$('#ddlVolumeProtocol').val(),"poolId":$('#ddlVolumePool').val(),"hostId":$('#ddlVolumeHost').val(),"lun":$('#txtVolumeLUN').val(),"portId":$('#ddlvolumePorts').val()};
	CallPythonService(request);
}
function UpdateVoume()
{
	var isFormValid = $("#formVolumeMgr").validationEngine('validate');
	if(!isFormValid)
		return;
	
	var dedup = $('#chkDedup').is(":checked");
	var compression = $('#chkCompression').is(":checked");
	
	var request = new Request();
	request.url ="cgi/cgi_VolumeManager.py"
	request.statusType="SaveVolume";
	request.parameters={"requestType":'update_Volume',"volumeId":$('#ddlVolumeNames').val(),"size":$('#txtVolumeSize').val(),"dedup":dedup,"compression":compression,"protocolId":$('#ddlVolumeProtocol').val(),"poolId":$('#ddlVolumePool').val(),"hostId":$('#ddlVolumeHost').val(),"lun":$('#txtVolumeLUN').val(),"portId":$('#ddlvolumePorts').val()};
	CallPythonService(request);
}
function DeleteVoume()
{
	var isFormValid = $("#formVolumeMgr").validationEngine('validate');
	if(!isFormValid)
		return;
	var request = new Request();
	request.url ="cgi/cgi_VolumeManager.py"
	request.statusType="SaveVolume";
	request.parameters={"requestType":'delete_Volume',"volumeId":$('#ddlVolumeNames').val()};
	CallPythonService(request);
}
function BindVolumeSavedData()
{
	var request = new Request();
	request.url ="cgi/cgi_VolumeManager.py"
	request.statusType="getVolumeSavedData";
	request.parameters={"requestType":'read_Volume','volumeId':0};
	CallPythonService(request);
}
$('#ddlVolumeNames').change(function(){
	var request = new Request();
	request.url ="cgi/cgi_VolumeManager.py"
	request.statusType="getVolumeById";
	request.parameters={"requestType":'read_Volume','volumeId':$(this).val()};
	CallPythonService(request);
});

function OnOffVolume(volumeId,state)
{
	var request = new Request();
	request.url ="cgi/cgi_VolumeManager.py"
	request.statusType="changeVolumeState";
	request.parameters={"requestType":'onOff_Volume','volumeId':volumeId,"state":state};
	CallPythonService(request);
}
function SnapShotVolume(volumeId,volumeName)
{	
	$('#volumeSnapshotPop').modal('show');	
	$('#txtSnapshotName').val(volumeName + "-ss1");
	$('#btnVolumeSnap').attr('onclick',"SaveSnapshotVolume("+volumeId+")");
}
$('#txtSnapshotName').on('input',function(){
	if($(this).val().length > 0)
		$('#btnVolumeSnap').show();
	else
		$('#btnVolumeSnap').hide();
})
function VolumeInfo(size)
{
	$('#lblSize').text(size + ' GB');
	$('#volumeInfoPop').modal('show');
}
function SaveSnapshotVolume(volumeId)
{
	var snapShotName = $('#txtSnapshotName').val();
	var request=new Request();
	request.url ="cgi/cgi_VolumeManager.py"
	request.statusType = 'SaveSnapVolume';
	request.parameters = {"requestType":'snapShot_volume',"volumeId":volumeId,"snapShotName":snapShotName};			
	CallPythonService(request);
}

$('#ddlVolumeProtocol').change(function(){
	selectedProtocol = $(this).val();
	var request = new Request();
	request.url ="cgi/cgi_VolumeManager.py"
	request.statusType="getHostsForVolume";
	request.parameters={"requestType":'read_HostByProtocol',"protocolId":selectedProtocol};
	CallPythonService(request);
});

function OpenChartGroupSelection(showclass)
{
	$('.clsDevice').hide();
	$('.'+showclass).show();
}
function ShowChart()
{
	$('#divMetrics').hide();
	var deviceList=$("input[name='chartGroup']:checked").val();
	var scale =$("input[name='chartSclae']:checked").val();
	var grpName = $("input[name='chartGroup']:checked").attr('group');
	var metric=$('#ddlDeviceMetric').val();
	InitializeChart(deviceList,scale,grpName,metric);
}

/*function ShowApplicationChart()
{
	$('#divMetrics').hide();
	$('#divApplications').hide();
	
	var deviceList=$("input[name='chartAppGroup']:checked").val();
	var scale =$("input[name='chartSclae']:checked").val();
	var grpName = $("input[name='chartAppGroup']:checked").attr('group');
	var appName = $('#ddlApplication').val();
	var metric=$('#ddlDeviceMetric').val();
	$("input[name='chartAppGroup']:checked").prop('checked', false);
	InitializeApplicationChart(deviceList,scale,grpName,metric,appName);
}*/

$('input[type=radio][name=chartGroup]').change(function() {
	$("#showGraph").attr("onclick","ShowChart()");
	var device=$("input[name='chartGroup']:checked").val();
	BindMetricsData(device);
	$('#divMetrics').show();
});
$('input[type=radio][name=chartGroup]').click(function() {
	$("#showGraph").attr("onclick","ShowChart()");
	var device=$("input[name='chartGroup']:checked").val();
	BindMetricsData(device);
	$('#divMetrics').show();
});

/*$('input[type=radio][name=chartAppGroup]').change(function() {
	$("#showGraph").attr("onclick","ShowApplicationChart()");
	var device=$("input[name='chartAppGroup']:checked").val();
	BindApplicationDevices(device);
	//$('#divApplications').show();
});
$('input[type=radio][name=chartAppGroup]').click(function() {
	$("#showGraph").attr("onclick","ShowApplicationChart()");
	var device=$("input[name='chartAppGroup']:checked").val();
	BindApplicationDevices(device);
	//$('#divApplications').show();
});

$('#ddlApplication').change(function(){
	var device=$("input[name='chartAppGroup']:checked").val();
	BindMetricsData(device);
	$('#divMetrics').show();
});
$('#ddlApplication').click(function(){
	var device=$("input[name='chartAppGroup']:checked").val();
	BindMetricsData(device);
	$('#divMetrics').show();
});*/

$('#ddlDeviceMetric').change(function(){
	$('#aMetricInfo').attr('data-original-title',$("#ddlDeviceMetric").val()+ ' info content here');
});
function BindMetricsData(device)
{
	var request = new Request();
	request.url ="cgi/cgi_CollectD_Manager.py"
	request.statusType="getMetricsByDevice";
	request.parameters={"requestType":'get_Metrics',"deviceList":device};
	CallPythonService(request);
}
/*function BindApplicationDevices(device)
{
	var request = new Request();
	request.url ="cgi/cgi_CollectD_Manager.py"
	request.statusType="getApps";
	request.parameters={"requestType":'get_Apps',"deviceList":device};
	CallPythonService(request);
}*/
$('.clsChartScale').change(function(){
	ShowChart();
});
$('#btnResizeGraph').click(function(){
	if($(this).attr('currentView') == 'small'){
		 $(this).attr('ht',$('.serverMiddle' ).height());
		 $(this).attr('wd',$('.serverMiddle' ).width());
		 $(this).attr('ContainerHt',$('#container').height());
		 $(this).attr('currentView','full');
		 $(this).val('Zoom Out');
		 $('.serverContainer').hide();
		 $('.serverMiddle' ).width( $(window).width()-54 );
		 $('.serverMiddle' ).height( $(window).height() );
		 $('#container').height( $(window).height() -200);	
		 
			$('html, body').animate({
				scrollTop: ($('.serverMiddle').first().offset().top)
			},500);
	}
	else
	{
		$(this).attr('currentView','small');
		$(this).val('Zoom In');
		$('.serverContainer').show();
		$('.serverMiddle' ).width( $(this).attr('wd') );
		$('.serverMiddle' ).height( $(this).attr('ht') );
		$('#container' ).height( $(this).attr('ContainerHt') );
		
	}
	ShowChart();
	
});
function GetString(str)
{
	if(str == null)
		return 'n/a';
	else
		return str;
}

function trimString(valueString, lengthValue) {
    var len = String(valueString).trim().length;
    var newValueString = valueString;
    if (len > lengthValue) {
        newValueString = String(valueString).substr(0, lengthValue) + '...';
    }
    return newValueString;
}
function BindDiskImage()
{	
	var request = new Request();
	request.url = 'cgi/cgi_statusView.py';
	request.parameters = { requestType:'read_Disks'};
	InvokePythonService(request).then(function(response) {
		var hddCount = 1;
		var ssdCount = 1
		$.each(response, function(i, item) {
			if(item.rotation == 'HDD'){
				$("[poolType="+item.rotation+"][Number="+hddCount+"]").attr("onclick","GetStatusbyType('disks','"+item.wwn+"')").attr('title',item.name);
				hddCount +=1;
			}
			else
			{
				$("[poolType="+item.rotation+"][Number="+ssdCount+"]").attr("onclick","GetStatusbyType('disks','"+item.wwn+"')").attr('title',item.name);
				ssdCount +=1;
			}
		});
		$('[data-toggle="tooltip"]').tooltip()
	}).catch(function(ex) {
		console.log(ex);
	});
}
BindDiskImage()



function ShowSSDChart()
{
	$('#popUpSSDChart').modal('show');
	var request = new Request();
	request.url = 'cgi/cgi_statusView.py';
	request.parameters = { requestType:'read_SSDChartData'};
	InvokePythonService(request).then(function(response) {
		SSDChartOthers(response.ssdOtherUsage);
		SSDChartDataUsage(response.ssdDataUsage);
	}).catch(function(ex) {
		console.log(ex);
	});
	
	
}
function SSDChartDataUsage(response)
{
	var chartData = [];
	var drillDownData = [];
	$.each(response, function(i, item) { 
		chartData.push({name:item.name,y:item.used,drilldown:item.name});
		
		var listDataDrillDown = [];
		$.each(item.List, function(j, record) { 
			listDataDrillDown.push([record.name,record.size]);
		});
		if(listDataDrillDown.length > 0){
			drillDownData.push({
				name: item.name,
				id: item.name,
				data: listDataDrillDown
			});
		}
	});	
	
		
	Highcharts.chart('divSSDChartData', {
    chart: {
        type: 'pie',
		options3d: {
            enabled: true,
            alpha: 60,
            beta: 0
        }
    },
    title: {
        text: 'SSD Pool usage',
		style: { "color": "black", "fontSize": "20px" ,fontWeight: 'bold'},
    },
    subtitle: {
        text: 'Click on storage type to see in details.'
    },
	exporting: {
			enabled: false
	},
    plotOptions: {
        series: {
            dataLabels: {
                enabled: true,
                format: '{point.name}: {point.y:.1f}%'
            }
        },
		pie: {
            allowPointSelect: true,
            cursor: 'pointer',
            depth: 35,
            dataLabels: {
                enabled: true,
                format: '{point.name}'
            }
        }
    },

    tooltip: {
        headerFormat: '<span style="font-size:11px">{series.name}</span><br>',
        pointFormat: '<span style="color:{point.color}">{point.name}</span>: <b>{point.y:.2f}%</b> of total<br/>'
    },
    series: [{
        name: 'Storage',
        colorByPoint: true,
        data: chartData
    }],
    drilldown: {
        series: drillDownData
    }

	});	
}


function SSDChartOthers(response)
{
	
	var ssdOtherUsageData = [];
	var drillDownData=[];
	
	$.each(response, function(i, item) { 
		ssdOtherUsageData.push({name:item.name,y:item.used,drilldown:''});
		
		
		var listDataDrillDown = [];
		$.each(item.List, function(j, record) { 
			listDataDrillDown.push([record.name,record.size]);
		});
		if(listDataDrillDown.length > 0){
			drillDownData.push({
				name: item.name,
				id: item.name,
				data: listDataDrillDown
			});
		}
	});	
	
		
	Highcharts.chart('divSSDChartOther', {
    chart: {
        type: 'pie',
		options3d: {
            enabled: true,
            alpha: 60,
            beta: 0
        }
    },
    title: {
        text: 'SSD Pool used for acceleration/cache',
		style: { "color": "black", "fontSize": "20px" ,fontWeight: 'bold'},
    },
    subtitle: {
        text: 'Click on storage type to see in details.'
    },
	exporting: {
			enabled: false
	},
    plotOptions: {
        series: {
            dataLabels: {
                enabled: true,
                format: '{point.name}: {point.y:.1f}%'
            }
        },
		pie: {
            allowPointSelect: true,
            cursor: 'pointer',
            depth: 35,
            dataLabels: {
                enabled: true,
                format: '{point.name}'
            }
        }
    },

    tooltip: {
        headerFormat: '<span style="font-size:11px">{series.name}</span><br>',
        pointFormat: '<span style="color:{point.color}">{point.name}</span>: <b>{point.y:.2f}%</b> of total<br/>'
    },
    series: [{
        name: 'Storage',
        colorByPoint: true,
        data: ssdOtherUsageData
    }],
    drilldown: {
        series: drillDownData
    }
});

		
}

function InvokePythonService(request) {
	return new Promise(function(resolve, reject) {
		request.parameters.uuid=uuid;
		$.ajax({
			type: "Get",
			url: request.url,
			contentType: 'application/json',
			dataType: 'json',
			headers: { 'Access-Control-Allow-Origin': '*' },
			data: request.parameters,
			success: function (response) {
				resolve(response) ;
			},
			error: function (ex) {
				reject(ex); // Reject the promise and go to catch()
				if(!isProduction){
					console.log(ex);
				}
			}
		});
	});
}
var diskUploadId = '';
function openConfigfileUpload(diskid)
{
    diskUploadId = diskid;
	$('#fileUploadIfSrc').attr('src','configfileUpload.html');
    $('#divFileUpload').modal('show');
}
function OnOffDisks(disk, status) {
	//console.log("Disk : ", disk, " Status : ", status);
	var request = new Request();
	request.url ="cgi/cgi_DiskStatusViewActionManager.py"
	request.statusType="doNothing";
	request.parameters={"requestType":'onOff_Disk','diskid':disk,"status":status};
	CallPythonService(request);
}
function ejectDisk(disk) {
	//console.log("ejected disk : ", disk);
	var request = new Request();
	request.url ="cgi/cgi_DiskStatusViewActionManager.py"
	request.statusType="doNothing";
	request.parameters={"requestType":'eject_Disk','disk':disk};
	CallPythonService(request);
}

$('input[name="serverComponents"]').on('click',function(){
	var component = $(this).attr('component');
	var title = $(this).attr('data-original-title');
	var request = new Request();
	request.parameters = {"requestType":"read_component","component":component,"title":title};
	request.url = 'cgi/cgi_statusView.py';	
	request.statusType="ReadComponent";
	request.isSingleStatus=false;
	CallPythonService(request);	
});