var currentState = 0;
var vmID = 0;
var systemUsage = {};
var userSelectedGroups = [];
var allDBGroups = [];
$(window).bind("load", function () {
    GetImageNames();
    BindAllNetworks();
    BindSystemUsage();
    if (location.hash.substr(1) > 0) {
        ShowImgDetatils(location.hash.substr(1));
        vmID = location.hash.substr(1);
        $('#spanTitle').html('View');
        //window.location.replace("#");
    }
    //BindSystemUsage();   #It was here before
});
function Request() {
    var request = {
        url: "",
        parameters: {},
        Type: ""
    };
    return request;
}
function CallPythonService(request) {
    request.parameters.uuid = uuid;
    $.ajax({
        type: "Get",
        url: request.url,
        contentType: 'application/json',
        dataType: 'json',
        headers: { 'Access-Control-Allow-Origin': '*' },
        data: request.parameters,
        success: function (response) {
            BindResponseData(request.Type, response);
        },
        error: function (ex) {
            if (!isProduction) {
                console.log(ex);
            }
        }
    });
}
function BindResponseData(Type, response) {
    if (Type === 'AllImages') {
        if (location.hash.substr(1) > 0) {
            response = jQuery.grep(response, function (n, i) {
                return (n.id == location.hash.substr(1));
            });
            $('#divSingleVM').css('display', 'block');
        }
        $.each(response, function (i, item) {
            var imgHtml = '<div class="col-xs-6"> <a href="#" class="redBox" data-toggle="modal" onclick="ShowImgDetatils(' + item.id + ')"><figure><img src=".' + item.iconPath + '" alt="' + item.name + '"></figure><h5>' + item.name + '</h5></a> </div>'
            $('#divImgs').append(imgHtml);
        });
        //window.location.replace("#");		
    }
    else if (Type == 'ShowPopUp') {
        $('#myModalLabelPop').html(response.VirtualServername);
        //$('#imgIconPop').html('<img src=".' + response.iconPath + '">');
        $('#groupPop').html(response.GroupName);
        $('#imagePop').html(response.ImageName);

        $('#vcpuPop').html(response.vcpu);
        $('#memoryPop').html(response.memory);
        $('#storagePop').html(response.storage);
        $('#pathPop').html(response.path);
        $('#CreatedDatePop').html(response.cr_date);
        $('#startedDatePop').html(response.start_date);
        $('#remotebackupPop').html(response.last_remoteBck);
        $('#localbackupPop').html(response.last_localBck);
        $('#attachedDisksPop').html((response.attachedDisks).slice(1));
        $('#selectedGroups').html(response.mappedGroups.selectedGroupNames.join(', '));

        userSelectedGroups = response.mappedGroups.selectedGroups;

        $('#SVMGroup').html(response.GroupName);
        $('#redirectConsole').attr("onclick", "RedirectToConsole('" + response.ImageName + "','" + response.portNo + "')");
        $('#SVMImage').html(response.ImageName);
        $('#SVMvCPU').html(response.vcpu);
        $('#SVMMemory').html(response.memory);
        $('#SVMStorage').html(response.storage);
        $('#SVMPath').html(response.path);
        $('#SVMDesc').html(response.Desc);
        $('#SVMPrice').html(response.Price);

        //$('#popImgDetatils').modal('show');
        GetServerDetails(response.VirtualServername);
        //system usage update
        //console.log("VCPU Value : " + response.vcpu);
        systemUsage.vcpu.Used_vCPU = response.vcpu;
        systemUsage.storage.Used_Storage = response.memory;
        systemUsage.memory.Used_Memory = response.storage;
        BindSystemUsageDynamic(systemUsage);
    }
    else if (Type === 'SystemUsage') {
        //console.log("BindSystemUsage :", response);
        //BindSystemUsageDynamic(response);
        systemUsage = response;


    }
    else if (Type === 'AllNetwork') {
        $('#divNetworkCidr').html('');
        $.each(response, function (i, item) {
            //$("#divNetworkCidr").append('<div class="repeatBox"><div class="checkBox-Item"><input name="chkNetwork" type="checkbox" value="" class="checkbox" id="chk_' + item.id + '"  disabled="disabled" ></div><div class="form-Container"><input name="" type="text" id="txtNetwork" class="form-control" title="' + item.network_name + '" value="' + item.network_name + '" disabled="disabled"></div><div class="form-Container"><input name="" type="text" id="txtCidr" class="form-control" title="' + item.cidr + '" value="' + item.cidr + '" disabled="disabled"></div> </div>');
            $("#divNetworkCidr").append('<div class="repeatBox"><div class="checkBox-Item"><input name="chkNetwork" type="checkbox" value="" class="checkbox" id="chk_' + item.id + '"  disabled="disabled" ></div><div class="form-Container"><input name="txtNetwork" type="text" class="form-control" title="' + item.network_name + '" value="' + item.network_name + '" disabled="disabled"></div><div class="form-Container"><input name="txtCidr" type="text" class="form-control" title="' + item.cidr + '" value="' + item.cidr + '" disabled="disabled"></div> </div>');
        });
        //BindLedStates(availableSources.currentState)
    }
    else if (Type === 'ServerDetails') {
        $('#divNetworkCidr').html('');
        $('#btnPause').attr('class', 'smbtn yellow');

        $.each(response, function (i, item) {
            //$("#divNetworkCidr").append('<div class="repeatBox"><div class="checkBox-Item"><input name="chkNetwork" type="checkbox" disabled="disabled" value="" checked="checked" class="checkbox" id="chk_' + item.id + '"></div><div class="form-Container"><input name="" type="text" id="txtNetwork" class="form-control" title="' + item.NetworkName + '" value="' + item.NetworkName + '" disabled="disabled"></div><div class="form-Container"><input name="" title="' + item.cidr + '" type="text" id="txtCidr" class="form-control" value="' + item.cidr + '" disabled="disabled"></div> </div>');
            $("#divNetworkCidr").append('<div class="repeatBox"><div class="checkBox-Item"><input name="chkNetwork" type="checkbox" disabled="disabled" value="" checked="checked" class="checkbox" id="chk_' + item.id + '"></div><div class="form-Container"><input name="txtNetwork" type="text" class="form-control" title="' + item.NetworkName + '" value="' + item.NetworkName + '" disabled="disabled"></div><div class="form-Container"><input name="txtCidr" title="' + item.cidr + '" type="text" class="form-control" value="' + item.cidr + '" disabled="disabled"></div> </div>');
        });

        $('#txtvmName').html(response[0].ServerName);
        currentState = response[0].State;
        if (response[0].State === 6) {
            $('#btnState').attr('class', 'smbtn led-green');
            $('#btnState').attr('title', 'On');
            $('#btnState').text('On');

            //$('#btnOn').attr('class', 'smbtn led-green');
            //$('#btnOff').attr('class', 'smbtn red');
            //$('#btnLogs').attr('class', 'smbtn blue');
            //$('#btnOn').addClass('led-green');            
        }
        else if (response[0].State === 4) {
            $('#btnState').attr('class', 'smbtn led-red');
            $('#btnState').attr('title', 'Off');
            $('#btnState').text('Off');

            //$('#btnOff').attr('class', 'smbtn led-red');
            //$('#btnOn').attr('class', 'smbtn green');
            //$('#btnLogs').attr('class', 'smbtn blue');
            //$('#btnOff').removeClass('red');
            //$('#btnOff').addClass('led-red');
        }
        else {
            $('#btnState').attr('class', 'smbtn green');
            $('#btnPause').attr('class', 'smbtn led-yellow');
            $('#btnPause').attr('title', 'pause');
            $('#btnState').attr('title', 'Pause');
            $('#btnState').text('On');
            //    $('#btnLogs').attr('class', 'smbtn led-blue');
            //    $('#btnOff').attr('class', 'smbtn red');
            //    $('#btnOn').attr('class', 'smbtn green');
            //$('#btnLogs').removeClass('blue');
            //$('#btnLogs').addClass('blue-red');
        }

    }
    else if (Type == 'ShowAppGroups') {
        allDBGroups = response;
        var table = $('#tblOrgGroups').DataTable();
        table.destroy();
        var groupsData = `<thead><th>#</th><th>Group Name</th><th>Description</th><th>Status</th></thead><tbody id="tbodyGroupsData" ></tbody>`
        $('#tblOrgGroups').html(groupsData);
        $.each(allDBGroups, function (i, item) {
            var selectedStatus = userSelectedGroups.indexOf(item.id) != -1 ? 'checked' : '';
            var mappedStatus = userSelectedGroups.indexOf(item.id) != -1 ? 'Selected' : '';
            var rowData = '<tr><td><input type="checkbox" value="' + item.id + '" class="clsOrgGroups" name="clsOrgGroups" ' + selectedStatus + ' disabled/></td><td>' + item.name + '</td><td>' + item.description + '</td><td>' + mappedStatus + '</td></tr>';
            $('#tbodyGroupsData').append(rowData);
        });
        $('.clsOrgGroups').bind('change', function () {
            if (this.checked) {
                userSelectedGroups.push(parseInt(this.value));
            }
            else {
                var valuesToRemove = [parseInt(this.value)]
                userSelectedGroups = userSelectedGroups.filter(item => !valuesToRemove.includes(item))
            }

            // $('#txtSelectedGroups').val(GetSelectedGroupNames());
            // $('#txtSelectedGroups').attr('title',GetSelectedGroupNames());
        });
        $('#tblOrgGroups').DataTable();
    }
}
function ShowImgDetatils(id) {
    var request = new Request();
    request.url = "cgi/cgi_myServersView_details.py";
    request.parameters = { 'id': id };
    request.Type = "ShowPopUp";
    CallPythonService(request);

}
function GetImageNames() {
    var request = new Request();
    request.url = "cgi/cgi_myServersView_getNames.py";
    request.Type = "AllImages";
    CallPythonService(request);
}
function GetServerDetails(vmName) {
    var request = new Request();
    request.url = "cgi/cgi_myServerView_get_ntwDetails.py";
    request.parameters = { 'server_name': vmName };
    request.Type = "ServerDetails";
    CallPythonService(request);
}
function BindSystemUsage() {
    var request = new Request();
    request.url = "cgi/cgi_myServer_SystemUsage.py";
    request.Type = "SystemUsage";
    CallPythonService(request);
}
function BindAllNetworks() {
    var request = new Request();
    request.url = "cgi/cgi_myserver_get_GIN.py";
    request.Type = 'AllNetwork';
    request.parameters = { "getType": "network" };
    CallPythonService(request);
}
$('#btnRedirectEdit').click(function () {
    var url = "vmstatus-edit.html?type=Edit#" + vmID;
    if (currentState != 4) {
        $('#erYES').attr('onclick', 'location.href="' + url + '"');
        $('#editRedirect').modal('show');
    }
    else {
        location.href = url;
    }

});
function showVMLogs() {
    var request = new Request();
    request.url = "cgi/cgi_App_Manager.py";
    request.Type = 'GetVmVDisks';
    request.parameters = {
        "VMId": vmID, "requestType": "read_AppLogs"
    };
    CallPythonService(request);
}
function BindSystemUsageDynamic(response) {
    //console.log("vcpu" + response.vcpu.Used_vCPU);
    $('#vcpuUsed').html('Used :<i>' + response.vcpu.Used_vCPU + '</i>');
    $('#vcpuAvailable').html('Available : <i>' + response.vcpu.Available_vCPU + '</i>');
    $('#vcpuTotal').html('Total: <i>' + response.vcpu.Total_vCPU + '<i>');
    $('#MemoryUsed').html('Used :<i>' + response.memory.Used_Memory.toFixed(2) + ' GB</i>');
    $('#MemoryAvailable').html('Available : <i>' + response.memory.Available_Memory.toFixed(2) + ' GB</i>');
    $('#MemoryTotal').html('Total :<i>' + response.memory.Total_Memory.toFixed(2) + ' GB</i>');
    $('#StorageUsed').html('Used : <i>' + response.storage.Used_Storage.toFixed(2) + ' TB</i>');
    $('#StorageAvailable').html('Available :<i>' + response.storage.Available_Storage.toFixed(2) + ' TB</i>');
    $('#StorageTotal').html('Total : <i>' + response.storage.Total_Storage.toFixed(2) + ' TB</i>');

    $('#sliderVcpu').css('transform', 'rotate(' + ((response.vcpu.Used_vCPU * 100 / response.vcpu.Total_vCPU) * 2.6 - 130) + 'deg)');
    $('#sliderStorage').css('transform', 'rotate(' + ((response.storage.Used_Storage * 100 / response.storage.Total_Storage) * 2.6 - 130) + 'deg)');
    $('#sliderMemory').css('transform', 'rotate(' + ((response.memory.Used_Memory * 100 / response.memory.Total_Memory) * 2.6 - 130) + 'deg)');


    $('#vcpuSlider').val(response.vcpu.Used_vCPU * 100 / response.vcpu.Total_vCPU);
    $('#storageSlider').val(response.storage.Used_Storage * 100 / response.storage.Total_Storage);
    $('#memorySlider').val(response.memory.Used_Memory * 100 / response.memory.Total_Memory);
    //Range Slider starts here
    var rangeSlider = function () {
        var slider = $(".range-slider"),
            range = $(".range-slider__range"),
            value = $(".range-slider__value");

        slider.each(function () {
            value.each(function () {
                var value = $(this).prev().attr("value");
                $(this).html(value);
            });

            range.on("input", function () {
                $(this).next(value).html(this.value);
            });
        });
    };

    rangeSlider();
}
function ShowAppGroups() {
    var request = new Request();
    request.url = "cgi/cgi_Organization_Manager.py";
    request.parameters = { "RequestType": 'read_Group', "groupId": 0 };
    request.Type = "ShowAppGroups";
    CallPythonService(request);
    $('#orgSetupGroupsPopup').modal('show');
}