function Request() {
    var request = {
        url: "",
        parameters: {},
        statusType: ""
    };
    
    $('#displayData').css('overflow', 'scroll');
    $('#displayData').css('height', '450px');
    $('#displayData').css('width', '568px');
    
    return request;
}
function ShowStatus(statusType) {
    var request = new Request();
    if (statusType === 'fans') {
        request.url = "cgi/cgi_fanStatus.py";
    }
    else if (statusType === 'cpu') {
        request.url = "cgi/cgi_cpuStatus.py";
    }
    else if (statusType === 'network')
    {
        request.url = "cgi/cgi_networkStatus.py";
    }
    else if (statusType === 'psu1') {
        request.url = "cgi/cgi_psuStatus.py";
    }    
    else if (statusType === 'psu2') {
        request.url = "cgi/cgi_psuStatus.py";
    }
    else if (statusType === 'disks')
    {
        request.url = "cgi/cgi_disksStatus.py";
    }
    if (request.url != "") {
        request.statusType = statusType;
        CallPythonService(request);
    }
}
function CallPythonService(request) {
	request.parameters.uuid=uuid;
    $.ajax({
        type: "Get",
        url: request.url,
        contentType: 'application/json',
        dataType: 'json',
        headers: { 'Access-Control-Allow-Origin': '*' },
        data: request.parameters,
        success: function (response) {
            BindResponseData(request.statusType,response);
        },
        error: function (ex) {
            if(!isProduction){
				console.log(ex);
				alert(ex);	
			}
        }
    });
}
function BindResponseData(statusType, response) {
    var result = SetIconPath(response);
    if (statusType === 'fans') {
        $('#displayHeader').html('Fan Status View');
        var tableHeader = '<table border="1" class="table table-curved tbdata" id="tblhead"><thead><tr class="tbheader"><th>Slot</th><th>State</th><th>Name</th><th>Speed</th><th>Low Threshold</th><th>High Threshold</th></tr></thead><tbody></tbody></table>'
        $('#displayData').html(tableHeader);
        $.each(response, function (i, item) {
            var records = '<tr><td>' + item.Slot + '</td><td><img src="' + item.IconPath + '" alt="'+item.state+'" id="state" class="dvstate"></td><td>' + item.name + '</td><td>' + item.speed + '</td><td>' + item.low_threshold + '</td><td>' + item.hi_threshold + '</td></tr>'
            $('#tblhead').append(records);
        });       
    }
    else if (statusType == 'cpu')
    {
        $('#displayHeader').html('CPU Status View');
        var tableHeader = '<table border="1" class="table table-curved tbdata" id="tblhead"><thead><tr class="tbheader"><th>Slot</th><th>State</th><th>Name</th><th>Temp</th><th>Low Threshold</th><th>High Threshold</th></tr></thead><tbody></tbody></table>'
        $('#displayData').html(tableHeader);
        $.each(response, function (i, item) {
            var records = '<tr><td>' + item.Slot + '</td><td><img src="' + item.IconPath + '" alt="' + item.state + '" id="state" class="dvstate"></td><td>' + item.name + '</td><td>' + item.temp + '</td><td>' + item.low_threshold + '</td><td>' + item.hi_threshold + '</td></tr>'
            $('#tblhead').append(records);
        });
    }
    else if (statusType == 'network') {
        $('#displayHeader').html('Network Status View');
        var tableHeader = '<table border="1" class="table table-curved tbdata" id="tblhead"><thead><tr class="tbheader"><th>Slot</th><th>State</th><th>Name</th><th>Speed</th><th>IP</th><th>Netmask</th><th>Port Id</th></tr></thead><tbody></tbody></table>'
        $('#displayData').html(tableHeader);
        $.each(response, function (i, item) {
            var records = '<tr><td>' + item.Slot + '</td><td><img src="' + item.IconPath + '" alt="' + item.state + '" id="state" class="dvstate"></td><td>' + item.name + '</td><td>' + item.speed + '</td><td>' + item.ip + '</td><td>' + item.netmask + '</td><td>' + item.port_id + '</td></tr>'
            $('#tblhead tbody').append(records);
        });        
    }
    else if (statusType == 'psu1') {
        $('#displayHeader').html('PSU1 Status View');
        var tableHeader = '<table border="1" class="table table-curved tbdata" id="tblhead"><thead><tr class="tbheader"><th>Slot</th><th>State</th><th>Name</th><th>AC Status</th><th>DC Status</th></tr></thead><tbody></tbody></table>'
        $('#displayData').html(tableHeader);
        $.each(response, function (i, item) {
            var records = '<tr><td>' + item.Slot + '</td><td><img src="' + item.IconPath + '" alt="' + item.state + '" id="state" class="dvstate"></td><td>' + item.name + '</td><td>' + item.ac_status + '</td><td>' + item.dc_status + '</td></tr>'
            $('#tblhead').append(records);
        });
    }
    else if (statusType == 'psu2') {
        $('#displayHeader').html('PSU2 Status View');
        var tableHeader = '<table border="1" class="table table-curved tbdata" id="tblhead"><thead><tr class="tbheader"><th>Slot</th><th>State</th><th>Name</th><th>AC Status</th><th>DC Status</th></tr></thead><tbody></tbody></table>'
        $('#displayData').html(tableHeader);
        $.each(response, function (i, item) {
            var records = '<tr><td>' + item.Slot + '</td><td><img src="' + item.IconPath + '" alt="' + item.state + '" id="state" class="dvstate"></td><td>' + item.name + '</td><td>' + item.ac_status + '</td><td>' + item.dc_status + '</td></tr>'
            $('#tblhead').append(records);
        });
    }
    else if (statusType == 'disks')
    {
        $('#displayHeader').html('Disk Status View');
        var tableHeader = '<table border="1" class="table table-curved tbdata" id="tblhead"><thead><tr class="tbheader"><th>Slot</th><th>State</th><th>Name</th><th>Size</th><th>Vendor ID</th><th>Product ID</th><th>Prl</th><th>Serial#</th></tr></thead><tbody></tbody></table>'
        $('#displayData').html(tableHeader);
        $.each(response, function (i, item) {
            var records = '<tr><td>' + item.Slot + '</td><td><img src="' + item.IconPath + '" alt="' + item.state + '" id="state" class="dvstate"></td><td>' + item.name + '</td><td>' + item.size + '</td><td>' + item.vid + '</td><td>' + item.pid + '</td><td>' + item.prl + '</td><td>' + item.serial + '</td></tr>'
            $('#tblhead').append(records);
        });
    }
    $('#tblhead thead').css('background', 'red');
    $('#tblhead thead').css('color', 'white');
    $('#displayPopUp').modal('show');
}
function SetIconPath(response)
{
    var result = [];
    $.each(response, function (i, item) {
        switch(item.state)
        {
            case "0":
                item.IconPath = "./images/green-switch.png";
                item.Slot = i + 1;
                break;
            case "1":
                item.IconPath = "./images/red-switch.png";
                item.Slot = i + 1;
                break;
            case "2":
                item.IconPath = "./images/orange-switch.png";
                item.Slot = i + 1;
                break;
            case "3":
                item.IconPath = "./images/yellow-switch.png";
                item.Slot = i + 1;
                break;
        }
        result.push(item);
    });
    return result;
}