var serverConfig = { vcpu: 0, memory: 0, storage: 0.00, currentState: 0, progressbarTime: 0, packageType: "",IsNewRequest:true };
var availableSources = { vcpu: 0, memory: 0, storage: 0.00, currentState: 0, progressbarTime: 0, packageType: "", packageRequest: 1 };
var UsedSources = { vcpu: 0, memory: 0, storage: 0.00 };
var TotalSources = { vcpu: 0, memory: 0, storage: 0.00 };
var SelectedConfig = { vcpu: 0, memory:0, storage: 0 };
var SetupVMSteps=[0,0,0,0,0,0];
var SaveAndLaunchStatus={"Save":false,"Launch":false};
var SelectedPackage=0;
var isSetupSave=false;
var AllProfileData=[];
var userSelectedGroups=[];
var allDBGroups = [];
$(window).bind("load", function() {
    $('.rotarySwitch').rotaryswitch({ themeClass: 'big', step: 0.1, snapInMotion: true });

    var vcpuSlider = document.getElementById("rangeVcpu");
    var memorySlider = document.getElementById("rangeMemory");
    var storageSlider = document.getElementById("rangeStorage");


    vcpuSlider.addEventListener("mousemove", VCPUChageEvent, false);
    memorySlider.addEventListener("mousemove", MemoryChageEvent, false);
    storageSlider.addEventListener("mousemove", StorageChageEvent, false); 
    //storageSlider.addEventListener("mousewheel", VCPUChageEvent, false);

    function VCPUChageEvent() {
        if (parseInt($(this).val()) != UsedSources.vcpu)
        {
            var tempVcpu = serverConfig.vcpu
            serverConfig.vcpu = parseInt($(this).val());//+ UsedSources.vcpu;
            if (serverConfig.vcpu <= availableSources.vcpu + UsedSources.vcpu)
                ProfileSetUp();
            else
                serverConfig.vcpu = tempVcpu;
        }                          
    }
    function MemoryChageEvent() {
        if (parseFloat($(this).val()) != UsedSources.memory) {
            var tempMemory = serverConfig.memory;
            serverConfig.memory = parseFloat($(this).val());//parseInt($(this).val());
            if (serverConfig.memory <= availableSources.memory + UsedSources.memory)
                ProfileSetUp();
            else
                serverConfig.memory = tempMemory;
        }        
    }
    function StorageChageEvent() {
        if (parseFloat($(this).val()) * 1024 != UsedSources.storage)
        {
            var tempStorage = serverConfig.storage;
            serverConfig.storage = parseFloat($(this).val()) * 1024;
            if (serverConfig.storage <= (availableSources.storage + UsedSources.storage)) {
                ProfileSetUp();
            } else
                serverConfig.storage = tempStorage;
        }        
    }

    setTimeout(function () {
        var tempVcpu = serverConfig.vcpu
        serverConfig.vcpu = UsedSources.vcpu
        if (serverConfig.vcpu <= availableSources.vcpu + UsedSources.vcpu)
            ProfileSetUp();
        else
            serverConfig.vcpu = tempVcpu;
        //$('#rangeVcpu').val(serverConfig.vcpu);

        var tempMemory = serverConfig.memory;
        serverConfig.memory = UsedSources.memory
        if (serverConfig.memory <= availableSources.memory + UsedSources.memory)
            ProfileSetUp();
        else
            serverConfig.memory = tempMemory;

        var tempStorage = serverConfig.storage;
        serverConfig.storage = UsedSources.storage
        if (serverConfig.storage <= (availableSources.storage + UsedSources.storage)) {
            ProfileSetUp();
        } else
            serverConfig.storage = tempStorage;
        //SetSwitchPosition('Standard');
    }, 500);
    //setTimeout(function () {
    //    VCPUChageEvent();
    //    MemoryChageEvent();
    //    StorageChageEvent();
    //}, 1000);
    //function VCPUChageEvent() {
    //    var tempVcpu= serverConfig.vcpu
    //    serverConfig.vcpu = parseInt($(this).val()) + 1;
    //    if (serverConfig.vcpu <= availableSources.vcpu)
    //        ProfileSetUp();
    //    else
    //        serverConfig.vcpu = tempVcpu;
    //}
    //function MemoryChageEvent() {
    //    var tempMemory = serverConfig.memory;
    //    serverConfig.memory = parseInt($(this).val()) * 1 + 1;
    //    if (serverConfig.memory <= availableSources.memory)
    //        ProfileSetUp();
    //    else
    //        serverConfig.memory = tempMemory;
    //}
    //function StorageChageEvent() {
    //    var tempStorage = serverConfig.storage;
    //    serverConfig.storage = parseInt($(this).val()) * 1024 + 1024;
    //    if (serverConfig.storage <= availableSources.storage * 1024) {
    //        ProfileSetUp();
    //    } else
    //        serverConfig.storage = tempStorage;
    //}

    //VCPUChageEvent();
    //MemoryChageEvent();
    //StorageChageEvent();

    $('.rotarySwitchVcpu').on('change', function () {
        var tempVcpu = serverConfig.vcpu
        serverConfig.vcpu = parseInt($(this).val()) + 1;
        if (serverConfig.vcpu <= availableSources.vcpu)
            ProfileSetUp();
        else
            serverConfig.vcpu = tempVcpu;
    });
    $('.rotarySwitchMemory').on('change', function () {
        var tempMemory = serverConfig.memory;
        serverConfig.memory = parseInt($(this).val()) * 1 + 1;
        if (serverConfig.memory <= availableSources.memory)
            ProfileSetUp();
        else
            serverConfig.memory = tempMemory;
    });
    $('.rotarySwitchStorage').on('change', function () {
        var tempStorage = serverConfig.storage;
        serverConfig.storage = parseInt($(this).val()) * 1024 + 1024;
        if (serverConfig.storage <= availableSources.storage * 1024) {
            ProfileSetUp();
        } else
            serverConfig.storage = tempStorage;
    });


    $('.big').mouseup(function () {

        var deg = $('.switch', '#switchMain').attr("style").match(/\d+/)[0];
        // alert(deg);
        if (deg > 270 && deg <= 25)
            $('#div_Standard').click();
        else if (deg > 25 && deg <= 90)
            SetSwitchPosition('Professional');
        else if (deg > 90 && deg <= 155)
            SetSwitchPosition('Business');
        else if (deg > 155 && deg <= 270)
            SetSwitchPosition('Ultimate');
        else
            $('#div_Standard').click();
        setTimeout(function () {
            SetSwitchPositionDynamic(serverConfig.packageType)
        }, 500);
    })
});
//ValidateSession();
BindAvailableResources();
BindDefaultData('network');
BindDefaultData('vmGroup');
BindVMTableData();
//SetSwitchPosition('Standard');

function BindVMTableData(){
	var request = new Request();
        request.url = "cgi/cgi_myserver_getAllVM.py";
        request.ddType = "ALLVM";
        CallPythonService(request);
}


function SetUpResouceDials()
{
    $('.rotarySwitchVcpu').rotaryswitch({ showMarks: false, themeClass: 'light', step: 1, minimum: 0, maximum: availableSources.vcpu });
    $('.rotarySwitchMemory').rotaryswitch({ showMarks: false, themeClass: 'light', step: 1, minimum: 0, maximum: availableSources.memory });
    $('.rotarySwitchStorage').rotaryswitch({ showMarks: false, themeClass: 'light', step: 1, minimum: 0, maximum: availableSources.storage });

    $('#rangeVcpu').attr('max', availableSources.vcpu+UsedSources.vcpu);
    $('#rangeMemory').attr('max', availableSources.memory+UsedSources.memory);
    $('#rangeStorage').attr('max', (availableSources.storage+UsedSources.storage)/1024);
    $('#rangeVcpu').attr('min', UsedSources.vcpu);
    $('#rangeMemory').attr('min', UsedSources.memory);
    $('#rangeStorage').attr('min', (UsedSources.storage)/1024);

    //ProfileSetUp();
}

function SetSwitchPositionDynamic(packageType)
{
    if (packageType === 'Standard'){
        $('.switch', '#switchMain').css('transform', 'rotate(0deg)');
		SelectedPackage=0;
		}
    else if (packageType === 'Professional'){
        $('.switch', '#switchMain').css('transform', 'rotate(50deg)');
		SelectedPackage=50;
	}
    else if (packageType === 'Business'){
        $('.switch', '#switchMain').css('transform', 'rotate(130deg)');
		SelectedPackage=130
	}
    else if (packageType === 'Ultimate'){
        $('.switch', '#switchMain').css('transform', 'rotate(180deg)');
		SelectedPackage=180;
	}
}

function Request() {
    var request = {
        url: "",
        parameters: {},
        ddType: "",
        resourceType:""
    };   
    return request;
}
function ProfileSetUp() {
    $('#divVcpu').css('min-height', 100 - (TotalSources.vcpu != 0 ? (serverConfig.vcpu * 100 / TotalSources.vcpu) : 0) + '%');
    $('#divMemory').css('min-height', 100 - (serverConfig.memory * 100 / TotalSources.memory) + '%');
    $('#divStorage').css('min-height', 100 - (serverConfig.storage * 100 / (TotalSources.storage)) + '%');

    $('#divVcpuUsed').css('min-height', (TotalSources.vcpu != 0 ? (UsedSources.vcpu * 100 / TotalSources.vcpu) : 0) + '%');
    $('#divMemoryUsed').css('min-height', (TotalSources.memory!=0?(UsedSources.memory * 100 / TotalSources.memory):0) + '%');
    $('#divStorageUsed').css('min-height', (TotalSources.storage!=0?(UsedSources.storage * 100 / (TotalSources.storage)):0) + '%');

    $('#divCpuArrow').html(serverConfig.vcpu-UsedSources.vcpu  + ' vCPU');
    $('#VcpuPointer').css('bottom', (TotalSources.vcpu!=0?(serverConfig.vcpu * 100 / TotalSources.vcpu):0) - 4 + '%');
    $('#divmemoryArrow').html(serverConfig.memory-UsedSources.memory + 'G');
    $('#memoryPointer').css('bottom', (serverConfig.memory * 100 / TotalSources.memory)-4 + '%');
    $('#divstorageArrow').html((serverConfig.storage - UsedSources.storage).toFixed(2) + 'G');
    $('#StoragPointer').css('bottom', (serverConfig.storage * 100 / (TotalSources.storage))-4 + '%');
}
function BindDefaultData(ddtype) {
    var request = new Request();
    if (ddtype === 'vmGroup') {
        request.url = "cgi/cgi_myserver_get_GIN.py";
        request.ddType = ddtype;
        request.parameters = { "getType": "vmGroup" };
    }
    else if (ddtype === 'vmImage')
    {
        request.url = "cgi/cgi_myserver_get_GIN.py";
        request.ddType = ddtype;
        request.parameters = { "dd_group": $('#ddlVmGroup').val(), "getType": "vmImage" }
    }
    else if (ddtype === 'network')
    {
        request.url = "cgi/cgi_myserver_get_GIN.py";
        request.ddType = ddtype;
        request.parameters = { "getType": "network" }
    }
    CallPythonService(request);
}
function CallPythonService(request) {
	request.parameters.uuid=uuid;
    $.ajax({
        type: "Get",
        url: request.url,
        contentType: 'application/json',
        dataType: 'json',
        headers: { 'Access-Control-Allow-Origin': '*' },
        data: request.parameters,
        success: function (response) {
            BindResponseData(request.ddType, response);
        },
        error: function (ex) {
            if(!isProduction){
				console.log(ex);
			}
        }
    });
}

$('#setUpPopUp').on('keypress', function(event) {
    var keycode = (event.keycode ? event.keycode : event.which);
    if(keycode == '13')
    {
        $('#btnSetUpSave').click();
    }
        
});
function BindResponseData(ddType,response)
{
    if (ddType === 'vmGroup') {
        // $('#ddlVmGroup option').remove();
        // $('#ddlVmGroup').append(new Option('-- Select --', 0));
        // $.each(response, function (i, item) {
            // $('#ddlVmGroup').append(new Option(item.group_name, item.id));
        // });
		
		var ddData=[];
		$.each(response, function (i, item) {
			ddData.push({
				text: item.group_name,
				value: item.id,
				selected: false,
				imageSrc: '.'+item.iconPath
			});
		});
		$('#groupDropdown').ddslick({
				data: ddData,
				width: 300,
				height:200,
				imagePosition:"right",
				selectText: "-- Select --",
				//background :"gray",
				onSelected: function (data) {
					$('#btnSetUpSave').attr('disabled',false);
					$('#btnSetUpSave').attr('data-dismiss','modal');
					isSetupSave=true;
					$('#ddlVmGroup').val(data.selectedData.value);
					$('#ddlVmImage').val(0);
					BindDefaultData('vmImage');
				}
			});
    }
    else if (ddType === 'vmImage') {
		//$('#imageDropdown').html('');
		$('#imageDropdown').ddslick('destroy');
        // $('#ddlVmImage option').remove();
        // $('#ddlVmImage').append(new Option('-- Select --', 0));
        // $.each(response, function (i, item) {
            // $('#ddlVmImage').append(new Option(item.image_name, item.id));
        // });
		var ddData=[];
		// ddData.push({
				// text: '-- Select --',
				// value: 0,
				// selected: false				
			// });
		$.each(response, function (i, item) {
			ddData.push({
				text: item.image_name,
				value: item.id,
				selected: false,
				imageSrc: '.'+item.iconPath
			});
		});
		$('#imageDropdown').ddslick({
				data: ddData,
				width: 300,
                //Height:200,
				imagePosition:"right",
				selectText: "-- Select --",
				//background :"gray",
				onSelected: function (data) {
					$('#btnSetUpSave').attr('disabled',false);
					$('#btnSetUpSave').attr('data-dismiss','modal');
					isSetupSave=true;
					$('#ddlVmImage').val(data.selectedData.value);
					DisplayImageForGroup();
					$("#divImageLogo").css('display','block');
				}
			});
		DisplayImageForGroup();
    }
    else if(ddType === 'profile')
    {
		response = response[0];
        var packageAvailability = true;

        if (response.vcpu <= availableSources.vcpu)
            serverConfig.vcpu = response.vcpu+UsedSources.vcpu;
        else {
            serverConfig.vcpu = availableSources.vcpu+UsedSources.vcpu;
            packageAvailability = false;
        }
        if (response.memory <= availableSources.memory)
            serverConfig.memory = response.memory+UsedSources.memory;
        else{
            serverConfig.memory = availableSources.memory + UsedSources.memory;
            packageAvailability = false;
        }
        if (response.storage/1024 <= availableSources.storage)
            serverConfig.storage = response.storage+UsedSources.storage;
        else{
            serverConfig.storage = availableSources.storage+UsedSources.storage;
            packageAvailability = false;
        }
        if (!packageAvailability && availableSources.packageRequest !=0)
        {
            $('#packageAlert').html('<b>Selected Package Configuration not available.Do you want proceed with below sources??</b></br><div class="repeaterBox"><div class="col-lg-10 padding-0"><div class="col-lg-10 padding-0"><div class="col-lg-5">VCPU</div><div class="col-lg-1">:</div><div class="col-lg-6"><h4 id="groupPop">' + (serverConfig.vcpu-UsedSources.vcpu) + '</h4></div></div><div class="col-lg-10 padding-0"><div class="col-lg-5">Memory</div><div class="col-lg-1">:</div><div class="col-lg-6"><h4 id="groupPop">' + (serverConfig.memory-UsedSources.memory) + ' GB</h4></div></div><div class="col-lg-10 padding-0"><div class="col-lg-5">Storage</div><div class="col-lg-1">:</div><div class="col-lg-6"><h4 id="groupPop">' + (serverConfig.storage-UsedSources.storage) + ' GB</h4></div></div></div>')
            $('#resourcePackage').modal('show');            
        }
        availableSources.packageRequest = 1;
            ProfileSetUp();
        
    }
    
    else if (ddType === 'confirmSave')
    {
        if(response.status == 'fail')
        {
            $('#btnSaveOk').hide();
            $('.clsSaveBtn').show();
            $("#divMessageSub").html('');
            $('#divMessage').html('<strong>Do you want Save Virtual machine with below Configuration??</strong>');
            var GroupName = ($('#groupDropdown').data('ddslick')).selectedData.text;
            var VmImageName = ($('#imageDropdown').data('ddslick')).selectedData.text;
            var serverName = $('#txtServerName').val();
           // var config = '</br><ul><li>Group Name:' + GroupName + '</li><li>Image Name:' + VmImageName + '</li><li>Server Name:' + serverName + '</li><li>VCPU:' + (serverConfig.vcpu - UsedSources.vcpu) + '</li><li>Memory:' + (serverConfig.memory - UsedSources.memory) + ' GB</li><li>Storage:' + (serverConfig.storage - UsedSources.storage) + ' GB</li></ul>';
            var config = '<div class="repeaterBox"><div class="col-lg-10 padding-0"><div class="col-lg-5">Group Name</div><div class="col-lg-1">:</div><div class="col-lg-6"><h4 id="groupPop">' + GroupName + '</h4></div></div><div class="col-lg-10 padding-0"><div class="col-lg-5">VmImageName</div><div class="col-lg-1">:</div><div class="col-lg-6"><h4 id="groupPop">' + VmImageName + '</h4></div></div><div class="col-lg-10 padding-0"><div class="col-lg-5">Server Name</div><div class="col-lg-1">:</div><div class="col-lg-6"><h4 id="groupPop">'+serverName+'</h4></div></div><div class="col-lg-10 padding-0"><div class="col-lg-5">VCPU</div><div class="col-lg-1">:</div><div class="col-lg-6"><h4 id="groupPop">' + (serverConfig.vcpu - UsedSources.vcpu) + '</h4></div></div><div class="col-lg-10 padding-0"><div class="col-lg-5">Memory (GB)</div><div class="col-lg-1">:</div><div class="col-lg-6"><h4 id="groupPop">' + (serverConfig.memory - UsedSources.memory) + '</h4></div></div><div class="col-lg-10 padding-0"><div class="col-lg-5">Storage (GB)</div><div class="col-lg-1">:</div><div class="col-lg-6"><h4 id="groupPop">' + (serverConfig.storage - UsedSources.storage) + '</h4></div></div></div>';
            $("#divMessageSub").html(config);
        }
        else
        {
            $('#btnSaveOk').show();
            $('.clsSaveBtn').hide();
            SaveServerConfiguration();
        }
        $("#savePopup").modal('show');
    }
    else if(ddType === 'saveServer')
    {
        $('#btnSaveOk').show();
		$('#btnSaveOk').attr('onclick','LaunchVirtualMachine()');
        $('.clsSaveBtn').hide();
        $("#divMessageSub").html('');
        if (response.status === 'success'){
            $('#divMessage').html('<strong>' + response.message + '</strong>');
            SelectedConfig.vcpu = serverConfig.vcpu-UsedSources.vcpu;
            SelectedConfig.memory = serverConfig.memory-UsedSources.memory;
            SelectedConfig.storage = serverConfig.storage-UsedSources.storage;
            BindAvailableResources();
            $('.blue2').attr('disabled', 'disabled').prop('title','Cannot modify Saved VM in Add Page');
            $('.disableClass').attr('onclick', '#').prop('title', 'Cannot Modify Saved VM in Add Page');
            $('#txtServerName').attr('disabled', 'disabled');
			$('#ddlPackage').attr('disabled', 'disabled');
			$('#Step_6 span').attr('class','ledLight blackDial');
			SaveAndLaunchStatus.Save=true;
			BindVMTableData();
    }
        else
            $('#divMessage').html('<strong>' + response.message + '</strong>');

        //$("#savePopup").modal('show');
        //return false;
    }
    else if(ddType === 'network')
    {
        $.each(response, function (i, item) {
            $('#ddlNetwork').append(new Option(item.network_name+ ' - ' + item.cidr, item.id));
            //$('#ddlNetwork').append($("<option></option>")).attr("value",item.id).text(item.network_name+ ' - ' + item.cidr)         
        });         
        $('#ddlNetwork').multiselect();
		$("input[type='checkbox']").on("click", function() {
				
					if ($("input[type=checkbox]:checked").length === 0) {
						$('#btnSetUpSave').attr('disabled',true);
						$('#btnSetUpSave').removeAttr('data-dismiss');
						isSetupSave=false;
					}else
					{
                        if($('#ddlPortNo').val().length > 0)
                        {
                            $('#btnSetUpSave').attr('disabled',false);
                            $('#btnSetUpSave').attr('data-dismiss','modal');
                            isSetupSave=true;
                        }
					}
		
        });
    }
    else if(ddType === 'bindServerInfo')
    {
        serverConfig.vcpu = response.vcpu;
        serverConfig.memory = response.memory;
        serverConfig.storage = response.storage;

        //var config = '</br><ul><li>VCPU:' + serverConfig.vcpu + '</li><li>Memory:' + serverConfig.memory + '</li><li>Storage:' + serverConfig.storage + '</li></ul>';
        var config = '<div class="repeaterBox"><div class="col-lg-10 padding-0"><div class="col-lg-10 padding-0"><div class="col-lg-5">VCPU</div><div class="col-lg-1">:</div><div class="col-lg-6"><h4 id="groupPop">' + (serverConfig.vcpu) + '</h4></div></div><div class="col-lg-10 padding-0"><div class="col-lg-5">Memory (GB)</div><div class="col-lg-1">:</div><div class="col-lg-6"><h4 id="groupPop">' + (serverConfig.memory) + '</h4></div></div><div class="col-lg-10 padding-0"><div class="col-lg-5">Storage (GB)</div><div class="col-lg-1">:</div><div class="col-lg-6"><h4 id="groupPop">' + (serverConfig.storage) + '</h4></div></div></div>'
        $("#divResultSub").html(config);
    }
    else if (ddType === 'DisplayImages')
    {
        if (response.GroupIcon != ""){
            var htmlData = '<div class="logoBlock"><a href="#"><table width="100%" border="0"><tr><td><img src=".' + response.GroupIcon + '" alt="GNU CASH"></td></tr></table></a></div>'
            //$("#divGroupLogo").html(htmlData);
			$("#divImages").html(htmlData);
		}
	   if(response.ImageIcon !="" && $('#ddlVmImage').val() !=0){	
			var data='<div class="logoBlock"><a href="#"><table width="100%" border="0"><tr><td><img src=".' + response.ImageIcon + '" alt="GNU CASH"></td></tr></table></a></div>'
			//$("#divImageLogo").html(data);
			$("#divImages").append(data);
		}
		else
			$("#divImageLogo").html('');
        
    }
    else if(ddType === 'launchVMconfirm')
    {
        $("#divResult").attr('class', '');
        $("#divResultSub").html('');
        $(".divbtn").hide();
        if (response.status === 'success') {           
            $("#divResult").addClass('alert alert-success');
            /////////////////////////////////
            if (response.state != 6){
            var request = new Request();
            request.url = "cgi/cgi_myserver_launch_getDetails.py";
            request.ddType = 'bindServerInfo';
            request.parameters = { "server_name": $('#txtServerName').val() };
            CallPythonService(request);
            }
            /////////////////////////////////////            
            var description = response.state == 6 ? response.description : response.description ;
            $("#divResult").html(description);
           
            serverConfig.currentState = response.state;
            serverConfig.progressbarTime = response.sleepTime;
            serverConfig.currentState == 6 ? ($('#divOK').show(), $("#divTitle").html('<strong>Status</strong>')) : ($('#divNO').show(), $('#divYES').show(), $("#divTitle").html('<strong>Confirmation</strong>'));
            $("#vmLaunchConfirm").modal('show');
        }
        else
        {
            $("#divResult").addClass('alert alert-danger');
            $("#divResult").html(response.description);
            $("#divTitle").html('<strong>Error</strong>');
            $('#divOK').show();
            $("#vmLaunchConfirm").modal('show');
        }
    }
    else if(ddType === 'launchVM')
    {
        $("#divResponse").attr('class', '');

        if (response.status === 'success') {
            $("#divResponse").addClass('alert alert-success');
            $("#divResponse").html('<b>'+response.description+'</b>');            
            
            $("#vmLaunchPopUp").modal('show');
            CallNextStateLaunchVM(response.state);
        }
        else if(response.status === 'fail')
        {
            $("#divProgress").css("display", "none");
            $("#divResponse").addClass('alert alert-danger');
            $("#divResponse").html(response.description);
            $("#vmLaunchPopUp").modal('show');
        }
                
    }
    else if(ddType==='AvailableResource')
    {
        availableSources.vcpu = response.free.vcpu;
        availableSources.storage = response.free.storageGB*1024;
        availableSources.memory = response.free.memoryGB;

        UsedSources.vcpu = response.used.vcpu;
        UsedSources.storage = response.used.storageGB*1024;
        UsedSources.memory = response.used.memoryGB;

        TotalSources.vcpu = availableSources.vcpu + UsedSources.vcpu;
        TotalSources.memory = availableSources.memory + UsedSources.memory;
        TotalSources.storage = availableSources.storage + UsedSources.storage;

        $('#vcpuF').text(availableSources.vcpu);
        $('#memoryF').text(availableSources.memory.toFixed(2) + ' GB');
        $('#storageF').text((availableSources.storage/1024).toFixed(2) + ' TB');
        $('#vcpuT').text(UsedSources.vcpu);
        $('#memoryT').text(UsedSources.memory.toFixed(2) + ' GB');
        $('#storageT').text((UsedSources.storage / 1024).toFixed(2) + ' TB');
        $('#vcpuS').text(SelectedConfig.vcpu);
        $('#memoryS').text(SelectedConfig.memory.toFixed(2) + ' GB');
        $('#storageS').text((SelectedConfig.storage / 1024).toFixed(2) + ' TB');
        SetUpResouceDials();
        ProfileSetUp();
        if (serverConfig.IsNewRequest) {
            //SetSwitchPosition('Standard');
            availableSources.packageRequest = 0;
            serverConfig.IsNewRequest = false;
        }
        else
        {
            serverConfig.vcpu = UsedSources.vcpu;
            serverConfig.memory = UsedSources.memory;
            serverConfig.storage = UsedSources.storage;
            ProfileSetUp();
        }
        
    }
	else if(ddType === 'ALLVM')
	{		
		var dataTable = $('#tblApps').DataTable();
		dataTable.destroy();
		$('#divVmList').html('');
		$.each(response, function (i, item) {

            //var imgHtml = '<tr class=""><td class="col-xs-2 class-span-trim text-left" title="'+ item.name+'">'+item.name+'</td><td class="col-xs-2 text-left">'+item.appType+'</td><td class="col-xs-2 text-left">'+item.CreateDate+'</td><td class="col-xs-2 text-left">'+GetStatusNameById(item.state)+'</td><td class="col-xs-2 text-left"><span class="linksBlk"><a style="padding-left: 0px;" href="vmstatus.html?type=View#'+item.id+'">View</a><a href="javascript:void(0);" url="vmstatus-edit.html?type=Edit#'+item.id+'" class="clsEditConfirm" state="'+item.state+'">Edit</a></span></td><td class="col-xs-2 text-left">'+'<a href="javascript:void(0);">View</a>'+'</td></tr>';
			var imgHtml = '<tr><td class="col-xs-2 class-span-trim" title="'+ item.name+'">'+item.name+'</td><td class="col-xs-2">'+item.appType+'</td><td class="col-xs-2">'+item.CreateDate+'</td><td class="col-xs-2">'+GetStatusNameById(item.state)+'</td><td class="col-xs-2">'+item.portNo+'</td><td class="col-xs-2"><span class="linksBlk"><a style="padding-left: 0px;" href="vmstatus.html?type=View#'+item.id+'">View</a><a href="javascript:void(0);" url="vmstatus-edit.html?type=Edit#'+item.id+'" onclick="RedirectToEditVM('+item.id+','+item.state+')" class="clsEditConfirm" state="'+item.state+'">Edit</a></span></td><td class="col-xs-2">'+'<a href="javascript:void(0);" onclick="RedirectToConsole(`'+item.imageName+'`,'+item.portNo+')">View</a>'+'</td></tr>';
			$('#divVmList').append(imgHtml);
        });		
		
		
		$('#tblApps').DataTable(GetTableConfig('AppsList'));
		
		
		
		$('#tblApps').on('click','paginate_button', function() {
			alert('eve');
		});
		
		$(".class-span-trim").each(function(i){
        var len=$(this).text().trim().length;
        if(len>12)
        {
            $(this).text($(this).text().substr(0,12)+'...');
        }
    });
	}
	else if(ddType=='AllProfiles')
	{
		AllProfileData = response;
		$('#ddlPackage').trigger('change');
	}
	else if(ddType == 'GetAllOrgGroups')
	{
		allDBGroups =response;
	}
}
function RedirectToEditVM(vmId,currentState)
{
	var url="vmstatus-edit.html?type=Edit#"+vmId;
	//var currentState=$(this).attr('state');
	if(currentState !=4)
	{				
		$('#erYES').attr('onclick','location.href="'+url+'"');	
		$('#editRedirect').modal('show');
	}else
		location.href=url;
}
function GetStatusNameById(id)
{
	if(id==4)
		return 'Off';
	else if(id==5)
		return 'O';
	else if(id==6)
		return 'Running';
	else if(id == 7)
		return 'Suspended';
}
// $('#ddlVmGroup').change(function () {    
    // BindDefaultData('vmImage');
    // //DisplayImageForGroup();
// });
// $('#ddlVmImage').change(function () {
    // DisplayImageForGroup();
	// $("#divImageLogo").css('display','block');
// });
function SetSwitchPosition(packageType)
{
    serverConfig.packageType = packageType;
    var request = new Request();
    // if (packageType === 'Standard')
        // $('.switch', '#switchMain').css('transform', 'rotate(0deg)');
    // else if (packageType === 'Professional')
        // $('.switch', '#switchMain').css('transform', 'rotate(50deg)');
    // else if (packageType === 'Business')
        // $('.switch', '#switchMain').css('transform', 'rotate(130deg)');
    // else if (packageType === 'Ultimate')
        // $('.switch', '#switchMain').css('transform', 'rotate(180deg)');
	if (packageType === 'Standard'){
        $('.switch', '#switchMain').css('transform', 'rotate(0deg)');
		SelectedPackage=0;
		}
    else if (packageType === 'Professional'){
        $('.switch', '#switchMain').css('transform', 'rotate(50deg)');
		SelectedPackage=50;
	}
    else if (packageType === 'Business'){
        $('.switch', '#switchMain').css('transform', 'rotate(130deg)');
		SelectedPackage=130
	}
    else if (packageType === 'Ultimate'){
        $('.switch', '#switchMain').css('transform', 'rotate(180deg)');
		SelectedPackage=180;
	}
	

    $('.textBold').css('font-weight','normal');
    $('#div_' + packageType).css('font-weight','bold');

    request.url = "cgi/cgi_myserver_get_vmProfileData.py";
    request.ddType = 'profile';
    request.parameters = { "dd_profile": packageType };

    CallPythonService(request);
}
function SaveConfirmServerConfig()
{
	if(SetupVMSteps[4] == 1){
    var isFormValid = $("#formVirtualServer").validationEngine('validate');
    if (isFormValid) {
        var VmImageId = $('#ddlVmImage').val();
        var serverName = $('#txtServerName').val();
        var selectedNetworks = $('#ddlNetwork').val() != null ? $('#ddlNetwork').val().toString() : '0';

        if (VmImageId != 0 && VmImageId != null && serverName != "" && selectedNetworks != "0") {
            var request = new Request();
            request.url = "cgi/cgi_myserver_launch.py";
            request.ddType = 'confirmSave';
            request.parameters = { "server_name": $('#txtServerName').val(), "state": 0 };
            CallPythonService(request);
        }
        else
            alert('Please choose Image Name or Fill Server Name or Atleast one Network required');
    }
	}else
		alert('Please Complete Step 5 to Save VM');
}
function SaveServerConfiguration()
{
    var VmImageId = $('#ddlVmImage').val();
    var serverName = $('#txtServerName').val();
    var selectedNetworks = $('#ddlNetwork').val() != null ? $('#ddlNetwork').val().toString():'0';
    var portNo = $('#ddlPortNo').val() != null ? $('#ddlPortNo').val() : 0;
    //console.log("port no : " + portNo);

    if (VmImageId != 0 && VmImageId != null && serverName != "" && selectedNetworks !="0" && portNo != 0) {
        var request = new Request();
        request.url = "cgi/cgi_myserver_save_config.py";
        request.ddType = 'saveServer';
        request.parameters = {"portNo": portNo, "server_name": serverName, "vcpu": serverConfig.vcpu-UsedSources.vcpu, "memory": serverConfig.memory-UsedSources.memory, "disk_size": (serverConfig.storage-UsedSources.storage), "image_id": VmImageId, network_name: selectedNetworks,"selectedOrgGroups":userSelectedGroups.toString() };
        CallPythonService(request);
    }
    else
        alert('Please choose Image Name or Fill Server Name or Atleast one Network required or Port Number required');
}
//$('#txtUpdate').on('keydown', function (e) {
//    if (parseInt($(this).val()) >= parseInt($(this).attr('max')))
//        e.preventDefault();   
//});
function ModifyServerConfiguration(ResourceType) {
    if (ResourceType === 'vcpu') {
        $('#lblType').html('VCPU');
        $('.lblSizeType').html('VCPU');
        $('#txtUsed').val(UsedSources.vcpu);
        $('#txtUpdate').val(serverConfig.vcpu - UsedSources.vcpu);
        $('#txtUpdate').attr('max', availableSources.vcpu);
        $('#txtAvailable').val(availableSources.vcpu);
    }
    else if (ResourceType === 'memory') {
        $('#lblType').html('Memory');
        $('.lblSizeType').html('GB');
        $('#txtUsed').val(UsedSources.memory);
        $('#txtUpdate').val(serverConfig.memory - UsedSources.memory);
        $('#txtUpdate').attr('max', availableSources.memory);
        $('#txtAvailable').val(availableSources.memory);
    }
    else if (ResourceType === 'storage') {
        $('#lblType').html('Storage');
        $('.lblSizeType').html('GB');
        $('#txtUsed').val(UsedSources.storage);
        $('#txtUpdate').val(serverConfig.storage - UsedSources.storage);
        $('#txtUpdate').attr('max', availableSources.storage);
        $('#txtAvailable').val(availableSources.storage);
    }
        serverConfig.resourceType = ResourceType
        $('#updatePopUp').modal('show');    
}
function UpdateServerConfig() {
    if (serverConfig.resourceType === 'vcpu')
    {
        if (parseInt($('#txtUpdate').val()) <= availableSources.vcpu)
            serverConfig.vcpu = parseInt($('#txtUpdate').val()) + UsedSources.vcpu;
        else
            $('#ResourceUpdatePop').modal('show');
            //serverConfig.vcpu = availableSources.vcpu+UsedSources.vcpu;
    }        
    else if (serverConfig.resourceType === 'memory')
    {
        if (parseInt($('#txtUpdate').val()) <= availableSources.memory)
            serverConfig.memory = parseInt($('#txtUpdate').val()) + UsedSources.memory;
        else
            $('#ResourceUpdatePop').modal('show');
            //serverConfig.memory = availableSources.memory + UsedSources.memory;
    }
        
    else if (serverConfig.resourceType === 'storage')
    {
        if (parseInt($('#txtUpdate').val()) <= availableSources.storage)
            serverConfig.storage = parseInt($('#txtUpdate').val()) + UsedSources.storage;
        else
            $('#ResourceUpdatePop').modal('show');
            //serverConfig.storage = availableSources.storage + UsedSources.storage;
    }
        

    ProfileSetUp();
}
function LaunchVirtualMachine()
{
	if(SetupVMSteps[4] == 1){
    var isFormValid = $("#formVirtualServer").validationEngine('validate');
    if(isFormValid){
    var serverName = $('#txtServerName').val();
    var request = new Request();
    request.url = "cgi/cgi_myserver_launch.py";
    request.ddType = 'launchVMconfirm';
    request.parameters = { "server_name": serverName,"state":0};
    CallPythonService(request);
    }
	}else
		alert('Please Complete Step 5 to Launch VM');
}
function CallNextStateLaunchVM(currentState)
{
    var serverName = $('#txtServerName').val();
    if (currentState == 4) {
        $("#divResponse").addClass('alert alert-success');
        $("#divResponse").html('<b>' + 'Virtual Machine ' + serverName + ' is ready to Start with selected configuration' + '</b>');
        $("#vmLaunchPopUp").modal('show');
    }
    if (currentState == 5)
    {
        $("#divResponse").addClass('alert alert-success');
        $("#divResponse").html('<b>' + 'Virtual Machine Starting...' + '</b>');
        $("#vmLaunchPopUp").modal('show');
    }        
    if (currentState != 6) {
        $("#divProgress").css("display", "block");
        StartProgressBar();
        //$(".clsClose").attr('disabled',true);
        $(".clsClose").removeAttr('data-dismiss').attr('disabled', true);
        var request = new Request();
        request.url = "cgi/cgi_myserver_launch.py";
        request.ddType = 'launchVM';
        request.parameters = { "server_name": serverName, "state": currentState };
        CallPythonService(request);
    }
    else {
        $("#divProgress").css("display", "none");
        //$(".clsClose").attr('disabled', false);
        $(".clsClose").attr("data-dismiss", "modal").attr('disabled', false);
		$('#Step_6 span').attr('class','ledLight blackDial');
		SetupVMSteps[5]=1;
		SaveAndLaunchStatus.Launch=true;
		BindVMTableData();
        BindAvailableResources();
    }
}
function StartProgressBar() {
    var width = 1;
    var id = setInterval(frame, serverConfig.progressbarTime * 10);
    function frame() {
        if (width >= 100) {
            clearInterval(id);
        } else {
            width++;
            $('#myBar').css('width', width + '%');
            $('#myBar').html('' + width +'%'+ '')
        }
    }
}
function DisplayImageForGroup()
{
    // var GroupName = $('#ddlVmGroup').find("option:selected").text();
    // var VmImageName = $('#ddlVmImage').find("option:selected").text();
	var GroupName =($('#groupDropdown').data('ddslick')).selectedData.text;
	var VmImageName =$('#ddlVmImage').val()>0? ($('#imageDropdown').data('ddslick')).selectedData.text  : "" ;
    if ($('#ddlVmGroup').val() !=0){ //&& $('#ddlVmImage').val()!=0){
    var request = new Request();
    request.url = "cgi/cgi_myservers_get_GrpImg_Icons.py";
    request.ddType = 'DisplayImages';
    request.parameters = { "dd_group": GroupName==""?"a":GroupName, "dd_image": (VmImageName=="" || VmImageName=='-- Select --')?"ubuntu1":VmImageName };
    CallPythonService(request);
    }else
    {
        $("#divImages").html('');
    }
}
function BindAvailableResources()
{
    var request = new Request();
    request.url = "cgi/cgi_totalResource_Available.py";
    request.ddType = 'AvailableResource';
    CallPythonService(request);
}
function ResetServerConfig()
{
    serverConfig.vcpu = UsedSources.vcpu;
    serverConfig.memory = UsedSources.memory;
    serverConfig.storage = UsedSources.storage;
    $('.switch', '#switchMain').css('transform', 'rotate(0deg)');
    $('.textBold').css('font-weight', 'normal');
    $('#div_' + 'Standard').css('font-weight', 'bold');
    ProfileSetUp();
}
 $('.mouseover').mouseover(function(){
	 //$(this).click();
	var angle= $(this).attr("value")+"deg";
	$('#dialImg').css('transform', 'rotate('+angle+')');
 });
 $('.mouseover').mouseout(function(){
	 //$(this).click();
	var angle= SelectedPackage+"deg";
	$('#dialImg').css('transform', 'rotate('+angle+')');
 });
 
 // New Requirement Start
 function InitializeSetup()
 {	
	for(var i=1;i<7; i++)
	{
		if(SetupVMSteps[i-1] == 1)
		{
		 $('#Step_'+i+' span').attr('class','ledLight blackDial');
		 $('#Step_'+(i+1)+' span').attr('class','ledLight grayDial');
		 $('#Step_'+(i+1)).addClass('clsHover');
		 $('#Step_'+(i+1)).removeClass('clsHover');
		}
		else
		{
			$('#Step_'+i+' span').attr('class','ledLight grayDial');
			$('#Step_'+i).addClass('clsHover');
			break;
		}
	} 
 //start--For Dynamic added elements
	$('.clsHover').mouseover(function (){
		var stepNum=($(this).attr('id')).match(/\d+/)[0];
	   if(SetupVMSteps[stepNum-1] !=1){		
		$('#rotator').css('transform', 'rotate('+$(this).attr("value")+')');
	   }
	});
	$('.clsHover').click(function(){
		var stepNum=($(this).attr('id')).match(/\d+/)[0];
	   if(SetupVMSteps[stepNum-1] !=1){
		$('.clsHide').css('display','none');		
		$('#btnSetUpSave').attr('onclick','SaveSetUP('+stepNum+')');
		if(stepNum == 6 && SaveAndLaunchStatus.Save == false)
			{
				SaveConfirmServerConfig();		
			}
		else if(stepNum == 6 && SaveAndLaunchStatus.Save == true)
			{
			LaunchVirtualMachine();
			}
		else{
			if (stepNum !=5){
				$('#btnSetUpSave').attr('disabled',true);
				$('#btnSetUpSave').removeAttr('data-dismiss');
				isSetupSave=false;
			}
			if(stepNum == 5)
			{
				var table = $('#tblOrgGroups').DataTable();
				table.destroy();
				var groupsData = `<thead><th>#</th><th>Group Name</th><th>Description</th><th>Status</th></thead><tbody id="tbodyGroupsData" ></tbody>`
				$('#tblOrgGroups').html(groupsData);
				$.each(allDBGroups, function (i, item) {
					var selectedStatus = userSelectedGroups.indexOf(item.id) !=-1 ? 'checked':'';
					var mappedStatus = userSelectedGroups.indexOf(item.id) !=-1 ? 'Selected':'';
					var rowData = '<tr><td><input type="checkbox" value="'+ item.id+'" class="clsOrgGroups" name="clsOrgGroups" '+selectedStatus+'/></td><td>'+item.name+'</td><td>'+item.description+'</td><td>'+mappedStatus+'</td></tr>';
					$('#tbodyGroupsData').append(rowData);
				});
				$('.clsOrgGroups').bind('change',function(){
					if(this.checked){
						userSelectedGroups.push(parseInt(this.value));
					}
					else
					{
						var valuesToRemove = [parseInt(this.value)]
						userSelectedGroups = userSelectedGroups.filter(item => !valuesToRemove.includes(item))
					}
					
					// $('#txtSelectedGroups').val(GetSelectedGroupNames());
					// $('#txtSelectedGroups').attr('title',GetSelectedGroupNames());
				});
				$('#tblOrgGroups').DataTable();
			}
			$('#divStep_'+stepNum).css('display','block');
			$('#setUpPopUp').modal('show');
		}
	  }
	});	
 //End--For Dynamic added elements
 }
 $('.clsHover').mouseover(function (){		
	var stepNum=($(this).attr('id')).match(/\d+/)[0];
	   if(SetupVMSteps[stepNum-1] !=1){		
		$('#rotator').css('transform', 'rotate('+$(this).attr("value")+')');
	   }
});
$('.clsHover').click(function(){
	var stepNum=($(this).attr('id')).match(/\d+/)[0];	
  if(SetupVMSteps[stepNum-1] !=1){
	$('.clsHide').css('display','none');	
	
	$('#btnSetUpSave').attr('onclick','SaveSetUP('+stepNum+')');
	if(stepNum == 6 && SaveAndLaunchStatus.Save == false)
	{
		SaveConfirmServerConfig();		
	}
	else if(stepNum == 6 && SaveAndLaunchStatus.Save == true)
	{
		LaunchVirtualMachine();
	}
	else{
		if (stepNum !=5){
			$('#btnSetUpSave').attr('disabled',true);
			$('#btnSetUpSave').removeAttr('data-dismiss');
			isSetupSave=false;
		}
		$('#divStep_'+stepNum).css('display','block');
		$('#setUpPopUp').modal('show');
	}
  }
});	
function SaveSetUP(stepNum)
{
	if(isSetupSave){
		SetupVMSteps[stepNum-1]=1;
		if(stepNum == 5){
			SetSwitchPosition($('#ddlPackage').val());
		}
		InitializeSetup();
	}
}
$('#txtServerName').keyup(function(){
	if($(this).val().trim().length >0)
	{
		$('#btnSetUpSave').attr('disabled',false);
		$('#btnSetUpSave').attr('data-dismiss','modal');
		isSetupSave=true;
	}else
	{
		$('#btnSetUpSave').attr('disabled',true);
		$('#btnSetUpSave').removeAttr('data-dismiss');
		isSetupSave=false;
	}
});
$('#ddlPortNo').keyup(function(){
	if($(this).val().trim().length >0)
	{
        if($('#ddlNetwork').val() != null)
        {
            $('#btnSetUpSave').attr('disabled',false);
            $('#btnSetUpSave').attr('data-dismiss','modal');
            isSetupSave=true;
        }
	}else
	{
        
		$('#btnSetUpSave').attr('disabled',true);
		$('#btnSetUpSave').removeAttr('data-dismiss');
		isSetupSave=false;
	}
});
function GetAllProfileData()
{
	var request = new Request();
    request.url = "cgi/cgi_myserver_get_vmProfileData.py";
    request.ddType = 'AllProfiles';
    CallPythonService(request);
}
$('#ddlPackage').change(function(){
	var selectedProfile = {};
	for(var i=0;i<4;i++)
	{
		if(AllProfileData[i].name == $(this).val())
			selectedProfile=AllProfileData[i];
			
	}
	$('#prflCPU').text(selectedProfile.vcpu );
	$('#prflMemory').text(selectedProfile.memory + ' GB');
	$('#prflStorage').text(selectedProfile.storage + ' GB');
	
});
function GetAllOrgGroups()
{
	var request = new Request();
	request.url = "cgi/cgi_Organization_Manager.py";
	request.parameters = {"RequestType": 'read_Group', "groupId": 0 };
	request.ddType = "GetAllOrgGroups";
	CallPythonService(request);		
}
GetAllProfileData();
GetAllOrgGroups();
