BindVMTableData();
function Request() {
    var request = {
        url: "",
        parameters: {},
        ddType: "",
        resourceType:""
    };   
    return request;
}
function CallPythonService(request) {
    $.ajax({
        type: "Get",
        url: request.url,
        contentType: 'application/json',
        dataType: 'json',
        headers: { 'Access-Control-Allow-Origin': '*' },
        data: request.parameters,
        success: function (response) {
            BindResponseData(request.ddType, response);
        },
        error: function (ex) {
            if(!isProduction){
				console.log(ex);
			}
        }
    });
}
function BindResponseData(ddType,response)
{
    if(ddType === 'ALLVM')
	{		
		var dataTable = $('#tblApps').DataTable();
		dataTable.destroy();
		$('#divVmList').html('');
		$.each(response, function (i, item) {
            var renew = ''
            if(item.renew)
                renew = 'disabled'
            //var imgHtml = '<tr class=""><td class="col-xs-2 class-span-trim text-left" title="'+ item.name+'">'+item.name+'</td><td class="col-xs-2 text-left">'+item.appType+'</td><td class="col-xs-2 text-left">'+item.CreateDate+'</td><td class="col-xs-2 text-left">'+GetStatusNameById(item.state)+'</td><td class="col-xs-2 text-left"><span class="linksBlk"><a style="padding-left: 0px;" href="vmstatus.html?type=View#'+item.id+'">View</a><a href="javascript:void(0);" url="vmstatus-edit.html?type=Edit#'+item.id+'" class="clsEditConfirm" state="'+item.state+'">Edit</a></span></td><td class="col-xs-2 text-left">'+'<a href="javascript:void(0);">View</a>'+'</td></tr>';
			var imgHtml = '<tr><td class="col-xs-2 class-span-trim" title="'+ item.name+'">'+item.name+'</td><td >'+item.appType+'</td><td >'+item.CreateDate+'</td><td >'+GetStatusNameById(item.state)+'</td><td >'+item.portNo+'</td><td>'+item.trialExp+'</td><td>'+item.licenseExp+' <button style="float:right; border:1px solid; border-radius:15%;" '+renew+'>Renew</button></td><td >'+'<a href="javascript:void(0);" onclick="RedirectToConsole(`'+item.imageName+'`,'+item.portNo+')">View</a>'+'</td></tr>';
			$('#divVmList').append(imgHtml);
        });				
		$('#tblApps').on('click','paginate_button', function() {
			alert('eve');
		});
		
		$(".class-span-trim").each(function(i){
            var len=$(this).text().trim().length;
            if(len>12)
            {
                $(this).text($(this).text().substr(0,12)+'...');
            }
        });
    }
}
function GetStatusNameById(id)
{
	if(id==4)
		return 'Off';
	else if(id==5)
		return 'O';
	else if(id==6)
		return 'Running';
	else if(id == 7)
		return 'Suspended';
}
function BindVMTableData(){
	var request = new Request();
        request.url = "cgi/cgi_appPortal.py";
        request.ddType = "ALLVM";
        CallPythonService(request);
}