var hostGrayedOutRules =[{'protocol':1,'user':1,'password':1,'iqn':0,'wwn':0},
						 {'protocol':2,'user':1,'password':1,'iqn':0,'wwn':0},
						 {'protocol':3,'user':0,'password':0,'iqn':1,'wwn':0},
						 {'protocol':4,'user':1,'password':1,'iqn':1,'wwn':0},
						 {'protocol':5,'user':1,'password':1,'iqn':0,'wwn':0},
						 {'protocol':6,'user':0,'password':0,'iqn':0,'wwn':1},
						 {'protocol':7,'user':0,'password':0,'iqn':0,'wwn':0},
					  	 {'protocol':8,'user':0,'password':0,'iqn':1,'wwn':0},
					         {'protocol':9,'user':1,'password':1,'iqn':1,'wwn':0},
						 {'protocol':999,'user':0,'password':0,'iqn':0,'wwn':0}
						];
var selectedProtocol = 0;
var hostActionPage = '';
var selectedVolume = 0;
var used_luns = new Array();
var icons_for_these_states = [8,9,10,11,12,13];
var lunMinValue = 0, lunMaxValue = 128;
function Request() {
    var request = {
        url: "",
        parameters: {},
        statusType: "",
		typeNumber: "",
		isSingleStatus:false
    };
    
    return request;
}
$(window).bind("load", function() {
    BindVolumeSavedData();
	if(location.hash.substr(1) !="")
		$('#divBackButton').show();
	else
		$('#divBackButton').hide();
});
function CallPythonService(request) {
	request.parameters.uuid=uuid;
    $.ajax({
        type: "Get",
        url: request.url,
        contentType: 'application/json',
        dataType: 'json',
        headers: { 'Access-Control-Allow-Origin': '*' },
        data: request.parameters,
        success: function (response) {			
				BindResponseData(request.statusType,response);
        },
        error: function (ex) {
            if(!isProduction){
				console.log(ex);
			}
        }
    });
}
function BindResponseData(statusType, response) {
	
    if(statusType=='SaveHost')
	{
		if(response.status != 'fail')
			HostPageNavigate();
		alert(response.description);
		BindAllHosts();
		return;
	}
	else if(statusType == 'getProtocol')
	{
		$("#ddlHostType option").remove();	
		$('#ddlHostType').append(new Option('-- Select --',''));
		$.each(response, function (i, item) {
            $('#ddlHostType').append(new Option(item.protocolName, item.id));            
        }); 
		//SetUpGrayedOutRules(1);
		return;
	}
	else if(statusType == 'getHosts')
	{
		$("#ddlHostNames option").remove();	
		$('#ddlHostNames').append(new Option('-- Select --', ''));
		$('#tbodyHostData').html('');
		$.each(response, function (i, item) {
			
			var host = `<tr class="text-left">
                                       <td class="col-xs-2 class-span-trim text-left">
                                          `+item.name+`
                                       </td>
									   <td class="col-xs-2 text-left">`+item.protocol_name+`</td>
                                       <td class="col-xs-2 text-left">`+GetString(item.user_name)+`</td>
                                       <td class="col-xs-2 text-left">
                                          `+GetString(item.pw)+`
                                       </td>
                                       <td class="col-xs-2 text-left">
                                          `+GetString(item.iqn)+`
                                       </td>
                                       <td class="col-xs-2 text-left">
                                          `+GetString(item.wwn)+`
                                       </td>
                                    </tr>`
			$('#tbodyHostData').append(host);
			
            $('#ddlHostNames').append(new Option(item.name, item.id));            
        }); 
		return;
	}
	else if(statusType == 'getHostsForVolume')
	{
		$("#ddlVolumeHost option").remove();	
		$('#ddlVolumeHost').append(new Option('-- Select --', ''));
		$.each(response, function (i, item) {			
			$('#ddlVolumeHost').append(new Option(item.name, item.id)); 
        }); 
		//$('#ddlVolumeHost').multiselect();
		return;
	}
	else if(statusType == 'refineHostOnLoading')
	{
		var oldValue = $('#ddlVolumeHost').val()
		$("#ddlVolumeHost option").remove();	
		$('#ddlVolumeHost').append(new Option('-- Select --', ''));
		$.each(response, function (i, item) {			
			$('#ddlVolumeHost').append(new Option(item.name, item.id)); 
        });
		$('#ddlVolumeHost').val(oldValue);
		//$('#ddlVolumeHost').multiselect();
		return;
	}
	
	else if(statusType == 'getProtocolForVolume')
	{
		$("#ddlVolumeProtocol option").remove();	
		$('#ddlVolumeProtocol').append(new Option('-- Select --', ''));
		$.each(response, function (i, item) {
            $('#ddlVolumeProtocol').append(new Option(item.protocolName, item.id));            
        }); 
		return;
	}
	else if(statusType == 'getStoragePools')
	{
		$("#ddlVolumePool option").remove();
		$("#ddlVolumePool optgroup").remove();
		$('#ddlVolumePool').append(new Option('-- Select --', ''));	

		var optGroup = `<!--<optgroup label="HDD POOL" id="HDDopt">
			<option value="NoneHDD" disabled>No items</option>
		</optgroup>
		<optgroup label="SSD POOL" id="SSDopt">
			<option value="NoneSSD" disabled>No items</option>
		</optgroup>    
		<optgroup label="iSCSI POOL" id="iSCSIopt">
			<option value="NoneiSCSI" disabled>No items</option>
		</optgroup>
		<optgroup label="NVMeOF POOL" id="NVMeOFopt">
			<option value="NoneNVMeOF" disabled>No items</option>
		</optgroup>-->
		<optgroup label="MegaRAID POOL" id="MegaRAIDopt">
			<option value="NoneMegaRAID" disabled>No items</option>
		</optgroup>
		`;

		$('#ddlVolumePool').append(optGroup);
		
		$.each(response, function (i, item) {

			optionText = item.systemName;
			optionValue = item.id;
			optionName = item.name;
			remaining = item.remaining;

			if(optionName == 'HDD POOL') 
			{
				$('#ddlVolumePool option[value="NoneHDD"]').remove();
				$('#HDDopt').append(`<option remaining="${remaining}" value="${optionValue}"> 
						${optionText}
						</option>`);
			}
			else if(optionName == 'SSD POOL') 
			{
				$('#ddlVolumePool option[value="NoneSSD"]').remove();
				$('#SSDopt').append(`<option remaining="${remaining}" value="${optionValue}"> 
						${optionText}
						</option>`);
			}
			else if(optionName == 'iSCSI POOL') 
			{
				$('#ddlVolumePool option[value="NoneiSCSI"]').remove();
				$('#iSCSIopt').append(`<option remaining="${remaining}" value="${optionValue}"> 
						${optionText}
						</option>`);
			}
			else if(optionName == 'NVMeOF POOL') 
			{
				$('#ddlVolumePool option[value="NoneNVMeOF"]').remove();
				$('#NVMeOFopt').append(`<option remaining="${remaining}" value="${optionValue}"> 
						${optionText}
						</option>`);
			}
			else if(optionName == 'MegaRAID POOL') 
			{
				$('#ddlVolumePool option[value="NoneMegaRAID"]').remove();
				$('#MegaRAIDopt').append(`<option remaining="${remaining}" value="${optionValue}"> 
						${optionText}
						</option>`);
			}
			//$('#ddlVolumePool').append(new Option(item.systemName + ' - ' + item.name, item.id));          
		}); 
		
		return;
	}
	else if(statusType == 'getEthernetPorts')
	{
		$("#ddlvolumePorts option").remove();	
		$('#ddlvolumePorts').append(new Option('-- Select --', ''));
		$.each(response, function (i, item) {
            $('#ddlvolumePorts').append(new Option(item.name, item.id));            
        }); 
		return;
	}
	else if(statusType == 'getHostById')
	{
		var host= response[0];
		$('#txtHostName').val(host.name);
		$('#ddlHostType').val(host.protocol_id);
		$('#txtHostUser').val(host.user_name);
		$('#txtHostPwd').val(host.pw);
		$('#txtHostIQN').val(host.iqn);
		$('#txtHostWWN').val(host.wwn);
		
		SetUpGrayedOutRules(host.protocol_id);
		return;
	}
	else if(statusType == 'SaveVolume')
	{		
		
		if(response.status !='fail'){
			VolumeMgrPageNavigate('cancel');
			BindVolumeSavedData();
			selectedVolume = 0;
			swal("Success", response.description , "success");
		}
		else
		{
			swal("Error", response.description , "error");
		}		
	}
	else if(statusType == 'changeVolumeState')
	{
		BindVolumeSavedData();
		if(response.status !='fail')
			swal("Success", response.description , "success");
		else
			swal("Error", response.description , "error");
	}
	else if(statusType == 'SaveSnapVolume')
	{	
		if(response.status == 'fail')
		{
			swal("Error", response.description , "error");			
		}	
		else{
			BindVolumeSavedData();	
			selectedVolume = 0;
			swal("success", response.description , "success");
		}
		
	}
	else if(statusType == 'getVolumeSavedData')
	{
		$("#ddlVolumeNames option").remove();
		$('#ddlVolumeNames').append(new Option('-- Select --', ''));
		
		//$('#ddlVolumeNames').trigger('change');
		
		 var table = $('#tblVolumeManager').DataTable();
		 table.destroy();
		$('#tbodyVolumeManager').html('');
		used_luns = new Array();
		$.each(response, function (i, item) {
			used_luns.push(item.lun)
			var dedup = item.dedup == 'true' ?'Yes':'No';
			var compression = item.compression == 'true'?'Yes':'No';
			var backup_device = item.backup_device == 'true'?'Yes':'No';
			var thin = item.thin == 'yes'?'Yes':'No';
			var onClass = item.state == 6 ? '':'hide';
			var offClass = item.state == 4 ? '':'hide';
			var isDisabled = item.type == null || item.type.toLowerCase() != 'native'? '':''
			var len=$(this).text().trim().length;
			var disabled_class = item.type == null || item.type.toLowerCase() !='native'? 'custom-disabled':'';
			item.nametxt = item.name;
			if(item.name.length>10)
			{
				item.nametxt = item.name.substr(0,12)+'...';
			}		

			var actionButton = `
			<label class="radio-switch `+offClass+`" title="Click to Turn On Volume">
				<input type="checkbox" name="VolumeToggele"  onclick="OnOffVolume(`+item.id+`,`+6+`,'`+item.type+`')">
				<span class="slider"></span>
			</label>
			
			<label class="radio-switch `+onClass+`" title="Click to Turn Off Volume">
				<input type="checkbox" name="VolumeToggele" onclick="OnOffVolume(`+item.id+`,`+4+`,'`+item.type+`')" checked>
				<span class="slider"></span>
			</label>`;
			
			//if()
			if(icons_for_these_states.includes(parseInt(item.state)))
			{	
				var onclass_protocol = getProtocolForState(parseInt(item.state));
				var onclass = onclass_protocol[0];
				var offclass = onclass == '' ? 'hide' : '';
				
				var protocol = onclass_protocol[1];
				actionButton = `
				<label class="radio-switch `+disabled_class+` `+offclass+`">
					<input type="checkbox" name="VolumeToggele" disabled>
					<span class="slider"></span>
					<span class="protocol-icon-label-off `+offclass+`">`+protocol+`</span>
				</label>
				
				<label class="radio-switch `+disabled_class+` `+onclass+`">
					<input type="checkbox" name="VolumeToggele" checked disabled>
					<span class="slider"></span>
					<span class="protocol-icon-label `+onclass+`">`+protocol+`</span>
				</label>`;
			}
			strVolume = `<tr>
												<td width="30px"><input onclick="selectedVolume=`+item.id+`" class="clsVolumeRecord" name="rdVolume" value="`+item.id+`" type="radio" volType="`+item.type+`" id="chkVolume_`+item.id+`" `+isDisabled+`></td>
                                                <td><span class="overflow" title="`+item.name+`">`+item.nametxt+`</span></td>
                                                <td>`+item.type+`</td>
												<td>`+item.diskType+`</td>
                                                <td>`+item.size+`</td>
                                                <td><span class="overflow" title="`+item.poolName+`">`+item.poolName+`</span></td>
                                                <td>`+item.lun+`</td>
                                                
                                                
                                                <td>`+backup_device+`</td>
                                                
                                                <td>`+item.protocolName+`</td>
                                                <td><span class="overflow" title="`+item.hostName+`">`+item.hostName+`</span></td>
                                                <td>`+item.portName+`</td>
                                                <td width="150px" align="center">
                                                    <span class="linksBlk"> 
                                          <!--<a href="javascript:void(0);" class=" yellowBG `+disabled_class+`">-->
                                          <!--<img src="images/screen-shot-icon.png" alt="Snap" title="Snap" onclick="SnapShotVolume(`+item.id+`,'`+item.name+`')"></a>-->
											  <a href="javascript:void(0);" class=" yellowBG `+disabled_class+`">
                                          <img src="images/infoIcon.png" alt="infoIcon" title="Info" onclick="VolumeInfo(`+item.id+`,'`+item.type+`')"></a>
										   
										   `+actionButton+`

                                          </span>
                                                </td>
                                            </tr>`;
			$('#tbodyVolumeManager').append(strVolume);			
			//if(item.type == 'native')
			$('#ddlVolumeNames').append(new Option(item.name, item.id));
		}); 
		//console.log("used_luns: ",used_luns)
		 var table = $('#tblVolumeManager').DataTable();
		 table.destroy();
		$('#tblVolumeManager').DataTable(GetTableConfig('volumeManager'));
		
		$('.clsVolumeRecord').on("change",function(){
			selectedVolume = $(this).attr('value');
			//alert(selectedVolume);
		});
		addValidationToLUN();
		return;
	}
	else if(statusType == 'getVolumeById')
	{
		var volume =response[0];
		$('#ddlVolumeNames').val(volume.id);
		$('#txtVolumeSize').val(volume.size);
		$('#ddlVolumeProtocol').val(volume.protocolId);
		$('#ddlVolumePool').val(volume.poolId);
		$('#ddlVolumePool').trigger('change');
		$('#ddlVolumeHost').val(volume.hostId);
		$('#txtVolumeLUN').val(volume.lun);
		$('#ddlvolumePorts').val(volume.portId);
		$('#chkDedup').prop('checked',volume.dedup =="true"?true:false);// volume.dedup
		$('#chkCompression').prop('checked', volume.compression =="true"?true:false);
		$('#chkBackupDevice').prop('checked', volume.backup_device =="true"?true:false);
		$('#chkThin').prop('checked', volume.thin =="yes"?true:false);
		refineHostsAfterLoadingVolumeForEdit();
		//"size":$('#txtVolumeSize').val(),"protocolId":$('#ddlVolumeProtocol').val(),"poolId":$('#ddlVolumePool').val(),"hostId":$('#ddlVolumeHost').val(),"lun":$('#txtVolumeLUN').val(),"portId":$('#ddlvolumePorts').val()
		const index = used_luns.indexOf(parseInt(volume.lun));
		if (index > -1) {
			used_luns.splice(index, 1);
		}
		//console.log("used_luns [edit]: ",used_luns)
		addValidationToLUN()
		return;
	}	
	else if(statusType == 'volumeInfo')
	{
		$('#divVolumeInfo').html('');
		$.each(response, function (i, item) {
		var infoData=`<div class="form-group">
						<div class="col-lg-12 padding-0">
							<div class="col-xs-4 padding-0">
								<h4><b>`+item.propertyName+`:</b></h4>
							</div>
							<div class="col-xs-4 padding-0">
								<h4>`+item.propertyValue+`</h4>
							</div>
						</div>
                       </div>`;
			$('#divVolumeInfo').append(infoData);
		});
		$('#volumeInfoPop').modal('show');
	}
}

function SaveHost()
{
	var isFormValid = $("#formHostServer").validationEngine('validate');
	if(!isFormValid)
		return;
	var request = new Request();
	request.url ="cgi/cgi_HostManager.py"
	request.statusType="SaveHost";
	request.parameters={"requestType":'create_Host',"hostName":$('#txtHostName').val(),"protocol":$('#ddlHostType').val(),"user":$('#txtHostUser').val(),"password":$('#txtHostPwd').val(),"iqn":$('#txtHostIQN').val(),"wwn":$('#txtHostWWN').val()};
	CallPythonService(request);
}
function UpdateHost()
{
	var isFormValid = $("#formHostServer").validationEngine('validate');
	if(!isFormValid)
		return;
	var request = new Request();
	request.url ="cgi/cgi_HostManager.py"
	request.statusType="SaveHost";
	request.parameters={"requestType":'update_Host',"hostId":$('#ddlHostNames').val(),"hostName":$('#txtHostName').val(),"protocol":$('#ddlHostType').val(),"user":$('#txtHostUser').val(),"password":$('#txtHostPwd').val(),"iqn":$('#txtHostIQN').val(),"wwn":$('#txtHostWWN').val()};
	CallPythonService(request);
}
function DeleteHost()
{
	var isFormValid = $("#formHostServer").validationEngine('validate');
	if(!isFormValid)
		return;
	var request = new Request();
	request.url ="cgi/cgi_HostManager.py"
	request.statusType="SaveHost";
	request.parameters={"requestType":'delete_Host',"hostId":$('#ddlHostNames').val()};
	CallPythonService(request);
}
function GetAllProtocol()
{
	var request = new Request();
	request.url ="cgi/cgi_HostManager.py"
	request.statusType="getProtocol";
	request.parameters={"requestType":'read_Protocol'};
	CallPythonService(request);
}
$('#ddlHostNames').change(function(){
	var request = new Request();
	request.url ="cgi/cgi_HostManager.py"
	request.statusType="getHostById";
	request.parameters={"requestType":'read_Host',"hostId":$(this).val()};
	CallPythonService(request);
});
$('#ddlHostType').change(function(){
	//$('#txtHostName').val('');
	
	SetUpGrayedOutRules(1);
});
$('#ddlVolumePool').change(function(){
	remaining = $("#ddlVolumePool option:selected").attr("remaining")
	if (!remaining) {remaining = 0}
	remaining = remaining + " GB"
	$('#txtRemainingCapacity').val(remaining)
});
function SetUpGrayedOutRules(protocolId)
{
	if(hostActionPage == 'Delete')
		return;
	var protocol=$('#ddlHostType').val();
	if(protocol == 0)
		var rule = hostGrayedOutRules[hostGrayedOutRules.length-1]; //last item
	else
		var rule = hostGrayedOutRules[protocol-1];
	
	if(rule.user == 0){
		$('#txtHostUser').attr('disabled',true);
		$('#txtHostUser').val('');
	}
	else
		$('#txtHostUser').attr('disabled',false);
	
	if(rule.password == 0){
		$('#txtHostPwd').attr('disabled',true);
		$('#txtHostPwd').val('');
	}
	else
		$('#txtHostPwd').attr('disabled',false);
	
	if(rule.iqn == 0){
		$('#txtHostIQN').attr('disabled',true);
		$('#txtHostIQN').val('');
	}
	else
		$('#txtHostIQN').attr('disabled',false);
	
	
	if(rule.wwn == 0){
		$('#txtHostWWN').attr('disabled',true);
		$('#txtHostWWN').val('');
	}
	else
		$('#txtHostWWN').attr('disabled',false);
}

$('.clsHostPage').click(function(){
	$('.clsHostPage').removeClass('alert-danger');
	$(this).addClass('alert-danger');
	BindAllHosts();	
});

function BindAllHosts()
{
	var request = new Request();
	request.url ="cgi/cgi_HostManager.py"
	request.statusType="getHosts";
	request.parameters={"requestType":'read_Host',"hostId":0};
	CallPythonService(request);
}
function openHostPopup()
{
	//$('#btnHostAdd').trigger('click');
}
function HostPageNavigate(page)
{
	$('#txtHostName').val('')
	$('#txtHostUser').val('');
	$('#txtHostPwd').val('');
	$('#txtHostIQN').val('');
	$('#txtHostWWN').val('');
	
	$('.hostFieldCls').attr('disabled',false);
	GetAllProtocol();
	$('#divHostNew').css('display','none');
	hostActionPage = page;
	
	if(page == 'Add'){
		$('.clsHostNames').css('display','none');
		$('#btnHostAction').attr('onclick','SaveHost()').html('Confirm');
		$('#divHostNew').css('display','block');
		BindAllHosts();
		
	}
	else if(page == 'Edit'){
		$('.clsHostNames').css('display','block');
		$('#btnHostAction').attr('onclick','UpdateHost()').html('Confirm');
		$('#divHostNew').css('display','block');
	}
	else if(page == 'Delete'){
		$('.clsHostNames').css('display','block');
		$('#btnHostAction').attr('onclick','DeleteHost()').html('Confirm');	
		$('#divHostNew').css('display','block');
		$('.hostFieldCls').attr('disabled',true);		
	}	
	else
	{
		$('.clsHostPage').removeClass('alert-danger');
	}
}
// Host Manager code End

// Volume Manager code Start
$('.clsVolumePage').click(function(){
	$('.clsVolumePage').removeClass('alert-danger');
	$(this).addClass('alert-danger');
});

function VolumeMgrPageNavigate(page)
{
		$('#txtVolumeSize').val('');
		$('#txtRemainingCapacity').val('');
		$('#txtVolumeLUN').val('');
		$('#txtVolumeName').val('');
		$('#chkCompression').attr('checked',false);
		$('#chkDedup').attr('checked',false);
		$('#chkBackupDevice').attr('checked',false);
		$('#chkThin').attr('checked',false);
		
		$('#ddlVolumeProtocol').attr('disabled',false);
		$('#ddlVolumeHost').attr('disabled',false);
		$('#ddlvolumePorts').attr('disabled',false);
		$('#chkCompression').attr('disabled',false);
		$('#chkDedup').attr('disabled',false);

		$('#txtVolumeLUN').attr('disabled',false);
		$('#ddlVolumePool').attr('disabled',false);
		$('#txtVolumeSize').attr('disabled',false);
	
	$('#divNewVolumeMgr').hide();
	if(page == 'Add'){
		BindVolumeDefaultData();
		$('#txtVolumeName').show();
		$('#ddlVolumeNames').hide();
		$('#divNewVolumeMgr').show();
		$('#btnVolumeAction').attr('onclick','SaveVoume()');
	}
	else if(page == 'Edit')
	{
		BindVolumeDefaultData();
		$('#txtVolumeName').hide();
		$('#ddlVolumeNames').show();
		//$('#divNewVolumeMgr').show();
		$('#btnVolumeAction').attr('onclick','UpdateVoume()');
		$('#ddlVolumeProtocol').attr('disabled',true);
		$('#ddlVolumeHost').attr('disabled',false);
	}
	else if(page == 'Delete')
	{
		$('#divNewVolumeMgr').hide();
		// BindVolumeDefaultData();
		// $('#txtVolumeName').hide();
		// $('#ddlVolumeNames').show();
		// $('#divNewVolumeMgr').show();
		// $('#btnVolumeAction').attr('onclick','DeleteVoume()');
		
		// $('#ddlVolumeProtocol').attr('disabled',true);
		// $('#ddlVolumeHost').attr('disabled',true);
		// $('#ddlvolumePorts').attr('disabled',true);
		// $('#chkCompression').attr('disabled',true);
		// $('#chkDedup').attr('disabled',true);
		// $('#txtVolumeLUN').attr('disabled',true);
		// $('#ddlVolumePool').attr('disabled',true);
		// $('#txtVolumeSize').attr('disabled',true);
	}
	else if(page== 'cancel')
	{
		$('#divNewVolumeMgr').hide();
		$('.clsVolumePage').removeClass('alert-danger');
	}
	//BindVolumeSavedData();
}
function BindVolumeDefaultData()
{
	selectedProtocol=0;
	var request = new Request();
	request.url ="cgi/cgi_HostManager.py"
	request.statusType="getHostsForVolume";
	request.parameters={"requestType":'read_Host',"hostId":0};
	CallPythonService(request);
	
	var request = new Request();
	request.url ="cgi/cgi_Pool_Get.py"
	request.statusType="getStoragePools";
	request.parameters={"requestType":'read_pool'};
	CallPythonService(request);
	
	var request = new Request();
	request.url ="cgi/cgi_VolumeManager.py"
	request.statusType="getEthernetPorts";
	request.parameters={"requestType":'read_Ethernet_ports'};
	CallPythonService(request);
	
	var request = new Request();
	request.url ="cgi/cgi_HostManager.py"
	request.statusType="getProtocolForVolume";
	request.parameters={"requestType":'read_Protocol'};
	CallPythonService(request);
	
}
function SaveVoume()
{
	var isFormValid = $("#formVolumeMgr").validationEngine('validate');
	if(!isFormValid)
		return;
	var dedup = $('#chkDedup').is(":checked");
	var compression = $('#chkCompression').is(":checked");
	var backup_device = $('#chkBackupDevice').is(":checked");
	var thin = $('#chkThin').is(":checked");
	//var selectedhosts = $('#ddlVolumeHost').val() != null ? $('#ddlVolumeHost').val().toString():'0';
	
	var request = new Request();
	request.url ="cgi/cgi_VolumeManager.py"
	request.statusType="SaveVolume";
	request.parameters={
		"requestType":'create_Volume',"volumeName":$('#txtVolumeName').val(),"size":$('#txtVolumeSize').val(),
		"dedup":dedup,"compression":compression,"backup_device":backup_device,"protocolId":$('#ddlVolumeProtocol').val(),
		"poolId":$('#ddlVolumePool').val(),"hostId":$('#ddlVolumeHost').val(),"lun":$('#txtVolumeLUN').val(),
		"portId":$('#ddlvolumePorts').val(), "thin":thin
	};
	CallPythonService(request);
}
function UpdateVoume()
{
	var isFormValid = $("#formVolumeMgr").validationEngine('validate');
	if(!isFormValid)
		return;
	
	var dedup = $('#chkDedup').is(":checked");
	var compression = $('#chkCompression').is(":checked");
	var backup_device = $('#chkBackupDevice').is(":checked");
	var thin = $('#chkThin').is(":checked");

	var request = new Request();
	request.url ="cgi/cgi_VolumeManager.py"
	request.statusType="SaveVolume";
	request.parameters={
		"requestType":'update_Volume',"volumeId":selectedVolume,"size":$('#txtVolumeSize').val(),"dedup":dedup,"compression":compression,
		"backup_device":backup_device,"protocolId":$('#ddlVolumeProtocol').val(),"poolId":$('#ddlVolumePool').val(),
		"hostId":$('#ddlVolumeHost').val(),"lun":$('#txtVolumeLUN').val(),"portId":$('#ddlvolumePorts').val(),"thin":thin};
	CallPythonService(request);
}
function DeleteVoume()
{
	//alert($('input[name=rdVolume]:checked').val());
	// var isFormValid = $("#formVolumeMgr").validationEngine('validate');
	// if(!isFormValid)
		// return;
	
	if(selectedVolume > 0){
		
		swal({
		  title: "Are you sure?",
		  text: "You want to delete Volume and its snapshots!",
		  type: "warning",
		  showCancelButton: true,
		  confirmButtonClass: "btn-danger",
		  confirmButtonText: "Yes, delete it!",
		  cancelButtonText: "No, cancel please!",
		  closeOnConfirm: false,
		  closeOnCancel: false
		},
		function(isConfirm) {
		  if (isConfirm) {
			var request = new Request();
			request.url ="cgi/cgi_VolumeManager.py"
			request.statusType="SaveVolume";
			request.parameters={"requestType":'delete_Volume',"volumeId":selectedVolume,"volumeType":$('input[name=rdVolume]:checked').attr('volType')};
			CallPythonService(request);
		  } else {
			swal("Cancelled", "Your Volume is safe :)", "error");
		  }
		});
		
		
		
		
		
	}
	else
	{
		$('.clsVolumePage').removeClass('alert-danger');
		alert('Please select Volume');
	}
}
function BindVolumeSavedData()
{
	var request = new Request();
	request.url ="cgi/cgi_VolumeManager.py"
	request.statusType="getVolumeSavedData";
	request.parameters={"requestType":'read_Volume','volumeId':0};
	CallPythonService(request);
}
$('#ddlVolumeNames').change(function(){
	var request = new Request();
	request.url ="cgi/cgi_VolumeManager.py"
	request.statusType="getVolumeById";
	request.parameters={"requestType":'read_Volume','volumeId':$(this).val()};
	CallPythonService(request);
});

function EditVolume(){
	if(selectedVolume > 0){
		BindVolumeSavedData();
		var request = new Request();
		request.url ="cgi/cgi_VolumeManager.py"
		request.statusType="getVolumeById";
		request.parameters={"requestType":'read_Volume','volumeId':selectedVolume};
		
		setTimeout(function(){ CallPythonService(request);$('#divNewVolumeMgr').show();}, 2000);
		
	}
	else{
		$('.clsVolumePage').removeClass('alert-danger');
		alert('Please select Volume');
	}
}

function OnOffVolume(volumeId,state,volumeType)
{
	var request = new Request();
	request.url ="cgi/cgi_VolumeManager.py"
	request.statusType="changeVolumeState";
	request.parameters={"requestType":'onOff_Volume','volumeId':volumeId,"state":state,"volumeType":volumeType};
	CallPythonService(request);
}

$('#txtSnapshotName').on('input',function(){
	if($(this).val().length > 0)
		$('#btnVolumeSnap').show();
	else
		$('#btnVolumeSnap').hide();
})
function VolumeInfo(volumeId,volumeType)
{
	var request = new Request();
	request.url ="cgi/cgi_VolumeManager.py"
	request.statusType="volumeInfo";
	request.parameters={"requestType":'read_VolumeInfo','volumeId':volumeId,"volumeType":volumeType};
	CallPythonService(request);
	
	
}
function SnapShotVolume(volumeId,volumeName)
{	
	swal({
        title: "volume Snapshot",
        text: "Enter snapshot name:",
        type: "input",
        showCancelButton: true,
		confirmButtonText: 'Confirm',		
        closeOnConfirm: false,
        inputPlaceholder: volumeName,
        inputValue: volumeName + "-ss1"
    }, function(inputValue) {
        if (inputValue === false) return false;
        if (inputValue === "") {
            swal.showInputError("Snapshot name required!");
            return false
        }
		else{
			var serverName = $('#myModalLabelPop').text();
			var request=new Request();
			request.url ="cgi/cgi_VolumeManager.py"
			request.statusType = 'SaveSnapVolume';
			request.parameters = {"requestType":'snapShot_volume',"volumeId":volumeId,"snapShotName":inputValue};			
			CallPythonService(request);		
		}        
    });
}

$('#ddlVolumeProtocol').change(function(){
	selectedProtocol = $(this).val();
	var request = new Request();
	request.url ="cgi/cgi_VolumeManager.py"
	request.statusType="getHostsForVolume";
	request.parameters={"requestType":'read_HostByProtocol',"protocolId":selectedProtocol};
	CallPythonService(request);
}); 

function refineHostsAfterLoadingVolumeForEdit() {
	selectedProtocol = $('#ddlVolumeProtocol').val();
	var request = new Request();
	request.url ="cgi/cgi_VolumeManager.py"
	request.statusType="refineHostOnLoading";
	request.parameters={"requestType":'read_HostByProtocol',"protocolId":selectedProtocol};
	CallPythonService(request);
}
$('.clsVolumeRecord').change(function(){
	selectedVolume = $(this).attr('value');
	alert(selectedVolume);
});
function GetString(str)
{
	if(str == null)
		return '';
	else
		return str;
}
function getProtocolForState(state)
{
	var imagePath = 'images/';
	if(state==8)
	{
		return(['','N']);
	}
	else if(state==9)
	{
		return(['hide','N']);
	}
	else if(state==10)
	{
		return(['','C']);
	}
	else if(state==11)
	{
		return(['hide','C']);
	}
	else if(state==12)
	{
		return(['','I']);
	}
	else if(state==13)
	{
		return(['hide','I']);
	}
}
function addValidationToLUN() {
	$('#txtVolumeLUN').on("keyup change", function(e)  {
		lun_value = parseInt($('#txtVolumeLUN').val())
		if(used_luns.includes(lun_value)) {
			$('#lun_error').html('  (* LUN already in use )  ')
		}
		else if (lun_value < lunMinValue || lun_value>lunMaxValue) {
			$('#lun_error').html('  (* invalid LUN )  ')
		}
		else {
			$('#lun_error').html('')
		}
	});

	$("#txtVolumeLUN").focusout(function() {
		if(used_luns.includes(lun_value) ) {
			$("#txtVolumeLUN").val('')
		}
		else if (lun_value < lunMinValue || lun_value>lunMaxValue) {
			$("#txtVolumeLUN").val('')
		}
    });
}