#!/usr/bin/python3

import cgi, cgitb
from global_func import *

cgitb.enable()
import sqlite3
import json
from db import *

form = cgi.FieldStorage()
request_Type = form.getvalue('RequestType')
cmd_Id = get_ccm_command_id()

CCM = False

def create_EmailServices():
    sender = form.getvalue('sender')
    emailRecipient = form.getvalue('emailRecipient')
    password = form.getvalue('password')
    smtpServer = form.getvalue('smtpServer')
    portNumber = form.getvalue('portNumber')
    alertType = form.getvalue('alertType')

    if smtpServer != "":
        if CCM:
            cmd = "SaveEmail"
            message = "set,element=services,element_name={0},args=7,Action={1},recipient_email={2}," \
                    "password={3},smtp_server={4},port={5},alert_type={6},uuid={7}" \
                .format(sender, cmd, emailRecipient, password, smtpServer, portNumber, alertType, cmd_Id)
            send_ccm_msg(message)
            response = get_ccm_response(cmd_Id)
            print(response)
            delete_ccm_response(cmd_Id)
        else:
            query_lan = c.execute("delete from email_logs")
            conn.commit()
            query_lan = c.execute(
                "insert into email_logs (sender_email,recipient_email,password,smtp_server,port,alert_type) values(?,?,?,?,?,?)",
                [sender, emailRecipient, password, smtpServer, portNumber, alertType])
            conn.commit()
            print(json.JSONEncoder().encode({"status": "success", "description": "Saved successfully"}))
    else:
        print(json.JSONEncoder().encode({"status": "fail", "description": "Fill All mandatory fields"}))

    c.close()
    conn.close()


def create_BackupServices():
    backupDest = form.getvalue('backupDest')
    iPAddress = form.getvalue('iPAddress')
    accountName = form.getvalue('accountName')
    bckPassword = form.getvalue('bckPassword')
    certificate = form.getvalue('certificate')

    if backupDest != "":
        if CCM:
            cmd = "SaveService"
            message = "set,element=services,element_name={0},args=6,Action={1},ip_address={2}," \
                    "account_name={3},password={4},certificate_path={5},uuid={6}" \
                .format(backupDest, cmd, iPAddress, accountName, bckPassword, certificate, cmd_Id)
            send_ccm_msg(message)
            response = get_ccm_response(cmd_Id)
            print(response)
            delete_ccm_response(cmd_Id)
        else:
            query_lan = c.execute("delete from backup where destination_name='" + str(backupDest) + "'")
            conn.commit()
            query_lan = c.execute(
                "insert into backup (ip_address,account_name,password,certificate_path,destination_name) values(?,?,?,?,?)",
                [iPAddress, accountName, bckPassword, certificate, backupDest])
            conn.commit()
            print(json.JSONEncoder().encode({"status": "success", "description": "Saved successfully"}))
    else:
        print(json.JSONEncoder().encode({"status": "fail", "description": "Fill All mandatory fields"}))

    c.close()
    conn.close()


def read_EmailServices():
    dbquery = "SELECT id,recipient_email,sender_email,password,smtp_server,port,alert_type from email_logs"
    query = c.execute(dbquery)
    dbdata = []
    conn.commit()
    for col in c:
        jsonschema = {"id": col[0], "recipient_email": col[1], "sender_email": col[2], "password": col[3],
                      "smtp_server": col[4], "port": col[5], "alert_type": col[6]}
        dbdata.append(jsonschema)
    conn.close()
    print(json.JSONEncoder().encode(dbdata))


def read_BackupServices():
    destType = form.getvalue('destType')
    dbquery = "SELECT id,destination_name,ip_address,account_name,password,certificate_path from backup where destination_name='" + str(
        destType) + "'"
    query = c.execute(dbquery)
    dbdata = []
    conn.commit()
    for col in c:
        jsonschema = {"id": col[0], "destination_name": col[1], "ip_address": col[2], "account_name": col[3],
                      "password": col[4], "certificate_path": col[5]}
        dbdata.append(jsonschema)
    conn.close()
    print(json.JSONEncoder().encode(dbdata))


print ("Content-type:text/html\r\n\r\n")
if request_Type == 'create_EmailServices':
    create_EmailServices()
elif request_Type == 'create_BackupServices':
    create_BackupServices()
elif request_Type == 'read_BackupServices':
    read_BackupServices()
elif request_Type == 'read_EmailServices':
    read_EmailServices()
else:
    print(Json.JSONEncoder().encode({"test"}))
