#!/usr/bin/python3

from global_func import *
import sqlite3
import json
from db import *
import subprocess
import os

CIFS=1
NFS=2
iSCSIChap=3
iSCSINoChap=4
FTP=5
FC=6

GUI=true
#GUI=false

if GUI==true:
    import cgi,cgitb
    cgitb.enable()

if GUI==true:
    form = cgi.FieldStorage()
    request_Type=form.getvalue('requestType')

else:
    print('1. create_Storage')
    print('2. read_Storage')
    print('3. OnOff_Device')
    print('4. delete_Storage ')
    print('5. ConnectDisconnect SM_Storage ')

    choice=int(input("select cgi function==>"))
    if (choice==1):
        request_Type='create_Storage'
    if (choice==2):
        request_Type='read_Storage'
    if (choice==3):
        request_Type='OnOff_Device'
    if (choice==4):
        request_Type='delete_Storage'
    if (choice==5):
        request_Type='ConnectDisconnectSM_Storage'
    print("Reques_Type="+str(request_Type))


def form_getvalue(val):
    if (val=='name'):
        name=str(input("input StorMan Name==>"))
        return name
    elif (val=='protocolId'):
        protID=str(input("input ProtID (CIFS=1, NFS=2)==>"))
        return protID
    elif (val=='hostId'):
        hostID=str(input("input HostID ==>"))
        return hostID
    elif (val=='Status'):
        statusID=str(input("input Status ==>"))
        return status
    elif (val=='storageId'):
        storageId=str(input("input StorMan Id ==>"))
        return storageId
    elif (val=='state'):
        state=str(input("input state 0=Off, 1=On ==>"))
        return state
    elif (val=='deviceId'):
        deviceId=str(input("input deviceId ==>"))
        return deviceId
    elif (val=='action'):
        action=str(input("input action C/D ==>"))
        return action

    else: 
        print("Unknown Value")

def create_Storage():
    if GUI==true:
        name=form.getvalue('name')
        protocolId=form.getvalue('protocolId') 
        hostId=form.getvalue('hostId') 
        Status=form.getvalue('Status')
        remoteDir=form.getvalue('remoteDir')
    else:
        name=form_getvalue('name')
        protocolId=form_getvalue('protocolId') 
        hostId=form_getvalue('hostId') 
        Status=form_getvalue('Status')
        remoteDir=form_getvalue('remoteDir')
        
    query_lan=c.execute("select count(*) from stor_man where name='"+ str(name)+"'")
    nameCount = c.fetchone()[0]
    conn.commit()
    
    if nameCount == 0:
        query_SP=c.execute("insert into  stor_man(name,protocol,host_id,state,cr_date,remote_share) values(?,?,?,?,datetime(),?)",[name,protocolId,hostId,0,remoteDir])
        conn.commit()       
        print(json.JSONEncoder().encode({'status':'success','description':'Saved successfully'}))
    else:               
        print(json.JSONEncoder().encode({'status':'fail','description':'Host Name Already Exists'}))
        
    c.close()
    conn.close()

def read_Storage():
    if GUI==true:
        storageId = form.getvalue('storageId')
    else:
        storageId = form_getvalue('storageId')
        
    if storageId == '0':
        dbquery="SELECT id,name,protocol,host_id,state,remote_share from stor_man"
    else:
        dbquery="SELECT id,name,protocol,host_id,state,remote_share from stor_man where id="+str(storageId)
    query = c.execute(dbquery)
    dbdata = []
    conn.commit()
    for col in c:
        jsonschema = {"id":col[0],"name" : col[1],"protocol":col[2],"host_id":col[3],"state":col[4],"remoteDir":col[5],"dummy":'-'}
        dbdata.append(jsonschema)
    print(json.JSONEncoder().encode(dbdata))


def OnOff_Device():
    if GUI==true:
        state=form.getvalue('state') 
        deviceId = form.getvalue('deviceId')
    else:
        state=form_getvalue('state') 
        deviceId = form_getvalue('deviceId')
        print("state, deviceId",state,deviceId)
        
    query=c.execute("update device set state=? where id=?",[state,deviceId])
    conn.commit()
    
    if  state == str(0):
        print(json.JSONEncoder().encode({'status':'success','description':'Device is OFF'}))
    else:               
        print(json.JSONEncoder().encode({'status':'success','description':'Device is ON'}))
def fake_pool_create():
        PoolName="HDD POOL"
        PoolSystemName="HDD POOL"
        PoolSize =100
        PoolLevel=0
        zfsCompression="false"
        zfsAcceleration=0
        zfsDedup="false"
        PoolAccelerationStorage=0

        query_SP = c.execute(
        "insert into multi_device(name,pool_storage,level,state,cr_date,edit_date,compression,acceleration,deduplication,acceleration_storage,system_name) \
        values(?,?,?,1,datetime(),datetime(),?,?,?,?,?)",[PoolName, PoolSize, PoolLevel, zfsCompression, zfsAcceleration, zfsDedup,PoolAccelerationStorage,PoolSystemName])
        conn.commit()
        
def fake_volume_create(volumeName,hostId,multi_device_id):

        size=100
        dedup="false"
        compression="false"
        backup_device="true"
        
        #query_SP=c.execute("insert into  Volume(name,state,size,deduplication,compression,backup_device,multi_device_id,cr_date) values(?,?,?,?,?,?,?,datetime())",\
        #[volumeName,4,size,dedup,compression,backup_device,poolId])
        
        query=c.execute("insert into  volume(name,state,size,multi_device_id,compression,deduplication,cr_date,backup_device) values(?,?,?,?,?,?,datetime(),?)",\
        [volumeName,4,size,multi_device_id,compression, dedup,backup_device]) 
        conn.commit() 
        volumeId = c.lastrowid
        portId =1
        lun=1
        query=c.execute("select id from Volume where name='"+ str(volumeName)+"'")
        resp= c.fetchone()
        if str(resp) != str("None"):
            volumeId= resp[0]
            query_SP=c.execute("insert into  export(port_id,vol_id,host_id,lun) values(?,?,?,?)",[portId,volumeId,hostId,lun])
            conn.commit()
            
def fake_volume_delete(name,hostId,multi_device_id):
        query=c.execute("select id from volume where name='"+ str(name)+"'")
        volId = c.fetchone()[0]
        #print "vol_id = "+str(volId)
        query=c.execute("delete from export where vol_id=?",[volId])
        conn.commit()
        query=c.execute("delete from  volume where name=?",[name])
        conn.commit()        

def ConnectDisconnectSM_Storage():
    if GUI==true:
        storManId = form.getvalue('storageId')
        #hostId=form.getvalue('hostId')
        #action=form.getvalue('action')
        #protocolId=form.getvalue('protocolId')
    else:
        #hostId=form_getvalue('hostId')
        storManId = form_getvalue('storageId')
        #action=form_getvalue('action')
        #protocolId=form_getvalue('protocolId')
    
    dbquery="SELECT sm.state,h.user_name,sm.remote_share,h.id from stor_man sm join host h on h.id=sm.host_id where sm.id="+str(storManId)
    query = c.execute(dbquery)
    dbdata = []
    conn.commit()
    for col in c:
        state = col[0]
        user_name = col[1]
        remote_share = col[2]
        hostId = col[3]

    if state == 0:
        action="C"
    elif state == 1:
        action="D"

    #print("action : ",action, user_name, remote_share)
    #select user_name from host where hostId=hostId
    if action=="C":   #connection

        #user_name="192.168.30.7:/mnt/nfs_backup"
        #remote_share="nfs_backup"   #get the share name from host/share
        local_path="/mnt/"+remote_share
        arg1="-p"
        arg2=local_path

        #sudo mkdir -p /mnt/nfs_backup
        process1 = subprocess.check_output(["mkdir",arg1,arg2])
        #print(process1)
        
        #sudo mount 192.168.30.7:/mnt/nfs_backup  /mnt/nfs_backup
        arg1=user_name      #this is the remote share path , maybe need to fix the db field name
        arg2=local_path
        process1 = subprocess.check_output(["sudo","mount",arg1,arg2])
        #print process1
        
        arg2=local_path
        process1 = subprocess.check_output(["mountpoint",arg2]) #Check if mountpoint
        #print process1

        name=local_path
        sys_name=local_path
        protocolId=NFS
        size=100
        query_SP=c.execute("insert into  device(name,sys_name, size,stor_man_id,state,cr_date) values(?,?,?,?,?,datetime())",[name,sys_name,size,storManId,0])
        conn.commit()
        multi_device_id=22   #some valid pool ID
        fake_volume_create(local_path,hostId,multi_device_id)


    elif action=="D":   #dis-connection
        #user_name="192.168.30.7:/mnt/nfs_backup"
        #remote_share="nfs_backup"   #get the share name from host/share
        local_path="/mnt/"+remote_share    
        arg1=local_path
        try:
            process1 = subprocess.check_output(["sudo","umount",arg1])
            #print process1
            #needs to poll here until mountpoint is gone
        except Exception as err:
            #print ("umount except ",err)
            print(json.JSONEncoder().encode({'status':'success','description':'umout error'}))
            return
            
        try:
            #sudo rmdir -p /mnt/nfs_backup
            arg1="-p"
            arg2=local_path        
            #process1 = subprocess.check_output(["rmdir",arg1,arg2])
            process1 = subprocess.check_output(["rmdir",arg2])
        except Exception as err:
            #print ("rmdir except ",err)
            print(json.JSONEncoder().encode({'status':'success','description':'rmdir error'}))
            return

        #Not required because it will be unmounted - will always throw error
        '''try: 
            #print "checking Mountpoint"
            arg1=local_path
            process1 = subprocess.check_output(["mountpoint",arg1]) #Check if mountpoint
            #print process1
        except Exception as err:
            #print ("mountpoint except ",err)
            #print json.JSONEncoder().encode({'status':'success','description':'mountpoint doesn\'t exist'})
            #return'''
            
        #print "deleting device"
        query=c.execute("delete from  device where name=?",[local_path])
        conn.commit()
        multi_device_id=1
        fake_volume_delete(local_path,hostId,multi_device_id)
        
    query=c.execute("update stor_man set state = (case when state=1 then 0 else 1 end) where id=?",[storManId])
    conn.commit()
    
    print(json.JSONEncoder().encode({'status':'success','description':'Updated Successfully'}))
        
def delete_Storage():

    if GUI==true:
        storageId = form.getvalue('storageId') 
    else:
        storageId = form_getvalue('storageId')
    
    query_lan=c.execute("select count(*) from stor_man where state=1 and id='"+ str(storageId)+"'")
    state = c.fetchone()[0]
    conn.commit()
    if state > 0:
        print(json.JSONEncoder().encode({'status':'fail','description':'Cannot Delete Used Storage'}))
        return
    
    query=c.execute("delete from stor_man where id=?",[storageId])
    conn.commit()
    
    print(json.JSONEncoder().encode({'status':'success','description':'Deleted successfully'}))

def read_Devices():
    if GUI==true:
        storageId = form.getvalue('storageId') 
    else:
        storageId = form_getvalue('storageId')
    
    dbquery="SELECT d.id,d.name,d.sys_name,d.state,p.name protocol from device d  join stor_man sm on sm.id=d.stor_man_id  inner join protocol p on p.id=sm.protocol  where stor_man_id="+str(storageId)
    query = c.execute(dbquery)
    dbdata = []
    conn.commit()
    for col in c:
        jsonschema = {"id":col[0],"name" : col[1],"sys_name":col[2],"state":col[3],"protocol":col[4],"dummy":'-'}
        dbdata.append(jsonschema)
    
    print(json.JSONEncoder().encode(dbdata))
    
print("Content-type:text/html\r\n\r\n")

try:
    if request_Type == 'create_Storage':
        create_Storage()
    elif request_Type == 'read_Storage':
        read_Storage()
    elif request_Type == 'OnOff_Device':
        OnOff_Device()
    elif request_Type == 'delete_Storage':
        delete_Storage()
    elif request_Type == 'ConnectDisconnectSM_Storage':
        ConnectDisconnectSM_Storage()
    elif request_Type == 'read_Devices':
        read_Devices()
    
except BaseException as e:
    #print e.message #Better to implement error logging
    pass
finally:
    conn.close()
