#!/usr/bin/python3

import cgi,cgitb
cgitb.enable()
from globalSettings import *
import csv
import json
#import datetime
from datetime import datetime

form = cgi.FieldStorage()

request_Type=form.getvalue('request_Type')

startDate=form.getvalue('startDate')
endDate=form.getvalue('endDate')
maxLogLevel=form.getvalue('maxLogLevel')
logType=form.getvalue('logType')


def read_CCMLogs():	
	displayTextList = ['Date Time','Element','Element Name','Log Level','State','Action','Message']
	propertyNameList = ['datetime','element','elementname','loglevel','sate','action','message']
	
	with open(LogsFilePath, 'rb') as csvfile:
		filereader = csv.reader(csvfile, delimiter='@')
		i = 0
		header = []
		out_data = []
		header = propertyNameList
		for row in filereader:
			i+=1
			if i > 50:
				break
			row = [elem for elem in row if elem]
			#print row
			#row[0:2] = [row[0]]
			_dict = {}
			for elem, header_elem in zip(row, header):
				_dict[header_elem.strip()] = elem.strip()
			out_data.append(_dict)	
	#print datetime.strptime('15/03/2019-19:34:46', '%d/%m/%Y-%H:%M:%S')
	print(json.JSONEncoder().encode({'logsData':ApplyFilter(out_data),'headers':displayTextList,'propetyName':propertyNameList}))

def read_CCMAlerts():	
	displayTextList = ['Date Time','Element','Element Name','Log Level','State','Action','Message']
	propertyNameList = ['datetime','element','elementname','loglevel','sate','action','message']
	
	with open(AlertsFilePath, 'rb') as csvfile:
		filereader = csv.reader(csvfile, delimiter='@')
		i = 0
		header = []
		out_data = []
		header = propertyNameList
		for row in filereader:
			i+=1
			if i > 50:
				break
			row = [elem for elem in row if elem]
			#print row
			#row[0:2] = [row[0]]
			_dict = {}
			for elem, header_elem in zip(row, header):
				_dict[header_elem.strip()] = elem.strip()
			out_data.append(_dict)	
	#print datetime.strptime('15/03/2019-19:34:46', '%d/%m/%Y-%H:%M:%S')
	print(json.JSONEncoder().encode({'logsData':ApplyFilter(out_data),'headers':displayTextList,'propetyName':propertyNameList}))

	
def ApplyFilter(logs):
	if str(logType) != '':
		logTypeFilters = logType.split(",")
		
	if str(logType) != '' and str(logType) != 'All':
		logs = [x for x in logs if x['sate'] in logTypeFilters]
	
	if str(maxLogLevel) != '' and str(maxLogLevel) != 'None':
		logs = [x for x in logs if int(x['loglevel']) <= int(maxLogLevel)]
	
	if str(startDate) != '' and str(startDate) != 'None':		
		#print datetime.strptime(str(startDate), '%m/%d/%Y')
		logs = [x for x in logs if datetime.strptime(x['datetime'], '%d/%m/%Y-%H:%M:%S') >= datetime.strptime(str(startDate), '%m/%d/%Y')]
		
	if str(endDate) != '' and str(endDate) != 'None':
		#print datetime.strptime(str(endDate)+" 23:59:59", '%m/%d/%Y %H:%M:%S')	
		logs = [x for x in logs if datetime.strptime(x['datetime'], '%d/%m/%Y-%H:%M:%S') <= datetime.strptime(str(endDate)+" 23:59:59", '%m/%d/%Y %H:%M:%S')]
		
	return logs
	
	
print ("Content-type:text/html\r\n\r\n")

try:
	if request_Type == 'read_CCMLogs':
		read_CCMLogs()
	elif request_Type == 'read_CCMAlerts':
		read_CCMAlerts()
	()
except BaseException as e:
	#print json.JSONEncoder().encode({'status':'fail','description':'Eror occured, Please refer log file more info'})
	print(json.JSONEncoder().encode({'status':'fail','description':str(e)}))
	timeNow =  datetime.now()
	f= open("./log.txt","a+")
	f.write(str(timeNow)+" "+ str(e.message)+ "\r\n")