#!/usr/bin/python3

import cgi,cgitb
from global_func import *
from globalSettings import *
cgitb.enable()
import sqlite3
import json
from db import *


form = cgi.FieldStorage()
request_Type=form.getvalue('RequestType')

component = form.getvalue('component')
subComponent = form.getvalue('subComponent')

def read_SubComponent():
	#Call corresponding method based on component and sub component
	if component == 'Temperature':		
		result={}
		if "CPU" in subComponent:
			cpu_query=c.execute("Select id,name,ifnull(location,'System'),ifnull(temperature,0),ifnull(low_threshold,0),ifnull(hi_threshold,0),ifnull(min,0),ifnull(max,0),ifnull([default],0) from cpu where name = '"+subComponent + "'")
		elif "Disk" in subComponent or "HDD" in subComponent or "SSD" in subComponent:
			cpu_query=c.execute("Select id,name,ifnull(location,'System'),ifnull(temp,0),ifnull(low_threshold,0),ifnull(hi_threshold,0),ifnull(t_min,0),ifnull(t_max,0),ifnull([temp_default],0) from disks where name = '"+subComponent + "'")
		else:
			cpu_query=c.execute("Select id,name,ifnull(location,'System'),ifnull(temp,0),ifnull(low_threshold,0),ifnull(hi_threshold,0),ifnull(t_min,0),ifnull(t_max,0),ifnull([default],0) from temp_probes where name = '"+subComponent + "'")
		for col in c:			
			result['id'] = col[0]
			result['name'] = col[1]
			result['location'] = col[2]
			result['temperature'] = col[3]
			result['low_threshold'] = col[4]
			result['hi_threshold'] = col[5]
			result['min'] = col[6]
			result['max'] = col[7]
			result['default_val'] = col[8]
			result['TemperatureType'] = TemperatureType
		print((json.JSONEncoder().encode(result)))
		
	elif component == 'Fans':
		result={}
		cpu_query=c.execute("Select id,name,location,ifnull([default],0),ifnull(low_threshold,0),ifnull(hi_threshold,0),ifnull(t_min,0),ifnull(t_max,0),ifnull(speed,0) from fan where name = '"+subComponent + "'")
		for col in c:			
			result['id'] = col[0]
			result['name'] = col[1]
			result['location'] = col[2]
			result['default_val'] = col[3]
			result['low_threshold'] = col[4]			
			result['hi_threshold'] = col[5]
			result['t_min'] = col[6]
			result['t_max'] = col[7]
			result['speed'] = col[8]
		print((json.JSONEncoder().encode(result)))
	elif component == 'Network':
		result={}
		cpu_query=c.execute("Select id,name,location,ifnull(tx_rx_monitor,0),ifnull(err_threshold,0),ifnull(err_max,0),ifnull(tx_rx_default,0) from eth_ports where name = '"+subComponent + "'")
		for col in c:			
			result['id'] = col[0]
			result['name'] = col[1]
			result['location'] = col[2]
			result['tx_rx_monitor'] = col[3]
			result['err_threshold'] = col[4]
			result['err_max'] = col[5]
			result['tx_rx_default'] = col[6]
		print((json.JSONEncoder().encode(result)))		
	elif component == 'Storage':
		result={}
		if subComponent.find("POOL") > 1:
			cpu_query=c.execute("Select id,name,ifnull(location,'System'),ifnull(tx_rx_monitor,0),ifnull(err_threshold,0),ifnull(err_max,0),ifnull(tx_rx_default,0) from multi_device where name = '"+subComponent + "'")
		else:
			cpu_query=c.execute("Select id,name,ifnull(location,'System'),ifnull(tx_rx_monitor,0),ifnull(err_threshold,0),ifnull(err_max,0),ifnull([default],0) from disks where name = '"+subComponent + "'")
		for col in c:			
			result['id'] = col[0]
			result['name'] = col[1]
			result['location'] = col[2]
			result['tx_rx_monitor'] = col[3]
			result['err_threshold'] = col[4]
			result['err_max'] = col[5]
			result['tx_rx_default'] = col[6]
		print((json.JSONEncoder().encode(result)))
		
	
	conn.commit()
	c.close()
	conn.close()
def update_SubComponent():
	if component == 'Temperature':
		low_threshold = form.getvalue('low_threshold')
		hi_threshold = form.getvalue('hi_threshold')
		temperature = form.getvalue('temperature')
		if "CPU" in subComponent:
			cpu_query=c.execute("update cpu set low_threshold=?,hi_threshold=?,temperature=?  where name =?",[low_threshold,hi_threshold,temperature,subComponent])
		elif "Disk" in subComponent or "HDD" in subComponent or "SSD" in subComponent:
			cpu_query=c.execute("update disks set low_threshold=?,hi_threshold=?,temp=?  where name =?",[low_threshold,hi_threshold,temperature,subComponent])
		else:
			cpu_query=c.execute("update temp_probes set low_threshold=?,hi_threshold=?,temp=?  where name =?",[low_threshold,hi_threshold,temperature,subComponent])
		print((json.JSONEncoder().encode({"status":"success","description":"updated successfully"})))
	
	if component == 'Network':
		err_threshold = form.getvalue('err_threshold')
		tx_rx_monitor = form.getvalue('tx_rx_monitor')
		cpu_query=c.execute("update eth_ports set err_threshold=?,tx_rx_monitor=?  where name =?",[err_threshold,tx_rx_monitor,subComponent])
		print((json.JSONEncoder().encode({"status":"success","description":"updated successfully"})))
	
	if component == 'Storage':
		err_threshold = form.getvalue('err_threshold')
		tx_rx_monitor = form.getvalue('tx_rx_monitor')
		
		if subComponent.find("POOL") > 1:
			cpu_query=c.execute("update multi_device set err_threshold=?,tx_rx_monitor=?  where name =?",[err_threshold,tx_rx_monitor,subComponent])
		else:
			cpu_query=c.execute("update disks set err_threshold=?,tx_rx_monitor=?  where name =?",[err_threshold,tx_rx_monitor,subComponent])
		print((json.JSONEncoder().encode({"status":"success","description":"updated successfully"})))
	
	elif component == 'Fans':
		low_threshold = form.getvalue('low_threshold')
		hi_threshold = form.getvalue('hi_threshold')
		cpu_query=c.execute("update fan set low_threshold=?,hi_threshold=?  where name =?",[low_threshold,hi_threshold,subComponent])
		print((json.JSONEncoder().encode({"status":"success","description":"updated successfully"})))
	conn.commit()
	c.close()
	conn.close()
def read_AllSubComponents():
	temperature = []#['CPU','Motherboard','Storage']
	fans = []#'CPU','REAR FAN1','REAR FAN2','PSU1 FAN','PSU2 FAN'
	network = []
	storage = [] #['HDD Pool','SSD Pool','HDD 0','HDD 1','HDD 2','HDD 3','HDD 4','HDD 5','HDD 6','HDD 7','SSD 0','SSD 1','SSD 2','SSD 3']
	
	temperature_query=c.execute("Select name from cpu union select name from temp_probes union select name from disks")
	for col in c:			
		temperature.append(col[0])
	
	fan_query=c.execute("Select name from fan order by name")
	for col in c:			
		fans.append(col[0])
	
	network_query=c.execute("Select name from eth_ports order by name")
	for col in c:			
		network.append(col[0])
	
	storage_query=c.execute("Select name from multi_device  union select name from disks")
	for col in c:			
		storage.append(col[0])
		
	
	conn.commit()
	c.close()
	conn.close()
	print(json.JSONEncoder().encode({"temperature":temperature,"fans":fans,"network":network,"storage":storage}))

print("Content-type:text/html\r\n\r\n")

#Entry point for CRUD operations
if request_Type == 'read_SubComponent':
	read_SubComponent()
elif request_Type == 'update_SubComponent':
	update_SubComponent()
elif request_Type == 'create_Component':
	create_Component()
elif request_Type == 'read_AllSubComponents':
	read_AllSubComponents()
