#!/usr/bin/python3

import cgi,cgitb
from global_func import *
from cgi_UploadControl_Manager import *
cgitb.enable()
import sqlite3
import json
from db import *


form = cgi.FieldStorage()
request_Type=form.getvalue('RequestType') 


def create_Group():
	groupId=form.getvalue('groupId')
	groupName=form.getvalue('groupName') 
	groupDescription=form.getvalue('groupDescription')	
	if groupId == '0':
		query_lan=c.execute("select count(*) from OrgGroup where Name='"+ str(groupName)+"'")
		nameCount = c.fetchone()[0]
		conn.commit()
	
		if nameCount == 0:
			query_SP=c.execute("insert into OrgGroup(Name,Description,cr_date,edit_date) values(?,?,datetime(),datetime())",[groupName,groupDescription])
			conn.commit()		
			print(json.JSONEncoder().encode({'status':'success','description':'Saved successfully'}))
		else:
			print(json.JSONEncoder().encode({"status":"fail","description":"Group Name already exists"}))
	else:
		query_SP=c.execute("update OrgGroup set Name=?,Description=?,edit_date=datetime() where id=?",[groupName,groupDescription,groupId])
		conn.commit()		
		print(json.JSONEncoder().encode({'status':'success','description':'Updated successfully'}))
		
	c.close()
	conn.close()
	
def delete_Group():
	groupId=form.getvalue('groupId')
	query_lan=c.execute("select count(*) from UserLink where group_id='"+ str(groupId)+"'")
	recordCount = c.fetchone()[0]
	conn.commit()	
	
	query_lan=c.execute("select count(*) from GroupLink where link_group_id='"+ str(groupId)+"'")
	recordCountGroups = c.fetchone()[0]
	conn.commit()
	
	if recordCount > 0:
		print(json.JSONEncoder().encode({'status':'fail','description':'You cant delete group, since users are mapped to this group.'}))
		return
	elif recordCountGroups >0:
		print(json.JSONEncoder().encode({'status':'fail','description':'You cant delete group, since groups are mapped to this group.'}))
		return
	else:
		query_FT=c.execute("delete from  OrgGroup where id=?",[groupId])
		conn.commit()
		query_FT=c.execute("delete from  GroupLink where group_id=?",[groupId])
		conn.commit()
		print(json.JSONEncoder().encode({'status':'success','description':'Deleted successfully'}))
			

def delete_Role():
	roleId=form.getvalue('roleId')
	
	query_lan=c.execute("select count(*) from UserLink where role_id='"+ str(roleId)+"'")
	recordCount = c.fetchone()[0]
	conn.commit()	
	if recordCount > 0:
		print(json.JSONEncoder().encode({'status':'fail','description':'You cant delete role, since users are mapped to this role.'}))
		return
	else:
		query_FT=c.execute("delete from  OrgRole where id=?",[roleId])	
		conn.commit()	
		query_FT=c.execute("delete from  RoleLink where role_id=?",[roleId])	
		conn.commit()
		print(json.JSONEncoder().encode({'status':'success','description':'Deleted successfully'}))
	
def read_Group():
	groupId=form.getvalue('groupId')
	if groupId == '0':
		dbquery="SELECT id,name,description from OrgGroup"
	else:
		dbquery="SELECT id,name,description from OrgGroup where id="+str(groupId)
	
	query = c.execute(dbquery)
	dbdata = []
	conn.commit()
	for col in c:
		jsonschema = {"id":col[0],"name" : col[1],"description" :col[2]}
		dbdata.append(jsonschema)
	conn.close()
	print(json.JSONEncoder().encode(dbdata))

def getDBGroups():
	dbquery="SELECT id,Name,Description,level from OrgGroup"
	query = c.execute(dbquery)
	dbdata = []
	conn.commit()
	for col in c:
		jsonschema = {"id":col[0],"Name" : col[1],"Description" :col[2],"level":col[3]}
		dbdata.append(jsonschema)
	#conn.close()
	return dbdata
	
def create_User():
	userId=form.getvalue('userId')
	
	firstName=form.getvalue('firstName')
	middleName=form.getvalue('middleName')
	lastName=form.getvalue('lastName') 
	
	userName=form.getvalue('userName') 
	password=form.getvalue('password')
	
	selectedRoles =form.getvalue('selectedRoles')
	selectedGroups =form.getvalue('selectedGroups')
	
	managerId=form.getvalue('managerId')
	employmentStatus=form.getvalue('employmentStatus')
	imgPath = form.getvalue('imgPath')
	
	contactEmail=form.getvalue('contactEmail')
	contactPhone=form.getvalue('contactPhone')
	companyEmail=form.getvalue('companyEmail')
	companyPhone=form.getvalue('companyPhone')
	
	address1=form.getvalue('address1')
	address2=form.getvalue('address2')
	city=form.getvalue('city')
	state=form.getvalue('state')
	country=form.getvalue('country')
	postalCode=form.getvalue('postalCode')
	
	if userId == '0':
		query_lan=c.execute("select count(*) from person where userName='"+ str(userName)+"'")
		nameCount = c.fetchone()[0]
		conn.commit()
		
		if nameCount == 0:
			query_SP=c.execute("insert into person(userName,FirstName,MiddleName,LastName,password,contactEmail,contactPhone,companyEmail,companyPhone,manager_id,employmentStatus,address1,address2,city,state_providence,country,postalcode,profilePic_id,cr_date,edit_date) values(?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,datetime(),datetime())",[userName,firstName,middleName,lastName,password,contactEmail,contactPhone,companyEmail,companyPhone,managerId,employmentStatus,address1,address2,city,state,country,postalCode,Uploadfile(imgPath)])
			conn.commit()
			userId = c.lastrowid			
			
			mapUserRoleGroups(userId,selectedRoles,selectedGroups)
			
			print(json.JSONEncoder().encode({'status':'success','description':'Saved successfully'}))
		else:
			print(json.JSONEncoder().encode({"status":"fail","description":"User Name already exists"}))
			
	else:
		query_SP=c.execute("update person set userName = ?,FirstName = ?,MiddleName = ?,LastName = ?,password = ?,contactEmail = ?,contactPhone = ?,companyEmail = ?,companyPhone = ?,manager_id = ?,employmentStatus = ?,address1 = ?,address2 = ?,city = ?,state_providence = ?,country = ?,postalcode = ?,edit_date=datetime(),profilePic_id=? where id=?",[userName,firstName,middleName,lastName,password,contactEmail,contactPhone,companyEmail,companyPhone,managerId,employmentStatus,address1,address2,city,state,country,postalCode,Uploadfile(imgPath),str(userId)])
		conn.commit()
		query_SP=c.execute("delete from UserLink where person_id=?",[userId])
		conn.commit()
		
		mapUserRoleGroups(userId,selectedRoles,selectedGroups)
		
		print(json.JSONEncoder().encode({'status':'success','description':'Updated successfully'}))
	
	c.close()
	conn.close()

def mapUserRoleGroups(userId,selectedRoles,selectedGroups):
	if str(selectedRoles) != "None":
		selectedRolesList = selectedRoles.split(",")
		selectedGroupsList = selectedGroups.split(",")
		
		for index, roleId in enumerate(selectedRolesList):
			groupId = selectedGroupsList[index]
			query_SP=c.execute("insert into UserLink(state,cr_date,person_id,role_id,group_id) values(?,datetime(),?,?,?)",[1,userId,roleId,groupId])
			conn.commit()

def delete_User():
	userId=form.getvalue('userId')
	query_lan=c.execute("select count(*) from person where manager_id='"+ str(userId)+"'")
	recordCount = c.fetchone()[0]
	conn.commit()	
	if recordCount > 0:
		print(json.JSONEncoder().encode({'status':'fail','description':'You cant delete user, since other users are mapped to this user.'}))
		return
	else:
		query_FT=c.execute("delete from  person where id=?",[str(userId)])	
		conn.commit()
		query_FT=c.execute("delete from  UserLink where person_id=?",[str(userId)])	
		conn.commit()
	c.close()
	conn.close()
	print(json.JSONEncoder().encode({'status':'success','description':'Deleted successfully'}))
	
def validate_User():
	userName=form.getvalue('userName')
	query_lan=c.execute("select count(*) from person where userName='"+ str(userName)+"'")
	nameCount = c.fetchone()[0]
	conn.commit()	
	if nameCount == 0:
		print(json.JSONEncoder().encode({'status':'success','description':'User Name Available'}))
	else:
		print(json.JSONEncoder().encode({'status':'fail','description':'User Name Already Exists, please choose another'}))

def read_User(bReturn):
	userId=form.getvalue('userId')
	if str(userId) == "None":
		userId= '0'
	if userId == '0':
		dbquery="SELECT person.id,userName,FirstName,MiddleName,LastName,password,contactEmail,contactPhone,companyEmail,companyPhone,manager_id,employmentStatus,address1,address2,city,state_providence,country,postalcode,fileInfo.path from person left join fileInfo on person.profilePic_id = fileInfo.id"
	else:
		dbquery="SELECT person.id,userName,FirstName,MiddleName,LastName,password,contactEmail,contactPhone,companyEmail,companyPhone,manager_id,employmentStatus,address1,address2,city,state_providence,country,postalcode,fileInfo.path from person  left join fileInfo on person.profilePic_id = fileInfo.id where person.id="+str(userId)
	
	query = c.execute(dbquery)
	dbdata = []
	conn.commit()
	for col in c:
		jsonschema = {"id":col[0],"userName" : col[1],"FirstName" :col[2],"MiddleName":col[3],"LastName" : col[4],"password" :col[5],"userEmail":col[6],"Phone" : col[7],"companyEmail":col[8],"companyPhone" : col[9],"manager_id" :col[10],"employmentStatus":col[11],"address1" : col[12],"address2" :col[13],"city":col[14],"state_providence" : col[15],"country":col[16],"postalcode" : col[17],"profilePicPath":col[18],"userSelectedGroupsRoles" :read_AllUserLinksByUser(col[0])}
		dbdata.append(jsonschema)
	#conn.close()
	if bReturn == True:
		return dbdata
	else:
		print(json.JSONEncoder().encode(dbdata))


def read_AllUserLinksByUser(userId):
	newCon=conn.cursor()
	dbquery="SELECT group_id,role_id from UserLink where person_id="+str(userId)
	query = newCon.execute(dbquery)
	selectedRoles = []
	conn.commit()
	for userLink in newCon:
		selectedRoles.append({"groupId":userLink[0],"roleId":userLink[1]})
	return  selectedRoles

def read_AllGroupsByUser(userId):
	newCon=conn.cursor()
	dbquery="SELECT group_id from UserLink where type='group' and user_id="+str(userId)
	query = newCon.execute(dbquery)
	selectedGroups = []
	conn.commit()
	for lst in newCon:
		selectedGroups.append(lst[0])
	return  selectedGroups

def read_AllGroupsByRole(roleId):
	newCon=conn.cursor()
	dbquery="SELECT group_id from RoleLink where role_id="+str(roleId)
	query = newCon.execute(dbquery)
	selectedGroups = []
	conn.commit()
	for lst in newCon:
		selectedGroups.append(lst[0])
	return  selectedGroups
	
def read_UsersByRole():
	roleId=form.getvalue('roleId')
	dbquery="SELECT distinct person.id,userName,FirstName,LastName,contactEmail from person inner join UserLink rul on  person.id = rul.person_id where rul.role_id="+str(roleId)
	
	query = c.execute(dbquery)
	dbdata = []
	conn.commit()
	for col in c:
		jsonschema = {"id":col[0],"userName" : col[1],"FirstName" :col[2],"LastName":col[3],"userEmail" : col[4]}
		dbdata.append(jsonschema)
	conn.close()
	print(json.JSONEncoder().encode(dbdata))

def read_RolesByGroup():
	groupId=form.getvalue('groupId')
	dbquery="SELECT role.id,role.name,role.description from orgRole role inner join RoleLink rgl on  role.id = rgl.role_id where rgl.group_id="+str(groupId)
	
	query = c.execute(dbquery)
	dbdata = []
	conn.commit()
	for col in c:
		jsonschema = {"id":col[0],"name" : col[1],"description" :col[2]}
		dbdata.append(jsonschema)
	conn.close()
	print(json.JSONEncoder().encode(dbdata))
	
def read_GroupsByRoles():
	roleIds=form.getvalue('roleIds')
	dbquery="SELECT role.id,role.name,role.description,rgl.group_id,orgGroup.name from orgRole role inner join RoleLink rgl on  role.id = rgl.role_id inner join OrgGroup on orgGroup.id=rgl.group_id where rgl.role_id in("+str(roleIds)+")"
	
	query = c.execute(dbquery)
	dbdata = []
	conn.commit()
	for col in c:
		jsonschema = {"roleId":col[0],"roleName" : col[1],"description" :col[2],"id":col[3],"name":col[4]}
		dbdata.append(jsonschema)
	conn.close()
	print(json.JSONEncoder().encode(dbdata))

	
def create_Role():
	roleId=form.getvalue('roleId')
	roleName=form.getvalue('roleName') 
	roleDescription=form.getvalue('roleDescription')	
	selectedGroups=form.getvalue('selectedGroups')
	if roleId == '0':
		query_lan=c.execute("select count(*) from OrgRole where Name='"+ str(roleName)+"'")
		nameCount = c.fetchone()[0]
		conn.commit()
	
		if nameCount == 0:
			query_SP=c.execute("insert into OrgRole(Name,Description,cr_date,edit_date) values(?,?,datetime(),datetime())",[roleName,roleDescription])
			conn.commit()
			roleId = c.lastrowid
			mapRoleGroups(roleId,selectedGroups)
			print(json.JSONEncoder().encode({'status':'success','description':'Saved successfully'}))
			
		else:
			print(json.JSONEncoder().encode({"status":"fail","description":"Role Name already exists"}))
	else:
		query_SP=c.execute("update OrgRole set Name=?,Description=?,edit_date=datetime() where id=?",[roleName,roleDescription,roleId])
		conn.commit()
		
		query_SP=c.execute("delete from RoleLink where role_id=?",[roleId])
		conn.commit()
		
		mapRoleGroups(roleId,selectedGroups)
		print(json.JSONEncoder().encode({'status':'success','description':'Updated successfully'}))
		
	c.close()
	conn.close()

def mapRoleGroups(roleId,selectedGroups):
	if str(selectedGroups) != "None":
		selectedGroupsList = selectedGroups.split(",")
		for groupId in selectedGroupsList:
			query_SP=c.execute("insert into RoleLink(group_id,role_id,cr_date,edit_date) values(?,?,datetime(),datetime())",[groupId,roleId])
			conn.commit()
			
def read_Role(bReturn):
	roleId=form.getvalue('roleId')
	if str(roleId) == "None":
		roleId ='0'
	if roleId == '0':
		dbquery="SELECT id,Name,Description from OrgRole"
	else:
		dbquery="SELECT id,Name,Description from OrgRole where id="+str(roleId)
	
	query = c.execute(dbquery)
	dbdata = []
	conn.commit()
	for col in c:
		jsonschema = {"id":col[0],"name" : col[1],"description" :col[2],"selectedGroups":read_AllGroupsByRole(col[0])}
		dbdata.append(jsonschema)
	#conn.close()
	if bReturn == True:
		return dbdata
	else:
		print(json.JSONEncoder().encode(dbdata))

def create_GroupOrganize():
	groupsIds=form.getvalue('groupsIds')
	linkGroupIds=form.getvalue('linkGroupIds')
	groupLevels=form.getvalue('groupLevels')
	
	selectedGroups = groupsIds.split(",")
	selectedLinkedGroups = linkGroupIds.split(",")
	selectedGroupLevels = groupLevels.split(",")
	
	query_SP=c.execute("delete from  GroupLink")
	conn.commit()
	
	for index, groupId in enumerate(selectedGroups):
			linkGroupId = selectedLinkedGroups[index]
			level = selectedGroupLevels[index]
			query_SP=c.execute("insert into GroupLink(group_id,link_group_id,cr_date,edit_date) values(?,?,datetime(),datetime())",[groupId,linkGroupId])
			query_SP=c.execute("update orgGroup set level=? where id=?",[level,groupId])
			conn.commit()	
	print(json.JSONEncoder().encode({'status':'success','description':'Saved successfully'}))

def read_GroupOrganize():
	dbquery="SELECT group_id,link_group_id,level from GroupLink inner join orgGroup on GroupLink.group_id=orgGroup.id"	
	query = c.execute(dbquery)
	dbdata = []	
	for col in c:
		jsonschema = {"groupId":col[0],"linkGroupId" : col[1],"level":col[2],"type":"GroupLinks"}
		dbdata.append(jsonschema)	
	print(json.JSONEncoder().encode({'savedLinkGroups':dbdata,'DBGroups':getDBGroups(),'DBRoles':read_Role(True),'savedRoleLinks':read_AllRoleLinks(),'DBUsers':read_User(True),'savedUserLinks':read_AllUserLinks()}))
	conn.close()

def read_AllRoleLinks():
	dbquery="SELECT group_id,role_id from RoleLink"	
	query = c.execute(dbquery)
	dbdata = []	
	for col in c:
		jsonschema = {"groupId":col[0],"roleId" : col[1],"type":"RoleLinks"}
		dbdata.append(jsonschema)	
	return dbdata
	

def read_AllUserLinks():
	dbquery="SELECT group_id,role_id,person_id from UserLink"	
	query = c.execute(dbquery)
	dbdata = []	
	for col in c:
		jsonschema = {"groupId":col[0],"roleId" : col[1],"userId":col[2],"type":"UserLinks"}
		dbdata.append(jsonschema)	
	return dbdata
	
print("Content-type:text/html\r\n\r\n")

try:
	if request_Type=='create_Group':
		create_Group()
	elif request_Type == 'read_Group':
		read_Group()
	elif request_Type == 'delete_Group':
		delete_Group()
	elif request_Type == 'create_User':
		create_User()
	elif request_Type == 'delete_User':
		delete_User()
	elif request_Type == 'read_User':
		read_User(False)
	elif request_Type == 'validate_User':
		validate_User()
	elif request_Type == 'read_UsersByRole':
		read_UsersByRole()
	elif request_Type == 'read_RolesByGroup':
		read_RolesByGroup()
	elif request_Type=='create_Role':
		create_Role()
	elif request_Type=='read_Role':
		read_Role(False)
	elif request_Type == 'delete_Role':
		delete_Role()
	elif request_Type == 'create_GroupOrganize':
		create_GroupOrganize()
	elif request_Type == 'read_GroupOrganize':
		read_GroupOrganize()
	elif request_Type == 'read_GroupsByRoles':
		read_GroupsByRoles()
except BaseException as e:
	print(e.message)
finally:
	conn.close() #TODO: need to remove connection close from all other places