#!/usr/bin/python3

import cgi,cgitb
from global_func import *
cgitb.enable()
import sqlite3
import json
from db import *


form = cgi.FieldStorage()
request_Type=form.getvalue('requestType')

def create_Volume():
	volumeName=form.getvalue('volumeName')
	size=form.getvalue('size') 
	poolId=form.getvalue('poolId') 
	hostId=form.getvalue('hostId') 
	dedup=form.getvalue('dedup') 
	compression=form.getvalue('compression')
	backup_device=form.getvalue('backup_device')
	protocolId =form.getvalue('protocolId') 
	lun=form.getvalue('lun') 
	portId=form.getvalue('portId') 
	
	query_lan=c.execute("select count(*) from Volume where name='"+ str(volumeName)+"'")
	nameCount = c.fetchone()[0]
	conn.commit()
	
	if nameCount == 0:
		query_SP=c.execute("insert into  Volume(name,state,size,deduplication,compression,backup_device,multi_device_id,cr_date) values(?,?,?,?,?,?,?,datetime())",[volumeName,4,size,dedup,compression,backup_device,poolId])
		conn.commit()
		volumeId = c.lastrowid
		
		#print "select id from host where id in ("+str(hostId)+")"
		# query=c.execute("select id from host where id in ("+str(hostId)+")")      
		# conn.commit()
		# for host in c:
			# host_Id=host[0]
			# query_SP=c.execute("insert into  export(port_id,vol_id,host_id,lun) values(?,?,?,?)",[portId,volumeId,host_Id,lun])
			# conn.commit()
		
		query_SP=c.execute("insert into  export(port_id,vol_id,host_id,lun) values(?,?,?,?)",[portId,volumeId,hostId,lun])
		conn.commit()
		
		print(json.JSONEncoder().encode({'status':'success','description':'Saved successfully'}))
	else:				
		print(json.JSONEncoder().encode({'status':'fail','description':'Volume Name Already Exists'}))
		
	c.close()
	conn.close()

def update_Volume():
	volumeName=form.getvalue('volumeName')
	size=form.getvalue('size') 
	poolId=form.getvalue('poolId') 
	hostId=form.getvalue('hostId') 
	protocolId =form.getvalue('protocolId')
	compression=form.getvalue('compression')
	dedup =form.getvalue('dedup')	
	lun=form.getvalue('lun') 
	portId=form.getvalue('portId') 
	volumeId = form.getvalue('volumeId')
	backup_device = form.getvalue('backup_device')
	
	query_lan=c.execute("select count(*) from Volume where state=6 and id='"+ str(volumeId)+"'")
	state = c.fetchone()[0]
	conn.commit()
	if state > 0:
		print(json.JSONEncoder().encode({'status':'fail','description':'Cannot update running Volume'}))
		return
		
	query_lan=c.execute("select count(*) from Volume where id='"+ str(volumeId)+"'")
	nameCount = c.fetchone()[0]
	conn.commit()
	
	if nameCount > 0:
		query_SP=c.execute("update Volume set size=?,deduplication=?,compression=?,backup_device=?,multi_device_id=?,edit_date=datetime() where id=?",[size,dedup,compression,backup_device,poolId,volumeId])
		conn.commit()
		query_SP=c.execute("update export set port_id=?,host_id=?,lun=? where vol_id=?",[portId,hostId,lun,volumeId])
		conn.commit()
		
		print(json.JSONEncoder().encode({'status':'success','description':'Updated successfully'}))
	else:				
		print(json.JSONEncoder().encode({'status':'fail','description':'Volume does''t Exists'}))
		
	c.close()
	conn.close()
	
def read_Volume():		
	volumeId = form.getvalue('volumeId')
	if volumeId != str(0):
		dbquery=""" SELECT v.id,v.name,hp.id ,v.multi_device_id,e.host_id,e.lun,e.port_id,v.size,
				ep.name portName,h.name hostName,hp.name protocolName,md.name poolName,v.deduplication,v.compression,v.state,'Native',date(v.cr_date) createdDate,v.cr_date,'Volume',
				v.backup_device
				from volume v  
				join export e on e.vol_id=v.id 
				join eth_ports ep on ep.id = e.port_id
				join host h on h.id = e.host_id
				join protocol hp on hp.id = (select  protocol from host where host.id = e.host_id limit 1)
				join multi_device md on md.id = v.multi_device_id where v.id=""" +str(volumeId)
	else:
		dbquery=""" SELECT v.id,v.name,hp.id ,v.multi_device_id,e.host_id,e.lun,e.port_id,v.size,
				ep.name portName,h.name hostName,hp.name protocolName,md.name poolName,v.deduplication,v.compression,v.state,'Native',date(v.cr_date) createdDate,v.cr_date,'Volume',
				v.backup_device 
				from volume v 
				join export e on e.vol_id=v.id 
				join eth_ports ep on ep.id = e.port_id
				join host h on h.id = e.host_id
				join protocol hp on hp.id = (select  protocol from host where host.id = e.host_id limit 1)
				join multi_device md on md.id = v.multi_device_id
				
				union all
				
				SELECT vsn.id,vsn.name,hp.id ,v.multi_device_id,e.host_id,e.lun,e.port_id,v.size,
				ep.name portName,h.name hostName,hp.name protocolName,md.name poolName,v.deduplication,v.compression,vsn.state,'Local',date(v.cr_date) createdDate,vsn.cr_date,'Volume',
				v.backup_device
				from volume v 
				join export e on e.vol_id=v.id 
				join eth_ports ep on ep.id = e.port_id
				join host h on h.id = e.host_id
				join protocol hp on hp.id = (select  protocol from host where host.id = e.host_id limit 1)
				join multi_device md on md.id = v.multi_device_id
				join volume_snapshot vsn on vsn.vol_id = v.id
										
				union all
				
				SELECT v.id,v.name,0 ,v.multi_device_id,vm.id,'-' lun,0 portid,v.size,
				'-' portName,vm.name hostName,'-' protocolName,md.name poolName,v.deduplication,v.compression,ifnull(v.state,4),'Native',date(v.cr_date) createdDate,v.cr_date,'App',
				v.backup_device 
				from volume v 
				join vm_storage vs on vs.volume_id = v.id
                join virtualmachine vm on vm.id=vs.vm_id
				join multi_device md on md.id = v.multi_device_id
				
				order by v.cr_date desc
				"""
	#print dbquery
	query = c.execute(dbquery)
	dbdata = []
	conn.commit()
	for col in c:
		jsonschema = {"id":col[0],"name" : col[1],"protocolId":col[2],"poolId":col[3],"hostId":col[4],"lun":col[5],"portId":col[6],"size":col[7],"portName":col[8],"hostName":col[9],"protocolName":col[10],"poolName":col[11],"dedup":col[12],"compression":col[13],"state":col[14],"type":col[15],"createdDate":col[16],"diskType":col[18],"backup_device":col[19]}
		dbdata.append(jsonschema)
	conn.close()
	print(json.JSONEncoder().encode(dbdata))

def delete_Volume():
	volumeId = form.getvalue('volumeId')
	volumeType = form.getvalue('volumeType')
	
	if volumeType == 'Native':	
		query_lan=c.execute("select count(*) from Volume where state=6 and id='"+ str(volumeId)+"'")
		state = c.fetchone()[0]
		conn.commit()
		if state > 0:
			print(json.JSONEncoder().encode({'status':'fail','description':'Cannot Delete running Volume'}))
			return
		
		query = "Delete from Volume where id in ("+str(volumeId)+")"
		query_FT=c.execute(query)
		conn.commit()
		
		query = "Delete from vm_storage where volume_id in ("+str(volumeId)+")"
		query_FT=c.execute(query)
		conn.commit()
		
		query = "Delete from export where vol_id in ("+str(volumeId)+")"
		query_FT=c.execute(query)
		conn.commit()
		
		#TODO: need to cleanup
		query = "Delete from volume_snapshot where vol_id in ("+str(volumeId)+")"
		query_FT=c.execute(query)
		conn.commit()
	else:
		query_lan=c.execute("select count(*) from volume_snapshot where state=6 and id='"+ str(volumeId)+"'")
		state = c.fetchone()[0]
		conn.commit()
		if state > 0:
			print(json.JSONEncoder().encode({'status':'fail','description':'Cannot Delete running Volume'}))
			return
		
		query = "Delete from volume_snapshot where id in ("+str(volumeId)+")"
		query_FT=c.execute(query)
		conn.commit()
	
			
	print(json.JSONEncoder().encode({'status':'success','description':'Deleted successfully'}))
	c.close()
	conn.close()

def onOff_Volume():	
	volumeState=form.getvalue('state') 
	volumeId = form.getvalue('volumeId')
	volumeType = form.getvalue('volumeType')
	
	if volumeType == 'Native':	
		query=c.execute("update Volume set state=?,edit_date=datetime() where id=?",[volumeState,volumeId])
	else:
		query=c.execute("update volume_snapshot set state=?,edit_date=datetime() where id=?",[volumeState,volumeId])
	conn.commit()
	
	if 	volumeState == str(4):
		print(json.JSONEncoder().encode({'status':'success','description':'Volume is OFF'}))
	else:				
		print(json.JSONEncoder().encode({'status':'success','description':'Volume is ON'}))
		
	c.close()
	conn.close()
def snapShot_volume():
	volumeId = form.getvalue('volumeId')
	snapShotName = form.getvalue('snapShotName')	
	
	query_lan=c.execute("select count(*) from volume_snapshot where name='"+ str(snapShotName)+"'")
	nameCount = c.fetchone()[0]
	conn.commit()
	
	if nameCount == 0:
		query_SP=c.execute("insert into  volume_snapshot(name,state,vol_id,cr_date) values(?,?,?,datetime())",[snapShotName,4,volumeId])
		conn.commit()		
		
		print(json.JSONEncoder().encode({'status':'success','description':'Saved successfully'}))
	else:				
		print(json.JSONEncoder().encode({'status':'fail','description':'Volume Name Already Exists'}))
		
	c.close()
	conn.close()
def read_HostByProtocol():	
		
	protocolId = form.getvalue('protocolId')	
	dbquery="SELECT id,name,protocol,user_name,iqn,pw,wwn from host where protocol="+str(protocolId)
	
	query = c.execute(dbquery)
	dbdata = []
	conn.commit()
	for col in c:
		jsonschema = {"id":col[0],"name" : col[1],"protocol_id":col[2],"user_name":col[3],"iqn":col[4],"pw":col[5],"wwn":col[6]}
		dbdata.append(jsonschema)
	conn.close()
	print(json.JSONEncoder().encode(dbdata))
	
def read_Ethernet_ports():
	dbdata = []
	query = "Select id,name from eth_ports"
	query_FT=c.execute(query)
	conn.commit()		
	for col in c:
		jsonschema = {"id":col[0],"name" : col[1]}
		dbdata.append(jsonschema)
	c.close()
	conn.close()
	print(json.JSONEncoder().encode(dbdata))
def read_VolumeInfo():
	volumeId = form.getvalue('volumeId')
	volumeType = form.getvalue('volumeType')
	#This function should return data in below format.
	mockdata	= [{"propertyName":"Size","propertyValue":"10 GB"},
				   {"propertyName":"Free","propertyValue":"150 GB"},
				   {"propertyName":"Compressed","propertyValue":"1.5X"},
				   {"propertyName":"Dedup","propertyValue":"2.3X"},
				   {"propertyName":"propertyName_5","propertyValue":"propertyValue_5"},
				   {"propertyName":"propertyName_6","propertyValue":"propertyValue_6"}
				  ]
	print(json.JSONEncoder().encode(mockdata))
	
print("Content-type:text/html\r\n\r\n")
if request_Type == 'read_Volume':
	read_Volume()
elif request_Type == 'delete_Volume':
	delete_Volume()
elif request_Type == 'create_Volume':
	create_Volume()
elif request_Type == 'update_Volume':
	update_Volume()
elif request_Type == 'read_Ethernet_ports':
	read_Ethernet_ports()
elif request_Type == 'onOff_Volume':
	onOff_Volume()
elif request_Type == 'snapShot_volume':
	snapShot_volume()
elif request_Type == 'read_HostByProtocol':
	read_HostByProtocol()
elif request_Type == 'read_VolumeInfo':
	read_VolumeInfo()
